$Id: README,v 1.2 2007/07/23 16:00:57 meyer Exp $

To build and test the teq module, simply type:

./configure --with-SEPLIBPATH=/path/to/separatrix/library && make && make test

"configure" generates a Makefile for your system.

"make" builds the teq library libteq.a.

"make test" builds and executes a demonstration driver program.

Some older versions of the make utility might not work. Then try gmake instead
(the GNU implementation of make).

You might have to specify where the lapack library is installed. For example:

./configure --with-SEPLIBPATH=/path/to/separatrix/library \
--with-LAPACKFLAGS="-L$HOME/LAPACK -llapack -lblas"

The configure script should be able to find a working F90 compiler (if one is
available on your system of course). However, if more than one F90 compiler is
available, you might want to override the configure script. For example, if you
have both pgf90 and lf95 installed on a Linux box, the configure script will
choose lf95. To override this you can either

./configure --with-F90=pgf90

or set the shell variable F90 to "pgf90".

You don't have to build the code in the source directory. For example, if you
are in the directory teq (the source directory) and want to build the
library in a subdirectory called build, just do the following:

mkdir build && cd build && ../configure \
--with-SEPLIBPATH=/path/to/separatrix/library && make

When you type "make test", a demonstration driver is compiled and executed.
The source code, driver.f90, demonstrates the basic use of the teq library and
should be fairly self-explanatory. Direct (free-boundary) equilibria can either
be loaded from a Corsica save file (*.in) or calculated from scratch (by doing
a dead start). In the demo driver the direct equilibria are perturbed and then
recalculated to demonstrate the convergence of the Grad-Shafranov solver.
When a direct equilibrium has been found, the inverse equilibrium can be
calculated. The direct and inverse equilibria are finally stored in the file
driver.sav (in Corsica save file format).

The input variables are described in the file teqinit.f90. Also, the upper
level variable are desribed in teqlib.f90

To use exception handling (currently only supported on Linux), see
the file SeparatrixManual.pdf that comes with the separatrix module.

The IDL script teqplot.pro can be used to plot the equilibria. In the
teq directory type:

idl
  .run teqplot
  teqplot, 'input/foo.in'
  exit

Here foo.in is the desired savefile and driver.eps is the resultant
postscript file. 

The teq library is built with the same floating-point precision as the
separatrix library (8-byte floating point by default). To switch to 4-byte
floating point, change line 7 in the file separatrix/utils.f90 from "rq=r8" to
"rq=r4" and rebuild first the separatrix library and then the teq library.

To get help, send an email to <teq-users@fusion.txcorp.com>.

The teq module has been built and tested with the following
OS/compiler combinations (current as of 03/01/06):

Fedora Core 3:
 Lahey/Fujitsu lf95 6.2

Redhat7.2:
 Portland Group pgf90 6.0

Darwin (Mac OS X) 7.9.0:
 IBM xlf 8.1

HP-UX 11.11:
 HP f90 2.8

Known problems:

Intel ifort 8.0 is known to ICE (Internal Compiler Error) on gradsh.f90,
line 113, even without optimization. However, at least one user reports that
ifort 8.0 did manage to build the teq library.

Redhat bumped up the stack size from 8MB to 10MB for Enterprise Linux
release 3, causing lf95 to break. A fix for the problem is presented at:
<http://www.laheyforum.com/archive/index.php/t-10322>.

On Darwin, xlf -O2 gives incorrect output, xlf -O0 works OK.

On HP-UX:
* f90 -O2 gives incorrect output, f90 -O1 works OK.
* you have to comment out the call to time_date in teqlib.f90 or you'll
  get a bus error.

! $Id: teqerr.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

module teqerr

  logical :: exceptions_enabled = .false.
  logical :: stop_on_error = .true.
  integer :: error_code = 0
  character(len = 128) :: error_msg = 'none'

  interface

     subroutine catch_inveq(ierr,inv,prof,glb)
       use teqlib
       integer, intent(inout) :: ierr
       type(profile_type), intent(inout) :: prof
       type(inv_type), intent(inout) :: inv
       type(global_type), intent(in) :: glb
     end subroutine catch_inveq

     subroutine catch_direq(ierr,dir,pf,inv,prof,glb)
       use teqlib
       integer, intent(inout) :: ierr
       type(dir_type), intent(inout) :: dir
       type(pf_type), intent(inout) :: pf
       type(profile_type), intent(inout) :: prof
       type(inv_type), intent(inout) :: inv
       type(global_type), intent(in) :: glb
     end subroutine catch_direq

     subroutine throw_xcpt(arg)
       integer, intent(inout) :: arg
     end subroutine throw_xcpt

     subroutine catch_dead_start(ierr,glb)
       use teqlib
       integer, intent(inout) :: ierr
       type(global_type), intent(in) ::glb
     end subroutine catch_dead_start

     subroutine catch_load_savefile(ierr,glb,dir,pf,inv,prof)
       use teqlib
       integer, intent(inout) :: ierr
       type(dir_type), intent(inout) :: dir
       type(pf_type), intent(inout) :: pf
       type(profile_type), intent(inout) :: prof
       type(inv_type), intent(inout) :: inv
       type(global_type), intent(in) :: glb
     end subroutine catch_load_savefile

  end interface

end module teqerr

subroutine errdetec(blah, flag)
  use teqerr
  use teqlib_input, only : logunit
  implicit none
  character*(*), intent(in) :: blah
  integer, intent(inout) :: flag
  integer :: ierr=0
  real :: sq

  error_code = flag
  error_msg  = blah

  if (flag < 0) then
     print *, blah," flag = -1: benign"
     write(logunit,*) blah," flag = -1: benign"
     return
  end if
  if (stop_on_error) stop
  if (exceptions_enabled) then
     print *, blah
     write(logunit,*) blah
     call throw_xcpt(flag)
  end if

end subroutine errdetec

subroutine savefile(glb,dir,pf,inv,prof)
  use teqlib
  use teqlib_input, only : inv_eq,fix_bound

  type(dir_type), intent(inout) :: dir
  type(pf_type), intent(inout) :: pf
  type(inv_type), intent(inout) :: inv
  type(profile_type), intent(inout) :: prof
  type(global_type), intent(in) :: glb
  call load_savefile(glb%filename)
  if(inv_eq==0 .or. (inv_eq==1 .and. .not.fix_bound)) then ! direct solve
     call find_direq(dir,pf,inv,prof,glb)
  else
     call find_inveq(inv,prof,glb)
  end if
end subroutine savefile

subroutine deadstar(glb)
  use DeadStart
  use teqlib
  type(global_type), intent(in) ::glb
  call do_dead_start(glb%tokamak,glb%pfcoil)
end subroutine deadstar

subroutine inveq(inv,prof,glb)
  use teqlib
  implicit none
  
  type(inv_type), intent(inout) :: inv
  type(profile_type), intent(inout) :: prof
  type(global_type), intent(in) :: glb
  call find_inveq(inv,prof,glb)
end subroutine inveq

subroutine direq(dir,pf,inv,prof,glb)
  use teqlib
  implicit none
  
  type(dir_type), intent(inout) :: dir
  type(pf_type), intent(inout) :: pf
  type(inv_type), intent(inout) :: inv
  type(profile_type), intent(inout) :: prof
  type(global_type), intent(in) :: glb
  call find_direq(dir,pf,inv,prof,glb)
end subroutine direq

! $Id: deadstart.f90,v 1.2 2007/07/23 16:00:57 meyer Exp $

MODULE DeadStart

  USE sep_math

  IMPLICIT none

  REAL(rq) :: r_major, r_minor, z_axis
  REAL(rq) :: kappa_95, delta_95, delta_sep, beta_p, l_i, psi_ext
  REAL(rq) :: rtor
  REAL(rq) :: rgrid1, rgrid2, zgrid1, zgrid2

CONTAINS

  subroutine do_dead_start(paramsfile, coilsfile)

    use runTeq_mod
!    use DeadStart

    character(len = *), intent(in) :: paramsfile, coilsfile
    call mach
    call read_coils(coilsfile)
    call read_params(paramsfile)
    call teqGS_interface
    call teq_interface

    ! mach() must be called before genTeq(), or errb_rq won't get initialized

    call genTeq
!  call write_coils("coils.inp")
    call dead_start

  end subroutine do_dead_start

  SUBROUTINE read_coils(filename)

    USE teqlib_input
    IMPLICIT none
    CHARACTER (LEN=*), INTENT(IN) :: filename
    INTEGER, SAVE :: io=0
    CHARACTER (LEN=16) :: coil_set
    INTEGER :: i

    CALL freeus(io)
    OPEN(UNIT=io, FILE=filename, DELIM='QUOTE')
    READ(io,*) coil_set
    READ(io,*) nc
    READ(io,*)
    CALL teq_input_allocate
    DO i=1,nc
       READ(io,*) pfid(i),rc(i),zc(i),drc(i),dzc(i)
    END DO
    CLOSE(io)



  END SUBROUTINE read_coils

  SUBROUTINE write_coils(filename)

    USE teqlib_input
    IMPLICIT none
    CHARACTER (LEN=*), INTENT(IN) :: filename
    INTEGER, SAVE :: io=0
    INTEGER :: i
    CHARACTER (LEN=16) :: coil_set="<TBD>"
    EXTERNAL freeus

    CALL freeus(io)
    OPEN(UNIT=io, FILE=filename, DELIM='QUOTE')
    WRITE(io,'(2a)') coil_set,"TEQ needs variable to hold coil set name"
    WRITE(io,'(I5," coils")') nc
    WRITE(io,'("pfid        rc [m]    zc [m]   drc [m]   dzc [m]")')
    WRITE(io,'(a,4F10.4)') (pfid(i),rc(i),zc(i),drc(i),dzc(i),i=1,nc)
    CLOSE(io)

  END SUBROUTINE write_coils

  SUBROUTINE read_params(filename)

    USE sep_math
    USE teqlib_input
    USE teqlib_output
    USE teq_output_mod
    IMPLICIT none
    CHARACTER (LEN=*), INTENT(IN) :: filename
    CHARACTER (LEN=32) :: heading
    CHARACTER (LEN=1) :: token
    INTEGER :: i, io
    EXTERNAL freeus

    CALL freeus(io)
    initflx=0
    psix=0
    prsx=0
    lsrf=0
    jqm=0
    mls=0
    nplates=0
    lmax=0
    plcx=0
    wvert=0
    psil=0
    dpsi00=0
    scl=0
    dr=0
    dz=0

    OPEN(UNIT=io, FILE=filename)
    DO
       READ(io,*) heading
       IF (heading(1:6) == 'Plasma') EXIT
    END DO
    READ(io,*) plcm
    READ(io,*) r_major
    READ(io,*) r_minor
    READ(io,*) z_axis
    READ(io,*) kappa_95
    READ(io,*) delta_95
    READ(io,*) delta_sep
    READ(io,*) beta_p
    READ(io,*) l_i
    READ(io,*) psi_ext
    DO
       READ(io,*) heading
       IF (heading(1:8) == 'Toroidal') EXIT
    END DO
    READ(io,*) btor, token, token, token, token, rtor
    DO
       READ(io,*) heading
       IF (heading(1:4) == 'Comp') EXIT
    END DO
    READ(io,*) rgrid1
    READ(io,*) rgrid2
    READ(io,*) zgrid1
    READ(io,*) zgrid2
    READ(io,*) jm, token, km
    CLOSE(io)
    
    r_major=r_major*100
    r_minor=r_minor*100
    z_axis=z_axis*100
    btor=btor*1d4
    rtor=rtor*100
    rgrid1=rgrid1*100
    rgrid2=rgrid2*100
    zgrid1=zgrid1*100
    zgrid2=zgrid2*100
    
    ! Specify computational grid
    liml=(jm-1)/8+1
!    fwall=btor*rtor
    IF (rgrid1 <= 0) THEN
       rgrid1=errt_rq
       rgrid2=rgrid2+errt_rq
    END IF
    ro=0.5*(rgrid1+rgrid2)
    dr=(rgrid2-rgrid1)/(jm-1)
    rb=(dr/1.0017469212_rq)*((jm+1)/2-liml)
    rfix=0
    el=(zgrid2-zgrid1)/(rgrid2-rgrid1)
    rlim(0)=ro-rb
    zlim(0)=0
    
    ! Specify x-point search-box
    rxpr(1)=MAX(ro-rb,100*(MINVAL(rc(:nc))+2*MAXVAL(drc(:nc))))
    rxpr(2)=MIN(ro+rb,100*(MAXVAL(rc(:nc))+2*MINVAL(drc(:nc))))
    zxpr(2)=MIN(zgrid2,100*(MAXVAL(zc(:nc))-3*MINVAL(drc(:nc))))
    zxpr(1)=-zxpr(2)

   
    ! Parameters for plasma boundary generation
    nsym=2
    ibdry=1
    nbd=MIN(7,2*((nc+1)/2)-1)
    ebdu=kappa_95
    dbdu=delta_95
    ebdl=ebdu
    dbdl=dbdu
    
    ! Coil regularization parameters
    nsymc=2
    ircwt=3
    cc(:nc)=-1
    ic(:nc)=(/ (i, i=1,nc) /)
    vltf=0
    
    ! Specify profile parameters
    betaj=0.1
    ipp=1
    ipf=1
    alfa(1)=-1
    alfa(0)=-1
    
    ! Equilibrium parameters
    ixpt=1
    keqic=1
    psix=plcm*1d8
    nl=200
    ni=1
    map=64
    alphac=0.5
    
  END SUBROUTINE read_params
  
  SUBROUTINE dead_start

    USE teqlib_input
    USE teqlib_output
    USE runTeq_mod
    IMPLICIT none
    INTEGER :: i
    REAL(rq) :: t

    !CALL mach
    PRINT *,"DEADSTART: Initial equilibrium with simple profiles"
    ngp=0
    
    CALL runTeq

    PRINT *,"DEADSTART: Install fuzzy markers"
    nfbd=64
    nbd=0
    CALL teq_interface
    DO i=1,nfbd
       t=2*PI*FLOAT(i-1)/nfbd
       rfbd(i)=ro+rb*COS(t+dbdu*SIN(t))
       zfbd(i)=ebdu*rb*SIN(t) ! ? NEED Z0
    END DO
    rlim(0)=rfbd(1)
    zlim(0)=zfbd(1)
    alfbd=(PI*1d9)/(plcm*ro**2)
    alfbd=2**(INT(LOG(alfbd(1))/LOG(2.0)+1))
    CALL runTeq

    IF (s_limiterd == 0 .AND. delta_sep /= 0 .AND. ABS(delta_sep) < 0.001) THEN
       PRINT *,"DEADSTART: Add separatrix separation constraint for ~DN"
       nbd=1
       rbd(1)=MINVAL(rfbd)
       zbd(1)=0
       IF (s_limiterd == 1) THEN
          IF (rlim(0) > s_rcntr) THEN
             rlim(0)=rlim(0)+dr
          ELSE
             rlim(0)=rlim(0)-dr
          END IF
       END IF
       irl=0
       IF (delta_sep == 0) THEN
          rl=-1e-6_rq
       ELSE
          rl=SIGN(1.0e-06_rq,delta_sep)
       END IF
       CALL runTeq
    ELSE IF (ABS(delta_Sep) >= 0.001) THEN
       PRINT *,"DEADSTART: Add separatrix separation constraint for SN"
       IF (s_limiterd == 1) THEN
          IF (rlim(0) > s_rcntr) THEN
             rlim(0)=rlim(0)+dr
          ELSE
             rlim(0)=rlim(0)-dr
          END IF
       END IF
       IF (ABS(delta_sep) > 0) THEN
          DO WHILE (s_dsep < 10*ABS(delta_sep) .and. rl/=0)
             rl=10*rl
             CALL runTeq
          END DO
          IF (delta_sep > 0) THEN ! SNT
             irl=-1
          ELSE ! SNB
             irl=1
          END IF
          rl=100*ABS(delta_sep)
          CALL runTeq
       END IF
    END IF

    PRINT *,"DEADSTART: Install ohmic profiles"
    nfbd=mls
    CALL teq_interface
    alfbd=100
    rfbd(:nfbd)=rls(:nfbd)
    zfbd(:nfbd)=zls(:nfbd)
    aap=0
    msrf=51
    lsrf=-1
    ipj=2
    ipp=3
    alfa(1)=2
    betp(1)=1
    ipf=3
    alfa(0)=2
    betp(0)=1
    alfa(0)=2
    betp(0)=1
    betaj=0.2
    CALL runTeq

  END SUBROUTINE dead_start

END MODULE DeadStart

! $Id: inv.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

MODULE inv_mod

  USE teqPol_mod
  USE source_mod

  IMPLICIT NONE

  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE ::  uk,vk,anu,a,ai,ha,pswpts,&
       c_0,c_1,c_2,c_3,dpsrf,qelm,pelm,selm,c_q,qq,tt,hh,rr,dq1,dq2,cq1,cq2
  REAL(rq), DIMENSION(:),POINTER, PRIVATE :: tet
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, PRIVATE :: ur,ut,vz,vt,jac,e2
  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE :: y,y0,rajh,rajh0,drq,au,bu,&
       haaj0,hatj0,curk,fu,drq0,ajj,fi0,haaj,hatj,fi,drr,auq,buq,fuq,bet,&
       rosg,cp1,cp2,cp3,qrk_,fsp,fsp1,fsp2,fsp3,psp
  REAL(rq), DIMENSION(:), ALLOCATABLE, PUBLIC :: pst,tst
  REAL(rq), PRIVATE :: um,vm,psend,elong,rsj,rsj0,zdp0
  INTEGER,  PRIVATE :: nh,nst,mlm
  INTEGER, PARAMETER, PRIVATE :: GAMMA=5._rq/3._rq

CONTAINS
  
  SUBROUTINE polar1(kp,ip)
    !**************************************************************
    !  AUTHORS Triniti group                                      *
    !  MODIFIED by LDP                                            *
    !**************************************************************
    ! calculates inverse equilibrium

    !**************************************************************
    ! kp<=0: input qrk, pp(kp=0) or srk(kp=-1); output f          *
    ! kp= 3: input jrk, pp; output f and p preserved              *
    ! with                                                        *
    ! ip<0;  input psend; output=tpl(KA), pp(scaled), p fixed     *
    ! ip=0:  input fwall;output dpsi0, plc(amps*10) tpl(KA)       *
    ! ip> 0; input tpl; output psend, pp(scaled), p fixed         *
    !-------------------------------------------------------------*
    ! kp= 1: input pff and pp; output p and f; pp and pff scaled  *
    ! kp= 2: input jrk, pp; output f, pff; pp scaled to fix p     *
    ! with                                                        *
    ! ip= 0: input none; output tpl=current(KA), psend            *
    ! ip< 0: input psend; output tpl;                             *
    ! ip> 0: tpl input; output psend;                             *
    !**************************************************************
    INTEGER, INTENT(IN) :: kp,ip
    INTEGER :: ndbg,m,ii,jj,nsave,ntp,i,j,nal,jp,jps,ips
    REAL(rq) :: norm,rr(4),zz(4),dd(4),ps(4),fwalli,rrd(4),zzd(4),&
         za(3),ra(3),uu(2),vv(2),uk_(2),um0,ff(4),no_yint(1),xx(4)
    REAL(rq) :: a11,a22,ddd,ut2,vt2,ds1,ua1,va1,uc1,vc1,ss,al0,sf,sd,qc,&
         qr,yy,x1,x2,x3,rat_,al1,tok1,tok2,tok3,tok4,tok5,tok6,tok7,tok8,&
         fadd,dum,dvm,y1,yb,us,de1,de2,ppi,pffi,prj,bum,dfuv,&
         sigm,padd,pbnd,inv_x,frat
    LOGICAL ibd
    CHARACTER(len=128) :: mes
    SAVE ntp,nsave,inv_x,frat,ips,jp
    include "debug.i"
    DATA nsave /0/,ntp/0/,yb/777/,no_yint(1)/-999/,y1/-666/,inv_x/0/,frat/1/
    DATA ips /0/, jp/0/

    IF(t_npo*t_ntet/=nsave) THEN
       IF(nsave/=0) DEALLOCATE(ur,ut,vz,vt,jac,e2,cp1,cp2,cp3,qrk_,rosg)
       ALLOCATE(ur(t_npo,t_ntet),ut(t_npo,t_ntet),vz(t_npo,t_ntet),&
            vt(t_npo,t_ntet),jac(t_npo,t_ntet),e2(t_npo,t_ntet),cp1(t_npo),&
            cp2(t_npo),cp3(t_npo),qrk_(t_npo),rosg(t_npo))
       nsave=t_npo*t_ntet
       ur=0;vz=0;e2=0
    END IF
    IF(ntp/=t_ntet+1) THEN
       if(ntp/=0) DEALLOCATE(y,y0,rajh,rajh0,drq,au,bu,haaj0,hatj0,curk,&
            fu,drq0,ajj,fi0,haaj,hatj,fi,drr,auq,buq,fuq,bet,qq,tt,hh)
       ntp=t_ntet+1
       ALLOCATE(y(ntp),y0(ntp),rajh(ntp),rajh0(ntp),drq(ntp),au(ntp),&
            bu(ntp),haaj0(ntp),hatj0(ntp),curk(ntp),fu(ntp),drq0(ntp),&
            ajj(ntp),fi0(ntp),haaj(ntp),hatj(ntp),fi(ntp),drr(ntp),&
            auq(ntp),buq(ntp),fuq(ntp),bet(ntp),qq(t_ntet),tt(t_ntet),&
            hh(t_ntet))
       ntp=t_ntet+1
    END IF
    ibd=.true.
    IF(kp==1) THEN
       fwalli=t_f(1)**2
    ELSE
       fwalli=t_f(1)
    END IF
    pbnd=t_p(1)
    jac=0
    al1=1
    norm=1
    m=t_ntet+1
    t_qrk(1)=t_qrk(2)
    qrk_=t_qrk
    um0=um
    !     US=1./DKRI0
    us=t_ro
    nh=0
    IF(t_anun==0) t_anun=1

    !     By~iClEHiE plO}Adi KOvYXA
    !.....computation of cross-sectional area of plasma
    ss=uk(t_ntet)*(vk(2)-vk(t_ntet-1))
    ss=ss+SUM(uk(2:t_ntet-1)*(vk(3:)-vk(:t_ntet-2)))
    ss=ss*0.5_rq
    nal=0
    tok8=psend ! needed for ip=-2
    if(t_inv_x==0) jp=0
    jps=jp
    IF(abs(t_inv_x)/=0 .AND. t_inv_x/=inv_x) THEN
       DO jp=t_npo-1,1,-1
          IF(t_psiinv(jp)<=t_inv_x) EXIT
       END DO
       IF(ALLOCATED(psp)) THEN
          IF((SIZE(psp)/=jp)) DEALLOCATE(psp,fsp,fsp1,fsp2,fsp3)
       END IF
       IF(.NOT.ALLOCATED(psp)) ALLOCATE(psp(jp),fsp(jp),fsp1(jp),fsp2(jp),&
            fsp3(jp))
       inv_x=t_inv_x
    ELSE IF(t_inv_x==0 .OR. t_inv_x==1) THEN
          jp=t_npo+1
    END IF
    IF(ip/=ips .OR. jp/=jps) frat=1
    ips=ip

    !----------------------------------------------------------------------

1001 continue
    de1=0
    de2=0
    t_nitt=t_nitt+1
    !     HA~AlO PAC~ETA
    !.....start of calculation
    IF(t_iter_bdry .AND. ibd) THEN
       ! Move boundary points to conform with teq coordinates--LDP 96/1/7
       IF(t_nsym/=2) THEN
          uk_(1)=uk(1)
          uk_(2)=uk(t_ntet/2+1)
       END IF
       tt=atan2((vk-vm)/elong,uk-um)
       DO i=1,t_ntet
          IF(tt(i)>0) EXIT
       END DO
       DO j=i,t_ntet
          IF(tt(j)<=0) EXIT
       END DO
       DO i=j,t_ntet
          tt(i)=tt(i)+TWOPI
       END DO
       qq=uk
       call interp_interp(tt,qq,y1,y1,tet,uk,hh)
       qq=vk
       call interp_interp(tt,qq,y1,y1,tet,vk,hh)
       IF(t_nsym/=2) THEN
          uk_(1)=uk(1)
          uk_(2)=uk(t_ntet/2+1)
       END IF
    END IF
    !---- end of boundary move
    ibd=.true.
    t_ns1=0
    nst=3
    !     OKAjMlEHiE
    !.....boundary
    t_rork(:,1)=t_rork(:,t_ntet)
    t_aj(:,1)=t_aj(:,t_ntet)
    drr(2:t_ntet)=(((uk(2:)+uk(:t_ntet-1))*.5_rq-um)**2+((vk(2:)+&
         vk(:t_ntet-1))*0.5_rq-vm)**2)
    drr(m)=drr(2);drr(1)=drr(t_ntet)
    drr=0.5_rq*sqrt(drr)
    !-----------------------------------------------------------------------

    !     HA~AlxHyj {Ag: OpPEdElEHiE Y(1.5,J), I=2
    !.....beginning {Ag: determination of Y(3/2,j)}
    IF(nal==0) THEN
       al0=0
       nal=1
    ELSE
       al0=t_alfa1
    END IF
    DO i=1,t_npo
       ur(i,:)=(1-al0)*(um+t_rork(i,:)*(uk-um))+al0*ur(i,:)
       vz(i,:)=(1-al0)*(vm+t_rork(i,:)*(vk-vm))+al0*vz(i,:)
    END DO

    DO i=1,t_npo
       ut(i,2:)=ur(i,2:)-ur(i,:t_ntet-1)
       vt(i,2:)=vz(i,2:)-vz(i,:t_ntet-1)
    END DO
    t_crk(1)=0
    tok1=0
    !-----------------------------------------------------------------------
    !     C~ET pO KAvdOj pOBEPXHOCTi A(I)=CONST, I=3,T_NPO
    !.....calculation along each surface a(i)=constant

    DO i=2,t_npo ! Begin i loop---flux
       tok2=0
       tok3=0
       tok4=0
       tok5=0
       tok6=0
       tok7=0
       ppi=t_pp(i)
       pffi=t_pff(i)
       IF(t_ifluxcord==-1) THEN ! Now derivative wrt poloidal flux
          ppi=ppi*qrk_(i)
          pffi=pffi*qrk_(i)
       END IF
       DO j=2,t_ntet
          ua1=ur(i,j)-ur(i-1,j)+ur(i,j-1)-ur(i-1,j-1)
          va1=vz(i,j)-vz(i-1,j)+vz(i,j-1)-vz(i-1,j-1)
          ds1=ua1*(vt(i,j)+vt(i-1,j))-va1*(ut(i,j)+ut(i-1,j))
          uc1=0.25_rq*(ur(i,j)+ur(i-1,j)+ur(i,j-1)+ur(i-1,j-1))
          vc1=0.25_rq*(vz(i,j)+vz(i-1,j)+vz(i,j-1)+vz(i-1,j-1))
          ddd=sqrt((uc1-um)**2+(vc1-vm)**2)
          IF(ds1==0) THEN
             WRITE(mes,*)"TEQ failure in polar1: impending zero divide"
             CALL errdetec(mes,0)
          END IF
          drq(j+1)=4*ha(i)*drr(j)*ddd/ds1
          jac(i,j)=ds1*uc1
          a11=us/uc1
          a22=a11
          hatj(j+1)=(-a11*va1*(vt(i,j)+vt(i-1,j))-a22*ua1*(ut(i,j)+ut(i-1,j)))&
               /ds1*ha(i)
          ut2=2*(ut(i,j)**2+ut(i-1,j)**2)
          vt2=2*(vt(i,j)**2+vt(i-1,j)**2)
          haaj(j+1)=(a11*vt2+a22*ut2)/ds1*ha(i)
          IF(kp>1) THEN ! jrk as input
             fi(j+1)=ds1
          ELSEIF(i>jp) THEN
             fi(j+1)=-(ppi*uc1/us+0.5_rq*pffi*us/uc1)*ds1*0.25_rq
          ELSE ! here always derivs wrt poloidal flux
             fi(j+1)=-(ppi*uc1/us+kp*0.5_rq*pffi*us/uc1)*ds1*0.25_rq
          END IF
          tok7=tok7+4*(ut2+vt2)*uc1/ds1
          tok6=tok6+4*(ut2+vt2)/uc1*vc1/ds1
          tok5=tok5+4*(ut2+vt2)/uc1/ds1
          tok4=tok4+ds1/uc1
          tok3=tok3+ds1*uc1
          tok2=tok2+ds1/uc1
          rajh(j+1)=ds1/(uc1*4*ha(i))
       END DO
       t_crk(i)=2.5e+04_rq*tok5*anu(i)*ha(i)*us
       t_rrk(i)=tok7/tok5 ! radius squared of current centroid
       t_zrk(i)=tok6/tok5 !         height of current centroid
       IF(t_ifluxcord<=0) THEN
          t_vrk(i)=TWOPI**2*tok3/tok4
       ELSE
          t_vrk(i)=TWOPI*tok3/anu(i)/us*2e-2
       END IF
       jac(i,:)=jac(i,:)*0.5_rq/(anu(i)*ha(i)*FOURPI)
       t_trk(i)=0.5_rq*tok2*t_f(i)/anu(i)/ha(i)/FOURPI
       IF(kp/=0) t_qrk(i)=t_trk(i)
       IF(kp>1) THEN
          prj=1+tok5/tok4*(anu(i)*ha(i)/t_f(i))**2
          IF(kp==2) THEN ! jtsrf as input
             IF(t_ifluxcord==2) THEN
                pffi=2*(t_jrk(i)/qrk_(i)-ppi*tok3/tok4/us**2)/prj
             ELSE
                pffi=2*(t_jrk(i)-ppi*tok3/tok4/us**2)/prj
             END IF
          ELSEIF(kp==3) THEN ! jparsrf as input
             pffi=2*(t_jrk(i)*t_f(i)-ppi*tok3/tok4/us**2/prj)
          END IF
          IF(t_ifluxcord==-1) THEN
             t_pff(i)=pffi/qrk_(i) ! back to toroidal flux derivative
          ELSE
             t_pff(i)=pffi
          END IF
          DO j=2,t_ntet
             uc1=0.25_rq*(ur(i,j)+ur(i-1,j)+ur(i,j-1)+ur(i-1,j-1))
             fi(j+1)=-(ppi*uc1/us+0.5_rq*pffi*us/uc1)*fi(j+1)*0.25_rq
          END DO
       END IF
       !     OKAjMlEHiE
       !.....boundary
       fi(1)=fi(t_ntet)
       drq(1)=drq(t_ntet)
       haaj(1)=haaj(t_ntet)
       hatj(1)=hatj(t_ntet)
       rajh(1)=rajh(t_ntet)
       fi(2)=fi(m)
       drq(2)=drq(m)
       haaj(2)=haaj(m)
       hatj(2)=hatj(m)
       rajh(2)=rajh(m)
       rsj=us/SUM(rajh(3:))
       tok1=tok1+SUM(fi(2:t_ntet))
       IF(i==2) THEN

          ! HAXOdiM Y(1.5,J)
          ! .....we find Y(3/2,j)
          sf=0.5_rq*SUM(fi(2:t_ntet))
          sd=SUM(haaj(2:t_ntet))

          yy=sf/sd
          qrk_(1)=qrk_(2)
          t_qrk(1)=t_qrk(2)
          t_trk(1)=t_trk(2)
          IF (kp==0) THEN
             qc=TWOPI*(qrk_(1)+qrk_(2))/2*us
             qr=TWOPI*qrk_(2)*rsj/us
             yy=anu(2)
             t_f(2)=yy*qr
             t_f(1)=((sd+qc*qr)*yy-sf)/qc
             IF(nh/=0) THEN
                ff(2:4)=t_f(2:4)
                ps=t_psiinv(:4)
                t_f(1)=extrp(ff,ps,4,0,0)
             END IF
          END IF
          ! -----------------------------------------------------
          !     TO~HOCTi   TO~HOCTi   TO~HOCTi
          !.....precision
          y(:)=yy
          t_aj(i,:)=yy
          ! -----------------------------------------------------
       ELSE ! remaining surfaces
          ! -----------------------------------------------------
          !     pOlY~EHiE KO|fficiEHTOB AU, BU, CU, FU dlq PAzHOCTHyX YPABHEHij
          !.....calculation of coefficients AU,... for the difference equations
          !     YPABHEHiq PE{A\TCq METOdOM pPOgOHKi
          !.....equations solved by method of running(?) driving(?)
          ! -----------------------------------------------------
          DO j=2,t_ntet
             au(j)=-0.25_rq*hatj(j+1)
             bu(j)=0.25_rq*hatj(j)
             curk(j)=0.5_rq*(haaj(j+1)+haaj(j))-au(j)-bu(j)
             x1=y0(j)*0.5_rq*(haaj0(j+1)+haaj0(j))
             x2=-0.25_rq*hatj0(j+1)*(y0(j+1)+y0(j))
             x3=0.25_rq*hatj0(j)*(y0(j)+y0(j-1))
             fu(j)=0.25_rq*(fi(j)+fi(j+1)+fi0(j)+fi0(j+1))+x1+x2+x3
             ! BBEdEHiE BqzKOCTi  (DRQ(J),DRQ0(J)=0 pPi DR=0)
             ! .....conduction(?) of viscosity
             au(j)=au(j)+drq(j+1)
             bu(j)=bu(j)+drq(j)
             curk(j)=curk(j)+drq(j)+drq(j+1)
             fu(j)=fu(j)-drq0(j+1)*(y0(j+1)-y0(j))+drq0(j)*(y0(j)-y0(j-1))
          END DO
          !-------------------------------------------------------
          !     OpPEdElEHiE Y(I+0.5,J)
          !.....determination of Y(i+1/2,j)

          IF(kp==0 .AND.i<=jp) THEN
             ajj(2:m)=t_aj(i,:t_ntet);ajj(1)=t_aj(i,t_ntet)
             call quval(i)
             IF(i==jp) THEN
                psp=t_psiinv(:jp)
                fsp=t_f(:jp)
                CALL spline_interp(psp,fsp,t_splbdry,t_splbdry,fsp1,fsp2,fsp3,&
                     no_yint)
                t_pff(:jp)=2*t_f(:jp)*fsp1*t_psidinv(t_npo)/anu(t_npo)
                ddd=t_inv_x-psp(jp)
                xx(1)=fsp(jp)+ddd*(fsp1(jp)+0.5_rq*ddd*(fsp2(jp)+ddd*fsp3(jp)/&
                     3))
                xx(2)=fsp1(jp)+ddd*(fsp2(jp)+0.5_rq*ddd*fsp3(jp))
                xx(3)=fsp2(jp)+ddd*fsp3(jp)
                ddd=1-t_inv_x
                IF(iabs(ip)==2) THEN
                   xx(3)=frat*xx(3)
                END IF
                xx(4)=-2*(xx(2)+xx(3)*ddd)/ddd**2
                rr(1)=xx(1)+ddd*(xx(2)+0.5_rq*ddd*(xx(3)+ddd/3*xx(4)))
                rr(2)=xx(2)+ddd*(xx(3)+0.5_rq*ddd*xx(4))
                ddd=t_psiinv(i+1)-t_inv_x
                rr(1)=xx(1)+ddd*(xx(2)+0.5_rq*ddd*(xx(3)+ddd/3*xx(4)))
                rr(2)=xx(2)+ddd*(xx(3)+0.5_rq*ddd*xx(4))
                t_f(i+1)=rr(1)
                rr(2)=2*rr(1)*rr(2)*t_psidinv(t_npo)/anu(t_npo)
                t_pff(i+1)=rr(2)
             END IF
          ELSEIF(kp==0 .AND. i<t_npo) THEN
             ddd=t_psiinv(i+1)-t_inv_x
             rr(1)=xx(1)+ddd*(xx(2)+0.5_rq*ddd*(xx(3)+ddd/3*xx(4)))
             rr(2)=xx(2)+ddd*(xx(3)+0.5_rq*ddd*xx(4))
             t_f(i+1)=rr(1)
             rr(2)=2*rr(1)*rr(2)*t_psidinv(t_npo)/anu(t_npo)
!             t_pff(i+1)=t_alfa0*t_pff(i+1)+(1-t_alfa0)*rr(2)
               t_pff(i+1)=rr(2)
             call progc(au,bu,curk,fu,y)
          ELSE
             call progc(au,bu,curk,fu,y)
          END IF
          yy=SUM(y(2:t_ntet))/(t_ntet-1)
          e2(i,:)=abs((t_aj(i,:)-y(2:))/t_aj(i,:))
          t_aj(i,:)=y(2:)
          DO j=2,t_ntet
             IF(e2(i,j)>=de1) THEN
                de1=e2(i,j)
                ii=i;jj=j
             END IF
          END DO
       END IF
       !     pEPEpPiCBAiBAHiE zHA~EHij, pOlY~EHHyX HA pPEdydY}Ej pOBEPXHOCTi
       !.....save values obtained on previous surfac
       drq0=drq
       haaj0=haaj
       hatj0=hatj
       fi0=fi
       rajh0=rajh
       rsj0=rsj
       y0=y
       !...................................................................
    END DO ! i loop

    rat_=t_alfa0-(1-t_alfa0)*yy*TWOPI*us/psend
    IF(kp==2 .AND. (ip==0 .OR. ip==1)) THEN
       psend=psend*rat_
       anu=rat_*anu
       t_pp=t_pp/rat_
    ELSEIF(kp==3 .AND. (ip==1 .OR. ip==-1)) THEN
       IF(t_ifluxcord==2) THEN
          fwalli=fwalli*rat_
       ELSE
          fwalli=fwalli/rat_
       END IF
    ELSEIF(kp==1 .AND. (ip==0 .OR. ip==1)) THEN
       psend=psend*rat_
       anu=rat_*anu
       t_pp=t_pp/rat_
    END IF
    IF(kp>1) THEN
       t_f=0.5_rq*t_pff/t_f*anu*ha
       IF(t_ifluxcord==-1) t_f=t_f*qrk_
       t_f(1)=0
       DO i=2,t_npo
          t_f(i)=t_f(i-1)+t_f(i)
       END DO
       fadd=fwalli-t_f(t_npo)
       t_f=t_f+fadd
       t_frk=t_f
       DO i=t_npo,2,-1
          t_f(i)=0.5_rq*(t_f(i)+t_f(i-1))
       END DO
    END IF
    !-----------------------------------------------------------------------
    !     PE0{EHiE YPABHEHiq dlq RO(A,TETA)
    !.....solution of equation for R0
    call ruthere
    ff(:3)=t_f(t_npo-2:)
    ps(:3)=t_psiinv(t_npo-2:)
    ps(4)=1
    ff(4)=extrp(ff,ps,4,1,0)
    tok1=tok1*10/FOURPI
    IF(kp==0) tok1=2.5_rq*tok5*ha(t_npo)*anu(t_npo)*us/FOURPI
    IF(kp==1 .OR. kp==2) THEN
       IF(ip==1) THEN
          al1=t_alfa0+(1-t_alfa0)*tok1/t_tpl
       ELSEIF(ip==3) THEN
          al1=t_alfa0+(1-t_alfa0)*um/um0
       ELSEIF(ip==-1) THEN
          al1=t_alfa0-(1-t_alfa0)*yy*TWOPI*us/psend
       END IF
       al1=1/al1
       IF(kp==1) THEN
          t_pff=t_pff*al1
          t_pp=t_pp*al1
       ELSEIF(kp==2) THEN
          t_jrk=t_jrk*al1
       END IF
       norm=norm*al1
    ELSE
       IF(ip>=0 ) THEN
          IF(ip==1) THEN
             al1=(t_alfa0+(1-t_alfa0)*tok1/t_tpl)
          ELSEIF(ip==3) THEN
             al1=t_alfa0+(1-t_alfa0)*um/um0
          ELSEIF(kp==0) THEN
             al1=(t_alfa0+(1-t_alfa0)*ff(4)/fwalli)
          ELSE
             al1=1/(t_alfa0-(1-t_alfa0)*yy*TWOPI*us/psend)
          END IF
          al1=1/al1
          psend=psend*al1
          anu=anu*al1
          t_pp=t_pp/al1 ! preserves p
       END IF
       IF(ip==2) THEN
          frat=frat+(1-tok1/t_tpl)*100
       ELSEIF(ip==-2) THEN
          frat=frat+(1+yy*TWOPI*us/psend)*100
       END IF
    END IF
    t_anun=0.
    rosg(1)=0.
    t_rork(1,:)=0
    DO j=1,t_ntet
       e2(2:,j)=(t_rork(2:,j)-t_rork(:t_npo-1,j))*anu(2:)/t_aj(2:,j)
    END DO
    DO j=1,t_ntet-1
       bum=0
       DO i=2,t_npo
          bum=bum+e2(i,j)
          rosg(i)=bum
       END DO
       e2(2:,j)=t_rork(2:,j)
       t_rork(2:,j)=rosg(2:)/rosg(t_npo)
       e2(2:,j)=abs(e2(2:,j)-t_rork(2:,j))
       !     TO~HOCTi   TO~HOCTi   TO~HOCTi<<<<<
       !.....precision
       IF(j==1) THEN
          y(1)=((uk(1)-um)*(vk(2)-vk(t_ntet-1))-(vk(1)-vm)*(uk(2)-&
               uk(t_ntet-1)))*rosg(t_npo)
       ELSE
          y(j)=((uk(j)-um)*(vk(j+1)-vk(j-1))-(vk(j)-vm)*(uk(j+1)-uk(j-1)))*&
               rosg(t_npo)
       END IF
       t_anun=t_anun+y(j)
    END DO
    t_rork(:,t_ntet)=t_rork(:,1)
    e2(:,t_ntet)=e2(:,1)
    t_anun=4*ss/t_anun
    y(t_ntet)=y(1)
    !     TO~HOCTi   TO~HOCTi   TO~HOCTi<<<<<
    !.....precision
    !DC   de0=abs((an0-t_anun)/t_anun)
    !     OpPEdElEHiE MAgHiTHOj OCi
    !.....calculation of magnetic axis
    !     OpPEdElEHiE TO~Ki |KCTPEMYMA
    !.....calculation of peak current
    t_rrk(1)=extrp(t_rrk,t_psiinv,t_npo,0,0)
    t_zrk(1)=extrp(t_zrk,t_psiinv,t_npo,0,0)
    DO i=2,4
       ps(i)=sqrt(t_psiinv(i))
       ps(1)=0
       dum=0.
       dvm=0.
       dfuv=0.
       DO j=2,t_ntet
          sigm=(t_rork(i,j)**2-t_rork(i-1,j)**2)*0.5_rq*(t_rork(i,j)+t_rork(i-1,j))/& 
               ha(i)/anu(i)*y(j)
          dum=dum+uk(j)*sigm
          dvm=dvm+vk(j)*sigm
          dfuv=dfuv+sigm
       END DO
       rr(i)=dum
       zz(i)=dvm
       dd(i)=dfuv
    END DO
    dum=rr(2)/dd(2)
    dvm=zz(2)/dd(2)
    IF(ldbg10==1) THEN
       rr(1)=extrp(rr,ps,4,0,1)
       zz(1)=extrp(zz,ps,4,0,1)
       dd(1)=extrp(dd,ps,4,0,1)
       dum=rr(1)/dd(1)
       dvm=zz(1)/dd(1)
    ELSEIF(ldbg10==-1) THEN
       dum=sqrt(t_rrk(1));dvm=t_zrk(1)
    END IF
    um=(1-t_alfa1)*dum+t_alfa1*um
    vm=(1-t_alfa1)*dvm+t_alfa1*vm
    !----------------------------------------------------------------------
    !     C~ET ~iClA iTEPAcij
    !.....iteration count
    IF(t_ifluxcord<=0) THEN
       t_vrk=t_vrk/(t_f*us*1.e+03_rq)
    END IF
    IF(t_entropy_flag==1) THEN ! LDP 98/1/7 p' from entropy
       cp1=t_alfa0*t_srk*t_vrk**(-GAMMA)+(1-t_alfa0)*t_p
       cp1(1)=extrp(cp1,t_psiinv,t_npo,0,0)
       t_p=cp1
       yb=t_splbdry
       IF(t_filter_p<0) THEN
          CALL polyfit_interp(cp1,t_pp,t_psiinv,t_dpoli,t_spoli,t_mpoli,1)
          yb=777
       ELSEIF(t_filter_p==1) THEN
          CALL polyfit_interp(cp1,t_pp,t_psiinv,t_dpoli,t_spoli,t_mpoli,-2)
          ! Derivative on edge to zero
          yb=777
       ELSE
          call spline_interp(t_psiinv,cp1,yb,yb,t_pp,cp2,cp3,no_yint)
       END IF
    END IF

    nh=nh+1

    !..... reset anu IF t_ifluxcord=-1 and kp/=0

    IF(t_ifluxcord == -1 .AND. kp/=0) THEN
       anu=anu*qrk_
       qrk_=(1-t_alfa2)*qrk_+t_alfa2*qrk_
       anu=anu/qrk_
       psend=-anu(t_npo)*us*TWOPI
    END IF

    !-------------------------------------------------------------------------
    !     pPOBEPKi HA OKOH~AHiE
    !.....test for completion
!    IF(nh.ge.t_nht)go to 24
    DO j=2,t_ntet
       DO i=2,t_npo
          IF(e2(i,j).gt.de2)de2=e2(i,j)
       END DO
    END DO
    t_residj=max(de1,de2)
    IF (t_nprt59 == 2) THEN
!       call parsestr("debug_inv")
       t_anun=abs(1-t_anun)
       rat_=1+psend/(yy*TWOPI*us)
       WRITE(STDOUT,2000)nh,t_residj,t_anun,rat_,al1-1
       WRITE(t_logunit,2000)nh,t_residj,t_anun,rat_,al1-1
2000   format(' res(',i3,')= ',1pe10.3, &
            ' anun= ',1pe10.3,' rat= ',1pe10.3,' ',1pe10.3)
    END IF
    IF(t_residj > t_epsrk .AND. nh<t_nht) THEN
       go to 1001
    ELSEIF(t_residj>1000) THEN
       WRITE(mes,*) "inverse solver will diverge"
       CALL errdetec(mes,1)
    ELSEIF(nh>=t_nht .AND. t_nht>=30 .AND. t_fix_bound) THEN
       WRITE(mes,'(a,i4,a,1pe8.1,a,1pe8.1)')&
            " inverse solver failed to converge, nht = ",&
            t_nht," residj =",t_residj," epsrk =",t_epsrk
       CALL errdetec(mes,-1)
    END IF
    !     OKOH~ATElxHAq BydA~A
    !.....final output

!24  continue
    IF(t_nprt59 == 2) THEN
       WRITE(STDOUT,1000)um,vm,t_anun,nh
       WRITE(t_logunit,1000)um,vm,t_anun,nh
    END IF
1000 FORMAT(10X,'UM=',1pe10.3,',VM=',1pe10.3,',anun=',1pe10.3,',nh=',i4)
    ! 
    t_rork(:,1)=t_rork(:,t_ntet)
    !DC   pt02=to1k
    !     print *,'tok1==',tok1
    rat_=1
    IF(kp==1) THEN
       IF(ip==0 .OR. ip==1) rat_=-yy*TWOPI*us/psend
       t_f=t_pff*anu*ha*rat_
       t_p= t_pp*anu*ha*rat_
       IF(t_ifluxcord==-1) THEN
          t_f=t_f*t_qrk
          t_p=t_p*t_qrk
       END IF
       t_f(1)=0
       t_p(1)=0
       DO i=2,t_npo
          t_f(i)=t_f(i-1)+t_f(i)
          t_p(i)=t_p(i-1)+t_p(i)
       END DO
       fadd=fwalli-t_f(t_npo)
       padd=-t_p(t_npo)+pbnd
       t_f=t_f+fadd
       t_p=t_p+padd
       DO i=t_npo,2,-1
          t_p(i)=0.5_rq*(t_p(i)+t_p(i-1))
          t_f(i)=0.5_rq*(t_f(i)+t_f(i-1))
       END DO
       t_f=sqrt(t_f)
    ELSE
       IF(ip==1 .OR. (ip==0 .AND. kp==2)) rat_=-yy*TWOPI*us/psend
       t_p=t_pp*anu*ha*rat_
       IF(t_ifluxcord==-1) t_p=t_p*t_qrk
       t_p(1)=0
       DO i=2,t_npo
          t_p(i)=t_p(i-1)+t_p(i)
       END DO
       padd=-t_p(t_npo)+pbnd
       t_p=t_p+padd
       DO i=t_npo,2,-1
          t_p(i)=0.5_rq*(t_p(i)+t_p(i-1))
       END DO
    END IF
    t_anun=norm
    t_tpl=tok1
    psend=-yy*TWOPI*us
    t_qrk(1)=extrp(t_qrk,t_psiinv,t_npo,0,0)
    t_trk(1)=extrp(t_trk,t_psiinv,t_npo,0,0)
    t_vrk(1)=extrp(t_vrk,t_psiinv,t_npo,0,0)
    t_jrk(1)=extrp(t_jrk,t_psiinv,t_npo,0,0)
    t_f(1)=extrp(t_f,t_psiinv,t_npo,0,0)
    t_pff(1)=extrp(t_pff,t_psiinv,t_npo,0,0)
    t_p(1)=extrp(t_p,t_psiinv,t_npo,0,0)
    t_pp(1)=extrp(t_pp,t_psiinv,t_npo,0,0)
  END SUBROUTINE polar1

  SUBROUTINE quval(i)
    INTEGER :: n,m,nsix,ns0,i,j,k
    REAL(rq) :: alf,arfs,alfr,x,x1,x2,x3,ff,qq,alfs,dsu
    SAVE nsix
    data nsix /10/
    
    m=t_ntet+1
    n=t_ntet
    ns0=t_ns1
    t_ns1=0
    !     MACCiB Y(J) CHA~AlA - KAK BCpOMOgATElxHyj
    y(2:n)=ajj(2:n)

    !     OKAjMlEHiE AU,BU
    au(1)=au(n)
    au(m)=au(2)
    bu(1)=bu(n)
    bu(m)=bu(2)
    bet(2:n)=0.25_rq*TWOPI*(t_qrk(i-1)*rsj0*(rajh0(2:n)+rajh0(3:m))+t_qrk(i)*&
         rsj*(rajh(2:n)+rajh(3:m)))
    ff=t_f(i-1)
    qq=t_qrk(i)

    !     HA~AlO iTEPAcij
    DO k=1,nsix
    !----------------------------------------------------------------------
    !     ECli ~iClO iTEPAcij BHYTPi 'QUVAL' HA pPEdydY}Ej iTEPAcii 'POLAR'
    !     bylO BEliKO, TO HA~. pPiblivEHiE - C pPEdydY}EgO ClOq (T.E. Y0)
    !     TEKY}Ej iTEPAcii 'POLAR',  ECli HET,
    !     TO HA~. pPiblivEHiE - C pPEdydY}Ej iTEPAcii 'POLAR' (T.E. T_AJ(I,J))
    !----------------------------------------------------------------------
       IF(ns0<=nst) THEN
          y0(2:n)=y(2:n)
       ELSE
          ns0=0
       END IF
       !     C~ET~iK BHYTPEHHiX iTEPAcij
       fuq(2:n)=0.5_rq*(rajh(3:m)+rajh(2:n))/y0(2:n)
       alfs=SUM(fuq(2:n))
       fuq(2:n)=fuq(2:n)/y0(2:n)
       auq(2:n)=bu(3:m)
       buq(2:n)=au(:n-1)
       call progc (auq,buq,curk,fuq,y)
       alfs=TWOPI*qq/alfs**2
       x1=SUM(bet(2:n)*y(2:n))
       x2=SUM(fu(2:n)*y(2:n))
       x1=x1*alfs
       x2=x2*alfs
       x=(ff*x1+x2)/(1.+x1)
       dsu=ff-x
       fuq(2:n)=fu(2:n)+bet(2:n)*dsu
       call progc(au,bu,curk,fuq,y)

       !----------------------------------------------------------------------
       !     pPOBEPKA HA OKOH~AHiE
       DO j=2,n
          IF(abs((y(j)-y0(j))/y(j)).gt.t_epskrk) EXIT
       END DO
       IF(j>n) EXIT
    END DO
    IF(k.gt.nsix) THEN
       call errdetec("quval: failed to converge in jx iterations",0)
       RETURN
    END IF
    t_ns1=k
    t_f(i)=x
  END SUBROUTINE quval

  SUBROUTINE progc(a,b,c,g,u)
    REAL(rq), DIMENSION(:) :: a,b,c,g,u
    REAL(rq), DIMENSION(SIZE(a)) :: alf,betc,u0,f0
    REAL(rq) :: d,fi2,fi20
    INTEGER :: m,k

    m=SIZE(a)
    u0(2)=0
    u0(m)=0

    DO k=2,m-1
       f0(k)=g(k)
    END DO
    alf(3)=0
    DO k=3,m-1
       alf(k+1)=a(k)/(c(k)-alf(k)*b(k))
    END DO

    betc(3)=u0(2)
    DO k=3,m-1
       betc(k+1)=(f0(k)+betc(k)*b(k))/(c(k)-alf(k)*b(k))
    END DO
    DO k=m-1,3,-1
       u0(k)=alf(k+1)*u0(k+1)+betc(k+1)
    END DO

    DO k=2,m
       f0(k)=0
       u(k)=u0(k)
    END DO

    u0(2)=1
    u0(m)=1
    betc(3)=u0(2)
    DO k=3,m-1
       betc(k+1)=(f0(k)+betc(k)*b(k))/(c(k)-alf(k)*b(k))
    END DO
    DO k=m-1,3,-1
       u0(k)=alf(k+1)*u0(k+1)+betc(k+1)
    END DO

    u(1)=u(m-1)
    u0(1)=u0(m-1)
    fi20=a(2)*u0(3)-c(2)*u0(2)+b(2)*u0(1)
    fi2=a(2)*u(3)-c(2)*u(2)+b(2)*u(1)
    d=-(g(2)+fi2)/fi20

    DO k=1,m
       u(k)=u(k)+d*u0(k)
    END DO
  END SUBROUTINE progc

  SUBROUTINE start_inv(kp,ip)
    INTEGER, INTENT(IN) :: kp,ip
    INTEGER :: lfg,i,j
    REAL(rq) :: aa(t_msrf)
    IF(SIZE(i_rhosq,1)/=t_msrf*t_mls) THEN
       IF(ALLOCATED(i_rhosq)) DEALLOCATE(i_rhosq)
       IF(t_n6==6) THEN
          ALLOCATE(i_rhosq(t_msrf*t_mls,2,3))
       ELSEIF(t_n6==16) THEN
          ALLOCATE(i_rhosq(t_msrf*t_mls,4,4))
       END IF
       i_rhosq=0
    END IF
    CALL mach
    t_npo=t_msrf;t_ntet=t_mls
    CALL teq_interface
    t_psil=t_psrf(t_msrf)
    t_psix=t_psrf(1)
    lfg=t_entropy_flag
    t_entropy_flag=0
    IF(t_inv_eq>=0) THEN
       t_rork(2:,:)=SQRT((TRANSPOSE(t_rlsd(:,2:,1)-t_raxis)**2)+&
            (TRANSPOSE(t_zlsd(:,2:,1)-t_zaxis)**2)/t_wvert**2)
       DO i=2,t_npo
          t_rork(i,:)=t_rork(i,:)/t_rork(t_npo,:)
       END DO
       t_rork(1,:)=0
    ELSEIF(t_inv_eq==-1) THEN
       aa=(/(i,i=0,t_npo-1)/)/(t_npo-1._rq)
       DO j=1,t_ntet
          t_rork(:,j)=aa
       END DO
    ELSEIF(t_inv_eq==-2) THEN
       t_rork(2:,:)=SQRT((TRANSPOSE(t_rlsd(:,2:,1)-t_raxis)**2)+&
            (TRANSPOSE(t_zlsd(:,2:,1)-t_zaxis)**2)/t_wvert**2)
       DO i=2,t_npo
          t_rork(i,:)=t_rork(i,:)/t_rork(t_npo,:)
       END DO
       t_rork(1,:)=0
    END IF
    t_inv_eq=0
    call teq_inv(kp,ip)
    t_entropy_flag=lfg
    IF(t_entropy_flag/=0) t_ssave=abs(t_vptor)**GAMMA
  END SUBROUTINE start_inv

  SUBROUTINE escinv
    ! calls ESC (zakharov)
    INTEGER ifail,ns,imth,clockwise,ls,l,lss
    EXTERNAL esc00,escin,esc1,escGetPsibar,escGetPhibar,escGetG,escGetP,&
         escGetR,escGetZ,esc
    SAVE ns
    REAL(rq), DIMENSION(t_msrf) :: p_esc,q_esc,j_esc,s_esc,temp_esc,psi_esc,&
         phi_esc,p_temp,g_esc
    REAL(rq), DIMENSION(t_mls) ::  cq_,rb_,zb_,dq_
    REAL(rq) :: yp,rbtor,dummy,rr(4)
    DATA yp /-666/, imth /-10/, clockwise /0/ ! counter clockwise
    CHARACTER(len=32) label
    include "debug.i"
    IF(ns/=t_msrf .AND. ns/=0) THEN
       call esc1;t_ijob=0
    END IF
    ns=t_msrf
    rb_=t_rls*.01_rq;zb_=t_zls*.01_rq
    s_esc=(/(ls,ls=0,ns-1)/)/(ns-1.0)
    p_temp=SQRT(t_phibar)
    call interp_interp(p_temp,t_qsave,t_splbdry,t_splbdry,s_esc,q_esc,temp_esc)
    call interp_interp(p_temp,t_psave,t_splbdry,t_splbdry,s_esc,p_esc,temp_esc)
    call interp_interp(p_temp,t_jtsave,t_splbdry,t_splbdry,s_esc,j_esc,&
         temp_esc)
    p_esc=0.1_rq*p_esc*MU0       ! MKS
    j_esc=-s_pin*1.0e+4*j_esc/t_raxis*MU0 ! MKS and amps/M**2
    p_esc=p_esc/(1e6*MU0);j_esc=j_esc/(1e6_rq*MU0)
    rbtor=1.e-6_rq*abs(t_fwall)
    IF(t_ijob==0) THEN ! initialization
       label="esc_test"
       call esc00(label,t_msrf-1)
       call escin(p_esc,j_esc,s_esc,t_msrf,21,rb_,zb_,t_mls,rbtor,.01_rq*&
            t_raxis)
       call esc(ifail, t_ijob, t_mesc, dummy) !Execute ESC
       t_ijob=1
       IF(ifail /= 0) THEN ! Test against failure
          print *, 'ESC-failure ', ifail
          print *, 'possible causes are:'
          print *, 'ifail=2 problems near the boundary'
          print *, 'ifail=4 problems near the axis'
          print *, 'ifail=8 problems in the middle'
          print *, 'odd ifail numbers are usually tolerable'
       END IF
    END IF

    IF(t_inv_k==0) THEN
       Call escin(p_esc,q_esc,s_esc,t_msrf,26,rb_,zb_,t_mls,rbtor,.01_rq*&
            t_raxis)
    ELSE
       call escin(p_esc,j_esc,s_esc,t_msrf,21,rb_,zb_,t_mls,rbtor,.01_rq*&
            t_raxis)
       !     p_esc=p_esc*(1e6*MU0);j_esc=j_esc*(1e6*MU0)
       !     call esc_p_jparallel(p_esc,j_esc,rb_,zb_,t_mls,rbtor,.01_rq*&
    END IF
    call esc(ifail, t_ijob, t_mesc, dummy)
    IF(ifail /= 0) THEN ! Test against failure
       print *, 'ESC-failure ', ifail
       print *, 'possible causes are:'
       print *, 'ifail=2 problems near the boundary'
       print *, 'ifail=4 problems near the axis'
       print *, 'ifail=8 problems in the middle'
       print *, 'odd ifail numbers are usually tolerable'
    END IF
    call escGetPsibar(psi_esc,t_msrf)
    call escGetPhibar(phi_esc,t_msrf)
    call escGetG(g_esc,t_msrf)
    call escGetP(t_prsrf,t_msrf)
    call escGetR(t_rlsd(1,1,1),t_mls,t_msrf,clockwise)
    call escGetZ(t_zlsd(1,1,1),t_mls,t_msrf,clockwise)
    g_esc=1e6_rq*g_esc
    t_prsrf=t_prsrf*10/MU0
    t_rlsd(:,:,1)=100*t_rlsd(:,:,1);t_zlsd(:,:,1)=100*t_zlsd(:,:,1)
    t_raxis=t_rlsd(1,1,1);t_zaxis=t_zlsd(1,1,1)
    t_dpsi0=psi_esc(t_msrf);t_dphi0=phi_esc(t_msrf)
    psi_esc=psi_esc/t_dpsi0;psi_esc(1)=0
    phi_esc=phi_esc/t_dphi0;phi_esc(1)=0
    t_dpsi0=1e8*s_pin*t_dpsi0;t_dphi0=1e8_rq*s_pin*t_dphi0
    IF(ndbg28==1) THEN ! Using ESC coordinates
       call fdDeriv(t_prsrf,psi_esc,t_msrf,t_pdsrf);t_pdsrf=t_pdsrf/t_dpsi0
       t_frsrf=g_esc
       call fdDeriv(t_frsrf,psi_esc,t_msrf,t_fpsrf);t_fpsrf=t_fpsrf/t_dpsi0
       p_temp=sqrt(psi_esc)
       t_rhosq(:,:,1)=transpose(t_rlsd(:,:,1))
       call bispline_interp(p_temp,t_tswpts,t_rhosq,imth,t_n6)
       t_rlsd(:,:,3)=transpose(t_rhosq(:,:,2))
       t_rlsd(:,:,2)=transpose(t_rhosq(:,:,3))
       t_rhosq(:,:,1)=transpose(t_zlsd(:,:,1))
       call bispline_interp(p_temp,t_tswpts,t_rhosq,imth,t_n6)
       t_zlsd(:,:,3)=transpose(t_rhosq(:,:,2))
       t_zlsd(:,:,2)=transpose(t_rhosq(:,:,3))
       t_rhosq(:,:,1)=t_zlsd(:,:,1)
       DO l=2,t_msrf
          t_rlsd(:,l,3)=t_rlsd(:,l,3)*0.5_rq/(p_temp(l)*t_dpsi0)
          t_zlsd(:,l,3)=t_zlsd(:,l,3)*0.5_rq/(p_temp(l)*t_dpsi0)
       END DO
       t_zlsd(:,:,4)=(t_rlsd(:,:,3)*t_zlsd(:,:,2)-t_rlsd(:,:,2)*&
            t_zlsd(:,:,3))*t_rlsd(:,:,1)
       DO ls=1,t_mls
          rr(2:)=t_zlsd(ls,2:4,4)
          t_zlsd(ls,1,4)=extrp(rr,p_temp,4,0,0)
       END DO
       t_rlsd(:,:,4)=sqrt(t_rlsd(:,:,2)**2+t_zlsd(:,:,2)**2)/abs(t_zlsd(:,:,4))
       t_psrf=t_psix+psi_esc*t_dpsi0
       dpsrf(2:)=t_psrf(2:)-t_psrf(:t_msrf-1)
       call get_surfint
       p_temp=t_cusrf/t_frsrf/.4_rq/PI
       call fdDeriv(p_temp,psi_esc,t_msrf,t_jtsrf)
       t_jtsrf=-t_frsrf**2*t_jtsrf/TWOPI/q_esc/t_dpsi0
       call remark("in escinv")
       CALL debugger
    END IF
    call interp_interp(psi_esc,t_prsrf,t_splbdry,t_splbdry,t_psibar,t_prsrf,&
         t_pdsrf)
    call interp_interp(psi_esc,g_esc,t_splbdry,t_splbdry,t_psibar,t_frsrf,t_fpsrf)
    t_pdsrf=t_pdsrf/t_dpsi0;t_fpsrf=t_fpsrf/t_dpsi0
    DO l=2,t_msrf
       t_rls=t_rlsd(:,l,1);t_zls=t_zlsd(:,l,1)
       cq_=atan2((t_zls-t_zaxis)/t_wvert,t_rls-t_raxis)
       DO ls=1,t_mls
          IF(cq_(ls)>=0)EXIT
       END DO
       DO lss=ls,t_mls
          IF(cq_(lss)<0) cq_(lss)=cq_(lss)+TWOPI
       END DO
       cq_(t_mls)=cq_(t_mls)+TWOPI
       call interp_interp(cq_,t_rls,yp,yp,t_tswpts,rb_,dq_)
       t_rlsd(:,l,3)=rb_
       t_rlsd(:,l,4)=dq_
       call interp_interp(cq_,t_zls,yp,yp,t_tswpts,zb_,dq_)
       t_zlsd(:,l,3)=zb_
       t_zlsd(:,l,4)=dq_
    END DO
    t_rlsd(:,1,3)=t_raxis;t_zlsd(:,1,3)=t_zaxis
    DO ls=1,t_mls
       p_temp=(t_rlsd(ls,:,3)-t_raxis)**2+((t_zlsd(ls,:,3)-t_zaxis)/t_wvert)**2
       call interp_interp(psi_esc,p_temp,t_splbdry,t_splbdry,t_psibar,pswpts,&
            temp_esc)
       t_rlsd(ls,:,1)=t_raxis+sqrt(pswpts)*t_brwpts(ls)
       t_zlsd(ls,:,1)=t_zaxis+sqrt(pswpts)*t_bzwpts(ls)*t_wvert
    END DO
!    IF(ndbg28==1) call parsestr('<<"exiting escinv";debugger')
  END SUBROUTINE escinv

  SUBROUTINE teq_inv(kp,ip)
    ! calls polar1 to calculate inverse coordinates      
    ! ********************************************************************
    !  kp=0: input qsave and t_psave or t_ssave on t_entropy_flag;         *
    !        output t_frsrf with t_psave fixed IF input.                 *
    !  kp=3: input jparsave--->t_jparsrf, t_psave; output t_frsrf        *
    !  with:                                                             *
    !  ip<0: input dpsi00; output plc(amps*10) tpl(KA)                   *
    !  ip=0: input t_fwall;output t_dpsi0, plc(amps*10) tpl(KA)          *
    !  ip>0: input plcm; output t_dpsi0 (dpsi00=t_dpsi0)                 *
    ! ------------------------------------------------------------------ *
    !  kp=1: input FF'=fpsrf*t_frsrf, t_psave; output FF', T_P' (scaled) *
    !  kp=2: input jtsave--->t_jtsrf, t_psave; output  jtsave(scaled)    *
    !        and t_frsrf with t_psave fixed                              *
    !  with                                                              *
    !  ip=0: no input; output plc (tpl) and t_dpsi0 (dpsi00=t_dpsi0)     *
    !  ip<0: input dpsi00; output plc and                                *
    !  ip>0; input plcm; output t_dpsi0=dpsi00;                          *
    ! ********************************************************************
    include "debug.i"
    INTEGER kp,ip 
    REAL(rq) :: pdp,pdm,qdp,qdm,qp,dflat,dmn,qpp,qppp,qq,zpsend,&
    bel(3,3),rel(3),rho(t_mls),zdpsi0,zt_frsrf,zdpsi00,y1,aa(4),bb(4),&
         fff(1),ffp(1),aaa(1),yb,noyint(1),wp0,qcelm_,pcelm_,scelm_,qmin,&
         qmn,dflas,dms,denom,eps
    INTEGER :: npoo,nteto,i,lelm_,iqq,l,lmt,lms,lflas,j,m3,m4,m5,iq,ls,lss,&
         mmm,jj,iter
    integer :: sz
    SAVE npoo,nteto,noyint,y1
    DATA noyint(1)/-999_rq/,y1/-666_rq/
    DATA npoo/0/,nteto/0/

    IF(npoo/=t_npo) THEN
       IF(npoo/=0)DEALLOCATE(anu,a,ai,ha,c_0,c_1,c_2,c_3,dpsrf,qelm,pelm,&
            selm)
       ALLOCATE(anu(t_npo),a(t_npo),ai(t_npo),ha(t_npo),c_0(t_npo),c_1(t_npo),&
            c_2(t_npo),c_3(t_npo),dpsrf(t_npo),qelm(t_npo),pelm(t_npo),&
            selm(t_npo))
       a=(/(i,i=0,t_npo-1)/)/(t_npo-1._rq)
       ai(2:)=(a(2:)+a(:t_npo-1))/2
       ha(2:)=a(2:)-a(:t_npo-1)
       ai(1)=0;ha(1)=0
       c_0=0;c_1=0;c_2=0;c_3=0
    END IF
    IF(nteto/=t_ntet) THEN
       IF(ALLOCATED(uk))DEALLOCATE(uk,vk,pswpts,c_q)
       ALLOCATE(uk(t_ntet),vk(t_ntet),pswpts(t_ntet),c_q(t_ntet))
       uk=0;vk=0;c_q=0
       nteto=t_ntet
    END IF
    sz = 0; if (allocated(t_vp)) sz = size(t_vp)
    IF(t_msrf/=sz) THEN
       if(ALLOCATED(t_vp)) DEALLOCATE(t_vp,t_vpp,t_vppp,t_wp,t_wpp,t_wppp)
       ALLOCATE(t_vp(t_msrf),t_vpp(t_msrf),t_vppp(t_msrf),t_wp(t_msrf),&
            t_wpp(t_msrf),t_wppp(t_msrf))
    END if
    IF(SIZE(s_jbl)/=t_km) THEN
       IF(ALLOCATED(s_jbl)) DEALLOCATE(s_jbl,s_jbu)
       ALLOCATE(s_jbl(t_km),s_jbu(t_km))
    END IF

    ! For rezonine
    IF(t_ntet==t_mls .AND. t_npo==t_msrf) THEN
       sz = 0; if (allocated(tst)) sz = size(tst)
       IF(sz/=t_ntet) THEN
          IF(ALLOCATED(tst)) DEALLOCATE(tst)
          ALLOCATE(tst(t_ntet))
          tst=t_tswpts
       END IF
       sz = 0; if (allocated(pst)) sz = size(pst)
       IF(sz/=t_npo) THEN
          IF(ALLOCATED(pst)) DEALLOCATE(pst)
          ALLOCATE(pst(t_npo))
          pst=t_psibar
       END IF
    END IF
    
    CALL i_t(i_rhosq)
    s_pin=SIGN(1.0_rq,t_dpsi0)
    yb=t_splbdry
    t_fwall=t_ro*t_btor
    tet=>t_tswpts
    IF(t_inv_flag<=0) THEN
       IF(t_use_halo) call haloboundary
       IF(t_inv_eq==0) THEN
          uk=t_rls
          vk=t_zls
          um=t_raxis
          vm=t_zaxis
          elong=t_wvert ! for inv
       END IF
       IF(uk(1)==0) THEN ! must initialize
          uk=t_rls
          vk=t_zls
       END IF
    END IF
    npoo=t_npo
    ! begin disruption models OR ELM model
    IF(t_vpsrf(1)==0)t_vpsrf=1
    IF(t_ifluxcord<=0) THEN
       t_vptor=abs(t_vpsrf/t_qsrf)
    ELSE
       t_vptor=t_vpsrf
    END IF
    qelm=t_qsave
    selm=t_ssave
    pelm=t_psave
    IF(t_use_halo .AND. t_lhalo<t_msrf) THEN
       zdpsi0=t_dpsi0;zdpsi00=t_dpsi00
       t_dpsi00=(t_psih-t_psix);t_dpsi0=t_dpsi00
       c_0=t_psix+(t_psih-t_psix)*t_psibar
       call interp_interp(t_psrf,qelm,yb,yb,c_0,c_1,c_2)
       qelm=c_1
       call interp_interp(t_psrf,selm,yb,yb,c_0,c_1,c_2)
       selm=c_1
       call interp_interp(t_psrf,pelm,yb,yb,c_0,c_1,c_2)
       pelm=c_1
    END IF
    IF(t_lelm/=0) THEN
       IF(t_lelm>0) THEN
          qcelm_=t_qcelm/(1-t_rhosrf(t_lelm))**3
          pcelm_=t_pcelm/(1-t_rhosrf(t_lelm))**3
          scelm_=t_scelm/(1-t_rhosrf(t_lelm))**3
          lelm_=t_lelm
          c_3=(t_rhosrf-t_rhosrf(t_lelm))**3
          c_2=c_3
       ELSEIF(t_lelm<0) THEN
          lelm_=-t_lelm
          qcelm_=t_qcelm/(1-t_rhosrf(lelm_))**4
          pcelm_=t_pcelm/(1-t_rhosrf(lelm_))**3
          scelm_=t_scelm/(1-t_rhosrf(lelm_))**3
          c_2=(t_rhosrf-t_rhosrf(lelm_))**3
          c_3=c_2*(1-t_rhosrf)
       END IF
       IF(t_pcelm>0) THEN
          pelm=t_psave*(1+pcelm_*c_2)
       ELSEIF(t_pcelm<0) THEN
          pelm=t_psave/(1-pcelm_*c_2)
       END IF
       IF(t_scelm>0) THEN
          selm=t_ssave*(1+scelm_*c_2)
       ELSEIF(t_scelm<0) THEN
          selm=t_ssave/(1-scelm_*c_2)
       END IF
       IF(t_qcelm>0) THEN
          qelm=t_qsave*(1+qcelm_*c_3)
       ELSEIF(t_qcelm<0) THEN
          qelm=t_qsave/(1-qcelm_*c_3)
       END IF
    END IF
    IF(t_lflat>0) THEN
       qelm=t_qsave
       qmin=xminaf(qelm,1,t_msrf,1,iq)
       IF(iq/=1 .AND. qmin>1) THEN
          qmin=qmin-(qelm(iq+1)-qelm(iq-1))**2/(qelm(iq+1)+qelm(iq-1)-&
               2*qelm(iq))/8
       ELSE
          iq=1
       END IF
       DO l=t_msrf-1,1,-1
          IF(qelm(l)<t_qflat) EXIT
       END DO
       t_lflat=l+1
       pdp=t_rhosrf(t_lflat+1)-t_rhosrf(t_lflat)
       pdm=t_rhosrf(t_lflat-1)-t_rhosrf(t_lflat)
       qdp=(qelm(t_lflat+1)-qelm(t_lflat))/pdp
       qdm=(qelm(t_lflat-1)-qelm(t_lflat))/pdm
       qpp=(qdp-qdm)/(pdp-pdm)
       qp=(qdp*pdm-qdm*pdp)/(pdm-pdp)
       qq=t_qflat-qelm(t_lflat)
       dflat=2*qq/qp/(1+sqrt(1+2*qq*qpp/qp**2))
       qp=qp+qpp*dflat
       dflat=dflat+t_rhosrf(t_lflat)
       dmn=-3*t_qrat*(t_qflat-qmin)/qp
       qpp=-2*qp/dmn ! makes q', q''=0 ,at joint
       qppp=-qpp/dmn ! makes q', q''=0 ,at joint
       qmn=t_qflat+dmn*(qp+0.5_rq*dmn*(qpp+dmn*qppp/3._rq))
       dmn=dmn+dflat
       DO l=2,t_lflat
          IF(t_rhosrf(l)>dmn) EXIT
       END DO
       lmt=l
       DO l=lmt,t_lflat-1
          c_3(l)=t_rhosrf(l)-dflat
          qelm(l)=t_qflat+c_3(l)*(qp+0.5_rq*c_3(l)*(qpp+c_3(l)*qppp/3._rq))
       END DO
       lms=0
       IF(iq>1 .AND. qelm(1)>t_qflat) THEN
          DO l=2,lmt
             IF(qelm(l)<t_qflat) EXIT
          END DO
          lflas=l-1
          pdp=t_rhosrf(lflas+1)-t_rhosrf(lflas)
          pdm=t_rhosrf(lflas-1)-t_rhosrf(lflas)
          qdp=(qelm(lflas+1)-qelm(lflas))/pdp
          qdm=(qelm(lflas-1)-qelm(lflas))/pdm
          qpp=(qdp-qdm)/(pdp-pdm)
          qp=(qdp*pdm-qdm*pdp)/(pdm-pdp)
          qq=t_qflat-qelm(lflas)
          dflas=2*qq/qp/(1+sqrt(1+2*qq*qpp/qp**2))
          qp=qp+qpp*dflas
          dflas=dflas+t_rhosrf(lflas)
          dms=3*(qmn-t_qflat)/qp
          qpp=-2*qp/dms ! makes q',q''=0 ,at joint
          qppp=-qpp/dms ! makes q',q''=0 ,at joint
          qmn=t_qflat+dms*(qp+0.5_rq*dms*(qpp+dms*qppp/3._rq))
          dms=dms+dflas
          DO l=lflas+1,t_lflat-1
             IF(t_rhosrf(l)>dms) EXIT
          END DO
          lms=l-1
          DO l=lflas+1,lms
             c_3(l)=t_rhosrf(l)-dflas
             qelm(l)=t_qflat+c_3(l)*(qp+0.5_rq*c_3(l)*(qpp+c_3(l)*qppp/3._rq))
          END DO
       END IF
       DO l=lms+1,lmt-1
          qelm(l)=qmn
       END DO
    END IF
    IF(t_lflat/=0) THEN
       selm=t_scflat*t_ssave
       pelm=t_scflat*t_psave
    END IF

    !  end models

    !  limit q(1) for reverse shear

    IF(qelm(1) > t_qmax) THEN
       qmin=xminaf(qelm,1,t_msrf,1,iq)
       IF(iq/=1) THEN
          qmin=qmin-(qelm(iq+1)-qelm(iq-1))**2/(qelm(iq+1)+qelm(iq-1)-&
               2*qelm(iq))/8
       END IF
       eps=(qelm(1)/t_qmax-1)/(qelm(1)/t_qmax-qmin/t_qmax)**2
       DO i=1,iq
          qelm(i)=qelm(i)/(1+eps*((qelm(i)-qmin)/t_qmax)**2)
       END DO
    END IF
    !   end limit
    IF(t_dpsi00==0) t_dpsi00=t_dpsi0
    IF(t_dphi00==0) t_dphi00=t_dphi0

    ! inputs for inverse equilibrium
    IF(t_inv_flag<=0) THEN
       IF(t_nitt<=1 .AND. t_wvert/=1) THEN
          IF(t_esrf(1)/=0 .AND. t_fix_bound) t_wvert=t_esrf(1)
       END IF
       elong=t_wvert
       IF(t_ifluxcord==-1) THEN
          zdp0=t_dphi00
          IF(t_ipj==2 .AND. .NOT.t_fix_bound) zdp0=t_dphi0
       ELSE
          zdp0=t_dpsi00
          IF(t_ipj==2 .AND. .NOT.t_fix_bound) zdp0=t_dpsi0
       END IF
       t_tpl=t_plcm*1.e+03
       t_inv_eq=1
       IF(t_fix_bound) t_inv_eq=2
       IF(t_inv_eq==1) THEN 
          IF(t_ipj==0 .OR. t_ipj>5) THEN
             IF(t_raxis==0) THEN
                t_raxis=um;t_zaxis=vm
                pswpts=(t_rls-t_raxis)**2+((t_zls-t_zaxis)/t_wvert)**2
                c_q=atan2((t_zls-t_zaxis)/t_wvert,t_rls-t_raxis)
                DO i=1,t_mls
                   IF(c_q(i)>0) EXIT
                END DO
                DO j=i,t_mls
                   IF(c_q(j)<0) EXIT
                END DO
                c_q(j:)=c_q(j:)+TWOPI
                call interp_interp(c_q,pswpts,y1,y1,t_tswpts,pswpts,noyint)
                t_rls=t_raxis+sqrt(pswpts)*cos(t_tswpts)
                t_zls=t_zaxis+sqrt(pswpts)*sin(t_tswpts)*t_wvert
             END IF
             uk=t_rls*t_alfa1+uk*(1-t_alfa1)
             vk=t_zls*t_alfa1+vk*(1-t_alfa1)
          END IF
       ELSEIF(t_nitt==0 .AND. t_inv_eq==2) THEN
          uk=t_rls
          vk=t_zls
       END IF
       denom=t_prsx*t_betaj
       IF(kp==0) THEN
          IF(t_entropy_flag>0) THEN
             pelm=selm/(t_vptor)**GAMMA
             t_psave=pelm
          ELSEIF(t_entropy_flag<0 .AND. t_nitt<=1) THEN
             pelm=selm/(t_vptor)**GAMMA
             t_psave=pelm
          END IF
          call interp_interp(t_rhosrf,qelm,yb,yb,t_psiinv,t_qrk,c_3)
          call interp_interp(t_rhosrf,selm,yb,yb,t_psiinv,t_srk,c_3)
          call interp_interp(t_rhosrf,t_frsrf,yb,yb,t_psiinv,t_f,t_pff)
          t_srk=4e-3_rq*PI*s_pin*t_ro*t_srk/zdp0
          t_f=t_f/(t_ro*1.e+03_rq)
          t_pff=2*s_pin*t_f*t_pff/zdp0
          t_f(t_npo)=t_frsrf(t_msrf)/(t_ro*1.e+03_rq)
          t_f(1)=t_frsrf(t_msrf)/(t_ro*1.e+03_rq) ! boundary condition
       ELSE
          IF(kp==1) t_frsrf=t_fsave
          call interp_interp(t_rhosrf,t_qsrf,yb,yb,t_psiinv,t_qrk,c_3)
          call interp_interp(t_rhosrf,t_frsrf,yb,yb,t_psiinv,t_f,t_pff)
          t_f=t_f/(t_ro*1.e+03_rq)
          t_pff=2*s_pin*t_f*t_pff/zdp0
          t_pff(1)=extrp(t_pff,ai,t_npo,0,0)
          t_f(1)=t_frsrf(t_msrf)/(t_ro*1.e+03_rq) ! boundary condition
          IF(kp==3) THEN
             call interp_interp(t_rhosrf,t_jparsave,yb,yb,t_psiinv,t_jrk,c_3)
             t_jrk=FOURPI*s_pin*t_jrk/10.0_rq
          ELSEIF(kp==2) THEN
             call interp_interp(t_rhosrf,t_jtsave,yb,yb,t_psiinv,t_jrk,c_3)
             t_jrk=FOURPI*s_pin*t_jrk/(1e+04_rq*t_ro)
          END IF
          !          t_fpsrf=t_fpsrf/zdp0
       END IF
       IF(ip/=1 .AND. ip/=-1 .AND. kp/=1 .AND. kp/=2) THEN
          IF(t_ifluxcord==2) THEN
             t_f(1)=t_fwall/(t_ro*1.e+03_rq) ! boundary condition
          ELSE
             t_f(1)=abs(t_fwall)/(t_ro*1.e+03_rq) ! boundary condition
          END IF
       END IF
       ! Set up arary v which can be filtered
       IF(t_ifluxcord==-1) THEN
          t_v=pelm/denom/t_dpsi00
       ELSE
          t_v=pelm/denom/zdp0
       END IF
       IF(t_filter_p>2) THEN
          t_v= zero_der_interp(t_psibar,t_v,t_filter_p)
       ELSEIF(t_filter_p>0) THEN
          CALL polyfit_interp(t_v,t_vp,t_psibar,t_dpoly,t_spoly,t_mpoly,-2)
          ! zeroes derivative at edge
          yb=777
       ELSEIF(t_filter_p<0) THEN
          CALL polyfit_interp(t_v,t_vp,t_psibar,t_dpoly,t_spoly,t_mpoly,1)
          yb=777
       ELSE
          DO i=1,3
             bel(i,1)=1
             bel(i,2)=t_psibar(i+2);bel(i,3)=t_psibar(i+2)*sqrt(t_psibar(i+2))
          END DO
          call rmInvert(bel,3,3)
          DO i=1,3
             rel(i)=0
             DO j=1,3
                rel(i)=rel(i)+bel(i,j)*t_v(j+2)
             END DO
          END DO
          t_v(1)=rel(1)
          t_v(2)=rel(1)+t_psibar(2)*(rel(2)+sqrt(t_psibar(2))*rel(3))
       END IF
       call spline_interp(t_psibar,t_v,yb,yb,t_vp,t_vpp,t_vppp,noyint)
       t_pdsrf=t_vp*denom
       IF(t_ifluxcord==-1) THEN ! this is computed for consistancy
          t_prsrf=t_v*denom*t_dpsi00
       ELSE
          t_prsrf=t_v*denom*zdp0
       END IF
       yb=t_splbdry ! reset

       ! begin inverse solver
       call interp_interp(t_rhosrf,t_v,yb,yb,t_psiinv,t_p,t_pp)
       IF(t_entropy_flag>0) THEN
          ! difference needed for entropy option
          t_p=FOURPI*1.e-3_rq*s_pin*t_ro*t_p*denom
       ELSE
          t_p=FOURPI*t_p*1e-6_rq*t_dpsi0*denom
       END IF
       t_pp=FOURPI*t_pp*1e-3_rq*s_pin*t_ro*denom
       t_p(1)=FOURPI*t_v(t_msrf)*1e-6_rq*t_dpsi0*denom ! boundary condition
       anu=s_pin*zdp0*1e-3_rq/t_ro*t_psidinv
       IF(t_ifluxcord==-1) THEN
          anu=anu/t_qrk
          t_pp=t_pp*t_dpsi00/zdp0 ! now derivative wrt toroidal flux
          t_p=t_p*t_dpsi00/zdp0 ! For q input, t_p is not recomputed
          t_fpsrf=t_fpsrf*t_qsrf ! this is computed for local info
       END IF
       DO j=1,t_ntet
          t_aj(:,j)=anu
       END DO
       psend=-anu(t_npo)*TWOPI*t_ro

       zpsend=psend
       IF(t_ifluxcord==-1) zpsend=zpsend*t_qrk(t_npo)
       call polar1(kp,ip)
       t_raxis=um;t_zaxis=vm 
       IF(kp==1 .AND. ip>-1) THEN
          t_prsx=t_prsx*t_anun*psend/zpsend
       END IF
       ! end inverse solver

       ! set t_dpsi0 from psend
       IF(t_ifluxcord==-1) THEN
          t_dphi0=zdp0*psend/zpsend*t_qrk(t_npo)
          zdp0=t_dphi0
       ELSE
          t_dpsi0=zdp0*psend/zpsend
          zdp0=t_dpsi0
       END IF
       ! set geometry in eq variables

       t_rhosq(:,:,1)=(ur(:,:)-um)**2+((vz(:,:)-vm)/elong)**2 ! rho**2
       t_rlsd(:,:,1)=transpose(ur(:,:))
       t_zlsd(:,:,1)=transpose(vz(:,:))
       IF(.NOT.t_iter_bdry) THEN ! convert back to polar coordinates
          IF(SIZE(dq1)/=t_mls) THEN
             IF(ALLOCATED(dq1)) DEALLOCATE(dq1,dq2,cq1,cq2)
             ALLOCATE(dq1(t_mls),dq2(t_mls),cq1(t_mls),cq2(t_mls))
          END IF
!          call parsestr('"equal arc boundary";debugger')
          call get_rhosq
          IF(t_n6==6) THEN
             m3=3;m4=4;m5=5
          ELSEIF(t_n6==16) THEN
             m3=5;m4=6;m5=3
          END IF
          t_brwpts=(uk-t_raxis)/sqrt(t_rhosq(t_msrf,:,1))
          t_bzwpts=(vk-t_zaxis)/sqrt(t_rhosq(t_msrf,:,1))
          call spline_interp(t_tswpts,t_brwpts,y1,y1,cq1,cq2,dq2,c_q)
          call spline_interp(t_tswpts,t_bzwpts,y1,y1,dq1,cq2,dq2,c_q)
          DO l=1,t_msrf
             rho=sqrt(abs(t_rhosq(l,:,1)))+errt_rq
             t_rlsd(:,l,2)=0.5_rq*t_rhosq(l,:,m3)/rho*t_brwpts+rho*cq1
             t_zlsd(:,l,2)=0.5_rq*t_rhosq(l,:,m3)/rho*t_bzwpts+rho*dq1
             t_rlsd(:,l,3)=0.5_rq*t_rhosq(l,:,2)/rho*t_brwpts/t_dpsi0
             t_zlsd(:,l,3)=0.5_rq*t_rhosq(l,:,2)/rho*t_bzwpts/t_dpsi0
             ! Jacobian
             t_zlsd(:,l,4)=0.5_rq*elong*t_rhosq(l,:,2)*t_rlsd(:,l,1)/t_dpsi0
             ! Bpol
             t_rlsd(:,l,4)=sqrt(t_rlsd(:,l,2)**2+t_zlsd(:,l,2)**2)/&
                  abs(t_zlsd(:,l,4)) ! Bpol
          END DO
          t_rlsd(:,1,4)=errt_rq
          dq1=atan2((vk-vm)/t_wvert,uk-um)
          DO ls=2,t_mls-1
             IF(dq1(ls)<0) EXIT
          END DO
          DO lss=ls,t_mls
             dq1(lss)=dq1(lss)+TWOPI
          END DO
!          call parsestr('"back to equal angle";debugger')
          DO l=2,t_msrf
             pswpts=t_rhosq(l,:,1)
             call interp_interp(dq1,pswpts,y1,y1,t_tswpts,dq2,cq1)
             t_rhosq(l,:,1)=dq2
          END DO
       END IF
       ! get derivative of t_rhosq
       IF(ndbg2==0) THEN
          ! First force t_rhosq smoothly to zero at axis
          DO ls=1,t_mls
             c_0=t_rhosq(:,ls,1)
             t_rhosq(1,ls,1)=extrp(c_0,t_rhosrf,t_msrf,0,0)
             c_q(ls)=t_rhosq(1,ls,1)
             t_rlsd(ls,1,1)=t_raxis
             t_zlsd(ls,1,1)=t_zaxis
          END DO
          DO l=1,t_msrf
             IF(l==1) THEN
                t_rhosq(l,:,1)=errt_rq**2*t_raxis**2
             ELSE
                t_rhosq(l,:,1)=t_rhosq(l,:,1)-c_q
             END IF
             t_rlsd(:,l,1)=t_raxis+sqrt(abs(t_rhosq(l,:,1)))*cos(t_tswpts)
             t_zlsd(:,l,1)=t_zaxis+sqrt(abs(t_rhosq(l,:,1)))*sin(t_tswpts)*&
                  t_wvert
          END DO
       END IF
       !end smooth
    ELSE
       t_rls=uk;t_zls=vk
       call escinv
       t_rhosq(:,:,1)=transpose((t_rlsd(:,:,1)-t_raxis)**2+((t_zlsd(:,:,1)-&
            t_zaxis)/t_wvert)**2)
    END IF
    t_rls=t_rlsd(:,t_msrf,1)
    t_zls=t_zlsd(:,t_msrf,1)
    call get_rhosq

    IF(t_n6==6) THEN
       m3=3;m4=4;m5=5
    ELSEIF(t_n6==16) THEN
       m3=5;m4=6;m5=3
    END IF

    IF(t_ifluxcord==-1) THEN
       IF(kp==0) THEN
          t_qsrf=t_qsave
          c_0=1/t_qsrf
          call spline_interp(t_phibar,c_0,yb,yb,c_1,c_2,c_3,t_psibar)
          t_dpsi0=t_dphi0*t_psibar(t_msrf)
          t_psibar=t_psibar/t_psibar(t_msrf)
          t_qh=t_phibar*t_dphi0/t_dpsi0
       ELSE
          t_qrk(1)=extrp(t_qrk,t_psiinv,t_npo,0,0)
          call interp_interp(t_psiinv,t_qrk,yb,yb,t_rhosrf,t_qsrf,c_1)
          c_0=1/t_qsrf
          call spline_interp(t_phibar,c_0,yb,yb,c_1,c_2,c_3,t_psibar)
          t_dpsi0=t_dphi0*t_psibar(t_msrf)
          t_psibar=t_psibar/t_psibar(t_msrf)
          zdp0=t_dphi0
          t_qh=t_phibar*t_dphi0/t_dpsi0
       END IF
       call spline_interp(t_psibar,t_qsrf,yb,yb,c_1,c_2,c_3,noyint)
       DO l=1,t_msrf
          t_rhosq(l,:,2)= t_rhosq(l,:,2)*t_qsrf(l)*t_dpsi0/t_dphi0
          t_rhosq(l,:,m4)= t_rhosq(l,:,m4)*t_qsrf(l)*t_dpsi0/t_dphi0
          t_rhosq(l,:,m5)=(t_rhosq(l,:,m5)*t_qsrf(l)+t_rhosq(l,:,2)*c_1(l))*&
               t_qsrf(l)*(t_dpsi0/t_dphi0)**2
       END DO
    END IF
    !   get flux coordinates, Jacobian and Bpol

    t_brwpts=cos(t_tswpts)
    t_bzwpts=sin(t_tswpts)
    DO l=1,t_msrf
       rho=sqrt(abs(t_rhosq(l,:,1)))+errt_rq
       t_rlsd(:,l,1)=rho*t_brwpts+t_raxis
       t_zlsd(:,l,1)=rho*t_bzwpts*elong+t_zaxis
       t_rlsd(:,l,2)=(0.5_rq*t_rhosq(l,:,m3)/rho*t_brwpts-rho*t_bzwpts)
       t_zlsd(:,l,2)=(0.5_rq*t_rhosq(l,:,m3)/rho*t_bzwpts+rho*t_brwpts)*elong
       t_rlsd(:,l,3)=0.5_rq*t_rhosq(l,:,2)/rho*t_brwpts/t_dpsi0
       t_zlsd(:,l,3)=0.5_rq*t_rhosq(l,:,2)/rho*t_bzwpts*elong/t_dpsi0
       t_zlsd(:,l,4)=0.5_rq*elong*t_rhosq(l,:,2)*t_rlsd(:,l,1)/t_dpsi0
       ! Jacobian
       t_rlsd(:,l,4)=sqrt(t_rlsd(:,l,2)**2+t_zlsd(:,l,2)**2)/abs(t_zlsd(:,l,4))
       ! Bpol
    END DO
    t_zlsd(:,1,4)=0.5_rq*elong*t_rhosq(1,:,2)*t_raxis/t_dpsi0
    t_rlsd(:,1,4)=errt_rq
    !   end get Jacobian
    IF(t_inv_flag<=0) THEN
       ! Get T_P, T_P' and T_F, T_F'
       IF(t_entropy_flag>0) THEN
          t_p=t_p*1.e-3_rq*s_pin*t_dpsi0/t_ro
       END IF
       IF(t_use_halo) THEN
          c_0=t_rhosrf
          mmm=t_msrf
          IF(t_use_halo .AND. t_lhalo<t_msrf) THEN
             c_0=(t_psrf-t_psix)/t_dpsi0
             t_dpsi00=zdpsi00;t_dpsi0=zdpsi0
             mmm=t_lhalo-1
          END IF
          call interp_interp(t_psiinv,t_p,yb,yb,c_0,c_1,c_2)
          t_prsrf(:mmm)=c_1(:mmm)/(FOURPI*1.e-6_rq)
          t_pdsrf(:mmm)=c_2(:mmm)/(FOURPI*1.e-6_rq*zdp0)
          call interp_interp(t_psiinv,t_f,yb,yb,c_0,c_1,c_2)
          t_frsrf(:mmm)=c_1(:mmm)*t_ro*1e3
          t_fpsrf(:mmm)=c_2(:mmm)*t_ro*1e3/zdp0
          IF(t_lhalo<t_msrf-2) THEN 
             ! Now make fpsrf continuous across halo boundary
             aaa=1
             call interp_interp(t_psiinv,t_f,yb,yb,aaa,fff,ffp)
             fff(1)=fff(1)*t_ro*1e3
             ffp(1)=ffp(1)*t_ro*1e3/zdp0
             aa(1)=t_psih;aa(2:)=t_psrf(t_lhalo:t_lhalo+2)
             bb(2:)=t_fpsrf(t_lhalo:t_lhalo+2)
             bb(1)=extrp(bb,aa,4,0,0)
             t_fpsrf(t_lhalo:t_msrf)=t_fpsrf(t_lhalo:t_msrf)*ffp(1)/bb(1)
             fff(1)=t_frsrf(1)
             call spline_interp(t_psrf,t_fpsrf,yb,yb,c_1,c_2,c_3,t_frsrf)
             t_frsrf=t_frsrf+fff(1)
          END IF
       ELSE
          call interp_interp(t_psiinv,t_f,yb,yb,t_psibar,t_frsrf,t_fpsrf)
          t_frsrf=t_frsrf*t_ro*1e3
          t_fpsrf=t_fpsrf*t_ro*1e3/zdp0
          call interp_interp(t_psiinv,t_p,yb,yb,t_psibar,t_prsrf,t_pdsrf)
          t_prsrf=t_prsrf/(FOURPI*1.e-6_rq)
          t_pdsrf=t_pdsrf/(FOURPI*1.e-6_rq*zdp0)
       END IF
    END IF
    ! Note that what follows is broken IF t_ifluxcord < 0, this option of using    ! v and w to calculate the currents rather than a direct interpolation from
    ! the inverse solver will probably disappear. The only issue is current on
    ! the edge in free boundary mode and transport. And, the ohm's law will
    ! either drive the current to zero or there will be current on open field
    ! lines which will THEN be handled as done in SSPX and THEN no problem.

    t_w=(t_frsrf**2-t_frsrf(t_msrf)**2)/(t_dpsi0*8*PI*t_prsx)
    t_wp=t_fpsrf*t_frsrf/(t_dpsi0*FOURPI*t_prsx)
    IF(t_filter_wp==999) THEN
       wp0=0
       jj=.9_rq*t_msrf+t_filter_wp
       call splider_interp(t_rhosrf,t_wp,t_w,t_wpp,t_wppp,ndbg10,wp0,jj,ldbg8)
       wp0=0
    ELSEIF(t_filter_wp==-999) THEN
       wp0=t_wp(t_msrf)
       jj=0.9_rq*t_msrf
       call splider_interp(t_rhosrf,t_wp,t_w,t_wpp,t_wppp,ndbg10,wp0,jj,ldbg8)
    ELSE
       IF(t_filter_wp>2) THEN
          CALL fdInt(t_wp,t_psibar,t_msrf,t_w)
          t_w=zero_der_interp(t_psibar,t_w,t_filter_wp)
       ELSEIF(t_filter_wp>0) THEN
          CALL polyfit_interp(t_frsrf,t_fpsrf,t_psibar,t_dpoly,t_spoly,&
               t_mpoly,-2)
          t_fpsrf=t_fpsrf/t_dpsi0
          t_w=(t_frsrf**2-t_frsrf(t_msrf)**2)/(t_dpsi0*8*PI)/t_prsx
          yb=777
       ELSEIF(t_filter_wp<0) THEN
          CALL polyfit_interp(t_frsrf,t_fpsrf,t_psibar,t_dpoly,t_spoly,&
               t_mpoly,1)
          t_fpsrf=t_fpsrf/t_dpsi0
          t_w=(t_frsrf**2-t_frsrf(t_msrf)**2)/(t_dpsi0*8*PI)/t_prsx
          yb=777
       ELSE
          DO i=1,3
             bel(i,1)=1;bel(i,2)=t_psibar(i+2);bel(i,3)=t_psibar(i+2)*&
                  sqrt(t_psibar(i+2))
          END DO
          call rmInvert(bel,3,3)
          DO i=1,3
             rel(i)=0
             DO j=1,3
                rel(i)=rel(i)+bel(i,j)*t_w(j+2)
             END DO
          END DO
          t_w(1)=rel(1)
          t_w(2)=rel(1)+t_psibar(2)*(rel(2)+sqrt(t_psibar(2))*rel(3))
       END IF
       call spline_interp(t_psibar,t_w,yb,yb,t_wp,t_wpp,t_wppp,noyint)
    END IF

    ! Reset coordinate system and renormalize F and T. Note have to avoid
    ! cumulative errors from interpolation/extrapolation from inverse
    ! cordinates. We do this by forcing qsrf=qsave  by recalculating
    ! frsrf and calculating prsrf from psave. ssave later:LDP 17/01/03
    !
    IF(t_inv_flag<=0 .AND. (kp==1 .OR. kp==2 .AND. ip/=0)) THEN
       t_psave=t_anun*t_psave
       IF(kp==2) t_jtsave=t_anun*t_jtsave
       IF(kp==1) t_fsave=t_frsrf
    END IF
    IF(t_inv_flag==-1 .OR. t_inv_flag==2) THEN
       t_prsrf=t_psave
       t_psrf=t_psix+t_dpsi0*t_psibar
       call fdDeriv(t_prsrf,t_psrf,t_msrf,t_pdsrf)
       DO l=1,t_msrf
          c_3=s_pin*TWOPI/(t_mls-1)*t_zlsd(:,l,4)
          c_3(1)=0.5_rq*c_3(1);c_3(t_mls)=0.5_rq*c_3(t_mls)
          t_qsrf(l)=SUM(c_3/t_rlsd(:,l,1)**2)
          t_vpsrf(l)=SUM(c_3)
          IF(kp==3) THEN
             c_1(l)=SUM(c_3*t_rlsd(:,l,4)**2)/t_vpsrf(l)
             c_2(l)=t_qsrf(l)/t_vpsrf(l)
          ELSEIF(kp==2) THEN
             c_1(l)=FOURPI*t_pdsrf(l)*t_vpsrf(l)/t_qsrf(l)
             c_2(l)=SUM(c_3*t_rlsd(:,l,4)**2)
          END IF
       END DO
       IF(kp==0) THEN
          t_frsrf=TWOPI*t_qsave/t_qsrf
          call fdDeriv(t_frsrf,t_psrf,t_msrf,t_fpsrf)
       ELSE
          c_0=t_frsrf
          DO iter=1,nter_interp
             IF(kp==2) THEN
                c_3=(.4*PI*t_jtsave-c_1)*(c_2/t_qsrf/c_0**2+1)
                call fdInt(c_3,t_psrf,t_msrf,c_0)
                c_0=sqrt(2*(c_0-c_0(t_msrf))+t_fwall**2)
                t_fpsrf=c_3/c_0
             ELSEIF(kp==3) THEN
                t_fpsrf=.4*PI*t_jparsave-FOURPI*t_pdsrf*c_0/(c_1+c_0**2*c_2)
                call fdInt(t_fpsrf,t_psrf,t_msrf,c_0)
                c_0=c_0-c_0(t_msrf)+t_frsrf(t_msrf)
             END IF
             IF(SUM(abs(c_0/t_frsrf-1))<100*t_msrf*errt_rq) EXIT
             t_frsrf=c_0
          END DO
!          IF(iter>nter_interp) call parsestr('<<"new iter";debugger')
       END IF
    END IF

    !   Calculate surface integrals..
    call maps_inv(t_msrf) ! pdld
    call get_surfint

    IF(t_ifluxcord>=0) THEN 
!       CALL fdInt(t_qsrf,t_psibar,t_msrf,t_qh)
       call spline_interp(t_psibar,t_qsrf,yb,yb,c_1,c_2,c_3,t_qh)
       t_phibar=t_qh/t_qh(t_msrf)
       t_dphi0=t_dpsi0*t_qh(t_msrf)
       zdp0=t_dpsi0
    END IF
!    IF(t_inv_p==1) then
!       t_psil=t_psix+t_dpsi0
!    ELSE
!       t_psil=t_psix+t_dpsi0 ! Is OK, LDP 16/01/03: NO 16/04/03 WHY?
!    END IF
    t_psix=t_psil-t_dpsi0
    t_psrf=t_psix+t_psibar*t_dpsi0
    dpsrf(2:)=t_psrf(2:)-t_psrf(:t_msrf-1)

    IF(t_inv_flag<=0) THEN
       !   Reset dpsi00, dphi00
       IF(ip==0 .OR. ip==1 .OR. ip==2) THEN
          t_dpsi00=t_dpsi0
          t_dphi00=t_dphi0
       END IF
       IF(t_ifluxcord==-1) THEN
          t_pdsrf=t_pdsrf*t_qsrf
          t_fpsrf=t_fpsrf*t_qsrf
       END IF
    ELSE
       t_dpsi00=t_dpsi0
       t_dphi00=t_dphi0
    END IF

    c_0=-t_cusrf/(t_frsrf*FOURPI/10)
    t_srsrf  = t_prsrf*t_vptor**GAMMA
    IF(kp==0 .AND. t_ifluxcord/=2 .AND. t_inv_x==0) THEN
       call spline_interp(t_psrf,c_0,yb,yb,c_1,c_2,c_3,noyint)
       t_jtsrf  = t_frsrf**2*c_1/TWOPI/t_qsrf
    ELSE
       t_jtsrf=(t_fpsrf*t_bsqrf/t_frsrf+FOURPI*t_pdsrf)/t_rsqirf/.4/Pi
    END IF
    t_jparsrf= t_jtsrf*t_frsrf*t_rsqirf/t_bsqrf
    t_plc=-s_pin*t_cusrf(t_msrf)/FOURPI
    IF(t_ifluxcord<=0) THEN
       t_vptor=abs(t_vpsrf/t_qsrf)
    ELSE
       t_vptor=t_vpsrf
       IF(t_ifluxcord==2) t_jtsrf=t_qsrf*t_jtsrf ! LDP RFP
    END IF
    mlm=t_mls/2+1
    t_asrf=0.5_rq*(t_rlsd(t_mls,:,1)-t_rlsd(mlm,:,1))
    t_rsrf=0.5_rq*(t_rlsd(t_mls,:,1)+t_rlsd(mlm,:,1))
    s_rcntr=t_rsrf(t_msrf)
    s_rbore=t_asrf(t_msrf)
    IF(t_itimestep_converged .AND. t_fix_bound) t_inv_eq=3
    IF(t_inv_eq==3) THEN
       call s_source_inv ! In case we want to get the external flux
    END IF
    call diaginv
    t_inv_eq=1
  END SUBROUTINE teq_inv

  SUBROUTINE get_rhosq
    REAL(RQ) :: c_3
    INTEGER l,ls,imth
    DATA imth /-10/ ! extrapolates 1st derivative, periodic
    CALL bispline_interp(t_psibar,t_tswpts,i_rhosq,imth,t_n6)
    IF(t_n6==7) THEN !  get 2nd derivs divide by 2 
       DO l=1,t_msrf
          DO ls=1,t_mls-1
             t_rhosq(l,ls,6)=(3*(t_rhosq(l,ls+1,1)-t_rhosq(l,ls,1))/&
                  t_tswpts(2)-(t_rhosq(l,ls+1,3)+2*t_rhosq(l,ls,3)))/&
                  t_tswpts(2)
          END DO
       END DO
       DO l=1,t_msrf
          t_rhosq(l,t_mls,6)=t_rhosq(l,1,6)
       END DO
       DO l=1,t_msrf-1
          c_3=t_psibar(l+1)-t_psibar(l)
          t_rhosq(l,:,5)=(3*(t_rhosq(l+1,:,1)-t_rhosq(l,:,1))/c_3-&
               (t_rhosq(l+1,:,2)+2*t_rhosq(l,:,2)))/c_3
       END DO
       t_rhosq(t_msrf,:,5)=(t_rhosq(t_msrf,:,2)-t_rhosq(t_msrf-1,:,2))/c_3-&
            t_rhosq(t_msrf-1,:,5)
    END IF
  END SUBROUTINE get_rhosq

  SUBROUTINE i_t(rhosq)
    USE sep_math
    USE teq_mod, only : t_msrf,t_mls,t_n6
    REAL(rq), TARGET, INTENT(INOUT) :: rhosq(t_msrf,t_mls,t_n6)
    t_rhosq=>rhosq
  END SUBROUTINE i_t

  SUBROUTINE maps_inv(l)
!-------------------------------------------------
!---- Gets pdls:psi,psir,psiz,psirr,psirz,psizz.  
!---- Use t_rhosq, the coordinate transformation.           
!-------------------------------------------------
    INTEGER :: l,ls,m3,m4,m5,m6,n1
    n1=0
    IF(ALLOCATED(dq1)) THEN
       n1=SIZE(dq1)
    END IF
    IF(n1/=t_mls) THEN
       IF(ALLOCATED(dq1)) DEALLOCATE(dq1,dq2,cq1,cq2)
       ALLOCATE(dq1(t_mls),dq2(t_mls),cq1(t_mls),cq2(t_mls))
    END IF
    IF(t_n6==6) THEN
       m3=3
       m4=4
       m5=5
       m6=6
    ELSEIF(t_n6==16) THEN
       m3=5
       m4=6
       m5=3
       m6=9
    END IF
    IF(l==t_msrf .OR. l==1) THEN
       t_brwpts=cos(t_tswpts)
       t_bzwpts=sin(t_tswpts)
       t_rlsd(:,1,1)=t_raxis
       t_zlsd(:,1,1)=t_zaxis
    END IF
    cq2=sqrt(t_rhosq(l,:,1))
    cq1=-t_bzwpts/cq2 ! thR!
    dq1=t_brwpts/cq2/t_wvert ! thZ
    dq2=(t_brwpts**2-t_bzwpts**2)/t_rhosq(l,:,1)/t_wvert !-thRZ
    ls=t_lmax
    t_pdls(:ls,2)=(2*cq2(:ls)*t_brwpts(:ls)-t_rhosq(l,:ls,m3)*cq1(:ls))/&
         t_rhosq(l,:ls,2) ! psiR
    t_pdls(:ls,3)=(2*cq2(:ls)*t_bzwpts(:ls)/t_wvert-t_rhosq(l,:ls,m3)*&
         dq1(:ls))/&
         t_rhosq(l,:ls,2) ! psiZ
    t_pdls(:ls,4)=(2-2*t_rhosq(l,:ls,m5)*t_pdls(:ls,2)**2-2*&
         t_rhosq(l,:ls,m4)*t_pdls(:ls,2)*cq1(:ls)-2*t_rhosq(l,:ls,m6)*&
         cq1(:ls)**2+2*t_wvert*t_rhosq(l,:ls,m3)*cq1(:ls)*dq1(:ls))/&
         t_rhosq(l,:ls,2)
    t_pdls(:ls,5)=-(2*t_rhosq(l,:ls,m5)*t_pdls(:ls,2)*t_pdls(:ls,3)+&
         t_rhosq(l,:ls,m4)*(t_pdls(:ls,2)*dq1(:ls)+t_pdls(:ls,3)*cq1(:ls))+&
         2*t_rhosq(l,:ls,m6)*cq1(:ls)*dq1(:ls)-t_rhosq(l,:ls,m3)*dq2(:ls))/&
         t_rhosq(l,:ls,2)
    t_pdls(:ls,6)=(2/t_wvert**2-2*t_rhosq(l,:ls,m5)*t_pdls(:ls,3)**2-2*&
         t_rhosq(l,:ls,m4)*t_pdls(:ls,3)*dq1(:ls)-2*t_rhosq(l,:ls,m6)*&
         dq1(:ls)**2-2/t_wvert*t_rhosq(l,:ls,m3)*cq1(:ls)*dq1(:ls))/&
         t_rhosq(l,:ls,2)
    t_pdls(:,2:6)=t_pdls(:,2:6)*t_dpsi0
    t_pdls(:,1) =t_psix+t_psibar(l)*t_dpsi0
  END SUBROUTINE maps_inv

END MODULE inv_mod

! $Id: inout_teq.f90,v 1.2 2007/07/23 16:00:57 meyer Exp $

SUBROUTINE teqGS_interface

  USE teqinit
  use teqlib_input

  implicit none

  !external teq_input_allocate

  CALL teq_input_allocate
  CALL teqGS_input
  CALL teqGS_output
  CALL teq_input_allocate

END SUBROUTINE teqGS_interface

SUBROUTINE teq_interface

  USE teqinit
  use teqlib_input
  USE teqSubs_mod

  implicit none

  !external teq_input_allocate, teq_input

  CALL teq_input_allocate
  CALL teq_input
  CALL teq_allocate
  CALL teq_output
  CALL teqSurf_output
  CALL teqPol_input
  IF (npo /= 0 .AND. ntet /= 0) THEN
     CALL teqPol_allocate
     CALL teqPol_output
  END IF

END SUBROUTINE teq_interface

! $Id: teqinit.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

MODULE teqlib_input

  USE sep_math

  IMPLICIT NONE

! Note units are cgs unless otherwise stated---USUALLY--will be cleaned up.

  INTEGER, PARAMETER :: MC=500,MLIM=50,MBD=500

  LOGICAL, TARGET :: &
       fix_bound=.FALSE.,&! if false boundary moves
       use_halo= .FALSE.,&! uses halo modes: inactive
       iter_bdry=.TRUE.   ! forces boundary to equal angle as polar1 converges
  INTEGER, TARGET :: &
       jqm,&
       lmax,&         ! equals mls for asymmetric and map for symmetric
       map=64,& 
       mls,&          ! number of points on surface = 2*map-1
       msrf=61,&      ! number of surfaces
       jm=33,&        ! dimension of radial mesh; must equal 2**n+1
       km=65,&        ! dimension of z mesh; must equal 2**n+1
       jmkm=33*65,&
       lsrf=-22,&     ! =11 , uniform; -22, stretched axis and edge [sin^2]
                      ! =jk , stretched as j power on axis and k power edge 
                      ! =-jk, stretched similar to positive jk, but uses 
                      ! sin's and cos's
       inv_flag=0,&   ! =0 uses polar1; =1 uses Esc
       inv_eq=0,&     ! =1 inverse equilibrium is used
       n4=6,&         ! 16 saves and uses all the bispline coefs for cps
       n6=6,&         ! 16 saves and uses all the bispline coefs for rhosq
       inv_k=0,&      ! =0, q;=1, FF';=2 <J.B>/<B-grad phi>;=3 <J.B>/<B.B>
                      ! as one input profile for the inverse solver; the
                      ! is P. The profiles are qsave, fsave, jtsave, jparsave
                      ! and psave
       inv_p=0,&      ! =-1 dpsi00, =1 plcm; =0 fwall
       entropy_flag=0,& ! zero uses pressure directly in adiabat and teqinv
                      ! negative uses entropy to calculate pressure nitt=1
                      ! (1st iteration) and then uses pressure
                      ! if positive uses entropy for all iterations
       filter_p=0,&   ! >0 smooths P using legendre polynomial fit with 
                      ! P'(msrf)=0; <0 smooths P using legendre polynomial
                      ! fit P'(msrf) floats. Always with the the derivative
                      ! wrt to sqrt(psibar)=0 on axis.
       filter_wp=0,&  ! same as filter_p for w(proportional to FF') except
                      ! =999 uses splider with w'=0 at edge
                      ! =-999 uses splider with w' at edge fixed
                      ! These two options modify in the vicinity of the edge
       one_pow=4,&    ! power of one~(F/F) in adiabat---incoming and new
                      ! for relaxation
       lelm=0,&       ! grid position where ELM occurs; if zero no ELM
       lflat=0,&      ! grid position where q-profile flattens to if <>0,
       mdpsi=0,&      ! if /= 0, psiscl applies dpsi00 at psrf(mdpsi)

       ipp=0,&        ! P profile selection selection:
                      !  ipp=1 : P' exp(-alfa(1)*x); x dimensionless flux
                      !  ipp=2 : P' exp(-alfa(1))*x-aap*exp(-alfa(1)*x)
                      !  ipp=3 : P (1-x^betp)^alfa
                      !  ipp=4 : P flat to x=app, then as ipp=3 beyond
                      !  ipp=5 : P=(1-xx^alfa);xx=x^betp; if betp>2 then
                      !  xx=((x+2-betp)/(3-betp))^2 and hollows
                      !  ipp=6 : j0=(1-xx)^aa if alfa>1 xx=x and aa=alfa...
                      !  else aa=1 and xx=x/(1-alfa*(1-x)/x*log(1-x))...
                      !  or xx=x^betp if betp<2 else xx=((x+2-betp)/(3-betp))^2
                      !  ipp=7 : Efit forms uses fefit pefit
                      !  ipp=999: spline fit; v, vp,vpp,vppp
       ipf=0,&        !  F^2-Fwall^2 profile options; same as ipp, but...
                      !  ipf>7 : j0=betp*(1.-xx)**aa+(1-betp)*(1-x)^(ipf-1)
                      !  if alfa>1 xx=x and aa=alfa
                      !  else aa=1 and xx=x/(1-(1-alfa)*(1-x)/x*log(1-x))
                      !  ipf=999; spline fit; w,wp,wpp,wppp
                      !  ipf=0 ;Spheromak(RFP);lambda profile with asph
                      !  ipf<0 ;Spheromak;external lambda profile with bsph
       ipj=0,&        !  flag for how Fand P is calculated...
                      !  ipj=0 : F' from profile form specified by ipf
                      !          P' from profile form specified by ipp
                      !          scalar constraint set by ipscl
                      !          if ipf<=0 lamda profile
                      !  ipj=1 : F,P from jtsave,psave (sets ipp/ipf=999)
                      !          scalar constraint set by ipscl
                      !  ipj=2 : uses ohmic profile, <J.B>/<B.grad phi> and
                      !          P' profile; use ipp and ipf per above
                      !          scalar constraint set by ipscl
                      !  ipj=3 : uses jparsave and psave: see ipscl
                      !  ipj=4 : F and P from qsave and psave: see ipscl
                      !  ipj=5 : F and P from qsave and psave with no scaling
       kedge=0,&      !  edge-current-model flag: ...=0 => no correction
                      !  =1 => LLL's model: current approximately 2nd-order
                      !  =2 => TBK's model: (1)+source distribution within
                      !  edge-cell to 2nd-order---not quite
                      !  USE default; othwer options needs work!!!
       ! Also see comments in source.f90 subroutine s_source
      
       ifluxCord=0,&  !  equals fluxCord
       nsym=2,&       ! =1 UP/DOWN symmetric; =2 asummetric
       nsymo=0,&
       kbfc=0,&
       ncf=0,&
       jm0p=0,&
       km0p=0,&
       nc0b=0,&
       nc0p=0,&
       nloop0p=0,&
       ncfo=0,&
       nsymco=0,&
       ngpo=0,&
       nfbc=0,&
       nmsc=0,&
       ircwt=3,&      ! -1 minimizes (dI/dz)^2;all coils and in sequence.
                      !  1 minimizes (cc-cc0)!(cc-cc0)
                      !  2 minimizes cc!cc
                      !  3 minimizes j**2=(cc/drc/dzc)^2
                      !  4 minimizes cc!pfim*!cc=I!L!I
                      !  5 minimizes B!B at the coils
                      !  6 minimizes (pfpsi-pfps0)^2;change in flux at coils
                      !  7 minimizes pfpsi!cc
                      !  8 minimizes fields at loops: see floop, rloop etc
                      !  9 reconstruction for SSPX (needs much work)
                      ! 11 minimizes (cc*rc)!(cc*rc)
                      ! svec will weight;
       lhalo=0,&      ! Surface where halo begins;=0 not used
       nprt59=0,&     ! =1 prints converging output
       npoly=8,&      ! number of polynomial in fit (filter_p, filter_wp)
       nsol,&
       nsep,&
       npri,&
       lflux,&
       jqd,&
       ncallsf=0,&
       bsph_flag=0,&  ! Spheromak option
                      ! If bsph_flag=1,2,3,4 bsph(bsph_flag) is used to force
                      ! the derivative of lamda to be continuous across the 
                      ! plasma boundary.
                      ! If bsph_flag=ij;ij=12,13,14,23,24,34 then bsphof i & j
                      ! used to force continuity of the lamda derivative and 
                      ! in addition forces the derivative to be zero at the 
                      ! geometric axis (R=0), The derivative across the private
                      ! flux region will be discontinuous if gsph is non zero.
       logunit,&
       nprob,&
       
       nplates        ! number of plates defining first wall

  REAL(rq), TARGET :: &
       npf=0,&        ! see epf
       npp=0,&        ! see epp
       m95=.95,&      ! boundary at the %m95 surface;if zero set to 0.95
       qcelm=0,&      ! coefficient of parabolic departure;>0 q=q*(1+qcelm*.)
                      ! <0 q=q/(1-qcelm*.)
       pcelm=0,&      ! coefficient of parabolic departure;>0 P=P(1+pcelm*.)
                      !<0 P=P/(1-pcelm*.)	
       scelm=0,&      ! coefficient of parabolic departure;>0 S=S(1+scelm*.)
                      !<0 S=S/(1-sccelm*.)
       qflat=0,&      ! q flattens inside this value; stores profile in qelm
       qrat=0,&       ! The flat portion of q = qflat+qrat*(qsave(1)-qflat)
       scflat=0,&     ! ssave multiplier
       betaj=0.5,&    ! FF' is proportional to (1/betaj -1)
       prsx=1.0001,&  ! normalization on pressure and FF'
       alfa(0:1)=0,&  ! alfa(i) is a profile parameter (see ipp) for
                      ! 0 element is FF'; 1 element1 is P'
       asph(4)=0,&    ! Spheromak lamda profile- confined region: ipf=0,-1
                      ! Spheromak FF' profile- confined region;   abs(ipf)=8
       bsph(4)=0,&    ! Spheromak lamda profile-outside region region;
                      ! ipf=-1,-8, In the code, bsph/(-psix/(psil-psix))**i
                      ! is used and i is the appropriate power:see nbsp
       aap=0,&        ! coefficient of subtraction (quartic if 1;ipp=2)
       betp(0:1)=0,&  ! betp(i) is a profile parameter (see ipp) for ith...
                      ! i=0 is FF';i=1 is P';
       pefit(5)=0,&   ! EFIT P' profiles
       fefit(5)=0,&   ! EFIT FF' profiles
       nasp=10._rq,&  ! power of flux for 4th asph
       nbsp=10._rq,&  ! power of flux for 4th bsph
       gsph=0,&       ! if not zero modifies private flux
       psph=0,&       ! value of poloidal flux [G cm^2/radian] where current
                      ! vanishes for spheromak in gun
       xsph=0,&       ! floor value of dimensionless flux for gsph option:
                      ! if too small not used.
       rzsph(2)=0,&   ! current vanishes at zero flux to the left of (1)
                      ! and above (2)
       epf=0,&        ! bump added to FF'(J0) ~epf* x**npf *(1.-x)
                      ! last piece if npp<0; normalized to epf
       epp=0,&        ! bump added to P ~x**npp *(1-x)**2 ;see epp
       rn=0,&         !  minimum value of r (mesh) [cm]
       rx=0,&         !  maximum value of r (mesh) [cm]
       zn=0,&         !  minimum value of z (mesh) [cm]
       zx=0,&         !  maximum value of z (mesh) [cm]: zn=-zx
       btor=0, &      ! external toroidal field at r=ro
       plcm=0, &      ! desired plasma current (used if ipscl=0) [MA]
       psix=0, &      ! psi at magnetic axis [Gauss cm**2/radian]
       psil=0,&       ! psi at plasma boundary; see ixpt [Gauss cm**2/radian]
       dphi00=0, &    ! desired dphi0 (toroidal flux) [Gauss cm**2/radian]
       dpsi00=0, &    ! desired dshi0 polroidal flux) [Gauss cm**2/radian]
       qmax=1.e3_rq,& ! maximum value of qaxis
                      ! see teq_inv comments-- for reverse shear
       inv_x=0,&      ! position in dimensionless flux where q is adjusted to
                      ! force FF'=0 at edge
       psilm,&        ! flux at limiter point [Gauss cm**2/radian]
       raxis,&        !  r at magnetic axis [cm]
       zaxis,&        !  z at magnetic axis [cm]
       splbdry=-111._rq,& 
                      ! boundary cond. for cubic spline:= 777. not-a-knot;..
                      ! =-111. extraps for 1st deriv;=-666. periodic
       alphac=.5+rq,& ! relaxation on plasma current update; =0 all new
       alpha=0,&      ! dynamic value
       gammac=0,&     ! relaxation on 2D mesh b.c.; =0 all new
       gamma=0,&      ! dynamic value
       deltac=.7_rq,& ! relaxation on scaling (see scl); =1 all new
       delta=0,&      ! dynamic value
       deltadc=.3_rq,&  ! relaxation in adiabat; =1 all new; if trub, try .3
       deltad,&       ! dynamic value
       sigmac=0,&     ! relaxation on psil; =0 all new
       sigma=0,&      !  relaxation on psil (dynamic value)
       tauc=.3_rq,&   ! relaxation on sawtooth model (aap); =0 all new...
                      ! sawtooth model not present at present
       thetac=0,&     ! psil = pxpt - thetac*( pxpt - psix )
       theta=0,&      ! dynamic value
       wvert=1._rq,&  ! ellipticity on axis;used for quasi-polar coords unless
                      ! defaulted to one
       ro,&           ! r-grid midpoint value, occurs at j=jm/2+1 [cm]
       dr,&           ! radial grid increment [cm]
       dz,&           ! radial grid increment [cm]
       hsrf=0.5,&     ! parameter used for stretching; use default value
       rxpr(2)=0,&    ! range in r for radial position of accepted xpoint; 
                      ! = 0 not used
       zxpr(2)=0,&    ! range in z for axial  position of accepted xpoint;!
                      ! =0 not used
       rapr(2)=0,&    ! range in r for radial position of accepted axis;
                      ! =0 not used
       zapr(2)=0,&    ! range in z for axial  position of accepted axis;
                      ! =0 not used
       rcur,&         !  r at current centroid [cm]
       zcur,&         !  z at current centroid [cm]
       dn_criterion=.0025_rq,&
       spt_angle=PI/8._rq,&
       plcm_gun,&     ! gun current at gun entrance [MA]
       shotTime,&
       f_gun0,&       ! desired f_gun
       epsb=1.e-8_rq,&! resb must be less than epsb
       epsj=1.e-8_rq  ! residj must be less than epsj

  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET ::  &
       qsave,&        ! qsrf for adiabat, computed in diag if ipj<3
       ssave,&        ! saved srsrf 
       psave,&        ! saved prsrf
       jtsave,&       ! saved jtsrf
       jparsave,&     ! saved jparsrf
       fsave,&        ! saved FF'
       psibin,&       ! dimensionless poloidal flux
       w,&            ! Spline at nodes F**2-F(msrf)**2)/(8*pi*dcpsi0*prsx)
       v,&            ! Spline at nodes P/(betaj*prsx)
       psi,&          ! total poloidal flux on 2D mesh
       r,&            ! mesh -r- coordinates
       z,&            ! mesh -z- coordinates
       rwl,&          ! radius of inner wall boundary on z-grid
       rwu,&          ! radius of outer wall boundary on z-grid
       rls,&          ! value of r along plasma boundary, input/output
       zls            ! value of z along plasma boundary, input/output

  INTEGER,  DIMENSION(:), ALLOCATABLE, TARGET :: &
       iloop,&        ! iloop=4 gaps,6 plasma current,7 coil currents (control)
                      ! iloop=4 uses rloop etc
       jwl,&          ! inner wall boundary on z-grid (j)
       jwu            ! outer wall boundary on z-grid (j)

  ! I/O Linkage [done] ...
  ! The input variables in this group may be used to change or assign
  ! names to the external disk files.

  CHARACTER(len=128),TARGET :: eqsum="eqsum" ! file name for summary output
  CHARACTER(len=20), TARGET :: aheader=" "   ! header for EQDSK a-file
  CHARACTER(len=48), TARGET :: gheader=" "   ! header for EQDSK g-file
  CHARACTER(len=40), TARGET :: theader=" "   ! header for EQDSK t-file
  CHARACTER(len=16), TARGET :: shotName = " ", site
  CHARACTER(len=80), TARGET :: note = " "
  CHARACTER(len=40), TARGET :: probid = " "
  CHARACTER(len=8),  TARGET :: rundate,runtime,codetime
  CHARACTER(len=10), TARGET :: codedate
  CHARACTER(len=64), TARGET :: logname
  CHARACTER(len=3),  TARGET :: pkgname

  ! teqPol

  INTEGER, TARGET ::&
       nht=100,&
       ntet=0,&
       npo=0,&
       ijob=0,&
       mesc=6,&
       ns1=0
  REAL(rq), TARGET ::&
       epsrk=1.e-6_rq,&
       epskrk=1.e-3_rq,&
       alfa0=.3_rq,&
       alfa1=.3_rq,&
       alfa2=.3_rq,&
       tpl,&
       anun=1_rq
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, TARGET ::&
       rork
  LOGICAL, TARGET :: itimestep_converged=.TRUE.

  ! TeqGS_input

  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET :: &
       rbd,&
       ! radial coordinate of boundary points[cm]: ...
       ! curcal varies ic-currents to get psi(rbd,zbd)= psi@ 0-pressure surface
       ! (except if diverted & thetac not 0, psi(rbd,zbd)=pxpt)
       zbd,&
       ! vertical coordinate of boundary points[cm]
       tbd,&
       psibd,&
       rfbd,&
       ! fuzzy boundary(minimizes); see rbd
       zfbd,&
       ! fuzzy boundary; see zbd
       psiwfc,&
       ! used to get SN generator
       whtz,&
       ! used to get SN generator
       alfbd,&
       ! fuzzy boundary weighting added to the regular1zation (see ircwt)
       rloop,&
       ! radial position of meassuring loop;[cm]
       zloop,&
       ! radial position of meassuring loop;[cm]
       thloop,&
       ! loop orientation: Bpol=Br*sin(thloop)-Bz*cos(thloop)
       ! iloop=4 gaps, 6 plasma current, 7 coil currents
       sigloop,&
       ! error in measurement
       floop0,&
       ! desired flux or field at meassuring loop[cgs]
       cc,&
       !  coil currents[MA]
       rc,&
       !  mean radii of PF coils[m]
       zc,&
       !  mean z-locations[m]
       drc,&
       !  cross-section radial build[m]
       dzc,&
       !  cross-section axial height[m]
       ac,&
       ! Non-zero for Type 1 parallelogram coil section (a la EFIT) angle, ...
       ! measured from a radial line to the upper (or lower) edge [radians]
       ac2,&
       ! Non-zero for Type 2 parallelogram coil section
       svec,&
       ! Weighting for coil current regularization; defaulted to one
       rcase,&
       !  mean radii PF coil casings
       zcase,&
       !  mean -z- PF coil casings
       drcase,&
       !  delta-r PF coil casings
       dzcase,&
       !  delta-z PF coil casings
       rhc,&
       !  resisitivity
       rextc,&
       ! external resistance in coils
       lextc,&
       ! external inductance in coils
       pfps0,&
       !  desired flux at coil see iflxc=1
       cc0,&
       ! desired current at coils see ircwt=1 which minimizes error
       rxc,&
       rlim,&
       zlim,&
       dlim
  
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, TARGET :: &
       gdc,&
       !  current grading ratio
       rplate,&
       !  r-coordinates of each plate defining 1st wall
       zplate
  !  z-coordinates of each plate defining 1st wall
  
  INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: &
       nrc,&
       !  no. of filaments across drc
       nzc,&
       !  no. of filaments across dzc
       ic,&
       ! Current circuit index...i.e. ic(3)=1 and ic(5)=1 keeps the current
       ! ratio fixed
       ict,&
       ! =1 for Series; =0 for Parallel for the ic circuits
       ix,&
       ! Circuit for flux at coils
       ! ix(i) = j makes the flux at cc(i) the jth circuit, note circuit number
       ! starts at jbdcir, the number of curcal constraints
       iferro
       ! = 1 if coil is ferromagnetic
  
  CHARACTER(len=8), DIMENSION(:), ALLOCATABLE, TARGET ::&
       pfid
  
  REAL(rq), TARGET :: &
       scl=1,&
       psil00=0,&
       dt=0,&
       !  time increment [sec]
       thetat=0.5_rq,&
       !  2nd order accurate time stepping
       ccoil,&
       !  initial guess for coil currents [MA]
       zocoil,&
       !  Z0 for analytic coil generator [cm]
       rocoil,&
       !  R0 for analytic coil generator [cm]
       rbcoil,&
       !  a for analytic coil generator [cm]
       elcoil,&
       !  kappa for analytic coil generator
       dcoil,&
       !  delta for analytic coil generator
       qcoil,&
       !  q-bean for anal. coil generator
       cnorm,&
       !  internal normalization=0.5abs(plcm)
       crdn=4000._rq,&
       !  J for sizing coil sect. in plots [A/cm^2]
       acmin=10._rq,&
       !O min. coil section dimension
       magfac=0 ,&
       ! magnetization factor (saturated magnetization (T) in ferromagnetic ...
       ! coil, and switch for existence of any ferromagnetic coils) [T]
       bsat=8.864e-2_rq,&
       ! magnetic-field magnitude (T) at which magnetization is half saturated
       ! for Incoloy Alloy 908 [T]
       dsurf=.1_rq,&
       ! width of magnetization surface current [cm]
       almim,&
       ! multiplier of constraint when added to the minimization
       geomo,&
       ! stored value of coil geometry factor; used to decide whether
       ! Greens' functions need to be recalculated
       pfjx,&
       !  maximum value of pfjf(1,...,nfjx)
       pfbx,&
       !  maximum value of pfbc(1,...,nfjx) [T]
       delc,&
       !  grid size (coil B-fields)
       pftd=10.0_rq,&
       !  dump time constant (CICC) [s]
       pfahs=500.0_rq,&
       !  allow. hoop stress conduit (CICC) [MPa]
       dfac=10.0_rq,&
       !  EFFI distance factor in coils.f
       dtofst=0,&
       ! theta offset
       finit2=1.0_rq,&
       ! used if initflx,c=2; psil encloses finit2*(p_xpt-p_ax)
       el=2.0_rq,&
       !  zx=el*rb*(jm/2) / ((jm/2)+1-liml) !also /geo/!
       elx=1.6_rq,&
       ! z-length for psi ic (Strickler's initflx=0 option)
       bbdu,&
       !?
       bbdl,&
       !?
       dbdu=0,&
       ! upper triangularity, analytic bdry model
       dbdl=0,&
       ! lower triangularity, analytic bdry model
       ebdu=0,&
       ! upper elongation, analytic boundary model
       ebdl=0,&
       ! lower elongation, analytic boundary model
       queu=0,&
       ! upper beaning, analytic boundary model
       quel=0,&
       ! lower beaning, analytic boundary model
       alpcoilc=0.,&
       ! PF coil update relaxation; =0 all new
       alpsphc=0.,&
       ! asph/bsph update relaxation; =0 all new
       alpcoil,&
       !
       alpsph,&
       !
       vltf,&
       ! if cejima=0 & vltf not 0, then VS fixed to vltf.   ... [Vs]
       ! if cejima not 0 then prebiased VS fixed using vltf: see cejima.
       rfix=0.0,&
       !  if=0, rfix=rb; used if ibdry>0 to set rbd array [cm]
       psires0,&
       ! desired average plasma poloidal flux [Wb]
       raxis0,&
       ! desired raxis [cm]
       zaxis0,&
       ! desired zaxis [cm]
       rxpt0,&
       ! desired rxpt [cm]
       zxpt0,&
       ! desired zxpt [cm]
       cejima,&
       ! psires=vltf-0.4*pi*cejima*plcm*ro/100
       plcx,&
       ! forces psix to plcx in curcal
       rl,&
       !  distances between separatrices fixed in curcal... [cm]
       !  irl=0; rl relative flux between separatrices (pxpu-pxpl)/dpsi0
       !  irl=+(-) rl>0 then distance at outer mid-plane, upper(lower);
       !           rl<0                  inner mod_plane
       rb,&
       !  j=liml is at r=ro-rb [cm]
       betx=0.1_rq
  ! initial estimate of maximum beta (%)
  INTEGER, TARGET :: &
       nbd,&
       ! no. pts at which psi is to be = psil...
       !  ic-currents are varied to achieve this. see also rbd,zbd
       nfbd,&
       ! no. fuzzy points on boundary, see nbd
       ! number upper boundary points (asymmetric)
       nbdl,&
       ! number lower boundary points (asymmetric)
       nbdu,&
       ! number upper boundary points (asymmetric)
       lgrn=0,&
       ! =1 never recalculates Green functions
       kgreenc=1,&
       !  Green functions flag for gc and gp...
       !  kgreenc=0 computes when used; =1 computed at EQUILA and stores
       ncplot=0,&
       !  number of coils entered on plots usually the PFcoils only
       nc=0,&
       !  total number of coils PF coils plus passive coils representing walls
       nloop,&
       ! number of flux loops
       nsymc=2,&
       !  PFC symmetry flag: 1/2=sym/asym
       limw=0,&
       !
       lcal,&
       ! tells curcal to recalculate inverses (gmat(,,2),gmat(,,3)) if not -1
       liml=-1,&
       !  if =-1 uses rn, rx and zx as input and ro is computed; zn=-zx
       nitr,&
       ! EQUILC (finds ext & plasma currents for fixed bc) loop index
       ierr1=1,&
       ! =1 uses new crj + clj  in RESID
       nlim,&
       !
       lsph=0,&
       ! if=0 nothing; if=1 minimizes loops pf f_gun; if=2 forces current=plcm
       nsph,&
       ! number of asph's used for reconstruction;
       iflxc=0,&
       ! =1 runs circuit equations nbd=0!! etc. ic sets circuits
       ixpt,&
       ! flag for setting psil, the 0-pressure flux...
       ! rbd,zbd and rfbd,zfbd on separatrix
       ixp,&
       ! dynamic value
       ixpo=1,&
       ! nonzero sets ixp=ixpt for first PSILMS call
       ncsym,&
       !
       irl=0,&
       !  see rl
       jxp=0,&
       ! deprecated
       kxp=0,&
       ! if not zero forces X-point to (rxp,zxp)
       jaxis=0,&
       ! deprecated
       kaxis=0,&
       ! if not zero forces O-point to (raxis0,zaxis0); problematic
       ! since requires user ingenuity to avoid over-constraining
       ! can also be another X-point
       keqic=0,&
       ! flag for package eq initial values...
       !  for cc, prsx, and psi; if in ceq,meq also controls rbd,zbd,x0
       !  =0 do nothing; =2 use stored values for all EQUILA calls;
       !  =1(3) like =2 for 1st FCNS call, & like =0 thereafter
       !  1(3) uses "00"("01") stored values
       ifscl=0,&
       !  >1 scales F in PSISCL (see ipscl); =2 scales fwall
       ipscl=0,&
       !  scale Grad-Shafranov: =0 fix current (plcm), 
       !  =1  fix enclosed poloidal flux(dpsi00) ,
       !  =-1 no scale
       !  If ipj=3,4 (jparsave, qsave is input) and ipscl=-1, then
       !  inv_p=0 constrains to fwall,inv_p=-1 constrains to dpsi00, 
       !  inv_p=1 constrains to plcm
       !  If ipscl <>-1 (not recommended) uses the ipscl options

       ibdry=1,&
       !  option flag to set rbd,zbd arrays (pressure=0 pts)...
       ! =0 you set r,zbd; =1 for sym analytic; =2 for asym analytic
       ni=1,&
       ! # of internal iteration for each external iteration to convergence
       nl=100,&
       ! maximum number of iterations to equilblibrium
       initflx=0,&
       ! flux (r,z) initial condition option flag, in INITSI...
       !  =0 Strickler's parabolic;
       !  =1 models plasma as filaments with right current;
       !  =2 sym, triang=0, elong=ebdu at psi-psix=psil-psix,
       !  encloses finit2*(pxpt-psix);
       !  =3 asymmetric, single X-point enclosing psil-psix
       !  =4 psi00 (from last ksave)
       ksave=2,&
       ! flag to save flux & coil-current values; =0 don't save; ...
       ! =1 save start conditions for next equilibrium calc depends on keqic;
       ! =2 save after last equilibrium (from next EQ, CEQ, or MEQ run).
       ! ksave is 0'd after the save, stores into '00' arrays, has only 1 level
       ! =0 turns off lasteq=1 after HYBRD return (no plots, eqdsk)
       ! logic flag for DIAGNQ, GRAFIK; computed in CEQ, used in EQ ...
       ! If you're in package eq & want saved 01's for keqic=3
       ! preserved, set lasteq=1. See also lasteqsav.
       lasteq,&
       lasteqsav,&
       lop0,&
       nbs,&
       int_flag=0,&
       ! if =1 internal coils are treated as coils; ...
       ! GS solver solves for plasma flux and the external flux
       ! from Green's functions is added back in;
       ! if =0 internal coils are distributed and added to the source;
       ! GS solver solves for total flux: and coil currents inside
       ! computational grid, which are put in clj,  are added to the source
       n_gauss_even=4,&
       ! order for even-order quadrature
       n_gauss_odd=7,&
       ! order for odd-order quadrature
       ! The following parameters can each be either even or odd. The
       ! only restriction is that they be different, and not both odd.
       ! The total number of integrand evaluations required to compute
       ! the self-inductance is n_gauss_even*n_gauss_odd for rectangular
       ! and type 1 coils, 6*n_gauss_even*n_gauss_odd for type 2 coils.
       gauss_check=0,&
       ! set <> 0 to check Guassian quadrature, =1 to get certain
       ! debugging readout.
       nfil=1,&
       !  min. no. filaments across coil
       ngp=5,&
       ! min. no.  grid pts (field calc)
       ! ngp=1 when there are ferromagnetic coils
       nfjx=0,&
       !  no. coils to scan for pfjx
       ncase=0,&
       !  number of PF coil casings
       nsegs=10,&
       dbg=-1,&
       ncoil=0
  !  if ncf=0, use this for nc
  LOGICAL, TARGET :: &
       crj_flag=.FALSE.,&
       ! If true calculates current outside the plasma when inverse equlibrium
       ! used for plasma
       use_ellip=.FALSE.
  ! If true uses the complete elliptic integrals in Mutual.
  
CONTAINS

  SUBROUTINE teq_input

!    use teqlib_input
    USE teq_mod
    USE sep_interp, only : i_dbg
    USE sep_separatrix, only : s_n4
    USE teqSubs_mod,  only : teq_allocate, t_stretch

    s_n4        => n4
    i_dbg       => dbg
    t_jm        => jm
    t_km        => km
    t_jmkm      => jmkm
    t_mls       => mls
    t_map       => map
    t_msrf      => msrf
    t_n6        => n6
    t_n4        => n4
    t_lsrf      => lsrf
    t_lelm      => lelm
    t_lflat     => lflat
    t_ifluxcord => ifluxcord 
    t_nsym      => nsym
    t_nsymo     => nsymo
    t_entropy_flag=> entropy_flag
    t_filter_wp => filter_wp
    t_filter_p  => filter_p
    t_one_pow   => one_pow
    t_mdpsi     => mdpsi
    t_btor      => btor
    t_plcm      => plcm
    t_dphi00    => dphi00
    t_dpsi00    => dpsi00
    t_psilm     => psilm
    t_raxis     => raxis
    t_zaxis     => zaxis
    t_psix      => psix
    t_psil      => psil
    t_betaj     => betaj
    t_psilm     => psilm
    t_raxis     => raxis
    t_zaxis     => zaxis
    t_psix      => psix
    t_psil      => psil
    t_splbdry   => splbdry
    t_betaj     => betaj
    t_qcelm     => qcelm
    t_pcelm     => pcelm
    t_scelm     => scelm
    t_qflat     => qflat
    t_qrat      => qrat
    t_scflat    => scflat
    t_prsx      => prsx
    t_aap       => aap
    t_nasp      => nasp
    t_nbsp      => nbsp
    t_gsph      => gsph
    t_psph      => psph
    t_xsph      => xsph
    t_epf       => epf
    t_epp       => epp
    t_npf       => npf
    t_npp       => npp
    t_ipp       => ipp
    t_ipf       => ipf
    t_ipj       => ipj
    t_kedge     => kedge
    t_alphac    => alphac
    t_alpha     => alpha
    t_gammac    => gammac
    t_deltac    => deltac
    t_delta     => delta
    t_deltadc   => deltadc
    t_deltad    => deltad
    t_sigmac    => sigmac
    t_sigma     => sigma
    t_tauc      => tauc
    t_thetac    => thetac
    t_theta     => theta
    t_wvert     => wvert
    t_ro        => ro
    t_dr        => dr
    t_dz        => dz
    t_hsrf      => hsrf
    t_rcur      => rcur
    t_zcur      => zcur
    t_f_gun0    => f_gun0
    t_plcm_gun  => plcm_gun
    t_ircwt     => ircwt
    t_bsph_flag => bsph_flag
    t_inv_eq    => inv_eq
    t_lhalo     => lhalo
    t_use_halo  => use_halo
    t_fix_bound => fix_bound
    t_lmax      => lmax
    t_alfa      => alfa
    t_betp      => betp
    t_asph      => asph
    t_bsph      => bsph
    t_pefit     => pefit
    t_fefit     => fefit
    t_rzsph     => rzsph
    t_rxpr      => rxpr
    t_zxpr      => zxpr
    t_rapr      => rapr
    t_zapr      => zapr
    t_nprt59    => nprt59
    t_npoly     => npoly
    t_logunit   => logunit
    t_rn        => rn
    t_rx        => rx
    t_zn        => zn
    t_zx        => zx
    t_m95       => m95
    t_qsave     => qsave
    t_jtsave    => jtsave
    t_jparsave  => jparsave
    t_ssave     => ssave
    t_psave     => psave
    t_fsave     => fsave
    t_w         => w
    t_v         => v
    t_psi       => psi
    t_r         => r
    t_z         => z
    t_rwl       => rwl
    t_rwu       => rwu
    t_jwl       => jwl
    t_jwu       => jwu
    t_rls       => rls
    t_zls       => zls
    t_rplate    => rplate
    t_zplate    => zplate
    t_dn_criterion=> dn_criterion
    t_nplates   => nplates
    t_nsegs     => nsegs
    t_spt_angle => spt_angle
    t_rundate   => rundate
    t_runtime   => runtime
    t_codedate  => codedate
    t_codetime  => codetime
    t_aheader   => aheader
    t_gheader   => gheader
    t_theader   => theader
    t_logname   => logname
    t_probid    => probid
    t_note      => note
    t_nprob     => nprob
    t_shotName  => shotName
    t_shotTime  => shotTime
    t_site      => site
    t_pkgname   => pkgname
    t_ncallsf   => ncallsf
    
  END SUBROUTINE teq_input

  SUBROUTINE teq_input_allocate

    integer :: sz

    sz = 0; if (allocated(qsave)) sz = size(qsave)
    IF (sz/=msrf) THEN
       IF (ALLOCATED(qsave)) DEALLOCATE(qsave,jtsave,jparsave,fsave,ssave,w,v,&
            psave,psibin)
       ALLOCATE(jtsave(msrf),qsave(msrf),fsave(msrf),ssave(msrf),psave(msrf),&
            jparsave(msrf),w(msrf),v(msrf),psibin(msrf))
       qsave=0;psave=0;fsave=0;psave=0;ssave=0;jtsave=0;jparsave=0;w=0;v=0
       psibin=0
    END IF
    sz = 0; if (allocated(rls)) sz = size(rls)
    IF (sz/=mls) THEN
       IF(ALLOCATED(rls)) DEALLOCATE(rls,zls)
       ALLOCATE(rls(mls),zls(mls))
    END IF
    sz = 0; if (allocated(jwl)) sz = size(jwl)
    IF (sz/=km) THEN
       IF(ALLOCATED(jwl)) DEALLOCATE(jwl,jwu,rwl,rwu)
       ALLOCATE(jwl(km),jwu(km),rwl(km),rwu(km))
       jwl=0;jwu=0;rwl=0;rwu=0
    END IF
    sz = 0; if (allocated(psi)) sz = size(psi)
    IF (sz/=jmkm) THEN
       IF(ALLOCATED(r)) DEALLOCATE(r,z,psi)
       ALLOCATE(r(jm),z(km),psi(jmkm))
       r=0;z=0;psi=0
    END IF
    IF(.NOT.ALLOCATED(rbd)) THEN
       ALLOCATE(rbd(MBD),zbd(MBD))
    END IF
    IF(ALLOCATED(tbd)) THEN
       IF(SIZE(tbd)/=nbd) DEALLOCATE(tbd,whtz,psiwfc,psibd)
    END IF
    IF(.NOT.ALLOCATED(tbd)) THEN
       ALLOCATE(whtz(nbd),psiwfc(nbd),tbd(nbd),psibd(nbd))
       psibd=0;tbd=0;whtz=0;psiwfc=0
    END IF
    IF(.NOT.ALLOCATED(rfbd)) THEN
       ALLOCATE(rfbd(MBD),zfbd(MBD),alfbd(MBD))
       alfbd=100;rfbd=0;zfbd=0
    END IF
    IF(.NOT.ALLOCATED(rlim)) THEN
       ALLOCATE(rlim(0:MLIM),zlim(0:MLIM),dlim(0:MLIM))
    END IF
    sz = 0; if (allocated(rloop)) sz = size(rloop)
    IF (sz/=nloop .OR. .NOT.ALLOCATED(rloop)) THEN
       IF(ALLOCATED(rloop)) DEALLOCATE(rloop,zloop,thloop,floop0,iloop,sigloop)
       ALLOCATE(rloop(nloop),zloop(nloop),thloop(nloop),floop0(nloop),&
            iloop(nloop),sigloop(nloop))
       rloop=0;zloop=0;thloop=0;iloop=0;sigloop=1
    END IF
    IF(.NOT.ALLOCATED(cc)) THEN
       ALLOCATE(cc(MC),rc(MC),zc(MC),rhc(MC),drc(MC),dzc(MC),rxc(MC),cc0(MC),&
            ac(MC),ac2(MC),svec(MC),pfps0(MC),ic(MC),ix(MC),nrc(MC),nzc(MC),&
            pfid(MC),lextc(MC),iferro(MC),ict(MC),rcase(MC),zcase(MC),&
            drcase(MC),dzcase(MC),rextc(MC))
       cc=0;rc=0;zc=0;drc=0;dzc=0;rxc=0;cc0=0;ac=0;ac2=0;svec=1;pfps0=0
       ic=0;ix=0;nrc=0;nzc=0;pfid=" ";lextc=0;iferro=0;ict=0;rcase=0;zcase=0
       drcase=0;dzcase=0;rextc=0
    END IF
    sz = 0; if (allocated(gdc)) sz = SIZE(gdc,1)
    IF(ALLOCATED(gdc) .AND. sz/=nc) THEN
       DEALLOCATE(gdc)
    END IF
    IF(.NOT.ALLOCATED(gdc)) THEN
       ALLOCATE(gdc(nc,6));gdc=0
    END IF
    sz = 0; if (allocated(rplate)) sz = size(rplate,1)
    IF (sz/=nplates .OR. .NOT.ALLOCATED(rplate)) THEN
       IF(ALLOCATED(rplate)) DEALLOCATE(rplate,zplate)
       ALLOCATE(rplate(nplates,2),zplate(nplates,2))
       rplate=0;zplate=0
    END IF
    sz = 0; if (allocated(rork)) sz = size(rork,1) * size(rork,2)
    IF (sz/=msrf*mls) THEN
       IF(ALLOCATED(rork)) DEALLOCATE(rork)
       ALLOCATE(rork(msrf,mls))
       rork=0
    END IF
  END SUBROUTINE teq_input_allocate
 
END MODULE teqlib_input

MODULE teqlib_output

  USE sep_math

  ! teqPol

  REAL(rq), DIMENSION(:), POINTER :: &
       qrk,&
       jrk,&
       srk,&
       trk,&
       vrk,&
       crk,&
       rrk,& ! current centroid, r^2
       zrk,& ! current centroid, z
       f,&
       pff,&
       p,&
       pp
  REAL(rq), DIMENSION(:,:), POINTER :: &
       aj
  
  REAL(rq), DIMENSION(:,:,:), POINTER :: &
       rhosq ! transpose((rlsd(,,1)-raxis)**2+((zlsd(,,1)-zaxis)/wvert)**2)
  
  !teq
  
  REAL(rq), DIMENSION(:), POINTER :: &
       rm,&
       zm,&
       crj,&
       br,&
       bz,&
       bp,&
       bt,&
       bmod,&
       pvec,&
       fldind,&
       ! Prime means derivative wrt the poloidal flux divided by 2pi
       frsrf,&     ! F
       fpsrf,&     ! F'
       qsrf,&      ! q
       rsqbp,&
       jtsrf,&     ! <J.B>/<B-grad phi>
       jparsrf,&   ! <J.B>/<B.B>
       susrf,&     ! Area enclosed by flux surface
       cusrf,&     ! Mu0*I(psi)
       vpsrf,&     ! V'
       srsrf,&
       prsrf,&     ! P
       pdsrf,&     ! P'
       rsrf,&      ! Major radius of flux surface 
       asrf,&      ! Minor radius of flux surface  
       volsrf,&    ! Volume enclosed by flux surface
       c1srf,&
       c4srf,&
       c5srf,&
       esrf,&      ! Elongation
       tsrf,&      ! Triangularity
       tlsrf,&     ! Triangularity(lower)
       tusrf,&     ! Triangularity(upper)
       r2bzrf,&
       r4bp2rf,&
       rsqrf,&     ! <R**2>
       bpsrf,&     ! <Bpol>
       bsqrf,&     ! <B.B>
       rsqirf,&    ! <1/R**2>
       alsrf,&     ! Perimeter of flux surface
       risrf,&     ! <1/R>
       fttcsrf,&   ! Effective trapped to circulating
       qh,&        ! Integral q * d(psibar)
       psibar,&    ! Dimensionless poloidal flux (see lsrf), independent coord
       psidbar,&   ! Derivative of psibar wrt to the integer (1,msrf)
       phibar,&    ! Dimensional toroidal flux
       psiinv,&    
       psidinv,&
       rhosrf,&
       psrf,&      ! Poloidal flux/2/pi
       vptor,&     ! V'/q
       tswpts,&    ! Uniform angle coord (1-2pi)
       brwpts,&
       bzwpts,&
       psiw,&      ! External poloidal flux (R-Z grid)
       clj,&
       rlimw,&     ! Limiter coord
       zlimw,&     ! Limiter coord
       tlimw,&
       plimw,&
       rstkpt,&
       zstkpt,&
       dstkpt,&
       bstkpt,&
       psi00,&
       psi01,&
       vltsnd,&   ! Flux linkage(curren weighted,magnetic axis,geometric axis)
       li,&       ! Internal induction, standard definitions
       betap,&    ! beta poloidal, standard definitions
       betaps,&
       lam,&
       rspt,&
       zspt,&
       dspt,&
       bspt,&
       rpts,&
       wp,wpp,wppp,& ! Spline derivatives: see w
       vp,vpp,vppp,& ! Spline derivatives: see v
       zpts        
  
  REAL(rq), DIMENSION(:,:), POINTER :: &
       plsolo,&
       plsoli,&
       tlsolo,&
       tlsoli
  
  REAL(rq), DIMENSION(:,:,:), POINTER :: &
       rlsd,&    ! R,dR/dtheta,dR/dpsibar,Bpol     on inverse coordinates
       zlsd      ! Z,dZ/dtheta,dZ/dpsibar,Jacobian on inverse coordinates
  
  REAL(rq), POINTER :: &
       rxpf,&
       zxpf,&
       rxpt,&    ! R at X_point
       zxpt,&    ! Z at X_point
       pxpt,&    ! Value of psi at X_point
       psih,&
       dpsi0,&   ! delta psi(poloidal flux) across plasma
       dphi0,&   ! delta phi(toroidal flux) across plasma
       fwall,&   ! vacuum F=ro*btor(ro)
       plc,&     ! plasma current amps/10
       lamda_gun,&
       r_gun,&
       z_gun,&
       f_gun,&
       residj,&  ! Residual error of equilibrium solver
       betae,&
       betat,&
       flxln,&
       absflx,&
       psisep,&
       psipls,&
       xindf,&
       slfnd,&   ! plasma self inductance uH
       xlfnd,&
       volume,&  ! plasma volume
       surf,&    ! plasma cross sectional area
       ctroy,&   ! Troyon coeff
       qmerc,&
       placur,&
       helicity,&! Helicity of plasma (wb**2)
       elongn,&
       trianu,&
       trianl,&
       trian,&
       t95,&
       tl95,&
       tu95,&
       trider,&
       f95,&
       p95,&
       psi95,&
       e95,&
       q95,&
       qmin,&
       rhomin,&
       qstar,&  ! Cylindrical q
       aspct,&
       wpf,&    ! PF coils stored energy (GJ)
       wpt,&
       ccdir,&  ! average current per unit length of PFCoil system (MA/m)
       al,&
       bpsqva,&
       presva,&
       pressa,&
       betal, &
       bpolsa,&
       skew,  & ! Orientation of axis at magnetic axis; 0=up/down symmetric
       dsep,  & ! Distance bewtween separatrices at outboard midplane
       dsip,  & ! Distance bewtween separatrices at inboard midplane
       rcntr, & ! Major radius of plasma at plasma mid-plane 
       rbore    ! Minor radius of plasma at plasma mid-plane 
  
  INTEGER, POINTER ::&
       nspt,&   ! number of strike points
       nitt,&   ! number of current iterations in GS 
       nstkpts  ! number of candidaye strike points(could be redundant)
  
  INTEGER, DIMENSION(:), POINTER ::&
       lstkpt   ! plate number containing strike points
  
  ! teqGS
  
  INTEGER, POINTER ::&
       ncircuit,&
       jbdcir,& ! total number of constraints in gs_curcal
       ncrmx,&  ! maximum nrc
       nczmx,&  ! maximum nzc
       ifjx,&   ! index of coil prodcing pfjx
       ifbx,&   ! index of coil prodcing pfbx
       ncs,&    ! number analytic coil filamants
       ngroup   ! number of current circuits: see ic
  
  REAL(rq), DIMENSION(:), POINTER ::&
       ccf,&    ! variables ending in f desribe filaments: see cc,  etc
       rcf,&
       zcf,&
       drcf,&
       dzcf,&
       ccfd,&   ! ignore
       ccmf,&   ! ignore
       cscl,&   ! ignore
       ccls,&   ! group currents
       cscl00,& ! ignore
       cscl01,& ! ignore
       cclsr,&  ! ignore
       cmplas,& ! mutual inductance between coil and plasma
       pfjp,&   ! pack current density
       pfjc,&   ! critical (Miller) current density MA/m^2
       pfjf,&   ! ratio of actual/critical current
       pfbc,&   ! conductor B-field
       pfbi,&   ! max B inner coil surface
       pfbo,&   ! max B outer coil surface
       pfbr,&   ! mean radial B-field T
       pfbz,&   ! mean axial  B-field T
       pfhs,&   ! average hoop stress MPa
       pfms,&   ! maximun hoop stress MPa
       pffr,&   ! radial force MN
       pffz,&   ! axial force MN
       pfil,&   ! current length product MA*m
       pfse,&   ! storage energy per coil MJ
       pfe0,&   ! stored self energy per coil
       pfpsi,&  ! Poloidal flux at coils (Wb)
       vlts2D,& ! Flux linkage per coil (VS)
       pfpci,&  ! average Poloidal flux per group: not connected
       pfpc0,&  ! average Poloidal flux per group (desired ?)
       rcg,&    ! weighted average radius of coil group M
       zcg,&    ! weighted average height of coil group M
       gloop,&  ! loop output: see iloop, rloop, zloop
       br0p,&   ! radial field at the coil center not connected G
       bz0p,&   ! axial  field at the coil center not connected G
       aac,&    ! ignore
       rcs,&    ! ignore
       zcs,&    ! ignore
       ths      ! ignore
  
  INTEGER, DIMENSION(:), POINTER ::&
       p_in,&   ! flags coil number inside mesh ignore
       jnt,&    ! ignore
       knt,&    ! ignore
       icc,&    ! ignore
       loopm,&  ! ignore
       loop0,&  ! ignore
       icf,&    ! ignore
       icnf     ! ignore
  
  REAL(rq), DIMENSION(:,:), POINTER ::&
       pfim,&   ! induction matrix coil to coil uH
       pbim,&   ! Bpol matrix
       floop,&  ! user variable see iloop, gloop
       ploop,&  ! flux and first derivs at loops see iloop, rloop, zloop
       rc4,&    ! corners of the coils, used for graphics M
       zc4      ! "
  
  REAL(rq), DIMENSION(:,:,:), POINTER ::&
       gc,&     ! Green's function between coil and 2D mesh
       gfbr,&   ! Green's function for Br between coil and 2D mesh
       gfbz,&   ! Green's function for Bz between coil and 2D mesh
       gp,&     ! Green's function between 2D mesh mesh boundary
       plim,&   ! spheromak option
       gpl      ! spheromak option
  
  REAL(rq), POINTER ::&
       psires,& ! average poloidal flux across plasma
       rbin,&   ! radius of inner-most boundary point
       rbout,&  ! radius of outer-most boundary point
       pfcse,&  ! total store energy with in the coils MJ, from the coils
       pftse,&  ! total store energy with in the coils MJ 
       pfcsi,&  ! total magnitude of the coil currents MA
       pfcil,&  ! total magnitude of the coil current-lengths MA*m
       error,&  ! residual on psi
       resb,&   ! residual on boundary
       resid,&  ! residual between rhs and lhs of GS equation
       prsx00,& ! ignore
       prsx01,& ! ignore
       rlimm,&  ! equals rlim(0)
       zlimm    ! equals 

END MODULE teqlib_output

module teqinit

contains

  SUBROUTINE teq_output

    use teqlib_output
    USE teq_output_mod
    USE teq_mod, only : t_c1srf,t_c4srf,t_c5srf,t_r2bzrf,t_r4bp2rf,t_rm,t_zm,&
         t_clj,t_psi00,t_psi01
    USE source_mod, only : t_wp,t_wpp,t_wppp,t_vp,t_vpp,t_vppp
    USE sep_separatrix, only : s_skew,s_dsep,s_dsip,s_rbore,s_rcntr

    IMPLICIT NONE
    
    rm        => t_rm
    zm        => t_zm
    crj       => t_crj
    pvec      => t_pvec
    br        => t_br
    bz        => t_bz
    bp        => t_bp
    bt        => t_bt
    bmod      => t_bmod
    fldind    => t_fldind
    frsrf     => t_frsrf
    fpsrf     => t_fpsrf
    qsrf      => t_qsrf
    rsqbp     => t_rsqbp
    jtsrf     => t_jtsrf
    jparsrf   => t_jparsrf
    susrf     => t_susrf
    cusrf     => t_cusrf
    vpsrf     => t_vpsrf
    srsrf     => t_srsrf
    prsrf     => t_prsrf
    pdsrf     => t_pdsrf
    rsrf      => t_rsrf
    asrf      => t_asrf
    volsrf    => t_volsrf
    c1srf     => t_c1srf
    c4srf     => t_c4srf
    c5srf     => t_c5srf
    esrf      => t_esrf
    tsrf      => t_tsrf
    tlsrf     => t_tlsrf
    tusrf     => t_tusrf
    r2bzrf    => t_r2bzrf
    r4bp2rf   => t_r4bp2rf
    rsqrf     => t_rsqrf
    bpsrf     => t_bpsrf
    bsqrf     => t_bsqrf
    rsqirf    => t_rsqirf
    alsrf     => t_alsrf
    risrf     => t_risrf
    fttcsrf   => t_fttcsrf
    qh        => t_qh
    psibar    => t_psibar
    psidbar   => t_psidbar
    phibar    => t_phibar
    psiinv    => t_psiinv
    psidinv   => t_psidinv
    rhosrf    => t_rhosrf
    psrf      => t_psrf
    vptor     => t_vptor
    tswpts    => t_tswpts
    brwpts    => t_brwpts
    bzwpts    => t_bzwpts
    psiw      => t_psiw
    clj       => t_clj
    rlimw     => t_rlimw
    zlimw     => t_zlimw
    tlimw     => t_tlimw
    plimw     => t_plimw
    wp        => t_wp
    wpp       => t_wpp
    wppp      => t_wppp
    vp        => t_vp
    vpp       => t_vpp
    vppp      => t_vppp
    
    rlsd      => t_rlsd
    zlsd      => t_zlsd
    rstkpt    => t_rstkpt
    zstkpt    => t_zstkpt
    dstkpt    => t_dstkpt
    bstkpt    => t_bstkpt
    lstkpt    => t_lstkpt
    
    rxpf      => t_rxpf
    zxpf      => t_zxpf
    rxpt      => t_rxpt
    zxpt      => t_zxpt
    pxpt      => t_pxpt
    psih      => t_psih
    dpsi0     => t_dpsi0
    dphi0     => t_dphi0
    fwall     => t_fwall
    plc       => t_plc
    nitt      => t_nitt
    lamda_gun => t_lamdagun
    r_gun     => t_rgun
    z_gun     => t_zgun
    f_gun     => t_fgun
    residj    => t_residj
    psi00     => t_psi00
    psi01     => t_psi01
    vltsnd    => t_vltsnd
    li        => t_li
    betap     => t_betap
    betaps    => t_betaps
    lam       => t_lam
    betae     => t_betae
    betat     => t_betat
    flxln     => t_flxln
    absflx    => t_absflx
    psisep    => t_psisep
    psipls    => t_psipls
    xindf     => t_xindf
    slfnd     => t_slfnd
    xlfnd     => t_xlfnd
    volume    => t_volume
    surf      => t_surf
    ctroy     => t_ctroy
    qmerc     => t_qmerc
    placur    => t_placur
    helicity  => t_helicity
    elongn    => t_elongn
    trianu    => t_trianu
    trianl    => t_trianl
    trian     => t_trian
    t95       => t_t95
    tl95      => t_tl95
    tu95      => t_tu95
    trider    => t_trider
    f95       => t_f95
    p95       => t_p95
    psi95     => t_psi95
    e95       => t_e95
    q95       => t_q95
    qmin      => t_qmin
    rhomin    => t_rhomin
    qstar     => t_qstar
    aspct     => t_aspct
    wpf       => t_wpf
    wpt       => t_wpt
    ccdir     => t_ccdir
    al        => t_al
    bpsqva    => t_bpsqva
    presva    => t_presva
    pressa    => t_pressa
    betal     => t_betal
    bpolsa    => t_bpolsa
    rspt      => t_rspt
    zspt      => t_zspt
    dspt      => t_dspt
    bspt      => t_bspt
    nspt      => t_nspt
    nstkpts   => t_nstkpts
    skew      => s_skew
    dsep      => s_dsep
    dsip      => s_dsip
    
  END SUBROUTINE teq_output
  
  SUBROUTINE teqSurf_output

    USE teq_mod, only : t_nsym
    USE teqSurf_mod
    use teqlib_input
    USE teqlib_output, only : plsolo,plsoli,tlsolo,tlsoli,rpts,zpts
    USE teqSubs_mod

    t_nsol     => nsol
    t_nsep     => nsep
    t_npri     => npri
    t_lflux    => lflux
    t_jqm      => jqm
    t_jqd      => jqd
    t_nsym     => nsym

    CALL teqSurf_allocate

    plsolo     => t_plsolo
    plsoli     => t_plsoli
    tlsolo     => t_tlsolo
    tlsoli     => t_tlsoli
    rpts       => t_rpts
    zpts       => t_zpts

  END SUBROUTINE teqSurf_output
  
  SUBROUTINE teqPol_input

    use teqlib_input
    USE teqPol_mod

    t_tpl       => tpl
    t_epsrk     => epsrk
    t_epskrk    => epskrk
    t_anun      => anun
    t_alfa0     => alfa0
    t_alfa1     => alfa1
    t_alfa2     => alfa2
    t_nht       => nht
    t_ns1       => ns1
    t_ijob      => ijob
    t_mesc      => mesc
    t_inv_k     => inv_k
    t_inv_p     => inv_p
    t_rork      => rork
    t_npo       => npo
    t_ntet      => ntet
    t_iter_bdry => iter_bdry
    t_inv_flag  => inv_flag
    t_itimestep_converged => itimestep_converged
    t_qmax      => qmax
    t_inv_x     => inv_x

  END SUBROUTINE teqPol_input
  
  SUBROUTINE teqPol_output

    use teqlib_output
    USE teqPol_mod, only : t_qrk,t_jrk,t_srk,t_trk,t_vrk,t_crk,t_rrk,t_zrk,&
         t_f,t_pff,t_p,t_pp,t_aj
    USE sep_interp, only : i_rhosq

    IF(.NOT. ALLOCATED(t_qrk)) RETURN

    qrk    => t_qrk
    jrk    => t_jrk
    srk    => t_srk
    trk    => t_trk
    vrk    => t_vrk
    crk    => t_crk
    rrk    => t_rrk
    zrk    => t_zrk
    f      => t_f
    pff    => t_pff
    p      => t_p
    pp     => t_pp
    aj     => t_aj
    rhosq  => i_rhosq

  END SUBROUTINE teqPol_output

  SUBROUTINE teqGS_input

    use teqlib_input
    USE teqGS_mod
    USE sep_utils, only : use_elp

    t_ncsym    => ncsym
    t_nc       => nc
    t_cc       => cc(:nc)
    t_rc       => rc(:nc)
    t_zc       => zc(:nc)
    t_drc      => drc(:nc)
    t_dzc      => dzc(:nc)
    t_nrc      => nrc(:nc)
    t_nzc      => nzc(:nc)
    t_ac       => ac(:nc)
    t_ac2      => ac2(:nc)
    t_svec     => svec(:nc)
    t_rcase    => rcase
    t_zcase    => zcase
    t_drcase   => drcase
    t_dzcase   => dzcase
    t_rhc      => rhc(:nc)
    t_rxc      => rxc(:nc)
    t_rextc    => rextc
    t_pfps0    => pfps0(:nc)
    t_cc0      => cc0(:nc)
    t_gdc      => gdc
    t_ic       => ic(:nc)
    t_ix       => ix(:nc)
    t_ict      => ict
    t_lextc    => lextc
    t_iferro   => iferro
    t_pfid     => pfid(:nc)

    t_nloop    => nloop
    t_rloop    => rloop
    t_zloop    => zloop
    t_thloop   => thloop
    t_iloop    => iloop
    t_sigloop  => sigloop
    t_floop0   => floop0
    t_kgreenc  => kgreenc
    t_lgrn     => lgrn
    t_nsymc    => nsymc
    t_gauss_even=> n_gauss_even
    t_gauss_odd=> n_gauss_odd
    t_gauss_chck=> gauss_check
    use_elp    => use_ellip
    t_ncplot   => ncplot
    t_nsph     => nsph
    t_lsph     => lsph
    t_dt       => dt
    t_thetat   => thetat
    t_zocoil   => zocoil
    t_rocoil   => rocoil
    t_rbcoil   => rbcoil
    t_elcoil   => elcoil
    t_dcoil    => dcoil
    t_qcoil    => qcoil
    t_cnorm    => cnorm
    t_crdn     => crdn
    t_acmin    => acmin
    t_magfac   => magfac
    t_bsat     => bsat
    t_almim    => almim
    t_geomo    => geomo
    t_pfjx     => pfjx
    t_pfbx     => pfbx
    t_delc     => delc
    t_pftd     => pftd
    t_pfahs    => pfahs
    t_dfac     => dfac
    t_plcx     => plcx
    t_rlim     => rlim
    t_zlim     => zlim
    t_dlim     => dlim
    t_int_flag => int_flag
    t_rbd      => rbd(:nbd)
    t_zbd      => zbd(:nbd)
    t_tbd      => tbd
    t_psibd    => psibd
    t_rfbd     => rfbd(:nfbd)
    t_zfbd     => zfbd(:nfbd)
    t_psiwfc   => psiwfc
    t_whtz     => whtz
    t_alfbd    => alfbd(:nfbd)
    t_nbd      => nbd
    t_nfbd     => nfbd
    t_nlim     => nlim
    t_nfbc     => nfbc
    t_nmsc     => nmsc
    t_alpcoilc => alpcoilc
    t_alpsphc  => alpsphc
    t_epsb     => epsb
    t_epsj     => epsj
    t_alpcoil  => alpcoil
    t_alpsph   => alpsph
    t_vltf     => vltf
    t_alpcoil  => alpcoil
    t_alpsph   => alpsph
    t_iflxc    => iflxc
    t_ixpt     => ixpt
    t_raxis0   => raxis0
    t_zaxis0   => zaxis0 
    t_jaxis    => jaxis
    t_kaxis    => kaxis
    t_rxpt0    => rxpt0
    t_zxpt0    => zxpt0 
    t_jxp      => jxp
    t_kxp      => kxp
    t_cejima   => cejima
    t_rl       => rl
    t_irl      => irl
    t_keqic    => keqic
    t_ifscl    => ifscl
    t_ipscl    => ipscl
    t_ibdry    => ibdry
    t_ni       => ni
    t_nl       => nl
    t_ixp      => ixp
    t_ixpo     => ixpo
    t_initflx  => initflx
    t_ksave    => ksave
    t_lop0     => lop0
    t_betx     => betx
    t_rb       => rb
    t_nitr     => nitr
    t_limw     => limw
    t_lcal     => lcal
    t_ierr1    => ierr1
    t_psires0  => psires0
    t_dtofst   => dtofst
    t_rfix     => rfix
    t_dbdu     => dbdu
    t_queu     => queu
    t_bbdl     => bbdl
    t_bbdu     => bbdu
    t_ebdu     => ebdu
    t_dbdl     => dbdl
    t_quel     => quel
    t_ebdl     => ebdl
    t_nbdu     => nbdu
    t_nbdl     => nbdl
    t_nbs      => nbs
    t_dsurf    => dsurf
    t_lasteq   => lasteq
    t_lasteqsav   => lasteqsav
    t_nfil     => nfil
    t_ngp      => ngp
    t_nfjx     => nfjx
    t_ncase    => ncase
    t_ncoil    => ncoil
    t_crj_flag => crj_flag
    t_finit2   => finit2
    t_liml     => liml
    t_el       => el
    t_elx      => elx
    t_psil00   => psil00
  END SUBROUTINE teqGS_input

  SUBROUTINE teqGS_output

    use teqlib_input
    USE teqGS_mod, only : t_ncf,t_jm0p,t_km0p,t_nc0b,t_nc0p,t_nloop0p,&
         t_ncfo,t_nsymco,t_ngpo

    t_ncf     => ncf
    t_jm0p    => jm0p
    t_km0p    => km0p
    t_nc0b    => nc0b
    t_nc0p    => nc0p
    t_nloop0p => nloop0p
    t_ncfo    => ncfo
    t_nsymco  => nsymco
    t_ngpo    => ngpo

    CALL teqGS_p

  END SUBROUTINE teqGS_output
  
  SUBROUTINE teqGS_p

    USE teqlib_output
    USE teqGS_mod
    USE teqSubs_mod

    ncircuit=> t_ncircuit
    jbdcir  => t_jbdcir
    ncrmx   => t_ncrmx
    nczmx   => t_nczmx
    ifjx    => t_ifjx
    ifbx    => t_ifbx
    ncs     => t_ncs
    ngroup  => t_ngroup
    
    CALL teqGS_allocate_output
    CALL teq_allocate_greens
    
    ccf    => t_ccf
    rcf    => t_rcf
    zcf    => t_zcf
    drcf   => t_drcf
    dzcf   => t_dzcf
    ccfd   => t_ccfd
    ccmf   => t_ccmf
    cscl   => t_cscl
    ccls   => t_ccls
    cscl00 => t_cscl00
    cscl01 => t_cscl01
    cclsr  => t_cclsr
    cmplas => t_cmplas
    pfjp   => t_pfjp
    pfjc   => t_pfjc
    pfjf   => t_pfjf
    pfbc   => t_pfbc
    pfbi   => t_pfbi
    pfbo   => t_pfbo
    pfbr   => t_pfbr
    pfbz   => t_pfbz
    pfhs   => t_pfhs
    pfms   => t_pfms
    pffr   => t_pffr
    pffz   => t_pffz
    pfil   => t_pfil
    pfse   => t_pfse
    pfe0   => t_pfe0
    pfpsi  => t_pfpsi
    vlts2D => t_vlts2D
    pfpci  => t_pfpci
    pfpc0  => t_pfpc0
    rcg    => t_rcg
    zcg    => t_zcg
    gloop  => t_gloop
    br0p   => t_br0p
    bz0p   => t_bz0p
    aac    => t_aac
    rcs    => t_rcs
    zcs    => t_zcs
    ths    => t_ths
    p_in   => t_intc
    jnt    => t_jnt
    knt    => t_knt
    icc    => t_icc
    loopm  => t_loopm
    loop0  => t_loop0
    icf    => t_icf
    icnf   => t_icnf
    pfim   => t_pfim
    floop  => t_floop
    ploop  => t_ploop
    rc4    => t_rc4
    zc4    => t_zc4
    gc     => t_gc
    gfbr   => t_gfbr
    gfbz   => t_gfbz
    gp     => t_gp
    plim   => t_plim
    pbim   => t_pbim
    gpl    => t_gpl
    psires => t_psires
    rbin   => t_rbin
    rbout  => t_rbout
    pfcse  => t_pfcse
    pftse  => t_pftse
    pfcsi  => t_pfcsi
    pfcil  => t_pfcil
    error  => t_error
    resb   => t_resb
    resid  => t_resid
    prsx00 => t_prsx00
    prsx01 => t_prsx01
    rlimm  => t_rlimm
    zlimm  => t_zlimm

  END SUBROUTINE teqGS_p

  SUBROUTINE allocate_interface(jmm,kmm,mlss,nsymm,n4)
    USE sep_separatrix
    INTEGER, INTENT(IN) :: jmm,kmm,mlss,nsymm
    INTEGER, INTENT(INOUT) :: n4
    CALL allocate_separatrix(jmm,kmm,mlss,nsymm,n4)
  END SUBROUTINE allocate_interface

 end module teqinit

!$Id: driver.f90,v 1.4 2007/07/31 20:13:30 pearls Exp $

program driver
  use teqlib
  use deadstart

  use teqerr

  implicit none
  
  real(rq), DIMENSION(:), ALLOCATABLE :: psuser,puser,juser

  integer :: muser
  
  type(profile_type) :: prof

  type(inv_type) :: inv

  type(dir_type) :: dir

  type(pf_type) :: pf
 
  type(global_type) :: glb

  integer :: ierr

! FOR A LIST OF THESE DEFINED TYPES LOOK AT THE TOP OF teqlib.f90
! IT SHOULD BE SELF EXPANATORY.I WILL ADD MORE COMMENTS AND ADD TO
! THE README FILE. IT IS NOW NECESSARY THAT NO DATA BE CHANGED UNTIL
! AFTER THE FIRST EQUILIBRIUM IS OBTAINED. IT IS AFTER THIS THAT ALL
! POINTERS, ETC ARE SET UP.

  character(len = 64) :: which

  integer :: i,logunit

!  logical :: do_deadstart = .true.
 logical :: do_deadstart = .false.
  logical :: do_test = .true.
  logical :: get_external = .false.


  nullify(prof%q,prof%qs,prof%p, prof%ps,prof%jpar,prof%jpars,prof%jt,prof%jts)
  nullify(prof%f,prof%fs,prof%pd,prof%bp,prof%bp,  prof%rsqi, prof%cu,prof%phi)
  nullify(prof%r,prof%a ,prof%w, prof%v ,prof%bsq, prof%psi , prof%vpr)
  nullify(inv%R%f, inv%mth, inv%rbnd, inv%raxis)
  nullify(dir%psi%f, dir%psi%nx, dir%ipp)
  nullify(pf%cc, pf%rlim, pf%rbd, pf%rfbd)

  call set_global(glb) ! Now sets pointer
  glb%logunit = 9
  glb%ioun7=7
  glb%ioun12=12
  glb%ioun13=13
  glb%logname="driver.log"
  logunit=glb%logunit
  open(unit = glb%logunit, file = glb%logname, status = "replace")

  glb%filename="input/iter.in"
!  glb%filename="input/iter_inv.in"
!  glb%filename="input/iter_dir-inv.in"
!  glb%filename="input/fire.in"
!  glb%filename="input/fire_inv.in"
!  glb%filename="input/ignitor_sof.in"
!  glb%filename="input/jet.in"
!  glb%filename="input/jet_inv.in"
!  glb%filename="input/d3d.in"
!  glb%filename="input/d3d_inv.in"
!  glb%filename="input/cmod.in"
!  glb%filename="input/cmod_inv.in"
!  glb%filename="input/nstx.in"
!  glb%filename="input/nstx_sym.in"
!  glb%filename="input/nstx_inv.in"
!  glb%filename="input/sspx_bcs.in"
!  glb%filename="input/sspx_bcm.in"
!  glb%filename="input/kstar.in"
!  glb%filename="input/kstar_inv.in"
!  glb%filename="input/mst.in"
!  glb%filename="input/mast-sn.in"
!  glb%filename="input/pegasus.in"
!  glb%filename="input/pegasus_snl.in"
!  glb%filename="input/east_snl.in"
!  glb%filename="input/tftr.in"
!  glb%filename="input/tftr_inv.in"
!  glb%tokamak ="input/kstar-tokamak.inp"
!  glb%pfcoil  ="input/kstar-pfcoil.inp"
!  glb%tokamak ="input/pegasus-tokamak.inp"
!  glb%pfcoil  ="input/pegasus-pfcoil.inp"
!  glb%filename="driver.in"

  stop_on_error = .false.

  ! Put an exception handler around all of the calls
  exceptions_enabled = .true.

  if (do_deadstart .and. glb%filename == "input/kstar.in") then
     write(*,*)"deadstart with ",trim(glb%tokamak)," and ",glb%pfcoil
     write(logunit,*)"deadstart with ",trim(glb%tokamak)," and ",glb%pfcoil
     call catch_dead_start(ierr,glb)
    if(ierr/=0) then
        print *, 'An exception occurred, the error message is: ', &
             trim(error_msg), '. Bailing out...'
        write(logunit,*) 'An exception occurred, the error message is: ', &
             trim(error_msg), '. Bailing out...'
        ! user intervenes
        stop
     end if
  elseif (do_deadstart .and. glb%filename == "input/pegasus.in") then
     write(*,*)"deadstart with ",trim(glb%tokamak)," and ",glb%pfcoil
     write(logunit,*)"deadstart with ",trim(glb%tokamak)," and ",glb%pfcoil
     call set_verbosity(1)
     call catch_dead_start(ierr,glb)
     if(ierr/=0) then
        print *, 'An exception occurred, the error message is: ', &
             trim(error_msg), '. Bailing out...'
        write(logunit,*) 'An exception occurred, the error message is: ', &
             trim(error_msg), '. Bailing out...'
        ! user intervenes
        stop
     end if
  else
     call remark("Using "//glb%filename)
     write(logunit,*)"Using "//glb%filename
     call catch_load_savefile(ierr,glb,dir,pf,inv,prof)
     write(*,*) inv%fix_bnd
     if(ierr/=0) then
        print *, 'An exception occurred, the error message is: ', &
             trim(error_msg), '. Bailing out...'
        write(logunit,*) 'An exception occurred, the error message is: ', &
             trim(error_msg), '. Bailing out...'
        ! user intervenes
        stop
     end if

     if(get_external==.true.) then 
        ! This logic is to be used to get the external flux (free-boundary
        ! calculation) after a fixed-boundary calculation
        ! During a run all you should need is the last "call catch_direq"
        ! Note that if you are starting up from an inverse savefile with
        ! inv%fix_bnd=.true., you will need to do all of the below in order
        ! to synchronize with the derived types, otherwise you are ready to go.
        ! During a seqhence of fixed-boundary calculations one needa only call
        ! catch_direq after each catch_inveq.
        inv%eq=1
        inv%nht=6
        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(glb%filename=="input/d3d_inv.in") then
           pf%ic(:pf%ncp)=(/(i,i=1,pf%ncp)/)
           ! pf%ncp is the number of shaping coils in DIII-D
           ! otherwise it is the number of active coils.
           ! you may want to intervene here
           pf%nfbd=inv%mth
           pf%alfbd(:pf%nfbd)=pf%alfbd(1)
           pf%rfbd(:pf%nfbd)=inv%rbnd
           pf%zfbd(:pf%nfbd)=inv%zbnd
        end if
        pf%nbd=0 ! no fixed boundary points
        pf%psix=dir%paxis
        ! force the flux on axis in free_boundary to be that of fixed_boundary
        call catch_direq(ierr,dir,pf,inv,prof,glb)
        call write_savefile("driver.in")
        stop
     endif

     if((inv%eq==0 .or. (inv%eq==1 .and. .not.inv%fix_bnd)) &
          .and. .not. do_test) then
! direct solve
!        call set_verbosity(1)  

        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        if(glb%filename=="input/sspx_bcm.in" .or. &
             glb%filename=="input/sspx_bcs.in") then
           stop
        end if
        ! note in the direct solve all inactive save arrays are reset

        inv%mth=81
        inv%mpsi=81
        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        dir%thc = 0.01! move boundary inside separatrix in dimensionless flux;
                      ! necessary for inverse solves and direct solves if q is
                      ! is the inputted profile: ipj=5

        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        ! this option is the "adiabatic option"
        dir%ipj = 5   ! compute from qsave and psave
        dir%ipscl = -1! do not scale to fix current or flux
        inv%p = 0     ! fixes F on boundary to fwall
                      ! note that in this case the options are the same
                      ! as for the inverse solver
        dir%f_wp=999  ! smoothes current at edge
        inv%eq=0      ! in case the starting direct solver was using the
                      ! inverse solver for the solution inside the separatrix

        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        !
        dir%ipscl = 0 ! fixes plasma current;ipscl=1 fixes flux
                      !  
        dir%ipj = 1   ! compute from jtsave and psave

        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        which="both"
        call gridup(dir,pf,inv,prof,glb,which) ! changes grid
        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        which ="y"
        call griddown(dir,pf,inv,prof,glb,which) ! changes grid
        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        which ="x"
        call griddown(dir,pf,inv,prof,glb,which) ! changes grid
        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        inv%nht = 200; inv%epsrk = 1.0e-6
        call set_verbosity(2)
        inv%p = 0     ! fixes F_bound to fwall
        inv%k = 0     ! uses q-profile (qsave)
        inv%eq=-2     ! first time after direct equilibrium, uses internal data
        call catch_inveq(ierr,inv,prof,glb) ! first inverse solve
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if
!        inv%p = -1    ! fixes polflux(GS) across plasma to dpsi00 (cgs)
        inv%p = 1     ! fixes current, uses plcm (MA)
        inv%k = 3     ! uses jparsave (<J.B>/<B.B>
        ! Uses previous solution as starting point

        call catch_inveq(ierr,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        ! if in the course of running there is a STOP or a major change in 
        ! the boundary make sure inv%rbnd and inv%zbnd are properly set

        ! and set inv%eq=-1 and call catch_inveq(ierr,inv,prof,glb)
        ! for the profiles options!
        ! inv%k=0 or inv_k%3 are preferred since output profiles are equal to
        ! input profiles; if inv%k=1,2 output profiles are only proportional
        ! to the input profiles
        inv%eq = 0 ! This value tells the free-boundary solver not to use
                   ! the inverse solver for the solution inside separatrix.
        dir%thc = 0
        call set_verbosity(1)

        call catch_direq(ierr,dir,pf,inv,prof,glb) ! back to direct solve
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        ! constrict spline coefficients for the input profiles
        prof%fs = prof%f
        prof%w  = (prof%fs**2 - prof%f(dir%psi%nx)**2) / &
             (8  * pi * inv%dpsi0 * dir%prsx)
        prof%v  = prof%ps / (dir%betaj * inv%dpsi0 * dir%prsx)
        call get_spline_coefficients ! The spline coefficients for w and v
        ! end construct

        ! set input parameters to use spline coefficients
        dir%ipp = 999
        dir%ipf = 999
        dir%ipj = 0
        ! end set

        call catch_direq(ierr,dir,pf,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

     elseif(.not.do_test) then
        call set_verbosity(2)
        call catch_inveq(ierr,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        inv%p=0 ! Fwall scaler boundary condition

        ! user provides input profiles on dimensionless poloidal flux profiles
        muser=51
        allocate(psuser(muser),puser(muser),juser(muser))
        psuser=sqrt((/(i,i=0,muser-1)/)/(muser-1.0_rq)) ! dim-less pol-flux

        ! just interpolate the profiles to the user coord. to get user profiles
        call translate(prof%psi,prof%qs,psuser,juser) ! from teq coordinates
        call translate(prof%psi,prof%ps,psuser,puser) ! from teq coordinates

        ! next transform user profiles to teq coordinates 
        call translate(psuser,juser,prof%psi,prof%qs)
        call translate(psuser,puser,prof%psi,prof%ps)
        ! note the only change for this example is from grid resolution
        
        call catch_inveq(ierr,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if
        inv%rbnd=inv%rbnd+0.25_rq*prof%a(inv%mpsi)
        inv%zbnd=inv%zbnd+0.25_rq*prof%a(inv%mpsi)
        
        inv%eq=-1 ! Do not use internal geoemetry info if boundary points
                  ! are moved. If there is a "gentle" motion during surveys,
                  ! this should not be necessary
        inv%eq=0  ! This is the prefrred option with a boundary move: note
                  ! the comnents in libteq.f90 for inv_type
        call catch_inveq(ierr,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        ! now transform back to user coord.
        call translate(prof%psi,prof%qs,psuser,juser) ! from teq coordinates
        call translate(prof%psi,prof%ps,psuser,puser) ! from teq coordinates

        ! Move boundary points
        inv%rbnd=inv%rbnd-0.25_rq*prof%a(inv%mpsi)
        inv%zbnd=inv%zbnd-0.25_rq*prof%a(inv%mpsi)
        inv%eq=-1 ! Do not use internal geoemetry info if boundary points
                  ! are moved. If there is a "gentle" motion during surveys,
                  ! this should not be necessary

        inv%eq=0

        call catch_inveq(ierr,inv,prof,glb)
        if(ierr/=0) then
           print *, 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           write(logunit,*) 'An exception occurred, the error message is: ', &
                trim(error_msg), '. Bailing out...'
           ! user intervenes
           stop
        end if

        if(glb%filename=="input/nstx_inv.in") then
           prof%qs=10*prof%qs

           call catch_inveq(ierr,inv,prof,glb)
           if (ierr /= 0) then
             print *, 'An exception occurred, the error message is: ', &
                 trim(error_msg), '. Bailing out...'
             write(logunit,*)'An exception occurred, the error message is: ', &
                 trim(error_msg), '. Bailing out...'
     ! new calculation
             prof%qs=0.1_rq*prof%qs
             inv%eq=-2 ! This uses the old flux geometry, but re-initializes.
             ! inv%eq=-1 ! This uses no prior information; just initializes
             inv%x=.9 ! modifies FF' beyond pssibar=.9 to force FF'=0 at bndry
             call catch_inveq(ierr,inv,prof,glb)
             if (ierr /= 0) then
              print *, 'An exception occurred, the error message is: ', &
                 trim(error_msg), '. Bailing out...no really...'
              write(logunit,*) 'Exception occurred, the error message is: ', &
                 trim(error_msg), '. Bailing out...no really...'
              stop
             end if
           end if

        end if
     end if
  end if
  call write_savefile("driver.in")
  if(do_test) then
     write(*,*) " "
     write(logunit,*) " "
     write(*,*) "OUTPUT"
     write(logunit,*) "OUTPUT"
     if(inv%eq==0 .or. .not.inv%fix_bnd) then
        write(*,*) "coil currents and pbnd   ",pf%cc(:pf%nc),&
             dir%pbnd
        write(logunit,*) "coil currents and pbnd   ",pf%cc(:pf%nc),&
             dir%pbnd
     else
        if(inv%k==0) then
           write(*,*) "q(1) and P(1)            ",prof%q(1),prof%p(1)
           write(logunit,*) "q(1) and P(1)            ",prof%q(1),prof%p(1)
        elseif(inv%k==1) then
           write(*,*) "F(1) and P(1)            ",prof%f(1),prof%p(1)
           write(logunit,*) "F(1) and P(1)            ",prof%f(1),prof%p(1)
        elseif(inv%k==2) then
           write(*,*) "jt(1) and P(1)           ",prof%jt(1),prof%p(1)
           write(logunit,*) "jt(1) and P(1)           ",prof%jt(1),prof%p(1)
        elseif(inv%k==3) then
           write(*,*) "jpar(1) and P(1)         ",prof%jpar(1),prof%p(1)
           write(logunit,*) "jpar(1) and P(1)         ",prof%jpar(1),prof%p(1)
        endif
     end if
     write(*,*) "boundary point           ",inv%rbnd(25),inv%zbnd(25)
     write(logunit,*) "boundary point           ",inv%rbnd(25),inv%zbnd(25)
     write(*,*) "scaler constraints -dpsi0,cur,fwall- two can be bad &
          since only one is used"
     write(logunit,*) "scaler constraints -dpsi0,cur,fwall- two can be bad &
          since only one is used"
     write(*,*) inv%dpsi0,inv%cur,prof%f(inv%mpsi)
     write(logunit,*) inv%dpsi0,inv%cur,prof%f(inv%mpsi)

     call read_savefile(glb%filename)

     write(*,*)" "
     write(logunit,*)" "
     write(*,*) "INPUT"
     write(logunit,*) "INPUT"
     if(inv%eq==0 .or. .not.inv%fix_bnd) then
        write(*,*) "coil currents and pbnd   ",pf%cc(:pf%nc),&
             dir%pbnd
        write(logunit,*) "coil currents and pbnd   ",pf%cc(:pf%nc),&
             dir%pbnd
     else
        if(inv%k==0) then
           write(*,*) "q(1) and P(1)            ",prof%qs(1),prof%ps(1)
           write(logunit,*) "q(1) and P(1)            ",prof%qs(1),prof%ps(1)
        elseif(inv%k==1) then
           write(*,*) "F(1) and P(1)            ",prof%fs(1),prof%ps(1)
           write(logunit,*) "F(1) and P(1)            ",prof%fs(1),prof%ps(1)
        elseif(inv%k==2) then
           write(*,*) "jt(1) and P(1)           ",prof%jts(1),prof%ps(1)
           write(logunit,*) "jt(1) and P(1)           ",prof%jts(1),prof%ps(1)
        elseif(inv%k==3) then
           write(*,*) "jpar(1) and P(1)         ",prof%jpars(1),prof%ps(1)
           write(logunit,*) "jpar(1) and P(1)         ",prof%jpars(1),prof%ps(1)
        end if
     end if
     write(*,*)"boundary point           ",inv%rbnd(25),inv%zbnd(25)
     write(logunit,*) "boundary point           ",inv%rbnd(25),inv%zbnd(25)
     write(*,*) "scaler constraints -dpsi0,cur,fwall- two can be bad &
          since only one is used"
     write(logunit,*) "scaler constraints -dpsi0,cur,fwall- two can be bad &
          since only one is used"
     write(*,*) inv%dpsi00,inv%plc*1.e6,inv%fwall
     write(logunit,*) inv%dpsi00,inv%plc*1.e6,inv%fwall

     endif
  stop
end program driver

! $Id: greens.f90,v 1.2 2007/07/23 16:00:57 meyer Exp $

MODULE greens_mod

  USE teq_mod
  USE teqGS_mod

  IMPLICIT NONE

  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE :: wge,xge,rge,zgle,zgue,dae,&
       wgo,xgo,rgo,zglo,zguo,dao
  REAL(rq), PRIVATE :: area_e,area_o
  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE :: wr,wv,wz
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, PRIVATE :: wrk0,wrk1,wrk2


  ! The following parameters can each be either even or odd. The
  ! only restriction is that they be different, and not both odd.
  ! The total number of integrand evaluations required to compute
  ! the self-inductance is n_gauss_even*n_gauss_odd for rectangular
  ! and type 1 coils, 6*n_gauss_even*n_gauss_odd for type 2 coils.

CONTAINS

  SUBROUTINE g_fldp(rp,zp,br,bz,flx)
    USE teq_input_mod
    REAL(rq), INTENT(IN)  :: rp,zp
    REAL(rq), INTENT(OUT) :: br,bz,flx
    REAL(rq), DIMENSION(t_jmkm) :: fl,fcr,fcz

    CALL mutual_utils(t_rm,t_zm,rp,zp,fl,fcr,fcz,3)
    flx=-SUM(fl*t_crj/t_rm)*t_dr*t_dz/FOURPI
    br =-SUM(fcr*t_crj/t_rm)*t_dr*t_dz/FOURPI
    bz =-SUM(fcz*t_crj/t_rm)*t_dr*t_dz/FOURPI
  END SUBROUTINE g_fldp

  FUNCTION g_flxp(rp,zp) RESULT(flx)
    USE teq_input_mod
    REAL(rq), INTENT(IN) :: rp,zp
    REAL(rq) ff(t_jmkm),flx
    CALL mutual_utils(t_rm,t_zm,rp,zp,ff,ff,ff,0)
    flx=-SUM(ff*t_crj/t_rm)*t_dr*t_dz/FOURPI
  END FUNCTION g_flxp

  FUNCTION g_flxc(rp,zp) RESULT(flx)
    REAL(rq), INTENT(IN) :: rp,zp
    REAL(rq), DIMENSION(t_ncf) :: ff,fr,fz
    REAL(rq) flx
    CALL mutual_utils(t_rcf,t_zcf,rp,zp,ff,fr,fz,0)
    flx=1.0e+05*SUM(ff*t_ccf)
  END FUNCTION g_flxc

  SUBROUTINE g_flxfld(rp,zp,br,bz,fl)
    REAL(rq) rp,zp,br,bz,fl
    REAL(rq), DIMENSION(t_ncf) ::  ff,fcr,fcz
    CALL mutual_utils(t_rcf,t_zcf,rp,zp,ff,fcr,fcz,3)
    fl=1.0e5*SUM(ff*t_ccf)
    br=1.0e5*SUM(fcr*t_ccf)
    bz=1.0e5*SUM(fcz*t_ccf)
  END SUBROUTINE g_flxfld

  FUNCTION g_xslfind( r, t_dr, dzz ) RESULT(xslf)

    !***********************************************************************
    !                                                                      *
    !     Calculates the 1-turn inductance of a single axisymmetric coil   *
    !     of rectangular section (uses Grover formula if square).  Based   *
    !     on 4th order expansion in R, from formula for circular coils     *
    !     of rectang<ular section. (MKS units.)                            *
    !                                                                      *
    !        R       :  mean radius                                        *
    !        T_DR      :  radial build                                       *
    !        T_DZ      :  axial height                                       *
    !        XSLFIND := self inductance                                    *
    !                                                                      *
    !     Written by:  Jim Leuer 1982                                      *
    !     Updated to include Grover for square, Jim Leuer (8/87)           *
    !     Modified 12-Sep-88 RHB                                           *
    !                                                                      *
    !***********************************************************************
    REAL(rq), INTENT(IN) :: r,t_dr,dzz
    REAL(rq) :: xslf,co2a,d,u,v,w,wp,ba2,ba4,ca2,ca4,baca2,al,t1,t5a,t5b,&
         t5c,t5d,t5e,t5f,t5,t6a,t6b,t6c,t6d,t6e,t6,t_dz

    t_dz = ABS(dzz)
    IF( t_dz==t_dr ) then
       co2a   = t_dr/(2.0*r)
       co2a   = co2a*co2a
       xslf= r*(0.5*(1.+co2a/6.)*log(8./co2a)-0.84834+.2041*co2a)
    ELSE
       d      = sqrt(t_dz*t_dz+t_dr*t_dr)
       u      = t_dz*t_dz/t_dr/t_dr*log(d*d/t_dz/t_dz)
       v      = t_dr*t_dr/t_dz/t_dz*log(d*d/t_dr/t_dr)
       w      = t_dz/t_dr*atan2(t_dr,t_dz)
       wp     = t_dr/t_dz*atan2(t_dz,t_dr)
       ba2    = t_dz*t_dz/(r*r)
       ca2    = t_dr*t_dr/(r*r)
       ba4    = ba2*ba2
       ca4    = ca2*ca2
       baca2  = ba2*ca2
       al     = log(8.0*r/d)
       t1     = al + (1.0+u+v)/12.0 - 2.0*(w+wp)/3.0
       t5a    = (3*ba2+ca2)*al
       t5b    = ba2*u/2.0
       t5c    = -ca2*v/10.0
       t5d    = -16.0*ba2*w/5.0
       t5e    = 69.0*ba2/20.0
       t5f    = 221.0*ca2/60.0
       t5     = (t5a+t5b+t5c+t5d+t5e+t5f)/96.0
       t6a    = (-30.0*ba4+35.0*baca2+22.0*ca4/3.0)*al
       t6b    = -(115.0*ba4-480.0*baca2)*u/12.0
       t6c    = -23.0*ca4*v/28.0
       t6d    = 256.0*(6.0*ba4-7.0*baca2)*w/21.0
       t6e    = -(36590.0*ba4-2035.0*baca2-11442.0*ca4)/840.0
       t6     = (t6a+t6b+t6c+t6d+t6e)/30720.0
       xslf   = r*(t1+t5+t6)
    END IF
    !
  END FUNCTION g_xslfind

  FUNCTION g_xsind(r0,z0,drr,dzz,ang1,ang2) RESULT(xslf)
    USE teq_input_mod
    ! Compute the self-inductance of a coil with parallelogram cross-section.
    ! The geometric center of the coil is at (r0,z0), distance between side
    ! edges  drr, distance between top and bottom edges dzz. Coil shape is
    ! given by the angles:
    !                  -2*pi < ang1, ang2 < 2*pi,
    ! according to the following scheme:
    !
    !        ang1           ang2              coil
    !       ------------------------------------------
    !         0         0, +/- pi/2         rectangle
    !        <>0        0, +/- pi/2          type 1
    !         0              <>0             type 2
    !        <>0      <>0& <>+/- pi/2       invalid
    !       ------------------------------------------
    !
    ! (ang2=0 has no valid geometric interpretation, but is allowed as a
    ! flag.) Double Integration in r is by odd order, gauss_odd, and even
    ! order, gauss_even, Gaussian quadrature. In "type-2" parallelograms
    ! the coil cross-section is subdivided into three disjoint regions, in
    ! each of which the integrand is smooth and the quadrature performed
    ! separately. The total self inductance is then computed as
    !
    !        L = L_1 + L_2 +L_3 +2*(M_12 +M_23 + M_31).
    !
    ! This routine uses the internal FUNCTION xmcc(...) to compute the mutual
    ! inductance of two coils.
    !
    ! Ref: M. W. Garrett, J. Appl. Phys 34, 2567 (1963). 

    REAL(rq) xslf,r0,z0,drr,dzz,ang1,ang2,area_1e,area_2e,area_3e,area_1o,&
         area_2o,area_3o,tacrit,delr,hdelr,hdr,hdz,rll,rlr,rscale,r2,sumi,&
         sumj,ta,tabs,zt1e,zt2e,zt3e,zt1o,zt2o,zt3o,z1,z2,rul,rur,delr1,&
         hdelr1,r01,delr2,hdelr2,delr3,hdelr3,r03,self1,self2,self3,mut12,&
         mut23,mut31
    INTEGER i,j,nevn,nodd
    SAVE nevn, nodd
    DATA nevn/0/, nodd/0/

    ! Check input parameters:
    IF(ang1/=0. .AND. (abs(ang2)/=.5*PI .AND. ang2/=0.))&
         call errdetec("ang1, ang2 incompatible in xsind",1)
    IF(r0<=0. .or. drr<=0. .or. dzz<=0.)&
         call errdetec("r0, drr,or dzz <= 0 in xsind",1)

    ! Compute Gaussian weights and abscissae on the normalized
    ! interval [-1, 1], if necessary:
    IF(nevn /= t_gauss_even .or. nodd /= t_gauss_odd)then
       IF(nevn/=0) DEALLOCATE(wge,xge,rge,zgle,zgue,dae,&
            wgo,xgo,rgo,zglo,zguo,dao)
       nevn=t_gauss_even
       nodd=t_gauss_odd
       ALLOCATE(wge(nevn),xge(nevn),rge(nevn),zgle(nevn),zgue(nevn),&
            dae(nevn),wgo(nodd),xgo(nodd),rgo(nodd),zglo(nodd),&
            zguo(nodd),dao(nodd))
       call gaussWtsAbs(-1._rq,1._rq,nevn,wge,xge)
       call gaussWtsAbs(-1._rq,1._rq,nodd,wgo,xgo)
    END IF

    ! Check Gaussian weights and abscissae if gauss_chck /= 0:
    IF(t_gauss_chck /= 0)then 
       IF(t_gauss_chck == 1)t_gauss_chck=0
       ! check weights:
       sumi=0.5_rq*SUM(wge)-1.0_rq
       sumj=0.5_rq*SUM(wgo)-1.0_rq
       write(*,*)"weight-check, even, odd:",sumi,sumj
       !check abscissae (integrate x**2 from x=1 to x=4):
       sumi=SUM(wge*(1.5_rq*xge+2.5_rq)**2)
       sumi=.5_rq*(4._rq-1.)*sumi-21._rq  ! correct result is 21.
       sumj=SUM(wge*(1.5_rq*xge+2.5_rq)**2)
       sumj=.5_rq*(4._rq-1.)*sumj-21._rq  ! correct result is 21.
       write(*,*)"abscissae-check, even, odd:",sumi,sumj
    END IF

    hdr=.5_rq*drr
    hdz=.5_rq*dzz
    z1=z0-hdz
    z2=z0+hdz
    area_e=0.
    area_o=0.

    IF(ang1==0.0 .and. (ang2==0.0 .or. abs(2.*abs(ang2)/PI -1.)<1.d-12))THEN
       DO i=1,nevn                                ! rectangular coil
          rge(i)=hdr*xge(i)+r0                    !   ------                 
          zgue(i)=z2                              !   |    |                
          zgle(i)=z1                              !   |    |               
          dae(i)=dzz                               !   |    |
       END DO
       DO j=1,nodd
          rgo(j)=hdr*xgo(j)+r0
          zguo(j)=z2 
          zglo(j)=z1
          dao(j)=dzz  
       END DO
       delr=drr                                
       xslf=g_xmcc(rge,wge,zgle,zgue,dae,delr,nevn,area_e,&
            rgo,wgo,zglo,zguo,dao,delr,nodd,area_o)
       xslf=xslf/(area_e*area_o)
       RETURN
    ELSEif(ang2 == 0.0 .or. abs(2.*abs(ang2)/PI-1._rq)<1.e3*errt_rq)then 
       ta=tan(ang1)                 ! "vertical" parallelogram coil:
       DO i=1,nevn                  ! (type 1)      /|  
          rge(i)=hdr*xge(i)+r0      !              / | .  
          zgue(i)=z2+(rge(i)-r0)*ta !              | |.
          zgle(i)=zgue(i)-dzz        !              | / ang1
          dae(i)=dzz                 !              |/.......
       END DO
       DO j=1,nodd
          rgo(j)=hdr*xgo(j)+r0
          zguo(j)=z2+(rgo(j)-r0)*ta
          zglo(j)=zguo(j)-dzz
          dao(j)=dzz
       END DO
       delr=drr
       xslf=g_xmcc(rge,wge,zgle,zgue,dae,delr,nevn,area_e,&
            rgo,wgo,zglo,zguo,dao,delr,nodd,area_o)
       xslf=xslf/(area_e*area_o)
       RETURN
    ELSE IF(ang1 == 0.0)then     ! "horizontal" parallelogram coil
       ta=tan(ang2)              ! (type 2): subdivide into 3 regions
       tabs=abs(ta)
       tacrit=dzz/drr  ! |tan(ang2)| for which area of region 2 = 0

       ! the following definitions 
       ! hold for all -2*pi<=ang2<=2*pi             --------   
       rll=r0-hdz/ta-hdr  ! lower-left             /|   |3 / 
       rlr=rll+drr         ! lower-right           / | 2 | /
       rul=rll+dzz/ta      ! upper-left           / 1|   |/ ang2
       rur=rul+drr         ! upper-right          --------.......
       delr=drr+dzz/tabs
       hdelr=.5_rq*delr
       IF(r0-hdelr < 0.)call errdetec(&
            "geometric parameters of type 2 coil are invalid",1)

       ! Region 1:

       IF(tabs > tacrit)then
          delr1=rul-rll
          r01=rll+.5_rq*delr1
       ELSE
          delr1=rlr-rll
          IF(ta>0.)then
             r01=rll+.5_rq*delr1
          ELSE
             r01=rul+.5_rq*delr1
          END IF
       END IF
       delr1=abs(delr1)            
       hdelr1=.5_rq*delr1
       ! Self inductance:
       DO i=1,nevn      
          rge(i)=hdelr1*xge(i)+r01
          IF(ta > 0.)then
             zgle(i)=z1
             zgue(i)=z1+(rge(i)-rll)*ta
          ELSE
             zgle(i)=z2+(rge(i)-rul)*ta
             zgue(i)=z2
          END IF
          dae(i)=zgue(i)-zgle(i)
       END DO
       DO j=1,nodd
          rgo(j)=hdelr1*xgo(j)+r01
          IF(ta > 0.)then
             zglo(j)=z1
             zguo(j)=z1+(rgo(j)-rll)*ta
          ELSE
             zglo(j)=z2+(rgo(j)-rul)*ta
             zguo(j)=z2
          END IF
          dao(j)=zguo(j)-zglo(j)
       END DO
       self1=g_xmcc(rge,wge,zgle,zgue,dae,delr1,nevn,area_1e,&
            rgo,wgo,zglo,zguo,dao,delr1,nodd,area_1o) 
       area_e=area_e+area_1e
       area_o=area_o+area_1o

       ! Mutual inductance with region 2:
       IF(tabs < tacrit)then    ! region 2 is a type-1 parallelogram
          IF(ta > 0.)then
             delr2=rul-rlr
          ELSEif(ta < 0.)then
             delr2=rll-rur
          ELSE
             call errdetec("ang2=0 in xsind, region 2",1)
          END IF
          hdelr2=.5_rq*delr2
          DO j=1,nodd
             rgo(j)=hdelr2*xgo(j)+r0
             IF(ta > 0.)then
                zglo(j)=z1+(rgo(j)-rlr)*ta
             ELSE
                zglo(j)=z1+(rgo(j)-rll)*ta
             END IF
             zguo(j)=zglo(j)+drr*tabs
             dao(j)=drr*tabs
          END DO
          mut12=g_xmcc(rge,wge,zgle,zgue,dae,delr1,nevn,area_1e,&
               rgo,wgo,zglo,zguo,dao,delr2,nodd,area_2o) 
       ELSEif(tabs > tacrit)then           ! region 2 is a rectangle
          IF(ta > 0.)then
             delr2=rlr-rul
          ELSE
             delr2=rur-rll
          END IF
          hdelr2=.5_rq*delr2
          DO j=1,nodd
             rgo(j)=hdelr2*xgo(j)+r0
             zguo(j)=z2
             zglo(j)=z1
             dao(j)=dzz
          END DO
          mut12=g_xmcc(rge,wge,zgle,zgue,dae,delr1,nevn,area_1e,&
               rgo,wgo,zglo,zguo,dao,delr2,nodd,area_2o) 
       ELSE                           ! region 2 has zero-thickness
          mut12=0.                         
       END IF

       ! Region 2:

       ! Self-inductance:
       IF(tabs<tacrit .AND. mut12>0.)then ! region 2 is type-1 parallelogram
          DO i=1,nevn
             rge(i)=hdelr2*xge(i)+r0
             IF(ta > 0.)then
                zgle(i)=z1+(rge(i)-rlr)*ta
             ELSE
                zgle(i)=z1+(rge(i)-rll)*ta
             END IF
             zgue(i)=zgle(i)+drr*tabs
             dae(i)=drr*tabs
          END DO
          self2=g_xmcc(rge,wge,zgle,zgue,dae,delr2,nevn,area_2e,&
               rgo,wgo,zglo,zguo,dao,delr2,nodd,area_2o) 
       ELSEif(tabs > tacrit)then                ! region 2 is rectangle
          DO i=1,nevn
             rge(i)=hdelr2*xge(i)+r0
             zgue(i)=z2
             zgle(i)=z1
             dae(i)=dzz
          END DO
          self2=g_xmcc(rge,wge,zgle,zgue,dae,delr2,nevn,area_2e,&
               rgo,wgo,zglo,zguo,dao,delr2,nodd,area_2o) 
       ELSE
          self2=0.
       END IF
       area_e=area_e+area_2e
       area_o=area_o+area_2o

       ! Mutual inductance with region 3:
       IF(tabs > tacrit)then
          delr3=rur-rlr
          r03=rlr+.5_rq*delr3
       ELSE
          delr3=rur-rul
          IF(ta > 0.)then
             r03=rul+.5_rq*delr3
          ELSE
             r03=rll+.5_rq*delr3
          END IF
       END IF
       delr3=abs(delr3)
       hdelr3=.5_rq*delr3
       DO j=1,nodd
          rgo(j)=hdelr3*xgo(j)+r03
          IF(ta > 0.)then
             zglo(j)=z2+(rgo(j)-rur)*ta
             zguo(j)=z2
          ELSE
             zglo(j)=z1
             zguo(j)=z1+(rgo(j)-rlr)*ta
          END IF
          dao(j)=zguo(j)-zglo(j)
       END DO
       mut23=g_xmcc(rge,wge,zgle,zgue,dae,delr2,nevn,area_2e,&
            rgo,wgo,zglo,zguo,dao,delr3,nodd,area_3o) 
       ! Region 3

       ! Self-inductance:
       DO i=1,nevn
          rge(i)=hdelr3*xge(i)+r03
          IF(ta > 0.)then
             zgle(i)=z2+(rge(i)-rur)*ta
             zgue(i)=z2
          ELSE
             zgle(i)=z1
             zgue(i)=z1+(rge(i)-rlr)*ta
          END IF
          dae(i)=zgue(i)-zgle(i)
       END DO
       self3=g_xmcc(rge,wge,zgle,zgue,dae,delr3,nevn,area_3e,&
            rgo,wgo,zglo,zguo,dao,delr3,nodd,area_3o)
       area_e=area_e+area_3e
       area_o=area_o+area_3o 

       ! Mutual inductance with region 1:
       DO j=1,nodd
          rgo(j)=hdelr1*xgo(j)+r01
          IF(ta > 0.)then
             zglo(j)=z1
             zguo(j)=z1+(rgo(j)-rll)*ta
          ELSE
             zglo(j)=z2+(rgo(j)-rul)*ta
             zguo(j)=z2
          END IF
          dao(j)=zguo(j)-zglo(j)
       END DO
       mut31=g_xmcc(rge,wge,zgle,zgue,dae,delr3,nevn,area_3e,&
            rgo,wgo,zglo,zguo,dao,delr1,nodd,area_1o)

       ! Compute total self-inductance:

       xslf=(self1+self2+self3+2.*(mut12+mut23+mut31))/(area_e*area_o)

       IF(t_gauss_chck == 2)then  ! useful for debugging
          write(*,*)"   "
          write(*,*)"a1,a2: ",ang1,ang2
          write(*,*)"L's: ",self1,self2,self3
          write(*,*)"M's: ",mut12,mut23,mut31
          write(*,*)"rll,rlr,rul,rur: ",rll,rlr,rul,rur
          write(*,*)"ta,tacrit,drr*dzz: ",ta,tacrit,drr*t_dz
          write(*,*)"r0's: ",r01,r0,r03
          write(*,*)"delr's: ",delr1,delr2,delr3
          write(*,*)"rge: ",rge
          write(*,*)"zgle: ",zgle
          write(*,*)"zgue: ",zgue
          write(*,*)"dae: ",dae
          write(*,*)"area_e,area_o: ",area_e,area_o
          write(*,*)"area_1e,area_1o: ",area_1e,area_1o
          write(*,*)"area_2e,area_2o: ",area_2e,area_2o
          write(*,*)"area_3e,area_3o: ",area_3e,area_3o
       END IF

       return
    ELSE
       call errdetec("bad input angle(s) in xsind",1)
    END IF

  END FUNCTION g_xsind

  FUNCTION g_xmrr(a,r,z) RESULT(xmr)
    REAL(rq) :: a,r,z,z2,apr2,r12,r1,k2,ek,kme,pmk,m,xmr
    REAL(rq) :: c2,rf,rd,rj

    ! Mutual inductance between equivalent ideal end-rings of two solenoids.
    !
    ! xmrr = M(S,S)/MU0 = {z*M(S,L)/MU0 + (2/3)*a*r*r1*[K-(2/k**2-1)(K-E)]} 
    !
    ! Ref: M. W. Garrett, J. Appl. Phys 34, 2567 (1963), eqs(8)-(9). 
    ! This function is even in z and invariant under interchange of a, r,
    ! where z = vertical separation of the rings and a,r their radii.

    z2=z*z
    apr2=(a+r)**2
    r12=z2+apr2
    r1=sqrt(r12)
    k2=4._rq*a*r/r12
    m=1._rq-k2
    c2=-k2*r12/apr2
    ek=r_f(ZERO,m,1._rq)                  ! K(k2)
    kme=k2*r_d(ZERO,m,1._rq)*THIRD            ! K(k2)-E(k2)
    pmk=-c2*r_j(ZERO,m,1._rq,1._rq+c2)*THIRD  ! PI(k2)-K(k2)
    xmr=0.5_rq*z2*(r1*kme-pmk*(a-r)**2/r1)&
         +2._rq*THIRD*a*r*r1*(ek-(2._rq/k2-1._rq)*kme)  ! n.b. no factor MU0

  END function g_xmrr

  FUNCTION g_xmcc(r1, w1, zl1, zu1, da1, dr1, n1, a1, r2, w2, zl2, zu2, da2,& 
       dr2, n2, a2) RESULT(xmc)

    ! Evaluate the double integral over r needed to compute the (mutual)
    ! inductance of two coils, which may coincide if they use different
    ! Gauss points. The areas obtained by integrating da1 and da2 are
    ! returned in a1 and a2, respectively.
    ! This FUNCTION uses FUNCTION xmrr(a,r,z) to compute contributions
    ! from ideal solenoidal END-rings.
    ! This is an internal FUNCTION used only by FUNCTION xsind.

    INTEGER n1, n2, i, j 
    REAL(rq), DIMENSION(n1) :: r1, w1, zl1, zu1, da1
    REAL(rq), DIMENSION(n2) :: r2, w2, zl2, zu2, da2
    REAL(rq) sumi, sumj, a1, a2, integral, dr1, dr2, xmc

    sumi=0
    a1=0
    a2=0
    DO i=1,n1
       sumj=0
       DO j=1,n2
          sumj=sumj+w2(j)*(-g_xmrr(r1(i),r2(j),zu1(i)-zu2(j))&
                           +g_xmrr(r1(i),r2(j),zu1(i)-zl2(j))&
                           +g_xmrr(r1(i),r2(j),zl1(i)-zu2(j))&
                           -g_xmrr(r1(i),r2(j),zl1(i)-zl2(j)))
       END DO
       sumi=sumi+w1(i)*sumj
       a1=a1+da1(i)*w1(i)
    END DO
    integral=.5_rq*dr1*.5_rq*dr2*sumi
    DO j=1,n2
       a2=a2+da2(j)*w2(j)
    END DO
    a1=a1*.5_rq*dr1
    a2=a2*.5_rq*dr2
    xmc=integral
  END FUNCTION g_xmcc

  SUBROUTINE get_greens
    INTEGER :: ii,n,j,k,l,ll,l0,l3,l4,l5,l6 
    REAL(rq), DIMENSION(t_ncf) ::  ff,fcr,fcz,rmt
    IF(t_ncf==t_ncfo) RETURN
    t_pfim=0
    ii=1
    t_ncfo=t_ncf
    CALL remark("Calculating pfim")
    !      SELF-INDUCTANCES [uH]...
    DO n=1,t_nc
       t_pfim(n,n)=0.4_rq*PI*g_xsind(t_rc(n),t_zc(n),t_drc(n),t_dzc(n),&
            t_ac(n),t_ac2(n))
    END DO
    !       Add external inductance
    DO n=1,t_nc
       t_pfim(n,n)=t_pfim(n,n)+t_lextc(n)
    END DO

    !
    !     MUTUAL INDUCTANCES [uH]...
    ii=1
    DO k=2,t_nc
       l4=1
       l3=t_loop0(k-1)+1
       l5=t_loop0(k)
       rmt=0
       ll=t_loop0(k-1)
       DO l=l3,l5
          call mutual(t_rcmf,t_zcmf,t_rcmf(l),t_zcmf(l),ll,ff,fcr,fcz,ii)
          rmt(:ll)=rmt(:ll)+ff(:ll)*t_ccf(l)
       END DO
       rmt(:ll)=rmt(:ll)*t_ccf(:ll)
       DO j=1,k-1
          l6=t_loop0(j)
          t_pfim(j,k)=0.1_rq*TWOPI*SUM(rmt(l4:l6))/(t_cc(j)*t_cc(k))
          t_pfim(k,j)=t_pfim(j,k)
          l4=t_loop0(j)+1
       END DO
    END DO
    IF(t_nloop0p/=0) THEN ! Mutuals between coils and loops
       ii=3
       DO l=1,t_nloop0p
          l0=1
          call mutual_utils(t_rcf,t_zcf,t_rloop(l),t_zloop(l),ff,fcr,fcz,ii)
          ff=ff*t_ccf
          fcr=fcr*t_ccf
          fcz=fcz*t_ccf
          DO n=1,t_nc
             t_plim(n,l,1)=TWOPI*1.0e-3*SUM(ff(l0:t_loop0(n)))/t_cc(n)
             t_plim(n,l,2)=10.0_rq*SUM(fcr(l0:t_loop0(n)))/t_cc(n)
             t_plim(n,l,3)=10.0_rq*SUM(fcz(l0:t_loop0(n)))/t_cc(n)
             l0=t_loop0(n)+1
          END DO
       END DO
    END IF
  END SUBROUTINE get_greens

  SUBROUTINE grnfcnst
    USE teq_input_mod
    REAL(rq) ::  aa,bb,drr,dzz,rmt
    INTEGER kl,i,kb,jb,ncl,l1,nn,l2,ii,jj,l,l0

    kl=1
    IF(t_nsym<=1) kl=t_km/2+1

    CALL remark("Calculating Greens functions")
    IF (ALLOCATED(wr)) THEN
       IF(t_jmkm/=SIZE(wr)) THEN
          DEALLOCATE(wr,wv,wz,wrk0,wrk1,wrk2)
       END IF
    END IF
    IF (.not.ALLOCATED(wr)) THEN
       ALLOCATE(wr(t_jmkm),wv(t_jmkm),wz(t_jmkm))
       ALLOCATE(wrk0(t_jm,t_km),wrk1(t_jm,t_km),wrk2(t_jm,t_km))
    END IF

    i=0
    t_gp=0
    aa=0
    bb=0
    DO kb=kl,t_km
       DO jb=1,t_jm
          jj=(jb-1)*(jb-t_jm)*(kb-1)*(kb-t_km)
          IF(jj==0) THEN
             i=i+1
             CALL mutual_utils(t_rm,t_zm,i_r(jb),i_z(kb),wv,wr,wz,0)
             wv=wv/t_rm
             wrk0=RESHAPE(wv,(/t_jm,t_km/))
             drr=t_dr
             dzz=t_dz
             IF(jb==1 .AND. i_r(1)<t_dr/2.0_rq) THEN
                drr=i_r(1)/2.0_rq
             END IF
             wrk0(jb,kb)=2*g_xsind(i_r(jb),i_z(kb),drr,dzz,aa,bb)/i_r(jb)
             IF(t_nsym<=1) THEN
                t_gp(:,:kl-1,i)=wrk0(:,:kl-1)+wrk0(:,t_km:kl+1:-1)
                t_gp(:,kl,i)=wrk0(:,kl)
             ELSE
                t_gp(:,:,i)=wrk0
             END IF
          END IF
       END DO
    END DO 
    ncl=t_nc
    IF(t_nsym<=1) ncl=t_nc/2
    l1=1
    nn=0
    rmt=-1.0e-4_rq*t_dr*t_dz/FOURPI
    IF(t_nloop0p/=0) THEN
       DO i=1,t_nloop0p
          CALL mutual_utils(t_rm,t_zm,t_rloop(i),t_zloop(i),wv,wr,wz,3)
          t_gpl(:,i,1)=rmt*wv/t_rm*TWOPI*1.e-4_rq
          t_gpl(:,i,2)=rmt*wr/t_rm
          t_gpl(:,i,3)=rmt*wz/t_rm
       END DO
    END IF
    DO i=1,ncl
       wrk0=0
       wrk1=0
       wrk2=0
       l2=t_loop0(i)
       DO ii=l1,l2
          IF(t_iferro(i)==1) THEN
             nn=nn+1
             CALL mutual_utils(t_rm,t_zm,t_rcf(ii),t_zcf(ii),wv,wr,wz,3)
             wrk0=RESHAPE(wv,(/t_jm,t_km/))
             wrk1=RESHAPE(wr/t_rm,(/t_jm,t_km/))
             wrk2=RESHAPE(wz/t_rm,(/t_jm,t_km/))
          ELSE
             IF(ii==l2) nn=nn+1
             CALL mutual_utils(t_rm,t_zm,t_rcf(ii),t_zcf(ii),wv,wr,wz,3)
              wrk0=wrk0+RESHAPE(wv,(/t_jm,t_km/))*t_ccf(ii)/t_cc(i)
             wrk1=wrk1+RESHAPE(wr/t_rm,(/t_jm,t_km/))*t_ccf(ii)/t_cc(i)
             wrk2=wrk2+RESHAPE(wz/t_rm,(/t_jm,t_km/))*t_ccf(ii)/t_cc(i)
          END IF
          IF(t_iferro(i)==1 .OR. ii==l2) THEN
             IF(t_nsym<=1) THEN
                t_gc(:,:kl,nn)  =wrk0(:,:kl)+wrk0(:,t_km:kl:-1)
                t_gfbr(:,:kl,nn)=wrk1(:,:kl)+wrk1(:,t_km:kl:-1)
                t_gfbz(:,:kl,nn)=wrk2(:,:kl)+wrk2(:,t_km:kl:-1)
             ELSE
                t_gc(:,:,nn)  =wrk0
                t_gfbr(:,:,nn)=wrk1
                t_gfbz(:,:,nn)=wrk2
             END IF
          END IF
       END DO
       l1=l2+1
    END DO
  END SUBROUTINE grnfcnst

END MODULE greens_mod

SUBROUTINE mutual(rin,zin,rout,zout,nin,fl,br,bz,inum)
  USE sep_utils
  IMPLICIT NONE
  INTEGER, INTENT(in) :: nin,inum
  REAL(rq), DIMENSION(nin), INTENT(IN)  :: rin,zin
  REAL(rq), DIMENSION(nin), INTENT(OUT) :: fl,br,bz
  REAL(rq), INTENT(IN) :: rout,zout
  CALL mutual_utils(rin,zin,rout,zout,fl,br,bz,inum)
END SUBROUTINE mutual

! $Id: teq.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

MODULE teq_input_mod

  USE sep_math

  INTEGER,  POINTER :: t_lsrf,t_lelm,t_lflat,t_ifluxcord,t_nsym,&
       t_entropy_flag,t_filter_wp,t_filter_p,t_one_pow,t_mdpsi,t_ipp,t_ipf,&
       t_ipj,t_kedge,t_ircwt,t_bsph_flag,t_inv_eq,t_map,t_lhalo,t_lmax,&
       t_nprt59,t_npoly,t_logunit,t_jm,t_km,t_jmkm,t_mls,t_msrf,t_n4,t_n6,&
       t_nplates,t_nsegs,t_nsymo,t_ncallsf
  REAL(rq), POINTER :: t_btor,t_plcm,t_dphi00,t_dpsi00,t_splbdry,t_betaj,&
       t_qcelm,t_pcelm,t_scelm,t_qflat,t_qrat,t_scflat,t_prsx,t_psilm,t_aap,&
       t_nasp,t_nbsp,t_gsph,t_psph,t_xsph,t_epf,t_epp,t_npf,t_npp,t_psil,&
       t_psix,t_raxis,t_zaxis,t_alphac,t_alpha,t_gammac,t_deltac,t_delta,&
       t_deltadc,t_deltad,t_sigmac,t_sigma,t_tauc,t_thetac,t_theta,t_wvert,&
       t_ro,t_dr,t_dz,t_hsrf,t_rcur,t_zcur,t_plcm_gun,t_f_gun0,t_rn,t_rx,t_zn,&
       t_zx,t_m95,t_dn_criterion,t_spt_angle
  REAL(rq), DIMENSION(:), POINTER :: t_alfa,t_betp,t_asph,t_bsph,t_pefit,&
       t_fefit,t_rzsph,t_rxpr,t_zxpr,t_rapr,t_zapr,t_qsave,t_jtsave,&
       t_jparsave,t_ssave,t_psave,t_fsave,t_w,t_v,t_r,t_z,t_rwl,t_rwu,t_psi,&
       t_rls,t_zls
  REAL(rq), DIMENSION(:,:), POINTER :: t_rplate,t_zplate
  INTEGER,  DIMENSION(:), POINTER :: t_jwl,t_jwu
  LOGICAL,  POINTER :: t_fix_bound,t_use_halo

END MODULE teq_input_mod

MODULE teq_output_mod
  USE sep_math
  REAL(rq), TARGET :: t_rxpf,t_zxpf,t_rxpt,t_zxpt,t_pxpt,t_psih,t_dpsi0,&
       t_dphi0,t_fwall,t_plc,t_lamdagun,t_rgun=0,t_zgun,t_fgun,t_residj,&
       t_vltsnd(3),t_li(3),t_betap(3),t_betaps(3),t_lam(3),t_rstkpt(4),&
       t_zstkpt(4),t_dstkpt(4),t_bstkpt(4),t_rspt(4),t_zspt(4),&
       t_dspt(4),t_bspt(4),t_betae,t_betat,t_flxln,t_absflx,t_psisep,t_psipls,&
       t_helicity,t_xindf,t_slfnd,t_xlfnd,t_volume,t_surf,t_ctroy,t_qmerc,&
       t_placur,t_elongn,t_trianu,t_trianl,t_trian,t_t95,t_tl95,t_tu95,&
       t_trider,t_f95,t_p95,t_psi95,t_e95,t_q95,t_qmin,t_rhomin,t_qstar,&
       t_aspct,t_wpf,t_wpt,t_al,t_bpsqva,t_presva,t_pressa,t_betal,t_bpolsa,&
       t_ccdir
  INTEGER, TARGET :: t_nitt,t_nspt,t_nstkpts
  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET :: t_frsrf,t_fpsrf,t_qsrf,&
       t_rsqbp,t_jtsrf,t_rsqrf,t_rsqirf,t_jparsrf,t_susrf,t_cusrf,t_vpsrf,&
       t_srsrf,t_prsrf,t_pdsrf,t_rsrf,t_asrf,t_volsrf,t_qh,t_bsqrf,t_esrf,&
       t_tsrf,t_bpsrf,t_alsrf,t_risrf,t_psibar,t_phibar,t_psrf,t_vptor,&
       t_psiinv,t_psidinv,t_rhosrf,t_psidbar,t_rlimw,t_zlimw,t_tlimw,&
       t_plimw,t_crj,t_br,t_bz,t_bp,t_bt,t_bmod,t_pvec,t_psiw,t_tswpts,&
       t_tlsrf,t_tusrf,t_fldind,t_fttcsrf,t_brwpts,t_bzwpts
  INTEGER, DIMENSION(4), TARGET :: t_lstkpt(4)
  REAL(rq), DIMENSION(:,:,:), ALLOCATABLE, TARGET :: t_rlsd,t_zlsd

END MODULE teq_output_mod

MODULE teq_mod
  USE teq_input_mod
  USE teq_output_mod
  USE sep_separatrix
  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET :: t_c1srf,t_c4srf,t_c5srf,&
       t_r2bzrf,t_r4bp2rf,t_rm,t_zm,t_clj,t_psi00,t_psi01
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, TARGET :: t_pdls,t_mpoly,t_dpoly,&
       t_spoly,t_mpoli,t_dpoli,t_spoli,t_thhsrf
  REAL(rq), DIMENSION(:,:,:), POINTER ::t_rhosq
  INTEGER,  DIMENSION(:,:), ALLOCATABLE, TARGET :: t_lhsrf
  INTEGER, TARGET :: ioun7,ioun12,ioun13
  INTEGER, POINTER :: t_nprob
  REAL(rq), POINTER :: t_shotTime
  CHARACTER(len=16), POINTER :: t_shotName,t_site
  CHARACTER(len=80), POINTER :: t_note
  CHARACTER(len=40), POINTER :: t_probid,t_theader
  CHARACTER(len=8),  POINTER :: t_rundate,t_runtime,t_codetime
  CHARACTER(len=10), POINTER :: t_codedate
  CHARACTER(len=64), POINTER :: t_logname
  CHARACTER(len=3),  POINTER :: t_pkgname
  CHARACTER(len=48), POINTER :: t_gheader
  CHARACTER(len=20), POINTER :: t_aheader
  DATA ioun7 /7/, ioun12 /12/, ioun13 /13/

END MODULE teq_mod

MODULE teqGS_output_mod
  USE sep_math
  REAL(rq), TARGET :: t_psires,t_rbin,t_rbout,t_pfcse,t_pftse,t_pfcsi,t_pfcil,&
       t_error,t_resb,t_resid
  REAL(rq), DIMENSION(:),   ALLOCATABLE, TARGET :: t_br0p,t_bz0p,t_pfjp,&
       t_pfjc,t_pfjf,t_pfbc,t_pfbi,t_pfbo,t_pfbr,t_pfbz,t_pfhs,t_pfms,&
       t_pffr,t_pffz,t_pfil,t_pfse,t_pfe0,t_pfpsi, t_vlts2D,t_gloop,t_ccls,&
       t_rcs,t_zcs,t_ths
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, TARGET :: t_pfim,t_floop,t_ploop
  INTEGER, POINTER :: t_nbs
  INTEGER, TARGET :: t_kbfc=-2,t_ncircuit=-2,t_ngroup=-2,t_ncrmx=-2,&
       t_nczmx=-2,t_ifjx=-2,t_ifbx=-2,t_ncs=-2,t_jbdcir=-2
  INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: t_icc,t_loopm,t_loop0

END MODULE teqGS_output_mod

MODULE teqGS_input_mod
  USE sep_math
  REAL(rq), DIMENSION(:), POINTER :: t_rbd,t_tbd,t_zbd,t_rfbd,t_zfbd,t_psiwfc,&
       t_whtz,t_alfbd,t_rloop,t_zloop,t_sigloop,t_floop0,t_thloop,t_cc,t_rc,&
       t_zc,t_drc,t_dzc,t_ac,t_ac2,t_lextc,t_svec,t_rcase,t_zcase,t_drcase,&
       t_dzcase,t_rhc,t_rextc,t_pfps0,t_cc0,t_rxc,t_rlim,t_zlim,t_dlim
  INTEGER,  DIMENSION(:), POINTER :: t_nrc,t_nzc,t_iferro,t_ic,t_ix,t_iloop,&
       t_ict
  LOGICAL, POINTER :: t_crj_flag
  REAL(rq), DIMENSION(:,:), POINTER :: t_gdc
  REAL(rq), POINTER :: t_dt,t_thetat,t_ccoil,t_zocoil,t_rocoil,t_rbcoil,&
       t_elcoil,t_dcoil,t_qcoil,t_cnorm,t_crdn,t_acmin,t_magfac,t_bsat,&
       t_dsurf,t_almim,t_geomo,t_pfjx,t_pfbx,t_delc,t_pftd,t_pfahs,t_dfac,&
       t_dtofst,t_bbdu,t_bbdl,t_dbdu,t_dbdl,t_ebdu,t_ebdl,t_queu,t_quel,&
       t_alpcoilc,t_alpsphc,t_epsb,t_epsj,t_alpcoil,t_alpsph,t_vltf,t_rfix,&
       t_psires0,t_raxis0,t_zaxis0,t_cejima,t_plcx,t_rl,t_rb,t_betx,t_finit2,&
       t_el,t_elx,t_psil00,t_rxpt0,t_zxpt0
  INTEGER, POINTER :: t_nbd,t_nfbd,t_nbdl,t_nbdu,t_lgrn,t_kgreenc,t_ncplot,&
       t_nc,t_nloop,t_limw,t_nsymc,t_lcal,t_nitr,t_ierr1,t_nlim,t_lsph,t_nsph,&
       t_iflxc,t_ixpt,t_ncsym,t_irl,t_jaxis,t_kaxis,t_keqic,t_ifscl,t_ipscl,&
       t_ibdry,t_ni,t_nl,t_ixp,t_ixpo,t_initflx,t_ksave,t_lop0,t_int_flag,&
       t_gauss_even,t_gauss_odd,t_gauss_chck,t_lasteq,t_nfil,t_ngp,t_nfjx,&
       t_ncase,t_ncoil,t_liml,t_lasteqsav,t_nfbc,t_nmsc,t_jxp,t_kxp
  CHARACTER(len=8), DIMENSION(:), POINTER :: t_pfid
END MODULE teqGS_input_mod

MODULE teqGS_mod
  USE sep_utils
  USE teqGS_input_mod
  USE teqGS_output_mod
  IMPLICIT NONE
  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET :: t_rcf,t_zcf,t_ccf,t_drcf,&
       t_dzcf,t_rcmf,t_zcmf,t_aac,t_cmplas,t_cscl,t_cscl00,t_cscl01,t_cclsr,&
       t_pfpci,t_pfpc0,t_rcg,t_zcg,t_ccfd,t_ccmf,t_rgp,t_zgp,t_brgp,t_bzgp,&
       t_gplc
  INTEGER, DIMENSION(:), ALLOCATABLE, TARGET :: t_intc,t_jnt,t_knt,t_icn,&
       t_icf,t_icnf
  REAL(rq), DIMENSION(:,:),ALLOCATABLE, TARGET :: t_gcw,t_splw,t_rc4,t_zc4,&
       t_pbim,t_gsbr,t_gsbz
  REAL(rq), DIMENSION(:,:,:),ALLOCATABLE, TARGET :: t_gc,t_gfbr,t_gfbz,t_gpl,&
       t_gp,t_plim,t_gplw
  REAL(rq), DIMENSION(:),POINTER ::t_zbd00,t_rbd00,t_zbd01,t_rbd01,t_zfbd00,&
       t_rfbd00,t_zfbd01,t_rfbd01,t_psibd
  REAL(rq), TARGET :: t_prsx00,t_prsx01,t_rlimm,t_zlimm,t_scl
  INTEGER, POINTER :: t_ncf,t_jm0p,t_km0p,t_nc0b,t_nc0p,t_nloop0p
  INTEGER, POINTER :: t_ncfo,t_nsymco,t_ngpo
END MODULE teqGS_mod

MODULE teqPol_mod
  USE sep_math
  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET :: t_qrk,t_jrk,t_srk,t_frk,&
       t_trk,t_rrk,t_zrk,t_vrk,t_crk,t_p,t_pp,t_f,t_pff
  REAL(rq), DIMENSION(:,:), POINTER :: t_rork,t_aj
  REAL(rq), POINTER :: t_tpl,t_epsrk,t_epskrk,t_anun,t_alfa0,t_alfa1,t_alfa2,&
       t_qmax,t_inv_x
  INTEGER, POINTER :: t_nht,t_ns1,t_ijob,t_mesc,t_inv_k,t_inv_p,t_inv_flag
  LOGICAL, POINTER :: t_itimestep_converged,t_iter_bdry
  INTEGER, POINTER :: t_npo,t_ntet
END MODULE teqPol_mod
  
MODULE teqSurf_mod
  USE sep_math
  REAL(rq), DIMENSION(:,:), ALLOCATABLE,TARGET ::t_plsolo,t_plsoli,t_tlsolo,&
       t_tlsoli
  REAL(rq), DIMENSION(:),   ALLOCATABLE,TARGET :: t_rpts,t_zpts
  INTEGER, POINTER :: t_nsol,t_nsep,t_npri,t_lflux,t_jqm,t_jqd
END MODULE teqSurf_mod


MODULE teqSubs_mod
  USE sep_math
  IMPLICIT NONE

CONTAINS

  SUBROUTINE svd_Invert(asvd)
    USE sep_utils
    IMPLICIT NONE
    REAL(rq), DIMENSION(:, :), INTENT(INOUT) :: asvd
    REAL(rq) :: usvd(SIZE(asvd,1),SIZE(asvd,1)),ssvd(SIZE(asvd,1))
    REAL(rq) :: vsvd(SIZE(asvd,2),SIZE(asvd,2))
    REAL(rq) :: wsvd(SIZE(asvd,1)*SIZE(asvd,2))
    INTEGER :: msvd,nsvd

    CHARACTER*1 vt,u
    INTEGER info,l,i,j,k
    REAL(rq) err

    msvd=SIZE(asvd,1)
    nsvd=SIZE(asvd,2)
    usvd=0;vsvd=0
    vt="A"
    u ="A"
    err=errt_rq**0.75_rq ! d1mach(3)**.75_rq
    l=msvd*nsvd
    CALL gesvd(u,vt,msvd,nsvd,asvd,msvd,ssvd,usvd,msvd,vsvd,nsvd,wsvd,l,info)
    IF (msvd<=nsvd) THEN
       DO i=1,msvd
          IF (ssvd(i)>err*ssvd(1)) THEN
             ssvd(i)=1._rq/ssvd(i)
          ELSE
             ssvd(i)=0
          END IF
       END DO
       DO i=1,nsvd
          DO j=1,msvd
             asvd(j,i)=SUM(vsvd(:msvd,i)*ssvd(:msvd)*usvd(j,:msvd))
          END DO
       END DO
    ELSE
       DO i=1,nsvd
          IF (ssvd(i).gt.err*ssvd(1)) THEN
             ssvd(i)=1._rq/ssvd(i)
          ELSE
             ssvd(i)=0
          END IF
       END DO
       DO i=1,msvd
          DO j=1,nsvd
             asvd(i,j)=SUM(vsvd(:nsvd,i)*ssvd(:nsvd)*usvd(j,:nsvd))
          END DO
       END DO
    END IF

  END SUBROUTINE svd_Invert

  SUBROUTINE teqPol_allocate
    USE teqPol_mod
    INTEGER :: npoo,nteto
    DATA npoo/0/,nteto/0/
    IF(t_npo/=npoo) THEN
       IF(npoo/=0) DEALLOCATE(t_qrk,t_jrk,t_srk,t_frk,t_trk,t_rrk,t_zrk,t_vrk,&
            t_crk,t_f,t_pff,t_p,t_pp)
       ALLOCATE(t_qrk(t_npo),t_jrk(t_npo),t_srk(t_npo),t_frk(t_npo),&
            t_trk(t_npo),t_rrk(t_npo),t_zrk(t_npo),t_vrk(t_npo),t_crk(t_npo),&
            t_f(t_npo),t_pff(t_npo),t_p(t_npo),t_pp(t_npo))
       t_qrk=0
       t_jrk=0
       t_srk=0
       t_frk=0
       t_trk=0
       t_rrk=0
       t_zrk=0
       t_vrk=0
       t_crk=0
       t_f=0
       t_pff=0
       t_p=0
       t_pp=0
    END IF
    IF(t_npo/=npoo .OR. t_ntet/=nteto) THEN
       IF(npoo/=0 .AND. nteto/=0) DEALLOCATE(t_aj)
       ALLOCATE(t_aj(t_npo,t_ntet))
       t_aj=0
    END IF
    npoo=t_npo;nteto=t_ntet
  END SUBROUTINE teqPol_allocate

  SUBROUTINE teq_allocate
  USE teqPol_mod
  USE teq_mod
    INTEGER, SAVE :: msrfo,jmo,kmo,mlso,jmkmo,mlfo,lmaxo,npolyo
    INTEGER :: mlf,ls
    DATA msrfo /0/,jmo /0/,kmo /0/,jmkmo /0/,mlso/0/,mlfo/0/,lmaxo/0/

    mlf=t_mls*t_msrf
    IF(t_msrf/=msrfo .OR. t_npoly/=npolyo) THEN
       IF(msrfo/=0 .AND. npolyo/=0) DEALLOCATE(t_mpoly,t_dpoly,t_spoly,&
            t_mpoli,t_dpoli,t_spoli)
       ALLOCATE(t_mpoly(t_npoly,t_npoly),t_dpoly(t_msrf,t_npoly),&
            t_spoly(t_msrf,t_npoly),t_mpoli(t_npoly,t_npoly),&
            t_dpoli(t_msrf-1,t_npoly),t_spoli(t_msrf-1,t_npoly))
       t_mpoly=0
       t_dpoly=0
       t_spoly=0
       t_mpoli=0
       t_dpoli=0
       t_spoli=0
       npolyo=t_npoly
    END IF
    IF(t_msrf/=msrfo) THEN
       IF(msrfo/=0) DEALLOCATE(&
            t_frsrf,t_fpsrf,t_qsrf,t_rsqbp,t_jtsrf,t_jparsrf,t_susrf,t_cusrf,&
            t_vpsrf,t_srsrf,t_prsrf,t_pdsrf,t_rsrf,t_asrf,t_volsrf,t_c1srf,&
            t_c4srf,t_c5srf,t_esrf,t_tsrf,t_r2bzrf,t_r4bp2rf,t_rsqrf,t_bpsrf,&
            t_bsqrf,t_rsqirf,t_alsrf,t_risrf,t_qh,t_psibar,t_phibar,t_psrf,&
            t_vptor,t_psiinv,t_psidinv,t_rhosrf,t_psidbar,t_thhsrf,t_lhsrf,&
            t_tlsrf,t_tusrf,t_fttcsrf)
       ALLOCATE(&
            t_frsrf(t_msrf),t_fpsrf(t_msrf),t_qsrf(t_msrf),t_rsqbp(t_msrf),&
            t_jtsrf(t_msrf),t_jparsrf(t_msrf),t_susrf(t_msrf),t_cusrf(t_msrf),&
            t_vpsrf(t_msrf),t_srsrf(t_msrf),t_prsrf(t_msrf),t_pdsrf(t_msrf),&
            t_rsrf(t_msrf),t_asrf(t_msrf),t_volsrf(t_msrf),t_qh(t_msrf),&
            t_c1srf(t_msrf),t_c4srf(t_msrf),t_c5srf(t_msrf),t_esrf(t_msrf),&
            t_tsrf(t_msrf),t_r2bzrf(t_msrf),t_r4bp2rf(t_msrf),t_rsqrf(t_msrf),&
            t_bpsrf(t_msrf),t_bsqrf(t_msrf),t_rsqirf(t_msrf),t_alsrf(t_msrf),&
            t_risrf(t_msrf),t_psibar(t_msrf),t_phibar(t_msrf),t_psrf(t_msrf),& 
            t_vptor(t_msrf),t_psiinv(t_msrf),t_psidinv(t_msrf),t_rhosrf(t_msrf),&
            t_psidbar(t_msrf),t_thhsrf(t_msrf,2),t_lhsrf(t_msrf,2),&
            t_tlsrf(t_msrf),t_tusrf(t_msrf),t_fttcsrf(t_msrf))
       t_frsrf=0
       t_fpsrf=0
       t_qsrf=0
       t_rsqbp=0
       t_jtsrf=0
       t_jparsrf=0
       t_susrf=0
       t_cusrf=0
       t_vpsrf=0
       t_srsrf=0
       t_prsrf=0
       t_pdsrf=0
       t_rsrf=0
       t_asrf=0
       t_volsrf=0
       t_c1srf=0
       t_c4srf=0
       t_c5srf=0
       t_esrf=0
       t_tsrf=0
       t_r2bzrf=0
       t_r4bp2rf=0
       t_rsqrf=0
       t_bpsrf=0
       t_bsqrf=0
       t_rsqirf=0
       t_alsrf=0
       t_risrf=0
       t_qh=0
       t_psibar=0
       t_phibar=0
       t_psrf=0
       t_vptor=0
       t_psiinv=0
       t_psidinv=0
       t_rhosrf=0
       t_psidbar=0
       t_thhsrf=0
       t_lhsrf=0
       t_tlsrf=0
       t_tusrf=0
       t_fttcsrf=0
    END IF
       msrfo=t_msrf

    IF(mlf/=mlfo) THEN
       IF(mlfo/=0) DEALLOCATE(t_rlsd,t_zlsd)
       ALLOCATE(t_rlsd(t_mls,t_msrf,5),t_zlsd(t_mls,t_msrf,5))
       t_rlsd=0;t_zlsd=0
       mlfo=mlf
    END IF

    IF(t_mls/=mlso) THEN
       IF(mlso/=0) DEALLOCATE(t_tswpts,t_brwpts,t_bzwpts)
       ALLOCATE(t_tswpts(t_mls),t_brwpts(t_mls),t_bzwpts(t_mls))
       mlso=t_mls
       t_tswpts=(/(ls,ls=0,t_mls-1)/)*TWOPI/(t_mls-1)
       t_brwpts=cos(t_tswpts)
       t_bzwpts=sin(t_tswpts)
    END IF

    IF(t_jm/=jmo) THEN
       IF(jmo/=0) DEALLOCATE(t_fldind)
       ALLOCATE(t_fldind(t_jm))
       t_fldind=0
       jmo=t_jm
    END IF

    IF(t_jm*t_km/=jmkmo) THEN
       IF(jmkmo/=0) DEALLOCATE(&
            t_br,t_bz,t_bp,t_bt,t_bmod,t_crj,t_pvec,t_rm,t_zm,t_psiw,t_clj,&
            t_psi00,t_psi01)
       jmkmo=t_jm*t_km
       t_jmkm=jmkmo
       ALLOCATE(&
            t_crj(jmkmo),t_rm(jmkmo),t_zm(jmkmo),t_br(jmkmo),t_bz(jmkmo),&
            t_bp(jmkmo),t_bt(jmkmo),t_bmod(jmkmo),t_psiw(jmkmo),t_clj(jmkmo)&
            ,t_psi00(jmkmo),t_psi01(jmkmo),t_pvec(jmkmo))
       t_br=0
       t_bz=0
       t_bp=0
       t_bt=0
       t_bmod=0
       t_crj=0
       t_pvec=0
       t_rm=0
       t_zm=0
       t_psiw=0
       t_clj=0
       t_psi00=0
       t_psi01=0
    END IF
    IF(t_lmax/=lmaxo) THEN
       IF(lmaxo/=0) DEALLOCATE(t_pdls,t_rlimw,t_zlimw,t_tlimw,t_plimw)
       lmaxo=t_lmax
       ALLOCATE(t_pdls(t_lmax,8),t_rlimw(t_lmax),t_zlimw(t_lmax),&
            t_tlimw(t_lmax),t_plimw(t_lmax))
       t_pdls=0
       t_rlimw=0
       t_zlimw=0
       t_tlimw=0
       t_plimw=0
       lmaxo=t_lmax
    END IF
  END SUBROUTINE teq_allocate

  SUBROUTINE teqSurf_allocate
    USE teqSurf_mod
    USE teq_input_mod, ONLY : t_nsym,t_mls

    integer :: sz1, sz2

    sz1 = 0; sz2 = 0
    if (allocated(t_plsolo)) then
       sz1 = size(t_plsolo,1)
       sz2 = size(t_plsolo,2)
    end if
    IF ((sz1/=t_nsym .OR. sz2/=t_nsol) .AND. t_nsol/=0) THEN
       IF(ALLOCATED(t_plsolo)) DEALLOCATE(t_plsolo,t_plsoli,t_tlsolo,t_tlsoli)
       ALLOCATE(t_plsolo(t_nsym,t_nsol),t_plsoli(t_nsym,t_nsol),&
            t_tlsolo(t_nsym,t_nsol),t_tlsoli(t_nsym,t_nsol))
       t_plsolo=0
       t_plsoli=0
       t_tlsolo=0
       t_tlsoli=0
    END IF
    sz1 = 0; if (allocated(t_rpts)) sz1 = size(t_rpts)
    IF (sz1/=t_mls) THEN
       IF(ALLOCATED(t_rpts)) DEALLOCATE(t_rpts,t_zpts)
       ALLOCATE(t_rpts(t_mls),t_zpts(t_mls))
       t_rpts=0
       t_zpts=0
    END IF
  END SUBROUTINE teqSurf_allocate

  SUBROUTINE teqGS_allocate_output
    USE teqGS_mod
    IMPLICIT NONE
    INTEGER, SAVE :: nco,ngroupo
    DATA nco/0/,ngroupo/-1/

    IF(t_nc/=nco) THEN
       IF(nco/=0) DEALLOCATE(t_cmplas,t_cscl,t_ccls,t_cscl00,t_cscl01,t_cclsr,&
            t_pfjp,t_pfjc,t_pfjf,t_pfbc,t_pfbi,t_pfbo,t_pfbr,t_pfbz,t_pfhs,&
            t_pfms,t_pffr,t_pffz,t_pfil,t_pfse,t_pfe0,t_pfpsi,t_vlts2D,t_rc4,&
            t_zc4,t_icc,t_loopm,t_loop0)
       ALLOCATE(t_cmplas(t_nc),t_cscl(t_nc),t_ccls(0:t_nc),t_cscl00(t_nc),&
            t_cscl01(t_nc),t_cclsr(t_nc),t_pfjp(t_nc),t_pfjc(t_nc),t_pfjf(t_nc),&
            t_pfbc(t_nc),t_pfbi(t_nc),t_pfbo(t_nc),t_pfbr(t_nc),t_pfbz(t_nc),&
            t_pfhs(t_nc),t_pfms(t_nc),t_pffr(t_nc),t_pffz(t_nc),t_pfil(t_nc),&
            t_pfse(t_nc),t_pfe0(t_nc),t_pfpsi(t_nc),t_vlts2D(t_nc), t_rc4(4,t_nc),&
            t_zc4(4,t_nc),t_icc(t_nc),t_loopm(t_nc),t_loop0(t_nc))

       t_cmplas=0
       t_cscl=0
       t_ccls=0
       t_cscl00=0
       t_cscl01=0
       t_cclsr=0
       t_pfjp=0
       t_pfjc=0
       t_pfjf=0
       t_pfbc=0
       t_pfbi=0
       t_pfbo=0
       t_pfbr=0
       t_pfbz=0
       t_pfhs=0
       t_pfms=0
       t_pffr=0
       t_pffz=0
       t_pfil=0
       t_pfse=0
       t_pfe0=0
       t_pfpsi=0
       t_vlts2D=0
       t_rc4=0
       t_zc4=0
       t_icc=0
       t_loopm=0
       t_loop0=0
       nco=t_nc
    END IF
    IF(ngroupo/=t_ngroup) THEN
       IF(ngroupo/=-1) DEALLOCATE(t_pfpci,t_pfpc0,t_rcg,t_zcg)
       ALLOCATE(t_pfpci(0:t_ngroup),t_pfpc0(0:t_ngroup),t_rcg(0:t_ngroup),&
            t_zcg(0:t_ngroup))
       t_pfpci=0
       t_pfpc0=0
       t_rcg=0
       t_zcg=0
       ngroupo=t_ngroup
    END IF
  END SUBROUTINE teqGS_allocate_output

  SUBROUTINE teq_allocate_greens
    USE teqGS_mod
    IMPLICIT NONE
    INTEGER :: n1,n2,n3

    n1 = 0; n2 = 0
    if (allocated(t_plim)) then
       n1 = size(t_plim,1); n2 = size(t_plim,2)
    end if
    n3=t_nc0p*t_nloop0p
    IF(n3/=0 .AND. (n1/=t_nc0p .OR. n2/=t_nloop0p)) THEN
       IF(n1>1 .AND. n2>1) DEALLOCATE(t_plim)
       IF(t_nc0p/=0 .AND. t_nloop0p/=0)ALLOCATE(t_plim(t_nc0p,t_nloop0p,3))
       t_plim=0
    END IF

    n1 = 0; if (allocated(t_pfim)) n1 = size(t_pfim,1)
    n3=t_nc
    IF(n3/=0 .AND. n1/=t_nc) THEN
       IF(n1>1) DEALLOCATE(t_pfim)
       ALLOCATE(t_pfim(t_nc,t_nc))
       t_pfim=0
    END IF

    n1 = 0; if (allocated(t_pbim)) n1 = size(t_pbim,1)
    n3=t_ncsym
    IF(n3/=0 .AND. n1/=t_ncsym) THEN
       IF(ALLOCATED(t_pbim)) DEALLOCATE(t_pbim)
       IF(t_ncsym/=0) ALLOCATE(t_pbim(t_ncsym,t_ncsym))
       t_pbim=0
    END IF

    n1 = 0; if (allocated(t_rcf)) n1 = size(t_rcf)
    n3=t_ncf
    IF(n3/=0 .AND. n1/=t_ncf) THEN
       IF(n1>1) DEALLOCATE(t_rcf,t_zcf,t_ccf,t_drcf,t_dzcf,t_rcmf,t_zcmf,&
            t_intc,t_jnt,t_knt,t_ccfd,t_ccmf,t_aac,t_rcs,t_zcs,t_ths,t_icf,&
            t_icnf,t_icn)
       ALLOCATE(t_rcf(t_ncf),t_zcf(t_ncf),t_drcf(t_ncf),t_dzcf(t_ncf),&
            t_ccf(t_ncf),t_rcmf(t_ncf),t_zcmf(t_ncf),t_intc(t_ncf),&
            t_jnt(t_ncf),t_knt(t_ncf),t_ccfd(t_ncf),t_ccmf(t_ncf),&
            t_aac(t_ncf),t_rcs(t_ncf),t_zcs(t_ncf),t_ths(t_ncf),t_icf(t_ncf),&
            t_icnf(t_ncf),t_icn(t_ncf))
       t_rcf=0
       t_zcf=0
       t_ccf=0
       t_drcf=0
       t_dzcf=0
       t_rcmf=0
       t_zcmf=0
       t_intc=0
       t_jnt=0
       t_knt=0
       t_ccfd=0
       t_ccmf=0
       t_aac=0
       t_rcs=0
       t_zcs=0
       t_ths=0
       t_icf=0
       t_icnf=0
       t_icn=0

    END IF

    n1 = 0; if (allocated(t_gloop)) n1 = size(t_gloop)
    n3=t_nloop
    IF(n3/=0 .AND. n1/=t_nloop) THEN
       IF(n1>1) DEALLOCATE(t_floop,t_ploop,t_gloop)
       ALLOCATE(t_floop(t_nloop,3),t_ploop(t_nloop,3),t_gloop(t_nloop))
       t_floop=0
       t_ploop=0
       t_gloop=0
    END IF

    n1 = 0; n2 = 0
    if (allocated(t_gc)) then
       n1=SIZE(t_gc,1)*SIZE(t_gc,2);n2=SIZE(t_gc,3)
    end if
    n3=t_jm0p*t_km0p*t_nc0p
    IF(n3/=0 .AND. (n1/=t_jm0p*t_km0p .OR. n2/=t_nc0p)) THEN
       IF(n1>1 .AND. n2>1) DEALLOCATE(t_gc,t_gfbr,t_gfbz)
       ALLOCATE(t_gc(t_jm0p,t_km0p,t_nc0p),t_gfbr(t_jm0p,t_km0p,t_nc0p),&
            t_gfbz(t_jm0p,t_km0p,t_nc0p))
       t_gc=0
       t_gfbr=0
       t_gfbz=0
    END IF
    n2 = 0; if (allocated(t_br0p)) n2 = size(t_br0p)
    n3=t_nc0p
    IF(n3/=0 .AND. n2/=t_nc0p) THEN
       IF(n2>1) DEALLOCATE(t_br0p,t_bz0p)
       ALLOCATE(t_br0p(t_nc0p),t_bz0p(t_nc0p))
       t_br0p=0
       t_bz0p=0
    END IF
    n2 = 0; if (allocated(t_gp)) n2 = size(t_gp,3)
    n3=t_jm0p*t_km0p*t_nc0b
    IF(n3/=0 .AND. (n1/=t_jm0p*t_km0p .OR. n2/=t_nc0b)) THEN
       IF(n1>1 .AND. n2>1) DEALLOCATE(t_gp)
       ALLOCATE(t_gp(t_jm0p,t_km0p,t_nc0b))
       t_gp=0
    END IF
    n2 = 0; if (allocated(t_gpl)) n2 = size(t_gpl,2)
    n3=t_jm0p*t_km0p*t_nloop0p
    IF(n3/=0 .AND. (n1/=t_jm0p*t_km0p .OR. n2/=t_nloop0p)) THEN
       IF(n1>1 .AND. n2>1) DEALLOCATE(t_gpl)
       ALLOCATE(t_gpl(t_jm0p*t_km0p,t_nloop0p,3))
       t_gpl=0
    END IF
      
    n1 = 0; n2 = 0
    if (allocated(t_gcw)) then
       n1=SIZE(t_gcw,1);n2=SIZE(t_gcw,2)
    end if
    n3=t_nsph*t_nc0p
    IF(n3/=0 .AND. (n1/=t_nsph .OR. n2/=t_nc0p)) THEN
       IF(n1>1 .AND. n2>1) DEALLOCATE(t_gcw)
       ALLOCATE(t_gcw(t_nc0p,0:t_nsph))
       t_gcw=0
    END IF
    
    n1 = 0; n2 = 0
    if (allocated(t_gplw)) then
       n1=SIZE(t_gplw,1);n2=SIZE(t_splw,2)
    end if
    n3=t_nloop0p*t_nsph
    IF(n3/=0 .AND. (n1/=t_nloop0p .OR. n2/=t_nsph)) THEN
       IF(n1>1 .AND. n2>1) DEALLOCATE(t_gplw,t_splw)
       ALLOCATE(t_gplw(t_nloop0p,0:t_nsph,3),t_splw(t_nloop0p+1,t_nsph))
       t_gplw=0
       t_splw=0
    END IF
    n3=t_nsph
    IF(n3/=0 .AND. n2/=t_nsph) THEN
       IF(n2>1) DEALLOCATE(t_gplc)
       ALLOCATE(t_gplc(0:t_nsph))
       t_gplc=0
    END IF
    
    n1 = 0; if (allocated(t_rgp)) n1 = size(t_rgp)
    n3=t_nbs
    IF(n3/=0 .AND. n1/=t_nbs) THEN
       IF(ALLOCATED(t_rgp)) DEALLOCATE(t_rgp,t_zgp,t_brgp,t_bzgp)
       ALLOCATE(t_rgp(t_nbs),t_zgp(t_nbs),t_brgp(t_nbs),t_bzgp(t_nbs))
       t_rgp=0
       t_zgp=0
       t_brgp=0
       t_bzgp=0
    END IF
    n2 = 0; if (allocated(t_gsbr)) n2 = size(t_gsbr,1)
    n3=t_nc0p*t_nbs
    IF(n3/=0 .AND. (n1/=t_nbs .OR. n2/=t_nc0p)) THEN
       IF(ALLOCATED(t_gsbr)) DEALLOCATE(t_gsbr,t_gsbz)
       ALLOCATE(t_gsbr(t_nc0p,t_nbs),t_gsbz(t_nc0p,t_nbs))
       t_gsbr=0
       t_gsbz=0
    END IF

  END SUBROUTINE teq_allocate_greens
  
  SUBROUTINE t_stretch(jsrf,psill,psixx)
    USE teq_mod
    REAL(rq), INTENT(IN) ::  psill,psixx
    INTEGER, INTENT(IN) :: jsrf
    REAL(rq), SAVE :: hsrf_
    INTEGER, SAVE :: jsrf_=-999,msrf_=-999,inv_=-999
    INTEGER :: ls

    IF(jsrf/=jsrf_ .OR. t_msrf/=msrf_ .OR. t_inv_eq/=inv_ .OR. t_hsrf/=hsrf_) &
         THEN
       jsrf_=jsrf
       msrf_=t_msrf
       inv_=t_inv_eq
       hsrf_=t_hsrf
       CALL str_tch(jsrf,t_rhosrf,t_psidbar,t_psiinv,t_psidinv,t_hsrf)
    END IF
    t_psrf=psixx+(psill-psixx)*t_rhosrf
    t_psrf(t_msrf)=psill
    t_dpsi0=psill-psixx
    IF(t_ifluxcord==-1) THEN
       t_phibar=t_rhosrf
    ELSE
       t_psibar=t_rhosrf
    END IF
    t_tswpts=(/(ls,ls=0,t_mls-1)/)*TWOPI/(t_mls-1)
  END SUBROUTINE t_stretch

  SUBROUTINE str_tch(js,ds,dsd,di,did,aa)
    INTEGER, INTENT(IN) :: js
    REAL(rq), INTENT(IN) :: aa
    REAL(rq), DIMENSION(:), INTENT(OUT) :: ds,dsd,di,did
    REAL(rq) :: a,d,ee,b,bb
    INTEGER ms,ls,j,k
    ms=SIZE(ds)
    ds=(/(ls,ls=0,ms-1)/)/(ms-1.0_rq)
    di=((/(ls,ls=0,ms-1)/)-0.5_rq)/(ms-1.0_rq)
    did(:ms)=1
    dsd(:ms)=1
    di(1)=0
    did(1)=0.5_rq
    !     Range set by aa
    IF(aa<0) THEN
       ds=(ds-aa)/(1-2*aa)
       di=(di-aa)/(1-2*aa)
       dsd=1/(1-2*aa)
       did=1/(1-2*aa)
    ELSEIF(aa>0 .AND. aa<1) THEN
       a=(2*aa-1)/(1-aa)
       dsd=(1+a)/(1+a*ds)**2
       did=(1+a)/(1+a*di)**2
       ds =(1+a)*ds/(1+a*ds)
       di =(1+a)*di/(1+a*di)
    END IF
    IF(js>11) THEN
       j=js/10
       k=js-10*j
       a=j;b=k
       d=b**(a/(a+b))
    END IF
    IF(js== 0 .OR. js== 11 .OR. js == -11) THEN  !   doesn't stretch
       did=1
       dsd=1
    ELSEIF(js == -1 .OR. js== -22) THEN !  stretched at both ends with sin^2
       dsd=PI2*dsd*sin(Pi*ds)
       did=PI2*did*sin(Pi*di)
       ds=(sin(PI2*ds))**2
       di=(sin(PI2*di))**2
    ELSEIF(js == -21) THEN  ! stretches on axis (quadratic)
       dsd=PI2*dsd*sin(PI2*ds)
       did=PI2*did*sin(PI2*di)
       ds=1-cos(PI2*ds)
       di=1-cos(PI2*di)
    ELSEIF(js == -12) THEN  ! stretches on edge (quadratic)
       dsd=PI2*dsd*cos(PI2*ds)
       did=PI2*did*cos(PI2*di)
       ds=sin(PI2*ds)
       di=sin(PI2*di)
    ELSEIF(js == -23) THEN  ! stretches at both ends but now cubic at edge
       dsd=0.75_rq*PI2*dsd*(sin(3*PI2*ds)+sin(PI2*ds))
       did=0.75_rq*PI2*did*(sin(3*PI2*di)+sin(PI2*di))
       ds=1-0.25_rq*cos(3*PI2*ds)-0.75_rq*cos(PI2*ds)
       di=1-0.25_rq*cos(3*PI2*di)-0.75_rq*cos(PI2*di)
    ELSEIF(js == -32) THEN  ! stretches at both ends but now cubic at axis
       dsd=0.75_rq*PI2*dsd*(cos(PI2*ds)-cos(3*PI2*ds))
       did=0.75_rq*PI2*did*(cos(PI2*di)-cos(3*PI2*di))
       ds=0.75_rq*sin(PI2*ds)-0.25_rq*sin(3*PI2*ds)
       di=0.75_rq*sin(PI2*di)-0.25_rq*sin(3*PI2*di)
    ELSEIF(js == -33) THEN ! stretches at both ends cubically
       dsd=dsd*(1-cos(TWOPI*ds))
       did=did*(1-cos(TWOPI*di))
       ds=ds-sin(TWOPI*ds)/TWOPI
       di=di-sin(TWOPI*di)/TWOPI
    ELSE ! stretches with powers: x**j,(1-x)**k near the boundaries with
       !the same coefficients which accounts for the d dendence.
       ds=ds/(d+(1-d)*ds)
       di=di/(d+(1-d)*di)
       dsd=dsd*d/(d+(1-d)*ds)**2
       did=did*d/(d+(1-d)*di)**2
       IF(k/=1) THEN
          ds=1-ds
          di=1-di
          dsd=k*dsd*ds**(k-1)
          did=k*did*di**(k-1)
          ds=1-ds**k
          di=1-di**k
       END IF
       IF(j/=1) THEN
          dsd=j*dsd*ds**(j-1)
          did=j*did*di**(j-1)
          ds=ds**j
          di=di**j
       END IF
    END IF
    IF(aa<0) THEN
       ee=ds(1)
       bb=ds(ms)-ee
       ds=(ds-ee)/bb
       dsd=dsd/bb
       di=(di-ee)/bb
       did=did/bb
    END IF
    ds(1)=0
    ds(ms)=1
  END SUBROUTINE str_tch

END MODULE teqSubs_mod

! $Id: gradsh.f90,v 1.2 2007/07/23 16:00:57 meyer Exp $

MODULE gradsh_mod

  USE inv_mod
  USE teqGS_mod
  USE teqSubs_mod, only : svd_Invert,t_stretch

  IMPLICIT NONE

  REAL(rq), PRIVATE :: zgplc(0:4),fcr,fcz,fcrr,fczz,rsk(2),rump,zump,gamm,&
       zpl
  INTEGER,  PRIVATE :: lfbd,ngrup,jsvd,jbd,jbdrl,jbdr,jbdz,jbdvltf,jbdaxis,&
       npdesol,kim,nsvd,lsvd,ibcntrl,msvd,jbig,jbdxr,jbdxz
  INTEGER,  DIMENSION(:), ALLOCATABLE, PRIVATE :: jlim
  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE :: evec,rvec,dvec,zvec,onec,&
       psia,psib,zsvd,vbcp,rcls,zcls,psir,rlo,rup,rdi,bda,bdb,bdc,bdd
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, PRIVATE :: gmatfbd,wk,umat,psiv,&
       asvd,pfbd
  REAL(rq), DIMENSION(:,:,:), ALLOCATABLE, PRIVATE :: gmat
  REAL(rq), DIMENSION(:,:), ALLOCATABLE :: amat,bmat
  REAL(rq), DIMENSION(:), ALLOCATABLE :: avec
  REAL(rq) :: x_l,a_ll,s_l,d_l,q_l,a_lmax,a_ln
  DATA lsvd/0/,ibcntrl/0/

CONTAINS
  
  SUBROUTINE gs_bndpsi(kalc)
    !
    !     Compute a new boundary condition given a current
    !     density, crj, on the 2d mesh, and compute the error, resb.
    !

    REAL(rq) :: bnrm,cof,ww(t_jm,t_km0p)
    INTEGER kalc,na,kb,jb,nbu,n,kl,k,j,lb,jko
    SAVE jko
    IF(jko/=2*(t_jm+t_km)) THEN
       IF(jko/=0) DEALLOCATE(psia,psib)
       jko=2*(t_jm+t_km)
       ALLOCATE(psia(jko),psib(jko))
    END IF
    IF(t_int_flag<=0) THEN
       wk(:,1)=t_psiw
       wk(:,2)=t_psi
    ELSE
       wk(:,1)=0
       wk(:,2)=t_psi-t_psiw
    END IF
    t_resb=0.
    bnrm=0.
    cof=-t_dr*t_dz/FOURPI
    IF(kalc==0) return
    IF(t_nsym==2) THEN
       na=1
       DO kb=1,t_km
          DO jb=1,t_jm
             lb=(jb-1)*(jb-t_jm)*(kb-1)*(kb-t_km)
             IF(lb==0) THEN
                nbu=(kb-1)*t_jm+jb
                psia(na)=wk(nbu,2)
                IF(t_kgreenc==1) THEN ! used stored value
                   ww=t_gp(:,:,na)
                   psib(na)=cof*sumxpy(ww,t_crj,t_jmkm)+wk(nbu,1)
                ELSE
                   psib(na)=g_flxp(t_r(jb),t_z(kb))+wk(nbu,1)
                END IF
                bnrm=bnrm+abs(psib(na))
                t_resb=t_resb+abs(psib(na)-psia(na))
                wk(nbu,2)=gamm*psia(na)+(1.-gamm)*psib(na)
                na=na+1
             END IF
          END DO
       END DO
    ELSE
       !     
       !     symmetric about t_z=0 case
       !
       kl=t_km/2+1
       IF(kalc==0) return
       na=1
       DO kb=kl,t_km
          DO jb=1,t_jm
             lb=(jb-1)*(jb-t_jm)*(kb-1)*(kb-t_km)
             IF(lb==0) THEN
                nbu=(kb-1)*t_jm+jb
                psia(na)=wk(nbu,2)
                IF(t_kgreenc==1) THEN ! used stored values
                   ww(:,:)=t_gp(:,:,na)
                   psib(na)=cof*sumxpy(ww,t_crj,t_jm*kl)+wk(nbu,1)
                ELSE
                   psib(na)=g_flxp(t_r(jb),t_z(kb))+wk(nbu,1)
                END IF
                bnrm=bnrm+abs(psib(na))
                t_resb=t_resb+abs(psib(na)-psia(na))
                wk(nbu,2)=gamm*psia(na)+(1.-gamm)*psib(na)
                na=na+1
             END IF
          END DO
       END DO
       psiv=RESHAPE(wk(:,2),(/t_jm,t_km/))
       DO k=1,kl-1
          DO j=1,t_jm
             psiv(j,k)=psiv(j,t_km+1-k)
          END DO
       END DO
       wk(:,2)=RESHAPE(psiv,(/t_jmkm/))
    END IF ! symmetry

    IF(t_int_flag<=0) THEN
       t_psi=wk(:,2)
    ELSE
       t_psi=wk(:,2)+t_psiw
    END IF
    IF(bnrm==0)CALL errdetec("Fatal: bnrm = 0 in bndpsi",1)
    t_resb=t_resb/bnrm
  END SUBROUTINE gs_bndpsi

  SUBROUTINE gs_clcalc
    REAL(rq) :: a2,dr1,dr2,dz1,dz2
    INTEGER n,nn,j,k,kstart,klower,nlower
    t_clj=0
    IF(t_int_flag==1) RETURN
    DO nn=1,t_ncf
       IF(t_intc(nn)==1) THEN
          a2 = t_dr*t_dz
          j = t_jnt(nn)
          k = t_knt(nn)
          n = (k - 1)*t_jm + j
          dr1 = t_rcf(nn) - t_r(j)
          dr2 = t_r(j + 1) - t_rcf(nn)
          dz1 = t_zcf(nn) - t_z(k)
          dz2 = t_z(k + 1) - t_zcf(nn)
          t_clj(n) = t_clj(n) + t_ccf(nn)*t_r(j)*dr2*dz2/a2
          t_clj(n + 1) = t_clj(n + 1) + t_ccf(nn)*t_r(j + 1)*dr1*dz2/a2
          t_clj(n + t_jm) = t_clj(n + t_jm) + t_ccf(nn)*t_r(j)*dr2*dz1/a2
          t_clj(n + t_jm + 1) = t_clj(n + t_jm + 1) + t_ccf(nn)*t_r(j + 1)*&
               dr1*dz1/a2
       END IF
    END DO
    t_clj=-t_clj*FOURPI*1.0e+05_rq/t_dr/t_dz
    IF(t_nsym>=2) RETURN
    kstart = t_km/2 + 2
    DO k=kstart,t_km
       DO j=1,t_jm
          klower = t_km - k + 1
          nlower = (klower - 1)*t_jm + j
          n = (k - 1)*t_jm + j
          t_clj(nlower) = t_clj(n)
       END DO
    END DO
  END SUBROUTINE gs_clcalc

  SUBROUTINE gs_curcal(ncal)
    !
    !     compute delta-I/I for variable-current coils ( ic(j) not 0 ).
    !     constraints controlled by nbd,rbd,zbd, vltf,rl,cejima,ifxc.
    !     minimization options controlled by ircwt
    !
    INTEGER, INTENT(INOUT) :: ncal
    REAL(rq) :: pds(8),ff,vlts,aaa,fcrz
    INTEGER j,jrwct,n,i,k,isw,l,nn,jer,kk,nloo,l0,l1,ier,n1
    include "debug.i"

    ier=0
    n1=0
    IF(ALLOCATED(evec)) THEN
       n1=SIZE(evec)
    END IF
    IF(n1/=t_nc) THEN
       IF(ALLOCATED(evec)) DEALLOCATE(evec,rvec,dvec,zvec,onec,vbcp,rcls,zcls)
       ALLOCATE(evec(t_nc),rvec(0:t_nc),dvec(t_nc),zvec(0:t_nc),onec(0:t_nc),&
            vbcp(t_nc),rcls(t_nc),zcls(t_nc))
       vbcp = 0.0_rq ! Temporary fix, LDP will fix properly later. JAC 05/19/05
    END IF
    rcls=t_rc*100;zcls=t_zc*100
    n1=0
    IF(ALLOCATED(pfbd)) THEN
       n1=SIZE(pfbd,1)
    END IF
    IF(n1/=t_nfbd .AND. t_nfbd/=0) THEN
       IF(ALLOCATED(pfbd)) DEALLOCATE(pfbd)
       ALLOCATE(pfbd(t_nfbd,8))
    END IF
    n1=0
    IF(ALLOCATED(gmat)) THEN
       n1=SIZE(gmat,1)
    END IF
    IF(t_ngroup/=0 .AND. n1/=t_ngroup) THEN
       IF(ALLOCATED(gmat)) DEALLOCATE(gmat)
       ALLOCATE(gmat(t_ngroup,t_ngroup,5))
    END IF
    n1=0
    IF(ALLOCATED(gmatfbd)) THEN
       n1=SIZE(gmatfbd,1)*SIZE(gmatfbd,2)
    END IF
    IF(n1/=t_nfbd*t_ngroup .AND. t_nfbd*t_ngroup/=0) THEN
       IF(ALLOCATED(gmatfbd)) DEALLOCATE(gmatfbd)
       ALLOCATE(gmatfbd(t_nfbd,t_ngroup))
    END IF
    n1=0
    IF(ALLOCATED(umat)) THEN
       n1=SIZE(umat,1)*SIZE(umat,2)
    END IF
    IF(n1/=(t_nc+1)*(t_ngroup+2) .AND. t_ngroup/=0) THEN
       IF(ALLOCATED(umat)) DEALLOCATE(umat)
       ALLOCATE(umat(0:t_nc,0:t_ngroup+1))
    END IF
    n1=0
    IF(ALLOCATED(jlim)) THEN
       n1=SIZE(jlim)
    END IF
    IF(n1/=t_nlim .AND. t_nlim/=0) THEN
       IF(ALLOCATED(jlim)) DEALLOCATE(jlim)
       ALLOCATE(jlim(t_nlim))
    END IF
    DO j=1-iABS(t_lsph),t_nsph
       zgplc(j)=t_gplc(j)
    END DO

    jrwct=0
    t_ccls=0
    onec=0
    rvec=0
    zvec=0
    dvec=0
    lfbd=0
    ngrup=t_ngroup
    IF(t_ircwt==9) ngrup=t_ngroup-t_nsph-iabs(t_lsph)
    DO n=1,t_nfbd
       IF(t_alfbd(n)/=0) THEN
	  lfbd=1
          EXIT
       END IF
    END DO
    DO j=1,t_nc
       IF(t_ict(j)==0) THEN
          t_ccls(t_ic(j))=t_ccls(t_ic(j))+t_cc(j) ! parallel
       ELSE
          t_ccls(t_ic(j))=t_cc(j) ! series
       END IF
    END DO
    IF(t_ircwt>5 .AND. t_ircwt/=7 .OR. t_iflxc==1) THEN
       IF(t_ipj<10) THEN
          CALL vltsec(vlts,3)
       ELSE
          t_pfpsi=t_pfse
       END IF
       DO i=1,t_nc
          zvec(t_ic(i))=zvec(t_ic(i))+t_pfpsi(i)*t_cc(i)/t_ccls(t_ic(i))
       END DO
       DO i=1,t_nc
          t_pfpci(t_ic(i))=zvec(t_ic(i))
       END DO
       onec(1:)=t_pfpsi-t_pfps0
       dvec=t_dt*t_thetat*t_rxc
       evec=onec(1:)+dvec*t_cc+t_dt*(1-t_thetat)*t_rxc*t_cc0
       onec(1:)=onec(1:)*t_cc
       zvec=0
       IF(t_ircwt==10 .OR. t_ircwt==9 .OR. t_ircwt==8) THEN
          WHERE(t_iloop==1)
             t_gloop=(t_floop(:,1)-t_floop0)/t_sigloop
          ELSEWHERE
             t_gloop=(sin(t_thloop)*t_floop(:,2)-cos(t_thloop)*t_floop(:,3)-&
                  t_floop0)/t_sigloop
          ENDWHERE
          onec(1:t_nloop)=t_gloop
          IF(t_lsph==1) onec(t_nloop+1)=1.e-6_rq*(t_fgun-t_f_gun0)
          IF(t_deltad/=1.0) THEN
             DO k=1-iabs(t_lsph),t_nsph ! update from prsx and flux change
                WHERE(t_iloop==1)
                   t_splw(:,k)=-t_deltad*t_gplw(:,k,1)/t_sigloop+(1.0_rq-&
                        t_deltad)*t_splw(:,k)
                ELSEWHERE
                   t_splw(:,k)=-t_deltad*(sin(t_thloop)*t_gplw(:,k,2)-&
                        cos(t_thloop)*t_gplw(:,k,3))+(1.0_rq-t_deltad)*&
                        t_splw(:,k)
                ENDWHERE
             END DO
          END IF
       END IF
    END IF
    ! set up refrence point for nbd or t_nfbd
    IF(s_limiterd==0) THEN
       !BUG? IF theta ne 0, don't you want t_r,t_z at t_psi=psil?, ie, make
       ! rbd,zbd's define the p=0 surface, not the xpt surface?
       !At any rate beware: thetac /=0--> t_psi(rbd,zbd) /= psil=t_psi(rls,zls)
       IF(t_ixpt/=3) THEN
          fcr = t_rxpt
          fcz = t_zxpt
       ELSE
          fcr = s_rcntr-s_rbore;   fcz = t_zaxis
       END IF
       IF(t_ixpt==4) fcrz=t_psil
       IF(t_ixpt==5) fcrz=t_psix+t_dpsi00
    ELSE
       fcr = t_rlim(0)
       fcz = t_zlim(0)
    END IF
    CALL boxd_interp(fcr,fcz,pds,ier,t_n4)
    fcrz =pds(1)
    IF(t_ixpt==4) fcrz=t_psil
    IF(t_ixpt==5) fcrz=t_psix+t_dpsi00
    ! end setup of reference points
    IF(t_iflxc==1 .AND. t_dt/=0) THEN !  feedback on vertical stability
       IF(ibcntrl==1)THEN     ! shape control                           !4.96
          CALL bcontrol(t_dt) ! time advanced in transStep; need arg/=0 !5.96
          DO i=1,t_ncplot                                               !5.94
             evec(i)=evec(i)-t_dt*t_thetat*vbcp(i)*t_cc(i)              !5.94
          END DO                                                        !5.94
          IF(t_nsymc == 1 .AND. t_ncplot /= t_nc)THEN                   !5.94
             DO i=1,t_ncplot                                            !9.94
                evec(t_nc/2+i)=evec(i)                                  !9.94
             END DO                                                     !9.94
          END IF                                                        !9.94
       END IF
       IF(t_nfbc>0) THEN
          IF(t_nmsc/=1) THEN
             ier=3
             isw=0
             CALL boxm_interp(t_rloop,t_zloop,t_ploop,i_r,i_z,i_cps,isw,ier,&
                  t_n4)
             nloo=0
             DO l=1,t_nloop
                IF(t_iloop(l)==4) THEN
                   t_gloop(l)=-s_pin*(t_ploop(l,1)-t_pxpt)/&
                        sqrt(t_ploop(l,2)**2+t_ploop(l,3)**2)*1.e-2_rq
                   t_floop(l,1)=TWOPI*1.0e-08_rq*t_ploop(l,1)
                   t_floop(l,2)=-t_ploop(l,3)/t_rloop(l) ! br
                   t_floop(l,3)=t_ploop(l,2)/t_rloop(l)  ! bz
                   nloo=nloo+1
                ELSEIF(t_iloop(l)==6) THEN
                   t_gloop(l)=-t_plc*1.e-5_rq
                ELSEIF(t_iloop(l)==7) THEN
                   t_gloop(l)=-t_ccls(t_ic(l-nloo))
                ELSEIF(t_iloop(l)==t_nloop) THEN
                   t_gloop(l)=t_zaxis*1.e-2_rq !if zcur wanted in circuits.bas
                END IF
             END DO
          END IF
       END IF
    END IF
    IF(ncal/=-1) THEN
       CALL gs_curmat1
    END IF
    gmat(:,:,4)=0
    jbd=t_nbd
    jbdrl=0
    jbdr=0
    jbdz=0
    jbdxr=0
    jbdxz=0
    jbdvltf=0
    jbdaxis=0
    zpl=1.e8_rq/TWOPI
    IF(t_plcx/=0) THEN
       jbd=jbd+1
       jbdaxis=jbd
       rvec(jbd)=(t_psix-t_plcx)
       ncal=1
    ELSEIF(t_cejima==0 .AND. t_vltf/=0.0) THEN !     VS=t_vltf
       jbd=jbd+1
       jbdvltf=jbd
       IF(t_iflxc/=1 .AND. t_ircwt/=6 .AND. t_ircwt/=7) CALL vltsec(vlts,1)
       rvec(jbd)=(vlts-t_vltf)*zpl
    ELSEIF(t_cejima/=0.0 .AND. t_vltf/=0.0) THEN !    Ejima formula
       jbd=jbd+1
       jbdvltf=jbd
       CALL vltsec(vlts,2)
       rvec(jbd)=(t_psires-t_vltf+FOURPI*t_cejima*t_plcm*s_rcntr/1000)*zpl
       ncal=1
    END IF
    IF(t_jaxis/=0 .OR. t_kaxis/=0) THEN
       ier=3
       CALL boxd_interp(t_raxis0,t_zaxis0,pds,ier,t_n4)
       ier=1
       jbd=jbd+1
       jbdr=jbd
       rvec(jbd)=-pds(3)*t_raxis0
       jbd=jbd+1
       jbdz=jbd
       rvec(jbd)= pds(2)*t_raxis0
    END IF
    IF(t_jxp/=0 .OR. t_kxp/=0) THEN
       ier=3
       CALL boxd_interp(t_rxpt0,t_zxpt0,pds,ier,t_n4)
       ier=1
       jbd=jbd+1
       jbdxr=jbd
       rvec(jbd)=-pds(3)*t_rxpt0
       jbd=jbd+1
       jbdxz=jbd
       rvec(jbd)= pds(2)*t_rxpt0
    END IF
    IF(t_nlim/=0) THEN          !  holds point to be on scrapeoff layer
       DO nn=1,t_nlim
          jbd=jbd+1
          jlim(nn)=jbd
          ier=1
          CALL boxd_interp(t_rlim(nn),t_zlim(nn),pds,ier,t_n4)
          rvec(jbd)=pds(1)
          IF(t_dlim(nn)>=0) THEN
             rsk(nn)=s_rcntr+s_rbore+t_dlim(nn)
          ELSE
             rsk(nn)=s_rcntr-s_rbore+t_dlim(nn)
          END IF
          ier=1
          CALL boxd_interp(rsk(nn),t_zaxis,pds,ier,t_n4)
          rvec(jbd)=rvec(jbd)-pds(1)
       END DO
    END IF
    IF(t_rl/=0 .AND. t_nsymc==2) THEN
       jbd=jbd+1
       jbdrl=jbd
       IF(t_irl>0) THEN
          !--- distance between separatrices equal to t_rl, upper Xpt inactive
          IF(t_rl>0) THEN
             rump=s_rcntr+s_rbore+t_rl
          ELSEIF(t_rl<0) THEN
             rump=s_rcntr-s_rbore+t_rl
          END IF
          zump=t_zaxis
          ier=1
          CALL boxd_interp(rump,zump,pds,ier,t_n4)
          ff=pds(1)
          ier=1
          fcrr=s_rxpu
          fczz=s_zxpu
          CALL boxd_interp(fcrr,fczz,pds,ier,t_n4)
          rvec(jbd)=ff-pds(1)
       ELSEIF(t_irl<0) THEN
          !--- distance between separatrices equal to t_rl, lower Xpt inactive
          IF(t_rl>0) THEN
             rump=s_rcntr+s_rbore+t_rl
          ELSEIF(t_rl<0) THEN
             rump=s_rcntr-s_rbore+t_rl
          END IF
          zump=t_zaxis
          ier=1
          CALL boxd_interp(rump,zump,pds,ier,t_n4)
          ff=pds(1)
          ier=1
          fcrr=s_rxpl
          fczz=s_zxpl
          CALL boxd_interp(fcrr,fczz,pds,ier,t_n4)
          rvec(jbd)=ff-pds(1)
       ELSEIF(t_irl==0) THEN
          rump=s_rxpu
          zump=s_zxpu
          ier=1
          CALL boxd_interp(rump,zump,pds,ier,t_n4)
          ff=pds(1)
          fcrr=s_rxpl
          fczz=s_zxpl
          ier=1
          CALL boxd_interp(fcrr,fczz,pds,ier,t_n4)
          rvec(jbd)=ff-pds(1)-(t_psil-t_psix)*t_rl
       END IF
    END IF
    
    ! --- Finish calculation of constraints
    t_jbdcir=jbd
    IF(t_iflxc==1) THEN
       t_jbdcir=t_ncircuit+jbd
    ELSE
       ! t_ncircuit=t_jbdcir LDP 2003/03/08 Cannot imagine why this 
       ! was ever done but will have to watch this.
    END IF
    jbig=0
    IF(t_ircwt==10 .AND. t_nloop<=t_ngroup .AND. t_almim==0) THEN
       jbig=t_jbdcir+t_ngroup
       IF(SIZE(avec)/=jbig) THEN
          IF(ALLOCATED(avec)) DEALLOCATE(avec,amat,bmat)
          ALLOCATE(avec(jbig),amat(jbig,jbig),bmat(jbig,jbig))
          amat=0;avec=0;bmat=0
       END IF
    END IF
    jsvd=0
    IF(lfbd==1) THEN
       jsvd=0 !   use rmInvert and standard logic
    ELSEIF((t_almim==0 .AND. t_ncircuit/=0) .AND. ((t_ircwt==6 .AND. &
         t_ncircuit/=t_ngroup) .OR. t_ircwt==-1 .OR. t_ircwt==9)) THEN
       jsvd=1 ! use SVD or rmInvert IF lsvd=0 for full matrix with multipliers
    ELSE
       jsvd=0 ! use rmInvert and standard logic
    END IF
    IF(t_jbdcir==0) THEN ! will minimize with no constraints
       IF(ncal==-1) go to 400
       go to 100
    END IF
    ier=1
    jer=1
    DO i=1,t_nbd
       ier=jer
       CALL boxd_interp (t_rbd(i),t_zbd(i),pds,ier,t_n4)
       t_psibd(i)=pds(1)
       rvec(i)=t_psibd(i)-fcrz
    END DO
    ! LDP for t_ircwt
    DO i=1,jbd
       rvec(i)=rvec(i)/zpl
    END DO
    !
    IF(t_iflxc==1) THEN
       zvec=0
       DO i=1,t_nc
          zvec(t_ic(i))=zvec(t_ic(i))+t_cc(i)*evec(i)
       END DO
       zvec(1:ngrup)=zvec(1:ngrup)/t_ccls(1:ngrup)
       DO n=1,t_nc
          rvec(t_ix(n))=zvec(t_ic(n))
       END DO

       IF(t_ircwt==9 .AND. t_lsph==-1) THEN
          rvec(t_ncircuit)=(1.e-5_rq*t_plc-t_plcm)
       END IF

       IF(t_dt/=0 .AND. ncal/=-1) THEN  !  green's functions for IR

          umat=0
          zvec=0
          DO i=1,t_nc
             zvec(t_ic(i))=zvec(t_ic(i))-dvec(i)*t_cc(i)**2
          END DO
          DO i=1,ngrup
             umat(i,i)=umat(i,i)+zvec(i)*zpl/t_ccls(i)**2
          END DO
          DO i=1,ngrup
             DO n=1,t_nc
                zvec(t_ix(n))=umat(t_ic(n),i)
             END DO
             DO j=1,t_jbdcir
                gmat(j,i,4)=gmat(j,i,4)+zvec(j)
             END DO
          END DO

       END IF
    END IF
    !
    IF(ncal==-1)  THEN
       IF(t_jbdcir==t_ngroup .AND. t_ircwt/=9) THEN ! nothing to minimize
          jrwct=1
          onec(1:t_jbdcir)=0
          dvec(:t_jbdcir)=rvec(1:t_jbdcir)
          go to 300
       ELSE
          go to 400                        ! something to minimize
       END IF
    END IF

    CALL gs_calcMatrices

    IF(t_jbdcir==t_ngroup) THEN   !  nothing to minimize
       jrwct=1
       onec(1:t_jbdcir)=0
       dvec(:t_jbdcir)=rvec(1:t_jbdcir)
       go to 200
    END IF
!-----------------
100 continue
    CALL gs_curmat3
400 continue
    IF(t_ircwt<=5) THEN
       zvec=0
       IF(t_ircwt==1) THEN
          DO i=1,t_nc
             zvec(t_ic(i))=zvec(t_ic(i))+(t_cc(i)-t_cc0(i))*t_cc(i)
          END DO
          zvec(1:t_ngroup)=zvec(1:t_ngroup)/t_ccls(1:t_ngroup)
       ELSE
          zvec(1:t_ngroup)=t_ccls(1:t_ngroup)
       END IF
       DO i=1,t_ngroup
          onec(i)=SUM(umat(i,1:t_ngroup)*zvec(1:t_ngroup))
       END DO
    ELSEIF(t_ircwt==6) THEN
       zvec=0
       DO i=1,t_nc
          zvec(t_ic(i))=zvec(t_ic(i))+onec(i)
       END DO
       DO i=1,t_ngroup
          onec(i)=SUM(umat(1:t_ngroup,i)*zvec(1:t_ngroup)/t_ccls(1:t_ngroup))
       END DO
    ELSEIF(t_ircwt==7) THEN     ! total PF energy
       zvec=0
       DO i=1,t_nc
          zvec(t_ic(i))=zvec(t_ic(i))+onec(i)
       END DO
       DO i=1,t_ngroup
          onec(i)=0.5_rq*(SUM(umat(i,1:t_ngroup)*t_ccls(1:t_ngroup))+zvec(i)/&
               t_ccls(i))
       END DO
    ELSEIF(t_ircwt==10 .OR. t_ircwt==9 .OR. t_ircwt==8) THEN
       DO i=1,ngrup
          zvec(i)=SUM(umat(1:t_nloop,i)*onec(1:t_nloop))
       END DO
       DO k=1-iabs(t_lsph),t_nsph
          kk=k+ngrup+iabs(t_lsph)
          nloo=t_nloop
          IF(t_lsph==1) nloo=nloo+1
          zvec(kk)=SUM(t_splw(:nloo,k)*onec(1:nloo))
       END DO
       DO i=1,t_ngroup
          onec(i)=zvec(i)
       END DO
       IF(jbig/=0) avec(1:t_ngroup)=-onec(1:t_ngroup)
    END IF
    IF(lfbd/=0) THEN
       ier=3
       isw=0
       CALL boxm_interp(t_rfbd,t_zfbd,pfbd,i_r,i_z,i_cps,isw,ier,t_n4)
       DO i=1,ngrup
          onec(i)=onec(i)+(SUM(pfbd(:,1)*t_alfbd(:t_nfbd)*gmatfbd(:,i))-fcrz*&
               SUM(t_alfbd(:t_nfbd)*gmatfbd(:,i)))/zpl
       END DO
    END IF
    IF(t_jbdcir/=0 .AND. t_almim/=0) THEN
       DO i=1,t_ngroup
          onec(i)=onec(i)-t_almim*SUM(gmat(:t_jbdcir,i,1)*rvec(1:t_jbdcir))
       END DO
    END IF
    !     IF(t_ircwt==9 .AND. t_dt==0) THEN
    !     skip
    IF(jsvd==1 .OR. t_ircwt==8) THEN
       !     skip
    ELSE
       DO i=1,t_ngroup
          zvec(i)=SUM(gmat(i,:,3)*onec(1:t_ngroup))
       END DO
       onec(1:t_ngroup)=zvec(1:t_ngroup)
    END IF
    !    end of minimization
    IF(t_jbdcir==0)THEN
       zvec=0
       go to 101               ! nothing to constrain
    END IF
    !
    IF(jbig==0) THEN
       DO i=1,t_jbdcir
          dvec(i)=SUM(gmat(i,:,1)*onec(1:t_ngroup))+rvec(i)
       END DO
    ELSE
       avec(t_ngroup+1:jbig)=+rvec(1:t_jbdcir)
    END IF

    IF(ncal==-1) go to 300

    !---Now calculate matrix to invert for constraint
    IF(jbig/=0) THEN
       bmat=amat
!       CALL rmInvert(bmat,jbig,jbig)
       CALL svd_Invert(bmat)
    ELSE
       DO i=1,t_ngroup
          IF(t_ircwt>=4 .OR. lfbd/=0) THEN
             DO j=1,t_jbdcir
                gmat(i,j,5)=SUM(gmat(i,:,3)*gmat(j,:,1))
             END DO
          ELSE
             DO j=1,t_jbdcir
                gmat(i,j,5)=gmat(i,i,3)*gmat(j,i,1)
             END DO
          END IF
       END DO
       DO i=1,t_jbdcir
          DO j=1,t_jbdcir
             gmat(i,j,2)=SUM(gmat(i,:,1)*gmat(:,j,5))
          END DO
       END DO
       !     invert matrix to solve gmat(,,2)*zvec=dvec
    END IF
200 continue
    IF(jsvd==1) THEN
       !       CALL parsestr("new_min(2)")
       DO i=1,t_ncircuit
          asvd(t_ngroup+i,:t_ngroup)=-gmat(i,:t_ngroup,1)
          asvd(:t_ngroup,t_ngroup+i)=-gmat(i,:t_ngroup,1)
       END DO
       IF(lsvd==0) THEN
          CALL rmInvert(asvd,msvd,nsvd)
       ELSE
          CALL svd_Invert(asvd)
       END IF
    ELSEIF(t_ircwt==8) THEN
       !       CALL parsestr("svd_(2)")
    ELSEIF(jbig==0) then
       CALL rmInvert(gmat(1,1,2),t_ngroup,t_jbdcir)
    END IF
300 continue
    IF(jsvd==1 .OR. t_ircwt==8) go to 101
    DO i=1,t_jbdcir
       zvec(i)=SUM(gmat(i,:t_jbdcir,2)*dvec(:t_jbdcir))
    END DO
    IF(jrwct==0) THEN
       DO j=1,t_ngroup
          dvec(j)=SUM(gmat(j,:t_jbdcir,5)*zvec(1:t_jbdcir))
       END DO
       zvec(1:)=dvec
    END IF
101 continue
    IF(jsvd==1) THEN
       nsvd=t_ngroup+t_ncircuit
       msvd=nsvd
       IF(SIZE(zsvd)/=nsvd) THEN
          IF(SIZE(zsvd)>1) DEALLOCATE(asvd,zsvd)
          ALLOCATE(asvd(nsvd,nsvd),zsvd(nsvd))
       END IF
       zsvd(:t_ngroup)=-onec(1:t_ngroup)
       zsvd(t_ngroup+1:t_ncircuit+t_ngroup)=-rvec(1:t_ncircuit)
       DO i=1,t_ngroup
          zvec(i)=SUM(asvd(i,:)*zsvd)
       END DO
    ELSEIF(t_ircwt==8) THEN
       !       CALL parsestr("new_min(3)")
       !       CALL parsestr("svd_(3)")
    ELSEIF(jbig==0) then
       zvec(1:ngrup)=-onec(1:ngrup)+zvec(1:ngrup)
    ELSE
       DO i=1,ngrup
          zvec(i)=SUM(bmat(i,:)*avec)
       END DO
    END IF
    dvec=t_cc
    IF( ncal==0 ) RETURN
    zvec(1:ngrup)=zvec(1:ngrup)*(1-t_alpcoil)
    IF(t_ircwt==9) THEN
       zvec(ngrup+1:t_ngroup)=zvec(ngrup+1:t_ngroup)*(1-t_alpsph)
       DO k=1,t_nsph
          kk=k+ngrup+iabs(t_lsph)
          t_asph(k)=t_asph(k)+zvec(kk)
       END DO
       IF(t_lsph/=0) THEN
          aaa=1+zvec(ngrup+1)
          IF(iabs(t_ipf)==8) THEN
             t_prsx=t_prsx*aaa
          ELSE
             t_prsx=t_prsx*aaa**2
          END IF
          DO k=1,4
             t_asph(k)=t_asph(k)/aaa
          END DO
       END IF
    END IF
    DO n=1,t_nc
       IF(t_ic(n)/=0)t_cc(n)=t_cc(n)*(1+zvec(t_ic(n))/t_ccls(t_ic(n)))
    END DO
    t_ccls(1:ngrup)=t_ccls(1:ngrup)+zvec(1:ngrup)

    IF(t_magfac /= 0.)THEN 
       DO i=1,t_ncf
          t_ccfd(i)=t_ccf(i)-t_ccmf(i) ! save filament current
       END DO
       CALL gs_curmag  ! compute magnetization current
       DO i=1,t_ncf   ! reset filements to driven current
          t_ccf(i)=t_ccfd(i)
       END DO
    END IF  ! t_magfac/=0
    l0=1
    DO n=1,t_nc ! set filaments
       ff=t_cc(n)/dvec(n)
       DO l=l0,t_loop0(n)
          t_ccf(l)=t_ccf(l)*ff
       END DO
       l0=t_loop0(n)+1
    END DO
    IF(t_magfac /= 0.) THEN     ! add magnetization
       DO i=1,t_ncf
          t_ccf(i)=t_ccf(i)+t_ccmf(i)
       END DO
    END IF  ! t_magfac/=0
    t_psi=t_psi-t_psiw
    CALL gs_psiext
    t_psi=t_psi+t_psiw
    ncal=-1                   !  don't recalculate inverse
  END SUBROUTINE gs_curcal

  SUBROUTINE gs_curmat1
    REAL(rq) ::  ff_(t_nc),fbr_(t_nc),fbz_(t_nc),rmt
    INTEGER inum,izpt,n_,i,j,n,ii
    ! Matrices(Greens's functions) for fuzzy boundary points and flux at coils
    inum=0
    umat=0
    IF(lfbd/=0) THEN
       rmt=TWOPI*1.0e-03_rq
       CALL mutual_utils(rcls,zcls,fcr,fcz,ff_,fbr_,fbz_,inum)
       rvec(1:)=ff_
       IF(t_ixpt>=4 .AND. s_limiterd==0) THEN
          CALL mutual_utils(rcls,zcls,t_raxis,t_zaxis,ff_,fbr_,fbz_,inum)
          IF(t_ixpt==5) THEN
             rvec(1:)=ff_
          ELSEIF(t_ixpt==4) THEN
             rvec(1:)=t_theta*ff_+(1-t_theta)*rvec(1:)
          END IF
       END IF

       DO i=1,t_nfbd
          zvec=0
          CALL mutual_utils(rcls,zcls,t_rfbd(i),t_zfbd(i),ff_,fbr_,fbz_,inum)
          DO j=1,t_nc
             zvec(t_ic(j))=zvec(t_ic(j))+rmt*(ff_(j)-rvec(j))*t_cc(j)
          END DO
          DO n=1,ngrup
             gmatfbd(i,n)=zvec(n)/t_ccls(n)
          END DO
       END DO
       zvec=0
    END IF
    IF(t_iflxc==1) THEN
       DO i=1,t_nc
          DO j=1,t_nc
             umat(t_ic(i),t_ic(j))=umat(t_ic(i),t_ic(j))+t_cc(i)*t_pfim(i,j)*&
                  t_cc(j)
          END DO
       END DO
       DO i=1,ngrup
          umat(i,1:ngrup)=umat(i,1:ngrup)/t_ccls(i)/t_ccls(1:ngrup)
       END DO
       DO j=1,ngrup
          DO n=1,t_nc
             zvec(t_ix(n))=umat(t_ic(n),j)
          END DO
          DO i=1,t_ncircuit
             gmat(i,j,2)=zvec(i)
          END DO
       END DO
       IF(t_ircwt==9) THEN
          DO i=1-iabs(t_lsph),t_nsph
             ii=i+ngrup+iabs(t_lsph)
             zvec=0
             DO n=1,t_nc
                zvec(t_ix(n))=zvec(t_ix(n))-t_cc(n)*t_gcw(n,i)/t_ccls(t_ic(n))
             END DO
             DO j=1,t_ncircuit
                gmat(j,ii,2)=zvec(j)
             END DO
          END DO
          IF(t_lsph==-1) THEN
             DO i=1-iabs(t_lsph),t_nsph
                ii=i+ngrup+iabs(t_lsph)
                gmat(t_ncircuit,ii,2)=-zgplc(i)
             END DO
          END IF
       END IF
    END IF
  END SUBROUTINE gs_curmat1

  SUBROUTINE gs_curmat3
    INTEGER :: ncsy,i,j,k,n,kk,nloo,jj
    REAL(rq) ::  sumg,alfo,alfn
    ! Matrix(Green's function) for minimizations: see ircwt
    ncsy=t_nc/(3-t_nsymc)
    umat=0
    IF(t_ircwt<4 .AND. t_ircwt>0) THEN
       zvec=0
       DO j=1,t_nc
          IF(t_ircwt==0) THEN
             zvec(t_ic(j))=zvec(t_ic(j))+(t_cc(j)*t_rc(j))**2*t_svec(j)
          ELSEIF(t_ircwt==1) THEN
             zvec(t_ic(j))=zvec(t_ic(j))+t_cc(j)**2*t_svec(j)
          ELSEIF(t_ircwt==2) THEN
             zvec(t_ic(j))=zvec(t_ic(j))+t_cc(j)**2*t_svec(j)
          ELSEIF(t_ircwt==3) THEN
             zvec(t_ic(j))=zvec(t_ic(j))+(t_cc(j)/t_drc(j)/t_dzc(j))**2*&
                  t_svec(j)
          END IF
       END DO
       DO i=1,ngrup
          umat(i,i)=zvec(i)/t_ccls(i)**2
       END DO
       gmat(:ngrup,:ngrup,3)=umat(1:ngrup,1:ngrup)
    ELSEIF(t_ircwt==4 .OR. t_ircwt==6 .OR. t_ircwt==7) THEN
       !     minimize wpf, delta t_pfpsi or wpt
       DO j=1,t_nc
          DO i=1,t_nc
             umat(t_ic(i),t_ic(j))=umat(t_ic(i),t_ic(j))+t_cc(i)*t_cc(j)*&
                  t_pfim(i,j)
          END DO
       END DO
       DO i=1,ngrup
          umat(i,1:ngrup)=umat(i,1:ngrup)/t_ccls(i)/t_ccls(1:ngrup)
       END DO
       IF(t_ircwt==4 .OR. t_ircwt==7) THEN
          gmat(:,:,3)=umat(1:t_ngroup,1:t_ngroup)
       ELSEIF(t_ircwt==6) THEN   !   minimize flux difference at coils
          DO i=1,t_ngroup
             IF(t_icc(i)==0 .AND. t_almim/=0) umat(i,1:t_ngroup)=0
          END DO
          gmat(:,:,3)=MATMUL(&
               TRANSPOSE(umat(1:ngrup,1:ngrup)),umat(1:ngrup,1:ngrup))
       END IF

    ELSEIF(t_ircwt==5) THEN   !   minimizes B**2 at coils
       DO j=1,t_nc/(3-t_nsymc)
          DO i=1,t_nc/(3-t_nsymc)
             umat(t_ic(i),t_ic(j))=umat(t_ic(i),t_ic(j))+t_cc(i)*t_cc(j)*&
                  t_pbim(i,j)
          END DO
       END DO
       DO i=1,t_ngroup
          umat(i,1:ngrup)=umat(i,1:ngrup)/t_ccls(i)/t_ccls(1:ngrup)
          gmat(i,:,3)=umat(i,1:ngrup)
       END DO

    ELSEIF(t_ircwt==10 .OR. t_ircwt==9 .OR. t_ircwt==8) THEN
       ! loop measurements
       DO n=1,t_nloop
          zvec(:t_nc)=0
          DO i=1,t_nc
             IF(t_iloop(n)==1) THEN ! flux
                zvec(t_ic(i))=zvec(t_ic(i))+t_cc(i)*t_plim(i,n,1)/t_sigloop(n)
             ELSEIF(t_iloop(n)==2) THEN ! field              
                zvec(t_ic(i))=zvec(t_ic(i))+t_cc(i)*(t_plim(i,n,2)*sin(&
                     t_thloop(n))-t_plim(i,n,3)*cos(t_thloop(n)))/t_sigloop(n)
             END IF
          END DO
          umat(n,1:ngrup)=zvec(1:ngrup)
       END DO
       DO i=1,t_nloop
          umat(i,1:ngrup)=umat(i,1:ngrup)/t_ccls(1:ngrup)
       END DO
       gmat(:,:,3)=MATMUL(&
            TRANSPOSE(umat(1:t_nloop,1:ngrup)),umat(1:t_nloop,1:ngrup))
       IF(jbig/=0) THEN
          amat(:ngrup,:ngrup)=gmat(:,:,3)
       END IF
       DO k=1-iabs(t_lsph),t_nsph
          WHERE(t_iloop==1)
             t_splw(:,k)=-t_gplw(:,k,1)/t_sigloop
          ELSEWHERE
             t_splw(:,k)=-(sin(t_thloop)*t_gplw(:,k,2)-cos(t_thloop)*&
                  t_gplw(:,k,3))
          ENDWHERE
       END DO
       DO k=1-iabs(t_lsph),t_nsph
          kk=k+ngrup+iabs(t_lsph)
          DO n=1,ngrup
             gmat(n,kk,3)=SUM(umat(1:t_nloop,n)*t_splw(:,k))
             gmat(kk,n,3)=gmat(n,kk,3)
          END DO
          DO j=1-iabs(t_lsph),t_nsph
             jj=j+ngrup+iabs(t_lsph)
             nloo=t_nloop
             IF(t_lsph==1)nloo=t_nloop+1
             gmat(kk,jj,3)=SUM(t_splw(:nloo,k)*t_splw(:nloo,j))
          END DO
       END DO
    ELSEIF(t_ircwt==-1) THEN ! (dI/t_dz)**2
       gmat(:,:,3)=0
       IF(t_nsymc==2) THEN
          alfo=t_svec(t_ngroup)/((t_rcg(1)-t_rcg(t_ngroup))**2+(t_zcg(1)-&
               t_zcg(t_ngroup))**2)
       ELSE
          alfo=0
       END IF
       DO i=1,t_ngroup
          j=i+1
          IF(i==t_ngroup) j=1
          alfn=t_svec(i)/((t_rcg(j)-t_rcg(i))**2+(t_zcg(j)-t_zcg(i))**2)
          umat(i,i)=alfn+alfo
          IF(i<t_ngroup) umat(i,j)=-alfn
          umat(i,i-1)=-alfo
          alfo=alfn
       END DO
       gmat(:,:,3)=umat(1:,1:t_ngroup)
    END IF
    IF(lfbd/=0) THEN
       DO j=1,ngrup
          DO i=1,ngrup
             zvec(i)=SUM(gmatfbd(:t_nfbd,i)*gmatfbd(:t_nfbd,j)*&
                  t_alfbd(:t_nfbd))
          END DO
          gmat(:,j,3)=gmat(:,j,3)+zvec(1:ngrup)
       END DO
    END IF

    IF(t_jbdcir/=0 .AND. t_almim/=0) THEN 
       !  add the square of the constrain to function too minimize: 
       !  removes singularity in inverse
       gmat(:,:,3)=gmat(:,:,3)+t_almim*MATMUL(&
            TRANSPOSE(gmat(:t_jbdcir,:,1)),gmat(:t_jbdcir,:,1))
    END IF
    IF(t_ircwt>=4 .OR. lfbd/=0 .OR. t_jbdcir/=0) THEN
       !  continue minimization (common)
       IF(t_ircwt==8) THEN
          !      CALL parsestr("svd_(1)")
       ELSEIF(jsvd==1) THEN
          asvd=0
          DO i=1,msvd*nsvd
             asvd(i,1)=0
          END DO
          asvd(:t_ngroup,:t_ngroup)=gmat(:,:,3)
       ELSEIF(jbig==0) THEN
          CALL rmInvert(gmat(1,1,3),t_ngroup,t_ngroup)
       END IF
    ELSE
       DO i=1,t_ngroup
          gmat(i,i,3)=1./gmat(i,i,3)
       END DO
    END IF
  END SUBROUTINE gs_curmat3

  SUBROUTINE gs_calcMatrices
    REAL(rq) ::  pds(8),ff_(t_nc),fbr_(t_nc),fbz_(t_nc),rmt
    INTEGER ::  inum,jnum,i,j,ier,nlo
    inum=0;jnum=3
    !--- Now calculate Matrices for constraints
    umat=0
    rmt=-1.e+05_rq
    CALL mutual_utils(rcls,zcls,fcr,fcz,ff_,fbr_,fbz_,inum)
    zvec(1:)=ff_

    IF(t_ixpt>=4 .AND. s_limiterd==0) THEN
       CALL mutual_utils(rcls,zcls,t_raxis,t_zaxis,ff_,fbr_,fbz_,inum)
       IF(t_ixpt==5) THEN
          zvec(1:)=ff_
       ELSEIF(t_ixpt==4) THEN
          zvec(1:)=t_theta*ff_+(1-t_theta)*zvec(1:)
       END IF
    END IF
    DO i=1,t_nbd
       CALL mutual_utils(rcls,zcls,t_rbd(i),t_zbd(i),ff_,fbr_,fbz_,inum)
       dvec=rmt*(ff_-zvec(1:))*t_cc
       DO j=1,t_nc
          umat(i,t_ic(j))=umat(i,t_ic(j))+dvec(j)
       END DO
    END DO

    IF(jbdaxis/=0) THEN       !  FIXING FLUX ON AXIS
       i=jbdaxis
       CALL mutual_utils(rcls,zcls,t_raxis,t_zaxis,ff_,fbr_,fbz_,inum)
       dvec=rmt*ff_*t_cc
       DO j=1,t_nc
          umat(i,t_ic(j))=umat(i,t_ic(j))+dvec(j)
       END DO

    ELSEIF(jbdvltf/=0) THEN !  FIXING VOLTSECONDS
       i=jbdvltf
       CALL mutual_utils(rcls,zcls,t_raxis,t_zaxis,ff_,fbr_,fbz_,inum)
       dvec=rmt*ff_*t_cc
       DO j=1,t_nc
          umat(i,t_ic(j))=umat(i,t_ic(j))+dvec(j)
       END DO
    END IF

    IF(t_jaxis/=0 .OR. t_kaxis/=0) THEN ! Fixing axis
       CALL mutual_utils(rcls,zcls,t_raxis0,t_zaxis0,ff_,fbr_,fbz_,jnum)
       dvec=rmt*fbr_*t_cc*t_raxis0**2
       DO j=1,t_nc
          umat(jbdr,t_ic(j))=umat(jbdr,t_ic(j))+dvec(j)
       END DO
       dvec=rmt*fbz_*t_cc*t_raxis0**2
       DO j=1,t_nc
          umat(jbdz,t_ic(j))=umat(jbdz,t_ic(j))+dvec(j)
       END DO
    END IF

    IF(t_jxp/=0 .OR. t_kxp/=0) THEN ! Fixing X-point
       CALL mutual_utils(rcls,zcls,t_rxpt0,t_zxpt0,ff_,fbr_,fbz_,jnum)
       dvec=rmt*fbr_*t_cc*t_rxpt0**2
       DO j=1,t_nc
          umat(jbdxr,t_ic(j))=umat(jbdxr,t_ic(j))+dvec(j)
       END DO
       dvec=rmt*fbz_*t_cc*t_rxpt0**2
       DO j=1,t_nc
          umat(jbdxz,t_ic(j))=umat(jbdxz,t_ic(j))+dvec(j)
       END DO
    END IF

    IF(t_nlim/=0) THEN
       DO nlo=1,t_nlim
          i=jlim(nlo)
          CALL mutual_utils(rcls,zcls,rsk(nlo),t_zaxis,ff_,fbr_,fbz_,inum)
          CALL mutual_utils(rcls,zcls,t_rlim(nlo),t_zlim(nlo),fbr_,ff_,fbz_,&
               inum)
          dvec=rmt*(fbr_-ff_)*t_cc
          DO j=1,t_nc
             umat(i,t_ic(j))=umat(i,t_ic(j))+dvec(j)
          END DO
       END DO
    END IF

    IF(t_rl/=0 .AND. t_nsymc==2) THEN !   FIX DIST. BETWEEN SEP.
       i=jbdrl
       CALL mutual_utils(rcls,zcls,fcrr,fczz,ff_,fbr_,fbz_,inum)
       CALL mutual_utils(rcls,zcls,rump,zump,fbr_,ff_,fbz_,inum)
       dvec=rmt*(fbr_-ff_)*t_cc
       DO j=1,t_nc
          umat(i,t_ic(j))=umat(i,t_ic(j))+dvec(j)
       END DO
    END IF

    IF(jbd>0) THEN
       DO j=1,ngrup
          gmat(:jbd,j,1)=umat(1:jbd,j)/t_ccls(j) ! must remove t_cc
       END DO
    END IF

    IF(t_iflxc==1) THEN         !    FIXING FLUX AT COILS
       DO i=jbd+1,t_jbdcir
          gmat(i,:,1)=-gmat(i,:,2)*zpl+gmat(i,:,4)
       END DO
    END IF

    gmat(:t_jbdcir,:,1)=gmat(:t_jbdcir,:,1)/zpl
    gmat(:t_jbdcir,:,2)=gmat(:t_jbdcir,:,1)
    IF(jbig/=0) THEN
       DO i=1,t_jbdcir
          amat(:ngrup,ngrup+i)=gmat(i,:,1)
          amat(ngrup+i,:ngrup)=gmat(i,:,1)
       END DO
    END IF


  END SUBROUTINE gs_calcMatrices

  SUBROUTINE gs_equil0
    INTEGER :: n1
    n1=0
    IF (ALLOCATED(wk)) THEN
       n1=SIZE(wk,1)
    END IF
    IF(n1/=t_jmkm) THEN
       IF(ALLOCATED(wk)) DEALLOCATE(wk,psiv,psir,rlo,rup,rdi,bda,bdb,bdc,bdd)
       ALLOCATE(wk(t_jmkm,4),psiv(t_jm,t_km),psir(t_jmkm),rlo(t_jm),rup(t_jm),&
            rdi(t_jm),bda(t_km),bdb(t_km),bdc(t_jm),bdd(t_jm))
       wk=0
    END IF
    CALL setpfc !  finds filament currents etc
    CALL get_greens
    CALL gs_equila
    t_fwall=t_ro*t_btor ! To accomodate adiabat options:LDP
  END SUBROUTINE gs_equil0

  SUBROUTINE gs_equila
    include "debug.i"
    REAL(rq), SAVE ::  raxx,zaxx,zvert,prsxx,tp,prsxest
    INTEGER :: kxpl,iter,nitt_,jedge,n,i
    IF(t_nl==-1) THEN
       IF(t_lop0==1 .OR. t_kbfc==1) CALL pfcfld
       RETURN
    END IF
    IF(t_ipscl==1) THEN
       s_pin=sign(1.0_rq,t_dpsi00)
    ELSE
       s_pin=-sign(1.0_rq,t_plcm)
       ! Can now change sign of current in mid stream
    END IF
    t_nitr = 0
    t_nitt = 0
    CALL setcls  !  need before initsi IF initflx=1
    npdesol=1
    CALL gs_pdesol !  stupid must set up pdesol
    IF(npdesol<t_jmkm)npdesol=t_jmkm

    !  set initial flux
    prsxest = t_betx*(t_plcm*2.0e05_rq/t_rb)**2/FOURPI
    IF( t_keqic == 2 ) THEN
       CALL initsi  ! beware: psil,x, ebdu etc. enter at their present values
       IF( t_initflx==4 ) THEN
          t_prsx = t_prsx00
       ELSE
          t_prsx = prsxest
       END IF
    ELSEIF( t_keqic == 0 ) THEN
       IF( t_prsx<=0.0 ) t_prsx = prsxest
    ELSEIF( t_keqic == 1 .AND. t_ncallsf==1 ) THEN
       CALL initsi
       IF( t_initflx==4 ) THEN
          t_prsx = t_prsx00
       ELSE
          t_prsx = prsxest
       END IF
    ELSEIF( t_keqic == 3 .AND. t_ncallsf==1 ) THEN
       CALL initsi
       IF( t_initflx==4 ) THEN
          t_prsx = t_prsx01
       ELSE
          t_prsx = prsxest
       END IF
    END IF
    t_fwall=t_btor*t_ro ! DO here so hybrid can vary btor
    IF(t_ipj<3 .OR. t_frsrf(t_msrf)==0) THEN
       IF(t_ipf==0) THEN
          t_frsrf(t_msrf)=t_fwall ! to accomodate RFP
       ELSE
          t_frsrf(t_msrf)=abs(t_fwall)
       END IF
    END IF
    !
    IF( t_ksave == 1 ) THEN
       t_psi00=t_psi
       ! IF t_ksave=1 after an t_ipj=4 run, DO not want prsx00=1
       IF(t_ipj<3) THEN; t_prsx00 = t_prsx
          ! t_ipj=4: the following coding works only after done.
          !         ELSE; zbetaj=t_ro**2*vp(1)/(wp(1)+t_ro**2*vp(1))
          !               t_prsx00=-wp(1)*prsx*(psil-psix)/(t_ro**2*(1-zbetaj))
       END IF
       t_ksave = 0
    END IF
    !
    ! *****************
    !   IF you change the order of the following and don't check that t_keqic=0
    !   still works, including t_ipj=5, i'm taking a contract out. lll
    ! *****************
    !
    IF(t_ipj>=3) THEN
       !        t_prsx=1.0
    ELSEIF(t_prsx==0) THEN
       t_prsx=prsxx
    ELSEIF(t_keqic==0 .AND. t_prsx==1.0) THEN
       t_prsx=t_prsx01
    END IF
    t_delta=t_deltac   !  not relaxation; can scale i.c.
    t_theta=t_thetac
    t_deltad=t_deltadc
    gamm=0.
    !  from initsi:
    t_alpha  =0.
    t_alpcoil=0.
    t_alpsph =0.
    IF(t_ixpo == 0) THEN
       kxpl=2
       s_kxpu=t_km-1
       s_lxpt=0
       t_ixp = 0
    ELSE
       t_ixp = t_ixpt  !  be sure new psilms does something ok IF no xpt
    END IF
    t_sigma=0.
    t_rlimm=t_rlim(0);t_zlimm=t_zlim(0)
    IF(t_ipj<6 .AND. t_inv_eq==0) THEN
       CALL gs_psiext ! want t_psiw to reflect t_ccf, independent of t_keqic
       CALL gs_separatrix
       IF(t_ipj/=0 .AND. t_ipj<3 .AND. t_inv_eq==0) CALL s_xohmic(nter_interp,&
            iter)
    END IF
    IF(t_ipj==3 .OR. t_ipj==4 .OR. t_ipj==5) THEN
       CALL s_adiabat ! uses q or jpar
    ELSEIF(t_inv_eq==1) THEN
       IF(s_jx/=0) CALL gs_pdesol
       CALL gs_psiext ! want t_psiw to reflect t_ccf, independent of t_keqic
       CALL gs_separatrix
       t_dpsi0=t_psil-t_psix ! ldp 11/2/96
       nitt_=t_nitt
       t_inv_eq=0
       t_fix_bound=.false.
       CALL teq_inv(t_inv_k,t_inv_p)
       t_nitt=nitt_
       CALL s_source_inv
    END IF
    IF(t_ipj==0 .AND. t_inv_eq==0) THEN
       CALL s_source(t_psibar,t_prsrf,t_pdsrf,0)
       CALL s_source(t_psibar,t_frsrf,t_fpsrf,1)
    END IF
    jedge=t_kedge
    IF(t_kedge==2) t_kedge=-1
    IF(t_inv_eq==0 .OR. (t_ipf==999 .AND. iabs(t_ipp)==999)) THEN
       t_clj=t_psi        ! t_clj,crje calculated later, ok here
       IF(t_ipf/=-1 .AND. t_ipf/=-8) THEN ! No outside region
          WHERE(s_lxpt<0) s_lxpt=1
       END IF
       CALL s_sourceGS(t_clj,t_rm,t_crj,t_pvec)
       t_bt=t_clj/t_rm
       t_kedge=jedge
       IF(t_kedge==2) THEN
          CALL shift
          CALL s_sourceGS(psish,rmsh,t_clj,crje)
          t_bt=psish/t_rm
       END IF
    END IF
    t_kedge=jedge
    IF(ndbg28==1) THEN
       CALL parsestr('<<"after sourceGS in equila";call separatrix_interface')
       CALL debugger
    END IF
    crjr=t_crj;psir=t_psi
    CALL gs_psiscl

    ! IF T_NSYM/=0, SET PLASMA SHAPE
    IF( t_nsym/=0 ) CALL gs_plbdry
    !----move rbd points normal to surface(nearly)
    IF(t_ncallsf==1) THEN
       raxx=t_raxis
       zaxx=t_zaxis
       zvert=t_wvert
       DO i=1,t_nbd
          IF(t_whtz(i)/=0) THEN
             t_psiwfc(i)=sqrt((t_rbd(i)-raxx)**2+(t_zbd(i)-zaxx)**2/zvert**2)/&
                  t_whtz(i)
             t_tbd(i)=atan2((t_zbd(i)-zaxx)/zvert,t_rbd(i)-raxx)
          END IF
       END DO
    END IF
    DO i=1,t_nbd
       IF(t_whtz(i)>0) THEN  ! destroys rbd IF t_raxis @ncallsf=1 bad
          t_rbd(i)=t_raxis+t_whtz(i)*t_psiwfc(i)*cos(t_tbd(i))
          t_zbd(i)=t_zaxis+t_whtz(i)*t_psiwfc(i)*sin(t_tbd(i))*zvert
       ELSEIF(t_whtz(i)<0) THEN
          t_zbd(i)=zaxx+zvert*(t_rbd(i)-raxx)*tan(t_tbd(i))
       END IF
    END DO
    IF(t_int_flag<=0) CALL gs_intcls
    CALL gs_clcalc
    CALL gs_bndpsi(1) ! ldp's change 23/10/95
    gamm   = t_gammac
    t_alpcoil=t_alpcoilc
    t_alpsph =t_alpsphc
    t_alpha  =t_alphac
    t_sigma  =t_sigmac
    ! SOLVE EQUILIBRIUM PROBLEM...
    IF(t_jbdcir==0) THEN
       i=0
       CALL gs_curcal(i)
       t_lcal=-1
    END IF
    CALL gs_equilb(t_nl)

    t_sigma = 0.0
    t_alpha = 0.0
    t_alpcoil= 0.0
    t_alpsph = 0.0
    t_nitr  = 2000
    t_ixp = t_ixpt
    ! COMPUTE DIAGNOSTIC QUANTITIES, OUTPUT...
    IF(t_ipj<3) prsxx=t_prsx
    t_dpsi0=t_psil-t_psix
    IF(t_ipf==-7) THEN ! Spheromak
       IF(t_lamdagun>0) THEN
          WHERE(t_crj<0)t_bt=-t_bt
       ELSE
          WHERE(t_crj>0)t_bt=-t_bt
       END IF
    END IF
    IF(t_ipj==1 .AND. t_inv_eq==0) THEN ! must rescale to be consistent
       IF(t_prsx01==0) t_prsx01=t_prsx
       t_jtsave=t_jtsave*t_prsx/t_prsx01
       t_psave=t_psave*t_prsx/t_prsx01
    END IF
    CALL gs_separatrix
    t_dpsi0=t_psil-t_psix ! ldp 11/2/96
    IF(ndbg20==0) THEN
       IF(t_inv_eq==0) THEN
          CALL s_source(t_psibar,t_prsrf,t_pdsrf,0)
          CALL s_source(t_psibar,t_frsrf,t_fpsrf,1)
          CALL diag
       ELSE
          CALL diaginv
       END IF
       ! CALL trap_to_pass
    END IF
  END SUBROUTINE gs_equila

  SUBROUTINE gs_equilb(nll)
    CHARACTER(len=2) aa
    CHARACTER(len=6) bb
    CHARACTER(len =128) mes
    INTEGER nll,ib
    REAL(rq) pp
    include "debug.i"

    t_alpha=t_alphac
    t_sigma=t_sigmac
    t_alpcoil=t_alpcoilc
    t_alpsph =t_alpsphc
    DO ib=1,nll
       IF(t_dt .NE. 0) CALL parsestr("mov_lim")
       CALL gs_equilc
       CALL gs_psiscl
       CALL gs_bndpsi(1)
       aa=" "
       IF( s_limiterd == 0) aa=" *"
       IF(t_ipj==5 .AND. t_inv_p==-1) THEN
          bb=" dps ="
          pp=t_dpsi0
       ELSEIF(t_ipj==5) THEN
          bb=" plc= "
          pp=t_plc*1.e-5_rq
       ELSEIF(t_ipscl<=0) THEN
          bb=" plc= "
          pp=t_plc*1.e-5_rq
       ELSEIF(t_ipscl==1) THEN
          bb=" dps ="
          pp=t_dpsi0
       ELSEIF(t_ipscl==2) THEN
          bb=" fgn ="
          pp=t_fgun
       ELSEIF(t_ipscl==3) THEN
          bb=" psl ="
          pp=t_psil
       ELSEIF(t_ipscl==4) THEN
          bb=" psr = "
          pp=t_psires
       END IF
       IF(t_nprt59==1) THEN
          IF(s_nxps/=0) THEN
             aa=" -"
             IF(s_kxpt==s_kxpu) aa=" +"
             WRITE(STDOUT,2000)t_nitt,t_residj,s_jxpt,s_kxpt,t_rxpt,t_zxpt,&
                  bb,pp,aa
             WRITE(t_logunit,2000)t_nitt,t_residj,s_jxpt,s_kxpt,t_rxpt,&
                  t_zxpt,bb,pp,aa
          ELSE
             WRITE(STDOUT,4000)t_nitt,t_residj,s_jx,s_kx,t_raxis,t_zaxis,bb,pp
             WRITE(t_logunit,4000)t_nitt,t_residj,s_jx,s_kx,t_raxis,t_zaxis,&
                  bb,pp
          END IF
       END IF
       IF(t_resb<=t_epsb .AND. t_residj<=t_epsj) EXIT
    END DO
    
    IF(ib>nll .AND. nll>30) THEN
       write(mes,'(a,i4,a,1pe8.1,a,1pe8.1,a)')&
            " direct solver failed to converge, nl = ",t_nl, &
            " residj =",t_residj," epsj =",t_epsj
       CALL errdetec(mes,-1)
    END IF
    IF(ib<=nll .AND. t_nprt59==0 .AND. nll>5) THEN
       WRITE(STDOUT,3000)ib,t_nitr,s_jx,s_kx,t_raxis,t_zaxis,s_jxpt,s_kxpt,&
            t_rxpt,t_zxpt,aa
       WRITE(t_logunit,3000)ib,t_nitr,s_jx,s_kx,t_raxis,t_zaxis,s_jxpt,s_kxpt,&
            t_rxpt,t_zxpt,aa
    ELSEIF(t_nprt59==2 .OR. (t_nprt59==0 .AND. ib>nll)) THEN
       WRITE(STDOUT,2000)t_nitt,t_residj,s_jxpt,s_kxpt,t_rxpt,t_zxpt,bb,pp,aa
       WRITE(t_logunit,2000)t_nitt,t_residj,s_jxpt,s_kxpt,t_rxpt,t_zxpt,bb,&
            pp,aa
    END IF
 1000 format(i3,' res=',1pe10.3,1pe10.3,' plc= ',1pe10.3,&
           ' theta= ',1pe9.3,' psil= ',1pe10.3)
 2000 format(' res(',i3,')= ',1pe10.3,'  xpt(',i2,',',i3,')= ',1pe10.3,',',&
           1pe10.3,a,1pe10.3,a)
 3000 format(i3,i3,' axis(',i2,',',i3,')= ',1pe9.3,',',1pe10.3,&
           ' xpt(',i2,',',i3,')= ',1pe9.3,',',1pe10.3,a)
 4000 format(' res(',i3,')= ',1pe10.3,' axis(',i2,',',i3,')= ',1pe10.3,&
           ',',1pe10.3,a,1pe10.3)
  END SUBROUTINE gs_equilb

  SUBROUTINE gs_equilc
    include "debug.i"
    INTEGER jedge,ncal,imth,nn,iter,nitt_,n
    REAL(rq) dtold,tp,p_
    SAVE dtold
    DATA imth/11/

    !
    !     SOLVE THE GRAD-SHAFRANOV EQUATION FOR GIVEN BOUNDARY VALUES
    !     OF T_PSI AND GIVEN EXTERNAL FLUX T_PSIW ON THE 2D MESH
    !
    !     CHECK FOR CTRL-EI INTERRUPT FROM BASIS:
    CALL RUTHERE
    
    ncal=0
    IF(t_jbdcir/=t_ncircuit .OR. t_nitt==0) ncal=1
    t_rlimm=t_rlim(0);t_zlimm=t_zlim(0)
    DO nn=1, abs(t_ni)
       IF((ndbg4>0 .AND. ndbg4>t_nitt) .OR. t_dt/=dtold .OR. ncal==1) THEN
          t_lcal=1
          dtold=t_dt
       END IF
       t_nitr=nn
       t_nitt=t_nitt+1
       IF(t_nitr/=1) CALL gs_psiscl
       CALL gs_pdesol
       t_ixp = t_ixpt
       i_cps(:,1,1)=t_psi
       CALL bispline_interp(t_r,t_z,i_cps,imth,t_n4)
       IF(t_nsym/=0) THEN
          CALL gs_curcal(t_lcal)
       END IF
       CALL gs_separatrix
       CALL t_stretch(t_lsrf,t_psil,t_psix)
       IF(t_ipj/=0 .AND. t_ipj<3 .AND. t_inv_eq==0) &
            CALL s_xohmic(nter_interp,iter)
       IF(t_ipj==3 .OR. t_ipj==4 .OR. t_ipj==5) THEN ! 4and 5 are from qsave 
                                                     ! except 5 never scales
          CALL s_adiabat ! forces qsrf or jparsrf and prsrf 
                         ! from qsave,jparsave,psave
       ELSEIF(t_inv_eq==1) THEN
          nitt_=t_nitt
          IF(t_nitt==1) t_inv_eq=0
          t_fix_bound=.false.
          CALL teq_inv(t_inv_k,t_inv_p)
          t_nitt=nitt_
          CALL s_source_inv
       END IF
       IF(t_ipj==0 .AND. t_inv_eq==0) THEN
       END IF
       if(ndbg28==-2) CALL parsestr("debug_equilc")
       jedge=t_kedge
       IF(t_kedge==2) t_kedge=-1
       IF(t_inv_eq==0 .OR. (t_ipf==999 .AND. iabs(t_ipp)==999)) THEN
          t_clj=t_psi     ! t_clj,crje calculated later, ok here
          IF(t_ipf/=-1 .AND. t_ipf/=-8) THEN ! No outside region
             WHERE(s_lxpt<0) s_lxpt=1
          END IF
          CALL s_sourceGS(t_clj,t_rm,t_crj,t_pvec)
          t_bt=t_clj/t_rm
          t_kedge=jedge
          IF(t_kedge==2) THEN
             CALL shift
             CALL s_sourceGS(psish,rmsh,t_clj,crje)
          END IF
       END IF
       t_kedge=jedge
       IF(ndbg28==1) THEN
       CALL parsestr('<<"after sourceGS in equilc";call separatrix_interface')
          CALL debugger
       END IF
       CALL gs_clcalc
       CALL gs_errors
       IF((t_limw/=0 .AND. t_dt==0) .OR. (t_limw/=0 .AND. t_nitt<=t_limw)) THEN
          CALL gs_getlimtr(t_psil,t_rlim(0),t_zlim(0),t_dlim(0))
          t_rlimm=t_rlim(0);t_zlimm=t_zlim(0)
       END IF
       IF(t_residj<=t_epsj) EXIT
    END DO
  END SUBROUTINE gs_equilc

  SUBROUTINE gs_getlimtr(psis,t_rlim,t_zlim,t_dlim)
    REAL(rq) :: psis,t_rlim,t_zlim,t_dlim,y1,plim_(t_lmax,1)
    REAL(rq), DIMENSION(t_lmax) :: c0_,c1_,c2_,d0_,d1_,d2_
    REAL(rq) :: pmax,dpl,dmi,pp,pm,pmp,pmpp,tmax,rmax,zmax,amin,amax
    INTEGER :: ier,isw,ipm,jmin,jmax
    include "debug.i"

    ier=1
    isw=0
    y1=-666
    IF(t_nsym==1) y1=t_splbdry
    ! reset limiter coordinate system
    t_tlimw=atan2((t_zlimw-t_zaxis)/t_wvert,t_rlimw-t_raxis) 
    WHERE(t_tlimw<0)
       t_tlimw=t_tlimw+TWOPI
    END WHERE
    CALL boxm_interp(t_rlimw,t_zlimw,plim_,i_r,i_z,i_cps,isw,ier,t_n4)
    CALL interp_interp(t_tswpts,t_rls,y1,y1,t_tlimw,c0_,c1_)
    CALL interp_interp(t_tswpts,t_zls,y1,y1,t_tlimw,d0_,d1_)

    d1_=sqrt((c0_-t_raxis)**2+(d0_-t_zaxis)**2/t_wvert**2)
    d2_=sqrt((t_rlimw-t_raxis)**2+(t_zlimw-t_zaxis)**2/t_wvert**2)
    d0_=d1_-d2_

    pmax=xmaxaf(d0_,1,t_lmax,1,ipm)
    IF(ipm==1) ipm=2
    IF(ipm==t_lmax) ipm=t_lmax-1

    !    Refine distances      

    IF(ndbg13==1) THEN
       dpl=t_tlimw(ipm+1)-t_tlimw(ipm)
       dmi=t_tlimw(ipm-1)-t_tlimw(ipm)
       pp=(d0_(ipm+1)-pmax)/dpl
       pm=(d0_(ipm-1)-pmax)/dmi
       pmp=(pm*dpl-pp*dmi)/(dpl-dmi)
       pmpp=2*(pp-pm)/(dpl-dmi)
       tmax=-pmp/pmpp
       !  Maximum distance between (including sign)  boundary - limiter
       pmax=pmax-0.5_rq*pmp**2/pmpp
       rmax=t_rlimw(ipm)
       pp=(t_rlimw(ipm+1)-rmax)/dpl
       pm=(t_rlimw(ipm-1)-rmax)/dmi
       !  T_R position on limiter on ray thru maximum
       rmax=rmax+(pm*dpl-pp*dmi)/(dpl-dmi)*tmax+(pp-pm)/(dpl-dmi)*tmax**2
       zmax=t_zlimw(ipm)
       pp=(t_zlimw(ipm+1)-zmax)/dpl
       pm=(t_zlimw(ipm-1)-zmax)/dmi
       !  T_Z position on limiter on ray thru maximum
       zmax=zmax+(pm*dpl-pp*dmi)/(dpl-dmi)*tmax+(pp-pm)/(dpl-dmi)*tmax**2
       !  Angle on limiter on ray thru maximum
       tmax=t_tlimw(ipm)+tmax

    ELSE
       d1_=t_tlimw
       CALL spline_interp(d1_,d0_,t_splbdry,t_splbdry,c1_,c2_,c0_,noint)
       tmax=1-2*c0_(ipm)*c1_(ipm)/c2_(ipm)**2
       tmax=-2*c1_(ipm)/c2_(ipm)/(1+sqrt(abs(tmax)))
       IF(tmax>t_tlimw(ipm+1)-t_tlimw(ipm)) THEN
          ipm=ipm+1
          tmax=1-2*c0_(ipm)*c1_(ipm)/c2_(ipm)**2
          tmax=-2*c1_(ipm)/c2_(ipm)/(1+sqrt(abs(tmax)))
       ELSEIF(tmax<t_tlimw(ipm-1)-t_tlimw(ipm)) THEN
          ipm=ipm-1  
          tmax=1-2*c0_(ipm)*c1_(ipm)/c2_(ipm)**2
          tmax=-2*c1_(ipm)/c2_(ipm)/(1+sqrt(abs(tmax)))
       END IF

       !  Maximum distance between (including sign)  boundary - limiter
       pmax=d0_(ipm)+tmax*(c1_(ipm)+0.5_rq*tmax*(c2_(ipm)+tmax*c0_(ipm)/3))
       CALL spline_interp(t_tlimw,t_rlimw,t_splbdry,t_splbdry,c1_,c2_,c0_,&
            noint)
       !  T_R position on limiter on ray thru maximum
       rmax=t_rlimw(ipm)+tmax*(c1_(ipm)+0.5_rq*tmax*(c2_(ipm)+tmax*c0_(ipm)/3))
       CALL spline_interp(t_tlimw,t_zlimw,t_splbdry,t_splbdry,c1_,c2_,c0_,&
            noint)
       !  T_R position on limiter on ray thru maximum
       zmax=t_zlimw(ipm)+tmax*(c1_(ipm)+0.5_rq*tmax*(c2_(ipm)+tmax*c0_(ipm)/3))
    END IF
    !  Angle on limiter on ray thru maximum
    tmax=t_tlimw(ipm)+tmax
    t_rlim=rmax
    t_zlim=zmax
    t_dlim=pmax
    !    End refine

    CALL xminmax(t_tlimw,1,t_lmax,1,amin,amax,jmin,jmax)
    IF(tmax<amin) THEN
       t_rlim=t_rlimw(jmin)
       t_zlim=t_zlimw(jmin)
    ELSEIF(tmax>amax) THEN
       t_rlim=t_rlimw(jmax)
       t_zlim=t_zlimw(jmax)
    END IF
  END SUBROUTINE gs_getlimtr

  SUBROUTINE gs_pdesol
    REAL(rq)  wvec(npdesol)
    REAL(rq) ::  raa,rbb,zdd,zd,alpx,btax,pertrb
    INTEGER :: iorder,nr,nz,idmn,ierror
    INTERFACE
       SUBROUTINE cofx(x,afun,bfun,cfun)
         USE sep_utils
         REAL(rq) ::  x,afun,bfun,cfun
       END SUBROUTINE cofx
    END INTERFACE
    wvec(1)=npdesol
    iorder = 2
    raa    = t_r(1)
    rbb    = t_r(t_jm)
    zdd    = t_z(1)
    zd     = t_z(t_km)
    nr     = t_jm - 1
    nz     = t_km - 1
    idmn   = t_jm
    !

    IF(t_int_flag<=0) THEN
       wk(:,1)=t_crj + t_clj
       psiv=RESHAPE(t_psi,(/t_jm,t_km/))
    ELSE
       wk(:,1)=t_crj
       psiv=RESHAPE(t_psi,(/t_jm,t_km/))-RESHAPE(t_psiw,(/t_jm,t_km/))
    END IF
    !
    alpx = 0.0  ! not used
    btax = 0.0  ! not used

    CALL sepx4( iorder,raa,rbb,nr,1,bda,alpx,bdb,btax,zdd,zd,nz,1,bdc,bdd,&
         cofx,wk,psiv,idmn,wvec,pertrb,ierror )
    npdesol=wvec(1)
    !
    IF(t_int_flag<=0) THEN
       t_psi = RESHAPE(psiv,(/t_jmkm/))
    ELSE
       t_psi = RESHAPE(psiv,(/t_jmkm/)) + t_psiw
    END IF
    !
  END SUBROUTINE gs_pdesol

  SUBROUTINE gs_psiext
    REAL(rq) p_si(t_jm,t_km)
    INTEGER ::  nn,l1,kl,i,l2,j,k,l,neu,nel,n
    IF( t_kgreenc==1) THEN   !   USE STORED VALUES
       !
       nn=0
       l1=1
       p_si=0
       IF( t_nsym==1 ) THEN   !   SYMMETRIC CONFIGURATION...
          kl=t_km/2+1
          DO i=1,t_nc/2
             l2=t_loop0(i)
             IF(t_iferro(i)==1) THEN
                DO l=l1,l2
                   nn=nn+1
                   p_si(:,:kl)=p_si(:t_jm,:kl)+1.0e+5_rq*t_gc(:,:kl,nn)*&
                        t_ccf(l)
                END DO
             ELSE
                nn=nn+1
                p_si(:,:kl)=p_si(:,:kl)+1.0e+5_rq*t_gc(:,:kl,nn)*t_cc(i)
             END IF
             l1=l2+1
          END DO
          DO k=kl+1,t_km
             p_si(:,k)=p_si(:,t_km+1-k)
          END DO
          t_psiw=RESHAPE(p_si,(/t_jmkm/))
          ! 
       ELSEIF( t_nsym==2 ) THEN  !   NON-SYMMETRIC CONFIGURATION...
          !
          DO i=1,t_nc
             l2=t_loop0(i)
             IF(t_iferro(i)==1) THEN
                DO l=l1,l2
                   nn=nn+1
                   p_si=p_si+1.0e+5_rq*t_gc(:,:,nn)*t_ccf(l)
                END DO
             ELSE
                nn=nn+1
                p_si=p_si+1.0e+5_rq*t_gc(:,:,nn)*t_cc(i)
             END IF
             l1=l2+1
          END DO
       END IF
       t_psiw=RESHAPE(p_si,(/t_jmkm/))
       ! 
    ELSEIF ( t_kgreenc == 0 ) THEN
       ! 
       IF( t_nsym==1 ) THEN   !  CALCULATE SYMMETRIC CONFIGURATION...
          ! 
          kl = t_km/2 + 1
          DO k=kl,t_km
             DO j=1,t_jm
                neu = ( k - 1 )*t_jm + j
                t_psiw(neu) = g_flxc(t_r(j),t_z(k))
                IF( k/=kl ) THEN
                   nel       = ( t_km - k )*t_jm + j
                   t_psiw(nel) = t_psiw(neu)
                END IF
             END DO
          END DO
          !
       ELSEIF( t_nsym==2 ) THEN  !  NON-SYMMETRIC CONFIGURATION...
          ! 
          DO k=1,t_km
             DO j=1,t_jm
                n   = ( k - 1 )*t_jm + j
                t_psiw(n) = g_flxc(t_r(j),t_z(k))
             END DO
          END DO
          ! 
       END IF
       ! 
    ELSE
       CALL errdetec(" psiext: ~ 0 <= t_kgreenc <= 1.",1)
    END IF
  END SUBROUTINE gs_psiext

  SUBROUTINE gs_psiscl
    include "debug.i"
    !
    !Scale equilibrium quantities to: fix poloidal flux IF ipscl >0
    !                            fix plasma current IF ipscl=0
    !                            doesn't scale IF ipscl=-1
    !                            fixes F(msrf)=fwall IF ipscl=-2
    REAL(rq) ::  plc_gun,vlt_
    IF(t_ipj==6 .OR. t_ipj==8 .OR. t_ipj==5) THEN
       t_scl=1
       RETURN
    END IF
    IF(t_ipscl==0) THEN
       t_scl=1._rq+t_delta*(t_plcm*1.0e+05_rq/t_plc-1.)
    ELSEIF(t_ipscl==-2) THEN
       t_scl=1._rq+t_delta*(t_fwall/t_frsrf(t_msrf)-1.)
    ELSEIF(t_ipscl==-1) THEN  !  could RETURN, but might want ifscl
       t_scl=1.0_rq
    ELSEIF(t_ipscl==1) THEN
       IF(t_mdpsi>0) THEN !  enforce dpsi00 at middle of mesh when diverted
          t_scl=1._rq+t_delta*(t_dpsi00/(t_psrf(t_mdpsi)-t_psix)-1.)
       ELSE
          t_scl=1._rq+t_delta*(t_dpsi00/(t_psil-t_psix)-1.)
       END IF
    ELSEIF(t_ipscl==2) THEN
       plc_gun=0.5_rq*t_fgun
       t_scl=1._rq+t_delta*(t_plcm_gun*1.0e+05_rq/plc_gun-1)
    ELSEIF(t_ipscl==3) THEN
       t_scl=1.0_rq+t_delta*(t_psilm/t_psil-1)
    ELSEIF(t_ipscl==4) THEN
       CALL vltsec(vlt_,2)
       t_scl=1._rq+t_delta*(t_psires0/t_psires-1.)
    END IF
    IF(ndbg11>=4 .OR. (t_ipj>2 .AND. ndbg11==0)) THEN 
       !these are not scale transformations
       ! prsx=..should have no affect on adiabat (IF bet=0 or 
       ! t_ipj=5, ndbg17=1->Oh-oh )
       ! but will screw up CALL to source in diag: needs prsx& w's 
       ! in synch.

       IF(t_ipj<3) THEN
          t_prsx=t_prsx*t_scl
       END IF
       t_crj=t_crj*t_scl
       RETURN
    END IF
    IF(t_nitr==0) THEN  !  CALL from equila (why special?)
       t_crj=t_crj*t_scl
       t_prsx=t_prsx*t_scl**2
       RETURN
    END IF
    t_prsx=t_prsx*t_scl**2
    ! need to scale prsx (to be determined); t_crj (bndpsi follows psiscl); 
    ! t_psi (resb) others for safety, but watch out
    ! psil=psil*t_scl  !  curcal options use psil, between here and psilms
    ! psix=psix*t_scl  !  any affect?
    ! t_pxpt=t_pxpt*t_scl  !  curcal checks t_pxpt-pxpu,l  scale all or none
    t_crj=t_crj*t_scl
    t_psi=t_psi*t_scl     !  affects resb CALL in bndpsi
    i_cps=i_cps*t_scl     !  any affect?
    !      DO i=1,nfsq  !  source option, now trashed
    !         cfsq(i)=cfsq(i)*t_scl**2
    !      END DO
    !      DO i=1,nprs
    !         cprs(i)=cprs(i)*t_scl**2
    !      END DO
  END SUBROUTINE gs_psiscl

  SUBROUTINE gs_errors
    REAL(rq) ::  dzrsq,resid1,pnrm,rjnrm,dnrm,delpsi
    INTEGER j,n,jbeg,jend,k
    dzrsq=(t_dz/t_dr)**2
    DO j=1,t_jm
       rlo(j)=dzrsq/(1.-.5_rq*t_dr/t_r(j))
       rup(j)=dzrsq/(1.+.5_rq*t_dr/t_r(j))
       rdi(j)=2._rq+rup(j)+rlo(j)
    END DO
    !
    ! calculate resid = del-star t_psi - rhs
    n=1
    t_resid=0.
    resid1=0.
    dnrm=0.0
    jbeg=2
    jend=t_km-1
    DO k=2,t_km-1
       IF(t_ierr1==1) THEN ! test on plasma current only
          jbeg=s_jbl(k)
          jend=s_jbu(k)
          n=t_jm*(k-1)+jbeg-1
       END IF
       DO j=jbeg,jend
          n=n+1
          delpsi=(t_psi(n-t_jm)+rlo(j)*t_psi(n-1)-rdi(j)*t_psi(n)+rup(j)*&
               t_psi(n+1)+t_psi(n+t_jm))/t_dz**2
          dnrm=dnrm+abs(delpsi)
          resid1=resid1+abs(delpsi-t_crj(n)-t_clj(n))
          t_resid=t_resid+abs(delpsi-crjr(n))
       END DO
    END DO
    IF(t_ierr1==0) t_resid=resid1
    t_resid=t_resid/dnrm
    !
    ! calculate error = t_psi - psiold
    t_error=0.
    pnrm=0.0
    t_error=SUM(abs(t_psi-psir))/SUM(abs(t_psi))
    ! calculate residj = j - jold
    IF(t_nitr/=0) THEN
       t_residj=sum(abs(t_crj-crjr))/sum(abs(t_crj))
    END IF
    psir=t_psi
    crjr=t_crj
  END SUBROUTINE gs_errors

  SUBROUTINE gs_intcls
    INTEGER ::  j,k,n
    DO  n=1,t_ncf
       t_intc(n) = 0
       IF(t_rcf(n)>=t_rn .AND. t_rcf(n)<=t_rx .AND. t_zcf(n)>=t_zn .AND.&
            t_zcf(n)<=t_zx) THEN
          t_intc(n) = 1
          DO j=1,t_jm
             IF(t_r(j)>=t_rcf(n)) EXIT
             t_jnt(n) = j
          END DO
          DO  k=1,t_km
             IF(t_z(k)>=t_zcf(n)) EXIT
             t_knt(n) = k
          END DO
       END IF
    END DO
  END SUBROUTINE gs_intcls

  SUBROUTINE gs_plbdry
    REAL(rq) ::  dth,th,dthu,dthl
    INTEGER i,n,nuu,nll
    IF(t_nbd==0) RETURN
    !
    IF(t_ibdry==0) THEN
       DO  i=1,t_nbd
          IF( t_zbd(i)<0 .AND. t_nsym<2 )&
               CALL errdetec("Plbdry error: symmetric case with zbd < 0",1)
       END DO
    ELSEIF( t_ibdry==1 ) THEN
       dth=Pi/t_nbd
       IF(t_nsym==2) dth=2*dth
       DO n=1,t_nbd
          th=(n-1)*dth + t_dtofst
          t_tbd(n)=th
          IF(th<=Pi) THEN
             t_rbd(n)=t_ro+t_rfix*cos(th+t_dbdu*sin(th)+t_queu*sin(2*th))&
                  +t_bbdu*t_rfix*cos(2*th)-t_rfix*t_bbdu
             t_zbd(n)=t_rfix*t_ebdu*sin(th)
          ELSE
             t_rbd(n)=t_ro+t_rfix*cos(th+t_dbdl*sin(th)+t_quel*sin(2*th))+&
                  t_bbdl*t_rfix*cos(2*th)-t_rfix*t_bbdl
             t_zbd(n)=t_rfix*t_ebdl*sin(th)
          END IF
       END DO
    ELSE
       IF( t_nsym/=2 ) CALL errdetec(&
            "plbdry: found t_nsym/=2 with asymmetric plbdry points.",1)
       dthu=Pi/t_nbdu
       dthl=Pi/t_nbdl
       n=0
       th=0.0
       DO nuu=1,t_nbdu
          n=n+1
          th=th+dthu
          t_rbd(n)=t_ro+t_rfix*cos(th+t_dbdu*sin(th)+t_queu*sin(2._rq*th))+&
               t_bbdu*t_rfix*cos(2._rq*th)-t_rfix*t_bbdu
          t_zbd(n)=t_rfix*t_ebdu*sin(th)
       END DO
       DO  nll=1,t_nbdl
          n=n+1
          th=th+dthl
          t_rbd(n)=t_ro+t_rfix*cos(th+t_dbdl*sin(th)+t_quel*sin(2._rq*th))+&
               t_bbdl*t_rfix*cos(2._rq*th)-t_rfix*t_bbdl
          t_zbd(n)=t_rfix*t_ebdl*sin(th)
       END DO
       IF( t_nbd/=n ) CALL errdetec("plbdry: t_nsym=2, t_nbd ne n",1)
    END IF
  END SUBROUTINE gs_plbdry

  SUBROUTINE gs_curmag
    include "debug.i"
    !
    ! Compute magnetization current in ferromagnetic coils.
    ! (Recalculation of Green functions can be forced by changing ngp
    ! or setting ncfo=0.)
    !
    ! n.b.: coils that are one filament "high" and > one filament
    ! "wide" [nzc(n)==1& nrc(n)>1] are not done correctly.
    !

    INTEGER :: i,j,jk,jkl,k,kl,l,n,nhi,nhim,nlo,nlom,loom,loop
    INTEGER :: kk,jj,ll,mm,nn,k1,k2,l1,l2,ir,iz
    REAL(rq) ::  bcmag,bmr,bmz,mag,brr,bzz
    
    nlo=1 
    nlom=1 
    mm=0
    DO k=1,t_ncf
       t_ccmf(k)=0.
    END DO
    DO n=1,t_ncplot/(3-t_nsymc)
       nhi=t_loop0(n)
       nhim=t_loopm(n)
       IF(t_iferro(n) == 1) THEN
          ! Compute b_r, b_z from plasma at center of "filament" faces 
          kl=t_km
          IF (t_nsym <= 1) kl=t_km/2+1
          jkl=t_jm*kl
          loop=mm
          DO kk=nlo,nhi
             mm=mm+1
             brr=0.
             bzz=0.
             DO jk=1,jkl ! contribution from plasma current
                brr=brr - t_gfbr(jk,1,mm)*t_crj(jk)
                bzz=bzz - t_gfbz(jk,1,mm)*t_crj(jk)
             END DO
             t_br0p(mm)=1.0e-04_rq*brr*t_dr*t_dz/FOURPI ! MKS
             t_bz0p(mm)=1.0e-04_rq*bzz*t_dr*t_dz/FOURPI
          END DO
          ! Now we get field at center of faces and store in bzgp etc.
          ! loom=nlom-1
          DO ir=1,t_nrc(n)
             DO iz=1,t_nzc(n)
                loop=loop+1
                loom=loom+1
                t_brgp(loom)=t_br0p(loop)
                t_bzgp(loom)=t_bz0p(loop)
             END DO
             loop=loop+1
             loom=loom+1
             t_brgp(loom)=t_br0p(loop)
             t_bzgp(loom)=t_bz0p(loop)
             DO iz=1,t_nzc(n)
                loop=loop+1
                loom=loom+1
                t_brgp(loom)=0.5_rq*(t_br0p(loop)+t_br0p(loop+1))
                t_bzgp(loom)=0.5_rq*(t_bz0p(loop)+t_bz0p(loop+1))
                IF(ir/=t_nrc(n)) THEN
                   ! Stores fields at right inside face in t_bz0p, etc
                   t_br0p(loop)=0.5_rq*(t_br0p(loop)+t_br0p(loop+t_nzc(n)+2))
                   t_bz0p(loop)=0.5_rq*(t_bz0p(loop)+t_bz0p(loop+t_nzc(n)+2))
                END IF
             END DO
             loop=loop+1
             ! Store field on top, overwrites incorrect value
             t_brgp(loom)=t_br0p(loop)
             t_bzgp(loom)=t_bz0p(loop)
             IF(ir/=t_nrc(n)) loop=loop-t_nzc(n)-1 !  reset count  
          END DO
          DO iz=1,t_nzc(n)
             loop=loop+1
             loom=loom+1
             t_brgp(loom)=t_br0p(loop)
             t_bzgp(loom)=t_bz0p(loop)
          END DO
          ! end move to t_bzgp etc
          DO l=nlom,nhim
             bmr=t_brgp(l) ! plasma contribution
             bmz=t_brgp(l) 
             nn=0
             l1=1
             DO k=1,t_nc/(3-t_nsymc)   ! contribution from coil currents
                IF(t_iferro(k)==1) THEN
                   DO ll=l1,t_loop0(k)
                      nn=nn+1
                      bmr=bmr+t_gsbr(nn,l)*t_ccf(ll)  
                      bmz=bmz+t_gsbz(nn,l)*t_ccf(ll)
                   END DO
                ELSE
                   nn=nn+1
                   bmr=bmr+t_gsbr(nn,l)*t_cc(k)  
                   bmz=bmz+t_gsbz(nn,l)*t_cc(k)
                END IF
                l1=t_loop0(k)+1
             END DO
             t_brgp(l)=bmr ! total poloidal field at faces
             t_bzgp(l)=bmz
          END DO
          DO l=nlom,nhim
             bcmag=sqrt(t_brgp(l)**2+t_bzgp(l)**2)
             mag=t_magfac*tanh(bcmag/t_bsat)/bcmag
             t_bzgp(l)=mag*t_dzc(n)/t_nzc(n)*t_bzgp(l) ! for line integeral
             t_brgp(l)=mag*t_drc(n)/t_nrc(n)*t_brgp(l)
          END DO
          ! compute t_ccmf, the magnetization current
          IF(ndbg3==0) THEN
             loop=nlo-1
             loom=nlom-1
             DO iz=1,t_nzc(n)
                loop=loop+1
                loom=loom+1
                t_ccmf(loop)=-t_bzgp(loom)
             END DO
             DO ir=1,t_nrc(n)
                IF(ir/=1) loom=loom+t_nzc(n)
                loop=loop+1
                t_ccmf(loop)=t_brgp(loom+1)
                DO iz=1,t_nzc(n)
                   loop=loop+1
                   loom=loom+1
                   t_ccmf(loop)=-t_brgp(loom)+t_brgp(loom+1)-t_bzgp(loom+&
                        t_nzc(n)+1)+t_bzgp(loom-t_nzc(n))
                END DO
                loop=loop+1
                loom=loom+1
                t_ccmf(loop)=-t_brgp(loom)
             END DO
             DO iz=1,t_nzc(n)
                loop=loop+1
                loom=loom+1
                t_ccmf(loop)=t_bzgp(loom)
             END DO
          ELSE ! kaiser's
             nn=t_nzc(n)    ! internal filaments
             l=nlom-2  
             k=nlo+nn-2
             DO i=1,t_nrc(n)
                k=k+2
                l=l+nn+1
                DO j=1,nn
                   k=k+1
                   l=l+1
                   t_ccmf(k)=t_bzgp(l-nn)-t_bzgp(l+nn+1)+t_brgp(l+1)-t_brgp(l)
                END DO
             END DO
             k1=nlo-1    ! surface filaments
             k2=nhi+1    ! vertical edges:
             l1=nlom-1
             l2=nhim+1
             DO j=1,nn
                t_ccmf(k1+j)=-t_bzgp(l1+j)  ! left
                t_ccmf(k2-j)= t_bzgp(l2-j)  ! right
             END DO
             k1=nlo+nn   ! horizontal edges:
             k2=k1+nn+1
             l1=nlom+nn
             l2=l1+nn
             DO i=1,t_nrc(n)
                t_ccmf(k1)= t_brgp(l1)   ! bottom
                t_ccmf(k2)=-t_brgp(l2)   ! top
                k1=k1+nn+2
                k2=k2+nn+2
                l1=l1+2*nn+1
                l2=l2+2*nn+1
             END DO
          END IF             
       ELSE
          mm=mm+1
       END IF  ! t_iferro(n)=1
       nlo=nhi+1
       nlom=nhim+1
    END DO   ! n=1,t_ncplot/(3-t_nsymc)
    IF(t_nsymc == 1)THEN  ! set lower-half mag current IF up/down symmetric
       DO k=t_ncf/2+1,t_ncf
          t_ccmf(k)=t_ccmf(k-t_ncf/2)
       ENDDO
    END IF  ! t_nsymc=1
  END SUBROUTINE gs_curmag

  SUBROUTINE gs_separatrix
    CALL separatrix_separatrix(t_r,t_z,t_psi,t_rxpr,t_zxpr,t_rlimm,t_zlimm,&
         i_tswpts,t_rls,t_zls,t_psix,t_raxis,t_zaxis,t_psil,t_pxpt,t_rxpt,&
         t_zxpt,t_ixp,t_nsym,t_wvert,t_theta,t_n4)
    CALL boundary_separatrix(t_ipf,t_jwl,t_jwu,s_lxpt)
    t_br= -i_cps(:,1,2)/t_rm
    t_bz=  i_cps(:,2,1)/t_rm
    t_bp=  sqrt(t_br**2+t_bz**2)
    t_bmod=sqrt(t_bt**2+t_bp**2)
END SUBROUTINE gs_separatrix
  
  SUBROUTINE initsi
    REAL(rq) ::  rclplas(4),zclplas(4),fl(t_jmkm),flr(t_jmkm),flz(t_jmkm),&
         zbsq,tloc,delps,psisl,psisu,expt2,zksq,pis
    INTEGER :: j,k,n,m4
    !
    !     initialize the solution (psi)
    !

    IF(t_initflx==0 ) THEN
       !   Strickler i.c.
       n=1
       DO k=1,t_km
          zksq=(t_z(k)/(t_r(1)-t_ro)/t_elx)**2
          DO j=1,t_jm
             t_psi(n)=t_psix*(1.-zksq-((t_r(j)-t_ro)/(t_r(1)-t_ro))**2)
             n=n+1
          END DO
       END DO
    ELSEIF(t_initflx==1) THEN
       !   models plasma as filament
       tloc = .5_rq*(t_r(t_jm/2+1) + t_r(t_jm/2+2))
       rclplas(1) = tloc+t_dr
       rclplas(2) = tloc-t_dr
       rclplas(3) = tloc
       rclplas(4) = tloc
       zclplas(1) = 0.
       zclplas(2) = 0.
       zclplas(3) = t_ebdu*t_dr
       zclplas(4) = -t_ebdu*t_dr          ! dipole current not in yet
       m4=4
       IF(t_ebdu==1.0) m4=1
       pis=0
       DO j = 1,m4
          CALL mutual_utils(t_rm,t_zm,rclplas(j),zclplas(j),fl,flr,flz,1)
          t_psi=t_psi+fl/m4
       END DO
       !   smooth at axis or large psi causes trouble
       DO  k = t_km/2-1,t_km/2+3
          psisl=t_psi(t_jm*(k-1)+t_jm/2-1)
          psisu=t_psi(t_jm*(k+3)+t_jm/2+3)
          DO j = t_jm/2-1,t_jm/2+3
             n = (k-1)*t_jm + j
             delps=.25_rq*(psisu-psisl)*(j-t_jm/2+1)
             t_psi(n)=psisl+delps
          END DO
       END DO
       tloc = t_psi((t_km/2)*t_jm+1)
       CALL gs_psiext
       t_psi=-20*(t_psi-tloc)/t_plcm+t_psiw
    ELSEIF(t_initflx==2) THEN
       !   has symmetric x-points, elongation t_ebdu at psi-psi_axis=psil-psix,
       !   no triangularity; psil encloses finit2*(pxpt-paxis)
       expt2 = t_ebdu**2*t_finit2/(1-SQRT(1-t_finit2))
       DO k=1,t_km
          zksq = t_finit2/(t_rb*expt2)**2*(t_z(k)**2-expt2*t_rb**2/t_finit2)**2
          DO j=1,t_jm
             t_psi((k-1)*t_jm+j) = (t_r(j)-t_ro)**2 - zksq
          END DO
       END DO
       tloc = t_psi((t_km/2)*t_jm+1)
       t_psi=(t_psi-tloc)*(t_psil-t_psix)/t_rb**2
    ELSEIF(t_initflx==3) THEN
       !   asymmetric, single x-point, enclosing psil-psix
       IF(t_nsym/=2) CALL errdetec("initsi: t_nsym/=2, flux t_ic asymmetric",1)
       tloc = t_rb*(t_ebdu+t_ebdl)/2
       DO k=1,t_km
          zksq = 27._rq/32._rq*(t_z(k)-tloc)*(t_z(k)**2-tloc**2)/tloc**3
          DO j=1,t_jm
             t_psi((k-1)*t_jm+j) = (t_r(j)-t_ro)**2/t_rb**2 - zksq
          END DO
       END DO
       tloc = t_psi((t_km/2)*t_jm+1)
       t_psi=(t_psi-tloc)*(t_psil-t_psix)
    ELSEIF(t_initflx==4) THEN
       IF(t_keqic==3) THEN
          t_psi=t_psi01
       ELSE
          t_psi=t_psi00
       END IF
    ELSE
       CALL errdetec("Bad value of t_initflx in initsi",1)
    END IF
  END SUBROUTINE initsi

  SUBROUTINE setpfc
    REAL(rq) :: geom,sumr,sumz,sumg
    INTEGER :: icm,n,i,ii,j,jj,ll,m,l1,nn,ncu,kk,nnn,i1,mm,j1,j2,i2,k

    ! IF anything important has changed, set the flags (lgrn=0) to
    ! update the Greens functions...

    geom=SUM(t_rc+SQRT(t_zc**2)+t_drc+t_dzc+t_ac**2+t_ac2**2)
    IF (abs(geom-t_geomo) > 100*errt_rq*geom .AND. t_geomo/=-999) THEN
       t_lgrn=t_kgreenc
       t_ncfo=0
    END IF
    t_geomo= geom

    ! Enforce up/down symmetry, IF requested...

    IF (t_nsymc == 1) THEN
       ncu= t_nc/(3 - t_nsymc)
       DO n=1,ncu
          m=ncu+n
          IF (t_pfid(m) == ' ') t_pfid(m)= t_pfid(n)
          t_rc(m)=    t_rc(n)
          t_zc(m)=   -t_zc(n)
          t_drc(m)=   t_drc(n)
          t_dzc(m)=   t_dzc(n)
          t_ac(m)=   -t_ac(n)
          t_ac2(m)=  -t_ac2(n)
          t_cc(m)=    t_cc(n)
          t_nrc(m)=   t_nrc(n)
          t_nzc(m)=   t_nzc(n)
          t_ic(m)=    t_ic(n)
          t_icc(m)=   t_icc(n)
          t_ix(m)=    t_ix(n)
          t_svec(m)=  t_svec(n)
          t_iferro(m)=t_iferro(n)
          t_icn(m)=   t_icn(n)
          t_pfps0(m)= t_pfps0(n)
          DO i=1,6 ! beware this is hard wired for now
             t_gdc(m,i)= t_gdc(n,i)
          END DO
       END DO
    END IF

    ! Sets up 100*t_rc etc for gradsh.m
    DO n=1,t_nc
       t_rxc(n)=TWOPI*1.e+6*t_rhc(n)*t_rc(n)/t_drc(n)/t_dzc(n)+t_rextc(n)
    END DO

    ! Set the search length for the critical coil...

    IF (t_nfjx > t_nc/(3-t_nsymc)) t_nfjx= t_nc/(3-t_nsymc)

    ! Discretize the coils into unIFormly distributed filaments...

    CALL t_corners(t_rc,t_zc,t_drc,t_dzc,t_ac,t_ac2,t_rc4,t_zc4)
    CALL fe_quad
    !
    !      get coil-to-coil Greens functions for solid coils
    !
    IF(t_ngp/=0 .AND. t_ngp/=t_ngpo) THEN

       DO n=1,t_nc0p*t_nbs
          t_gsbr(n,1)=0
          t_gsbz(n,1)=0
       END DO
       t_ngpo=t_ngp
       DO j=1,t_nbs
          CALL bcoil(t_ncf,t_rcmf,t_zcmf,t_drcf,t_dzcf,t_ccf,t_dfac,t_rgp(j),&
               t_zgp(j),t_rcs,t_zcs)
           l1=1
          nn=0
          DO i=1,t_nc/(3-t_nsymc)
             sumr=0
             sumz=0
             IF(t_iferro(i)==1) THEN
                DO ll=l1,t_loop0(i)
                   nn=nn+1
                   IF(t_nsymc==2) THEN
                      t_gsbr(nn,j)=t_rcs(ll)/t_ccf(ll)
                      t_gsbz(nn,j)=t_zcs(ll)/t_ccf(ll)
                   ELSE
                      kk=ll+t_ncf/2
                      t_gsbr(nn,j)=t_rcs(ll)/t_ccf(ll)+t_rcs(kk)/t_ccf(kk)
                      t_gsbz(nn,j)=t_zcs(ll)/t_ccf(ll)+t_zcs(kk)/t_ccf(kk)
                   END IF
                END DO
             ELSE
                nn=nn+1
                DO ll=l1,t_loop0(i)
                   IF(t_nsymc==2) THEN
                      sumr=sumr+t_rcs(ll)
                      sumz=sumz+t_zcs(ll)
                   ELSE
                      kk=ll+t_ncf/2
                      sumr=sumr+t_rcs(ll)+t_rcs(kk)
                      sumz=sumz+t_zcs(ll)+t_zcs(kk)
                   END IF
                END DO
                t_gsbr(nn,j)=sumr/t_cc(i)
                t_gsbz(nn,j)=sumz/t_cc(i)
             END IF
             l1=t_loop0(i)+1
          END DO
       END DO
       nnn=0
       i1=1
       DO i=1,t_nc/(3-t_nsymc)
          mm=0
          j1=1
          DO j=1,t_nc/(3-t_nsymc)
             sumg=0
             j2=1
             IF(t_iferro(j)==1) j2=t_loop0(j)-j1+1
             DO jj=1,j2
                mm=mm+1
                i2=1
                IF(t_iferro(i)==1) i2=t_loop0(i)-i1+1
                nn=nnn
                DO ii=i1,i2
                   nn=nn+1
                   sumg=sumg+SUM(t_gsbr(nn,:)*t_gsbr(mm,:)+t_gsbz(nn,:)*&
                        t_gsbz(mm,:))
                END DO ! ii loop
             END DO ! jj loop
             t_pbim(i,j)=sumg/(t_nbs*i2*j2)
          END DO ! j loop
          nnn=nn
       END DO
    END IF
    !
    ! get grid to filament Greens functions
    !
    IF(t_kgreenc==1 .AND. t_lgrn==t_kgreenc) THEN !  get Greens functions
       CALL teqGS_interface
       CALL grnfcnst
       t_lgrn=0
    END IF
    IF(t_magfac /= 0.)THEN  ! add magnetization current IF necessary
       icm=1
       DO k=1,t_ncf
          IF(t_ccmf(k) /= 0.)THEN
             icm=0.
             EXIT
          END IF  ! t_ccmf(k)/=0
       END DO
       IF(icm == 1)CALL gs_curmag
       DO k=1,t_ncf
          t_ccf(k)=t_ccf(k)+t_ccmf(k)
       END DO
    END IF  ! t_magfac/=0
  END SUBROUTINE setpfc

  SUBROUTINE setcls
    REAL(rq) :: thl,thh
    INTEGER :: nch,n
    t_cnorm=0.5*ABS(t_plcm)
    !
    !     initialize coil locations, currents if t_ncf=0
    !
    IF(t_ncf/=0) return
    t_ncf=t_ncoil
    IF(t_rocoil<=0.0) t_rocoil=t_ro
    IF(t_rbcoil<=0.0) t_rbcoil=t_rb+0.4_rq*t_rn
    IF(t_elcoil<=0.0) t_elcoil=0.8_rq*t_el
    thl=0.25_rq*TWOPI
    thh=0.35_rq*TWOPI
    nch=t_ncf/2
    t_ncf=nch*2
    t_ncs=t_ncf
    CALL cpts(0.0_rq,TWOPI)
    DO n=1,t_ncf
       t_rcf(n)=t_rcs(n)
       t_zcf(n)=t_zcs(n)+t_zocoil
       t_ccf(n)=20.0*t_ccoil/abs(t_plcm)
       IF(t_ths(n)>=thl .AND. t_ths(n)<thh) t_ccf(n)=-t_ccf(n)
       IF(t_ths(n)>=TWOPI-thh .AND. t_ths(n)<TWOPI-thl) t_ccf(n)=-t_ccf(n)
       t_icf(n)=n
       IF(t_nsym==1 .AND. n>nch) t_icf(n)=t_ncf-n+1
    END DO
  END SUBROUTINE setcls

  SUBROUTINE t_corners(x,y,dx,dy,a,a2,x4,y4)
    REAL(rq), DIMENSION(:), INTENT(IN) ::  x,y,dx,dy,a,a2
    REAL(rq), DIMENSION(:,:), INTENT(OUT) :: x4,y4

    !     Derived from splitc2.for to translate EFIT type parallelogram
    !     (or rectangular) coil sections into corner coordinates for
    !     subsequent discretization by fe_quad.
    !     Jim Leuer, General Atomics, 10-11-94 <leuer@gav.gat.com>
    REAL(rq) :: tana(SIZE(x))
    INTEGER :: n
    n=SIZE(x)
    x4(1,:n)= x(:n) - 0.5_rq*dx(:n)
    x4(2,:n)= x(:n) + 0.5_rq*dx(:n)
    x4(3,:n)= x4(2,:n)
    x4(4,:n)= x4(1,:n)
    y4(1,:n)= y(:n) - 0.5_rq*dy(:n)
    y4(2,:n)= y4(1,:n)
    y4(3,:n)= y(:n) + 0.5_rq*dy(:n)
    y4(4,:n)= y4(3,:n)
    WHERE(a(:n)/=0)   ! Type 1 parallelogram
       tana(:n)= tan(a(:n))
       y4(1,:n)= y(:n) - 0.5_rq*dx(:n)*tana(:n) - 0.5_rq*dy(:n)
       y4(2,:n)= y(:n) + 0.5_rq*dx(:n)*tana(:n) - 0.5_rq*dy(:n)
       y4(3,:n)= y4(2,:n) + dy(:n)
       y4(4,:n)= y4(1,:n) + dy(:n)
    END WHERE
    WHERE(a2(:n)/= 0) ! Type 2 parallelogram
       tana(:n)= tan(a2(:n))
       x4(1,:n)= x(:n) - 0.5_rq*dy(:n)/tana(:n) - 0.5_rq*dx(:n)
       x4(4,:n)= x(:n) + 0.5_rq*dy(:n)/tana(:n) - 0.5_rq*dx(:n)
       x4(2,:n)= x4(1,:n) + dx(:n)
       x4(3,:n)= x4(4,:n) + dx(:n)
    END WHERE
  END SUBROUTINE t_corners

  SUBROUTINE fe_quad

!     Computes the centers of a regular sub-grid within a linear
!     quadrilateral (4 sided) finite element.  The routine takes the
!     coordinates of the 4 corners of the quadrilateral (rc4,t_zc4)
!     and splits the region into a nrc by nzc sub-grid. The grid is
!     uniform and the center is located halfway between grids.  The
!     routine locates the center of each sub-grid and loads the
!     centers into t_rcf,zcf.  Its structure is such that it can be
!     easily increased to higher order quadrilateral elements.
!     Jim Leuer, General Atomics, 10-11-94, <leuer@gav.gat.com>

    REAL(rq), SAVE ::  dsurfo
    INTEGER :: n,loop,j,k,l
    REAL(rq) :: dsur,ddr,ddz,fdx,fdy,fcc,rcin,rcout,zcbot,zctop,xm,xp,x12,&
         x34,y12,y34,ddc,ym,yp,fcx,fcy

    IF(t_dsurf/=dsurfo) then ! surface magnetization storage fix
       t_ngpo=0
       dsurfo=t_dsurf
    END IF
    loop=0
    dsur=.01_rq*t_dsurf !  MKS 
    DO n=1,t_nc
       ddr= t_drc(n)/t_nrc(n)
       ddz= t_dzc(n)/t_nzc(n)
       fdx= 2.0_rq/t_nrc(n)
       fdy= 2.0_rq/t_nzc(n)
       fcc= 1.0_rq/t_nrc(n)/t_nzc(n)
       IF(t_iferro(n)==1) THEN
          rcin= t_rc(n)-0.5_rq*(t_drc(n)+dsur)
          rcout=t_rc(n)+0.5_rq*(t_drc(n)+dsur)
          zcbot= t_zc(n)-0.5_rq*(t_dzc(n)+dsur)
          zctop=t_zc(n)+0.5_rq*(t_dzc(n)+dsur)
          DO k=1,t_nzc(n)
             loop=loop+1
             t_drcf(loop)= dsur
             t_dzcf(loop)= ddz
             t_ccf(loop)=  errt_rq
             t_rcmf(loop)=  rcin
             t_zcmf(loop)=  t_zc(n)-0.5*t_dzc(n)+ddz*(k-0.5)
             t_rcf(loop)= 100*t_rcmf(loop)
             t_zcf(loop)= 100*t_zcmf(loop)
          END DO
       END IF
       DO j=1,t_nrc(n)
          fcx= fdx*(j - 0.5_rq) - 1.0_rq
          xm=  1.0_rq - fcx
          xp=  1.0_rq + fcx
          x12= t_rc4(1,n)*xm + t_rc4(2,n)*xp
          x34= t_rc4(3,n)*xp + t_rc4(4,n)*xm
          y12= t_zc4(1,n)*xm + t_zc4(2,n)*xp
          y34= t_zc4(3,n)*xp + t_zc4(4,n)*xm
          ddc=1.0;IF(j<7) ddc=(1.0 + t_gdc(n,j))
          IF(t_iferro(n)==1) THEN
             loop=       loop+1
             t_drcf(loop)= ddr
             t_dzcf(loop)= dsur
             t_ccf(loop)=  errt_rq
             t_rcmf(loop)=  t_rc(n)-0.5_rq*t_drc(n)+ddr*(j-0.5_rq)
             t_zcmf(loop)=  zcbot
             t_zcf(loop)= 100*t_zcmf(loop)
             t_rcf(loop)= 100*t_rcmf(loop)
          END IF
          DO k=1,t_nzc(n)
             loop=       loop + 1
             fcy=        fdy*(k - 0.5_rq) - 1
             ym=         1 - fcy
             yp=         1 + fcy
             t_rcmf(loop)= 0.25_rq*(ym*x12 + yp*x34)
             t_zcmf(loop)= 0.25_rq*(ym*y12 + yp*y34)
             t_rcf(loop)=  100*t_rcmf(loop)
             t_zcf(loop)=  100*t_zcmf(loop)
             t_drcf(loop)= ddr
             t_dzcf(loop)= ddz
             t_ccf(loop)=  fcc*t_cc(n)*ddc
             t_icf(loop)=  t_ic(n)
             t_icnf(loop)= n
          END DO
          IF(t_iferro(n)==1) THEN
             loop=loop+1
             t_drcf(loop)= ddr
             t_dzcf(loop)= dsur
             t_ccf(loop)=  errt_rq
             t_rcmf(loop)=  t_rc(n)-0.5_rq*t_drc(n)+ddr*(j-0.5_rq)
             t_zcmf(loop)=  zctop
             t_zcf(loop)= 100*t_zcmf(loop)
             t_rcf(loop)= 100*t_rcmf(loop)
          END IF
       END DO
       IF(t_iferro(n)==1) THEN
          DO k=1,t_nzc(n)
             loop=loop+1
             t_drcf(loop)= dsur
             t_dzcf(loop)= ddz
             t_ccf(loop)=  errt_rq
             t_rcmf(loop)=  rcout
             t_zcmf(loop)=  t_zc(n)-0.5_rq*t_dzc(n)+ddz*(k-0.5_rq)
             t_rcf(loop)= 100*t_rcmf(loop)
             t_zcf(loop)= 100*t_zcmf(loop)
          END DO
       END IF
       t_loop0(n)= loop
    END DO
    !   symmetrize if t_nsymc=1
    IF(t_nsymc==1) THEN
       loop=t_ncf/2 
       DO l=1,loop
          t_drcf(l+loop)= t_drcf(l)
          t_dzcf(l+loop)= t_dzcf(l)
          t_rcf(l+loop) = t_rcf(l)
          t_zcf(l+loop) =-t_zcf(l)
          t_rcmf(l+loop)= t_rcmf(l)
          t_zcmf(l+loop)=-t_zcmf(l)
          t_ccf(l+loop) = t_ccf(l)
       END DO
       DO n=1,t_nc/2
          t_loop0(n+t_nc/2)=loop+t_loop0(n)
       END DO
    END IF
  END SUBROUTINE fe_quad

  SUBROUTINE cpts(thmin,thmax)
    REAL(rq), EXTERNAL ::  zeroin_c,qfun,zfun2
    REAL(rq) :: thmin,thmax,abserr,flag,alt,errest,dalt
    INTEGER :: nofun,n
    abserr=0.0
    x_l=t_rocoil
    a_ll=t_rbcoil
    s_l=t_elcoil
    d_l=t_dcoil
    q_l=t_qcoil
    call quanc8(qfun,thmin,thmax,abserr,errt_rq,alt,errest,nofun,flag)
    a_lmax=alt
    dalt=a_lmax/t_ncs
    a_ln=0.5*dalt
    DO n=1,t_ncs
       t_ths(n)=zeroin_c(thmin,thmax,zfun2,errt_rq)
       t_rcs(n)=x_l+a_ll*cos(t_ths(n)+d_l*sin(t_ths(n))+q_l*sin(2.0*t_ths(n)))
       t_zcs(n)=a_ll*s_l*sin(t_ths(n))
       a_ln=a_ln+dalt
    END DO
  END SUBROUTINE cpts

  FUNCTION sumxpy(x,y,n) RESULT(z)
    INTEGER, INTENT(IN) :: n
    REAL(rq),DIMENSION(n), INTENT(IN) :: x,y
    REAL(rq) :: z
    z=SUM(x(:n)*y(:n))
  END FUNCTION sumxpy
END MODULE gradsh_mod

SUBROUTINE cofx(x,afun,bfun,cfun)
  USE sep_utils
  REAL(rq) ::  x,afun,bfun,cfun
  afun=1.0
  bfun=-1.0/x
  cfun=0.0
END SUBROUTINE cofx

FUNCTION qfun(x) RESULT(qfu)
  USE gradsh_mod
  IMPLICIT NONE
  REAL(rq), INTENT(IN) :: x
  REAL(rq) :: drs,dzs,qfu
  drs=-a_ll*(1.0+d_l*cos(x)+2.0*q_l*cos(2.0*x))*sin(x+d_l*sin(x)+q_l*&
       sin(2.0*x))
  dzs=a_ll*s_l*cos(x)
  qfu=SQRT(drs**2+dzs**2)
END FUNCTION qfun

FUNCTION zfun2(x) RESULT(zfu)
  USE gradsh_mod
  IMPLICIT NONE
  REAL(rq), INTENT(IN) :: x
  REAL(rq), EXTERNAL :: qfun
  REAL(rq) :: zfu,abserr,errest,flag,thmin,alx
  INTEGER :: nofun
  abserr=0.0
  thmin = 0.0
  CALL quanc8(qfun,thmin,x,abserr,errt_rq,alx,errest,nofun,flag)
  zfu=alx-a_ln
END FUNCTION zfun2

! $Id: setTeq.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

Module setTeq_mod

  USE gradsh_mod
  USE teqSubs_mod, only : t_stretch

  IMPLICIT NONE

  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE :: psave_,fsave_,psibar_,&
       qsave_,jtsave_,jpsave_,w_,v_,r_,z_,ssave_
  INTEGER, PRIVATE :: nsvd
  DATA nsvd/0/

CONTAINS

  SUBROUTINE getstrg(kstr)
    INTEGER, INTENT(IN) :: kstr
    INTEGER, SAVE :: msrfo,lsrfo,npolyo,jmo,kmo,mlso,nsolo,nprio,lmaxo,limlo,&
         nspho,nfbdo,ngroupo,jqmo,ncpp,nbevmo,nco,n4o,n6o,nloopo
    REAL(rq), SAVE :: hsrfo,elo, rbo, roo, rno, rxo, zxo
    DATA msrfo/1/,lsrfo/-111/,npolyo/0/,jmo/0/,kmo/0/,mlso/0/,hsrfo/-1/,&
         nsolo/0/,nprio/0/,lmaxo/0/,nspho/0/,ngroupo/0/,nco/-1/,elo/0./,&
         rbo/0./,roo/-1234./,rno/-1234./,rxo/-1234./,n4o/6/,n6o/6/,     &
         zxo/-1234./,jqmo/0/,nloopo/0/,ncpp/0/
    INTEGER imth,l1,l2,i,nn,newcellsz,msrfx
    data imth /0/ ! extrapolates 1st derivative
    REAL(rq) :: psilor(t_msrf-1),yy
    REAL(rq), DIMENSION(t_msrf) :: c1
    integer :: sz

    c1=0
    IF(kstr==1) THEN
       ! For rezone: needed here and at the end of kstr=1
       IF(msrfo==t_msrf) THEN
          IF(SIZE(psave_)/=msrfo) THEN
             IF(ALLOCATED(psave_)) DEALLOCATE(psave_,fsave_,qsave_,&
                  jtsave_,jpsave_,psibar_,w_,v_,ssave_)
             ALLOCATE(psave_(msrfo),fsave_(msrfo),qsave_(msrfo),&
                  jtsave_(msrfo),jpsave_(msrfo),psibar_(msrfo),w_(msrfo),&
                  v_(msrfo),ssave_(msrfo))
          END IF
          psave_=t_psave(:msrfo)
          fsave_=t_fsave(:msrfo)
          qsave_=t_qsave(:msrfo)
          jtsave_=t_jtsave(:msrfo)
          jpsave_=t_jparsave(:msrfo)
          jtsave_=t_jtsave(:msrfo)
          psibar_=t_psibar(:msrfo)
          ssave_= t_ssave(:msrfo)
          w_=t_w(:msrfo)
          v_=t_v(:msrfo)
        END IF
       !
       IF(t_map==0) t_map=64
       t_lmax=2*t_map-1
       t_mls=2*t_map-1
       IF(t_nsym==1) t_lmax=t_map
       IF(t_msrf/=msrfo .OR. t_lsrf/=lsrfo .OR. t_hsrf/=hsrfo) THEN
          CALL teq_interface
          CALL t_stretch(t_lsrf,t_psil,t_psix)
          IF(t_ifluxcord==-1) THEN
             CALL fdInt(1.0/t_qsave,t_phibar,t_msrf,t_qh)
             t_psibar=t_qh/t_qh(t_msrf)
             t_dphi00=t_dpsi0/t_qh(t_msrf)
          END IF
          i_psibar=>t_psibar
          psilor=t_psiinv(2:)
          CALL polymatrix(t_psibar,t_dpoly,t_spoly,t_mpoly)
          CALL polymatrix(psilor,t_dpoli,t_spoli,t_mpoli)
          npolyo=t_npoly
          IF(msrfo/=1) THEN
             yy=t_splbdry
             CALL interp_interp(psibar_,psave_,yy,yy,t_psibar,t_psave,c1)
             CALL interp_interp(psibar_,fsave_,yy,yy,t_psibar,t_fsave,c1)
             CALL interp_interp(psibar_,qsave_,yy,yy,t_psibar,t_qsave,c1)
             CALL interp_interp(psibar_,jtsave_,yy,yy,t_psibar,t_jtsave,c1)
             CALL interp_interp(psibar_,jpsave_,yy,yy,t_psibar,t_jparsave,c1)
             CALL interp_interp(psibar_,ssave_,yy,yy,t_psibar,t_ssave,c1)
             IF(t_ipp==999) THEN
                CALL interp_interp(psibar_,v_,yy,yy,t_psibar,t_v,c1)
             END IF
             IF(t_ipf==999) THEN
                CALL interp_interp(psibar_,w_,yy,yy,t_psibar,t_w,c1)
             END IF
             t_qsrf=t_qsave
             t_frsrf=t_fsave
             t_prsrf=t_psave
          ELSEIF(t_frsrf(1)==0) THEN
             t_frsrf=t_fsave
          END IF
          msrfo=t_msrf
          msrfx=t_msrf+1
       END IF
       IF(t_npoly/=npolyo) THEN
          CALL teq_interface
          psilor=t_psiinv(2:)
          CALL polymatrix(t_psibar,t_dpoly,t_spoly,t_mpoly)
          CALL polymatrix(psilor,t_dpoli,t_spoli,t_mpoli)
          npolyo=t_npoly
       END IF
       t_jqd=2*(t_jm+t_km)
       IF(t_jqm<t_jqd) t_jqm=t_jqd
       IF(t_jqm<2*t_map-1) t_jqm=2*t_map-1
       IF(t_lmax/=lmaxo .OR. t_npri/=nprio .OR. t_nsol/=nsolo)  THEN
          t_nsep=t_mls
          IF(t_npri==0) t_npri=t_nsol
          CALL teq_interface
          CALL teqGS_interface
          i_tswpts=>t_tswpts
          jqmo=t_jqm
          lmaxo=t_lmax
          nprio=t_npri
          nsolo=t_nsol
       END IF
       IF(t_ntet/=0) THEN
          IF(t_mls/=t_ntet .OR. t_msrf/=t_npo .OR. t_lsrf/=lsrfo .OR. &
               t_hsrf/=hsrfo) THEN
             IF(t_inv_eq>0) CALL regrdinv
             n6o=t_n6
             t_ntet=t_mls
             t_npo=t_msrf
             IF(ALLOCATED(i_rhosq)) DEALLOCATE(i_rhosq)
             IF(t_n6==6) THEN
                ALLOCATE(i_rhosq(t_npo*t_ntet,2,3))
             ELSE
                ALLOCATE(i_rhosq(t_npo*t_ntet,4,4))
             END IF
             i_rhosq=0
             CALL teq_interface
             IF(t_inv_eq>0) CALL start_inv(t_inv_k,t_inv_p)
          ELSEIF(t_n6/=n6o) THEN
             IF(ALLOCATED(i_rhosq)) DEALLOCATE(i_rhosq)
             IF(t_n6==6) THEN
                ALLOCATE(i_rhosq(t_npo*t_ntet,2,3))
             ELSE
                ALLOCATE(i_rhosq(t_npo*t_ntet,4,4))
             END IF
             i_rhosq=0
             CALL teq_interface
             n6o=t_n6
          END IF
       END IF
       hsrfo=t_hsrf
       lsrfo=t_lsrf
       IF(msrfo==t_msrf) THEN
          sz = 0; if (allocated(psave_)) sz = size(psave_)
          IF(sz/=msrfo) THEN
             IF(ALLOCATED(psave_)) DEALLOCATE(psave_,fsave_,qsave_,&
                  jtsave_,jpsave_,psibar_,w_,v_,ssave_)
             ALLOCATE(psave_(msrfo),fsave_(msrfo),qsave_(msrfo),&
                  jtsave_(msrfo),jpsave_(msrfo),psibar_(msrfo),w_(msrfo),&
                  v_(msrfo),ssave_(msrfo))
             psave_=t_psave(:msrfo)
             fsave_=t_fsave(:msrfo)
             qsave_=t_qsave(:msrfo)
             jtsave_=t_jtsave(:msrfo)
             jpsave_=t_jparsave(:msrfo)
             psibar_=t_psibar(:msrfo)
             ssave_ =t_ssave(:msrfo)
             w_=t_w(:msrfo)
             v_=t_v(:msrfo)
          END IF
       END IF

       newcellsz = 0
       IF((t_liml /= limlo) .OR. (t_liml==-1 .AND. ((t_zx/=zxo) .OR. &
            (t_rx/=rxo) .OR. (t_rn/=rno))) .OR. (t_liml/=-1 .AND. &
            ((t_el/=elo) .OR. (t_rb/=rbo) .OR. (t_ro/=roo)))) newcellsz = 1
       IF(kmo/=0) THEN
          IF(t_jm==jmo .AND. t_km==kmo .AND. newcellsz==0 .AND. &
               t_nsym==t_nsymo) RETURN
          IF((t_keqic==1 .OR. t_keqic==3) .AND. t_initflx==4) CALL errdetec(&
               "can't change dimension and use saved psi's",1)
          !     now interpolate for psi on new mesh
          t_jqd=2*(t_jm+t_km)
          IF(t_jqm<t_jqd) t_jqm=t_jqd
          IF(t_jqm<2*t_map-1) t_jqm=2*t_map-1
          t_jmkm=t_jm*t_km
          CALL regrid(jmo,kmo,r_,z_)
          t_lgrn=t_kgreenc     ! compute gp etc.
          t_nsymo=t_nsym
       ELSE
          t_jmkm=t_jm*t_km
          n4o=t_n4
          t_jqd=2*(t_jm+t_km)
          IF(t_jqm<t_jqd) t_jqm=t_jqd
          IF(t_jqm<2*t_map-1) t_jqm=2*t_map-1
       END IF
       sz = 0; if (allocated(i_cps)) sz = size(i_cps, 1)
       IF(sz/=t_jm*t_km) THEN
          IF(ALLOCATED(i_cps)) DEALLOCATE(i_cps,s_jbl,s_jbu,s_lxpt)
          t_jmkm=t_jm*t_km
          IF(t_n4==6) THEN
             ALLOCATE(i_cps(t_jmkm,2,3))
          ELSE
             ALLOCATE(i_cps(t_jmkm,4,4))
          END IF
          ALLOCATE(s_jbl(t_km),s_jbu(t_km),s_lxpt(t_jmkm))
       ELSEIF(t_n4/=n4o) THEN
          IF(ALLOCATED(i_cps)) DEALLOCATE(i_cps)
          IF(t_n4==6) THEN
             ALLOCATE(i_cps(t_jmkm,2,3))
          ELSE
             ALLOCATE(i_cps(t_jmkm,4,4))
          END IF
       END IF
!       CALL teq_interface
       CALL setgeo(t_rm,t_zm)
       kmo=t_km
       jmo=t_jm
       n4o=t_n4
       limlo=t_liml
       If(t_liml==-1) THEN
          zxo = t_zx
          rxo = t_rx
          rno = t_rn
       ELSE
          elo = t_el
          rbo = t_rb
          roo = t_ro
       END IF
       t_nsymo=t_nsymc

       ! Setup for rezoning.
       IF(jmo==t_jm .AND. kmo==t_km) THEN
          sz = 0; if (allocated(r_)) sz = size(r_)
          IF(sz/=jmo) THEN
             IF(ALLOCATED(r_)) DEALLOCATE(r_)
             ALLOCATE(r_(jmo))
             r_=t_r
          END IF
          sz = 0; if (allocated(z_)) sz = size(z_)
          IF(sz/=kmo) THEN
             IF(ALLOCATED(z_)) DEALLOCATE(z_)
             ALLOCATE(z_(kmo))
             z_=t_z
          END IF
       END IF

       ! End setup for rezoning.

       RETURN
    ELSE
       IF(t_kgreenc==0) THEN
          t_nc0p=1
          t_nc0b=1
          t_jm0p=1
          t_km0p=1
          t_nc0p=0
       ELSE
          t_nc0b=t_nsymc*(t_jm+t_km-t_nsymc)
          IF(t_nc0p/=t_nc/(3-t_nsymc) .OR. t_km0p/=(t_km-1)/(3-t_nsymc)+1 &
               .OR. t_jm0p/=t_jm .OR. (kmo/=0 .AND. (t_nsymc/=t_nsymco .OR. &
               t_ncfo/=t_ncf))) THEN
             t_km0p=(t_km-1)/(3-t_nsymc)+1
             t_nc0p=t_nc/(3-t_nsymc)
             t_jm0p=t_jm
             t_lgrn=t_kgreenc
          END IF
          l1=1
          nn=t_nc0p
          DO i=1,nn
             l2=t_loop0(i)
             IF(t_iferro(i)==1) t_nc0p=t_nc0p+l2-l1
             l1=l2+1
          END DO
       END IF

       ncpp=t_nc
       IF(t_nsymc==1) ncpp=t_nc/2
       t_ncsym=t_nc/(3-t_nsymc)
       nn=ncpp
       l1=1
       DO i=1,nn
          l2=t_loop0(i)
          IF(t_iferro(i)==1) ncpp=ncpp+l2-l1
          l1=l2+1
       END DO
       IF(t_ncf/=t_ncfo .OR. t_ngp/=t_ngpo .OR. t_nsymc/=t_nsymco .OR. &
            t_ngroup/=ngroupo .OR. t_nloop/=nloopo .OR. t_nloop/=t_nloop0p &
            .OR. ncpp/=t_nc0p .OR. t_nfbd/=nfbdo  .OR. t_nsph/=nspho) THEN
          ngroupo=t_ngroup
          nfbdo=t_nfbd
          nloopo=t_nloop
          t_lcal=1
          IF((t_nloop0p/=t_nloop .OR. t_nsph/=nspho)) THEN
             ! will make Green's functions for loops
             t_nloop0p=t_nloop
             nspho=t_nsph
             t_ncfo=0
             t_lgrn=0
          END IF
          IF(t_ncf/=t_ncfo .OR. t_nsymc/=t_nsymco .OR. ncpp/=t_nc0p .OR. &
               t_nloop/=nloopo) THEN
             nloopo=t_nloop
             ! compute gp, Greens function grid and boundary and grid and loops
             t_ngpo=0 ! compute gsbr, gsbz, pbim IF ngp/=0
          END IF
          t_nsymco=t_nsymc
          CALL teqGS_interface
       END IF
    END IF
  END SUBROUTINE getstrg

  SUBROUTINE pfcfils
    INTEGER :: nbc,nb,n,nr,nz,ir,iz
    REAL(rq) :: drg,dzg,rg0,zg0,rg1
    nbc=0
    nb=t_nc
    IF(t_ngp /= 1)nb   = t_ncplot/(3-t_nsymc)  
    DO n=1,nb
       rg0   = t_rc(n) - 0.5_rq*t_drc(n)
       zg0   = t_zc(n) - 0.5_rq*t_dzc(n)
       rg1   = t_rc(n) + 0.5_rq*t_drc(n)
       IF(t_ngp==1) THEN
          nr = t_nrc(n)
          nz = t_nzc(n)
          drg=t_drc(n)/t_nrc(n)
          dzg=t_dzc(n)/t_nzc(n)
       ELSE
          nr    = ( t_drc(n)/t_delc ) + 1
          nz    = ( t_dzc(n)/t_delc ) + 1
          drg   = t_drc(n)/( nr - 1 )
          dzg   = t_dzc(n)/( nz - 1 )
       END IF
       IF(t_ngp==1) THEN
          DO ir=1, nr
             DO iz=1, nz
                nbc=nbc+1
                t_rgp(nbc)=   rg0+(ir-1)*drg
                t_rgp(nbc+nz)=rg0+(ir-0.5_rq)*drg
                t_zgp(nbc)=   zg0+(iz-0.5_rq)*dzg
                t_zgp(nbc+nz)=zg0+(iz-1)*dzg
             END DO
             nbc=nbc+nz+1
             t_rgp(nbc)=t_rgp(nbc-1)
             t_zgp(nbc)=t_zgp(nbc-1)+dzg
          END DO
          DO iz=1, nz
             nbc=nbc+1
             t_rgp(nbc)=rg1
             t_zgp(nbc)=zg0+(iz-0.5_rq)*dzg
          END DO
       ELSE
          DO iz = 1, nz
             DO ir = 1, nr
                nbc      = nbc + 1
                t_zgp(nbc) = zg0 + dzg*(iz - 1)
                t_rgp(nbc) = rg0 + drg*(ir - 1)
             END DO
          END DO
       END IF
       t_loopm(n)=nbc  !  "t_loop0"  for field points
    END DO
  END SUBROUTINE pfcfils


  SUBROUTINE pfcmem
    INTEGER :: i,j,n,idummy,jdummy,ncu,nb,nr,nz
    REAL(rq) :: spco,deltar,deltaz,hmin,smin,wmin,spc,deltaf
    SAVE spco
    INTEGER, SAVE :: ngro,ncro,ircwto,nbso,ncppo
    DATA nbso/0/,spco/0.0/,ncppo/0/, ngro/0/, ncro/0/, ircwto/0/

    ! t_nc is the total number of coils, whether symmetric (nsym==1) or
    ! asymmetric (nsym==2)
    CALL teqGS_interface
    ncu= t_nc/(3 - t_nsymc)
    IF (t_ncplot == 0) t_ncplot= t_nc
    ! IF coil geometry or number of filaments (t_nrc,t_nzc) has changed,
    ! set flag to update Greens functions...

    spc= 0
    DO n=1,ncu
       spc=spc+t_nrc(n)*t_nzc(n)+t_drc(n)*t_dzc(n)+t_ac(n)**2+t_ac2(n)**2+&
            t_rc(n)+t_zc(n)**2
   END DO
    IF (spc /= spco .AND. t_nc0p==ncppo) THEN
       spco=spc
       ncppo=t_nc0p
       t_ngpo=0
       t_ncfo=0
    END IF

    ! Set the cell-size for discretization to be used IF t_nrc,t_nzc==0...

    IF (t_nfil <= 0) t_nfil= 1
    deltar= xminaf(t_drc,1,ncu,1,jdummy)
    deltaz= xminaf(t_dzc,1,ncu,1,jdummy)
    deltaf= min(deltar,deltaz)/t_nfil

    ! Determine the number of filaments to be used for the coil-to-plasma
    ! Greens functions...
    DO n=1,ncu
       IF (t_nrc(n) == 0 .AND. t_nzc(n) == 0) THEN
          IF (t_drc(n) < t_dzc(n)) THEN
             t_nrc(n)= t_drc(n)/deltaf + 0.49_rq
             IF (t_nrc(n) <= 0) t_nrc(n)= t_nfil
          ELSE
             t_nzc(n)= t_dzc(n)/deltaf + 0.49_rq
             IF (t_nzc(n) <= 0) t_nzc(n)= t_nfil
          END IF
       END IF
       IF (t_nzc(n) == 0) t_nzc(n)= t_nrc(n)*t_dzc(n)/t_drc(n) + 0.49_rq
       IF (t_nrc(n) == 0) t_nrc(n)= t_nzc(n)*t_drc(n)/t_dzc(n) + 0.49_rq
    END DO
    t_ncf=0
    DO n=1,ncu
       t_ncf=t_ncf+t_nrc(n)*t_nzc(n)
       t_loop0(n)=t_ncf
       IF(t_nrc(n)>t_ncrmx) t_ncrmx=t_nrc(n)
       IF(t_nzc(n)>t_nczmx) t_nczmx=t_nzc(n)
       IF(t_iferro(n)==1) t_ncf=t_ncf+2*(t_nrc(n)+t_nzc(n))
       t_loop0(n)=t_ncf
    END DO
    IF(t_nsymc==1) t_ncf=2*t_ncf

    ! Determine the number of grid points for coil B-field calculation...
    ! The smallest coil cross-section determines the resolution of the
    ! grid (t_delc) used in *all* coils.

    t_nbs= 0
    IF(t_magfac/=0) t_ngp=1
    IF (t_ngp > 0) THEN
       nb=   t_ncplot/(3-t_nsymc)
       IF (t_ngp==1) THEN  ! grid points at filament-sides
          DO n=1,nb
             t_nbs=t_nbs+2*t_nrc(n)*t_nzc(n)+t_nrc(n)+t_nzc(n)
          END DO
          IF(t_nsymc == 1)t_nbs=2*t_nbs
       ELSE
          wmin= xminaf(t_drc,1,nb,1,jdummy)
          hmin= xminaf(t_dzc,1,nb,1,jdummy)
          smin= min(wmin,hmin)
          t_delc= smin/(t_ngp-1)
          DO n=1,nb
             nr=  t_drc(n)/t_delc + 1
             nz=  t_dzc(n)/t_delc + 1
             t_nbs= t_nbs + nr*nz
          END DO
       END IF
    END IF

    ! Check static memory limit...

    IF (t_nsymc == 1) THEN
       IF (t_nc > T_NC) THEN
          CALL errdetec('*** PFCMEMS: t_nc exceeds array lengths ***',1)
       END IF
    END IF
    IF (t_nbs /= nbso) THEN
       nbso= t_nbs
       t_ngpo= 0
    END IF

    t_icc=0
    t_ncircuit=0
    t_ngroup=0

    DO j=1,t_nc/(3-t_nsymc)
       IF(t_ic(j)/=0) THEN
          IF(t_ic(j)>t_ngroup) t_ngroup=t_ic(j)
          IF(t_ix(j)/=0) THEN
             IF(t_ix(j)>t_ncircuit) t_ncircuit=t_ix(j)
          ELSE
             t_icc(t_ic(j))=1
          END IF
       END IF
    END DO
    IF(t_nsymc==1) THEN
       DO j=1,t_nc/2
          t_ic(j+t_nc/2)=t_ic(j)
          t_ix(j+t_nc/2)=t_ix(j)
          t_svec(j+t_nc/2)=t_svec(j)
       END DO
    END IF

    IF(t_almim==0 .AND. (t_ircwt==9 .OR. (t_ncircuit/=0 .AND. t_ircwt==-1)))&
         THEN
       t_ngroup=t_ngroup+t_nsph+iabs(t_lsph) ! nloops etc
       IF(t_lsph==-1) t_ncircuit=t_ncircuit+1
       nsvd=t_ngroup+t_ncircuit
    END IF
    ! Compute new gmat's in curcal

    IF(t_ncircuit/=ncro .OR. t_ngroup/=ngro .OR. t_ircwt/=ircwto) t_lcal=1
    ncro=t_ncircuit
    ngro=t_ngroup
    ircwto=t_ircwt
    ! Allocate storage for coil filaments and coil grids...

    CALL getstrg(2)
    ! DO the coil gridding, IF requested...

    IF (t_nbs > 0) CALL pfcfils
    IF(t_ngroup==0) RETURN

    t_pfpc0=0
    t_ccls=0
    t_rcg=0
    t_zcg=0

    DO i=1,t_nc/(3-t_nsymc)
       t_pfpc0(t_ic(i))=t_pfpc0(t_ic(i))+t_pfps0(i)*t_cc(i)
       t_zcg(t_ic(i))=t_zcg(t_ic(i))+t_zc(i)*t_cc(i)
       t_rcg(t_ic(i))=t_rcg(t_ic(i))+t_rc(i)*t_cc(i)
       IF(t_ict(j)==0) THEN
          t_ccls(t_ic(i))=t_ccls(t_ic(i))+t_cc(i) ! parallel
       ELSE
          t_ccls(t_ic(i))=t_cc(i) ! series
       END IF
    END DO
    DO i=1,t_ngroup
       t_pfpc0(i)=t_pfpc0(i)/t_ccls(i)
       t_rcg(i)=t_rcg(i)/t_ccls(i)
       t_zcg(i)=t_zcg(i)/t_ccls(i)
    END DO

  END SUBROUTINE pfcmem

  SUBROUTINE regrdinv
    REAL(rq) :: cq0(t_mls),psw(t_mls,1)
    INTEGER :: isw,ier,ls,l

    isw=1
    t_tswpts=(/(ls,ls=0,t_mls-1)/)*TWOPI/(t_mls-1)
    t_brwpts=cos(t_tswpts)
    t_bzwpts=sin(t_tswpts)
    t_rlsd(:,1,1)=t_raxis
    t_zlsd(:,1,1)=t_zaxis

    DO l=2,t_msrf
       cq0=t_psibar(l)
       ier=1
       CALL boxm_interp(cq0,t_tswpts,psw,pst,tst,i_rhosq,isw,ier,t_n6)
       t_rlsd(:,l,1)=t_raxis+SQRT(psw(:,1))*t_brwpts
       t_zlsd(:,l,1)=t_zaxis+SQRT(psw(:,1))*t_bzwpts*t_wvert
    END DO
    t_rls=t_rlsd(:,t_msrf,1)
    t_zls=t_zlsd(:,t_msrf,1)
  END SUBROUTINE regrdinv

  SUBROUTINE regrid(jmo,kmo,r_,z_)
    INTEGER, INTENT(IN) :: jmo,kmo
    REAL(rq),INTENT(IN) ::  r_(jmo),z_(kmo)
    REAL(rq) :: psi_(t_jmkm,1)
    INTEGER :: ier,isw
    CALL teq_interface
    CALL setgeo(t_rm,t_zm)
    isw=0
    ier=1
    CALL boxm_interp(t_rm,t_zm,psi_,r_,z_,i_cps,isw,ier,t_n4)
    t_psi(:t_jmkm)=psi_(:t_jmkm,1)
  END SUBROUTINE regrid

  SUBROUTINE setgeo(rr,zz)
    REAL(rq), DIMENSION(t_jm,t_km) :: rr,zz
    INTEGER :: jc,i,j,k
    !
    !     set up mesh
    !
    jc=t_jm/2+1
    IF(t_liml==-1) THEN
       t_zn=-t_zx
       t_dr=(t_rx-t_rn)/(t_jm-1)
       t_dz=(t_zx-t_zn)/(t_km-1)
       t_ro=0.5_rq*(t_rn+t_rx)
       t_el=(t_zx-t_zn)/(t_rx+t_rn)
    ELSE
       t_dr=1.0017469212_rq*t_rb/(jc-t_liml)+sqrt(errt_rq)
       ! avoid contact with grid
       t_rn=t_ro-(jc-1)*t_dr
       t_rx=t_ro+(jc-1)*t_dr
       t_zx=(jc-1)*t_dr*t_el
       t_zn=-t_zx
    END IF
    t_dz=(t_zx-t_zn)/(t_km-1)
    t_r=(/(i,i=0,t_jm-1)/)*t_dr+t_rn
    t_z=(/(i,i=0,t_km-1)/)*t_dz+t_zn
    DO k=1,t_km
       rr(:,k)=t_r
    END DO
    DO j=1,t_jm
       zz(j,:)=t_z
    END DO
    i_r=>t_r
    i_z=>t_z
  END SUBROUTINE setgeo

  SUBROUTINE time_date
    CHARACTER(len=8) :: date1
    CHARACTER(len=10) :: time1
    INTEGER, save :: l
    DATA l /0/
    IF(l==0) THEN
       CALL glbtmdat(t_codetime,t_codedate)
       CALL DATE_AND_TIME(date1,time1)
       t_runtime=time1(1:2)//":"//time1(3:4)//":"//time1(5:6)
       t_rundate=date1(5:6)//"/"//date1(7:8)//"/"//date1(3:4)
       l=1
    END IF
  END SUBROUTINE time_date

END Module setTeq_mod

! $Id: teqlib.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

MODULE teqlib
  USE teqinit
  USE sep_math
  USE ioTeq_mod, only : wreqdskf
  IMPLICIT NONE
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Bpol=grad(psi) X grad(phi)
!   psi gauss-cm and is the poloidal flux per radian
!   psibar is the dimentionless poloidal flux and along with theta
!   defines the inverse coordinate system
!
!   Look at teqinit.f90 for more extensive comments
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  TYPE :: global_type
     INTEGER, POINTER :: logunit,ioun7,ioun12,ioun13
     CHARACTER(len=64), POINTER :: logname
     CHARACTER(len=64) :: filename,tokamak,pfcoil
  END TYPE global_type

  TYPE :: eq_type
     REAL(rq), DIMENSION(:),   POINTER :: x,y
     REAL(rq), DIMENSION(:,:), POINTER :: f,fx,fy,fs
     INTEGER, POINTER :: nx,ny
  END TYPE eq_type

  TYPE :: inv_type
     TYPE(eq_type) :: R,Z
     REAL(rq), DIMENSION(:), POINTER :: rbnd,zbnd
     REAL(rq), POINTER :: raxis,zaxis,dpsi0,dpsi00,dphi0,dphi00,plc,fwall,cur
     REAL(rq), POINTER :: epsrk,x
     INTEGER, POINTER :: p,k,eq,nht,mpsi,mth,flag,ls
     LOGICAL, POINTER :: fix_bnd
! (R%x,R%y)     = (theta,psibar)
! (R%f,R%fx,R%fy,R%fs) = (R,R_theta,R_psi,B)
! (Z%x,Z%y)     = (theta,psibar)
! (Z%f,Z%fx,Z%fy,Z%fs) = (Z,Z_theta,Z_psi,Jacobian)
! (raxis,zaxis) = position of axis cm
! (dpsi0,dpsi00)= poloidal flux/radian
! (dphi0,dphi00)= toroidal flux/radian
! x             = position in dimensionless flux beyond which solver adjusts q
!                 indirectly so as to force FF'=0 at the edge. 
! plc           = desired plasma current MA
! cur           = plasma current A
! fwall         = vacuum RBtor gauss-cm
! epsrk         = accuracy for polar1 (defaulted to 1e-6)
! k             = (0 use qs) (1 use fs) (2 use jts) (3 use jpars) as profile.
!               = For a time dependent (predictive mode) Ohm's law requires
!                 that the q-profile be inputed.
! p             = (-1 use dpsi00) (0 use fwall) (1 use plc) as constraint,
! eq            = -2: startup from direct solve, uses internal information,
!               = -1; vanilla flavored startup, uses no internal data, and is
!                     recommended for a "large" boundary change in a sequence
!                     of inverse solves. If this option fails with inv_k=0,
!                     q-profile as input, try a current profile. If it still
!                     fails try eq=0. If it still fails contact ldp@llnl.gov.
!               =  0; from an existing inverse solve, sets the boundary to
!                     (inv%rbnd,inv%zbnd); this is the recommended option if
!                     the boundary is moved.
!               =  1; from an existing inverse solve, but the boundary
!                     relaxes to (inv%rbnd,inv%zbnd); used for time dependent
!                     evolution predictive mode, not snap shots and is needed
!                     for numerical stability.
! nht           = maximum number of iterations
! mpsi          = flux grid size
! mth           = theta gridsize
! ls            = stretching in psi grid: ls=-22  (sin(i*pi/2))**2; i=1,mpsi
!                                           = 22 quadratic axi; polynomial
!                                           = 11  uniform
!                                           = -1=-22;1=11 anachroism
! flag          = 0, uses polar1; 1, uses esc if loaded (libesc.a)

  END TYPE inv_type

  TYPE :: profile_type
     REAL(rq), DIMENSION(:), POINTER :: q,jt,jpar,f,fd,p,pd,bp,rsqi,cu,phi,psi
     REAL(rq), DIMENSION(:), POINTER :: qs,jts,jpars,fs,ps,vpr,w,v,psin,r,a,bsq
! (q,qs)       = q-profile (dynamic,desired)
! (jt,jts)     = <J.B>/(J,grad phi> amps/cm
! (jpar,jpars) = J.B>/<B.B> amps/cm**2/gauss
! (f,fs)       = RBt gauss-cm
! fd           = df/dpsi 1/cm
! (p,ps)       = pressure ergs/cm**3
! pd           = dp/dpsi
! bp           = <Bpol> gauss
! bsq          = <B**2> qauss**2
! rsqi         = <1/R**2> 1/cm**2
! cu           = Mu0*I(psi) gauss-cm
! vpr          = dV/dpsi cm/gauss
! <w,v>        = node values for the two input spline profiles
!                Spline at nodes F**2-F(msrf)**2)/(8*pi*dcpsi0*prsx)
!                Spline at nodes P/(betaj*prsx)
! psin         = dimensionless poloidal flux: input
! (a,r)        = minor, major radius of flux surface at level of magnetic axis
! phi          = dimensionless toroidal flux
! psi          = dimensionless poloidal flux used by teq
! <>           = surface average
  END TYPE profile_type

  TYPE :: dir_type
     TYPE(eq_type) :: psi
     REAL(rq), DIMENSION(:), POINTER :: rxpr,zxpr,alfa,betp,li,betap
     REAL(rq), DIMENSION(:), POINTER :: rxps,zxps,pxps,rsep,zsep
     REAL(rq), POINTER :: rxpt,zxpt,pxpt,paxis,pbnd,rn,rx,ro,zx,prsx
     REAL(rq), POINTER :: betaj,thc,epsj,epsb,aap
     INTEGER,  POINTER :: ipscl,ipf,ipj,ipp,irl,liml,f_wp,nxps,limd,ixpt,msep
     LOGICAL,  POINTER :: fix_bnd
!
! (rsep,zsep)      = separatrix boundary
! (psi%f,psi%fx,psi%fy,psi%fs)=(psi,psi_r,psi_z,bpol)
! rxpr(2) zxpr(2)  = determines box to look for X-point cm
! (alfa(0:1),betp(0:1),aap)= profile factors for analytic forms: see ipp below
! (zxpt,rxpt,pxpt) = Xpoint location and flux/radian cm,cm,gauss-cm**2
! (paxis,pbnd      = poloidal flux at on (axis,boundary)
! (nxps,rxps,zxps,pxps) = number, flux, R and Z of Xpoints found by separatrix
! (rn,rx,zx)       = boundary of computational grid cm (up/down sym. grid)
! limd             = 0 not limited
! ro               = radial mid-point of grid (btor=fwall/ro)
! prsx             = scaling coefficient need for w,v the spline points
! betaj            = scaling factor multiplying the pressure for input forms
! thc              = fraction away from X-point in dimensionless poloidal flux
! ixpt             = 2 use Xpoint; = 1 if limiter is active use limiter
! ipscl            = constrain for dir solve (-1 none 0 plc 1 dpsi00 )
! ipj              = 0, analytic forms for FF' and P
!                    1  jts,ps arrays
!                    2  analytic forms for jt and p
!                    3  jpars and ps arrays for input (inv%p constraint choice)
!                       scaling (see ipscl) not recommended
!                    4  qs and ps arrays; scaling (see ipscl) not recommended
!                    5  qs and ps arrays; no scaling  (inv%p constraint choice)
! (ipf,ipp)        = profile forms for analytic; x dimensionless flux 
!                  = 1; Strickler form exp(-alfa*x)-exp(-alfa) for (FF',P');
!                  = 2; difference of two; 2nd form uses alfa*betp
!                  = 3; (1-x**betp)**alfa for (FF,P)
!                  = 4; 3 form but flat out to aap;with betp*(x-aap)/(1-aap)
!                  = 5; hollow profile: constrained to  2<betp<2.5 and
!                       SENSITIVE near upper limit.
!                  = 999; cubic spline for (FF,P); uses (w,v)
! (epsj,epsb)      = residual accuracy required, (comp boundary, GS rhs)
  END TYPE dir_type

  TYPE :: pf_type
     INTEGER, POINTER :: ngroup,ncircuit,nbd,jcir,nfbd,nc,jax,kax,nlim,irl,ngp
     INTEGER, POINTER :: ircwt,nsym,nsymc,iflxc,limw,lmax,kxp,ncp
     INTEGER,  DIMENSION(:), POINTER :: nrc,nzc,ic,ix,ict
     REAL(rq), DIMENSION(:), POINTER :: cc,rc,zc,drc,dzc,ps0,psi
     REAL(rq), DIMENSION(:), POINTER :: pci,pc0,rlim,zlim,rlimw,zlimw
     REAL(rq), DIMENSION(:), POINTER :: rbd,zbd,rfbd,zfbd,alfbd
     REAL(rq), DIMENSION(:,:), POINTER :: pfim
     REAL(rq), POINTER :: psix,vltf,cejima,rl,rax,zax,skew,dsep,dsip,rxp,zxp
     REAL(rq), POINTER :: rmajor,rminor
          
! nc               = number of coils
! ncp              = number of active coils (shaping coils for DIII-D)
! cc               = coil current, MA
! (rc,drc)         = coil R and width, M
! (zc,dzc)         = coil Z and width, M
! (nrc,nzc)        = number of filamants= nrc*nzc per coil; code generally 
!                    controls
! (psi,ps0)        = flux at coil (calculated, wanted), Wb
! (ic,ix)          = grouping of (coils,circuits); if (ic(1)=n and ic(2)=n
!                    where n=1,2,3,4,... keeps the ratio of current in 
!                    cc(1) and cc(2) fixed;similarly for ix and the coil flux.
!                    note that max(ic) must be greater or equal to max(ix)
!                    depending on whether there are additional constraints.
! iflxc            = 1 forces psi to ps0 for all ix/=0
! ngroup           = number of coil groups, max(ic)
! ncircuit         = number of circuits, max(ix)
! (nbd,rbd,zbd)    = number of boundary points and values in cm's, constraints
! psix             = desired flux at magnetic axis, constraint (units as paxis)
! vltf             = desires external flux linkage (VS), constraint
! cejima           = Ejima coefficient, constraint;vltf=psires +
!                    0.4*pi*cejima*plcm*ro/100, with  psires the average
!                    plasma poloidal flux.
! (rl,irl)         = irl=0,  required separation between active and inactive 
!                    separatrix in dimensionless flux:(pxpu-pxpl)/dpsi0
!                  = (irl=1,upper Xpoint active);(irl=-1, lower Xpoint active);
!                    rl is the required separation between inactive and active
!                    separatrix in cm's (>0 outside. <0 inside)
! (kxp,rxp,zxp)      kxp/=0 X-point forces to (rxp,zxp)
! (kax,rax,zax)      kax/=0 O-point forces to (rax,zax): problematic  since
!                    requires user ingenuity to avoid over-constrainingsing;
!                    can also be another X-point
! jcir             = total number of constraints
! (nfbd,alfbd)     = number of fuzzy boundary points and normalization
! (rfbd,zfbd)      = value of points in cm's not as a minimization
! ircwt            = -1 minimizes (dI/dz)^2;all coils and in sequence.
!                  =  1 minimizes (cc-cc0)!(cc-cc0)
!                  =  2 minimizes cc!cc
!                  =  3 minimizes j**2=(cc/drc/dzc)^2
!                  =  4 minimizes cc!pfim*!cc=I!L!I
!                  =  5 minimizes B!B at the coils
!                  =  6 minimizes (pfpsi-pfps0)^2;change in flux at coils
!                  =  7 minimizes pfpsi!cc
!                  = 11 minimizes (cc*rc)!(cc*rc)
! (rlim(0),zlim(0) = limiter point
! skew             = angle between flux aurface axis and vertical axis
! rminor           = minor radius
! rmajor           = major radius
! dsep             = distance bewtween separatrices at outboard midplane
! dsip             = distance bewtween separatrices at inboard midplane
! (nsym,nsymc;lmax)= (2,2), up/down asymmetric; lmax=mth
!                  = (1,1), up/down symmetrix;  lmax=mth/2+1
! (rlimw,zlimw)    = limiting wall; dimensioned lmax and must be continous.
!                    (rlim(0),zlim(0)) is set to the limiting point if limw=1

  END TYPE pf_type

  CHARACTER(len=48), PRIVATE :: gname
  LOGICAL,PRIVATE :: labeled

CONTAINS

  subroutine find_direq(dir,pf,inv,prof,glb)
    use runTeq_mod, only : runTeq,exeTeq,genTeq
    use teqlib_input, only : mls,map,inv_eq,btor,ro,wvert
    TYPE(dir_type), INTENT(INOUT) :: dir
    TYPE(pf_type), INTENT(INOUT) :: pf
    TYPE(profile_type), INTENT(INOUT) :: prof
    TYPE(inv_type), INTENT(INOUT) :: inv
    TYPE(global_type), INTENT(IN) :: glb
    integer :: inv_eqs

    if(.not.associated(dir%psi%f)) then
       ! first time
       inv_eqs=inv_eq
       inv_eq=0
       call genTeq
       inv_eq=inv_eqs
       wvert=1
       call exeTeq
       call connect_direq(dir,pf,inv,prof)
    elseif(dir%psi%nx/=size(dir%psi%x) .or. dir%psi%ny/=size(dir%psi%y) .or. &
         inv%mth/=size(inv%R%f,1) .or. inv%mpsi/=size(inv%R%f,2))then
       map = mls/2+1
       if(mls/=2*map-1) then
          mls=2*map-1
          inv%mth=mls
          write(*,*) "mls is even, changing mls to ",mls
       end if
       btor=inv%fwall/ro
       wvert=1
       call runteq
       call connect_direq(dir,pf,inv,prof)
    else
       btor=inv%fwall/ro
       wvert=1
       call runTeq
    end if

  end subroutine find_direq

  subroutine find_inveq(inv,prof,glb)

    use runTeq_mod, only : invTeq
    use teqlib_input, only : mls,map,inv_eq,rls,btor,ro,wvert
    type(profile_type), INTENT(INOUT) :: prof
    TYPE(inv_type), INTENT(INOUT) :: inv
    TYPE(global_type), INTENT(IN) :: glb

    if(.not.associated(inv%R%f)) then
       ! first time
       inv_eq=0
       wvert=1
       call invTeq 
       call connect_inveq(inv,prof)
    elseif(inv%eq<0) then
       ! first call from direct equilibrium or recovery or big boundary move
       wvert=1
       btor=inv%fwall/ro
       call start_inveq(inv,prof,glb)
    elseif(inv%mth/=size(inv%R%f,1) .or. inv%mpsi/=size(inv%R%f,2)) then
       ! change in dimension
       map = mls/2+1
       if(mls/=2*map-1) then
          mls=2*map-1
          inv%mth=mls
          write(*,*) "mls is even, changing mls to ",mls
       end if
       btor=inv%fwall/ro
       wvert=1
       call invTeq
       call connect_inveq(inv,prof)
    else
       wvert=1
       btor=inv%fwall/ro
       call invTeq 
    end if

  end subroutine find_inveq

  subroutine start_inveq(inv,prof,glb)
    use runTeq_mod, only : startinv
    type(profile_type), intent(inout) :: prof
    type(inv_type), intent(inout) :: inv
    type(global_type), intent(in) :: glb
    
    call connect_inveq(inv,prof)
    call startinv

  end subroutine start_inveq

  subroutine set_verbosity(level)

    use teqlib_input, only : nprt59

    integer, intent(in) :: level

    nprt59 = level

  end subroutine set_verbosity

  subroutine get_spline_coefficients
    use teqlib_input, only : w,v,splbdry
    use teqlib_output, only : wp,wpp,wppp,vp,vpp,vppp,psibar
    use sep_interp, only : spline_interp

    call spline_interp(psibar,w,splbdry,splbdry,wp,wpp,wppp,noint)
    call spline_interp(psibar,v,splbdry,splbdry,vp,vpp,vppp,noint)

  end subroutine get_spline_coefficients

  subroutine load_savefile(filename)

    use teqlib_input
    use teqlib_output
    use teq_mod
    use teqGS_mod
    use setTeq_mod, only : time_date
    use teqSubs_mod, only : t_stretch
    use diag_mod, only : limw_from_plates

    character(len = *), intent(in) :: filename

    external teq_interface, teqGS_interface

    call mach
    call read_savefile(filename)
    call teq_input
    call teq_interface
    call teqGS_interface
    call time_date
    write(logunit,*) "TEQ built ", codedate, " ", codetime, ": Run at ", &
         rundate, " ", runtime
    print *, "TEQ built ", codedate, " ", codetime, ": Run at ", rundate, &
         " ", runtime

    IF(nplates/=0) CAll limw_from_plates
    qsrf=qsave

  end subroutine load_savefile

  SUBROUTINE write_savefile(sname)

    use ioTeq_mod
    USE teq_mod
    USE teqGS_mod
    USE teqPol_mod, only : t_npo,t_ntet,t_rork
    USE sep_separatrix, only : s_pin
    USE teqlib_input

    IMPLICIT NONE

    include "debug.i"

    CHARACTER(len=*) :: sname
    INTEGER :: i
    OPEN(UNIT=ioun12,FILE=sname,STATUS="REPLACE")
    WRITE(ioun12,'(a)')TRIM(t_probid)
    WRITE(ioun12,'(a)')TRIM(t_note)
    WRITE(ioun12,'(a)')TRIM(t_shotName)
    WRITE(ioun12,*)t_shotTime
    WRITE(ioun12,*)t_npoly
    WRITE(ioun12,*)t_nbd
    WRITE(ioun12,*)t_nfbd
    WRITE(ioun12,*)t_nsol
    WRITE(ioun12,*)t_nlim
    WRITE(ioun12,*)t_nloop
    WRITE(ioun12,*)t_ircwt
    WRITE(ioun12,*)t_nc0p
    WRITE(ioun12,*)t_kbfc
    WRITE(ioun12,*)t_ixpt
    WRITE(ioun12,*)t_nsym
    WRITE(ioun12,*)t_nsymc
    WRITE(ioun12,*)t_iflxc
    WRITE(ioun12,*)t_nc
    WRITE(ioun12,*)t_jm
    WRITE(ioun12,*)t_km
    WRITE(ioun12,*)t_ipf
    WRITE(ioun12,*)t_ibdry
    WRITE(ioun12,*)t_bsph_flag
    WRITE(ioun12,*)t_keqic
    WRITE(ioun12,*)t_initflx
    WRITE(ioun12,*)t_map
    WRITE(ioun12,*)t_lelm
    WRITE(ioun12,*)t_inv_eq
    WRITE(ioun12,*)t_inv_flag
    WRITE(ioun12,*)t_lsrf
    WRITE(ioun12,*)t_jqm
    WRITE(ioun12,*)t_nsph
    WRITE(ioun12,*)t_lsph
    WRITE(ioun12,*)t_ipp
    WRITE(ioun12,*)t_irl
    WRITE(ioun12,*)t_liml
    WRITE(ioun12,*)t_lflat
    WRITE(ioun12,*)t_kedge
    WRITE(ioun12,*)t_ipj
    WRITE(ioun12,*)t_entropy_flag
    WRITE(ioun12,*)t_ncplot
    WRITE(ioun12,*)t_inv_k
    WRITE(ioun12,*)t_inv_p
    WRITE(ioun12,*)t_npp
    WRITE(ioun12,*)t_npf
    WRITE(ioun12,*)t_nasp
    WRITE(ioun12,*)t_nbsp
    WRITE(ioun12,*)ndbg16
    WRITE(ioun12,*)ndbg8
    WRITE(ioun12,*)ndbg10
    WRITE(ioun12,*)ldbg5
    WRITE(ioun12,*)ldbg9
    WRITE(ioun12,*)ldbg8
    WRITE(ioun12,*)ldbg7
    WRITE(ioun12,*)ldbg10
    WRITE(ioun12,*)ndbg12
    WRITE(ioun12,*)t_ngp
    WRITE(ioun12,*)t_ni
    WRITE(ioun12,*)t_kgreenc
    WRITE(ioun12,*)t_msrf
    WRITE(ioun12,*)t_n4
    WRITE(ioun12,*)t_mls
    WRITE(ioun12,*)t_nht
    WRITE(ioun12,*)t_fix_bound
    WRITE(ioun12,*)t_nplates
    WRITE(ioun12,*)t_one_pow
    WRITE(ioun12,*)t_lmax
    WRITE(ioun12,*)t_nl
    WRITE(ioun12,*)t_int_flag
    WRITE(ioun12,*)t_crdn
    WRITE(ioun12,*)t_gsph
    WRITE(ioun12,*)t_asph
    WRITE(ioun12,*)t_bsph
    WRITE(ioun12,*)t_alfa
    WRITE(ioun12,*)t_betp
    WRITE(ioun12,*)t_vltf
    WRITE(ioun12,*)t_thetac
    WRITE(ioun12,*)t_btor
    WRITE(ioun12,*)t_fefit
    WRITE(ioun12,*)t_rxpr
    WRITE(ioun12,*)t_zxpr
    WRITE(ioun12,*)t_plcm
    WRITE(ioun12,*)t_qmax
    WRITE(ioun12,*)t_zn
    WRITE(ioun12,*)t_zx
    WRITE(ioun12,*)t_rn
    WRITE(ioun12,*)t_pefit
    WRITE(ioun12,*)t_rx
    WRITE(ioun12,*)t_rcur
    WRITE(ioun12,*)t_zcur
    WRITE(ioun12,*)t_ro
    WRITE(ioun12,*)t_rb
    WRITE(ioun12,*)t_plcx
    WRITE(ioun12,*)t_raxis0
    WRITE(ioun12,*)t_zlim(0:t_nlim)
    WRITE(ioun12,*)t_zaxis0
    WRITE(ioun12,*)t_raxis
    WRITE(ioun12,*)t_zaxis
    WRITE(ioun12,*)t_wvert
    WRITE(ioun12,*)t_betaj
    WRITE(ioun12,*)t_qflat
    WRITE(ioun12,*)t_psil
    WRITE(ioun12,*)t_qcelm
    WRITE(ioun12,*)t_pcelm
    WRITE(ioun12,*)t_scelm
    WRITE(ioun12,*)t_alphac
    WRITE(ioun12,*)t_psil00
    WRITE(ioun12,*)t_thetat
    WRITE(ioun12,*)t_rlim(0:t_nlim)
    WRITE(ioun12,*)t_aap
    WRITE(ioun12,*)t_ipscl
    WRITE(ioun12,*)t_svec
    WRITE(ioun12,*)t_epsb
    WRITE(ioun12,*)t_scflat
    WRITE(ioun12,*)t_qrat
    WRITE(ioun12,*)t_dpsi00
    WRITE(ioun12,*)t_dlim(0:t_nlim)
    WRITE(ioun12,*)t_epsrk
    WRITE(ioun12,*)t_epskrk
    WRITE(ioun12,*)t_anun
    WRITE(ioun12,*)t_alfa0
    WRITE(ioun12,*)t_epsj
    WRITE(ioun12,*)s_pin
    WRITE(ioun12,*)t_epp
    WRITE(ioun12,*)t_epf
    WRITE(ioun12,*)t_prsx
    WRITE(ioun12,*)t_filter_p
    WRITE(ioun12,*)t_filter_wp
    WRITE(ioun12,*)t_scl
    WRITE(ioun12,*)t_dr
    WRITE(ioun12,*)t_dz
    WRITE(ioun12,*)t_hsrf
    WRITE(ioun12,*)t_psix
    WRITE(ioun12,*)t_el
    WRITE(ioun12,*)t_rl
    WRITE(ioun12,*)t_cejima
    WRITE(ioun12,*)t_jparsave
    WRITE(ioun12,*)t_qsave
    WHERE(t_ssave<1e-99_rq)
       t_ssave=0
    END WHERE
    WRITE(ioun12,*)t_ssave
    WHERE(t_psave<1e-99_rq)
       t_psave=0
    END WHERE
    WRITE(ioun12,*)t_psave
    WRITE(ioun12,*)t_jtsave
    WRITE(ioun12,*)t_fsave
    WRITE(ioun12,*)t_w
    WRITE(ioun12,*)t_v
    WRITE(ioun12,*)t_rhc
    WRITE(ioun12,*)t_ix
    WRITE(ioun12,*)t_ic
    WRITE(ioun12,*)t_cc
    WRITE(ioun12,*)t_gdc
    WRITE(ioun12,'(a)')(TRIM(t_pfid(i)),i=1,t_nc)
    WRITE(ioun12,*)t_zplate
    WRITE(ioun12,*)t_rc
    WRITE(ioun12,*)t_zc
    WRITE(ioun12,*)t_drc
    WRITE(ioun12,*)t_dzc
    WRITE(ioun12,*)t_ac
    WRITE(ioun12,*)t_ac2
    WRITE(ioun12,*)t_nrc
    WRITE(ioun12,*)t_nzc
    WRITE(ioun12,*)t_rxc
    WRITE(ioun12,*)t_thloop
    WRITE(ioun12,*)t_iloop
    WRITE(ioun12,*)t_sigloop
    WRITE(ioun12,*)t_floop0
    WRITE(ioun12,*)t_cc0
    WRITE(ioun12,*)t_rplate
    WRITE(ioun12,*)t_psi
    WRITE(ioun12,*)t_jwu
    WRITE(ioun12,*)t_jwl
    WRITE(ioun12,*)t_rwu
    WRITE(ioun12,*)t_rwl
    WRITE(ioun12,*)t_rbd(:t_nbd)
    WRITE(ioun12,*)t_zbd(:t_nbd)
    WRITE(ioun12,*)t_rfbd(:t_nfbd)
    WRITE(ioun12,*)t_zfbd(:t_nfbd)
    WRITE(ioun12,*)t_alfbd(:t_nfbd)
    WRITE(ioun12,*)t_pfps0
    WRITE(ioun12,*)t_whtz
    WRITE(ioun12,*)t_rloop
    WRITE(ioun12,*)t_zloop
    WRITE(ioun12,*)t_rls
    WRITE(ioun12,*)t_zls
    WRITE(ioun12,*)t_rork
    WRITE(ioun12,*)t_psibar
    CLOSE(ioun12)
    CALL freeus(ioun12)
  END SUBROUTINE write_savefile

  SUBROUTINE write_labeled_savefile(sname)


    use ioTeq_mod
    USE teq_mod
    USE teqGS_mod
    USE teqPol_mod, only : t_npo,t_ntet,t_rork
    USE sep_separatrix, only : s_pin

    IMPLICIT NONE

    include "debug.i"

    CHARACTER(len=*) :: sname
    INTEGER :: i

    OPEN(UNIT=ioun12,FILE=sname,STATUS="REPLACE")
    WRITE(ioun12,'(a)')"# probid S 1 : problem label "
    WRITE(ioun12,'(a)')TRIM(t_probid)
    WRITE(ioun12,'(a)')"# note S 1 : shot description "
    WRITE(ioun12,'(a)')TRIM(t_note)
    WRITE(ioun12,'(a)')"# shotName S 1 : shot label "
    WRITE(ioun12,'(a)')TRIM(t_shotName)
    WRITE(ioun12,'(a)')"# shotTime R 1 : time in shot "
    WRITE(ioun12,*)t_shotTime
    WRITE(ioun12,'(a)')"# npoly I 1 : number of polynomial in fit (filter_p, filter_wp) "
    WRITE(ioun12,*)t_npoly
    WRITE(ioun12,'(a)')"# nbd I 1 : constraints controlled by nbd,rbd,zbd, vltf,rl,cejima,ifxc. "
    WRITE(ioun12,*)t_nbd
    WRITE(ioun12,'(a)')"# nfbd I 1 : number of fuzzy points on boundary "
    WRITE(ioun12,*)t_nfbd
    WRITE(ioun12,'(a)')"# nsol I 1 : no def "
    WRITE(ioun12,*)t_nsol
    WRITE(ioun12,'(a)')"# nlim I 1 : number of limiter points "
    WRITE(ioun12,*)t_nlim
    WRITE(ioun12,'(a)')"# nloop I 1 : no def "
    WRITE(ioun12,*)t_nloop
    WRITE(ioun12,'(a)')"# ircwt I 1 : selects minimization functions, 2 total current, 1 dif from "
    WRITE(ioun12,*)t_ircwt
    WRITE(ioun12,'(a)')"# nc0p I 1 : no def "
    WRITE(ioun12,*)t_nc0p
    WRITE(ioun12,'(a)')"# kbfc I 1 : no def "
    WRITE(ioun12,*)t_kbfc
    WRITE(ioun12,'(a)')"# ixpt I 1 : flag for setting psil, the 0-pressure flux. "
    WRITE(ioun12,*)t_ixpt
    WRITE(ioun12,'(a)')"# nsym I 1 : 1 UP/DOWN symmetric; 2 asummetric "
    WRITE(ioun12,*)t_nsym
    WRITE(ioun12,'(a)')"# nsymc I 1 : "
    WRITE(ioun12,*)t_nsymc
    WRITE(ioun12,'(a)')"# iflxc I 1 : 1 runs circuit equations nbd!! etc. ic sets circuits "
    WRITE(ioun12,*)t_iflxc
    WRITE(ioun12,'(a)')"# nc I 1 : number of coils "
    WRITE(ioun12,*)t_nc
    WRITE(ioun12,'(a)')"# jm I 1 : number of psi grid points in r direction "
    WRITE(ioun12,*)t_jm
    WRITE(ioun12,'(a)')"# km I 1 : number of psi grid points in z direction "
    WRITE(ioun12,*)t_km
    WRITE(ioun12,'(a)')"# ipf I 1 : profile options; same as ipp "
    WRITE(ioun12,*)t_ipf
    WRITE(ioun12,'(a)')"# ibdry I 1 : option flag to set rbd,zbd arrays (pressure pts) you set r, "
    WRITE(ioun12,*)t_ibdry
    WRITE(ioun12,'(a)')"# bsph_flag I 1 : Spheromak option "
    WRITE(ioun12,*)t_bsph_flag
    WRITE(ioun12,'(a)')"# keqic I 1 : flag for package eq initial value "
    WRITE(ioun12,*)t_keqic
    WRITE(ioun12,'(a)')"# initflx I 1 : no def "
    WRITE(ioun12,*)t_initflx
    WRITE(ioun12,'(a)')"# map I 1 : no def "
    WRITE(ioun12,*)t_map
    WRITE(ioun12,'(a)')"# lelm I 1 : grid position where ELM occurs; if zero no ELM "
    WRITE(ioun12,*)t_lelm
    WRITE(ioun12,'(a)')"# inv_eq I 1 : inv_eq,& =1 inverse equilibrium is used "
    WRITE(ioun12,*)t_inv_eq
    WRITE(ioun12,'(a)')"# inv_flag I 1 : uses polar 1; =1 uses "
    WRITE(ioun12,*)t_inv_flag
    WRITE(ioun12,'(a)')"# lsrf I 1 : no def "
    WRITE(ioun12,*)t_lsrf
    WRITE(ioun12,'(a)')"# jqm I 1 : no def "
    WRITE(ioun12,*)t_jqm
    WRITE(ioun12,'(a)')"# nsph I 1 : no def "
    WRITE(ioun12,*)t_nsph
    WRITE(ioun12,'(a)')"# lsph I 1 : no def "
    WRITE(ioun12,*)t_lsph
    WRITE(ioun12,'(a)')"# ipp I 1 : no def "
    WRITE(ioun12,*)t_ipp
    WRITE(ioun12,'(a)')"# irl I 1 : no def "
    WRITE(ioun12,*)t_irl
    WRITE(ioun12,'(a)')"# liml I 1 : no def "
    WRITE(ioun12,*)t_liml
    WRITE(ioun12,'(a)')"# lflat I 1 : no def "
    WRITE(ioun12,*)t_lflat
    WRITE(ioun12,'(a)')"# kedge I 1 : edge-current-model flag: ...=0 => no correction "
    WRITE(ioun12,*)t_kedge
    WRITE(ioun12,'(a)')"# ipj I 1 : "
    WRITE(ioun12,*)t_ipj
    WRITE(ioun12,'(a)')"# entropy_flag I 1 : no def "
    WRITE(ioun12,*)t_entropy_flag
    WRITE(ioun12,'(a)')"# ncplot I 1 : no def "
    WRITE(ioun12,*)t_ncplot
    WRITE(ioun12,'(a)')"# inv_k I 1 : no def "
    WRITE(ioun12,*)t_inv_k
    WRITE(ioun12,'(a)')"# inv_p I 1 : "
    WRITE(ioun12,*)t_inv_p
    WRITE(ioun12,'(a)')"# npp I 1 : no def "
    WRITE(ioun12,*)t_npp
    WRITE(ioun12,'(a)')"# npf R 1 : no def "
    WRITE(ioun12,*)t_npf
    WRITE(ioun12,'(a)')"# nasp R 1 : "
    WRITE(ioun12,*)t_nasp
    WRITE(ioun12,'(a)')"# nbsp R 1 : nnumber of asph's used for reconstruction "
    WRITE(ioun12,*)t_nbsp
    WRITE(ioun12,'(a)')"# bg16 I 1 : debug? "
    WRITE(ioun12,*)ndbg16
    WRITE(ioun12,'(a)')"# bg8 I 1 : debug? "
    WRITE(ioun12,*)ndbg8
    WRITE(ioun12,'(a)')"# bg10 I 1 : debug? "
    WRITE(ioun12,*)ndbg10
    WRITE(ioun12,'(a)')"# bg5 I 1 : debug? "
    WRITE(ioun12,*)ldbg5
    WRITE(ioun12,'(a)')"# bg9 I 1 : debug? "
    WRITE(ioun12,*)ldbg9
    WRITE(ioun12,'(a)')"# bg8 I 1 : debug? "
    WRITE(ioun12,*)ldbg8
    WRITE(ioun12,'(a)')"# bg7 I 1 : debug? "
    WRITE(ioun12,*)ldbg7
    WRITE(ioun12,'(a)')"# bg10 I 1 : debug? "
    WRITE(ioun12,*)ldbg10
    WRITE(ioun12,'(a)')"# bg12 I 1 : no def "
    WRITE(ioun12,*)ndbg12
    WRITE(ioun12,'(a)')"# ngp I 1 : "
    WRITE(ioun12,*)t_ngp
    WRITE(ioun12,'(a)')"# ni I 1 : no def "
    WRITE(ioun12,*)t_ni
    WRITE(ioun12,'(a)')"# kgreenc I 1 : Green functions flag for gc and gp... "
    WRITE(ioun12,*)t_kgreenc
    WRITE(ioun12,'(a)')"# msrf I 1 : number of surfaces "
    WRITE(ioun12,*)t_msrf
    WRITE(ioun12,'(a)')"# n4 I 1 : 16 saves and uses all the bispline coefs for cps "
    WRITE(ioun12,*)t_n4
    WRITE(ioun12,'(a)')"# mls I 1 : size of grid in r direction? "
    WRITE(ioun12,*)t_mls
    WRITE(ioun12,'(a)')"# nht I 1 : no def "
    WRITE(ioun12,*)t_nht
    WRITE(ioun12,'(a)')"# fix_bound L 1 : if false boundary moves "
    WRITE(ioun12,*)t_fix_bound
    WRITE(ioun12,'(a)')"# nplates I 1 : number of first wall plates "
    WRITE(ioun12,*)t_nplates
    WRITE(ioun12,'(a)')"# one_pow I 1 : no def "
    WRITE(ioun12,*)t_one_pow
    WRITE(ioun12,'(a)')"# lmax I 1 : no def "
    WRITE(ioun12,*)t_lmax
    WRITE(ioun12,'(a)')"# nl I 1 : no def "
    WRITE(ioun12,*)t_nl
    WRITE(ioun12,'(a)')"# int_flag I 1 : no def "
    WRITE(ioun12,*)t_int_flag
    WRITE(ioun12,'(a)')"# crdn R 1 : no def "
    WRITE(ioun12,*)t_crdn
    WRITE(ioun12,'(a)')"# gsph R 1 : if not zero modifies private flux "
    WRITE(ioun12,*)t_gsph
    WRITE(ioun12,'(a)')"# asph RA 4 : Spheromak lamda profile "
    WRITE(ioun12,*)t_asph
    WRITE(ioun12,'(a)')"# bsph RA 4 : no def "
    WRITE(ioun12,*)t_bsph
    WRITE(ioun12,'(a)')"# alfa RA 2 : no def "
    WRITE(ioun12,*)t_alfa
    WRITE(ioun12,'(a)')"# betp RA 2 : no def "
    WRITE(ioun12,*)t_betp
    WRITE(ioun12,'(a)')"# vltf R 1 : no def "
    WRITE(ioun12,*)t_vltf
    WRITE(ioun12,'(a)')"# thetac R 1 : no def "
    WRITE(ioun12,*)t_thetac
    WRITE(ioun12,'(a)')"# btor R 1 : !fwall / ro !f wall = vacuum RBtor gauss-cm ! radial mid-po "
    WRITE(ioun12,*)t_btor
    WRITE(ioun12,'(a)')"# fefit RA 5 : no def "
    WRITE(ioun12,*)t_fefit
    WRITE(ioun12,'(a)')"# rxpr RA 2 : range in r for radial position of accepted axis "
    WRITE(ioun12,*)t_rxpr
    WRITE(ioun12,'(a)')"# zxpr RA 2 : range in z for axial position of accepted xpoint; "
    WRITE(ioun12,*)t_zxpr
    WRITE(ioun12,'(a)')"# plcm R 1 : plama current MA fixed "
    WRITE(ioun12,*)t_plcm
    WRITE(ioun12,'(a)')"# qmax R 1 : no def "
    WRITE(ioun12,*)t_qmax
    WRITE(ioun12,'(a)')"# zn R 1 : z start of z grid [cm] "
    WRITE(ioun12,*)t_zn
    WRITE(ioun12,'(a)')"# zx R 1 : no def "
    WRITE(ioun12,*)t_zx
    WRITE(ioun12,'(a)')"# rn R 1 : start of r grid [cm] "
    WRITE(ioun12,*)t_rn
    WRITE(ioun12,'(a)')"# pefit RA 5 : EFIT P' profiles "
    WRITE(ioun12,*)t_pefit
    WRITE(ioun12,'(a)')"# rx R 1 : maximum value of r (mesh) [cm] "
    WRITE(ioun12,*)t_rx
    WRITE(ioun12,'(a)')"# rcur R 1 : r at current centroid [cm] "
    WRITE(ioun12,*)t_rcur
    WRITE(ioun12,'(a)')"# zcur R 1 : z at current centroid [cm] "
    WRITE(ioun12,*)t_zcur
    WRITE(ioun12,'(a)')"# ro R 1 : r-grid midpoint value, occurs at j=jm/2+1 [cm] z at current "
    WRITE(ioun12,*)t_ro
    WRITE(ioun12,'(a)')"# rb R 1 : j=liml is at r=ro-rb [cm] "
    WRITE(ioun12,*)t_rb
    WRITE(ioun12,'(a)')"# plcx R 1 : forces psix to plcx in curcal "
    WRITE(ioun12,*)t_plcx
    WRITE(ioun12,'(a)')"# raxis0 R 1 : desired raxis [cm] (raxis r at magnetic axis [cm]) "
    WRITE(ioun12,*)t_raxis0
    WRITE(ioun12,'(a)')"# zlim RA nlim+1 : no def "
    WRITE(ioun12,*)t_zlim(0:t_nlim)
    WRITE(ioun12,'(a)')"# zaxis0 R 1 : desired zaxis [cm] "
    WRITE(ioun12,*)t_zaxis0
    WRITE(ioun12,'(a)')"# raxis R 1 : r at magnetic axis [cm] "
    WRITE(ioun12,*)t_raxis
    WRITE(ioun12,'(a)')"# zaxis R 1 : z at magnetic axis [cm] "
    WRITE(ioun12,*)t_zaxis
    WRITE(ioun12,'(a)')"# wvert R 1 : rq,& ellipticity on axis;used for quasi-polar coords unless "
    WRITE(ioun12,*)t_wvert
    WRITE(ioun12,'(a)')"# betaj R 1 : FF' is proportional to (1/betaj -1) "
    WRITE(ioun12,*)t_betaj
    WRITE(ioun12,'(a)')"# qflat R 1 : q flattens inside this value; stores profile in qelm "
    WRITE(ioun12,*)t_qflat
    WRITE(ioun12,'(a)')"# psil R 1 : psi on separatrix "
    WRITE(ioun12,*)t_psil
    WRITE(ioun12,'(a)')"# qcelm R 1 : coefficient of parabolic departure; "
    WRITE(ioun12,*)t_qcelm
    WRITE(ioun12,'(a)')"# pcelm R 1 : coefficient of parabolic departure;>0 P=P(1+pcelm*.) "
    WRITE(ioun12,*)t_pcelm
    WRITE(ioun12,'(a)')"# scelm R 1 : coefficient of parabolic departure "
    WRITE(ioun12,*)t_scelm
    WRITE(ioun12,'(a)')"# alphac R 1 : no def "
    WRITE(ioun12,*)t_alphac
    WRITE(ioun12,'(a)')"# psil00 R 1 : no def "
    WRITE(ioun12,*)t_psil00
    WRITE(ioun12,'(a)')"# thetat R 1 : psil = pxpt - thetac*( pxpt - psix ) "
    WRITE(ioun12,*)t_thetat
    WRITE(ioun12,'(a)')"# rlim RA nlim+1 : no def "
    WRITE(ioun12,*)t_rlim(0:t_nlim)
    WRITE(ioun12,'(a)')"# aap R 1 : P profile selection selection: ipp=2 : P' exp(-alfa(1))*x-a "
    WRITE(ioun12,*)t_aap
    WRITE(ioun12,'(a)')"# ipscl I 1 : ipscl=0,& scale Grad-Shafranov: =0 fix current (plcm), =1 f "
    WRITE(ioun12,*)t_ipscl
    WRITE(ioun12,'(a)')"# svec RA nc : no def "
    WRITE(ioun12,*)t_svec
    WRITE(ioun12,'(a)')"# epsb R 1 : epsb epsb=1.e-8_rq, resb must be less than epsb "
    WRITE(ioun12,*)t_epsb
    WRITE(ioun12,'(a)')"# scflat R 1 : ssave multiplier "
    WRITE(ioun12,*)t_scflat
    WRITE(ioun12,'(a)')"# qrat R 1 : The flat portion of q = qflat+qrat*(qsave(1)-qflat) "
    WRITE(ioun12,*)t_qrat
    WRITE(ioun12,'(a)')"# dpsi00 R 1 : no def "
    WRITE(ioun12,*)t_dpsi00
    WRITE(ioun12,'(a)')"# dlim RA nlim+1 : no def "
    WRITE(ioun12,*)t_dlim(0:t_nlim)
    WRITE(ioun12,'(a)')"# epsrk R 1 : no def "
    WRITE(ioun12,*)t_epsrk
    WRITE(ioun12,'(a)')"# epskrk R 1 : no def "
    WRITE(ioun12,*)t_epskrk
    WRITE(ioun12,'(a)')"# anun R 1 : no def "
    WRITE(ioun12,*)t_anun
    WRITE(ioun12,'(a)')"# alfa0 R 1 : no def "
    WRITE(ioun12,*)t_alfa0
    WRITE(ioun12,'(a)')"# epsj R 1 : no def "
    WRITE(ioun12,*)t_epsj
    WRITE(ioun12,'(a)')"# pin R 1 : no def "
    WRITE(ioun12,*)s_pin
    WRITE(ioun12,'(a)')"# epp R 1 : bump added to P ~x**npp *(1-x)**2 ;see epp (p-profile) "
    WRITE(ioun12,*)t_epp
    WRITE(ioun12,'(a)')"# epf R 1 : bump added to FF'(J0) ~epf* x**npf *(1.-x) last piece if np "
    WRITE(ioun12,*)t_epf
    WRITE(ioun12,'(a)')"# prsx R 1 : no def "
    WRITE(ioun12,*)t_prsx
    WRITE(ioun12,'(a)')"# filter_p R 1 : no def "
    WRITE(ioun12,*)t_filter_p
    WRITE(ioun12,'(a)')"# filter_wp R 1 : no def "
    WRITE(ioun12,*)t_filter_wp
    WRITE(ioun12,'(a)')"# scl R 1 : no def "
    WRITE(ioun12,*)t_scl
    WRITE(ioun12,'(a)')"# dr R 1 : r grid spacing [cm] "
    WRITE(ioun12,*)t_dr
    WRITE(ioun12,'(a)')"# dz R 1 : z grid spacing [cm] "
    WRITE(ioun12,*)t_dz
    WRITE(ioun12,'(a)')"# hsrf R 1 : hsrf = 0.5 parameter used for stretching; use default value "
    WRITE(ioun12,*)t_hsrf
    WRITE(ioun12,'(a)')"# psix R 1 : psi at magnetic axis [Gauss cm**2/radian] "
    WRITE(ioun12,*)t_psix
    WRITE(ioun12,'(a)')"# el R 1 : zx=el*rb*(jm/2) / ((jm/2)+1-liml) !also /geo/! "
    WRITE(ioun12,*)t_el
    WRITE(ioun12,'(a)')"# rl R 1 : distances between separatrices fixed in curcal... [cm] irl= "
    WRITE(ioun12,*)t_rl
    WRITE(ioun12,'(a)')"# cejima R 1 : psires=vltf-0.4*pi*cejima*plcm*ro/100 195- "
    WRITE(ioun12,*)t_cejima
    WRITE(ioun12,'(a)')"# jparsave RA msrf : parallel current as function of psi "
    WRITE(ioun12,*)t_jparsave
    WRITE(ioun12,'(a)')"# qsave RA msrf : q as function of psi "
    WRITE(ioun12,*)t_qsave
    WRITE(ioun12,'(a)')"# ssave RA msrf : psi on surfaces of psibar "
    WHERE(t_ssave<1e-99_rq)
       t_ssave=0
    END WHERE
    WRITE(ioun12,*)t_ssave
    WHERE(t_psave<1e-99_rq)
       t_psave=0
    END WHERE
    WRITE(ioun12,'(a)')"# psave RA msrf : saved prsrf - pressure as function of psi "
    WRITE(ioun12,*)t_psave
    WRITE(ioun12,'(a)')"# jtsave RA msrf : saved jtsrf toroidal current as function of psi "
    WRITE(ioun12,*)t_jtsave
    WRITE(ioun12,'(a)')"# fsave RA msrf : F as function of psi "
    WRITE(ioun12,*)t_fsave
    WRITE(ioun12,'(a)')"# w RA msrf : Spline at nodes F**2-F(msrf)**2)/(8*pi*dcpsi0*prsx) "
    WRITE(ioun12,*)t_w
    WRITE(ioun12,'(a)')"# v RA msrf : Spline at nodes P/(betaj*prsx) "
    WRITE(ioun12,*)t_v
    WRITE(ioun12,'(a)')"# rhc RA nc : resisitivity "
    WRITE(ioun12,*)t_rhc
    WRITE(ioun12,'(a)')"# ix IA nc : no def "
    WRITE(ioun12,*)t_ix
    WRITE(ioun12,'(a)')"# ic IA nc : Current circuit index... "
    WRITE(ioun12,*)t_ic
    WRITE(ioun12,'(a)')"# cc RA nc : coil currents [MA] "
    WRITE(ioun12,*)t_cc
    WRITE(ioun12,'(a)')"# gdc RA 6*nc : current grading ratino def "
    WRITE(ioun12,*)t_gdc
    WRITE(ioun12,'(a)')"# pfid SA nc : label for "
    WRITE(ioun12,'(a)')(TRIM(t_pfid(i)),i=1,t_nc)
    WRITE(ioun12,'(a)')"# zplate RA 2*nplates : z coordinates for wall [cm] "
    WRITE(ioun12,*)t_zplate
    WRITE(ioun12,'(a)')"# rc RA nc : coil centers [m] "
    WRITE(ioun12,*)t_rc
    WRITE(ioun12,'(a)')"# zc RA nc : coil centers [m] "
    WRITE(ioun12,*)t_zc
    WRITE(ioun12,'(a)')"# drc RA nc : coil r width [m] "
    WRITE(ioun12,*)t_drc
    WRITE(ioun12,'(a)')"# dzc RA nc : coil z width [m] "
    WRITE(ioun12,*)t_dzc
    WRITE(ioun12,'(a)')"# ac RA nc : no def "
    WRITE(ioun12,*)t_ac
    WRITE(ioun12,'(a)')"# ac2 RA nc : no def "
    WRITE(ioun12,*)t_ac2
    WRITE(ioun12,'(a)')"# nrc IA nc : number of filaments in r direction "
    WRITE(ioun12,*)t_nrc
    WRITE(ioun12,'(a)')"# nzc IA nc : number of filaments in z direction "
    WRITE(ioun12,*)t_nzc
    WRITE(ioun12,'(a)')"# rxc RA nc : no def "
    WRITE(ioun12,*)t_rxc
    WRITE(ioun12,'(a)')"# thloop RA nloop : loop orientation: Bpol=Br*sin(thloop)-Bz*cos(thloop) "
    WRITE(ioun12,*)t_thloop
    WRITE(ioun12,'(a)')"# iloop IA nloop : no def "
    WRITE(ioun12,*)t_iloop
    WRITE(ioun12,'(a)')"# sigloop RA nloop : error in measurement "
    WRITE(ioun12,*)t_sigloop
    WRITE(ioun12,'(a)')"# floop0 RA nloop : desired flux or field at meassuring loop[cgs] "
    WRITE(ioun12,*)t_floop0
    WRITE(ioun12,'(a)')"# cc0 RA nc : no def "
    WRITE(ioun12,*)t_cc0
    WRITE(ioun12,'(a)')"# rplate RA 2*nplates : r coordinates for wall [cm] "
    WRITE(ioun12,*)t_rplate
    WRITE(ioun12,'(a)')"# psi RA jm*km : psi function on grid "
    WRITE(ioun12,*)t_psi
    WRITE(ioun12,'(a)')"# jwu IA km : no def "
    WRITE(ioun12,*)t_jwu
    WRITE(ioun12,'(a)')"# jwl IA km : no def "
    WRITE(ioun12,*)t_jwl
    WRITE(ioun12,'(a)')"# rwu RA km : no def "
    WRITE(ioun12,*)t_rwu
    WRITE(ioun12,'(a)')"# rwl RA km : radius of inner wall boundary on z-grid "
    WRITE(ioun12,*)t_rwl
    WRITE(ioun12,'(a)')"# rbd RA nbd : r values of fuzzy boundary "
    WRITE(ioun12,*)t_rbd(:t_nbd)
    WRITE(ioun12,'(a)')"# zbd RA nbd : z values of fuzzy points on boudary "
    WRITE(ioun12,*)t_zbd(:t_nbd)
    WRITE(ioun12,'(a)')"# rfbd RA nfbd : r coordinates of fixed points on bnd. "
    WRITE(ioun12,*)t_rfbd(:t_nfbd)
    WRITE(ioun12,'(a)')"# zfbd RA nfbd : fuzzy boundary; see zbd "
    WRITE(ioun12,*)t_zfbd(:t_nfbd)
    WRITE(ioun12,'(a)')"# alfbd RA nfbd : fuzzy boundary weighting added to the regular1zation (see i "
    WRITE(ioun12,*)t_alfbd(:t_nfbd)
    WRITE(ioun12,'(a)')"# pfps0 RA nc : Target flux? "
    WRITE(ioun12,*)t_pfps0
    WRITE(ioun12,'(a)')"# whtz RA nbd : used to get SN generato "
    WRITE(ioun12,*)t_whtz
    WRITE(ioun12,'(a)')"# rloop RA nloop : radial position of meassuring loop;[cm] "
    WRITE(ioun12,*)t_rloop
    WRITE(ioun12,'(a)')"# zloop RA nloop : radial position of meassuring loop;[cm] "
    WRITE(ioun12,*)t_zloop
    WRITE(ioun12,'(a)')"# rls RA mls : value of r along plasma boundary, input/outpu "
    WRITE(ioun12,*)t_rls
    WRITE(ioun12,'(a)')"# zls RA mls : value of z along plasma boundary, input/output "
    WRITE(ioun12,*)t_zls
    WRITE(ioun12,'(a)')"# rork RA msrf*mls : no def "
    WRITE(ioun12,*)t_rork
    WRITE(ioun12,'(a)')"# psibar RA msrf : normalized psi "
    WRITE(ioun12,*)t_psibar
    CLOSE(ioun12)
    CALL freeus(ioun12)

  END SUBROUTINE write_labeled_savefile

  SUBROUTINE stripout
    USE teq_mod, only : ioun12
    IMPLICIT NONE
    CHARACTER(len=96) line
    INTEGER :: ios

    IF(.NOT.labeled) RETURN
    ios=0
    DO WHILE (ios==0)
       READ(ioun12,'(a)') line
       IF(line(1:1) /= '#') THEN
          BACKSPACE(ioun12)
          EXIT
       END IF
    END DO
  END SUBROUTINE stripout
    

  SUBROUTINE read_savefile(sname)

    USE teq_mod, only : ioun12
    USE sep_separatrix, only : s_pin
    USE teqlib_input

    IMPLICIT NONE

    include "debug.i"

    CHARACTER(len=1024) :: line
    CHARACTER(len=*) :: sname
    INTEGER :: i,j,ios=0
    REAL(rq) :: sz
    OPEN(UNIT=ioun12, FILE=sname, STATUS="OLD")
    READ(ioun12,'(a)') line
    IF( line(1:1) == '#') THEN
       ! begin modification for labeled savefiles
       labeled=.TRUE.
    ELSE
       labeled=.FALSE.
    END IF
    REWIND(ioun12)

    CALL stripout;READ(ioun12,'(a)')probid
    CALL stripout;READ(ioun12,'(a)')note
    CALL stripout;READ(ioun12,'(a)')shotName
    CALL stripout;READ(ioun12,*)shotTime
    CALL stripout;READ(ioun12,*)npoly
    CALL stripout;READ(ioun12,*)nbd
    CALL stripout;READ(ioun12,*)nfbd
    CALL stripout;READ(ioun12,*)nsol
    CALL stripout;READ(ioun12,*)nlim
    CALL stripout;READ(ioun12,*)nloop
    CALL stripout;READ(ioun12,*)ircwt
    CALL stripout;READ(ioun12,*)nc0p
    CALL stripout;READ(ioun12,*)kbfc
    CALL stripout;READ(ioun12,*)ixpt
    CALL stripout;READ(ioun12,*)nsym
    CALL stripout;READ(ioun12,*)nsymc
    CALL stripout;READ(ioun12,*)iflxc
    CALL stripout;READ(ioun12,*)nc
    CALL stripout;READ(ioun12,*)jm
    CALL stripout;READ(ioun12,*)km
    CALL stripout;READ(ioun12,*)ipf
    CALL stripout;READ(ioun12,*)ibdry
    CALL stripout;READ(ioun12,*)bsph_flag
    CALL stripout;READ(ioun12,*)keqic
    CALL stripout;READ(ioun12,*)initflx
    CALL stripout;READ(ioun12,*)map
    CALL stripout;READ(ioun12,*)lelm
    CALL stripout;READ(ioun12,*)inv_eq
    CALL stripout;READ(ioun12,*)inv_flag
    CALL stripout;READ(ioun12,*)lsrf
    CALL stripout;READ(ioun12,*)jqm
    CALL stripout;READ(ioun12,*)nsph
    CALL stripout;READ(ioun12,*)lsph
    CALL stripout;READ(ioun12,*)ipp
    CALL stripout;READ(ioun12,*)irl
    CALL stripout;READ(ioun12,*)liml
    CALL stripout;READ(ioun12,*)lflat
    CALL stripout;READ(ioun12,*)kedge
    CALL stripout;READ(ioun12,*)ipj
    CALL stripout;READ(ioun12,*)entropy_flag
    CALL stripout;READ(ioun12,*)ncplot
    CALL stripout;READ(ioun12,*)inv_k
    CALL stripout;READ(ioun12,*)inv_p
    CALL stripout;READ(ioun12,*)npp
    CALL stripout;READ(ioun12,*)npf
    CALL stripout;READ(ioun12,*)nasp
    CALL stripout;READ(ioun12,*)nbsp
    CALL stripout;READ(ioun12,*)ndbg16
    CALL stripout;READ(ioun12,*)ndbg8
    CALL stripout;READ(ioun12,*)ndbg10
    CALL stripout;READ(ioun12,*)ldbg5
    CALL stripout;READ(ioun12,*)ldbg9
    CALL stripout;READ(ioun12,*)ldbg8
    CALL stripout;READ(ioun12,*)ldbg7
    CALL stripout;READ(ioun12,*)ldbg10
    CALL stripout;READ(ioun12,*)ndbg12
    CALL stripout;READ(ioun12,*)ngp
    CALL stripout;READ(ioun12,*)ni
    CALL stripout;READ(ioun12,*)kgreenc
    CALL stripout;READ(ioun12,*)msrf
    CALL stripout;READ(ioun12,*)n4
    CALL stripout;READ(ioun12,*)mls
    CALL stripout;READ(ioun12,*)nht
    CALL stripout;READ(ioun12,*)fix_bound
    CALL stripout;READ(ioun12,*)nplates
    CALL stripout;READ(ioun12,*)one_pow
    CALL stripout;READ(ioun12,*)lmax
    CALL stripout;READ(ioun12,*)nl
    CALL stripout;READ(ioun12,*)int_flag
    
    jmkm=jm*km
    IF(inv_eq/=0) THEN
       npo=msrf
       ntet=mls
    END IF
    sz = 0; if (ALLOCATED(rork)) sz = SIZE(rork,1) * SIZE(rork,2)
    IF (sz/=msrf*mls) THEN
       IF(ALLOCATED(rork)) DEALLOCATE(rork)
       ALLOCATE(rork(msrf,mls))
       rork=0
    END IF

    CALL teq_input_allocate

    CALL stripout;READ(ioun12,*)crdn
    CALL stripout;READ(ioun12,*)gsph
    CALL stripout;READ(ioun12,*)asph
    CALL stripout;READ(ioun12,*)bsph
    CALL stripout;READ(ioun12,*)alfa
    CALL stripout;READ(ioun12,*)betp
    CALL stripout;READ(ioun12,*)vltf
    CALL stripout;READ(ioun12,*)thetac
    CALL stripout;READ(ioun12,*)btor
    CALL stripout;READ(ioun12,*)fefit
    CALL stripout;READ(ioun12,*)rxpr
    CALL stripout;READ(ioun12,*)zxpr
    CALL stripout;READ(ioun12,*)plcm
    CALL stripout;READ(ioun12,*)qmax
    CALL stripout;READ(ioun12,*)zn
    CALL stripout;READ(ioun12,*)zx
    CALL stripout;READ(ioun12,*)rn
    CALL stripout;READ(ioun12,*)pefit
    CALL stripout;READ(ioun12,*)rx
    CALL stripout;READ(ioun12,*)rcur
    CALL stripout;READ(ioun12,*)zcur
    CALL stripout;READ(ioun12,*)ro
    CALL stripout;READ(ioun12,*)rb
    CALL stripout;READ(ioun12,*)plcx
    CALL stripout;READ(ioun12,*)raxis0
    CALL stripout;READ(ioun12,*)zlim(0:nlim)
    CALL stripout;READ(ioun12,*)zaxis0
    CALL stripout;READ(ioun12,*)raxis
    CALL stripout;READ(ioun12,*)zaxis
    CALL stripout;READ(ioun12,*)wvert
    CALL stripout;READ(ioun12,*)betaj
    CALL stripout;READ(ioun12,*)qflat
    CALL stripout;READ(ioun12,*)psil
    CALL stripout;READ(ioun12,*)qcelm
    CALL stripout;READ(ioun12,*)pcelm
    CALL stripout;READ(ioun12,*)scelm
    CALL stripout;READ(ioun12,*)alphac
    CALL stripout;READ(ioun12,*)psil00
    CALL stripout;READ(ioun12,*)thetat
    CALL stripout;READ(ioun12,*)rlim(0:nlim)
    CALL stripout;READ(ioun12,*)aap
    CALL stripout;READ(ioun12,*)ipscl
    CALL stripout;READ(ioun12,*)svec(:nc)
    CALL stripout;READ(ioun12,*)epsb
    CALL stripout;READ(ioun12,*)scflat
    CALL stripout;READ(ioun12,*)qrat
    CALL stripout;READ(ioun12,*)dpsi00
    CALL stripout;READ(ioun12,*)dlim(0:nlim)
    CALL stripout;READ(ioun12,*)epsrk
    CALL stripout;READ(ioun12,*)epskrk
    CALL stripout;READ(ioun12,*)anun
    CALL stripout;READ(ioun12,*)alfa0
    CALL stripout;READ(ioun12,*)epsj
    CALL stripout;READ(ioun12,*)s_pin
    CALL stripout;READ(ioun12,*)epp
    CALL stripout;READ(ioun12,*)epf
    CALL stripout;READ(ioun12,*)prsx
    CALL stripout;READ(ioun12,*)filter_p
    CALL stripout;READ(ioun12,*)filter_wp
    CALL stripout;READ(ioun12,*)scl
    CALL stripout;READ(ioun12,*)dr
    CALL stripout;READ(ioun12,*)dz
    CALL stripout;READ(ioun12,*)hsrf
    CALL stripout;READ(ioun12,*)psix
    CALL stripout;READ(ioun12,*)el
    CALL stripout;READ(ioun12,*)rl
    CALL stripout;READ(ioun12,*)cejima
    CALL stripout;READ(ioun12,*)jparsave
    CALL stripout;READ(ioun12,*)qsave
    CALL stripout;READ(ioun12,*)ssave
    CALL stripout;READ(ioun12,*)psave
    CALL stripout;READ(ioun12,*)jtsave
    CALL stripout;READ(ioun12,*)fsave
    CALL stripout;READ(ioun12,*)w
    CALL stripout;READ(ioun12,*)v
    CALL stripout;READ(ioun12,*)rhc(:nc)
    CALL stripout;READ(ioun12,*)ix(:nc)
    CALL stripout;READ(ioun12,*)ic(:nc)
    CALL stripout;READ(ioun12,*)cc(:nc)
    CALL stripout;READ(ioun12,*)gdc
    CALL stripout;READ(ioun12,*)(pfid(i),i=1,nc)
    CALL stripout;READ(ioun12,*)zplate
    CALL stripout;READ(ioun12,*)rc(:nc)
    CALL stripout;READ(ioun12,*)zc(:nc)
    CALL stripout;READ(ioun12,*)drc(:nc)
    CALL stripout;READ(ioun12,*)dzc(:nc)
    CALL stripout;READ(ioun12,*)ac(:nc)
    CALL stripout;READ(ioun12,*)ac2(:nc)
    CALL stripout;READ(ioun12,*)nrc(:nc)
    CALL stripout;READ(ioun12,*)nzc(:nc)
    CALL stripout;READ(ioun12,*)rxc(:nc)
    CALL stripout;READ(ioun12,*)thloop
    CALL stripout;READ(ioun12,*)iloop
    CALL stripout;READ(ioun12,*)sigloop
    CALL stripout;READ(ioun12,*)floop0
    CALL stripout;READ(ioun12,*)cc0(:nc)
    CALL stripout;READ(ioun12,*)rplate
    CALL stripout;READ(ioun12,*)psi
    CALL stripout;READ(ioun12,*)jwu
    CALL stripout;READ(ioun12,*)jwl
    CALL stripout;READ(ioun12,*)rwu
    CALL stripout;READ(ioun12,*)rwl
    CALL stripout;READ(ioun12,*)rbd(:nbd)
    CALL stripout;READ(ioun12,*)zbd(:nbd)
    CALL stripout;READ(ioun12,*)rfbd(:nfbd)
    CALL stripout;READ(ioun12,*)zfbd(:nfbd)
    CALL stripout;READ(ioun12,*)alfbd(:nfbd)
    CALL stripout;READ(ioun12,*)pfps0(:nc)
    CALL stripout;READ(ioun12,*)whtz
    CALL stripout;READ(ioun12,*)rloop
    CALL stripout;READ(ioun12,*)zloop
    CALL stripout;READ(ioun12,*)rls
    CALL stripout;READ(ioun12,*)zls
    CALL stripout;READ(ioun12,*)rork
    CALL stripout;READ(ioun12,*,IOSTAT=ios)psibin
    IF(ios==-1) THEN
       CALL errdetec("error, past EOF in read_savefile",-1)
    END IF
    IF(rn==0) THEN
       rn=r(1);rx=r(jm)
       zn=z(1);zx=z(km)
       liml=-1 ! Uses rn, etc.
    END IF

    CLOSE(ioun12)
    CALL freeus(ioun12)

  END SUBROUTINE read_savefile
  
  SUBROUTINE read_greens(gname)

    use teqlib_input
    use teqlib_output
    USE teqinit
    USE teq_mod
    USE teqGS_mod
    USE teqSubs_mod

    IMPLICIT NONE

    CHARACTER(len=48) :: gname

    OPEN(UNIT=ioun12,FILE=gname,STATUS="OLD")
    PRINT *,"Getting Greens's functions from file ",gname
    READ(ioun12,*)lgrn
    READ(ioun12,*)jm0p
    READ(ioun12,*)km0p
    READ(ioun12,*)nc0p
    READ(ioun12,*)ncf
    READ(ioun12,*)kgreenc
    READ(ioun12,*)liml
    READ(ioun12,*)nsymco
    READ(ioun12,*)nsymo
    READ(ioun12,*)nc0b
    READ(ioun12,*)nloop0p
    READ(ioun12,*)rn
    READ(ioun12,*)rx
    READ(ioun12,*)zx

    CALL teqGS_p
    READ(ioun12,*)gc
    READ(ioun12,*)gfbr
    READ(ioun12,*)gfbz
    READ(ioun12,*)gp
    READ(ioun12,*)gpl
    READ(ioun12,*)pfim
    READ(ioun12,*)plim

  END SUBROUTINE read_greens

  SUBROUTINE write_greens(gname)

    USE teq_mod
    USE teqGS_mod

    IMPLICIT NONE

    CHARACTER(len=48) :: gname

    OPEN(UNIT=ioun12,FILE=gname,STATUS="REPLACE")
    WRITE(ioun12,*)t_lgrn
    WRITE(ioun12,*)t_jm0p
    WRITE(ioun12,*)t_km0p
    WRITE(ioun12,*)t_nc0p
    WRITE(ioun12,*)t_ncf
    WRITE(ioun12,*)t_kgreenc
    WRITE(ioun12,*)t_liml
    WRITE(ioun12,*)t_nsymco
    WRITE(ioun12,*)t_nsymo
    WRITE(ioun12,*)t_nc0b
    WRITE(ioun12,*)t_nloop0p
    WRITE(ioun12,*)t_rn
    WRITE(ioun12,*)t_rx
    WRITE(ioun12,*)t_zx
    WRITE(ioun12,*)t_gc
    WRITE(ioun12,*)t_gfbr
    WRITE(ioun12,*)t_gfbz
    WRITE(ioun12,*)t_gp
    WRITE(ioun12,*)t_gpl
    WRITE(ioun12,*)t_pfim
    WRITE(ioun12,*)t_plim
    CLOSE(ioun12)

  END SUBROUTINE write_greens

  SUBROUTINE translate(ain,fin,aout,fout)

    USE sep_math
    USE sep_interp, only : interp_interp
    USE teq_input_mod, only : t_splbdry

    IMPLICIT NONE

    REAL(rq), DIMENSION(:), INTENT(IN) :: ain,aout,fin
    REAL(rq), DIMENSION(:), INTENT(OUT) :: fout
    REAL(rq), DIMENSION(SIZE(aout)) :: dum2
    INTEGER :: mout

    CALL interp_interp(ain,fin,t_splbdry,t_splbdry,aout,fout,dum2)

  END SUBROUTINE translate

  SUBROUTINE gridup(dir,pf,inv,prof,glb,which)
    USE runTeq_mod, only : runTeq
    TYPE(dir_type), INTENT(INOUT) :: dir
    TYPE(pf_type), INTENT(INOUT) :: pf
    TYPE(inv_type), INTENT(INOUT) :: inv
    TYPE(profile_type), INTENT(INOUT) :: prof
    TYPE(global_type), INTENT(INOUT) :: glb
    CHARACTER(len=*), INTENT(INOUT) :: which
    dir%liml=-1
    IF(which=="x" .OR. which=="both") dir%psi%nx=2*dir%psi%nx-1
    IF(which=="y" .OR. which=="both") dir%psi%ny=2*dir%psi%ny-1
  END SUBROUTINE gridup

  SUBROUTINE griddown(dir,pf,inv,prof,glb,which)
    USE runTeq_mod, only : runTeq
    TYPE(dir_type), INTENT(INOUT) :: dir
    TYPE(pf_type), INTENT(INOUT) :: pf
    TYPE(inv_type), INTENT(INOUT) :: inv
    TYPE(profile_type), INTENT(INOUT) :: prof
    TYPE(global_type), INTENT(INOUT) :: glb
    CHARACTER(len=*), INTENT(INOUT) :: which
    dir%liml=-1
    IF(which=="x" .OR. which=="both") dir%psi%nx=dir%psi%nx/2+1
    IF(which=="y" .OR. which=="both") dir%psi%ny=dir%psi%ny/2+1
  END SUBROUTINE griddown

  SUBROUTINE set_global(glb)
    USE teqlib_input
    USE teq_mod, only : ioun7,ioun12,ioun13
    TYPE(global_type), INTENT(INOUT) :: glb
    glb%logunit  => logunit
    glb%logname  => logname
    glb%ioun7    => ioun7
    glb%ioun12   => ioun12
    glb%ioun13   => ioun13
  END SUBROUTINE set_global


  SUBROUTINE connect_inveq(inv,prof)
    use teqlib_input
    use teqlib_output
    type(profile_type), INTENT(INOUT) :: prof
    TYPE(inv_type), INTENT(INOUT) :: inv
    INTEGER :: i

    prof%qs        => qsave
    prof%jts       => jtsave
    prof%jpars     => jparsave
    prof%ps        => psave
    prof%fs        => fsave
    prof%w         => w
    prof%v         => v
    prof%psin      => psibin
    inv%rbnd       => rls
    inv%zbnd       => zls
    inv%raxis      => raxis
    inv%zaxis      => zaxis
    inv%dpsi00     => dpsi00
    inv%dphi00     => dphi00
    inv%dpsi0      => dpsi0
    inv%dphi0      => dphi0
    inv%epsrk      => epsrk
    inv%x          => inv_x
    inv%plc        => plcm
    inv%cur        => placur
    inv%fwall      => fwall
    inv%p          => inv_p
    inv%k          => inv_k
    inv%eq         => inv_eq
    inv%flag       => inv_flag
    inv%mpsi       => msrf
    inv%ls         => lsrf
    inv%mth        => mls
    inv%nht        => nht
    inv%R%nx       => inv%mth
    inv%R%ny       => inv%mpsi
    inv%Z%nx       => inv%mth
    inv%Z%ny       => inv%mpsi
    inv%fix_bnd    => fix_bound
    

    map            = mls / 2 + 1
    btor           = fwall / ro

    inv%R%x        => tswpts
    inv%R%y        => psibar
    inv%Z%x        => tswpts
    inv%Z%y        => psibar
    inv%R%f        => rlsd(:,:,1)
    inv%R%fx       => rlsd(:,:,2)
    inv%R%fy       => rlsd(:,:,3)
    inv%R%fs       => rlsd(:,:,4)
    inv%Z%f        => zlsd(:,:,1)
    inv%Z%fx       => zlsd(:,:,2)
    inv%Z%fy       => zlsd(:,:,3)
    inv%Z%fs       => zlsd(:,:,4)

    prof%q         => qsrf
    prof%p         => prsrf
    prof%pd        => pdsrf
    prof%jt        => jtsrf
    prof%jpar      => jparsrf
    prof%f         => frsrf
    prof%fd        => fpsrf
    prof%bsq       => bsqrf
    prof%phi       => phibar
    prof%psi       => psibar
    prof%cu        => cusrf
    prof%vpr       => vpsrf
    prof%bp        => bpsrf
    prof%rsqi      => rsqirf
    prof%a         => asrf
    prof%r         => rsrf
    inv%dpsi0      => dpsi0
    inv%dphi0      => dphi0

  END SUBROUTINE connect_inveq

  SUBROUTINE point_psi_cps(a,b,dir)
    USE teqlib_input, only : jm,km
    IMPLICIT NONE
    TYPE(dir_type), INTENT(INOUT) :: dir
    REAL(rq), DIMENSION(jm,km,3), TARGET, INTENT(INOUT) :: a
    REAL(rq), DIMENSION(jm,km),   TARGET, INTENT(INOUT) :: b
    dir%psi%f      =>  a(:,:,1)
    dir%psi%fx     =>  a(:,:,2)
    dir%psi%fy     =>  a(:,:,3)
    dir%psi%fs     =>  b
    dir%psi%nx      =>  jm
    dir%psi%ny      =>  km
  END SUBROUTINE point_psi_cps

  SUBROUTINE set_psi_cps(a,b,dir)
    USE teqlib_input, only : jm,km
    IMPLICIT NONE
    TYPE(dir_type), INTENT(INOUT) :: dir
    REAL(rq), DIMENSION(jm,km,3), INTENT(IN) :: a
    REAL(rq), DIMENSION(jm,km),   INTENT(IN) :: b
    dir%psi%f      =  a(:,:,1)
    dir%psi%fx     =  a(:,:,2)
    dir%psi%fy     =  a(:,:,3)
    dir%psi%fs     =  b
  END SUBROUTINE set_psi_cps

    
  SUBROUTINE connect_direq(dir,pf,inv,prof)
    use teqlib_input
    use teqlib_output
    USE teqinit
    USE sep_interp, only : i_cps
    USE sep_separatrix, only : s_nxps,s_rxps,s_zxps,s_pxps,s_limiterd,&
         s_rlse,s_zlse,s_mlse
    IMPLICIT NONE
    TYPE(dir_type), INTENT(INOUT) :: dir
    TYPE(pf_type), INTENT(INOUT) :: pf
    TYPE(inv_type), INTENT(INOUT) :: inv
    TYPE(profile_type), INTENT(INOUT) :: prof

    CALL connect_inveq(inv,prof)

    dir%psi%nx     => jm
    dir%psi%ny     => km
    dir%psi%x      => r
    dir%psi%y      => z
    CALL point_psi_cps(i_cps,bp,dir)
    dir%rxpt       => rxpt
    dir%zxpt       => zxpt
    dir%pxpt       => pxpt
    dir%paxis      => psix
    dir%rn         => rn
    dir%rx         => rx
    dir%ro         => ro
    dir%betaj      => betaj
    dir%zx         => zx
    dir%thc        => thetac
    dir%f_wp       => filter_wp
    dir%prsx       => prsx
    dir%rxpr       => rxpr
    dir%zxpr       => zxpr
    dir%alfa       => alfa
    dir%betp       => betp
    dir%li         => li
    dir%betap      => betap
    dir%pbnd       => psil
    dir%ipscl      => ipscl
    dir%ixpt       => ixpt
    dir%ipf        => ipf
    dir%ipj        => ipj
    dir%ipp        => ipp
    dir%irl        => irl
    dir%fix_bnd    => fix_bound
    dir%liml       => liml
    dir%epsj       => epsj
    dir%epsb       => epsb
    dir%aap        => aap
    dir%rxps       => s_rxps
    dir%zxps       => s_zxps
    dir%pxps       => s_pxps
    dir%nxps       => s_nxps
    dir%limd       => s_limiterd
    dir%msep       => s_mlse
    dir%zsep       => s_zlse
    dir%rsep       => s_rlse

    pf%ncircuit    => ncircuit
    pf%ngroup      => ngroup
    pf%nbd         => nbd
    pf%jcir        => jbdcir
    pf%nfbd        => nfbd
    pf%nc          => nc
    pf%ncp         => ncplot
    pf%ngp         => ngp
    pf%kax         => kaxis
    pf%kxp         => kxp
    pf%nlim        => nlim
    pf%nrc         => nrc
    pf%nzc         => nzc
    pf%ic          => ic
    pf%ix          => ix
    pf%ict         => ict
    pf%ic          => ic
    pf%cc          => cc
    pf%rc          => rc
    pf%zc          => zc
    pf%drc         => drc
    pf%dzc         => dzc
    pf%ps0         => pfps0
    pf%psi         => pfpsi
    pf%pci         => pfpci
    pf%pc0         => pfpc0
    pf%pfim        => pfim
    pf%rlim        => rlim
    pf%zlim        => zlim
    pf%rbd         => rbd
    pf%zbd         => zbd
    pf%rfbd        => rfbd
    pf%zfbd        => zfbd
    pf%alfbd       => alfbd
    pf%psix        => plcx
    pf%vltf        => vltf
    pf%cejima      => cejima
    pf%rl          => rl
    pf%irl         => irl
    pf%ircwt       => ircwt
    pf%iflxc       => iflxc
    pf%nsymc       => nsymc
    pf%nsym        => nsym
    pf%rax         => raxis0
    pf%zax         => zaxis0
    pf%rxp         => rxpt0
    pf%zxp         => zxpt0
    pf%skew        => skew
    pf%rminor      => rbore
    pf%rmajor      => rcntr
    pf%dsep        => dsep    
    pf%dsip        => dsip
    pf%lmax        => lmax
    pf%limw        => limw
    pf%rlimw       => rlimw
    pf%zlimw       => zlimw

  END SUBROUTINE connect_direq

END MODULE teqlib

! $Id: diag.f90,v 1.2 2007/07/23 16:00:57 meyer Exp $

MODULE diag_mod

  USE greens_mod
  USE teqSurf_mod

  IMPLICIT NONE

  REAL(rq), DIMENSION(:), ALLOCATABLE, TARGET, PRIVATE :: cq0,cq1,cq2,cq3,cq4,&
       cq5,cq6,dq0,dq1,dq2,dq3,dq4,dq5,dq6,cq7,cq8,cq9,cq10,dq7,dq8,dq9,&
       dq10,c0,c1,c2,c3,pswpts,brs,bzs,bps,bms,bts
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, PRIVATE :: pdloop
  REAL(rq), PARAMETER, PRIVATE :: GAMMA=5._rq/3._rq
  INTEGER, PRIVATE :: mlm

CONTAINS

  SUBROUTINE d_bline(dd,lxx,lss)
    INTEGER, INTENT(IN) :: lxx,lss
    REAL(rq), INTENT(IN) ::  dd
    INTEGER :: jmx,lbdry,lvv

    IF(dd>=0) THEN
       lbdry=2
       lvv=0
       CALL psisrf_separatrix(t_pxpt,lbdry,t_r,t_z,t_psi)
       CALL maps_separatrix(t_pxpt,lvv)
    END IF
    pswpts=SQRT((t_rlsd(:,t_msrf,1)-t_raxis)**2+((t_zlsd(:,t_msrf,1)-&
         t_zaxis)/t_wvert)**2)
    IF(lss/=0) THEN
       CALL blined(dd,lxx,lss)
    ELSE
       cq3=t_rlsd(:,t_msrf,1)
       dq3=t_zlsd(:,t_msrf,1)
       CALL d_strkpl(t_pxpt)            !   reset strike points
    END IF
  END SUBROUTINE d_bline

  SUBROUTINE blined(ddd,lxx,ls)
    !.........................................................................
    !.. This function evaluates the distance along the field line from the
    !.. mid-plane to the divertor plate.
    !.. ls abs=1 inside; abs=2 outside. ls>0 to strike point ls<0 to boundary
    !.. dd-s the distance off the separatrix
    !.. distances are stored in pds: pds(1:2)   direct (total:poloidal)
    !..                              pds(3:4) indirect (total:poloidal)
    !.. indirect only occurs for a single null
    !.. rpts,zpts,cq5,cq7,cq6: coordinates,bpol,tot dist, pol dist; direct
    !.. dq6,dq7,dq5,cq4,dq4: coordinates,bpol,tot dist, pol dist; indirect
    !.. cq8,dq8: cq4,dq4; direct
    !.. cq9,dq9: cq4,dq4; inirect
    !.. dq10  k-perp squared for direct; cq10 for indirect
    !.. lxx=number of points for direct; mls=number of points indirect
    !.........................................................................
    INTEGER,  INTENT(IN) :: lxx,ls
    REAL(rq), INTENT(IN) ::  ddd
    INTEGER,  SAVE :: ii,iii,mlx,ml1
    REAL(rq), SAVE :: dd,rrig(2),zrig(2),zrst(2),zzst(2),zrml(2)
    REAL(rq) :: pds(8),xang,rstart,zstart,psill,batan,dbxpt,drxpt,pan,f,fx,&
         fxx,fxxx,psiv(t_jm,t_km),rit,rat,zra,zza,avert,rmlm,rut,zbps,zbrs,&
         zbzs,test,denom,a1
    INTEGER :: kl,lv,ll,ier,ibxpt,n,jss,j,k,l1,l,i,jer,iter,isw,nn
    include "debug.i"

    !.... Must find strike points on lower divertor plates
    !.... These are the inner and outer radius of crossings on the separatrix

    dd=ABS(ddd)
    ll=ls
    kl=t_km/2+1
    lv=1
    mlm=t_mls/2+1
    IF(ls<0) THEN
       lv=0
       ll=-ls
    END IF
    !...  Now find strike points
    IF(ll==1) THEN
       rstart=s_rcntr-s_rbore-dd
       zstart=t_zaxis
       rat=rstart-(s_rcntr-s_rbore)
       ier=6
       CALL boxd_interp (rstart,zstart,pds,ier,t_n4)
       psill=pds(1)
       IF(ier/=0) call errdetec("boxd_interp error in bline",1)
       IF(lv/=0) THEN   !   inside
          CALL d_strkpl(psill)
          IF(t_nsym<=1) THEN
             t_nstkpts=t_nstkpts/2
             DO iii=1,t_nstkpts
                t_zstkpt(iii)=-t_zstkpt(iii)
             END DO
          END IF
          IF(t_nstkpts/=2) lv=0  !  ignore strike points go to wall
       END IF
    ELSEIF(ll==2) THEN      !   outside
       rstart=s_rcntr+s_rbore+dd
       zstart=t_zaxis
       rat=rstart-(s_rcntr+s_rbore)
       ier=3
       call boxd_interp (rstart,zstart,pds,ier,t_n4)
       psill=pds(1)
       IF(ier/=0) call errdetec("boxd_interp error in bline",1)
       IF(lv/=0) THEN
          call d_strkpl(psill)
          IF(t_nsym<=1) THEN
             t_nstkpts=t_nstkpts/2
             DO iii=1,t_nstkpts
                t_zstkpt(iii)=-t_zstkpt(iii)
             END DO
          END IF
          IF(t_nstkpts/=2) lv=0  !  ignore strike points go to wall
       END IF
    END IF
    batan=atan2((s_zxpl-t_zaxis)/t_wvert,s_rxpl-t_raxis)+TWOPI
    dbxpt=TWOPI/(t_mls-1)
    ibxpt=batan/dbxpt+1
    ier=6
    call boxd_interp(s_rxpl,s_zxpl,pds,ier,t_n4)
    drxpt=sqrt(abs((psill-pds(1))*2/pds(4)))
    IF(lv==0) THEN
       psiv=RESHAPE(t_psi,(/t_jm,t_km/))
       j=t_jm
       k=kl
       pan=psiv(t_jm,kl)-psill
       pan=SIGN(1.0_rq,pan)
       DO k=kl,1,-1      !    look on outside boundary for 2nd crossing
          IF((psiv(j,k)-psill)*pan<0) EXIT
       END DO
       jss=t_jm
       IF(k==0) THEN   !   no crossing yet
          k=1
          DO j=t_jm,1,-1   !   look on bottom  boundary for 2nd crossing
             IF((psiv(j,k)-psill)*pan<0) EXIT
          END DO
          jss=1
       END IF
       n=j+t_jm*(k-1)
       CALL Siden(n,jss,f,fx,fxx,fxxx)
       dd=(psill-t_psi(n))/(t_psi(n+jss)-t_psi(n))
       IF(jss==1) THEN
          dd=dd*t_dr
       ELSEIF(jss==t_jm) THEN
          dd=dd*t_dz
       END IF
       CALL Newton(psill,dd,f,fx,fxx,fxxx)   !   found crossing
       IF(jss==1) THEN
          t_rstkpt(2)=t_r(j)+(dd+0.5*t_dr)
          t_zstkpt(2)=t_z(k)
       ELSEIF(jss==t_jm) THEN
          t_rstkpt(2)=t_r(j)
          t_zstkpt(2)=t_z(k)+(dd+0.5*t_dz)
       END IF
       j=1
       k=kl
       pan=psiv(j,k)-psill
       pan=sign(1.0_rq,pan)
       j=1
       DO k=kl,1,-1    !   look on inside  boundary for 1st crossing
          IF((psiv(j,k)-psill)*pan<0) EXIT
       END DO
       jss=t_jm
       IF(k==0) THEN   !   no crossing yet
          DO j=1,t_jm           !   look on bottom  boundary for 1st crossing
             IF((psiv(j,k)-psill)*pan<0) EXIT
          END DO
          j=j-1
          jss=1
       END IF
       n=j+t_jm*(k-1)
       CALL Siden(n,jss,f,fx,fxx,fxxx)
       dd=(psill-t_psi(n))/(t_psi(n+jss)-t_psi(n))-0.5_rq
       IF(jss==1) THEN
          dd=dd*t_dr
       ELSEIF(jss==t_jm) THEN
          dd=dd*t_dz
       END IF
       CALL Newton(psill,dd,f,fx,fxx,fxxx)   !   found crossing
       IF(jss==1) THEN
          t_rstkpt(1)=t_r(j)+(dd+0.5_rq*t_dr)
          t_zstkpt(1)=t_z(k)
       ELSEIF(jss==t_jm) THEN
          t_rstkpt(1)=t_r(j)
          t_zstkpt(1)=t_z(k)+(dd+0.5_rq*t_dz)
       END IF
    END IF
    l1=1
    IF(t_nsym==2) THEN
       l1=2
    END IF
100 continue
    IF(l1==1) THEN   !   direct
       t_rpts(1)=rstart
       t_zpts(1)=zstart
       IF(ll==2 .AND. ddd>0) THEN  !   outside
          ii=1
          DO l=t_mls-1,ibxpt+1,-1
             rit=rat+(drxpt-rat)*(t_mls-l)/(t_mls-ibxpt)
             ii=ii+1
             t_rpts(ii)=cq3(l)+rit
             t_zpts(ii)=dq3(l)
          END DO
          ii=ii+1
          t_zpts(ii)=s_zxpl
          t_rpts(ii)=s_rxpl+drxpt
          rrig(ll)=t_r(t_jm)+s_rbore
          xang=atan2(s_zlse(s_mlxe+1)-s_zxpl,s_rlse(s_mlxe+1)-s_rxpl)-Pi/4
          zrig(ll)=s_zxpl+tan(xang)*(rrig(ll)-s_rxpl)
       ELSEIF(ll==1 .AND. ddd>0) THEN   !   inside
          ii=1
          DO l=mlm+1,ibxpt
             rit=rat-(l-mlm)*(drxpt+rat)/(ibxpt-mlm+1)
             ii=ii+1
             t_rpts(ii)=cq3(l)+rit
             t_zpts(ii)=dq3(l)
          END DO
          ii=ii+1
          t_zpts(ii)=s_zxpl
          t_rpts(ii)=s_rxpl-drxpt
          rrig(ll)=t_r(1)-s_rbore
          xang=atan2(s_zlse(s_mlxe-1)-s_zxpl,s_rlse(s_mlxe-1)-s_rxpl)+Pi/4
          zrig(ll)=s_zxpl+tan(xang)*(rrig(ll)-s_rxpl)
       END IF
       iii=ll
       ml1=1 
       mlx=lxx
       zra=rrig(iii)
       zza=zrig(iii)
    ELSEIF(l1==2) THEN      !   indirect strike trajectories
       IF(ll==2 .AND. ddd>0) THEN       !   starts outside to inside
          DO l=1,mlm
             t_rpts(l)=cq3(l)
             t_zpts(l)=dq3(l)
             cq5(l)=pswpts(l)
             dq0(l)=t_brwpts(l)
             dq1(l)=t_bzwpts(l)
          END DO
          ii=ibxpt+1
          t_zpts(ii)=s_zxpl
          t_rpts(ii)=s_rxpl-drxpt
          rut=cq3(mlm)-(s_rcntr-s_rbore)
          DO l=mlm+1,ibxpt
             rit=rut-(l-mlm)*(drxpt+rut)/(ibxpt-mlm+1)
             t_rpts(l)=cq3(l)+rit
             t_zpts(l)=dq3(l)
          END DO
          rrig(3-ll)=t_r(1)-s_rbore
          xang=atan2(s_zlse(s_mlxe-1)-s_zxpl,s_rlse(s_mlxe-1)-s_rxpl)+Pi/4
          zrig(ll)=s_zxpl+tan(xang)*(rrig(ll)-s_rxpl)
       ELSEIF(ll==1 .AND. ddd>0) THEN !   starts inside to outside
          DO l=1,mlm
             t_rpts(l)=cq3(mlm+1-l)
             t_zpts(l)=dq3(mlm+1-l)
             cq5(l)=pswpts(mlm+1-l)
             dq0(l)=t_brwpts(mlm+1-l)
             dq1(l)=t_bzwpts(mlm+1-l)
          END DO
          rut=cq3(1)-(s_rcntr+s_rbore)
          ii=mlm
          DO l=t_mls-1,ibxpt+1,-1
             ii=ii+1
             rit=rut+(drxpt-rut)*(t_mls-l)/(t_mls-ibxpt)
             t_rpts(ii)=cq3(l)+rit
             t_zpts(ii)=dq3(l)
          END DO
          ii=ii+1
          t_zpts(ii)=s_zxpl
          t_rpts(ii)=s_rxpl+drxpt
          rrig(3-ll)=t_r(t_jm)+s_rbore
          xang=atan2(s_zlse(s_mlxe+1)-s_zxpl,s_rlse(s_mlxe+1)-s_rxpl)-Pi/4
          zrig(ll)=s_zxpl+tan(xang)*(rrig(ll)-s_rxpl)
       END IF
       ml1=mlm
       mlx=t_lmax
       iii=3-ll
       zra=rrig(iii)
       zza=zrig(iii)
    END IF
    IF(ddd>=0) THEN
       DO i=ml1,ii
          cq5(i)=sqrt((t_rpts(i)-zra)**2+(t_zpts(i)-zza)**2)
          dq0(i)=(t_rpts(i)-zra)/cq5(i)
          dq1(i)=(t_zpts(i)-zza)/cq5(i)
       END DO
       cq5(mlx)=sqrt((t_rstkpt(iii)-zra)**2+(t_zstkpt(iii)-zza)**2)
       dq0(mlx)=(t_rstkpt(iii)-zra)/cq5(mlx)
       dq1(mlx)=(t_zstkpt(iii)-zza)/cq5(mlx)
       zbps=(cq5(ii)-cq5(mlx))/(mlx-ii)
       zbrs=(dq0(ii)-dq0(mlx))/(mlx-ii)
       zbzs=(dq1(ii)-dq1(mlx))/(mlx-ii)
       DO i=ii+1,mlx
          cq5(i)=cq5(ii)-zbps*(i-ii)
          dq0(i)=dq0(ii)-zbrs*(i-ii)
          dq1(i)=dq1(ii)-zbzs*(i-ii)
          t_rpts(i)=zra+cq5(i)*dq0(i)
          t_zpts(i)=zza+cq5(i)*dq1(i)
       END DO
    ELSE
       IF(l1==1) THEN
          DO i=ml1,mlx
             t_rpts(i)=dq2(i)
             t_zpts(i)=cq2(i)
             cq5(i)=sqrt((t_rpts(i)-zra)**2+(t_zpts(i)-zza)**2)
             dq0(i)=(t_rpts(i)-zra)/cq5(i)
             dq1(i)=(t_zpts(i)-zza)/cq5(i)
          END DO
          rmlm=rstart
       ELSEIF(l1==2) THEN
          DO i=1,mlx
             t_rpts(i)=dq6(i)
             t_zpts(i)=dq7(i)
          END DO
          DO i=1,mlm
             cq5(i)=sqrt((t_rpts(i)-t_raxis)**2+(t_zpts(i)-t_zaxis)**2)
             dq0(i)=(t_rpts(i)-t_raxis)/cq5(i)
             dq1(i)=(t_zpts(i)-t_zaxis)/cq5(i)
          END DO
          DO i=ml1,mlx
             cq5(i)=sqrt((t_rpts(i)-zra)**2+(t_zpts(i)-zza)**2)
             dq0(i)=(t_rpts(i)-zra)/cq5(i)
             dq1(i)=(t_zpts(i)-zza)/cq5(i)
          END DO
          rmlm=t_rpts(ml1)
          jer=3
          DO iter=1,nter_interp
             ier=jer
             call boxd_interp(rmlm,t_zaxis,pds,ier,t_n4)
             test=abs(pds(1)/psill-1)
             IF(test<errt_rq) EXIT
             rmlm=rmlm+(psill-pds(1))/pds(2)
          END DO
       END IF
       !---- shift origin so as to preserve initial and final angle
       denom=dq1(mlx)*dq0(ml1)-dq0(mlx)*dq1(ml1)
       rrig(iii)=rrig(iii)+(dq1(mlx)*dq0(ml1)*(t_rstkpt(iii)-zrst(iii))-&
            dq0(mlx)*dq1(ml1)*(rmlm-zrml(iii))-dq0(mlx)*dq0(ml1)*&
            (t_zstkpt(iii)-zzst(iii)))/denom
       zrig(iii)=zrig(iii)+(dq1(mlx)*dq1(ml1)*(t_rstkpt(iii)-zrst(iii)-&
            rmlm+zrml(iii))-dq0(mlx)*dq1(ml1)*(t_zstkpt(iii)-zzst(iii)))/denom
       zra=rrig(iii)
       zza=zrig(iii)
       t_rpts(mlx)=t_rstkpt(iii)
       t_zpts(mlx)=t_zstkpt(iii)
       !DC      zpss=sqrt((rstkpt(iii)-zra)**2+(zstkpt(iii)-zza)**2)
       !DC      zq0s=(rstkpt(iii)-zra)/zpss
       !DC      zq1s=(zstkpt(iii)-zza)/zpss
       !DC      zps1=sqrt((rmlm-zra)**2+(t_zaxis-zza)**2)
       !DC      zq01=(rmlm-zra)/zps1
       !DC      zq11=(t_zaxis-zza)/zps1
       !---- end of origin shift
    END IF
    isw=0
    DO iter=1,nter_interp
       ier=6
       call boxm_interp(t_rpts,t_zpts,t_pdls,t_r,t_z,i_cps,isw,ier,t_n4)
       test=0
       DO i=1,mlx-1
          cq0(i)=psill-t_pdls(i,1)
          test=test+abs(cq0(i))
       END DO
       test=test/abs(psill*mlx)
       IF(test<errt_rq) EXIT
       DO i=1,mlx-1
          cq1(i)=t_pdls(i,2)*dq0(i)+t_pdls(i,3)*dq1(i)
          cq2(i)=t_pdls(i,4)*dq0(i)**2+2*t_pdls(i,5)*dq0(i)*dq1(i)+&
               t_pdls(i,6)*dq1(i)**2
          a1=2*cq0(i)*cq2(i)/cq1(i)**2+1
          cq5(i)=cq5(i)+2*cq0(i)/cq1(i)/(1+sqrt(abs(a1)))
       END DO
       DO i=1,ml1-1
          t_rpts(i)=t_raxis+cq5(i)*dq0(i)
          t_zpts(i)=t_zaxis+cq5(i)*dq1(i)
       END DO
       DO i=ml1,mlx-1
          t_rpts(i)=zra+cq5(i)*dq0(i)
          t_zpts(i)=zza+cq5(i)*dq1(i)
       END DO
    END DO
    zrst(iii)=t_rstkpt(iii)
    zzst(iii)=t_zstkpt(iii)
    zrml(iii)=t_rpts(ml1)
    DO i=1,mlx
       dq0(i)=(t_pdls(i,2)**2+t_pdls(i,3)**2)
       cq0(i)=((t_pdls(i,4)-t_pdls(i,6))*(t_pdls(i,2)**2-t_pdls(i,3)**2)+4*&
            t_pdls(i,2)*t_pdls(i,3)*t_pdls(i,5))/dq0(i)
       cq8(i)=-t_pdls(i,3)/t_rpts(i)
       dq8(i)=t_pdls(i,2)/t_rpts(i)
       cq5(i)=sqrt(dq0(i))/t_rpts(i) ! Bpol
       cq1(i)=-t_fwall*(t_pdls(i,2)/t_rpts(i)+cq0(i))/t_rpts(i)**2/dq0(i)/cq5(i)
       cq6(i+1)=sqrt((t_rpts(i+1)-t_rpts(i))**2+(t_zpts(i+1)-t_zpts(i))**2)
    END DO
    cq6(1)=0
    cq7(1)=0
    dq10(1)=0
    DO l=2,mlx
       dq10(l)=0.5_rq*cq6(l)*(cq1(l)+cq1(l-1))
       cq7(l)=cq6(l)*0.5_rq*(sqrt(1+(t_frsrf(t_msrf)/t_rpts(l)/cq5(l))**2)+&
            SQRT(1+(t_frsrf(t_msrf)/t_rpts(l-1)/cq5(l-1))**2))
    END DO
    DO l=2,mlx
       dq10(l)=dq10(l)+dq10(l-1)! local dq9
       cq7(l)=cq7(l)+cq7(l-1)   !   el
       cq6(l)=cq6(l)+cq6(l-1)   !   el pol
    END DO
    IF(l1==2) THEN
       dq6(t_lmax)=t_rpts(t_lmax)   !   r for indirect strike
       dq7(t_lmax)=t_zpts(t_lmax)   !   z for indirect strike
       dq5(t_lmax)=cq5(t_lmax)      !   bpoloidal for indirect strike
       cq4(t_lmax)=cq7(t_lmax)      !   toroidal distance for indirect strike
       dq4(t_lmax)=cq6(t_lmax)      !   poloidal distance for indirect strike 
       cq9(t_lmax)=cq8(t_lmax)      !   Br for indirect strike point
       dq9(t_lmax)=dq8(t_lmax)      !   Bz for indirect strike point
       cq10(t_lmax)=dq10(t_lmax)    !   local dq9
       pds(3)=cq7(t_lmax)
       pds(4)=cq6(t_lmax)
       l1=1
       go to 100
    ELSEIF(l1==1) THEN
       dq2(mlx)=t_rpts(mlx)
       cq2(mlx)=t_zpts(mlx)
    END IF
    pds(1)=cq7(lxx)
    pds(2)=cq6(lxx)
    nn=0
    IF(ll==1 .AND. nn/=0) THEN
       t_tlsoli(1,nn)=pds(1)
       t_plsoli(1,nn)=pds(2)
       IF(t_nsym==2) THEN
          t_tlsoli(2,nn)=pds(3)
          t_plsoli(2,nn)=pds(4)
       END IF
    END IF
    IF(ll==2 .AND. nn/=0) THEN
       t_tlsolo(1,nn)=pds(1)
       t_plsolo(1,nn)=pds(2)
       IF(t_nsym==2) THEN
          t_tlsolo(2,nn)=pds(3)
          t_plsolo(2,nn)=pds(4)
       END IF
    END IF
  END SUBROUTINE blined!

  SUBROUTINE diag
    include "debug.i"
    REAL(rq) ::  pds(8),bmdf(t_jm),bzft(t_jm),sump,tanskew,fcr,skew,avert,qq,&
         flxx,dd
    INTEGER :: ier,l,j,k,mq,msr,n1
    n1=0
    IF(ALLOCATED(cq0)) THEN
       n1=SIZE(cq0)
    END IF
    IF(n1/=t_mls) THEN
       IF(ALLOCATED(cq0)) DEALLOCATE(cq0,cq1,cq2,cq3,cq4,cq5,cq6,cq7,cq8,cq9,&
            cq10,dq0,dq3,dq4,dq5,dq6,dq7,dq8,dq9,dq10,pswpts)
       ALLOCATE(cq0(t_mls),cq1(t_mls),cq2(t_mls),cq3(t_mls),cq4(t_mls),&
            cq5(t_mls),cq6(t_mls),cq7(t_mls),cq8(t_mls),cq9(t_mls),&
            cq10(t_mls),dq0(t_mls),dq3(t_mls),&
            dq4(t_mls),dq5(t_mls),dq6(t_mls),dq7(t_mls),dq8(t_mls),dq9(t_mls),&
            dq10(t_mls),pswpts(t_mls))
    END IF
    n1=0
    IF(ALLOCATED(dq1))THEN
       n1=SIZE(dq1)
    END IF
    IF(n1/=t_mls) THEN
       IF(ALLOCATED(dq1))DEALLOCATE(dq1,dq2)
       ALLOCATE(dq1(t_mls),dq2(t_mls))
    END IF

    
    sump=TWOPI/(t_lmax-1)
    IF(t_m95==0) t_m95=.95_rq
    !     for parallel current diagnostics
    !
    !     compute flux surface quantities
    !

    ier=0
    CALL boxd_interp (t_raxis,t_zaxis,pds,ier,t_n4)
    IF(t_nsym==1) THEN
       t_esrf(1)=sqrt(pds(4)/pds(6))
       t_rsqbp(1)=TWOPI/(t_raxis*sqrt(pds(4)*pds(6)))
    ELSE
       skew=0.5_rq*atan(2*pds(5)/(pds(4)-pds(6)))
       fcr=pds(4)/pds(6)
       avert=sqrt(1+4*pds(5)**2/(pds(4)-pds(6))**2)
       t_esrf(1)=sqrt((fcr+1+(fcr-1)*avert)/(fcr+1-(fcr-1)*avert))
       t_rsqbp(1)=TWOPI/(t_raxis*sqrt(pds(4)*pds(6)-pds(5)**2))
       tanskew=tan(skew)**2
       t_rsqbp(1)=TWOPI*(1-tanskew)/t_raxis/sqrt((pds(4)-pds(6)*tanskew)*&
            (pds(6)-pds(4)*tanskew))
       t_esrf(1)=sqrt((fcr-tanskew)/(1-fcr*tanskew))
    END IF
    IF(t_ipj==0) CALL surfaces_separatrix(t_psibar,t_rlsd,t_zlsd)
    CALL get_surfint
    !... reset t_mls arrays to plasma surface
    l=t_msrf
    cq3=t_rlsd(:,l,1)
    dq3=t_zlsd(:,l,1)
    dq0=s_pin*t_zlsd(:,l,4)
    cq4=t_rlsd(:,l,2)/dq0
    dq4=t_zlsd(:,l,2)/dq0
    cq5=sqrt(cq4**2+dq4**2)
    dq5=t_frsrf(l)/cq3
    dq6=sqrt(cq5**2+dq5**2)
    !...  done
    CALL diaginv

    t_jparsrf=10.*(t_frsrf*t_pdsrf/t_bsqrf+t_fpsrf/FOURPI)
    t_jtsrf = 10.*(t_pdsrf+t_bsqrf*t_fpsrf/t_frsrf/FOURPI)/t_rsqirf
    IF(t_ifluxcord==0) THEN
       t_vptor=abs(t_vpsrf/t_qsrf)
    ELSE
       t_vptor=t_vpsrf
       IF(t_ifluxcord==2) t_jtsrf=t_qsrf*t_jtsrf !  LDP RFP
    END IF
    t_srsrf=t_prsrf*t_vptor**GAMMA

    t_ssave=t_srsrf+errt_rq*t_srsrf
    t_fsave=t_frsrf
    IF(t_ipj==0) THEN
       t_qsave   =t_qsrf
       t_jparsave=t_jparsrf
       t_jtsave  =t_jtsrf
       t_psave   =t_prsrf
       t_dpsi00=t_dpsi0
    ELSEIF(t_ipj==1) THEN
       t_qsave   =t_qsrf
       t_jparsave=t_jparsrf
    ELSEIF(t_ipj==2) THEN
       t_qsave   =t_qsrf
       t_jparsave=t_jparsrf
       t_psave   =t_prsrf
       t_dpsi00=t_dpsi0
    ELSEIF(t_ipj==3) THEN
       t_qsave   =t_qsrf
       t_jtsave  =t_jtsrf
    ELSEIF(t_ipj>3) THEN
       t_jparsave=t_jparsrf
       t_jtsave  =t_jtsrf
    END IF

    DO j=1,t_jm
       CALL g_flxfld(t_r(j),t_zaxis,bmdf(j),bzft(j),flxx)
    END DO
    t_fldind(1)=0
    DO j=2,t_jm-1
       t_fldind(j)=-0.5_rq*t_r(j)*(bzft(j+1)-bzft(j-1))/bzft(j)/t_dr
    END DO
    msr=t_msrf
    IF(t_pxpt==t_psil)msr=t_msrf-1
    mq=1
    t_qmin=xminaf(t_qsrf,1,msr,1,mq)
    t_rhomin=0
    IF(mq==1) THEN
       t_qmin=xmaxaf(t_qsrf,1,msr,1,mq)
       DO l=mq-1,1,-1
          IF(t_qsrf(l)<t_qmin) THEN
             t_qmin=t_qsrf(l)
          ELSE
             EXIT
          END IF
       END DO
       mq=l+1
    END IF
    IF(mq>1 .AND. mq<t_msrf) THEN
       dd=-0.5_rq*(t_qsrf(mq+1)-t_qsrf(mq-1))/(t_qsrf(mq+1)+t_qsrf(mq-1)-2*&
            t_qsrf(mq))
       t_qmin=t_qmin+0.5_rq*(t_qsrf(mq+1)-t_qsrf(mq-1))*dd
       t_rhomin=t_phibar(mq)+0.5*dd*(t_phibar(mq+1)-t_phibar(mq-1))+0.5_rq*&
            dd**2*(t_phibar(mq+1)+t_phibar(mq-1)-2*t_phibar(mq))
       t_rhomin=SQRT(ABS(t_rhomin))
    END IF
    t_aac=SQRT(ABS(t_ccf/t_crdn)/PI)
    WHERE(t_aac<t_acmin) t_aac=t_acmin
    !
    !     compute inductances , energy in mks units
    !
    IF(t_fix_bound) THEN
       k=0
       CALL vltsec(t_slfnd,k)
       t_vltsnd(1)=t_slfnd
       t_vltsnd(2)=g_flxc(t_raxis,t_zaxis)*MU0/20
       t_vltsnd(3)=g_flxc(s_rcntr,t_zaxis)*MU0/20
       t_slfnd=1.e6*abs(t_psires-t_vltsnd(1))/abs(t_placur)
       ! Get candidate strike-points (get rstkpt(1:nstkpts), etc.)
       CALL d_strkpl(t_pxpt)
       ! Distill strike-points (get rspt(1:nspt), etc.)
       CALL dstrkpl
    END IF
    ! STORED ENERGY [MJ] IN PF COIL SYSTEM...
    t_pfe0=0
    DO k=1,t_nc
       t_pfse(k)=0.5_rq*t_cc(k)*SUM(t_pfim(k,:)*t_cc)
       t_pfe0(k)=t_pfe0(k)+0.5_rq*t_pfim(k,k)*t_cc(k)**2
    ENDDO
    t_pfcse=SUM(t_pfse)
    t_wpf = t_pfcse*1.0e-03_rq
    t_wpt=t_plcm*t_psires+SUM(t_pfpsi*t_cc)
    t_wpt=5.0e-4_rq*t_wpt
    t_pftse=t_wpt*1.e+3_rq
    t_ccdir=0
    DO k=1,t_ngroup
       j=k+1
       if(k==t_ngroup) j=1
       t_ccdir=t_ccdir+(t_ccls(j)-t_ccls(k))**2/((t_rcg(j)-t_rcg(k))**2+&
            (t_zcg(j)-t_zcg(k))**2)
    END DO
    t_ccdir=SQRT(t_ccdir)
    IF( t_lasteq==1 .AND. t_lop0==1 ) THEN
       CALL pfcfld
    ELSEIF(t_kbfc==1) THEN
       CALL pfcfld
    END IF
  END SUBROUTINE diag

  SUBROUTINE newflux(lpest)
    ! Calculates other flux coordinates
    ! lpest: 0=equal arcs, 1=Hamada, 2=Pest coordinates
    INTEGER, INTENT(IN) :: lpest
    REAL(rq), PARAMETER :: y1=-666
    INTEGER :: l,ls
    CALL parsestr('svtitlet="Myflux"')
    DO l=2,t_msrf
       IF(lpest==0) THEN
          CALL parsestr('svtitlet="Equal arcs"')
          dq0=t_rlsd(:,l,4)*t_zlsd(:,l,4) ! = dl/d theta
       ELSEIF(lpest==1) THEN
          CALL parsestr('svtitlet="Hamada"')
          dq0=t_zlsd(:,l,4)
       ELSEIF(lpest==2) THEN	
          CALL parsestr('svtitlet="Pest"')
          dq0=t_zlsd(:,l,4)*t_frsrf(l)/t_qsrf(l)/t_rlsd(:,l,1)**2
       ELSEIF(lpest==3) THEN ! NCLASS
          CALL parsestr('svtitlet="NCLASS"')            
          dq0=t_zlsd(:,l,4)*sqrt(t_rlsd(:,l,4)**2+t_frsrf(l)**2/&
               t_rlsd(:,l,1)**2)
       END IF
       CALL spline_interp(t_tswpts,dq0,y1,y1,cq0,cq1,cq2,dq1)
       !        cos0(l)=TWOPI/dq1(t_mls)
       dq1=TWOPI*dq1/dq1(t_mls)
       cq1=sqrt((t_rlsd(:,l,1)-t_raxis)**2+((t_zlsd(:,l,1)-t_zaxis)/t_wvert)**2)
       CALL interp_interp(dq1,cq1,y1,y1,t_tswpts,dq2,cq2)
       cq1=t_tswpts-dq1
       CALL interp_interp(dq1,cq1,y1,y1,t_tswpts,cq0,cq2)
       cq0=cq0+t_tswpts
       t_rlsd(:,l,1)=dq2*cos(cq0)+t_raxis
       t_zlsd(:,l,1)=dq2*sin(cq0)*t_wvert+t_zaxis
    END DO
    !      cos0(1)=extrp(cos0,t_psibar,t_msrf,0,0)
  END SUBROUTINE newflux
  
  SUBROUTINE pfcfld
    INTEGER ncu,nbeg,nn,loop,loom,denom,nr,nz,ir,iz,l1,n,kl,jkl,l,j,i,ii,&
         mm,ifjx0,nbc,k,l2,i1,jk0p
    REAL(rq) ::  wk(t_jm0p,t_km0p),br0,bz0,brr,bzz,bbr,bbz,bmod,bmod0,bmax,fr,fz,&
         rg,zf,zg,rg0,zg0,drg,dzg,fl1,fl,b
    DATA ifjx0 /0/
    ncu=t_nc
    IF (t_nsymc == 1) ncu=t_nc/2
    !
    ! CURRENT DENSITY, SUM |I| AND SUM |I*L|...
    !
    nbc=0
    jk0p=t_jm0p*t_km0p
    t_pfjp=t_cc/(t_drc*t_dzc)
    t_pfil=ABS( TWOPI*t_rc*t_cc )
    t_pfcsi=SUM(abs(t_cc))
    t_pfcil=SUM(t_pfil)
    !
    ! B-FIELDS...
    !
    nbeg=1
    nn=0
    l1=1
    loop=0
    loom=0
    DO n=1,ncu
       t_pfbc(n)=0.0
       t_pfbr(n)=0.0
       t_pfbz(n)=0.0
       t_pffr(n)=0.0
       t_pffz(n)=0.0
       IF (t_kgreenc == 1) THEN ! USE STORED GREENS FUNCIONS...
          br0=0
          bz0=0
          kl=t_km
          IF (t_nsym <= 1) kl=t_km/2+1
          jkl=t_jm*kl
          l2=t_loop0(n)
          IF(t_iferro(n)==1) THEN
             loop=nn
             DO l=l1,l2
                nn=nn+1
                wk=t_gfbr(:,:,nn)
                t_br0p(nn)=SUM(RESHAPE(wk,(/jk0p/))*t_crj(:jk0p))
                wk=t_gfbz(:,:,nn)
                t_bz0p(nn)=SUM(RESHAPE(wk,(/jk0p/))*t_crj(:jk0p))
                t_br0p(nn)=-t_br0p(nn)*t_dr*t_dz/FOURPI*1.0e-04_rq
                t_bz0p(nn)=-t_bz0p(nn)*t_dr*t_dz/FOURPI*1.0e-04_rq
                br0=br0+t_br0p(nn)*t_ccf(l)
                bz0=bz0+t_bz0p(nn)*t_ccf(l)
             END DO
             br0=br0/t_cc(n)
             bz0=bz0/t_cc(n)
          ELSE
             nn=nn+1
             wk=t_gfbr(:,:,nn)
             t_br0p(nn)=SUM(RESHAPE(wk,(/jk0p/))*t_crj(:jk0p))*1.0e-04_rq
             wk=t_gfbz(:,:,nn)
             t_bz0p(nn)=SUM(RESHAPE(wk,(/jk0p/))*t_crj(:jk0p))*1.0e-04_rq
             t_br0p(nn)=-t_br0p(nn)*t_dr*t_dz/FOURPI
             t_bz0p(nn)=-t_bz0p(nn)*t_dr*t_dz/FOURPI
             br0=t_br0p(nn)
             bz0=t_bz0p(nn)
          END IF
       ELSE
          CALL g_fldp(100*t_rc(n),100*t_zc(n),br0,bz0,fl1)
          br0=1.0e-04_rq*br0
          bz0=1.0e-04_rq*bz0
       END IF
       l1=l2+1
       IF (t_ngp == 0) THEN
          rg0=t_rc(n) - 0.5_rq*t_drc(n)
          zg0=t_zc(n) - 0.5_rq*t_dzc(n)
          drg=t_drc(n)/t_nrc(n)
          dzg=t_dzc(n)/t_nzc(n)
          bbr=0
          bbz=0
          fr=0
          fz=0
          bmax=0
          DO k=0,t_nzc(n)
             DO j=0,t_nrc(n)
                rg=100*(rg0 + drg*j)
                zg=100*(zg0 + dzg*k)
                CALL g_flxfld(rg,zg,brr,bzz,fl)
                brr=1.0e-04_rq*brr + br0 !   MKS
                bzz=1.0e-04_rq*bzz + bz0
                b=brr**2 + bzz**2
                IF (b > bmax) bmax=b
                bbr=bbr + brr
                bbz=bbz + bzz
                fr=fr + 0.01_rq*rg*bzz
                fz=fz + 0.01_rq*rg*brr
             END DO
          END DO
          nr=t_nrc(n)+1
          nz=t_nzc(n)+1
          denom=nz*nr
       ELSE                   !   EFFI calculation
          IF (t_ngp == 1 .AND. t_iferro(n)==1) THEN
             loom=nbeg-1
             DO ir=1,t_nrc(n)
                DO iz=1,t_nzc(n)
                   loop=loop+1
                   loom=loom+1
                   t_brgp(loom)=t_br0p(loop)
                   t_bzgp(loom)=t_bz0p(loop)
                END DO
                loop=loop+1
                loom=loom+1
                t_brgp(loom)=t_br0p(loop)
                t_bzgp(loom)=t_bz0p(loop)
                DO iz=1,t_nzc(n)
                   loop=loop+1
                   loom=loom+1
                   t_brgp(loom)=.5_rq*(t_br0p(loop)+t_br0p(loop+1))
                   t_bzgp(loom)=.5_rq*(t_bz0p(loop)+t_bz0p(loop+1))
                   IF(ir/=t_nrc(n)) THEN
                      !  Re-store for right face
                      t_br0p(loop)=.5_rq*(t_br0p(loop)+t_br0p(loop+t_nzc(n)+2))
                      t_bz0p(loop)=.5_rq*(t_bz0p(loop)+t_bz0p(loop+t_nzc(n)+2))
                   END IF
                END DO
                loop=loop+1
                !  Store top field, overwrites bad value
                t_brgp(loom)=t_br0p(loop)
                t_bzgp(loom)=t_bz0p(loop)
                IF(ir/=t_nrc(n)) loop=loop-t_nzc(n)-1
             END DO
             DO iz=1,t_nzc(n)
                loop=loop+1
                loom=loom+1
                t_brgp(loom)=t_br0p(loop)
                t_bzgp(loom)=t_bz0p(loop)
             END DO
          END IF
          bbr=0
          bbz=0
          fr=0
          fz=0
          bmax=0
          DO nbc=nbeg,t_loopm(n)
             IF(t_iferro(n)==1) THEN
                brr=t_brgp(nbc)
                bzz=t_bzgp(nbc)
             ELSE
                bzz=bz0
                brr=br0
             END IF
             i1=1
             mm=0
             DO i=1,t_nc/(3-t_nsymc)
                IF(t_iferro(i)==1) THEN
                   DO ii=i1,t_loop0(i)
                      mm=mm+1
                      brr=brr + t_ccf(ii)*t_gsbr(mm,nbc)
                      bzz=bzz + t_ccf(ii)*t_gsbz(mm,nbc)
                   END DO
                ELSE
                   mm=mm+1
                   brr=brr + t_cc(i)*t_gsbr(mm,nbc)
                   bzz=bzz + t_cc(i)*t_gsbz(mm,nbc)
                END IF
                i1=t_loop0(i)+1
             END DO
             t_brgp(nbc)=brr
             t_bzgp(nbc)=bzz
             bbr=bbr + brr
             bbz=bbz + bzz
             bmod0=brr**2 + bzz**2
             fr=fr + t_rgp(nbc)*bzz
             fz=fz + t_rgp(nbc)*brr
             IF (bmod0 > bmax) bmax=bmod0
          END DO
          denom=(nbc-nbeg)
       END IF
       t_pffr(n)= TWOPI*fr*t_cc(n)/denom
       t_pffz(n)=-TWOPI*fz*t_cc(n)/denom
       t_pfbr(n)= bbr/denom
       t_pfbz(n)= bbz/denom
       t_pfbc(n)= SQRT(bmax)
       nbeg=nbc
    END DO
    !     
    !    HOOP STRESS, CRITICAL PACK CURRENT DENSITY AND MARGIN...
    !     
    DO n=1,ncu
       t_pfhs(n)=t_pffr(n)/(TWOPI*t_drc(n)*t_dzc(n))
       t_pfjc(n)= xpfjc( t_rc(n),t_drc(n),t_pfbz(n),t_pfbc(n),t_pftd,t_pfahs )
       t_pfjf(n)=abs( t_pfjp(n) )/t_pfjc(n)
    END DO
    !     
    ! COPY IF SYMMETRI!...
    !     
    IF (t_nsymc == 1) THEN
       t_pfbc(ncu+1:)= t_pfbc(:ncu)
       t_pfhs(ncu+1:)= t_pfhs(:ncu)
       t_pfms(ncu+1:)= t_pfms(:ncu)
       t_pfbz(ncu+1:)= t_pfbz(:ncu)
       t_pfbr(ncu+1:)=-t_pfbr(:ncu)
       t_pffz(ncu+1:)=-t_pffz(:ncu)
       t_pffr(ncu+1:)= t_pffr(:ncu)
       t_pfjc(ncu+1:)= t_pfjc(:ncu)
       t_pfjf(ncu+1:)= t_pfjf(:ncu)
    END IF
    !
    ! SAVE MAXIMUM VALUE OF ALLOWABLE FRACTION...
    !
    t_pfjx=xmaxaf( t_pfjf, 1, t_nfjx, 1, t_ifjx )
    t_pfbx=xmaxaf( t_pfbc, 1, t_nfjx, 1, t_ifbx )
    !
    ! NOTIFY USER IF LIMITING COIL CHANGES...
    !
    IF (t_ifjx /= ifjx0) THEN
       IF (ifjx0 == 0) THEN
          WRITE(STDOUT,101) t_pfid(t_ifjx)
          WRITE(t_logunit,101) t_pfid(t_ifjx)
       ELSE
          WRITE(STDOUT,102) t_pfid(t_ifjx), t_pfid(ifjx0)
          WRITE(t_logunit,102) t_pfid(t_ifjx), t_pfid(ifjx0)
       END IF
    END IF
    ifjx0=t_ifjx
    !
101 format('*** limiting coil is: ',a5,' ***')
102 format('*** limiting coil is: ',a5,' - was: ',a5,' ***')
  END SUBROUTINE pfcfld

  SUBROUTINE d_strkpl(pxp)
    !     
    !***********************************************************************
    !                                                                      *
    !     This routine finds "candidate" strike-points: there may be       *
    !     redundancies which can be distilled with dstrkpl                 *
    !                                                                      *
    !     nplates     : number of piece-wise straight segments modeling    *
    !                   the divertor plates                                *
    !                                                                      *
    !     rplate(i,1) : coordinates of the start of the ith segment        *
    !     zplate(i,1)                                                      *
    !                                                                      *
    !     rplate(i,2) : coordinates of the end of the ith segment          *
    !     zplate(i,2)                                                      *
    !                                                                      *
    !     nstkpts     : number of strike points found                      *
    !                                                                      *
    !     nsegs       : number of subdivisions each straight segment is    *
    !                   broken into for the search - once the subdivision  *
    !                   in which the strike point occurs is found, it is   *
    !                   subdivided again for more accuracy                 *
    !                                                                      *
    !     rstkpt(j)   : coordinates of the jth strike point.               *
    !     zstkpt(j)                                                        *
    !                                                                      *
    !                                                                      *
    !     The output consists of the point number, the plate (or segment)  *
    !     number, the coordinates of the strike point, the distance to the *
    !     x-point, the value of the flux and the difference between the    *
    !     x-point T_PSI and the strike-point T_PSI (measure of accuracy).  *
    !                                                                      *
    !***********************************************************************
    INTEGER :: i,j,l,ier,iter
    REAL(rq) :: rw1,zw1,rw2,zw2,drw,dzw,dw,ds,cost,sint,psip0,pxp,fpsi(8),&
         pp,dss,arg,test,d,rpl,zpl,psipl1
    t_nstkpts=0
    t_nspt=SIZE(t_rstkpt)
    IF( t_nplates<=0 .OR. pxp==0) RETURN
    l = 0
    DO i=1,t_nplates
       rw1  = t_rplate(i,1)
       zw1  = t_zplate(i,1)
       rw2  = t_rplate(i,2)
       zw2  = t_zplate(i,2)
       drw  = rw2 - rw1
       dzw  = zw2 - zw1
       dw   = sqrt( drw**2 + dzw**2 )
       ds   = dw/t_nsegs
       cost = drw/dw
       sint = dzw/dw

       ! SUBDIVIDE THE PLATE INTO NSEGS SEGMENTS, FIND T_PSI AT EACH
       ! END OF THE SUBDIVISION AND COMPARE TO pxp...
       psip0 = 0.0
       DO j=0,t_nsegs
          rpl = rw1 + ds*j*cost
          zpl = zw1 + ds*j*sint
          ier=0
          CALL boxd_interp( rpl, zpl, fpsi,ier,t_n4)
          IF( ier==0 .AND. psip0==0.0 ) THEN
             psip0 = fpsi(1)
          ELSEIF( ier==0 ) THEN
             psipl1 = fpsi(1)
             IF( (psipl1-pxp)*(pxp-psip0)>=0 ) THEN
                ! PXP IS BETWEEN THE TWO POINTS - REFINE SEARCH...
                pp=(psipl1-pxp)/(psipl1-psip0)
                dss=ds*j+pp*ds
                rpl=rw1+dss*cost
                zpl=zw1+dss*sint
                ier=0
                CALL boxd_interp( rpl, zpl, fpsi,ier,t_n4)
                DO iter=1,nter_interp
                   ier=0
                   arg=pxp-fpsi(1)
                   test=abs(arg/pxp)
                   IF(test<errt_rq) EXIT
                   dss=dss+arg/(cost*fpsi(2)+sint*fpsi(3))
                   rpl=rw1+dss*cost
                   zpl=zw1+dss*sint
                   CALL boxd_interp( rpl,zpl,fpsi,ier,t_n4)
                END DO
                IF (l < t_nspt) l=l+1
                t_rstkpt(l)=rpl
                t_zstkpt(l)=zpl
                t_bstkpt(l)=sqrt(fpsi(2)**2+fpsi(3)**2)/rpl
                IF(t_nsym<=1 .AND. t_zstkpt(l)<0) THEN
                   d = sqrt((t_rxpt-t_rstkpt(l))**2+(-t_zxpt-t_zstkpt(l))**2)
                ELSE
                   d = sqrt((t_rxpt-t_rstkpt(l))**2+(t_zxpt-t_zstkpt(l))**2)
                END IF
                t_dstkpt(l) = d
                t_lstkpt(l) = i
             END IF
             psip0 = psipl1
          END IF
       END DO ! j=0,t_nsegs
    END DO ! i=1,t_nplates
    t_nstkpts = l

  END SUBROUTINE d_strkpl

  SUBROUTINE dstrkpl
    !***********************************************************************
    !                                                                      *
    !     This routine distills the candidate strike-points from strkpl by *
    !     removing redundancies.  The distilled strike-point coordinates,  *
    !     the (X-point to S-point) distances and the poloidial field at    *
    !     the strike-points are returned in arrays rspt, zspt, dspt and    *
    !     bspt, and the number of entries in integer nspt.                 *
    !                                                                      *
    !     IF the configuration is limited, nspt=0, IF it is a single-null, *
    !     THEN nspt will be 2 or less, and IF double-null THEN nspt is 4   *
    !     or less.  The entries in the above arrays will be ordered from   *
    !     top to bottom and from inboard to outboard.                      *
    !                                                                      *
    !***********************************************************************
    REAL(rq), DIMENSION(SIZE(t_rstkpt)) :: rxstkpt,zxstkpt,astkpt,rtemp,ztemp,&
         dtest,btemp,dtemp
    REAL(rq) :: dmin,dmax,test,d
    INTEGER :: ia(SIZE(t_rstkpt)),i,j,m,iamax,jmin,n_max,imin,imax,ier

    IF (s_limiterd == 1) THEN
       t_nspt = 0
    ELSEIF (t_nstkpts > 0) THEN
       ! Get relevant x-point for each strike-point...
       IF (ABS((s_pxpu - s_pxpl) / t_dpsi0) < t_dn_criterion) THEN ! DN
          DO i = 1,t_nstkpts
             IF (t_zstkpt(i) > 0) THEN
                rxstkpt(i) = s_rxpu
                zxstkpt(i) = s_zxpu
             ELSE
                rxstkpt(i) = s_rxpl
                zxstkpt(i) = s_zxpl
             END IF
          END DO
       ELSE ! SN
          DO i = 1,t_nstkpts
             rxstkpt(i) = t_rxpt
             zxstkpt(i) = t_zxpt
          END DO
       END IF
       ! Strike-point angles relative to associated x-point...
       DO i = 1,t_nstkpts
          astkpt(i) = atan2(t_zstkpt(i)-zxstkpt(i),t_rstkpt(i)-rxstkpt(i))
          IF (astkpt(i) < 0) THEN
             astkpt(i) = astkpt(i) + TWOPI
          END IF
       END DO
       ! Group strike-points with similar angles...
       ia(1) = 1
       iamax = 1
       DO i = 2,t_nstkpts
          dmin = 1/errb_rq
          DO j = 1,i
             IF (j /= i) THEN
                d = ABS(astkpt(i) - astkpt(j))
                IF (d < dmin) THEN
                   dmin = d
                   jmin = j
                END IF
             END IF
          END DO
          IF (dmin > t_spt_angle) THEN
             iamax = iamax + 1
             ia(i) = iamax
          ELSE
             IF (t_zstkpt(i) / t_zstkpt(jmin) > 0) THEN
                ia(i) = ia(jmin)
             ELSE
                iamax = iamax + 1
                ia(i) = iamax
             END IF
          END IF
       END DO
       ! Select closest point in each group
       m = iamax
       IF (m > t_nstkpts) m = t_nstkpts
       DO j = 1,m
          dmin = 1/errb_rq
          DO i = 1,t_nstkpts
             IF (ia(i) == j) THEN
                IF (t_dstkpt(i) < dmin) THEN
                   dmin = t_dstkpt(i)
                   rtemp(j) = t_rstkpt(i)
                   ztemp(j) = t_zstkpt(i)
                   dtemp(j) = t_dstkpt(i)
                   btemp(j) = t_bstkpt(i)
                END IF
             END IF
          END DO
       END DO
       ! Restrict to 2 or 4 at most
       IF (ABS((s_pxpu - s_pxpl) / t_dpsi0) < t_dn_criterion) THEN
          n_max = 4
       ELSE
          n_max = 2
       END IF
       DO i = 1,m
          dtest(i) = dtemp(i)
       END DO
       DO i = 1,n_max - 1
          CALL xminmax(dtest,1,m,1,dmin,dmax,imin,imax)
          dtest(imin) = 1./errb_rq
       END DO
       CALL xminmax(dtest,1,m,1,dmin,dmax,imin,imax)
       j = 0
       DO i = 1,m
          IF (dtemp(i) <= dmin) THEN
             j = j + 1
             t_nspt = j
             t_rspt(j) = rtemp(i)
             t_zspt(j) = ztemp(i)
             t_dspt(j) = dtemp(i)
             t_bspt(j) = btemp(i)
          END IF
       END DO

       ! Put in standard order {TOP{IN,OUT},BOT{IN,OUT}}
       DO i = 1,t_nspt
          rtemp(i) = t_rspt(i)
          ztemp(i) = t_zspt(i)
          dtemp(i) = t_dspt(i)
          btemp(i) = t_bspt(i)
       END DO
       IF (t_nspt == 4) THEN
          IF (t_zspt(1) < 0 .AND. t_zspt(2) > 0) THEN
             IF (t_zspt(3) > 0) THEN
                t_rspt(1) = rtemp(3); t_rspt(3) = rtemp(1)
                t_zspt(1) = ztemp(3); t_zspt(3) = ztemp(1)
                t_dspt(1) = dtemp(3); t_dspt(3) = dtemp(1)
                t_bspt(1) = btemp(3); t_bspt(3) = btemp(1)
             ELSE
                t_rspt(1) = rtemp(4); t_rspt(4) = rtemp(1)
                t_zspt(1) = ztemp(4); t_zspt(4) = ztemp(1)
                t_dspt(1) = dtemp(4); t_dspt(4) = dtemp(1)
                t_bspt(1) = btemp(4); t_bspt(4) = btemp(1)
             END IF
          ELSEIF (t_zspt(1) > 0 .AND. t_zspt(2) < 0) THEN
             IF (t_zspt(3) > 0) THEN
                t_rspt(2) = rtemp(3); t_rspt(3) = rtemp(2)
                t_zspt(2) = ztemp(3); t_zspt(3) = ztemp(2)
                t_dspt(2) = dtemp(3); t_dspt(3) = dtemp(2)
                t_bspt(2) = btemp(3); t_bspt(3) = btemp(2)
             ELSE
                t_rspt(2) = rtemp(4); t_rspt(4) = rtemp(2)
                t_zspt(2) = ztemp(4); t_zspt(4) = ztemp(2)
                t_dspt(2) = dtemp(4); t_dspt(4) = dtemp(2)
                t_bspt(2) = btemp(4); t_bspt(4) = btemp(2)
             END IF
          ELSEIF (t_zspt(1) < 0 .AND. t_zspt(2) < 0) THEN
             t_rspt(1:2) = rtemp(3:4); t_rspt(3:4) = rtemp(1:2)
             t_zspt(1:2) = ztemp(3:4); t_zspt(3:4) = ztemp(1:2)
             t_dspt(1:2) = dtemp(3:4); t_dspt(3:4) = dtemp(1:2)
             t_bspt(1:2) = btemp(3:4); t_bspt(3:4) = btemp(1:2)
          END IF
       END IF
       IF (t_nspt == 2 .OR. t_nspt == 4) THEN
          IF (t_rspt(1) > t_rspt(2)) THEN
             rtemp(1) = t_rspt(1); t_rspt(1) = t_rspt(2); t_rspt(2) = rtemp(1)
             ztemp(1) = t_zspt(1); t_zspt(1) = t_zspt(2); t_zspt(2) = ztemp(1)
             dtemp(1) = t_dspt(1); t_dspt(1) = t_dspt(2); t_dspt(2) = dtemp(1)
             btemp(1) = t_bspt(1); t_bspt(1) = t_bspt(2); t_bspt(2) = btemp(1)
          END IF
       END IF
       IF (t_nspt == 4) THEN
          IF (t_rspt(3) > t_rspt(4)) THEN
             rtemp(3) = t_rspt(3); t_rspt(3) = t_rspt(4); t_rspt(4) = rtemp(3)
             ztemp(3) = t_zspt(3); t_zspt(3) = t_zspt(4); t_zspt(4) = ztemp(3)
             dtemp(3) = t_dspt(3); t_dspt(3) = t_dspt(4); t_dspt(4) = dtemp(3)
             btemp(3) = t_bspt(3); t_bspt(3) = t_bspt(4); t_bspt(4) = btemp(3)
          END IF
       END IF

    END IF

  END SUBROUTINE dstrkpl
  SUBROUTINE vltsec(vlt,iv)
    INTEGER, INTENT(IN) :: iv
    REAL(rq), INTENT(OUT) :: vlt
    INTEGER :: klm,jkl,j,k,l,jl,ju,n,ncl,l1,l2,kl,nn,i,ier,n1
    REAL(rq) :: zum(3),summ,sump,sumd,wk(t_jm0p,t_km0p)

    !    
    !     iv=2 average flux; iv=1 volt-second ; iv=3 flux at coils
    !
    n1=0
    IF(ALLOCATED(pdloop))THEN
       n1=SIZE(pdloop,1)
    END IF
    IF(n1/=t_nloop0p) THEN
       IF(ALLOCATED(pdloop)) DEALLOCATE(pdloop)
       ALLOCATE(pdloop(t_nloop,8))
    END IF
    jkl=t_jm0p*t_km0p
    ncl=t_nc	
    IF(t_nsym<=1) ncl=t_nc/2
    vlt=0.0
    summ=0
    sumd=-t_plc*FOURPI/(t_dr*t_dz)
    IF(iv==2 .OR. iv==0) THEN  !  average flux "t_psires"
       DO k=1,t_km0p
          sump=0
          IF(s_jbl(k)/=t_jm+1 .OR. s_jbu(k)/=0) THEN
             n=t_jm*(k-1)+s_jbl(k)
             sump=sump+.5*t_crj(n)/t_rm(n)*(1.-(t_psil-t_psi(n))/&
                  (t_psi(n)-t_psi(n-1)))*t_psi(n)
             n=t_jm*(k-1)+s_jbu(k)
             sump=sump+.5*t_crj(n)/t_rm(n)*(1.+(t_psil-t_psi(n))/&
                  (t_psi(n+1)-t_psi(n)))*t_psi(n)
          END IF
          nn=t_jm*(k-1)
          DO n=nn+s_jbl(k)+1,nn+s_jbu(k)-1
             sump=sump+t_psi(n)*t_crj(n)/t_rm(n)
          END DO
          summ=summ+sump
       END DO
       IF(t_nsym<=1) THEN
          summ=2*summ-sump  !   made use of symmetry
          summ=summ/sumd
       ELSE
          summ=summ/sumd
       END IF
       t_psires=summ*MU0/20
    END IF
    sumd=200*sumd/MU0
    IF(iv/=2) THEN  !  flux at coils and voltsecs
       IF(t_kgreenc==1) THEN
          nn=0
          l1=1
          DO i=1,ncl
             summ=0
             l2=t_loop0(i)
             IF(t_iferro(i)==1) THEN
                DO l=l1,l2
                   nn=nn+1
                   wk=t_gc(:,:,nn)
                   IF(t_nsym<=1) wk(:,t_km0p)=0.5_rq*wk(:,t_km0p)
                   summ=summ+SUM(RESHAPE(wk,(/jkl/))*t_crj(:jkl)/&
                        t_rm(:jkl))*t_ccf(l)
                END DO
                summ=summ/t_cc(i)
             ELSE
                nn=nn+1
                wk=t_gc(:,:,nn)
                IF(t_nsym<=1) wk(:,t_km0p)=0.5_rq*wk(:,t_km0p)
                summ=SUM(RESHAPE(wk,(/jkl/))*t_crj(:jkl)/t_rm(:jkl))
             END IF
             l1=l2+1
             t_pfpsi(i)=-5.0e-9_rq*t_dr*t_dz*summ
          END DO
          IF(t_nloop0p/=0 .AND. t_int_flag>=0) THEN
             DO l=1,t_nloop0p
                t_floop(l,1)=SUM(t_gpl(:t_jm0p*t_km0p,l,1)*t_crj(:t_jm0p*&
                     t_km0p))
                t_floop(l,2)=SUM(t_gpl(:t_jm0p*t_km0p,l,2)*t_crj(:t_jm0p*&
                     t_km0p))
                t_floop(l,3)=SUM(t_gpl(:t_jm0p*t_km0p,l,3)*t_crj(:t_jm0p*&
                     t_km0p))
             END DO
          END IF
       ELSE
          DO i=1,ncl
             t_pfpsi(i)=g_flxp(100*t_rc(i),100*t_zc(i))*MU0/20
          END DO
          IF(t_nloop0p/=0 .AND. t_int_flag>=0) THEN
             DO l=1,t_nloop0p
                CALL g_fldp(t_rloop(l),t_zloop(l),t_floop(l,2),t_floop(l,3),&
                     t_floop(l,1))
                t_floop(l,1)=t_floop(l,1)*MU0/20
                t_floop(l,2)=t_floop(l,2)*1.e-4_rq
                t_floop(l,3)=t_floop(l,3)*1.e-4_rq
             END DO
          END IF
       END IF
       DO i=1,ncl
          t_cmplas(i)=0.1_rq*t_pfpsi(i)/t_plc
       END DO
       IF(iv==0 .OR. iv==3) THEN
          DO i=1,ncl
             t_pfpsi(i)=t_pfpsi(i)+SUM(t_pfim(i,:)*t_cc)
          END DO
          IF(t_nloop0p/=0 .AND. t_int_flag>=0) THEN
             DO l=1,t_nloop0p
                t_floop(l,1)=t_floop(l,1)+SUM(t_plim(:,l,1)*t_cc)
                t_floop(l,2)=t_floop(l,2)+SUM(t_plim(:,l,2)*t_cc)
                t_floop(l,3)=t_floop(l,3)+SUM(t_plim(:,l,3)*t_cc)
             END DO
          ELSEIF(t_nloop0p/=0) THEN
             ier=6
             CALL boxm_interp(t_rloop,t_zloop,pdloop,t_r,t_z,i_cps,0,ier,t_n4)
             DO l=1,t_nloop0p
                t_floop(l,1)=pdloop(l,1)*MU0/20
                t_floop(l,2)=-pdloop(l,3)/t_rloop(l)*1.0e-4_rq
                t_floop(l,3)= pdloop(l,2)/t_rloop(l)*1.0e-4_rq
             END DO
          END IF
       END IF
       IF(ncl/=t_nc) THEN
          t_pfpsi(ncl+1:)=t_pfpsi(:ncl)
          t_cmplas(ncl+1:)=t_cmplas(:ncl)
       END IF
       t_vlts2D=t_cmplas*t_cc*1.0e6_rq
       vlt=SUM(t_vlts2D)
    END IF
  END SUBROUTINE vltsec

  FUNCTION xpfjc( rr, drr, bza, bmax, tdump, stress ) RESULT(xpf)
    !
    !***********************************************************************
    !                                                                      *
    !     XPFJC computes the allowable pack current density of a solenoid  *
    !     coil using the algorithm from J. Miller (SCMDG 88-5.1-90R).      *
    !     Based on helium-cooled (4.5-K) NbSn cable-in-conduit conductor.  *
    !                                                                      *
    !     RR      :  mean radius of coil [m]                                *
    !     DRR     :  radial build [m]                                       *
    !     BZA    :  average axial field in coil pack [T]                   *
    !     BMAX   :  maximum transverse field in coil pack [T]              *
    !     TDUMP  :  dump time constant [s]                                 *
    !     STRESS :  allowable hoop stress in steel [MPa]                   *
    !     XPFJC  := allowable current density [MA/sqm]                     *
    !     F(1)   := fraction NbSn superconductor                           *
    !     F(2)   := fraction stabiilzing copper                            *
    !     F(3)   := fraction helium passage                                *
    !     F(4)   := fraction of steel conduit                              *
    !     F(5)   := fraction of insulation                                 *
    !                                                                      *
    !***********************************************************************
    REAL(rq), INTENT(IN) :: rr,drr,bza,bmax,tdump,stress
    REAL(rq), PARAMETER ::&
         bcrit=23.0_rq,&       ! critical field for NbSn [T]
         utotal=7.0e+04_rq,&   ! Cu,SC sp. ht. integral [s*MA**2/m**4]
         fsc= 0.6_rq,&         ! S.C. Jcrit utilization factor
         fcu= 0.6_rq,&         ! fraction Cu/conductor
         fhe= 0.375_rq,&       ! fraction He
         fi = 0.1_rq           ! insultion factor
         
    REAL(rq) ::  a(5),xpf,falpha,atot
    INTEGER :: i
    !
    ! COMPUTE AREAS BASED ON 1-MA CURRENT...
    !
    IF( bmax<bcrit ) THEN
       a(1)   = sqrt( bmax )/( fsc*( 109*( 1 - bmax/bcrit ) )**2 )
       a(2)   = sqrt( 0.5_rq*tdump/utotal )*fcu**1.5
       a(3)   = fhe*( a(1) + a(2) )/( 1 - fhe )
       t_alpha  = ( rr + 0.5_rq*drr )/( rr - 0.5_rq*drr )
       falpha = 0.100_rq + 0.925_rq*t_alpha - 0.053_rq*t_alpha**2
       a(4)   = falpha*abs( bza )*rr/stress
       a(5)   = fi*( a(1) + a(2) + a(3) + a(4) )
       atot   = 0.0
       DO i=1,5
          atot = atot + a(i)
       END DO
       xpf = 1.0_rq/atot
    ELSE
       xpf = 1.0e-15_rq
    END IF
  END FUNCTION xpfjc
  FUNCTION xpfms( rrc, drrc, xj, bi, bo ) RESULT(xpf)
    !
    !  xpfms returns the maximum hoop stress in a solenoid, as a function of
    !  the coil mean radius (rrc), radial build (drrc), average current density
    !  (xj), axial field on the inner edge (bi) and axial field on the outer
    !  edge (bo)
    !
    !  Ref:"Superconducting Magnets", M.N.Wilson, 1983 Clarendon Press pp 40-47
    REAL(rq), INTENT(IN) :: rrc,drrc,xj,bi,bo
    REAL(rq), PARAMETER :: pois=0.333_rq  ! Poisson's ratio
    REAL(rq)a,b,xa,xk,xm,ck,cvk,fk,cm,cmv,fm,xpf,cvm

    a     = rrc - 0.5_rq*drrc
    b     = rrc + 0.5_rq*drrc
    xa    = b/a
    xk    = a*xj*( xa*bi - bo )/( xa - 1 )
    xm    = a*xj*( bi - bo )/( xa - 1 )
    ck    = 2*xa**2 + xa + 1
    cvk   = ( 1 + 2*pois )*( xa + 1 )/( 2 + pois )
    fk    = xk*( 2 + pois )/( 3*( xa + 1 ) )
    cm    = 2*xa**2 + 1
    cvm   = ( 1 + 3*pois )/( 3 + pois )
    fm    = xm*( 3 + pois )/8
    xpf   = fk*( ck - cvk ) - fm*( cm - cvm )
  END FUNCTION xpfms

  SUBROUTINE trap_pass(dparb2rf)
    REAL(rq), INTENT(OUT) :: dparb2rf(t_msrf)
    REAL(rq) :: zbsq,dparb2,sun,tum,tum1,tuml,tum2,rum3,grat,xlam,ylam,zjam,&
         eps,djard,dydx,rat,bmax,bbar,gjard,zum,zlam,zuml,zumu,tum3
    INTEGER :: ier,l,isw,jjj,nxl,mpp,lsm,niter,lxl,llam,ls,m
    REAL(rq), DIMENSION(:), POINTER :: mu
    !
    !--- Calculates trapped to passing (effective) on a surface
    !
    IF(SIZE(cq0)/=t_mls) THEN
       IF(ALLOCATED(cq0)) DEALLOCATE(cq0,cq1,cq2,cq3,cq4,cq5,cq6,cq7,cq8,cq9,&
            dq0,dq3,dq4,dq5,dq6,dq7,dq8,dq9,dq10)
       ALLOCATE(cq0(t_mls),cq1(t_mls),cq2(t_mls),cq3(t_mls),cq4(t_mls),cq5(t_mls),&
       cq6(t_mls),cq7(t_mls),cq8(t_mls),cq9(t_mls),dq0(t_mls),dq3(t_mls),dq4(t_mls),&
            dq5(t_mls),dq6(t_mls),dq7(t_mls),dq8(t_mls),dq9(t_mls),dq10(t_mls))
    END IF
    IF(SIZE(dq1)/=t_mls) THEN
       IF(ALLOCATED(dq1))DEALLOCATE(dq1,dq2)
       ALLOCATE(dq1(t_mls),dq2(t_mls))
    END IF

    mu=>cq9
    mlm=t_mls/2
    s_pin=SIGN(1.0_rq,t_dpsi0)
    DO l=t_msrf,2,-1
       cq1=t_rlsd(:,l,1)
       dq1=t_zlsd(:,l,1)
       dq0=s_pin*t_zlsd(:,l,4)
       cq6=t_rlsd(:,l,2)/dq0
       dq4=t_zlsd(:,l,2)/dq0
       cq5=sqrt(cq6**2+dq4**2)
       dq5=t_frsrf(l)/cq1
       dq6=sqrt(cq5**2+dq5**2)
       dq2=-TWOPI/(t_lmax-1)/s_pin*dq0
       ier=6
       IF(t_inv_eq/=0) THEN
          ier=0
          cq2=t_rhosq(l,:,1)
          CALL boxi_interp(cq2,t_tswpts,t_pdls,t_dpsi0,t_psix,t_wvert,ier,t_n6)
       ELSE
          isw=0;ier=6;
          CALL boxm_interp(cq1,dq1,t_pdls,t_r,t_z,i_cps,isw,ier,t_n4)
       END IF
       zbsq=t_bsqrf(l)        
       cq0(:t_lmax)=dq2(:t_lmax)/(cq1(:t_lmax)*dq6(:t_lmax)**2)**2*&
            ((dq4(:t_lmax)**2-cq6(:t_lmax)**2)*t_pdls(:t_lmax,5)-cq6(:t_lmax)*&
            (dq4(:t_lmax)*(t_pdls(:t_lmax,6)-t_pdls(:t_lmax,4))+&
            dq6(:t_lmax)**2))**2
       IF(t_nsym==1) THEN
          DO ls=1,mlm-1
             cq0(ls+mlm)=cq0(mlm-ls)
          END DO
       END IF
       DO ls=1,t_mls-1
          cq2(ls)=dq2(ls+1)+dq2(ls)
       END DO
       mu(1)=0
       rat=0.5_rq
       IF(t_lmax/=t_mls) rat=0.25_rq
       DO ls=1,t_mls-1
          mu(ls+1)=mu(ls)+rat*cq2(ls)
       END DO
       dparb2=SUM(cq0(:t_mls-1))
       dparb2rf(l)=dparb2/SUM(dq2(:t_mls-1))/t_bsqrf(l)
       bmax=xmaxaf(dq6,1,t_mls,1,jjj)

       sun=t_vpsrf(l)/TWOPI
       tum=zbsq
       bbar=sqrt(tum)
       gjard=0
       dq2=sqrt(abs(1-dq6/bmax))*(1+0.5*dq6/bmax)/dq6**2
       DO ls=2,t_mls
          gjard=gjard+(mu(ls)-mu(ls-1))*(dq2(ls)+dq2(ls-1))*0.5
       END DO
       gjard=gjard*tum/mu(t_mls)
       zbsq=gjard/(1-gjard)
       dq0=dq6
       dq1(2:t_mls)=0.5_rq*(mu(2:t_mls)-mu(:t_mls-1))

       DO ls=1,jjj-1           !   re-order ls=1 now refers to peak of mod-B
          cq0(ls)=dq1(jjj+1-ls) !   dl/B reordered
          dq4(ls)=dq0(jjj+1-ls) !   B re-orderred
       END DO
       m=t_mls+jjj
       DO ls=jjj,t_mls
          cq0(ls)=dq1(m-ls)
          dq4(ls)=dq0(m-ls)
       END DO

       DO ls=2,t_mls
          dq2(ls)=dq2(ls-1)+cq0(ls) !   integral dl/B
       END DO
       zum=0
       nxl=2*nter_interp
       eps=sqrt(1.-bbar/bmax)
       lxl=1+1./eps
       IF(lxl>nxl)nxl=lxl

       DO llam=1,nxl-1
          xlam=(llam-0.5_rq)/(nxl-1.)
          ylam=xlam*eps/(1.+eps-xlam) !   stretched coordinate
          dydx=eps*(1+eps)/(1+eps-xlam)**2 !   Jacobian
          zlam=(1-ylam**2)/bmax !   pitch angle relation to stretched 
          !        Now calculate <sqrt(1-lambda*B)>
          tum1=0
          DO ls=1,t_mls-1
             dq0(ls)=sqrt(1-zlam*dq4(ls))
          END DO
          DO ls=t_mls-2,1,-1
             tuml=.5_rq*cq0(ls)*(dq0(ls)+dq0(ls+1))
             tum1=tum1+tuml 
          END DO
          tum1=sun/tum1
          tum2=0
          DO ls=1,t_mls-1         !   now integrate lambda=mu/E
             zuml=(dq4(ls)-bmax)/(sqrt(1-zlam*dq4(ls))+ylam)
             zumu=(dq4(ls+1)-bmax)/(sqrt(1-zlam*dq4(ls+1))+ylam)
             tum2=tum2+0.5*zlam*(zumu+zuml)*cq0(ls)
          END DO
          tum3=dydx*zlam*bmax*tum1*tum2/sun
          zum=zum+tum3
       END DO
       zum=zum*1.5_rq/(nxl-1.)
       grat=(1+zum)*tum/bmax**2 !   fraction of circulating
       t_fttcsrf(l)=(1-grat)/grat
    END DO
  END SUBROUTINE trap_pass

  SUBROUTINE diaginv
    REAL(rq) :: hb,hc,hd,hh,hm,s_pin,dd,bbb,hinas,psires_
    INTEGER :: is(t_msrf),l,lvz,mq,n1
    
    s_pin=SIGN(1.0_rq,t_dpsi0)
    mlm=t_mls/2+1
    n1=0
    IF(ALLOCATED(c1)) THEN
       n1=SIZE(c1)
    END IF
    IF(n1/=t_msrf) THEN
       IF(ALLOCATED(c1)) DEALLOCATE(c0,c1,c2,c3)
       ALLOCATE(c0(t_msrf),c1(t_msrf),c2(t_msrf),c3(t_msrf))
    END IF
    n1=0
    IF(ALLOCATED(dq1))THEN
       n1=SIZE(dq1)
    END IF
    IF(n1/=t_mls) THEN
       IF(ALLOCATED(dq1))DEALLOCATE(dq1,dq2)
       ALLOCATE(dq1(t_mls),dq2(t_mls))
    END IF

    DO l=1,t_msrf
       t_asrf(l)=0.5_rq*(t_rlsd(1,l,1)-t_rlsd(mlm,l,1))
       t_rsrf(l)=0.5_rq*(t_rlsd(1,l,1)+t_rlsd(mlm,l,1))
    END DO
    DO l=2,t_msrf
       dq1=t_zlsd(:,l,1)
       t_esrf(l)=xmaxaf(dq1,1,t_mls,1,is(l))
    END DO
    DO l=2,t_msrf
       lvz=is(l)
       c0(l)=(t_zlsd(lvz+1,l,1)-t_zlsd(lvz-1,l,1))/t_tswpts(3)
       c1(l)=(t_zlsd(lvz+1,l,1)+t_zlsd(lvz-1,l,1)-2*t_zlsd(lvz,l,1))/&
            t_tswpts(2)**2
       c2(l)=-c0(l)/(errt_rq+c1(l))
       t_esrf(l)=(t_zlsd(lvz,l,1)+c0(l)*c2(l)+0.5_rq*c1(l)*c2(l)**2)
    END DO
    DO l=2,t_msrf
       lvz=is(l)
       c0(l)=(t_rlsd(lvz+1,l,1)-t_rlsd(lvz-1,l,1))/t_tswpts(3)
       c1(l)=(t_rlsd(lvz+1,l,1)+t_rlsd(lvz-1,l,1)-2*t_rlsd(lvz,l,1))/&
            t_tswpts(2)**2
       t_tusrf(l)=(t_rlsd(lvz,l,1)+c0(l)*c2(l)+0.5_rq*c1(l)*c2(l)**2)
    END DO
    DO l=2,t_msrf
       dq1=t_zlsd(:,l,1)
       t_tsrf(l)=xminaf(dq1,1,t_mls,1,is(l))
    END DO
    DO l=2,t_msrf
       lvz=is(l)
       c0(l)=(t_zlsd(lvz+1,l,1)-t_zlsd(lvz-1,l,1))/t_tswpts(3)
       c1(l)=(t_zlsd(lvz+1,l,1)+t_zlsd(lvz-1,l,1)-2*t_zlsd(lvz,l,1))/&
            t_tswpts(2)**2
       c2(l)=-c0(l)/(errt_rq+c1(l))
       t_tsrf(l)=(t_zlsd(lvz,l,1)+c0(l)*c2(l)+0.5_rq*c1(l)*c2(l)**2)
    END DO
    DO l=2,t_msrf
       lvz=is(l)
       c0(l)=(t_rlsd(lvz+1,l,1)-t_rlsd(lvz-1,l,1))/t_tswpts(3)
       c1(l)=(t_rlsd(lvz+1,l,1)+t_rlsd(lvz-1,l,1)-2*t_rlsd(lvz,l,1))/&
            t_tswpts(2)**2
       t_tlsrf(l)=(t_rlsd(lvz,l,1)+c0(l)*c2(l)+0.5_rq*c1(l)*c2(l)**2)
    END DO
    t_rbin=t_rsrf(t_msrf)-t_asrf(t_msrf)
    t_rbout=t_rsrf(t_msrf)+t_asrf(t_msrf)
    IF(t_pxpt==s_pxpl) THEN
       t_rxpf=t_tusrf(t_msrf)
       t_zxpf=t_esrf(t_msrf)
    ELSEIF(t_pxpt==s_pxpu) THEN
       t_rxpf=t_tlsrf(t_msrf)
       t_zxpf=t_tsrf(t_msrf)
    END IF
    DO l=2,t_msrf
       t_esrf(l)=0.5_rq*(t_esrf(l)-t_tsrf(l))/t_asrf(l)
       t_tusrf(l)=(t_rsrf(l)-t_tusrf(l))/t_asrf(l)
       t_tlsrf(l)=(t_rsrf(l)-t_tlsrf(l))/t_asrf(l)
    END DO
    DO l=1,t_msrf
       t_tsrf(l)=0.5_rq*(t_tusrf(l)+t_tlsrf(l))
       t_psrf(l)=t_psibar(l)*t_dpsi0+t_psix   
    END DO
    t_tlsrf(1)=extrp(t_tlsrf,t_asrf,t_msrf,0,0)
    t_tusrf(1)=extrp(t_tusrf,t_asrf,t_msrf,0,0)
    t_qsrf(1)=extrp(t_qsrf,t_asrf,t_msrf,0,0)
    t_vpsrf(1)=extrp(t_vpsrf,t_asrf,t_msrf,0,0)
    t_esrf(1)=extrp(t_esrf,t_asrf,t_msrf,0,0)
    t_tsrf(1)=0.5_rq*(t_tlsrf(1)+t_tusrf(1))
    DO l=1,t_msrf
       c0(l)=t_tsrf(l)*t_asrf(l)
    END DO
    !     Force t_tsrf->0 smoothly on axis (triangularity) and evaluate trider
!    CALL polyfit_interp(c0,t_msrf,0,c2,3)
    CALL polyfit_interp(c0,c3,t_psibar,t_dpoly,t_spoly,t_mpoly,3)
    DO l=2,t_msrf
       t_tsrf(l)=c0(l)/t_asrf(l)
       c1(l)=t_tsrf(l)*t_rsrf(l)/t_asrf(l)
    END DO
    t_trider=extrp(c1,t_psibar,t_msrf,0,0)
    t_tsrf(1)=0
    t_rsqirf(1)=1./t_raxis**2
    IF(t_wvert/=1) t_wvert=t_esrf(1)
    mq=1
    t_qmin=xminaf(t_qsrf,1,t_msrf,1,mq)
    t_rhomin=0
    IF(mq==1) THEN
       t_qmin=xmaxaf(t_qsrf,1,t_msrf,1,mq)
       DO l=mq-1,1,-1
          IF(t_qsrf(l)<t_qmin) THEN
             t_qmin=t_qsrf(l)
          ELSE
             EXIT
          END IF
       END DO

       mq=l+1
    END IF
    IF(t_ifluxcord==-1) THEN
       CALL fdInt(1.+rq/t_qsrf,t_phibar,t_msrf,c0)
       t_psibar=c0/c0(t_msrf)
    ELSE
       CALL fdInt(t_qsrf,t_psibar,t_msrf,t_qh)
       t_phibar=t_qh/t_qh(t_msrf)
    END IF
    t_dphi0=t_dpsi0*t_qh(t_msrf)
    IF(mq>1 .AND. mq<t_msrf) THEN
       dd=-0.5_rq*(t_qsrf(mq+1)-t_qsrf(mq-1))/(t_qsrf(mq+1)+t_qsrf(mq-1)-2*&
            t_qsrf(mq))
       t_qmin=t_qmin+0.5_rq*(t_qsrf(mq+1)-t_qsrf(mq-1))*dd
       t_rhomin=t_phibar(mq)+0.5_rq*dd*(t_phibar(mq+1)-t_phibar(mq-1))+0.5_rq*&
            dd**2*&
            (t_phibar(mq+1)+t_phibar(mq-1)-2*t_phibar(mq))
       t_rhomin=SQRT(ABS(t_rhomin))
    END IF
    CALL fdInt(t_cusrf,t_psrf,t_msrf,c1)
    t_bpsqva=c1(t_msrf)
    c2=t_prsrf*t_vpsrf*s_pin
    CALL fdInt(c2,t_psrf,t_msrf,c1)
    t_presva=c1(t_msrf)
    c2=t_prsrf**2*t_vpsrf*s_pin
    CALL fdInt(c2,t_psrf,t_msrf,c1)
    t_betal=c1(t_msrf)
    c2=t_risrf*t_vpsrf*s_pin/TWOPI
    CALL fdInt(c2,t_psrf,t_msrf,t_susrf)
    t_surf=t_susrf(t_msrf)
    CALL fdInt(t_cusrf,t_psrf,t_msrf,c1)
    t_bpsqva=c1(t_msrf)
    c2=t_vpsrf*s_pin
    CALL fdINT(c2,t_psrf,t_msrf,t_volsrf)
    t_volume=t_volsrf(t_msrf)
    c2=t_qsrf*t_psrf
    CALL fdInt(c2,t_psrf,t_msrf,c1)
    t_helicity=c1(t_msrf)
    CALL get95
    t_helicity=TWOPI**2*2.0e-16_rq*(t_qh(t_msrf)*t_dpsi0*t_psrf(t_msrf)-t_helicity)
    !Wb**2
    t_bpolsa=t_cusrf(t_msrf)/t_alsrf(t_msrf)
    bbb=(t_frsrf(t_msrf)/s_rcntr)**2
    IF(t_ipj==0 .AND. t_ipf<=0) bbb=t_bpolsa**2+bbb
    t_placur=t_plc*10
    t_placur=-10*s_pin*t_cusrf(t_msrf)/FOURPI
    t_presva=t_presva/t_volume
    psires_=(t_psil-t_bpsqva/t_cusrf(t_msrf))*MU0/20
    t_bpsqva=s_pin*TWOPI*t_bpsqva/t_volume
    t_betal=SQRT(t_betal/t_volume)
    t_al=t_alsrf(t_msrf)
    t_psipls=t_surf/t_al
    t_betae=8*PI*t_presva/bbb
    t_betal=8*PI*t_betal/bbb
    t_betap(1)=8*PI*t_presva/t_bpolsa**2
    t_betap(2)=t_presva*t_volume*2/(t_plc**2*t_raxis*2*PI)
    t_betap(3)=t_betap(2)*t_raxis/s_rcntr
    t_ctroy=1.0e+02_rq*s_rbore*SQRT(bbb)*t_betae/abs(t_placur)
    t_absflx=t_psix*MU0/20
    t_flxln=t_dpsi0*MU0/20
    IF(.NOT.t_fix_bound) THEN
       CALL vltsec(t_vltsnd(1),0)
       t_vltsnd(2)=g_flxc(t_raxis,t_zaxis)*MU0/20
       t_vltsnd(3)=g_flxc(s_rcntr,t_zaxis)*MU0/20
       t_slfnd=1.e6_rq*abs(t_psires-t_vltsnd(1))/abs(t_placur)
       ! Get candidate strike-points (get rstkpt(1:nstkpts), etc.)
       CALL d_strkpl(t_pxpt)
       ! Distill strike-points (get rspt(1:nspt), etc.)
       CALL dstrkpl
    END IF
    t_li(3)=2.0e-12_rq*t_bpsqva*t_volume/MU0**2/t_placur**2/s_rcntr
    t_psires=psires_
    t_psisep= t_psil*MU0/20
    t_li(3)=2*abs((t_psires-t_psisep)/(MU0*0.01_rq*s_rcntr*t_placur))
    t_li(1)=t_bpsqva/t_bpolsa**2
    t_li(2)=t_li(3)*s_rcntr/t_raxis
    t_lam(1)=t_betap(1)+0.5_rq*t_li(1)
    t_lam(2)=t_betap(2)+0.5_rq*t_li(2)
    t_lam(3)=t_betap(3)+0.5_rq*t_li(3)
    t_aspct=s_rcntr/s_rbore
    hinas=1./t_aspct
    hh=(1.+1.81_rq*SQRT(hinas)+2.05_rq*hinas)*LOG(8/hinas)-(2+9.25_rq*&
         SQRT(hinas)-1.21_rq*hinas)
    hb=0.73_rq*SQRT(hinas)*(1+2*hinas**4-6*hinas**5+3.7_rq*hinas**6)
    hc=1+0.98_rq*hinas**2+0.49_rq*hinas**4+1.47_rq*hinas**6
    hd=0.25_rq*hinas*(1+0.84_rq*hinas-1.44_rq*hinas**2)
    hm=(1-hinas)**2/((1-hinas)**2*hc+hd*SQRT(t_e95))
    t_xlfnd=0.25_rq*(hm-1)*(log(8*t_aspct)+t_betap(3)+0.5_rq*t_li(3)-1.5_rq)
    t_xlfnd=1.e4_rq*MU0*s_rcntr*(hh*(1-hinas)/(1-hinas+hb*t_e95)+0.5_rq*&
         t_li(3)- t_xlfnd)
    t_qstar=2.5_rq*s_rbore**2*abs(t_frsrf(t_msrf)/s_rcntr/t_placur)*(1+&
    t_e95**2)/s_rcntr
    CALL get95
    IF(t_ipj>4 .AND. t_fix_bound) CALL vltsec(t_vltsnd(1),3)

  END SUBROUTINE diaginv

  SUBROUTINE get95
    REAL(rq) :: dd,dm,dp,sp,spp
    INTEGER :: l

    dd=t_m95/(1-t_thetac)
    DO l=2,t_msrf
       IF(t_psibar(l)>dd) EXIT
    END DO
    IF(l/=t_msrf+1) THEN
       l=l-1
       dp=t_psibar(l+1)-t_psibar(l)
       dm=t_psibar(l-1)-t_psibar(l)
       dd=dd-t_psibar(l)
       sp=((t_qsrf(l+1)-t_qsrf(l))*dm/dp-(t_qsrf(l-1)-t_qsrf(l))*dp/dm)/&
            (dm-dp)
       spp=-2*((t_qsrf(l+1)-t_qsrf(l))/dp-(t_qsrf(l-1)-t_qsrf(l))/dm)/&
            (dm-dp)
       t_q95=t_qsrf(l)+sp*dd+0.5_rq*spp*dd**2
       sp=((t_esrf(l+1)-t_esrf(l))*dm/dp-(t_esrf(l-1)-t_esrf(l))*dp/dm)/&
            (dm-dp)
       spp=-2*((t_esrf(l+1)-t_esrf(l))/dp-(t_esrf(l-1)-t_esrf(l))/dm)/&
            (dm-dp)
       t_e95=t_esrf(l)+sp*dd+0.5_rq*spp*dd**2
       sp=((t_tsrf(l+1)-t_tsrf(l))*dm/dp-(t_tsrf(l-1)-t_tsrf(l))*dp/dm)/&
            (dm-dp)
       spp=-2*((t_tsrf(l+1)-t_tsrf(l))/dp-(t_tsrf(l-1)-t_tsrf(l))/dm)/&
            (dm-dp)
       t_t95=t_tsrf(l)+sp*dd+0.5_rq*spp*dd**2
       sp=((t_tusrf(l+1)-t_tusrf(l))*dm/dp-(t_tusrf(l-1)-t_tusrf(l))*dp/&
            dm)/(dm-dp)
       spp=-2*((t_tusrf(l+1)-t_tusrf(l))/dp-(t_tusrf(l-1)-t_tusrf(l))/&
            dm)/(dm-dp)
       t_tu95=t_tusrf(l)+sp*dd+0.5_rq*spp*dd**2
       sp=((t_tlsrf(l+1)-t_tlsrf(l))*dm/dp-(t_tlsrf(l-1)-t_tlsrf(l))*dp/&
            dm)/(dm-dp)
       spp=-2*((t_tlsrf(l+1)-t_tlsrf(l))/dp-(t_tlsrf(l-1)-t_tlsrf(l))/&
            dm)/(dm-dp)
       t_tl95=t_tlsrf(l)+sp*dd+0.5_rq*spp*dd**2
       sp=((t_frsrf(l+1)-t_frsrf(l))*dm/dp-(t_frsrf(l-1)-t_frsrf(l))*dp/&
            dm)/(dm-dp)
       spp=-2*((t_frsrf(l+1)-t_frsrf(l))/dp-(t_frsrf(l-1)-t_frsrf(l))/&
            dm)/(dm-dp)
       t_f95=t_frsrf(l)+sp*dd+0.5_rq*spp*dd**2
    ELSE
       t_q95=t_qsrf(t_msrf)
       t_e95=t_esrf(t_msrf)
       t_t95=t_tsrf(t_msrf)
       t_tu95=t_tusrf(t_msrf)
       t_tl95=t_tlsrf(t_msrf)
       t_f95=t_frsrf(t_msrf)
    END IF
    t_elongn=t_esrf(t_msrf)
    t_trian=t_tsrf(t_msrf)
    t_trianu=t_tusrf(t_msrf)
    t_trianl=t_tlsrf(t_msrf)
  END SUBROUTINE get95

  SUBROUTINE Siden(n,l,f,fx,fxx,fxxx)
    INTEGER, INTENT(IN) :: n,l
    REAL(rq), INTENT(OUT) :: f,fx,fxx,fxxx
    INTEGER :: i,j
    !     Evaluate cubic coeffients on side:centered from splines.
    if(l.eq.1) then
       i=2;j=1
    else
       i=1;j=2
    endif
    fxxx=6*(i_cps(n,i,j)+i_cps(n+l,i,j))-12*(i_cps(n+l,1,1)-i_cps(n,1,1))
    fx=i_cps(n+l,1,1)-i_cps(n,1,1)-fxxx/24
    fxx=(i_cps(n+l,i,j)-i_cps(n,i,j))
    f=0.5_rq*(i_cps(n+l,1,1)+i_cps(n,1,1))-0.125_rq*fxx
  END SUBROUTINE Siden

  SUBROUTINE Newton(psill,dd,f,fx,fxx,fxxx)
    REAL(rq),  INTENT(IN) :: psill,f,fx,fxx,fxxx
    REAL(rq), INTENT(INOUT) :: dd
    REAL(rq) :: arg,argx,test
    INTEGER :: i
    DO i=1,nter_interp
       arg=psill-(f+dd*(fx+0.5_rq*dd*(fxx+dd/3*fxxx)))
       argx=fx+dd*(fxx+0.5_rq*dd*fxxx)
       test=ABS(arg/psill)
       IF(test < errt_rq) EXIT
       dd=dd+arg/argx
    END DO
  END SUBROUTINE Newton

  SUBROUTINE get_surfint
    INTEGER :: lst,l,ihl,ihu,m,n1
    REAL(rq) :: vprime,rhyp,r2bp2s
    n1=0
    IF(ALLOCATED(brs))THEN
       n1=SIZE(brs)
    END IF
    IF(n1/=t_mls) THEN
       IF(ALLOCATED(brs)) DEALLOCATE(brs,bzs,bps,bms,bts)
       ALLOCATE(brs(t_mls),bzs(t_mls),bps(t_mls),bms(t_mls),bts(t_mls))
    END IF
    n1=0
    IF(ALLOCATED(dq1))THEN
       n1=SIZE(dq1)
    END IF
    IF(n1/=t_mls) THEN
       IF(ALLOCATED(dq1))DEALLOCATE(dq1,dq2)
       ALLOCATE(dq1(t_mls),dq2(t_mls))
    END IF
    DO l=2,t_msrf
       t_rls=t_rlsd(:,l,1)
       t_zls=t_zlsd(:,l,1)
       brs=s_pin*t_rlsd(:,l,2)/t_zlsd(:,l,4)
       bzs=s_pin*t_zlsd(:,l,2)/t_zlsd(:,l,4)
       bps=t_rlsd(:,l,4)
       bts=t_frsrf(l)/t_rls
       bms=sqrt(bps**2+bts**2)
       dq2=s_pin*TWOPI/(t_mls-1)*t_zlsd(:,l,4)
       dq2(t_mls)=0
       IF(t_use_halo.AND.t_lhalo<t_msrf) then
          IF(t_lhsrf(l,1)/=0) then
             ihl=t_lhsrf(l,1)
             dq2(ihl)=dq2(ihl)*(t_thhsrf(l,1)-t_tswpts(ihl))/t_tswpts(2)
             ihu=t_lhsrf(l,2)
             dq2(ihu)=dq2(ihu)*(t_tswpts(ihu)-t_thhsrf(l,2))/t_tswpts(2)
             IF(ihu-ihl>1) dq2(ihl+1:ihu-1)=0
          END IF
       END IF

       vprime       = SUM(dq2)
       t_cusrf(l)   = SUM(dq2*bps**2)
       t_rsqbp(l)   = SUM(dq2/t_rls**2)
       t_rsqrf(l)   = SUM(dq2*t_rls**2)/vprime
       t_c4srf(l)   = SUM(dq2*t_rls*bps)
       rhyp         = SUM(dq2*t_rls**2*bps**2/bms**2)
       r2bp2s       = SUM(dq2*t_rls**2*bps**2)
       t_r4bp2rf(l) = SUM(dq2*t_rls**4*bps**2)/vprime
       t_r2bzrf(l)  = SUM(dq2*t_rls**2*bzs)/vprime
       t_alsrf(l)   = SUM(dq2*bps)
       t_risrf(l)   = SUM(dq2/t_rls)/vprime
       t_bpsrf(l)   = t_alsrf(l)/vprime
       t_bsqrf(l)   = (t_cusrf(l)+t_frsrf(l)**2*t_rsqbp(l))/vprime
       t_rsqirf(l)  = t_rsqbp(l)/vprime
       t_qsrf(l)    = t_frsrf(l)*t_rsqbp(l)/TWOPI
       t_vpsrf(l)   = TWOPI*vprime
       t_c1srf(l)   = t_frsrf(l)*t_rsqbp(l)/TWOPI*r2bp2s
       t_c5srf(l)   = rhyp/(r2bp2s+errt_rq)
       t_c5srf(l)   = t_c5srf(l)*t_bsqrf(l)-1

    END DO
    t_rsqirf(1)    = 1/t_raxis**2
    t_risrf(1)     = 1/t_raxis
    t_bsqrf(1)     = t_frsrf(1)**2/t_raxis**2
    t_bpsrf(1)     = 0
    t_c1srf(1)     = 0
    t_c4srf(1)     = 0
    t_c5srf(1)     = 0
    t_r4bp2rf(1)   = 0
    t_r2bzrf(1)    = 0
    t_cusrf(1)     = 0
    t_alsrf(1)     =0
    t_rsqrf(1)     = t_raxis**2
    t_qsrf(1)      = extrp(t_qsrf,t_psibar,t_msrf,0,0)
    t_vpsrf(1)     = extrp(t_vpsrf,t_psibar,t_msrf,0,0)
    t_rsqbp(1)     = extrp(t_rsqbp,t_psibar,t_msrf,0,0)
    IF(t_psil==t_pxpt) then
       t_qsrf(t_msrf)   = extrp(t_qsrf,t_psibar,t_msrf,1,0)
       t_rsqbp(t_msrf)  = extrp(t_rsqbp,t_psibar,t_msrf,1,0)
       t_vpsrf(t_msrf)  = extrp(t_vpsrf,t_psibar,t_msrf,1,0)
       t_rsqirf(t_msrf) = extrp(t_rsqirf,t_psibar,t_msrf,1,0)
       t_risrf(t_msrf)  = extrp(t_risrf,t_psibar,t_msrf,1,0)
       t_rsqrf(t_msrf)  = extrp(t_rsqrf,t_psibar,t_msrf,1,0)
    END IF
    t_vptor=t_vpsrf
    IF(t_ifluxcord<=0) t_vptor=abs(t_vptor/t_qsrf)
    call currentCentroid

  END SUBROUTINE get_surfint

  SUBROUTINE limw_from_plates
     REAL(rq), DIMENSION(t_nplates) :: splate,dplate
     REAL(rq), DIMENSION(t_lmax) :: slimw,dummy
     REAL(rq) :: yb
     INTEGER i

     yb=t_splbdry
     splate(1)=0
     dplate(1)=0
     dummy=-999
     dplate(2:)=SQRT((t_rplate(2:,1)-t_rplate(:t_nplates-1,1))**2+ &
       (t_zplate(2:,1)-t_zplate(:t_nplates-1,1))**2)
     DO i=2,t_nplates
       splate(i)=splate(i-1)+dplate(i)
     END DO
     slimw=(/(i,i=0,t_lmax-1)/)*splate(t_nplates)/(t_lmax-1)
     dplate=t_rplate(:,1)
     CALL interp_interp(splate,dplate,yb,yb,slimw,t_rlimw,dummy)
     dplate=t_zplate(:,1)
     CALL interp_interp(splate,dplate,yb,yb,slimw,t_zlimw,dummy)

   END SUBROUTINE limw_from_plates

   SUBROUTINE currentCentroid

     INTEGER :: l,m
    l=t_mls-1
    m=t_msrf
    t_rcur=SUM(t_zlsd(:l,m,4)*t_rlsd(:l,m,4)*t_rlsd(:l,m,1)**2)/&
         SUM(t_zlsd(:l,m,4)*t_rlsd(:l,m,4))
    IF(t_nsym==1) THEN
       t_zcur=0
    ELSE
       t_zcur=SUM(t_zlsd(:l,m,4)*t_rlsd(:l,m,4)*t_zlsd(:l,m,1))/&
         SUM(t_zlsd(:l,m,4)*t_rlsd(:l,m,4))
    END IF
    DO l=1,t_msrf
       IF(t_rcur<0) THEN
          CALL errdetec("bad Jacobian in get_surfint",1)
       END IF
    END DO
    IF(l==t_msrf+1) t_rcur=SQRT(t_rcur)

  END SUBROUTINE currentCentroid


END MODULE diag_mod

! $Id: runTeq.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $

Module runTeq_mod

  USE setTeq_mod

  IMPLICIT NONE

CONTAINS

  SUBROUTINE genTeq

    t_ncallsf = 0 ! necessary for keqic=1 to work in equila
    IF(t_rfix==0) t_rfix=t_rb
    CALL pfcmem   ! set up filaments
    IF ( t_keqic==1 .OR. t_keqic==2 ) THEN
       IF(ALLOCATED(t_cscl00)) THEN
          IF (t_cscl00(1)/=0.0d0 .AND. ASSOCIATED(t_rbd00)) THEN
             IF (t_nc/=0) t_cc(1:t_nc)=t_cscl00(1:t_nc)
             IF (t_nbd/=0) t_rbd(1:t_nbd)=t_rbd00(1:t_nbd)
             IF (t_nbd/=0) t_zbd(1:t_nbd)=t_zbd00(1:t_nbd)
             IF (t_nfbd/=0) t_rfbd(1:t_nfbd)=t_rfbd00(1:t_nfbd)
             IF (t_nfbd/=0) t_zfbd(1:t_nfbd)=t_zfbd00(1:t_nfbd)
          ELSE
             IF (t_nc/=0) t_cscl00(1:t_nc)=t_cc(1:t_nc)
          END IF
       END IF
    ELSEIF( t_keqic==3 ) THEN
       IF (t_nc/=0) t_cc(1:t_nc)=t_cscl01(1:t_nc)
       IF (t_nbd/=0) t_rbd(1:t_nbd)=t_rbd01(1:t_nbd)
       IF (t_nbd/=0) t_zbd(1:t_nbd)=t_zbd01(1:t_nbd)
       IF (t_nfbd/=0) t_rfbd(1:t_nfbd)=t_rfbd01(1:t_nfbd)
       IF (t_nfbd/=0) t_zfbd(1:t_nfbd)=t_zfbd01(1:t_nfbd)
    END IF
    CALL getstrg(1) ! get remaining memory; also calls setgeo---the grid
  END SUBROUTINE genTeq

  SUBROUTINE exeTeq

    t_ncallsf = t_ncallsf + 1
    IF ( t_ksave.eq.1 ) THEN
       IF ( t_nc.ne.0) t_cscl00(1: t_nc)= t_cc(1: t_nc)
       t_rbd00=t_rbd
       t_zbd00=t_zbd
       t_rfbd00=t_rfbd
       t_zfbd00=t_zfbd
    END IF

    call gs_equil0
    call teq_interface

    IF ( (t_lasteqsav==0 .AND. t_lasteq==1) .OR. (t_lasteqsav==1 .AND.&
         ( (t_pkgname=="eq") .OR. ((t_pkgname/="eq") .AND. (t_lasteq==1)&
         ) ) ) .OR. (t_lasteqsav==2) ) THEN
       IF (t_nc/=0) t_cscl01(1:t_nc)=t_cc(1:t_nc)
       IF (t_jmkm/=0) t_psi01(1:t_jmkm)=t_psi(1:t_jmkm)
       IF (t_nbd/=0) t_rbd01(1:t_nbd)=t_rbd(1:t_nbd)
       IF (t_nbd/=0) t_zbd01(1:t_nbd)=t_zbd(1:t_nbd)
       IF (t_nfbd/=0) t_rfbd01(1:t_nfbd)=t_rfbd(1:t_nfbd)
       IF (t_nfbd/=0) t_zfbd01(1:t_nfbd)=t_zfbd(1:t_nfbd)
       t_prsx01=t_prsx
    END IF
    ! prepare for starting up in future from current state (t_keqic >0 )
    ! should do this here only IF package=eq, and do ceq's in ceqexe
    IF ( t_ksave ==2 .AND. (t_lasteq == 1 .OR. t_pkgname=="eq") ) THEN
       IF (t_nc/=0) t_cscl00(1:t_nc)=t_cc(1:t_nc)
       IF (t_jmkm/=0) t_psi00(1:t_jmkm)=t_psi(1:t_jmkm)
       IF (t_nbd/=0) t_rbd00(1:t_nbd)=t_rbd(1:t_nbd)
       IF (t_nbd/=0) t_zbd00(1:t_nbd)=t_zbd(1:t_nbd)
       IF (t_nbd/=0) t_rfbd00(1:t_nbd)=t_rfbd(1:t_nbd)
       IF (t_nbd/=0) t_zfbd00(1:t_nbd)=t_zfbd(1:t_nbd)
       t_prsx00=t_prsx
       t_ksave = 0 ! if one needs lasteq=1 for meq solve, this wrecks save
    END IF
  END SUBROUTINE exeTeq

  SUBROUTINE runTeq
    CALL genTeq
    CALL exeTeq 
  END SUBROUTINE runTeq

  SUBROUTINE startinv
    USE teqPol_mod, only : t_inv_k,t_inv_p
    CALL genTeq
    CALL start_inv(t_inv_k,t_inv_p)
  END SUBROUTINE startinv

  SUBROUTINE invTeq
    USE teqPol_mod, only : t_inv_k,t_inv_p
    CALL genTeq
    CALL teq_inv(t_inv_k,t_inv_p)
  END SUBROUTINE invTeq

END Module runTeq_mod

! $Id: hmb.f90,v 1.2 2007/07/23 16:00:57 meyer Exp $

subroutine chkprm(iorder,a,b,m,mbdcnd,c,d,n,nbdcnd,cofx,idmn,ierror)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this program checks the input parameters for errors

  real(rq) :: a,b,c,d

  external cofx

!     check definition of solution region

  ierror = 1
  if (a.ge.b .or. c.ge.d) return

!     check boundary switches

  ierror = 2
  if (mbdcnd.lt.0 .or. mbdcnd.gt.4) return
  ierror = 3
  if (nbdcnd.lt.0 .or. nbdcnd.gt.4) return

!     check first dimension in calling routine

  ierror = 5
  if (idmn .lt. 7) return

!     check m

  ierror = 6
  if (m.gt.(idmn-1) .or. m.lt.6) return

!     check n

  ierror = 7
  if (n .lt. 5) return

!     check iorder

  ierror = 8
  if (iorder.ne.2 .and. iorder.ne.4) return

!     check that equation is elliptic

  dlx = (b-a)/(m)
  do i=2,m
     xi = a+(i-1)*dlx
     call cofx (xi,ai,bi,ci)
     if (ai.le.0) then
        ierror=10
        return
     endif
  end do

!     no error found

  ierror = 0

  return

end subroutine chkprm

subroutine chksng(mbdcnd,nbdcnd,alpha,beta,cofx,singlr)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this subroutine checks if the pde   sepeli
!     must solve is a singular operator

  real(rq) :: alpha,beta

  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is,ms,js,ns,dlx,dly, &
       tdlx3,tdly3,dlx4,dly4

  logical :: singlr

  external cofx

  singlr = .false.

!     check if the boundary conditions are
!     entirely periodic and/or mixed

  if ((mbdcnd.ne.0 .and. mbdcnd.ne.3) .or. (nbdcnd.ne.0 .and. nbdcnd .ne.3)) &
       return

!     check that mixed conditions are pure neuman

  if (mbdcnd .ne. 3) go to 10
  if (alpha.ne.0.0_rq .or. beta.ne.0.0_rq) return
10 continue

!     check that non-derivative coefficient functions
!     are zero
!
  do i=is,ms
     xi = ait+(i-1)*dlx
     call cofx (xi,ai,bi,ci)
     if (ci .ne. 0.0_rq) return
  end do

!     the operator must be singular if this point is reached

  singlr = .true.

  return

end subroutine chksng

! fishpak23  from portlib                                  11/06/79

!     this file contains four subroutines used by subroutines genbun
!     (file 15) and poistg (file 17).

subroutine cosgen(n,ijump,fnum,fden,a)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: a(*),fnum,fden

!     this subroutine computes required cosine values in ascending
!     order.  when ijump .gt. 1 the routine computes values
!
!        2*cos(j*pi/l) , j=1,2,...,l and j .ne. 0(mod n/ijump+1)
!
!     where l = ijump*(n/ijump+1).
!
!     when ijump = 1 it computes
!
!            2*cos((j-fnum)*pi/(n+fden)) ,  j=1, 2, ... ,n
!
!     where
!        fnum = 0.5, fden = 0.0,  for regular reduction values
!        fnum = 0.0, fden = 1.0, for b-r and c-r when istag = 1
!        fnum = 0.0, fden = 0.5, for b-r and c-r when istag = 2
!        fnum = 0.5, fden = 0.5, for b-r and c-r when istag = 2
!                                in poisn2 only.

  if (n .eq. 0) go to 105
  if (ijump .eq. 1) go to 103

  k3 = n/ijump+1
  k4 = k3-1
  pibyn = 3.14159265358979323_rq/(n+ijump)

  do k=1,ijump
     k1 = (k-1)*k3
     k5 = (k-1)*k4
     do i=1,k4
        x = k1+i
        k2 = k5+i
        a(k2) = -2._rq*cos(x*pibyn)
     end do
  end do

  go to 105

103 continue
  np1 = n+1
  y = 3.14159265358979323_rq/((n)+fden)

  do i=1,n
     x = (np1-i)-fnum
     a(i) = 2._rq*cos(x*y)
  end do

105 continue

  return

end subroutine cosgen

subroutine defer(cofx,idmn,usol,grhs)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this subroutine first approximates the trun1ation error given by
!     trun1(x,y)=dlx**2*tx+dly**2*ty where
!     tx=afun(x)*uxxxx/12.0+bfun(x)*uxxx/6.0 on the interior and
!     at the boundaries if periodic(here uxxx,uxxxx are the third
!     and fourth partial derivatives of u with respect to x).
!     tx is of the form afun(x)/3.0*(uxxxx/4.0+uxxx/dlx)
!     at x=a or x=b if the boundary condition there is mixed.
!     tx=0.0 along specified boundaries.  ty has symmetric form
!     in y with x,afun(x),bfun(x) replaced by y,dfun(y),efun(y).
!     the second order solution in usol is used to approximate
!     (via second order finite differencing) the trun1ation error
!     and the result is added to the right hand side in grhs
!     and then transferred to usol to be used as a new right
!     hand side when calling blktri for a fourth order solution.

  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is,ms,js,ns,dlx,dly, &
       tdlx3,tdly3,dlx4,dly4

  real(rq) :: grhs(idmn,*),usol(idmn,*)

  external cofx

!     compute trun1ation error approximation over the entire mesh

  do i=is,ms
     xi = ait+(i-1)*dlx
     call cofx(xi,ai,bi,ci)
     do j=js,ns
!     compute partial derivative approximations at (xi,yj)
        call dx(usol,idmn,i,j,uxxx,uxxxx)
        call dy(usol,idmn,i,j,uyyy,uyyyy)
        tx = ai*uxxxx/12.0_rq+bi*uxxx/6.0_rq
        ty=uyyyy/12.0_rq
!     reset form of trun1ation if at boundary which is non-periodic
        if (kswx.eq.1 .or. (i.gt.1 .and. i.lt.k)) go to 10
        tx = ai/3.0_rq*(uxxxx/4.0_rq+uxxx/dlx)
10      if (kswy.eq.1 .or. (j.gt.1 .and. j.lt.l)) go to 20
        ty = (uyyyy/4.0_rq+uyyy/dly)/3.0_rq
20      grhs(i,j)=grhs(i,j)+dly**2*(dlx**2*tx+dly**2*ty)
     end do
  end do

!     reset the right hand side in usol

  do i=is,ms
     do j=js,ns
        usol(i,j) = grhs(i,j)
     end do
  end do

  return

end subroutine defer

subroutine dogleg(n,r,lr,diag,qtb,delta,x,wa1,wa2)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: n,lr
  real(rq) :: r(lr),diag(n),qtb(n),x(n),wa1(n),wa2(n),delta

!     **********
!
!     subroutine dogleg
!
!     given an m by n matrix a, an n by n nonsingular diagonal
!     matrix d, an m-vector b, and a positive number delta, the
!     problem is to determine the convex combination x of the
!     gauss-newton and scaled gradient directions that minimizes
!     (a*x - b) in the least squares sense, subject to the
!     restriction that the euclidean norm of d*x be at most delta.
!
!     this subroutine completes the solution of the problem
!     if it is provided with the necessary information from the
!     qr factorization of a. that is, if a = q*r, where q has
!     orthogonal columns and r is an upper triangular matrix,
!     then dogleg expects the full upper triangle of r and
!     the first n components of (q transpose)*b.
!
!     the subroutine statement is
!
!       subroutine dogleg(n,r,lr,diag,qtb,delta,x,wa1,wa2)
!
!     where
!
!       n is a positive integer input variable set to the order of r.
!
!       r is an input array of length lr which must contain the upper
!         triangular matrix r stored by rows.
!
!       lr is a positive integer input variable not less than
!         (n*(n+1))/2.
!
!       diag is an input array of length n which must contain the
!         diagonal elements of the matrix d.
!
!       qtb is an input array of length n which must contain the first
!         n elements of the vector (q transpose)*b.
!
!       delta is a positive input variable which specifies an upper
!         bound on the euclidean norm of d*x.
!
!       x is an output array of length n which contains the desired
!         convex combination of the gauss-newton direction and the
!         scaled gradient direction.
!
!       wa1 and wa2 are work arrays of length n.
!
!     subprograms called
!
!       minpack-supplied ... enorm
!
!       fortran-supplied ... abs,amax1,amin1,sqrt
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i,j,jj,jp1,k,l
  real(rq) :: alpha,bnorm,epsmch,gnorm,qnorm,sgnorm,sum,temp

!     epsmch is the machine precision.

  epsmch = errt_rq ! d1mach(3)

!     first, calculate the gauss-newton direction.

  jj = (n*(n + 1))/2 + 1
  do k = 1, n
     j = n - k + 1
     jp1 = j + 1
     jj = jj - k
     l = jj + 1
     sum = zero
     if (n .lt. jp1) go to 20
     do i = jp1, n
        sum = sum + r(l)*x(i)
        l = l + 1
     end do
20   continue
     temp = r(jj)
     if (temp .ne. zero) go to 40
     l = j
     do i = 1, j
        temp = max(temp,abs(r(l)))
        l = l + n - i
     end do
     temp = epsmch*temp
     if (temp .eq. zero) temp = epsmch
40   continue
     x(j) = (qtb(j) - sum)/temp
  end do

!     test whether the gauss-newton direction is acceptable.

  do j = 1, n
     wa1(j) = zero
     wa2(j) = diag(j)*x(j)
  end do
  qnorm = enorm(n,wa2)
  if (qnorm .le. delta) go to 140

!     the gauss-newton direction is not acceptable.
!     next, calculate the scaled gradient direction.

  l = 1
  do j = 1, n
     temp = qtb(j)
     do i = j, n
        wa1(i) = wa1(i) + r(l)*temp
        l = l + 1
     end do
     wa1(j) = wa1(j)/diag(j)
  end do

!     calculate the norm of the scaled gradient and test for
!     the special case in which the scaled gradient is zero.

  gnorm = enorm(n,wa1)
  sgnorm = zero
  alpha = delta/qnorm
  if (gnorm .eq. zero) go to 120

!     calculate the point along the scaled gradient
!     at which the quadratic is minimized.

  do j = 1, n
     wa1(j) = (wa1(j)/gnorm)/diag(j)
  end do
  l = 1
  do j = 1, n
     sum = zero
     do i = j, n
        sum = sum + r(l)*wa1(i)
        l = l + 1
     end do
     wa2(j) = sum
  end do
  temp = enorm(n,wa2)
  sgnorm = (gnorm/temp)/temp

!     test whether the scaled gradient direction is acceptable.

  alpha = zero
  if (sgnorm .ge. delta) go to 120

!     the scaled gradient direction is not acceptable.
!     finally, calculate the point along the dogleg
!     at which the quadratic is minimized.

  bnorm = enorm(n,qtb)
  temp = (bnorm/gnorm)*(bnorm/qnorm)*(sgnorm/delta)
  temp = temp - (delta/qnorm)*(sgnorm/delta)**2 + &
       sqrt((temp-(delta/qnorm))**2 + &
       (one-(delta/qnorm)**2)*(one-(sgnorm/delta)**2))
  alpha = ((delta/qnorm)*(one - (sgnorm/delta)**2))/temp

120 continue

!     form appropriate convex combination of the gauss-newton
!     direction and the scaled gradient direction.

  temp = (one - alpha)*min(sgnorm,delta)
  do j = 1, n
     x(j) = temp*wa1(j) + alpha*x(j)
  end do

140 continue

  return

!     last card of subroutine dogleg.

end subroutine dogleg

subroutine dx(u,idmn,i,j,uxxx,uxxxx)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this program computes second order finite difference
!     approximations to the third and fourth x
!     partial derivatives of u at the (i,j) mesh point

  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is,ms,js,ns,dlx,dly, &
       tdlx3,tdly3,dlx4,dly4

  real(rq) :: u(idmn,*),uxxx,uxxxx

  if (i.gt.2 .and. i.lt.(k-1)) go to 50
  if (i .eq. 1) go to 10
  if (i .eq. 2) go to 30
  if (i .eq. k-1) go to 60
  if (i .eq. k) go to 80

!     compute partial derivative approximations at x=a

10 if (kswx .eq. 1) go to 20

  uxxx = (-5.0_rq*u(1,j)+18.0_rq*u(2,j)-24.0_rq*u(3,j)+14.0_rq*u(4,j)- &
       3.0_rq*u(5,j))/(tdlx3)
  uxxxx = (3.0_rq*u(1,j)-14.0_rq*u(2,j)+26.0_rq*u(3,j)-24.0_rq*u(4,j)+ &
       11.0_rq*u(5,j)-2.0_rq*u(6,j))/dlx4

  return

!     periodic at x=a

20 uxxx = (-u(k-2,j)+2.0_rq*u(k-1,j)-2.0_rq*u(2,j)+u(3,j))/(tdlx3)
  uxxxx = (u(k-2,j)-4.0_rq*u(k-1,j)+6.0_rq*u(1,j)-4.0_rq*u(2,j)+u(3,j))/dlx4

  return

!     compute partial derivative approximations at x=a+dlx

30 if (kswx .eq. 1) go to 40

  uxxx = (-3.0_rq*u(1,j)+10.0_rq*u(2,j)-12.0_rq*u(3,j)+6.0_rq*u(4,j)-u(5,j))/ &
       tdlx3
  uxxxx = (2.0_rq*u(1,j)-9.0_rq*u(2,j)+16.0_rq*u(3,j)-14.0_rq*u(4,j)+ &
       6.0_rq*u(5,j)- u(6,j))/dlx4

  return

!     periodic at x=a+dlx

40 uxxx = (-u(k-1,j)+2.0_rq*u(1,j)-2.0_rq*u(3,j)+u(4,j))/(tdlx3)
  uxxxx = (u(k-1,j)-4.0_rq*u(1,j)+6.0_rq*u(2,j)-4.0_rq*u(3,j)+u(4,j))/dlx4

  return

!     compute partial derivative approximations on the interior

50 continue

  uxxx = (-u(i-2,j)+2.0_rq*u(i-1,j)-2.0_rq*u(i+1,j)+u(i+2,j))/tdlx3
  uxxxx = (u(i-2,j)-4.0_rq*u(i-1,j)+6.0_rq*u(i,j)-4.0_rq*u(i+1,j)+u(i+2,j))/ &
       dlx4

  return

!     compute partial derivative approximations at x=b-dlx

60 if (kswx .eq. 1) go to 70

  uxxx = (u(k-4,j)-6.0_rq*u(k-3,j)+12.0_rq*u(k-2,j)-10.0_rq*u(k-1,j)+ &
       3.0_rq*u(k,j))/tdlx3
  uxxxx = (-u(k-5,j)+6.0_rq*u(k-4,j)-14.0_rq*u(k-3,j)+16.0_rq*u(k-2,j)- &
       9.0_rq*u(k-1,j)+2.0_rq*u(k,j))/dlx4

  return

!     periodic at x=b-dlx

70 uxxx = (-u(k-3,j)+2.0_rq*u(k-2,j)-2.0_rq*u(1,j)+u(2,j))/tdlx3
  uxxxx = (u(k-3,j)-4.0_rq*u(k-2,j)+6.0_rq*u(k-1,j)-4.0_rq*u(1,j)+u(2,j))/ dlx4

  return

!     compute partial derivative approximations at x=b

80 uxxx = -(3.0_rq*u(k-4,j)-14.0_rq*u(k-3,j)+24.0_rq*u(k-2,j)- &
        18.0_rq*u(k-1,j)+ 5.0_rq*u(k,j))/tdlx3
  uxxxx = (-2.0_rq*u(k-5,j)+11.0_rq*u(k-4,j)-24.0_rq*u(k-3,j)+ &
       26.0_rq*u(k-2,j)- 14.0_rq*u(k-1,j)+3.0_rq*u(k,j))/dlx4

  return

end subroutine dx

subroutine dy(u,idmn,i,j,uyyy,uyyyy)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this program computes second order finite difference
!     approximations to the third and fourth y
!     partial derivatives of u at the (i,j) mesh point

  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is,ms,js,ns,dlx,dly, &
       tdlx3,tdly3,dlx4,dly4

  real(rq) :: u(idmn,*),uyyy,uyyyy

  if (j.gt.2 .and. j.lt.(l-1)) go to 50
  if (j .eq. 1) go to 10
  if (j .eq. 2) go to 30
  if (j .eq. l-1) go to 60
  if (j .eq. l) go to 80

!     compute partial derivative approximations at y=c

10 if (kswy .eq. 1) go to 20

  uyyy = (-5.0_rq*u(i,1)+18.0_rq*u(i,2)-24.0_rq*u(i,3)+14.0_rq*u(i,4)- &
       3.0_rq*u(i,5))/tdly3
  uyyyy = (3.0_rq*u(i,1)-14.0_rq*u(i,2)+26.0_rq*u(i,3)-24.0_rq*u(i,4)+ &
       11.0_rq*u(i,5)-2.0_rq*u(i,6))/dly4

  return

!     periodic at x=a

20 uyyy = (-u(i,l-2)+2.0_rq*u(i,l-1)-2.0_rq*u(i,2)+u(i,3))/tdly3
  uyyyy = (u(i,l-2)-4.0_rq*u(i,l-1)+6.0_rq*u(i,1)-4.0_rq*u(i,2)+u(i,3))/dly4

  return

!     compute partial derivative approximations at y=c+dly

30 if (kswy .eq. 1) go to 40

  uyyy = (-3.0_rq*u(i,1)+10.0_rq*u(i,2)-12.0_rq*u(i,3)+6.0_rq*u(i,4)-u(i,5))/ &
       tdly3
  uyyyy = (2.0_rq*u(i,1)-9.0_rq*u(i,2)+16.0_rq*u(i,3)-14.0_rq*u(i,4)+ &
       6.0_rq*u(i,5)- u(i,6))/dly4

  return

!     periodic at y=c+dly

40 uyyy = (-u(i,l-1)+2.0_rq*u(i,1)-2.0_rq*u(i,3)+u(i,4))/tdly3
  uyyyy = (u(i,l-1)-4.0_rq*u(i,1)+6.0_rq*u(i,2)-4.0_rq*u(i,3)+u(i,4))/dly4

  return

!     compute partial derivative approximations on the interior

50 continue

  uyyy = (-u(i,j-2)+2.0_rq*u(i,j-1)-2.0_rq*u(i,j+1)+u(i,j+2))/tdly3
  uyyyy = (u(i,j-2)-4.0_rq*u(i,j-1)+6.0_rq*u(i,j)-4.0_rq*u(i,j+1)+u(i,j+2))/ &
       dly4

  return

!     compute partial derivative approximations at y=d-dly

60 if (kswy .eq. 1) go to 70

  uyyy = (u(i,l-4)-6.0_rq*u(i,l-3)+12.0_rq*u(i,l-2)-10.0_rq*u(i,l-1)+ &
       3.0_rq*u(i,l))/tdly3
  uyyyy = (-u(i,l-5)+6.0_rq*u(i,l-4)-14.0_rq*u(i,l-3)+16.0_rq*u(i,l-2)- &
       9.0_rq*u(i,l-1)+2.0_rq*u(i,l))/dly4

  return

!     periodic at y=d-dly

70 continue

  uyyy = (-u(i,l-3)+2.0_rq*u(i,l-2)-2.0_rq*u(i,1)+u(i,2))/tdly3
  uyyyy = (u(i,l-3)-4.0_rq*u(i,l-2)+6.0_rq*u(i,l-1)-4.0_rq*u(i,1)+u(i,2))/ dly4

  return

!     compute partial derivative approximations at y=d

80 uyyy = -(3.0_rq*u(i,l-4)-14.0_rq*u(i,l-3)+24.0_rq*u(i,l-2)- &
        18.0_rq*u(i,l-1)+ 5.0_rq*u(i,l))/tdly3
  uyyyy = (-2.0_rq*u(i,l-5)+11.0_rq*u(i,l-4)-24.0_rq*u(i,l-3)+ &
       26.0_rq*u(i,l-2)- 14.0_rq*u(i,l-1)+3.0_rq*u(i,l))/dly4

  return

end subroutine dy

function enorm(n,x)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: n
  real(rq) :: enorm,x(n)

!     **********
!
!     function enorm
!
!     given an n-vector x, this function calculates the
!     euclidean norm of x.
!
!     the euclidean norm is computed by accumulating the sum of
!     squares in three different sums. the sums of squares for the
!     small and large components are scaled so that no overflows
!     occur. non-destructive underflows are permitted. underflows
!     and overflows do not occur in the computation of the unscaled
!     sum of squares for the intermediate components.
!     the definitions of small, intermediate and large components
!     depend on two constants, rdwarf and rgiant. the main
!     restrictions on these constants are that rdwarf**2 not
!     underflow and rgiant**2 not overflow. the constants
!     given here are suitable for every known computer.
!
!     the function statement is
!
!       function enorm(n,x)
!
!     where
!
!       n is a positive integer input variable.
!
!       x is an input array of length n.
!
!     subprograms called
!
!       fortran-supplied ... abs,sqrt
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i
  real(rq) :: agiant,floatn,rdwarf,rgiant,s1,s2,s3,xabs,x1max,x3max
  data rdwarf,rgiant /3.834d-20,1.304d19/

  s1 = zero
  s2 = zero
  s3 = zero
  x1max = zero
  x3max = zero
  floatn = n
  agiant = rgiant/floatn
  do i = 1, n
     xabs = abs(x(i))
     if (xabs .gt. rdwarf .and. xabs .lt. agiant) go to 70
     if (xabs .le. rdwarf) go to 30

!              sum for large components.

     if (xabs .le. x1max) go to 10
     s1 = one + s1*(x1max/xabs)**2
     x1max = xabs
     go to 20
10   continue
     s1 = s1 + (xabs/x1max)**2
20   continue
     go to 60
30   continue

!              sum for small components.

     if (xabs .le. x3max) go to 40
     s3 = one + s3*(x3max/xabs)**2
     x3max = xabs
     go to 50
40   continue
     if (xabs .ne. zero) s3 = s3 + (xabs/x3max)**2
50   continue
60   continue
     go to 80
70   continue

!           sum for intermediate components.

     s2 = s2 + xabs**2
80   continue
  end do

!     calculation of norm.

  if (s1 .eq. zero) go to 100
  enorm = x1max*sqrt(s1+(s2/x1max)/x1max)
  go to 130
100 continue
  if (s2 .eq. zero) go to 110
  if (s2 .ge. x3max) enorm = sqrt(s2*(one+(x3max/s2)*(x3max*s3)))
  if (s2 .lt. x3max) enorm = sqrt(x3max*((s2/x3max)+(x3max*s3)))
  go to 120
110 continue
  enorm = x3max*sqrt(s3)
120 continue
130 continue

  return

end function enorm

!     last card of function enorm.

! fishpak24  from portlib                                  11/06/79

subroutine fdjac1(fcn,n,x,fvec,fjac,ldfjac,iflag,ml,mu,epsfcn,wa1,wa2,nprint)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: n,ldfjac,iflag,ml,mu
  real(rq) :: epsfcn
  real(rq) :: x(n),fvec(n),fjac(ldfjac,n),wa1(n),wa2(n)

!     **********
!
!     subroutine fdjac1
!
!     this subroutine computes a forward-difference approximation
!     to the n by n jacobian matrix associated with a specified
!     problem of n functions in n variables. if the jacobian has
!     a banded form, then function evaluations are saved by only
!     approximating the nonzero terms.
!
!     the subroutine statement is
!
!       subroutine fdjac1(fcn,n,x,fvec,fjac,ldfjac,iflag,ml,mu,epsfcn,
!                         wa1,wa2)
!
!     where
!
!       fcn is the name of the user-supplied subroutine which
!         calculates the functions. fcn must be declared
!         in an external statement in the user calling
!         program, and should be written as follows.
!
!         subroutine fcn(n,x,fvec,iflag)
!         integer n,iflag
!         real x(n),fvec(n)
!         ----------
!         calculate the functions at x and
!         return this vector in fvec.
!         ----------
!         return
!         end
!
!         the value of iflag should not be changed by fcn unless
!         the user wants to terminate execution of fdjac1.
!         in this case set iflag to a negative integer.
!
!       n is a positive integer input variable set to the number
!         of functions and variables.
!
!       x is an input array of length n.
!
!       fvec is an input array of length n which must contain the
!         functions evaluated at x.
!
!       fjac is an output n by n array which contains the
!         approximation to the jacobian matrix evaluated at x.
!
!       ldfjac is a positive integer input variable not less than n
!         which specifies the leading real of the array fjac.
!
!       iflag is an integer variable which can be used to terminate
!         the execution of fdjac1. see description of fcn.
!
!       ml is a nonnegative integer input variable which specifies
!         the number of subdiagonals within the band of the
!         jacobian matrix. if the jacobian is not banded, set
!         ml to at least n - 1.
!
!       epsfcn is an input variable used in determining a suitable
!         step length for the forward-difference approximation. this
!         approximation assumes that the relative errors in the
!         functions are of the order of epsfcn. if epsfcn is less
!         than the machine precision, it is assumed that the relative
!         errors in the functions are of the order of the machine
!         precision.
!
!       mu is a nonnegative integer input variable which specifies
!         the number of superdiagonals within the band of the
!         jacobian matrix. if the jacobian is not banded, set
!         mu to at least n - 1.
!
!       wa1 and wa2 are work arrays of length n. if ml + mu + 1 is at
!         least n, then the jacobian is considered dense, and wa2 is
!         not referenced.
!
!     subprograms called
!
!       fortran-supplied ... abs,amax1,sqrt
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i,j,k,msum
  real(rq) :: eps,epsmch,h,temp

!     epsmch is the machine precision.

  epsmch = errt_rq ! d1mach(3)
  eps = sqrt(max(epsfcn,epsmch))
  msum = ml + mu + 1
  if (msum .lt. n) go to 40

!        computation of dense approximate jacobian.

  do j = 1, n
     temp = x(j)
     h = eps*abs(temp)
     if (h .eq. zero) h = eps
     x(j) = temp + h
     call fcn(n,x,wa1,iflag,nprint)
     if (iflag .lt. 0) go to 30
     x(j) = temp
     do i = 1, n
        fjac(i,j) = (wa1(i) - fvec(i))/h
     end do
  end do
30 continue
  go to 110
40 continue

!        computation of banded approximate jacobian.

  do k = 1, msum
     do j = k, n, msum
        wa2(j) = x(j)
        h = eps*abs(wa2(j))
        if (h .eq. zero) h = eps
        x(j) = wa2(j) + h
     end do
     call fcn(n,x,wa1,iflag,nprint)
     if (iflag .lt. 0) go to 100
     do j = k, n, msum
        x(j) = wa2(j)
        h = eps*abs(wa2(j))
        if (h .eq. zero) h = eps
        do i = 1, n
           fjac(i,j) = zero
           if (i .ge. j - mu .and. i .le. j + ml) &
                fjac(i,j) = (wa1(i) - fvec(i))/h
        end do
     end do
  end do

100 continue
110 continue

  return

!     last card of subroutine fdjac1.

end subroutine fdjac1

! fishpak15  from portlib                                  11/06/79

subroutine genbun(nperod,n,mperod,m,a,b,c,idimy,y,ierror,w)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: y(idimy,*)
  real(rq) :: w(*),b(*),a(*),c(*)

  ierror = 0

  if (m .le. 2) ierror = 1
  if (n .le. 2) ierror = 2
  if (idimy .lt. m) ierror = 3
  if (nperod.lt.0 .or. nperod.gt.4) ierror = 4
  if (mperod.lt.0 .or. mperod.gt.1) ierror = 5
  if (mperod .eq. 1) go to 102

  do i=2,m
     if (a(i) .ne. c(1)) go to 103
     if (c(i) .ne. c(1)) go to 103
     if (b(i) .ne. b(1)) go to 103
  end do

  go to 104

102 if (a(1).ne.0._rq .or. c(m).ne.0._rq) ierror = 7

  go to 104

103 ierror = 6

104 if (ierror .ne. 0) return

  mp1 = m+1
  iwba = mp1
  iwbb = iwba+m
  iwbc = iwbb+m
  iwb2 = iwbc+m
  iwb3 = iwb2+m
  iww1 = iwb3+m
  iww2 = iww1+m
  iww3 = iww2+m
  iwd = iww3+m
  iwtcos = iwd+m
  iwp = iwtcos+4*n

  do i=1,m
     k = iwba+i-1
     w(k) = -a(i)
     k = iwbc+i-1
     w(k) = -c(i)
     k = iwbb+i-1
     w(k) = 2._rq-b(i)
     do j=1,n
        y(i,j) = -y(i,j)
     end do
  end do

  mp = mperod+1
  np = nperod+1
  go to (114,107),mp

107 go to (108,109,110,111,123),np
108 call poisp2 (m,n,w(iwba),w(iwbb),w(iwbc),y,idimy,w,w(iwb2), &
         w(iwb3),w(iww1),w(iww2),w(iww3),w(iwd),w(iwtcos), w(iwp))
  go to 112
109 call poisd2 (m,n,1,w(iwba),w(iwbb),w(iwbc),y,idimy,w,w(iww1), &
         w(iwd),w(iwtcos),w(iwp))
  go to 112
110 call poisn2 (m,n,1,2,w(iwba),w(iwbb),w(iwbc),y,idimy,w,w(iwb2), &
         w(iwb3),w(iww1),w(iww2),w(iww3),w(iwd),w(iwtcos), w(iwp))
  go to 112
111 call poisn2 (m,n,1,1,w(iwba),w(iwbb),w(iwbc),y,idimy,w,w(iwb2), &
         w(iwb3),w(iww1),w(iww2),w(iww3),w(iwd),w(iwtcos), w(iwp))
112 ipstor = w(iww1)
  irev = 2
  if (nperod .eq. 4) go to 124
113 go to (127,133),mp
114 continue

!     reorder unknowns when mp =0

  mh = (m+1)/2
  mhm1 = mh-1
  modd = 1
  if (mh*2 .eq. m) modd = 2
  do j=1,n
     do i=1,mhm1
        mhpi = mh+i
        mhmi = mh-i
        w(i) = y(mhmi,j)-y(mhpi,j)
        w(mhpi) = y(mhmi,j)+y(mhpi,j)
     end do
     w(mh) = 2._rq*y(mh,j)
     go to (117,116),modd
116  w(m) = 2._rq*y(m,j)
117  continue
     do i=1,m
        y(i,j) = w(i)
     end do
  end do
  k = iwbc+mhm1-1
  i = iwba+mhm1
  w(k) = 0._rq
  w(i) = 0._rq
  w(k+1) = 2._rq*w(k+1)
  go to (120,121),modd
120 continue
  k = iwbb+mhm1-1
  w(k) = w(k)-w(i-1)
  w(iwbc-1) = w(iwbc-1)+w(iwbb-1)
  go to 122
121 w(iwbb-1) = w(k+1)
122 continue
  go to 107

!     reverse columns when nperod = 4.

123 irev = 1
  nby2 = n/2
124 do j=1,nby2
     mskip = n+1-j
     do i=1,m
        a1 = y(i,j)
        y(i,j) = y(i,mskip)
        y(i,mskip) = a1
     end do
  end do
  go to (110,113),irev
127 continue
  do j=1,n
     do i=1,mhm1
        mhmi = mh-i
        mhpi = mh+i
        w(mhmi) = .5_rq*(y(mhpi,j)+y(i,j))
        w(mhpi) = .5_rq*(y(mhpi,j)-y(i,j))
     end do
     w(mh) = .5_rq*y(mh,j)
     go to (130,129),modd
129  w(m) = .5_rq*y(m,j)
130  continue
     do i=1,m
        y(i,j) = w(i)
     end do
  end do
133 continue

!     return storage requirements for w array.

  w(1) = ipstor+iwp-1

  return

end subroutine genbun

subroutine hybrd(fcn,n,x,fvec,xtol,maxfev,ml,mu,epsfcn,diag,mode,&
     factor,nprint,info,nfev,fjac,ldfjac,r,lr, qtf,wa1,wa2,wa3,wa4)

  use teq_mod, only : STdoUT,t_logunit
  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: n,maxfev,ml,mu,mode,nprint,info,nfev,ldfjac,lr
  real(rq) :: xtol,epsfcn,factor
  real(rq) :: x(n),fvec(n),diag(n),fjac(ldfjac,n),r(lr),qtf(n), &
       wa1(n),wa2(n),wa3(n),wa4(n)

  external fcn

!     **********
!
!     subroutine hybrd
!
!     the purpose of hybrd is to find a zero of a system of
!     n nonlinear functions in n variables by a modification
!     of the powell hybrid method. the user must provide a
!     subroutine which calculates the functions. the jacobian is
!     then calculated by a forward-difference approximation.
!
!     the subroutine statement is
!
!       subroutine hybrd(fcn,n,x,fvec,xtol,maxfev,ml,mu,epsfcn,
!                        diag,mode,factor,nprint,info,nfev,fjac,
!                        ldfjac,r,lr,qtf,wa1,wa2,wa3,wa4)
!
!     where
!
!       fcn is the name of the user-supplied subroutine which
!         calculates the functions. fcn must be declared
!         in an external statement in the user calling
!         program, and should be written as follows.
!
!         subroutine fcn(n,x,fvec,iflag)
!         integer n,iflag
!         real x(n),fvec(n)
!         ----------
!         calculate the functions at x and
!         return this vector in fvec.
!         ---------
!         return
!         end
!
!         the value of iflag should not be changed by fcn unless
!         the user wants to terminate execution of hybrd.
!         in this case set iflag to a negative integer.
!
!       n is a positive integer input variable set to the number
!         of functions and variables.
!
!       x is an array of length n. on input x must contain
!         an initial estimate of the solution vector. on output x
!         contains the final estimate of the solution vector.
!
!       fvec is an output array of length n which contains
!         the functions evaluated at the output x.
!
!       xtol is a nonnegative input variable. termination
!         occurs when the relative error between two consecutive
!         iterates is at most xtol.
!
!       maxfev is a positive integer input variable. termination
!         occurs when the number of calls to fcn is at least maxfev
!         by the end of an iteration.
!
!       ml is a nonnegative integer input variable which specifies
!         the number of subdiagonals within the band of the
!         jacobian matrix. if the jacobian is not banded, set
!         ml to at least n - 1.
!
!       mu is a nonnegative integer input variable which specifies
!         the number of superdiagonals within the band of the
!         jacobian matrix. if the jacobian is not banded, set
!         mu to at least n - 1.
!
!       epsfcn is an input variable used in determining a suitable
!         step length for the forward-difference approximation. this
!         approximation assumes that the relative errors in the
!         functions are of the order of epsfcn. if epsfcn is less
!         than the machine precision, it is assumed that the relative
!         errors in the functions are of the order of the machine
!         precision.
!
!       diag is an array of length n. if mode = 1 (see
!         below), diag is internally set. if mode = 2, diag
!         must contain positive entries that serve as
!         multiplicative scale factors for the variables.
!
!       mode is an integer input variable. if mode = 1, the
!         variables will be scaled internally. if mode = 2,
!         the scaling is specified by the input diag. other
!         values of mode are equivalent to mode = 1.
!
!       factor is a positive input variable used in determining the
!         initial step bound. this bound is set to the product of
!         factor and the euclidean norm of diag*x if nonzero, or else
!         to factor itself. in most cases factor should lie in the
!         interval (.1,100.). 100. is a generally recommended value.
!
!       nprint is an integer input variable that enables controlled
!         printing of iterates if it is positive. in this case,
!         fcn is called with iflag = 0 at the beginning of the first
!         iteration and every nprint iterations thereafter and
!         immediately prior to return, with x and fvec available
!         for printing. if nprint is not positive, no special calls
!         of fcn with iflag = 0 are made.
!
!       info is an integer output variable. if the user has
!         terminated execution, info is set to the (negative)
!         value of iflag. see description of fcn. otherwise,
!         info is set as follows.
!
!         info = 0   improper input parameters.
!
!         info = 1   relative error between two consecutive iterates
!                    is at most xtol.
!
!         info = 2   number of calls to fcn has reached or exceeded
!                    maxfev.
!
!         info = 3   xtol is too small. no further improvement in
!                    the approximate solution x is possible.
!
!         info = 4   iteration is not making good progress, as
!                    measured by the improvement from the last
!                    five jacobian evaluations.
!
!         info = 5   iteration is not making good progress, as
!                    measured by the improvement from the last
!                    ten iterations.
!
!       nfev is an integer output variable set to the number of
!         calls to fcn.
!
!       fjac is an output n by n array which contains the
!         orthogonal matrix q produced by the qr factorization
!         of the final approximate jacobian.
!
!       ldfjac is a positive integer input variable not less than n
!         which specifies the leading real of the array fjac.
!
!       r is an output array of length lr which contains the
!         upper triangular matrix produced by the qr factorization
!         of the final approximate jacobian, stored rowwise.
!
!       lr is a positive integer input variable not less than
!         (n*(n+1))/2.
!
!       qtf is an output array of length n which contains
!         the vector (q transpose)*fvec.
!
!       wa1, wa2, wa3, and wa4 are work arrays of length n.
!
!     subprograms called
!
!       user-supplied ...... fcn
!
!       minpack-supplied ... dogleg,enorm,fdjac1,
!                            qform,qrfac,r1mpyq,r1updt
!
!       fortran-supplied ... abs,amax1,amin1,min0,mod
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i,iflag,iter,j,jm1,l,msum,ncfail,ncsuc,nslow1,nslow2
  integer :: iwa(1)
  logical :: jeval,sing_dummy
  real(rq) :: actred,delta,epsmch,fnorm,fnorm1,pnorm,prered,p1,p5, &
       p001,p0001,ratio,sum,temp,xnorm
  data p1,p5,p001,p0001/1.0d-1,5.0d-1,1.0d-3,1.0d-4/

!     epsmch is the machine precision.

  epsmch = errt_rq ! d1mach(3)

  info = 0
  iflag = 0
  nfev = 0

!     check the input parameters for errors.

  if (n .le. 0 .or. xtol .lt. zero .or. maxfev .le. 0 .or. ml .lt. 0 .or. &
       mu .lt. 0 .or. factor .le. zero .or. ldfjac .lt. n .or. &
       lr .lt. (n*(n + 1))/2) go to 300
  if (mode .ne. 2) go to 20
  do j = 1, n
     if (diag(j) .le. zero) go to 300
  end do

20 continue

!     evaluate the function at the starting point
!     and calculate its norm.

  iflag = 1
  call fcn(n,x,fvec,iflag,nprint)
  nfev = 1
  if (iflag .lt. 0) go to 300
  fnorm = enorm(n,fvec)

!     determine the number of calls to fcn needed to compute
!     the jacobian matrix.

  msum = min(ml+mu+1,n)

!     initialize iteration counter and monitors.

  iter = 1
  ncsuc = 0
  ncfail = 0
  nslow1 = 0
  nslow2 = 0

!     beginning of the outer loop.

30 continue

  jeval = .true.

!        calculate the jacobian matrix.

  iflag = 2
  call fdjac1(fcn,n,x,fvec,fjac,ldfjac,iflag,ml,mu,epsfcn,wa1,wa2,nprint)
  nfev = nfev + msum
  if (iflag .lt. 0) go to 300

!        compute the qr factorization of the jacobian.

  call qrfac(n,n,fjac,ldfjac,.false.,iwa,1,wa1,wa2,wa3)

!        on the first iteration and if mode is 1, scale according
!        to the norms of the columns of the initial jacobian.

  if (iter .ne. 1) go to 70
  if (mode .eq. 2) go to 50
  do j = 1, n
     diag(j) = wa2(j)
     if (wa2(j) .eq. zero) diag(j) = one
  end do

50 continue

!        on the first iteration, calculate the norm of the scaled x
!        and initialize the step bound delta.

  do j = 1, n
     wa3(j) = diag(j)*x(j)
  end do

  xnorm = enorm(n,wa3)
  delta = factor*xnorm
  if (delta .eq. zero) delta = factor

   70 continue

!        form (q transpose)*fvec and store in qtf.

  do i = 1, n
     qtf(i) = fvec(i)
  end do

  do j = 1, n
     if (fjac(j,j) .eq. zero) go to 110
     sum = zero
     do i = j, n
        sum = sum + fjac(i,j)*qtf(i)
     end do
     temp = -sum/fjac(j,j)
     do i = j, n
        qtf(i) = qtf(i) + fjac(i,j)*temp
     end do
110  continue
  end do

!        copy the triangular factor of the qr factorization into r.

  sing_dummy = .false.

  do j = 1, n
     l = j
     jm1 = j - 1
     if (jm1 .lt. 1) go to 140
     do i = 1, jm1
        r(l) = fjac(i,j)
        l = l + n - i
     end do
140  continue
     r(l) = wa1(j)
     if (wa1(j) .eq. zero) sing_dummy = .true.
  end do

!        accumulate the orthogonal factor in fjac.

  call qform(n,n,fjac,ldfjac,wa1)

!        rescale if necessary.

  if (mode .eq. 2) go to 170
  do j = 1, n
     diag(j) = max(diag(j),wa2(j))
  end do

170 continue

!        beginning of the inner loop.

180 continue

!           if requested, call fcn to enable printing of iterates.

  if (nprint .le. 0) go to 190
  iflag = 0
  if (mod(iter-1,nprint) .eq. 0) call fcn(n,x,fvec,iflag,nprint)
  if (iflag .lt. 0) go to 300

190 continue

!           determine the direction p.

  call dogleg(n,r,lr,diag,qtf,delta,wa1,wa2,wa3)

!           store the direction p and x + p. calculate the norm of p.

  do j = 1, n
     wa1(j) = -wa1(j)
     wa2(j) = x(j) + wa1(j)
     wa3(j) = diag(j)*wa1(j)
  end do

  pnorm = enorm(n,wa3)

!           on the first iteration, adjust the initial step bound.

  if (iter .eq. 1) delta = min(delta,pnorm)

!           evaluate the function at x + p and calculate its norm.

  iflag = 1
  call fcn(n,wa2,wa4,iflag,nprint)
  nfev = nfev + 1
  if (iflag .lt. 0) go to 300
  fnorm1 = enorm(n,wa4)

!           compute the scaled actual reduction.

  actred = -one
  if (fnorm1 .lt. fnorm) actred = one - (fnorm1/fnorm)**2

!           compute the scaled predicted reduction.

  l = 1

  do i = 1, n
     sum = zero
     do j = i, n
        sum = sum + r(l)*wa1(j)
        l = l + 1
     end do
     wa3(i) = qtf(i) + sum
  end do

  temp = enorm(n,wa3)
  prered = zero
  if (temp .lt. fnorm) prered = one - (temp/fnorm)**2

!           compute the ratio of the actual to the predicted
!           reduction.

  ratio = zero
  if (prered .gt. zero) ratio = actred/prered

!           update the step bound.

  if (ratio .ge. p1) go to 230
  ncsuc = 0
  ncfail = ncfail + 1
  delta = p5*delta
  go to 240
230 continue
  ncfail = 0
  ncsuc = ncsuc + 1
  if (ratio .ge. p5 .or. ncsuc .gt. 1) delta = max(delta,pnorm/p5)
  if (abs(ratio-one) .le. p1) delta = pnorm/p5
240 continue

!           test for successful iteration.

  if (ratio .lt. p0001) go to 260

!           successful iteration. update x, fvec, and their norms.

  do j = 1, n
     x(j) = wa2(j)
     wa2(j) = diag(j)*x(j)
     fvec(j) = wa4(j)
  end do

  xnorm = enorm(n,wa2)
  fnorm = fnorm1
  iter = iter + 1

260 continue

!           determine the progress of the iteration.

  nslow1 = nslow1 + 1
  if (actred .ge. p001) nslow1 = 0
  if (jeval) nslow2 = nslow2 + 1
  if (actred .ge. p1) nslow2 = 0

!           test for convergence.

  if (delta .le. xtol*xnorm .or. fnorm .le. xtol) info = 1

  if (nprint.ne.0) then

     write(STdoUT,10000) (wa1(i)/x(i)-1,i=1,n)
     if (t_logunit .ge. 0) then
        write(t_logunit,10000) (wa1(i)/x(i)-1,i=1,n)
     endif

     write(STdoUT,10001) (fvec(i),i=1,n)
     if (t_logunit .ge. 0) then
        write(t_logunit,10001) (fvec(i),i=1,n)
     endif

10000 format('X  =',6(1pg12.4))
10001 format('F  = ',6(1pg12.4))
  endif

  if (info .ne. 0) go to 300

!           tests for termination and stringent tolerances.

  if (nfev .ge. maxfev) info = 2
  if (p1*max(p1*delta,pnorm) .le. epsmch*xnorm) info = 3
  if (nslow2 .eq. 5) info = 4
  if (nslow1 .eq. 10) info = 5
  if (info .ne. 0) go to 300

!           criterion for recalculating jacobian approximation
!           by forward differences.

  if (ncfail .eq. 2) go to 290

!           calculate the rank one modification to the jacobian
!           and update qtf if necessary.

  do j = 1, n
     sum = zero
     do i = 1, n
        sum = sum + fjac(i,j)*wa4(i)
     end do
     wa2(j) = (sum - wa3(j))/pnorm
     wa1(j) = diag(j)*((diag(j)*wa1(j))/pnorm)
     if (ratio .ge. p0001) qtf(j) = sum
  end do

!           compute the qr factorization of the updated jacobian.

  call r1updt(n,n,r,lr,wa1,wa2,wa3,sing_dummy)
  call r1mpyq(n,n,fjac,ldfjac,wa2,wa3)
  call r1mpyq(1,n,qtf,1,wa2,wa3)

!           end of the inner loop.

  jeval = .false.
  go to 180

290 continue

!        end of the outer loop.

  go to 30

300 continue

!     termination, either normal or user imposed.

  if (iflag .lt. 0) info = iflag
  iflag = 0
  if (nprint .gt. 0) call fcn(n,x,fvec,iflag,nprint)

  return

!     last card of subroutine hybrd.

end subroutine hybrd

subroutine hybrd2(fcn,n,x,fvec,tol,info,wa,lwa)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: n,info,lwa
  real(rq) :: tol
  real(rq) :: x(n),fvec(n),wa(lwa)

  external fcn

!     **********
!
!     subroutine hybrd2
!
!     the purpose of hybrd1 is to find a zero of a system of
!     n nonlinear functions in n variables by a modification
!     of the powell hybrid method. this is done by using the
!     more general nonlinear equation solver hybrd. the user
!     must provide a subroutine which calculates the functions.
!     the jacobian is then calculated by a forward-difference
!     approximation.
!
!     the subroutine statement is
!
!       subroutine hybrd1(fcn,n,x,fvec,tol,info,wa,lwa)
!
!     where
!
!       fcn is the name of the user-supplied subroutine which
!         calculates the functions. fcn must be declared
!         in an external statement in the user calling
!         program, and should be written as follows.
!
!         subroutine fcn(n,x,fvec,iflag)
!         integer n,iflag
!         real x(n),fvec(n)
!         ----------
!         calculate the functions at x and
!         return this vector in fvec.
!         ---------
!         return
!         end
!
!         the value of iflag should not be changed by fcn unless
!         the user wants to terminate execution of hybrd1.
!         in this case set iflag to a negative integer.
!
!       n is a positive integer input variable set to the number
!         of functions and variables.
!
!       x is an array of length n. on input x must contain
!         an initial estimate of the solution vector. on output x
!         contains the final estimate of the solution vector.
!
!       fvec is an output array of length n which contains
!         the functions evaluated at the output x.
!
!       tol is a nonnegative input variable. termination occurs
!         when the algorithm estimates that the relative error
!         between x and the solution is at most tol.
!
!       info is an integer output variable. if the user has
!         terminated execution, info is set to the (negative)
!         value of iflag. see description of fcn. otherwise,
!         info is set as follows.
!
!         info = 0   improper input parameters.
!
!         info = 1   algorithm estimates that the relative error
!                    between x and the solution is at most tol.
!
!         info = 2   number of calls to fcn has reached or exceeded
!                    200*(n+1).
!
!         info = 3   tol is too small. no further improvement in
!                    the approximate solution x is possible.
!
!         info = 4   iteration is not making good progress.
!
!       wa is a work array of length lwa.
!
!       lwa is a positive integer input variable not less than
!         (n*(3*n+13))/2.
!
!     subprograms called
!
!       user-supplied ...... fcn
!
!       minpack-supplied ... hybrd
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: index,j,lr,maxfev,ml,mode,mu,nfev,nprint
  real(rq) :: epsfcn,factor,xtol
!     data factor /1.0e2/
  data factor /0.1_rq/

  info = 0

!     check the input parameters for errors.

  if (n .le. 0 .or. tol .lt. zero .or. lwa .lt. (n*(3*n + 13))/2) go to 20

!     call hybrd.

  maxfev = 200*(n + 1)
  xtol = tol
  ml = n - 1
  mu = n - 1
!     set epsfcn to 1.e-4 for HEQ problem
!     epsfcn = zero
  epsfcn = 1.d-4
  mode = 2

  do j = 1, n
     wa(j) = one
  end do

  nprint = 0
  lr = (n*(n + 1))/2
  index = 6*n + lr

  call hybrd(fcn,n,x,fvec,xtol,maxfev,ml,mu,epsfcn,wa(1),mode, &
       factor,nprint,info,nfev,wa(index+1),n,wa(6*n+1),lr, wa(n+1), &
       wa(2*n+1),wa(3*n+1),wa(4*n+1),wa(5*n+1))

  if (info .eq. 5) info = 4

20 continue

  return

!     last card of subroutine hybrd1.

end subroutine hybrd2

subroutine merge (tcos,i1,m1,i2,m2,i3)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: tcos(*)

!     this subroutine merges two ascending strings of numbers in the
!     array tcos.  the first string is of length m1 and starts at
!     tcos(i1+1).  the second string is of length m2 and starts at
!     tcos(i2+1).  the merged string goes into tcos(i3+1).

  j1 = 1
  j2 = 1
  j = i3
  if (m1 .eq. 0) go to 107
  if (m2 .eq. 0) go to 104
101 j = j+1
  l = j1+i1
  x = tcos(l)
  l = j2+i2
  y = tcos(l)
  if (x-y) 102,102,103
102 tcos(j) = x
  j1 = j1+1
  if (j1 .gt. m1) go to 106
  go to 101
  103 tcos(j) = y
  j2 = j2+1
  if (j2 .le. m2) go to 101
  if (j1 .gt. m1) go to 109
104 k = j-j1+1
  do j=j1,m1
     m = k+j
     l = j+i1
     tcos(m) = tcos(l)
  end do
  go to 109
106 continue
  if (j2 .gt. m2) go to 109
107 k = j-j2+1
  do j=j2,m2
     m = k+j
     l = j+i2
     tcos(m) = tcos(l)
  end do
109 continue

  return

end subroutine merge

subroutine minsol(usol,idmn,zn,zm,pertrb)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this subroutine orthogonalizes the array usol with respect to
!     the constant array in a weighted least squares norm

  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is,ms,js,ns,dlx,dly, &
       tdlx3,tdly3,dlx4,dly4

  real(rq) :: usol(idmn,*),zn(*),zm(*),pertrb

!     entry at minsol occurrs when the final solution is
!     to be minimized with respect to the weighted
!     least squares norm

  istr = 1
  ifnl = k
  jstr = 1
  jfnl = l

!     compute weighted inner products

  ute = 0.0_rq
  ete = 0.0_rq
  do i=is,ms
     ii = i-is+1
     do j=js,ns
        jj = j-js+1
        ete = ete+zm(ii)*zn(jj)
        ute = ute+usol(i,j)*zm(ii)*zn(jj)
     end do
  end do

!     set perturbation parameter

  pertrb = ute/ete

!     subtract off constant pertrb

  do i=istr,ifnl
     do j=jstr,jfnl
        usol(i,j) = usol(i,j)-pertrb
     end do
  end do

  return

end subroutine minsol

subroutine orthog(usol,idmn,zn,zm,pertrb)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this subroutine orthogonalizes the array usol with respect to
!     the constant array in a weighted least squares norm

  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is,ms,js,ns,dlx,dly, &
       tdlx3,tdly3,dlx4,dly4

  real(rq) :: usol(idmn,*),zn(*),zm(*),pertrb

  istr = is
  ifnl = ms
  jstr = js
  jfnl = ns

!     compute weighted inner products

  ute = 0.0_rq
  ete = 0.0_rq
  do i=is,ms
     ii = i-is+1
     do j=js,ns
        jj = j-js+1
        ete = ete+zm(ii)*zn(jj)
        ute = ute+usol(i,j)*zm(ii)*zn(jj)
     end do
  end do

!     set perturbation parameter

  pertrb = ute/ete

!     subtract off constant pertrb

  do i=istr,ifnl
     do j=jstr,jfnl
        usol(i,j) = usol(i,j)-pertrb
     end do
  end do

  return

end subroutine orthog

subroutine poisd2(mr,nr,istag,ba,bb,bc,q,idimq,b,w,d,tcos,p)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     subroutine to solve poisson"s equation for dirichlet boundary
!     conditions.
!
!     istag = 1 if the last diagonal block is the matrix a.
!     istag = 2 if the last diagonal block is the matrix a+i.

  real(rq) :: q(idimq,*),ba(*),bb(*),bc(*),tcos(*),b(*),d(*),w(*),p(*)

  m = mr
  n = nr
  jsh = 0
  fi = 1._rq/(istag)
  ip = -m
  ipstor = 0
  go to (101,102),istag
101 kr = 0
  irreg = 1
  if (n .gt. 1) go to 106
  tcos(1) = 0._rq
  go to 103
102 kr = 1
  jstsav = 1
  irreg = 2
  if (n .gt. 1) go to 106
  tcos(1) = -1._rq
103 do i=1,m
     b(i) = q(i,1)
  end do
  call trix(1,0,m,ba,bb,bc,b,tcos,d,w)
  do i=1,m
     q(i,1) = b(i)
  end do
  go to 183
106 lr = 0
  do i=1,m
     p(i) = 0._rq
  end do

  nun = n
  jst = 1
  jsp = n

!     irreg = 1 when no irregularities have occurred, otherwise it is 2.

108 l = 2*jst
  nodd = 2-2*((nun+1)/2)+nun

!     nodd = 1 when nun is odd, otherwise it is 2.

  go to (110,109),nodd
109 jsp = jsp-l
  go to 111
110 jsp = jsp-jst
  if (irreg .ne. 1) jsp = jsp-l

111 continue

!     regular reduction

  call cosgen(jst,1,0.5_rq,0.0_rq,tcos)

  if (l .gt. jsp) go to 118

  do j=l,jsp,l
     jm1 = j-jsh
     jp1 = j+jsh
     jm2 = j-jst
     jp2 = j+jst
     jm3 = jm2-jsh
     jp3 = jp2+jsh
     if (jst .ne. 1) go to 113
     do i=1,m
        b(i) = 2._rq*q(i,j)
        q(i,j) = q(i,jm2)+q(i,jp2)
     end do
     go to 115
113  do i=1,m
        t = q(i,j)-q(i,jm1)-q(i,jp1)+q(i,jm2)+q(i,jp2)
        b(i) = t+q(i,j)-q(i,jm3)-q(i,jp3)
        q(i,j) = t
     end do
115  continue
     call trix(jst,0,m,ba,bb,bc,b,tcos,d,w)
     do i=1,m
        q(i,j) = q(i,j)+b(i)
     end do
  end do

!     reduction for last unknown

118 go to (119,136),nodd
119 go to (152,120),irreg

!     odd number of unknowns

120 jsp = jsp+l
  j = jsp
  jm1 = j-jsh
  jp1 = j+jsh
  jm2 = j-jst
  jp2 = j+jst
  jm3 = jm2-jsh
  go to (123,121),istag
121 continue
  if (jst .ne. 1) go to 123
  do i=1,m
     b(i) = q(i,j)
     q(i,j) = 0._rq
  end do
  go to 130
123 go to (124,126),noddpr
124 do i=1,m
     ip1 = ip+i
     b(i) = .5_rq*(q(i,jm2)-q(i,jm1)-q(i,jm3))+p(ip1)+q(i,j)
  end do
  go to 128
126 do i=1,m
     b(i) = .5_rq*(q(i,jm2)-q(i,jm1)-q(i,jm3))+q(i,jp2)-q(i,jp1)+q(i,j)
  end do
128 do i=1,m
     q(i,j) = .5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))
  end do
130 call trix(jst,0,m,ba,bb,bc,b,tcos,d,w)
  ip = ip+m
  ipstor = max(ipstor,ip+m)
  do i=1,m
     ip1 = ip+i
     p(ip1) = q(i,j)+b(i)
     b(i) = q(i,jp2)+p(ip1)
  end do
  if (lr .ne. 0) go to 133
  do i=1,jst
     krpi = kr+i
     tcos(krpi) = tcos(i)
  end do
  go to 134
133 continue
  call cosgen(lr,jstsav,0._rq,fi,tcos(jst+1))
  call merge(tcos,0,jst,jst,lr,kr)
134 continue
  call cosgen(kr,jstsav,0.0_rq,fi,tcos)
  call trix(kr,kr,m,ba,bb,bc,b,tcos,d,w)
  do i=1,m
     ip1 = ip+i
     q(i,j) = q(i,jm2)+b(i)+p(ip1)
  end do
  lr = kr
  kr = kr+l
  go to 152

!     even number of unknowns

136 jsp = jsp+l
  j = jsp
  jm1 = j-jsh
  jp1 = j+jsh
  jm2 = j-jst
  jp2 = j+jst
  jm3 = jm2-jsh
  go to (137,138),irreg
137 continue
  jstsav = jst
  ideg = jst
  kr = l
  go to 139
138 call cosgen(kr,jstsav,0.0_rq,fi,tcos)
  call cosgen(lr,jstsav,0.0_rq,fi,tcos(kr+1))
  ideg = kr
  kr = kr+jst
139 if (jst .ne. 1) go to 141
  irreg = 2
  do i=1,m
     b(i) = q(i,j)
     q(i,j) = q(i,jm2)
  end do
  go to 150
141 do i=1,m
     b(i) = q(i,j)+.5_rq*(q(i,jm2)-q(i,jm1)-q(i,jm3))
  end do
  go to (143,145),irreg
143 do i=1,m
     q(i,j) = q(i,jm2)+.5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))
  end do
  irreg = 2
  go to 150
145 continue
  go to (146,148),noddpr
146 do i=1,m
     ip1 = ip+i
     q(i,j) = q(i,jm2)+p(ip1)
  end do
  ip = ip-m
  go to 150
148 do i=1,m
     q(i,j) = q(i,jm2)+q(i,j)-q(i,jm1)
  end do
150 call trix (ideg,lr,m,ba,bb,bc,b,tcos,d,w)
  do i=1,m
     q(i,j) = q(i,j)+b(i)
  end do
152 nun = nun/2
  noddpr = nodd
  jsh = jst
  jst = 2*jst
  if (nun .ge. 2) go to 108

!     start solution.

  j = jsp
  do i=1,m
     b(i) = q(i,j)
  end do
  go to (154,155),irreg
154 continue
  call cosgen(jst,1,0.5_rq,0.0_rq,tcos)
  ideg = jst
  go to 156
155 kr = lr+jst
  call cosgen(kr,jstsav,0.0_rq,fi,tcos)
  call cosgen(lr,jstsav,0.0_rq,fi,tcos(kr+1))
  ideg = kr
156 continue
  call trix(ideg,lr,m,ba,bb,bc,b,tcos,d,w)
  jm1 = j-jsh
  jp1 = j+jsh
  go to (157,159),irreg
157 do i=1,m
     q(i,j) = .5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))+b(i)
  end do
  go to 164
159 go to (160,162),noddpr
160 do i=1,m
     ip1 = ip+i
     q(i,j) = p(ip1)+b(i)
  end do
  ip = ip-m
  go to 164
162 do i=1,m
     q(i,j) = q(i,j)-q(i,jm1)+b(i)
  end do
164 continue

!     start back substitution.

  jst = jst/2
  jsh = jst/2
  nun = 2*nun
  if (nun .gt. n) go to 183
!  do 182 j=jst,n,l
  do j=jst,n,l
     jm1 = j-jsh
     jp1 = j+jsh
     jm2 = j-jst
     jp2 = j+jst
     if (j .gt. jst) go to 166
     do i=1,m
        b(i) = q(i,j)+q(i,jp2)
     end do
     go to 170
166  if (jp2 .le. n) go to 168
     do i=1,m
        b(i) = q(i,j)+q(i,jm2)
     end do
     if (jst .lt. jstsav) irreg = 1
     go to (170,171),irreg
168  do i=1,m
        b(i) = q(i,j)+q(i,jm2)+q(i,jp2)
     end do
170  continue
     call cosgen(jst,1,0.5_rq,0.0_rq,tcos)
     ideg = jst
     jdeg = 0
     go to 172
171  if (j+l .gt. n) lr = lr-jst
     kr = jst+lr
     call cosgen(kr,jstsav,0.0_rq,fi,tcos)
     call cosgen(lr,jstsav,0.0_rq,fi,tcos(kr+1))
     ideg = kr
     jdeg = lr
172  continue
     call trix(ideg,jdeg,m,ba,bb,bc,b,tcos,d,w)
     if (jst .gt. 1) go to 174
     do i=1,m
        q(i,j) = b(i)
     end do
     go to 182
174  if (jp2 .gt. n) go to 177
175  do i=1,m
        q(i,j) = .5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))+b(i)
     end do
     go to 182
177  go to (175,178),irreg
178  if (j+jsh .gt. n) go to 180
     do i=1,m
        ip1 = ip+i
        q(i,j) = b(i)+p(ip1)
     end do
     ip = ip-m
     go to 182
180  do i=1,m
        q(i,j) = b(i)+q(i,j)-q(i,jm1)
     end do
! I had flipped the two lines below! JAC 05/14/05
182  continue
  end do
  l = l/2
  go to 164
183 continue

!     return storage requirements for p vectors.

  w(1) = ipstor

  return

end subroutine poisd2

subroutine poisn2(m,n,istag,mixbnd,a,bb,c,q,idimq,b,b2,b3,w,w2,w3,d,tcos,p)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     subroutine to solve poisson's equation with neumann boundary
!     conditions.
!
!     istag = 1 if the last diagonal block is a.
!     istag = 2 if the last diagonal block is a-i.
!     mixbnd = 1 if have neumann boundary conditions at both boundaries.
!     mixbnd = 2 if have neumann boundary conditions at bottom and
!     dirichlet condition at top.  (for this case, must have istag = 1.)

  real(rq) :: a(*),bb(*),c(*),q(idimq,*),b(*),b2(*),b3(*),w(*),w2(*),w3(*), &
       d(*),tcos(*),k(4),p(*)

  equivalence (k(1),k1),(k(2),k2),(k(3),k3),(k(4),k4)

  fistag = 3-istag
  fnum = 1._rq/(istag)
  fden = 0.5_rq*(istag-1)
  mr = m
  ip = -mr
  ipstor = 0
  i2r = 1
  jr = 2
  nr = n
  nlast = n
  kr = 1
  lr = 0
  go to (101,103),istag
101 continue
  do i=1,mr
     q(i,n) = .5_rq*q(i,n)
  end do
  go to (103,104),mixbnd
103 if (n .le. 3) go to 155
104 continue
  jr = 2*i2r
  nrod = 1
  if ((nr/2)*2 .eq. nr) nrod = 0
  go to (105,106),mixbnd
105 jstart = 1
  go to 107
106 jstart = jr
  nrod = 1-nrod
107 continue
  jstop = nlast-jr
  if (nrod .eq. 0) jstop = jstop-i2r
  call cosgen(i2r,1,0.5_rq,0.0_rq,tcos)
  i2rby2 = i2r/2
  if (jstop .ge. jstart) go to 108
  j = jr
  go to 116
108 continue

!     regular reduction.

  do j=jstart,jstop,jr
     jp1 = j+i2rby2
     jp2 = j+i2r
     jp3 = jp2+i2rby2
     jm1 = j-i2rby2
     jm2 = j-i2r
     jm3 = jm2-i2rby2
     if (j .ne. 1) go to 109
     jm1 = jp1
     jm2 = jp2
     jm3 = jp3
109  continue
     if (i2r .ne. 1) go to 111
     if (j .eq. 1) jm2 = jp2
     do i=1,mr
        b(i) = 2._rq*q(i,j)
        q(i,j) = q(i,jm2)+q(i,jp2)
     end do
     go to 113
111  continue
     do i=1,mr
        fi = q(i,j)
        q(i,j) = q(i,j)-q(i,jm1)-q(i,jp1)+q(i,jm2)+q(i,jp2)
        b(i) = fi+q(i,j)-q(i,jm3)-q(i,jp3)
     end do
113  continue
     call trix(i2r,0,mr,a,bb,c,b,tcos,d,w)
     do i=1,mr
        q(i,j) = q(i,j)+b(i)
     end do

!     end of reduction for regular unknowns.

  end do

!     begin special reduction for last unknown.

  j = jstop+jr
116 nlast = j
  jm1 = j-i2rby2
  jm2 = j-i2r
  jm3 = jm2-i2rby2
  if (nrod .eq. 0) go to 128

!     odd number of unknowns

  if (i2r .ne. 1) go to 118
  do i=1,mr
     b(i) = fistag*q(i,j)
     q(i,j) = q(i,jm2)
  end do
  go to 126
118 do i=1,mr
     b(i) = q(i,j)+.5_rq*(q(i,jm2)-q(i,jm1)-q(i,jm3))
  end do
  if (nrodpr .ne. 0) go to 121
  do i=1,mr
     ii = ip+i
     q(i,j) = q(i,jm2)+p(ii)
  end do
  ip = ip-mr
  go to 123
121 continue
  do i=1,mr
     q(i,j) = q(i,j)-q(i,jm1)+q(i,jm2)
  end do
123 if (lr .eq. 0) go to 124
  call cosgen(lr,1,0.5_rq,fden,tcos(kr+1))
  go to 126
124 continue
  do i=1,mr
     b(i) = fistag*b(i)
  end do
126 continue
  call cosgen(kr,1,0.5_rq,fden,tcos)
  call trix(kr,lr,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,j) = q(i,j)+b(i)
  end do
  kr = kr+i2r
  go to 151
128 continue

!     even number of unknowns

  jp1 = j+i2rby2
  jp2 = j+i2r
  if (i2r .ne. 1) go to 135
  do i=1,mr
     b(i) = q(i,j)
  end do
  call trix(1,0,mr,a,bb,c,b,tcos,d,w)
  ip = 0
  ipstor = mr
  go to (133,130),istag
130 do i=1,mr
     p(i) = b(i)
     b(i) = b(i)+q(i,n)
  end do
  tcos(1) = 1._rq
  tcos(2) = 0._rq
  call trix(1,1,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,j) = q(i,jm2)+p(i)+b(i)
  end do
  go to 150
133 continue
  do i=1,mr
     p(i) = b(i)
     q(i,j) = q(i,jm2)+2._rq*q(i,jp2)+3._rq*b(i)
  end do
  go to 150
135 continue
  do i=1,mr
     b(i) = q(i,j)+.5_rq*(q(i,jm2)-q(i,jm1)-q(i,jm3))
  end do
  if (nrodpr .ne. 0) go to 138
  do i=1,mr
     ii = ip+i
     b(i) = b(i)+p(ii)
  end do
  go to 140
138 continue
  do i=1,mr
     b(i) = b(i)+q(i,jp2)-q(i,jp1)
  end do
140 continue
  call trix(i2r,0,mr,a,bb,c,b,tcos,d,w)
  ip = ip+mr
  ipstor = max(ipstor,ip+mr)
  do i=1,mr
     ii = ip+i
     p(ii) = b(i)+.5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))
     b(i) = p(ii)+q(i,jp2)
  end do
  if (lr .eq. 0) go to 142
  call cosgen(lr,1,0.5_rq,fden,tcos(i2r+1))
  call merge(tcos,0,i2r,i2r,lr,kr)
  go to 144
142 do i=1,i2r
     ii = kr+i
     tcos(ii) = tcos(i)
  end do
144 call cosgen(kr,1,0.5_rq,fden,tcos)
  if (lr .ne. 0) go to 145
  go to (146,145),istag
145 continue
  call trix(kr,kr,mr,a,bb,c,b,tcos,d,w)
  go to 148
146 continue
  do i=1,mr
     b(i) = fistag*b(i)
  end do
148 continue
  do i=1,mr
     ii = ip+i
     q(i,j) = q(i,jm2)+p(ii)+b(i)
  end do
150 continue
  lr = kr
  kr = kr+jr
151 continue
  go to (152,153),mixbnd
152 nr = (nlast-1)/jr+1
  if (nr .le. 3) go to 155
  go to 154
153 nr = nlast/jr
  if (nr .le. 1) go to 192
154 i2r = jr
  nrodpr = nrod
  go to 104
155 continue

!      begin solution

  j = 1+jr
  jm1 = j-i2r
  jp1 = j+i2r
  jm2 = nlast-i2r
  if (nr .eq. 2) go to 184
  if (lr .ne. 0) go to 170
  if (n .ne. 3) go to 161

!     case n = 3.

  go to (156,168),istag
156 continue
  do i=1,mr
     b(i) = q(i,2)
  end do
  tcos(1) = 0._rq
  call trix(1,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,2) = b(i)
     b(i) = 4._rq*b(i)+q(i,1)+2._rq*q(i,3)
  end do
  tcos(1) = -2._rq
  tcos(2) = 2._rq
  i1 = 2
  i2 = 0
  call trix(i1,i2,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,2) = q(i,2)+b(i)
     b(i) = q(i,1)+2._rq*q(i,2)
  end do
  tcos(1) = 0._rq
  call trix(1,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,1) = b(i)
  end do
  jr = 1
  i2r = 0
  go to 194

!     case n = 2**p+1

161 continue
  go to (162,170),istag
162 continue
  do i=1,mr
     b(i) = q(i,j)+.5_rq*q(i,1)-q(i,jm1)+q(i,nlast)-q(i,jm2)
  end do
  call cosgen(jr,1,0.5_rq,0.0_rq,tcos)
  call trix(jr,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,j) = .5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))+b(i)
     b(i) = q(i,1)+2._rq*q(i,nlast)+4._rq*q(i,j)
  end do
  jr2 = 2*jr
  call cosgen(jr,1,0.0_rq,0.0_rq,tcos)
  do i=1,jr
     i1 = jr+i
     i2 = jr+1-i
     tcos(i1) = -tcos(i2)
  end do
  call trix(jr2,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,j) = q(i,j)+b(i)
     b(i) = q(i,1)+2._rq*q(i,j)
  end do
  call cosgen(jr,1,0.5_rq,0.0_rq,tcos)
  call trix(jr,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,1) = .5_rq*q(i,1)-q(i,jm1)+b(i)
  end do
  go to 194

!     case of general n with nr = 3 .

168 do i=1,mr
     b(i) = q(i,2)
     q(i,2) = 0._rq
     b2(i) = q(i,3)
     b3(i) = q(i,1)
  end do
  jr = 1
  i2r = 0
  j = 2
  go to 177
170 continue
  do i=1,mr
     b(i) = .5_rq*q(i,1)-q(i,jm1)+q(i,j)
  end do
  if (nrod .ne. 0) go to 173
  do i=1,mr
     ii = ip+i
     b(i) = b(i)+p(ii)
  end do
  go to 175
173 do i=1,mr
     b(i) = b(i)+q(i,nlast)-q(i,jm2)
  end do
175 continue
  do i=1,mr
     t = .5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))
     q(i,j) = t
     b2(i) = q(i,nlast)+t
     b3(i) = q(i,1)+2._rq*t
  end do
177 continue
  k1 = kr+2*jr-1
  k2 = kr+jr
  tcos(k1+1) = -2._rq
  k4 = k1+3-istag
  call cosgen(k2+istag-2,1,0.0_rq,fnum,tcos(k4))
  k4 = k1+k2+1
  call cosgen(jr-1,1,0.0_rq,1.0_rq,tcos(k4))
  call merge(tcos,k1,k2,k1+k2,jr-1,0)
  k3 = k1+k2+lr
  call cosgen(jr,1,0.5_rq,0.0_rq,tcos(k3+1))
  k4 = k3+jr+1
  call cosgen(kr,1,0.5_rq,fden,tcos(k4))
  call merge(tcos,k3,jr,k3+jr,kr,k1)
  if (lr .eq. 0) go to 178
  call cosgen(lr,1,0.5_rq,fden,tcos(k4))
  call merge(tcos,k3,jr,k3+jr,lr,k3-lr)
  call cosgen(kr,1,0.5_rq,fden,tcos(k4))
178 k3 = kr
  k4 = kr
  call tri3(mr,a,bb,c,k,b,b2,b3,tcos,d,w,w2,w3)
  do i=1,mr
     b(i) = b(i)+b2(i)+b3(i)
  end do
  tcos(1) = 2._rq
  call trix(1,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,j) = q(i,j)+b(i)
     b(i) = q(i,1)+2._rq*q(i,j)
  end do
  call cosgen(jr,1,0.5_rq,0.0_rq,tcos)
  call trix(jr,0,mr,a,bb,c,b,tcos,d,w)
  if (jr .ne. 1) go to 182
  do i=1,mr
     q(i,1) = b(i)
  end do
  go to 194
182 continue
  do i=1,mr
     q(i,1) = .5_rq*q(i,1)-q(i,jm1)+b(i)
  end do
  go to 194
184 continue
  if (n .ne. 2) go to 188

!     case  n = 2

  do i=1,mr
     b(i) = q(i,1)
  end do
  tcos(1) = 0._rq
  call trix(1,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,1) = b(i)
     b(i) = 2._rq*(q(i,2)+b(i))*fistag
  end do
  tcos(1) = -fistag
  tcos(2) = 2._rq
  call trix(2,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,1) = q(i,1)+b(i)
  end do
  jr = 1
  i2r = 0
  go to 194
188 continue

!     case of general n and nr = 2 .

  do i=1,mr
     ii = ip+i
     b3(i) = 0._rq
     b(i) = q(i,1)+2._rq*p(ii)
     q(i,1) = .5_rq*q(i,1)-q(i,jm1)
     b2(i) = 2._rq*(q(i,1)+q(i,nlast))
  end do
  k1 = kr+jr-1
  tcos(k1+1) = -2._rq
  k4 = k1+3-istag
  call cosgen(kr+istag-2,1,0.0_rq,fnum,tcos(k4))
  k4 = k1+kr+1
  call cosgen(jr-1,1,0.0_rq,1.0_rq,tcos(k4))
  call merge(tcos,k1,kr,k1+kr,jr-1,0)
  call cosgen(kr,1,0.5_rq,fden,tcos(k1+1))
  k2 = kr
  k4 = k1+k2+1
  call cosgen(lr,1,0.5_rq,fden,tcos(k4))
  k3 = lr
  k4 = 0
  call tri3(mr,a,bb,c,k,b,b2,b3,tcos,d,w,w2,w3)
  do i=1,mr
     b(i) = b(i)+b2(i)
  end do
  tcos(1) = 2._rq
  call trix(1,0,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,1) = q(i,1)+b(i)
  end do
  go to 194
192 do i=1,mr
     b(i) = q(i,nlast)
  end do
  go to 196
194 continue

!     start back substitution.

  j = nlast-jr
  do i=1,mr
     b(i) = q(i,nlast)+q(i,j)
  end do
196 jm2 = nlast-i2r
  if (jr .ne. 1) go to 198
  do i=1,mr
     q(i,nlast) = 0._rq
  end do
  go to 202
198 continue
  if (nrod .ne. 0) go to 200
  do i=1,mr
     ii = ip+i
     q(i,nlast) = p(ii)
  end do
  ip = ip-mr
  go to 202
200 do i=1,mr
     q(i,nlast) = q(i,nlast)-q(i,jm2)
  end do
202 continue
  call cosgen(kr,1,0.5_rq,fden,tcos)
  call cosgen(lr,1,0.5_rq,fden,tcos(kr+1))
  if (lr .ne. 0) go to 204
  do i=1,mr
     b(i) = fistag*b(i)
  end do
204 continue
  call trix(kr,lr,mr,a,bb,c,b,tcos,d,w)
  do i=1,mr
     q(i,nlast) = q(i,nlast)+b(i)
  end do
  nlastp = nlast
206 continue
  jstep = jr
  jr = i2r
  i2r = i2r/2
  if (jr .eq. 0) go to 222
  go to (207,208),mixbnd
207 jstart = 1+jr
  go to 209
208 jstart = jr
209 continue
  kr = kr-jr
  if (nlast+jr .gt. n) go to 210
  kr = kr-jr
  nlast = nlast+jr
  jstop = nlast-jstep
  go to 211
210 continue
  jstop = nlast-jr
211 continue
  lr = kr-jr
  call cosgen(jr,1,0.5_rq,0.0_rq,tcos)
  do j=jstart,jstop,jstep
     jm2 = j-jr
     jp2 = j+jr
     if (j .ne. jr) go to 213
     do i=1,mr
        b(i) = q(i,j)+q(i,jp2)
     end do
     go to 215
213  continue
     do i=1,mr
        b(i) = q(i,j)+q(i,jm2)+q(i,jp2)
     end do
215  continue
     if (jr .ne. 1) go to 217
     do i=1,mr
        q(i,j) = 0._rq
     end do
     go to 219
217  continue
     jm1 = j-i2r
     jp1 = j+i2r
     do i=1,mr
        q(i,j) = .5_rq*(q(i,j)-q(i,jm1)-q(i,jp1))
     end do
219  continue
     call trix(jr,0,mr,a,bb,c,b,tcos,d,w)
     do i=1,mr
        q(i,j) = q(i,j)+b(i)
     end do
  end do
  nrod = 1
  if (nlast+i2r .le. n) nrod = 0
  if (nlastp .ne. nlast) go to 194
  go to 206
222 continue

!     return storage requirements for p vectors.

  w(1) = ipstor

  return

end subroutine poisn2

subroutine poisp2(m,n,a,bb,c,q,idimq,b,b2,b3,w,w2,w3,d,tcos,p)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     subroutine to solve poisson equation with periodic boundary
!     conditions.

  real(rq) :: a(*),bb(*),c(*),q(idimq,*),b(*),b2(*),b3(*),w(*),w2(*),w3(*), &
       d(*),tcos(*),p(*)

  mr = m
  nr = (n+1)/2
  nrm1 = nr-1
  if (2*nr .ne. n) go to 107

!     even number of unknowns

  do j=1,nrm1
     nrmj = nr-j
     nrpj = nr+j
     do i=1,mr
        s = q(i,nrmj)-q(i,nrpj)
        t = q(i,nrmj)+q(i,nrpj)
        q(i,nrmj) = s
        q(i,nrpj) = t
     end do
  end do
  do i=1,mr
     q(i,nr) = 2._rq*q(i,nr)
     q(i,n) = 2._rq*q(i,n)
  end do
  call poisd2(mr,nrm1,1,a,bb,c,q,idimq,b,w,d,tcos,p)
  ipstor = w(1)
  call poisn2(mr,nr+1,1,1,a,bb,c,q(1,nr),idimq,b,b2,b3,w,w2,w3,d,tcos,p)
  ipstor = max(ipstor,int(w(1)))
  do j=1,nrm1
     nrmj = nr-j
     nrpj = nr+j
     do i=1,mr
        s = .5_rq*(q(i,nrpj)+q(i,nrmj))
        t = .5_rq*(q(i,nrpj)-q(i,nrmj))
        q(i,nrmj) = s
        q(i,nrpj) = t
     end do
  end do
  do i=1,mr
     q(i,nr) = .5_rq*q(i,nr)
     q(i,n) = .5_rq*q(i,n)
  end do
  go to 118

107 continue

!     odd  number of unknowns

  do j=1,nrm1
     nrpj = n+1-j
     do i=1,mr
        s = q(i,j)-q(i,nrpj)
        t = q(i,j)+q(i,nrpj)
        q(i,j) = s
        q(i,nrpj) = t
     end do
  end do
  do i=1,mr
     q(i,nr) = 2._rq*q(i,nr)
  end do
  lh = nrm1/2
  do j=1,lh
     nrmj = nr-j
     do i=1,mr
        s = q(i,j)
        q(i,j) = q(i,nrmj)
        q(i,nrmj) = s
     end do
  end do

  call poisd2(mr,nrm1,2,a,bb,c,q,idimq,b,w,d,tcos,p)
  ipstor = w(1)
  call poisn2(mr,nr,2,1,a,bb,c,q(1,nr),idimq,b,b2,b3,w,w2,w3,d,tcos,p)
  ipstor = max(ipstor,int(w(1)))
  do j=1,nrm1
     nrpj = nr+j
     do i=1,mr
        s = .5_rq*(q(i,nrpj)+q(i,j))
        t = .5_rq*(q(i,nrpj)-q(i,j))
        q(i,nrpj) = t
        q(i,j) = s
     end do
  end do
  do i=1,mr
     q(i,nr) = .5_rq*q(i,nr)
  end do
  do j=1,lh
     nrmj = nr-j
     do i=1,mr
        s = q(i,j)
        q(i,j) = q(i,nrmj)
        q(i,nrmj) = s
     end do
  end do
118 continue

!     return storage requirements for p vectors.

  w(1) = ipstor

  return

end subroutine poisp2

subroutine qform(m,n,q,ldq,wa)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)
      
  integer :: m,n,ldq
  real(rq) :: q(ldq,m),wa(m)

!     **********
!
!     subroutine qform
!
!     this subroutine proceeds from the computed qr factorization of
!     an m by n matrix a to accumulate the m by m orthogonal matrix
!     q from its factored form.
!
!     the subroutine statement is
!
!       subroutine qform(m,n,q,ldq,wa)
!
!     where
!
!       m is a positive integer input variable set to the number
!         of rows of a and the order of q.
!
!       n is a positive integer input variable set to the number
!         of columns of a.
!
!       q is an m by m array. on input the full lower trapezoid in
!         the first min(m,n) columns of q contains the factored form.
!         on output q has been accumulated into a square matrix.
!
!       ldq is a positive integer input variable not less than m
!         which specifies the leading real of the array q.
!
!       wa is a work array of length m.
!
!     subprograms called
!
!       fortran-supplied ... min0
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i,j,jm1,k,l,minmn,np1
  real(rq) :: sum,temp

!     zero out upper triangle of q in the first min(m,n) columns.

  minmn = min(m,n)
  if (minmn .lt. 2) go to 30
  do j = 2, minmn
     jm1 = j - 1
     do i = 1, jm1
        q(i,j) = zero
     end do
  end do
30 continue

!     initialize remaining columns to those of the identity matrix.

  np1 = n + 1
  if (m .lt. np1) go to 60
  do j = np1, m
     do i = 1, m
        q(i,j) = zero
     end do
     q(j,j) = one
  end do
60 continue

!     accumulate q from its factored form.

  do l = 1, minmn
     k = minmn - l + 1
     do i = k, m
        wa(i) = q(i,k)
        q(i,k) = zero
     end do
     q(k,k) = one
     if (wa(k) .eq. zero) go to 110
     do j = k, m
        sum = zero
        do i = k, m
           sum = sum + q(i,j)*wa(i)
        end do
        temp = sum/wa(k)
        do i = k, m
           q(i,j) = q(i,j) - temp*wa(i)
        end do
     end do
110  continue
  end do

  return

!     last card of subroutine qform.

end subroutine qform

subroutine qrfac(m,n,a,lda,pivot,ipvt,lipvt,rdiag,acnorm,wa)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: m,n,lda,lipvt
  integer :: ipvt(lipvt)
  logical :: pivot
  real(rq) :: a(lda,n),rdiag(n),acnorm(n),wa(n)

!     **********
!
!     subroutine qrfac
!
!     this subroutine uses householder transformations with column
!     pivoting (optional) to compute a qr factorization of the
!     m by n matrix a. that is, qrfac determines an orthogonal
!     matrix q, a permutation matrix p, and an upper trapezoidal
!     matrix r with diagonal elements of nonincreasing magnitude,
!     such that a*p = q*r. the householder transformation for
!     column k, k = 1,2,...,min(m,n), is of the form
!
!                           t
!           i - (1/u(k))*u*u
!
!     where u has zeros in the first k-1 positions. the form of
!     this transformation and the method of pivoting first
!     appeared in the corresponding linpack subroutine.
!
!     the subroutine statement is
!
!       subroutine qrfac(m,n,a,lda,pivot,ipvt,lipvt,rdiag,acnorm,wa)
!
!     where
!
!       m is a positive integer input variable set to the number
!         of rows of a.
!
!       n is a positive integer input variable set to the number
!         of columns of a.
!
!       a is an m by n array. on input a contains the matrix for
!         which the qr factorization is to be computed. on output
!         the strict upper trapezoidal part of a contains the strict
!         upper trapezoidal part of r, and the lower trapezoidal
!         part of a contains a factored form of q (the non-trivial
!         elements of the u vectors described above).
!
!       lda is a positive integer input variable not less than m
!         which specifies the leading real of the array a.
!
!       pivot is a logical input variable. if pivot is set true,
!         then column pivoting is enforced. if pivot is set false,
!         then no column pivoting is done.
!
!       ipvt is an integer output array of length lipvt. ipvt
!         defines the permutation matrix p such that a*p = q*r.
!         column j of p is column ipvt(j) of the identity matrix.
!         if pivot is false, ipvt is not referenced.
!
!       lipvt is a positive integer input variable. if pivot is false,
!         then lipvt may be as small as 1. if pivot is true, then
!         lipvt must be at least n.
!
!       rdiag is an output array of length n which contains the
!         diagonal elements of r.
!
!       acnorm is an output array of length n which contains the
!         norms of the corresponding columns of the input matrix a.
!         if this information is not needed, then acnorm can coincide
!         with rdiag.
!
!       wa is a work array of length n. if pivot is false, then wa
!         can coincide with rdiag.
!
!     subprograms called
!
!       minpack-supplied ... enorm
!
!       fortran-supplied ... amax1,sqrt,min0
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i,j,jp1,k,kmax,minmn
  real(rq) :: ajnorm,epsmch,sum,temp
  real(rq) :: enorm

!     epsmch is the machine precision.

  epsmch = errt_rq ! d1mach(3)

!     compute the initial column norms and initialize several arrays.

  do j = 1, n
     acnorm(j) = enorm(m,a(1,j))
     rdiag(j) = acnorm(j)
     wa(j) = rdiag(j)
     if (pivot) ipvt(j) = j
  end do

!     reduce a to r with householder transformations.

  minmn = min(m,n)
  do j = 1, minmn
     if (.not.pivot) go to 40

!        bring the column of largest norm into the pivot position.

     kmax = j
     do k = j, n
        if (rdiag(k) .gt. rdiag(kmax)) kmax = k
     end do
     if (kmax .eq. j) go to 40
     do i = 1, m
        temp = a(i,j)
        a(i,j) = a(i,kmax)
        a(i,kmax) = temp
     end do
     rdiag(kmax) = rdiag(j)
     wa(kmax) = wa(j)
     k = ipvt(j)
     ipvt(j) = ipvt(kmax)
     ipvt(kmax) = k
40   continue

!        compute the householder transformation to reduce the
!        j-th column of a to a multiple of the j-th unit vector.

     ajnorm = enorm(m-j+1,a(j,j))
     if (ajnorm .eq. zero) go to 100
     if (a(j,j) .lt. zero) ajnorm = -ajnorm
     do i = j, m
        a(i,j) = a(i,j)/ajnorm
     end do
     a(j,j) = a(j,j) + one

!        apply the transformation to the remaining columns
!        and update the norms.

     jp1 = j + 1
     if (n .lt. jp1) go to 100
     do k = jp1, n
        sum = zero
        do i = j, m
           sum = sum + a(i,j)*a(i,k)
        end do
        temp = sum/a(j,j)
        do i = j, m
           a(i,k) = a(i,k) - temp*a(i,j)
        end do
        if (.not.pivot .or. rdiag(k) .eq. zero) go to 80
        temp = a(j,k)/rdiag(k)
        rdiag(k) = rdiag(k)*sqrt(max(zero,one-temp**2))
        if (p05*(rdiag(k)/wa(k))**2 .gt. epsmch) go to 80
        rdiag(k) = enorm(m-j,a(jp1,k))
        wa(k) = rdiag(k)
80      continue
     end do
100  continue
     rdiag(j) = -ajnorm
  end do

  return

!     last card of subroutine qrfac.

end subroutine qrfac

subroutine quanc8(fun,a,b,abserr,relerr,result,errest,nofun,flag)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: fun, a, b, abserr, relerr, result, errest, flag
  integer :: nofun

!   estimate the integral of fun(x) from a to b
!   to a user provided tolerance.
!   an automatic adaptive routine based on
!   the 8-panel newton-cotes rule.
!
!   input ..
!
!   fun     the name of the integrand function subprogram fun(x).
!   a       the lower limit of integration.
!   b       the upper limit of integration.(b may be less than a.)
!   relerr  a relative error tolerance. (should be non-negative)
!   abserr  an absolute error tolerance. (should be non-negative)
!
!   output ..
!
!   result  an approximation to the integral hopefully satisfying the
!           least stringent of the two error tolerances.
!   errest  an estimate of the magnitude of the actual error.
!   nofun   the number of function values used in calculation of result.
!   flag    a reliability indicator.  if flag is zero, then result
!           probably satisfies the error tolerance.  if flag is
!           xxx.yyy , then  xxx = the number of intervals which have
!           not converged and  0.yyy = the fraction of the interval
!           left to do when the limit on  nofun  was approached.

  real(rq) :: w0,w1,w2,w3,w4,area,x0,f0,stone,step,cor11,temp
  real(rq) :: qprev,qnow,qdiff,qleft,esterr,tolerr
  real(rq) :: qright(31),f(16),x(16),fsave(8,30),xsave(8,30)
  integer :: levmin,levmax,levout,nomax,nofin,lev,nim,i,j

!   ***   stage 1 ***   general initialization
!   set constants.

  levmin = 1
  levmax = 30
  levout = 6
  nomax = 5000
  nofin = nomax - 8*(levmax-levout+2**(levout+1))

!   trouble when nofun reaches nofin

  w0 = 3956.0_rq / 14175.0_rq
  w1 = 23552.0_rq / 14175.0_rq
  w2 = -3712.0_rq / 14175.0_rq
  w3 = 41984.0_rq / 14175.0_rq
  w4 = -18160.0_rq / 14175.0_rq

!   initialize running sums to zero.

  flag = 0.0_rq
  result = 0.0_rq
  cor11 = 0.0_rq
  errest = 0.0_rq
  area = 0.0_rq
  nofun = 0
  if (a .eq. b) return

!   ***   stage 2 ***   initialization for first interval

  lev = 0
  nim = 1
  x0 = a
  x(16) = b
  qprev = 0.0_rq
  f0 = fun(x0)
  stone = (b - a) / 16.0_rq
  x(8) = (x0 + x(16)) / 2.0_rq
  x(4) = (x0 + x(8)) / 2.0_rq
  x(12) = (x(8) + x(16)) / 2.0_rq
  x(2) = (x0 + x(4)) / 2.0_rq
  x(6) = (x(4) + x(8)) / 2.0_rq
  x(10) = (x(8) + x(12)) / 2.0_rq
  x(14) = (x(12) + x(16)) / 2.0_rq
  do j = 2, 16, 2
     f(j) = fun(x(j))
  end do
  nofun = 9

!   ***   stage 3 ***   central calculation
!   requires qprev,x0,x2,x4,...,x16,f0,f2,f4,...,f16.
!   calculates x1,x3,...x15, f1,f3,...f15,qleft,qright,qnow,qdiff,area.

30 x(1) = (x0 + x(2)) / 2.0_rq
  f(1) = fun(x(1))
  do j = 3, 15, 2
     x(j) = (x(j-1) + x(j+1)) / 2.0_rq
     f(j) = fun(x(j))
  end do
  nofun = nofun + 8
  step = (x(16) - x0) / 16.0_rq
  qleft = (w0*(f0 + f(8)) + w1*(f(1)+f(7)) + w2*(f(2)+f(6)) + &
       w3*(f(3)+f(5)) + w4*f(4)) * step
  qright(lev+1)=(w0*(f(8)+f(16))+w1*(f(9)+f(15))+w2*(f(10)+f(14)) + &
       w3*(f(11)+f(13)) + w4*f(12)) * step
  qnow = qleft + qright(lev+1)
  qdiff = qnow - qprev
  area = area + qdiff

!   ***   stage 4 *** interval convergence test

  esterr = abs(qdiff) / 1023.0_rq
  tolerr = max(abserr,relerr*abs(area)) * (step/stone)
  if (lev .lt. levmin) go to 50
  if (lev .ge. levmax) go to 62
  if (nofun .gt. nofin) go to 60
  if (esterr .le. tolerr) go to 70

!   ***   stage 5   ***   no convergence
!   locate next interval.

50 nim = 2*nim
  lev = lev+1

!   store right hand elements for future use.

  do i = 1, 8
     fsave(i,lev) = f(i+8)
     xsave(i,lev) = x(i+8)
  end do

!   assemble left hand elements for immediate use.

  qprev = qleft
  do i = 1, 8
     j = -i
     f(2*j+18) = f(j+9)
     x(2*j+18) = x(j+9)
  end do
  go to 30

!   ***   stage 6   ***   trouble section
!   number of function values is about to exceed limit.

60 nofin = 2*nofin
  levmax = levout
  flag = flag + (b - x0) / (b - a)
  go to 70

!   current level is levmax.

62 flag = flag + 1.0_rq

!   ***   stage 7   ***   interval converged
!   add contributions into running sums.

70 result = result + qnow
  errest = errest + esterr
  cor11 = cor11 + qdiff / 1023.0_rq

!   locate next interval.

72 if (nim .eq. 2*(nim/2)) go to 75
  nim = nim/2
  lev = lev-1
  go to 72
75 nim = nim + 1
  if (lev .le. 0) go to 80

!   assemble elements required for the next interval.

  qprev = qright(lev)
  x0 = x(16)
  f0 = f(16)
  do i = 1, 8
     f(2*i) = fsave(i,lev)
     x(2*i) = xsave(i,lev)
  end do
  go to 30

!   ***   stage 8   ***   finalize and return

80 result = result + cor11

!   make sure errest not less than roundoff level.

  if (errest .eq. 0.0_rq) return
82 temp = abs(result) + errest
  if (temp .ne. abs(result)) return
  errest = 2.0_rq*errest
  go to 82

end subroutine quanc8

subroutine r1mpyq(m,n,a,lda,v,w)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: m,n,lda
  real(rq) :: a(lda,n),v(n),w(n)

!     **********
!
!     subroutine r1mpyq
!
!     given an m by n matrix a, this subroutine computes a*q where
!     q is the product of 2*(n - 1) transformations
!
!           gv(n-1)*...*gv(1)*gw(1)*...*gw(n-1)
!
!     and gv(i), gw(i) are givens rotations in the (i,n) plane which
!     eliminate elements in the i-th and n-th planes, respectively.
!     q itself is not given, rather the information to recover the
!     gv, gw rotations is supplied.
!
!     the subroutine statement is
!
!       subroutine r1mpyq(m,n,a,lda,v,w)
!
!     where
!
!       m is a positive integer input variable set to the number
!         of rows of a.
!
!       n is a positive integer input variable set to the number
!         of columns of a.
!
!       a is an m by n array. on input a must contain the matrix
!         to be postmultiplied by the orthogonal matrix q
!         described above. on output a*q has replaced a.
!
!       lda is a positive integer input variable not less than m
!         which specifies the leading real of the array a.
!
!       v is an input array of length n. v(i) must contain the
!         information necessary to recover the givens rotation gv(i)
!         described above.
!
!       w is an input array of length n. w(i) must contain the
!         information necessary to recover the givens rotation gw(i)
!         described above.
!
!     subroutines called
!
!       fortran-supplied ... abs,sqrt
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more
!
!     **********

  integer :: i,j,nmj,nm1
  real(rq) :: cos,sin,temp

!     apply the first set of givens rotations to a

  nm1 = n - 1
  if (nm1 .lt. 1) go to 50
  do nmj = 1, nm1
     j = n - nmj
     if (abs(v(j)) .gt. one) cos = one/v(j)
     if (abs(v(j)) .gt. one) sin = sqrt(one-cos**2)
     if (abs(v(j)) .le. one) sin = v(j)
     if (abs(v(j)) .le. one) cos = sqrt(one-sin**2)
     do i = 1, m
        temp = cos*a(i,j) - sin*a(i,n)
        a(i,n) = sin*a(i,j) + cos*a(i,n)
        a(i,j) = temp
     end do
  end do

!     apply the second set of givens rotations to a.

  do j = 1, nm1
     if (abs(w(j)) .gt. one) cos = one/w(j)
     if (abs(w(j)) .gt. one) sin = sqrt(one-cos**2)
     if (abs(w(j)) .le. one) sin = w(j)
     if (abs(w(j)) .le. one) cos = sqrt(one-sin**2)
     do i = 1, m
        temp = cos*a(i,j) + sin*a(i,n)
        a(i,n) = -sin*a(i,j) + cos*a(i,n)
        a(i,j) = temp
     end do
  end do
50 continue

  return

!     last card of subroutine r1mpyq.

end subroutine r1mpyq

subroutine r1updt(m,n,s,ls,u,v,w,sing)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: m,n,ls
  logical :: sing
  real(rq) :: s(ls),u(m),v(n),w(m)

!     **********
!
!     subroutine r1updt
!
!     given an m by n lower trapezoidal matrix s, an m-vector u,
!     and an n-vector v, the problem is to determine an
!     orthogonal matrix q such that
!
!                   t
!           (s + u*v )*q
!
!     is again lower trapezoidal.
!
!     this subroutine determines q as the product of 2*(n - 1)
!     transformations
!
!           gv(n-1)*...*gv(1)*gw(1)*...*gw(n-1)
!
!     where gv(i), gw(i) are givens rotations in the (i,n) plane
!     which eliminate elements in the i-th and n-th planes,
!     respectively. q itself is not accumulated, rather the
!     information to recover the gv, gw rotations is returned.
!
!     the subroutine statement is
!
!       subroutine r1updt(m,n,s,ls,u,v,w,sing)
!
!     where
!
!       m is a positive integer input variable set to the number
!         of rows of s.
!
!       n is a positive integer input variable set to the number
!         of columns of s. n must not exceed m.
!
!       s is an array of length ls. on input s must contain the lower
!         trapezoidal matrix s stored by columns. on output s contains
!         the lower trapezoidal matrix produced as described above.
!
!       ls is a positive integer input variable not less than
!         (n*(2*m-n+1))/2.
!
!       u is an input array of length m which must contain the
!         vector u.
!
!       v is an array of length n. on input v must contain the vector
!         v. on output v(i) contains the information necessary to
!         recover the givens rotation gv(i) described above.
!
!       w is an output array of length m. w(i) contains information
!         necessary to recover the givens rotation gw(i) described
!         above.
!
!       sing is a logical output variable. sing is set true if any
!         of  diagonal elements of  output s are zero. orwise
!         sing is set false.
!
!     subprograms called
!
!       fortran-supplied ... abs,sqrt
!
!     argonne national laboratory. minpack project. march 1980.
!     burton s. garbow, kenneth e. hillstrom, jorge j. more,
!     john l. nazareth
!
!     **********

  integer :: i,j,jj,l,nmj,nm1
  real(rq) :: cos,cotan,giant,sin,tan,tau,temp

!     giant is the largest magnitude.

  giant = erra_rq ! d1mach(2)

!     initializ diagonal element pointer.

  jj = (n*(2*m - n + 1))/2 - (m - n)

!     move the nontrivial part of the last column of s into w.

  l = jj
  do i = n, m
     w(i) = s(l)
     l = l + 1
  end do

!     rotate the vector v into a multiple of the n-th unit vector
!     in such a way that a spike is introduced into w.

  nm1 = n - 1
  if (nm1 .lt. 1) go to 70
  do nmj = 1, nm1
     j = n - nmj
     jj = jj - (m - j + 1)
     w(j) = zero
     if (v(j) .eq. zero) go to 50

!        determine a givens rotation which eliminates the
!        j-th element of v.

     if (abs(v(n)) .ge. abs(v(j))) go to 20
     cotan = v(n)/v(j)
     sin = HALF/sqrt(p25+p25*cotan**2)
     cos = sin*cotan
     tau = one
     if (abs(cos)*giant .gt. one) tau = one/cos
     go to 30
20   continue
     tan = v(j)/v(n)
     cos = HALF/sqrt(p25+p25*tan**2)
     sin = cos*tan
     tau = sin
30   continue

!        apply the transformation to v and store the information
!        necessary to recover the givens rotation.

     v(n) = sin*v(j) + cos*v(n)
     v(j) = tau

!        apply the transformation to s and extend the spike in w.

     l = jj
     do i = j, m
        temp = cos*s(l) - sin*w(i)
        w(i) = sin*s(l) + cos*w(i)
        s(l) = temp
        l = l + 1
     end do
50   continue
  end do
70 continue

!     add the spike from the rank 1 update to w.

  do i = 1, m
     w(i) = w(i) + v(n)*u(i)
  end do

!     eliminate the spike.

  sing = .false.
  if (nm1 .lt. 1) go to 140
  do j = 1, nm1
     if (w(j) .eq. zero) go to 120

!        determine a givens rotation which eliminates the
!        j-th element of the spike.

     if (abs(s(jj)) .ge. abs(w(j))) go to 90
     cotan = s(jj)/w(j)
     sin = HALF/sqrt(p25+p25*cotan**2)
     cos = sin*cotan
     tau = one
     if (abs(cos)*giant .gt. one) tau = one/cos
     go to 100
90   continue
     tan = w(j)/s(jj)
     cos = HALF/sqrt(p25+p25*tan**2)
     sin = cos*tan
     tau = sin
100  continue

!        apply the transformation to s and reduce the spike in w.

     l = jj
     do i = j, m
        temp = cos*s(l) + sin*w(i)
        w(i) = -sin*s(l) + cos*w(i)
        s(l) = temp
        l = l + 1
     end do

!        store the information necessary to recover the
!        givens rotation.

     w(j) = tau
120  continue

!        test for zero diagonal elements in the output s.

     if (s(jj) .eq. zero) sing = .true.
     jj = jj + (m - j + 1)
  end do
140 continue

!     move w back into the last column of the output s.

  l = jj
  do i = n, m
     s(l) = w(i)
     l = l + 1
  end do
  if (s(jj) .eq. zero) sing = .true.

  return

!     last card of subroutine r1updt.

end subroutine r1updt

subroutine sepx4(iorder,a,b,m,mbdcnd,bda,alpha,bdb,beta,c,d,n, &
     nbdcnd,bdc,bdd,cofx,grhs,usol,idmn,w,pertrb,ierror)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)
!                          equations.  ncar technical note
!                          ncar-tn/ia-109, pp. 135-137.

  real(rq) :: grhs(idmn,*),usol(idmn,*)
  real(rq) :: bda(*),bdb(*),bdc(*),bdd(*),w(*)
  real(rq) :: a,b,alpha,c,d,pertrb

  external cofx

!     the following call is for gathering statistics on
!     library use at ncar
!
!     check input parameters

  call chkprm(iorder,a,b,m,mbdcnd,c,d,n,nbdcnd,cofx,idmn,ierror)
  if (ierror .ne. 0) return

!     compute minimum work space and check work space length input

  l = n+1
  if (nbdcnd .eq. 0) l = n
  k = m+1
  l = n+1
!     estimate log base 2 of n

!     modified after conversation with john adams,feb.27,1980

  log2n=int(log((n+1.0_rq))/log(2.0_rq)+0.5_rq)
  length=4*(n+1)+(10+log2n)*(m+1)

  ierror = 11
  linput = int(w(1)+0.5_rq)
  ierror = 0

!     set work space indices

  i1 = length+2
  i2 = i1+l
  i3 = i2+l
  i4 = i3+l
  i5 = i4+l
  i6 = i5+l
  i7 = i6+l
  i8 = i7+k
  i9 = i8+k
  i10 = i9+k
  i11 = i10+k
  i12 = i11+k
  i13 = 2
  loutpt = length+6*(k+l)+i12+3
  w(1) = (loutpt)
  if (loutpt .gt. linput) return

  call spelip(iorder,a,b,m,mbdcnd,bda,alpha,bdb,beta,c,d,n,nbdcnd, &
       bdc,bdd,cofx,w(i1),w(i2),w(i3), w(i4),w(i5),w(i6),w(i7),w(i8), &
       w(i9),w(i10),w(i11), w(i12),grhs,usol,idmn,w(i13),pertrb,ierror)

  return

end subroutine sepx4

function seval_c(n,u,x,y,b,c,d)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: x(n),y(n),b(n),c(n),d(n),seval_c
  data i/1/

  if (i.ge.n) i=1
  if (u.lt.x(i)) go to 10
  if (u.le.x(i+1)) go to 30
10 i=1
  j=n+1
20 k=(i+j)/2
  if (u.lt.x(k)) j=k
  if (u.ge.x(k)) i=k
  if (j.gt.i+1) go to 20
30 dx=u-x(i)
  seval_c=y(i)+dx*(b(i)+dx*(c(i)+dx*d(i)))

  return

end function seval_c

subroutine spelip(iorder,a,b,m,mbdcnd,bda,alpha,bdb,beta,c,d,n, &
     nbdcnd,bdc,bdd,cofx,an,bn, cn,dn,un,zn,am,bm,cm,dm,um,zm,grhs, &
     usol,idmn, w,pertrb,ierror)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     spelip sets up vectors and arrays for input to blktri
!     and computes a second order solution in usol.  a return jump to
!     sepeli occurrs if iorder=2.  if iorder=4 a fourth order
!     solution is generated in usol.

  real(rq) :: bda(*),bdb(*),bdc(*),bdd(*),w(*)
  real(rq) :: grhs(idmn,*),usol(idmn,*)
  real(rq) :: an(*),bn(*),cn(*),dn(*),un(*),zn(*)
  real(rq) :: am(*),bm(*),cm(*),dm(*),um(*),zm(*)

  real(rq) :: a,b,alpha,c,d,pertrb
  real(rq) :: ait,bit,cit,dit,dlx,dly,tdlx3,tdly3,dlx4,dly4
  common /splp/ kswx,kswy,k,l,ait,bit,cit,dit,mit,nit,is, &
       ms,js,ns,dlx,dly,tdlx3,tdly3,dlx4,dly4

  logical singlr

  external cofx

!     set parameters internally

  kswx = mbdcnd+1
  kswy = nbdcnd+1
  k = m+1
  l = n+1
  ait = a
  bit = b
  cit = c
  dit = d
  dly=(dit-cit)/(n)

!     set right hand side values from grhs in usol on the interior
!     and non-specified boundaries.

  do i=2,m
     do j=2,n
        usol(i,j)=dly**2*grhs(i,j)
     end do
  end do
  if (kswx.eq.2 .or. kswx.eq.3) go to 40
  do j=2,n
     usol(1,j)=dly**2*grhs(1,j)
  end do
40 continue
  if (kswx.eq.2 .or. kswx.eq.5) go to 60
  do j=2,n
     usol(k,j)=dly**2*grhs(k,j)
  end do
60 continue
  if (kswy.eq.2 .or. kswy.eq.3) go to 80
  do i=2,m
     usol(i,1)=dly**2*grhs(i,1)
  end do
80 continue
  if (kswy.eq.2 .or. kswy.eq.5) go to 100
  do i=2,m
     usol(i,l)=dly**2*grhs(i,l)
  end do
100 continue
  if (kswx.ne.2 .and. kswx.ne.3 .and. kswy.ne.2 .and. kswy.ne.3) &
       usol(1,1)=dly**2*grhs(1,1)
  if (kswx.ne.2 .and. kswx.ne.5 .and. kswy.ne.2 .and. kswy.ne.3) &
       usol(k,1)=dly**2*grhs(k,1)
  if (kswx.ne.2 .and. kswx.ne.3 .and. kswy.ne.2 .and. kswy.ne.5) &
       usol(1,l)=dly**2*grhs(1,l)
  if (kswx.ne.2 .and. kswx.ne.5 .and. kswy.ne.2 .and. kswy.ne.5) &
       usol(k,l)=dly**2*grhs(k,l)

!     set switches for periodic or non-periodic boundaries

  mp=1
  if (kswx.eq.1) mp=0
  np=nbdcnd

!     set dlx,dly and size of block tri-diagonal system generated
!     in nint,mint

  dlx = (bit-ait)/(m)
  mit = k-1
  if (kswx .eq. 2) mit = k-2
  if (kswx .eq. 4) mit = k
  dly = (dit-cit)/(n)
  nit = l-1
  if (kswy .eq. 2) nit = l-2
  if (kswy .eq. 4) nit = l
  tdlx3 = 2.0_rq*dlx**3
  dlx4 = dlx**4
  tdly3 = 2.0_rq*dly**3
  dly4 = dly**4

!     set subscript limits for portion of array to input to blktri

  is = 1
  js = 1
  if (kswx.eq.2 .or. kswx.eq.3) is = 2
  if (kswy.eq.2 .or. kswy.eq.3) js = 2
  ns = nit+js-1
  ms = mit+is-1

!     set x - direction

  do i=1,mit
     xi = ait+(is+i-2)*dlx
     call cofx(xi,ai,bi,ci)
     axi = (ai/dlx-0.5_rq*bi)/dlx
     bxi = -2._rq*ai/dlx**2+ci
     cxi = (ai/dlx+0.5_rq*bi)/dlx
     am(i)=dly**2*axi
     bm(i)=dly**2*bxi
     cm(i)=dly**2*cxi
  end do

!     set y direction

  do j=1,nit
     dyj=1.0_rq
     eyj=-2.0_rq
     fyj=1.0_rq
     an(j) = dyj
     bn(j) = eyj
     cn(j) = fyj
  end do

!     adjust edges in x direction unless periodic

  ax1 = am(1)
  cxm = cm(mit)
  go to (170,130,150,160,140),kswx

!     dirichlet-dirichlet in x direction

130 am(1) = 0.0_rq
  cm(mit) = 0.0_rq
  go to 170

!     mixed-dirichlet in x direction

140 am(1) = 0.0_rq
  bm(1) = bm(1)+2._rq*alpha*dlx*ax1
  cm(1) = cm(1)+ax1
  cm(mit) = 0.0_rq
  go to 170

!     dirichlet-mixed in x direction

150 am(1) = 0.0_rq
  am(mit) = am(mit)+cxm
  bm(mit) = bm(mit)-2._rq*beta*dlx*cxm
  cm(mit) = 0.0_rq
  go to 170

!     mixed - mixed in x direction

160 continue
  am(1) = 0.0_rq
  bm(1) = bm(1)+2._rq*dlx*alpha*ax1
  cm(1) = cm(1)+ax1
  am(mit) = am(mit)+cxm
  bm(mit) = bm(mit)-2._rq*dlx*beta*cxm
  cm(mit) = 0.0_rq
170 continue

!     adjust in y direction unless periodic

  dy1 = an(1)
  fyn = cn(nit)
  gama=0.0_rq
  xnu=0.0_rq
  go to (220,180,200,210,190),kswy

!     dirichlet-dirichlet in y direction

180 continue
  an(1) = 0.0_rq
  cn(nit) = 0.0_rq
  go to 220

!     mixed-dirichlet in y direction

190 continue
  an(1) = 0.0_rq
  bn(1) = bn(1)+2._rq*dly*gama*dy1
  cn(1) = cn(1)+dy1
  cn(nit) = 0.0_rq
  go to 220

!     dirichlet-mixed in y direction

200 an(1) = 0.0_rq
  an(nit) = an(nit)+fyn
  bn(nit) = bn(nit)-2._rq*dly*xnu*fyn
  cn(nit) = 0.0_rq
  go to 220

!     mixed - mixed direction in y direction

210 continue
  an(1) = 0.0_rq
  bn(1) = bn(1)+2._rq*dly*gama*dy1
  cn(1) = cn(1)+dy1
  an(nit) = an(nit)+fyn
  bn(nit) = bn(nit)-2.0_rq*dly*xnu*fyn
  cn(nit) = 0.0_rq
220 if (kswx .eq. 1) go to 270

!     adjust usol along x edge

  do j=js,ns
     if (kswx.ne.2 .and. kswx.ne.3) go to 230
     usol(is,j) = usol(is,j)-ax1*usol(1,j)
     go to 240
230  usol(is,j) = usol(is,j)+2.0_rq*dlx*ax1*bda(j)
240  if (kswx.ne.2 .and. kswx.ne.5) go to 250
     usol(ms,j) = usol(ms,j)-cxm*usol(k,j)
     go to 260
250  usol(ms,j) = usol(ms,j)-2.0_rq*dlx*cxm*bdb(j)
260  continue
  end do
  270 if (kswy .eq. 1) go to 320

!     adjust usol along y edge

  do i=is,ms
     if (kswy.ne.2 .and. kswy.ne.3) go to 280
     usol(i,js) = usol(i,js)-dy1*usol(i,1)
     go to 290
280  usol(i,js) = usol(i,js)+2.0_rq*dly*dy1*bdc(i)
290  if (kswy.ne.2 .and. kswy.ne.5) go to 300
     usol(i,ns) = usol(i,ns)-fyn*usol(i,l)
     go to 310
300  usol(i,ns) = usol(i,ns)-2.0_rq*dly*fyn*bdd(i)
310  continue
  end do
320 continue

!     save adjusted edges in grhs if iorder=4

  if (iorder .ne. 4) go to 350
  do j=js,ns
     grhs(is,j) = usol(is,j)
     grhs(ms,j) = usol(ms,j)
  end do
  do i=is,ms
     grhs(i,js) = usol(i,js)
     grhs(i,ns) = usol(i,ns)
  end do
350 continue
  iord = iorder
  pertrb = 0.0_rq

!     check if operator is singular

  call chksng(mbdcnd,nbdcnd,alpha,beta,cofx,singlr)

!     compute non-zero eigenvector in null space of transpose
!     if singular

  if (singlr) call trisp (mit,am,bm,cm,dm,um,zm)
  if (singlr) call trisp (nit,an,bn,cn,dn,un,zn)

!     adjust right hand side if necessary

360 continue
  if (singlr) call orthog (usol,idmn,zn,zm,pertrb)

!     compute solution

!     save adjusted right hand side in grhs
  do j=js,ns
     do i=is,ms
        grhs(i,j)=usol(i,j)
     end do
  end do

  call genbun(np,nit,mp,mit,am,bm,cm,idmn,usol(is,js),ieror,w)
!     check if error detected in pois
!     this can only correspond to ierror=12
  if (ieror.eq.0) go to 224
!     set error flag if improper coefficients input to pois
  ierror=12
  return
224 continue
  if (ierror .ne. 0) return

!     set periodic boundaries if necessary

  if (kswx .ne. 1) go to 380
  do j=1,l
     usol(k,j) = usol(1,j)
  end do
380 if (kswy .ne. 1) go to 400
  do i=1,k
     usol(i,l) = usol(i,1)
  end do
400 continue

!     minimize solution with respect to weighted least squares
!     norm if operator is singular

  if (singlr) call minsol (usol,idmn,zn,zm,prtrb)

!     return if deferred corrections and a fourth order solution are
!     not flagged

  if (iord .eq. 2) return
  iord = 2

!     compute new right hand side for fourth order solution

  call defer(cofx,idmn,usol,grhs)
  go to 360

end subroutine spelip

subroutine store(x)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: x,v
  common /value/ v

  v = x

  return

end subroutine store

subroutine tri3(m,a,b,c,k,y1,y2,y3,tcos,d,w1,w2,w3)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: a(*),b(*),c(*),k(4),tcos(*),y1(*),y2(*),y3(*),d(*), &
       w1(*),w2(*),w3(*)

!     subroutine to solve three linear systems whose common coefficient
!     matrix is a rational function in the matrix given by
!
!                  tridiagonal (...,a(i),b(i),c(i),...)

  mm1 = m-1
  k1 = k(1)
  k2 = k(2)
  k3 = k(3)
  k4 = k(4)
  f1 = k1+1
  f2 = k2+1
  f3 = k3+1
  f4 = k4+1
  k2k3k4 = k2+k3+k4
  if (k2k3k4 .eq. 0) go to 101
  l1 = f1/f2
  l2 = f1/f3
  l3 = f1/f4
  lint1 = 1
  lint2 = 1
  lint3 = 1
  kint1 = k1
  kint2 = kint1+k2
  kint3 = kint2+k3
101 continue
  do n=1,k1
     x = tcos(n)
     if (k2k3k4 .eq. 0) go to 107
     if (n .ne. l1) go to 103
     do i=1,m
        w1(i) = y1(i)
     end do
103  if (n .ne. l2) go to 105
     do i=1,m
        w2(i) = y2(i)
     end do
105  if (n .ne. l3) go to 107
     do i=1,m
        w3(i) = y3(i)
     end do
107  continue
     z = 1._rq/(b(1)-x)
     d(1) = c(1)*z
     y1(1) = y1(1)*z
     y2(1) = y2(1)*z
     y3(1) = y3(1)*z
     do i=2,m
        z = 1._rq/(b(i)-x-a(i)*d(i-1))
        d(i) = c(i)*z
        y1(i) = (y1(i)-a(i)*y1(i-1))*z
        y2(i) = (y2(i)-a(i)*y2(i-1))*z
        y3(i) = (y3(i)-a(i)*y3(i-1))*z
     end do
     do ip=1,mm1
        i = m-ip
        y1(i) = y1(i)-d(i)*y1(i+1)
        y2(i) = y2(i)-d(i)*y2(i+1)
        y3(i) = y3(i)-d(i)*y3(i+1)
     end do
     if (k2k3k4 .eq. 0) go to 115
     if (n .ne. l1) go to 111
     i = lint1+kint1
     xx = x-tcos(i)
     do i=1,m
        y1(i) = xx*y1(i)+w1(i)
     end do
     lint1 = lint1+1
     l1 = ((lint1)*f1)/f2
111  if (n .ne. l2) go to 113
     i = lint2+kint2
     xx = x-tcos(i)
     do i=1,m
        y2(i) = xx*y2(i)+w2(i)
     end do
     lint2 = lint2+1
     l2 = ((lint2)*f1)/f3
113  if (n .ne. l3) go to 115
     i = lint3+kint3
     xx = x-tcos(i)
     do i=1,m
        y3(i) = xx*y3(i)+w3(i)
     end do
     lint3 = lint3+1
     l3 = ((lint3)*f1)/f4
115  continue
  end do

  return

end subroutine tri3

subroutine trisp(n,a,b,c,d,u,z)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     this subroutine solves for a non-zero eigenvector corresponding
!     to the zero eigenvalue of the transpose of the rank
!     deficient one matrix with subdiagonal a, diagonal b, and
!     superdiagonal c , with a(1) in the (1,n) position, with
!     c(n) in the (n,1) position, and all other elements zero.

  real(rq) :: a(n),b(n),c(n),d(n),u(n),z(n)

  bn = b(n)
  d(1) = a(2)/b(1)
  v = a(1)
  u(1) = c(n)/b(1)
  nm2 = n-2
  do j=2,nm2
     den = b(j)-c(j-1)*d(j-1)
     d(j) = a(j+1)/den
     u(j) = -c(j-1)*u(j-1)/den
     bn = bn-v*u(j-1)
     v = -v*d(j-1)
  end do
  den = b(n-1)-c(n-2)*d(n-2)
  d(n-1) = (a(n)-c(n-2)*u(n-2))/den
  an = c(n-1)-v*d(n-2)
  bn = bn-v*u(n-2)
  den = bn-an*d(n-1)

!     set last component equal to one

  z(n) = 1.0_rq
  z(n-1) = -d(n-1)
  nm1 = n-1
  do j=2,nm1
     k = n-j
     z(k) = -d(k)*z(k+1)-u(k)*z(n)
  end do

  return

end subroutine trisp

subroutine trix(idegbr,idegcr,m,a,b,c,y,tcos,d,w)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

!     subroutineto solve a system of linear equations where the
!     coefficient matrix is a rational function in the matrix given by
!     tridiagonal  ( . . . , a(i), b(i), c(i), . . . ).

  real(rq) :: a(*),b(*),c(*),y(*),tcos(*),d(*),w(*)

  mm1 = m-1
  fb = idegbr+1
  fc = idegcr+1
  l = fb/fc
  lint = 1
  do k=1,idegbr
     x = tcos(k)
     if (k .ne. l) go to 102
     i = idegbr+lint
     xx = x-tcos(i)
     do i=1,m
        w(i) = y(i)
        y(i) = xx*y(i)
     end do
102  continue
     z = 1._rq/(b(1)-x)
     d(1) = c(1)*z
     y(1) = y(1)*z
     do i=2,mm1
        z = 1._rq/(b(i)-x-a(i)*d(i-1))
        d(i) = c(i)*z
        y(i) = (y(i)-a(i)*y(i-1))*z
     end do
     z = b(m)-x-a(m)*d(mm1)
     if (z .ne. 0._rq) go to 104
     y(m) = 0._rq
     go to 105
104  y(m) = (y(m)-a(m)*y(mm1))/z
105  continue
     do ip=1,mm1
        i = m-ip
        y(i) = y(i)-d(i)*y(i+1)
     end do
     if (k .ne. l) go to 108
     do i=1,m
        y(i) = y(i)+w(i)
     end do
     lint = lint+1
     l = ((lint)*fb)/fc
108  continue
  end do

  return

end subroutine trix

function zeroin_c(ax,bx,f,tol)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: ax,bx,f,tol,zeroin_c

!      a zero of the function  f(x)  is computed in the interval ax,bx .
!
!  input..
!
!  ax     left endpoint of initial interval
!  bx     right endpoint of initial interval
!  f      function subprogram which evaluates f(x) for any x in
!         the interval  ax,bx
!  tol    desired length of the interval of uncertainty of the
!         final result ( .ge. 0.0)
!
!  output..
!
!  zeroin abcissa approximating a zero of  f  in the interval ax,bx
!
!      it is assumed  that   f(ax)   and   f(bx)   have  opposite  signs
!  without  a  check.  zeroin  returns a zero  x  in the given interval
!  ax,bx  to within a tolerance  4*macheps*abs(x) + tol, where macheps
!  is the relative machine precision.
!      this function subprogram is a slightly  modified  translation  of
!  the algol 60 procedure  zero  given in  richard brent, algorithms for
!  minimization without derivatives, prentice - hall, inc. (1973).

  real(rq) :: a,b,c,d,e,eps,fa,fb,fc,tol1,xm,p,q,r,s

!  compute eps, the relative machine precision

  eps = 1.0_rq
10 eps = eps/2.0_rq
  tol1 = 1.0_rq + eps
  if (tol1 .gt. 1.0_rq) go to 10

! initialization

  a = ax
  b = bx
  fa = f(a)
  fb = f(b)

! begin step

20 c = a
  fc = fa
  d = b - a
  e = d
30 if (abs(fc) .ge. abs(fb)) go to 40
  a = b
  b = c
  c = a
  fa = fb
  fb = fc
  fc = fa

! convergence test

40 tol1 = 2.0_rq*eps*abs(b) + 0.5_rq*tol
  xm = .5_rq*(c - b)
  if (abs(xm) .le. tol1) go to 90
  if (fb .eq. 0.0_rq) go to 90

! is bisection necessary

  if (abs(e) .lt. tol1) go to 70
  if (abs(fa) .le. abs(fb)) go to 70

! is quadratic interpolation possible

  if (a .ne. c) go to 50

! linear interpolation

  s = fb/fa
  p = 2.0_rq*xm*s
  q = 1.0_rq - s
  go to 60

! inverse quadratic interpolation

50 q = fa/fc
  r = fb/fc
  s = fb/fa
  p = s*(2.0_rq*xm*q*(q - r) - (b - a)*(r - 1.0_rq))
  q = (q - 1.0_rq)*(r - 1.0_rq)*(s - 1.0_rq)

! adjust signs

60 if (p .gt. 0.0_rq) q = -q
  p = abs(p)

! is interpolation acceptable

  if ((2.0_rq*p) .ge. (3.0_rq*xm*q - abs(tol1*q))) go to 70
  if (p .ge. abs(0.5_rq*e*q)) go to 70
  e = d
  d = p/q
  go to 80

! bisection

70 d = xm
  e = d

! complete step

80 a = b
  fa = fb
  if (abs(d) .gt. tol1) b = b + d
  if (abs(d) .le. tol1) b = b + sign(tol1, xm)
  fb = f(b)
  if ((fb*(fc/abs(fc))) .gt. 0.0_rq) go to 20
  go to 30

! done

90 zeroin_c = b

  return

end function zeroin_c

function bessj(n,x,bessjp)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: bessj,x,bessjp
  parameter(iacc=40)

  bigni=(10.0_rq*errb_rq)*errb_rq ! d1mach(1)
!     bigno=0.10*r1mach(2)
  if (n.lt.1) call errdetec("bad index in bessj",0)
  bjm=bessj0(x)
  bj=bessj1(x)
  bessjp=bjm-bj/x
  bessj =bj
  if (n.eq.1) return
  tox=2._rq/x
  if (x.gt.(n)) then
     do j=1,n-1
        bjp=j*tox*bj-bjm
        bjm=bj
        bj=bjp
     end do
     bessj=bj
     bessjp=bjm-bj*n/x
  else
     ziacc=iacc
     m=2*((n+int(sqrt(ziacc*n)))/2)
     bessj=0._rq
     jsum=0
     sum=0._rq
     bjp=0._rq
!        bj=1.0
     bj=bigni*n/(2._rq*m)
     do j=m,1,-1
        bjm=j*tox*bj-bjp
        bjp=bj
        bj=bjm
!           if(abs(bj).gt.bigno)then
!              bj=bj*bigni
!              bjp=bjp*bigni
!              bessj=bessj*bigni
!              sum=sum*bigni
!           endif
        if (jsum.ne.0)sum=sum+bj
        jsum=1-jsum
        if (j.eq.n)bessj=bjp
        if (j.eq.n-1)bessjp=bjp
     end do
     sum=2._rq*sum-bj
     bessj=bessj/sum
     bessjp=bessjp/sum-n*bessj/x
  endif

  return

end function bessj

function bessj0(x)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: bessj0,x
  data p1,p2,p3,p4,p6 &
       /1._rq,-.1098628627e-2_rq,.2734510407e-4_rq, &
       -.2073370639e-5_rq,.2093887211e-6_rq/
  data q1,q2,q3,q4,q5/ &
       -.1562499995e-1_rq,.1430488765e-3_rq,-.6911147651e-5_rq, &
       .7621095161e-6_rq,-.934945152e-7_rq/
  data r1,r2,r3,z4,r5,r6 &
       /57568490574._rq,-13362590354._rq, &
       651619640._rq, -11214424.18_rq,77392.33017_rq,-184.9052456_rq/
  data s1,s2,s3,s4,s5,s6 &
       /57568490411._rq,1029532985._rq, &
       9494680.718_rq,59272.64853_rq,267.8532712_rq,1._rq/

  if (abs(x).lt.8._rq)then
     y=x**2
     bessj0=(r1+y*(r2+y*(r3+y*(z4+y*(r5+y*r6)))))/ &
          (s1+y*(s2+y*(s3+y*(s4+y*(s5+y*s6)))))
  else
     ax=abs(x)
     z=8._rq/ax
     y=z**2
     xx=ax-.785398164_rq
     bessj0=sqrt(.636619772_rq/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*p6))))- &
          z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5)))))
  endif

  return

end function bessj0

function bessj1(x)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: bessj1,x

  data r1,r2,r3,z4,r5,r6 &
       /72362614232._rq,-7895059235._rq, &
       242396853.1_rq, -2972611.439_rq,15704.48260_rq,-30.16036606_rq/
  data s1,s2,s3,s4,s5,s6 &
       /144725228442._rq,2300535178._rq, &
       18583304.74_rq,99447.43394_rq,376.9991397_rq,1._rq/
  data p1,p2,p3,p4,p6 &
       /1._rq,.183105e-2_rq,-.3516396496e-4_rq, &
       .2457520174e-5_rq, -.240337019e-6_rq/
  data q1,q2,q3,q4,q5 &
       /.04687499995_rq,-.2002690873e-3_rq,.8449199096e-5_rq, &
       -.88228987e-6_rq,.105787412e-6_rq/

  if (abs(x).lt.8._rq)then
     y=x**2
     bessj1=x*(r1+y*(r2+y*(r3+y*(z4+y*(r5+y*r6)))))/ &
          (s1+y*(s2+y*(s3+y*(s4+y*(s5+y*s6)))))
  else
     ax=abs(x)
     z=8._rq/ax
     y=z**2
     xx=ax-2.356194491_rq
     bessj1=sqrt(.636619772_rq/ax)*(cos(xx)*(p1+y*(p2+y*(p3+y*(p4+y*p6))))- &
          z*sin(xx)*(q1+y*(q2+y*(q3+y*(q4+y*q5))))) *sign(1._rq,x)
  endif

  return

end function bessj1

subroutine ssvd(nm,m,n,a,w,matu,u,matv,v,ierr,rv1)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  integer :: i,j,k,l,m,n,ii,i1,kk,k1,ll,l1,mn,nm,its,ierr
  real(rq) :: a(nm,n),w(n),u(nm,n),v(nm,n),rv1(n)
  real(rq) :: c,f,g,h,s,x,y,z,scale,anorm
  logical :: matu,matv

!     this subroutine is a translation of the algol procedure svd,
!     num. math. 14, 403-420(1970) by golub and reinsch.
!     handbook for auto. comp., vol ii-linear algebra, 134-151(1971).
!
!     this subroutine determines the singular value decomposition
!          t
!     a=usv  of a real m by n rectangular matrix.  householder
!     bidiagonalization and a variant of the qr algorithm are used.
!
!     on input.
!
!        nm must be set to the row dimension of two-dimensional
!          array parameters as declared in the calling program
!          dimension statement.  note that nm must be at least
!          as large as the maximum of m and n.
!
!        m is the number of rows of a (and u).
!
!        n is the number of columns of a (and u) and the order of v.
!
!        a contains the rectangular input matrix to be decomposed.
!
!        matu should be set to .true. if the u matrix in the
!          decomposition is desired, and to .false. otherwise.
!
!        matv should be set to .true. if the v matrix in the
!          decomposition is desired, and to .false. otherwise.
!
!     on output.
!
!        a is unaltered (unless overwritten by u or v).
!
!        w contains the n (non-negative) singular values of a (the
!          diagonal elements of s).  they are unordered.  if an
!          error exit is made, the singular values should be correct
!          for indices ierr+1,ierr+2,...,n.
!
!        u contains the matrix u (orthogonal column vectors) of the
!          decomposition if matu has been set to .true.  otherwise
!          u is used as a temporary array.  u may coincide with a.
!          if an error exit is made, the columns of u corresponding
!          to indices of correct singular values should be correct.
!
!        v contains the matrix v (orthogonal) of the decomposition if
!          matv has been set to .true.  otherwise v is not referenced.
!          v may also coincide with a if u is not needed.  if an error
!          exit is made, the columns of v corresponding to indices of
!          correct singular values should be correct.
!
!        ierr is set to
!          zero       for normal return,
!          k          if the k-th singular value has not been
!                     determined after 30 iterations.
!
!        rv1 is a temporary storage array.
!
!     questions and comments should be directed to b. s. garbow,
!     applied mathematics division, argonne national laboratory
!
!     modified to eliminate machep

  ierr = 0

  do i = 1, m
     do j = 1, n
        u(i,j) = a(i,j)
     end do
  end do
!     .......... householder reduction to bidiagonal form ..........
  g = 0.0_rq
  scale = 0.0_rq
  anorm = 0.0_rq

  do i = 1, n
     l = i + 1
     rv1(i) = scale * g
     g = 0.0_rq
     s = 0.0_rq
     scale = 0.0_rq
     if (i .gt. m) go to 210

     do k = i, m
        scale = scale + abs(u(k,i))
     end do

     if (scale .eq. 0.0_rq) go to 210

     do k = i, m
        u(k,i) = u(k,i) / scale
        s = s + u(k,i)**2
     end do

     f = u(i,i)
     g = -sign(sqrt(s),f)
     h = f * g - s
     u(i,i) = f - g
     if (i .eq. n) go to 190

     do j = l, n
        s = 0.0_rq
        do k = i, m
           s = s + u(k,i) * u(k,j)
        end do
        f = s / h
        do k = i, m
           u(k,j) = u(k,j) + f * u(k,i)
        end do
     end do

190  do k = i, m
        u(k,i) = scale * u(k,i)
     end do

210  w(i) = scale * g
     g = 0.0_rq
     s = 0.0_rq
     scale = 0.0_rq
     if (i .gt. m .or. i .eq. n) go to 290

     do k = l, n
        scale = scale + abs(u(i,k))
     end do

     if (scale .eq. 0.0_rq) go to 290

     do k = l, n
        u(i,k) = u(i,k) / scale
        s = s + u(i,k)**2
     end do

     f = u(i,l)
     g = -sign(sqrt(s),f)
     h = f * g - s
     u(i,l) = f - g

     do k = l, n
        rv1(k) = u(i,k) / h
     end do

     if (i .eq. m) go to 270

     do j = l, m
        s = 0.0_rq
        do k = l, n
           s = s + u(j,k) * u(i,k)
        end do
        do k = l, n
           u(j,k) = u(j,k) + s * rv1(k)
        end do
     end do
270  do k = l, n
        u(i,k) = scale * u(i,k)
     end do
290  anorm = max(anorm,abs(w(i))+abs(rv1(i)))
  end do
!     .......... accumulation of right-hand transformations ..........
  if (.not. matv) go to 410
!     .......... for i=n step -1 until 1 do -- ..........
  do ii = 1, n
     i = n + 1 - ii
     if (i .eq. n) go to 390
     if (g .eq. 0.0_rq) go to 360

     do j = l, n
!     .......... double division avoids possible underflow ..........
        v(j,i) = (u(i,j) / u(i,l)) / g
     end do

     do j = l, n
        s = 0.0_rq
        do k = l, n
           s = s + u(i,k) * v(k,j)
        end do
        do k = l, n
           v(k,j) = v(k,j) + s * v(k,i)
        end do
     end do

360  do j = l, n
        v(i,j) = 0.0_rq
        v(j,i) = 0.0_rq
     end do

390  v(i,i) = 1.0_rq
     g = rv1(i)
     l = i
  end do
!     .......... accumulation of left-hand transformations ..........
410 if (.not. matu) go to 510
!     ..........for i=min(m,n) step -1 until 1 do -- ..........
  mn = n
  if (m .lt. n) mn = m

  do ii = 1, mn
     i = mn + 1 - ii
     l = i + 1
     g = w(i)
     if (i .eq. n) go to 430

     do j = l, n
        u(i,j) = 0.0_rq
     end do

430  if (g .eq. 0.0_rq) go to 475
     if (i .eq. mn) go to 460

     do j = l, n
        s = 0.0_rq

        do k = l, m
           s = s + u(k,i) * u(k,j)
        end do
!     .......... double division avoids possible underflow ..........
        f = (s / u(i,i)) / g

        do k = i, m
           u(k,j) = u(k,j) + f * u(k,i)
        end do
     end do

460  do j = i, m
        u(j,i) = u(j,i) / g
     end do

     go to 490

475  do j = i, m
        u(j,i) = 0.0_rq
     end do

490  u(i,i) = u(i,i) + 1.0_rq
  end do

!     .......... diagonalization of the bidiagonal form ..........
!     .......... for k=n step -1 until 1 do -- ..........
!510 do 700 kk = 1, n
510 do kk = 1, n
     k1 = n - kk
     k = k1 + 1
     its = 0
!     .......... test for splitting.
!                for l=k step -1 until 1 do -- ..........
520  do ll = 1, k
        l1 = k - ll
        l = l1 + 1
        if (abs(rv1(l)) + anorm .eq. anorm) go to 565
!     .......... rv1(1) is always zero, so there is no exit
!                through the bottom of the loop ..........
        if (abs(w(l1)) + anorm .eq. anorm) go to 540
     end do
!     .......... cancellation of rv1(l) if l greater than 1 ..........
540  c = 0.0_rq
     s = 1.0_rq

     do i = l, k
        f = s * rv1(i)
        rv1(i) = c * rv1(i)
        if (abs(f) + anorm .eq. anorm) go to 565
        g = w(i)
        h = sqrt(f*f+g*g)
        w(i) = h
        c = g / h
        s = -f / h
        if (.not. matu) go to 560

        do j = 1, m
           y = u(j,l1)
           z = u(j,i)
           u(j,l1) = y * c + z * s
           u(j,i) = -y * s + z * c
        end do
560     continue
     end do
!     .......... test for convergence ..........
565  z = w(k)
     if (l .eq. k) go to 650
!     .......... shift from bottom 2 by 2 minor ..........
     if (its .eq. 30) go to 1000
     its = its + 1
     x = w(l)
     y = w(k1)
     g = rv1(k1)
     h = rv1(k)
     f = ((y - z) * (y + z) + (g - h) * (g + h)) / (2.0_rq * h * y)
     g = sqrt(f*f+1.0_rq)
     f = ((x - z) * (x + z) + h * (y / (f + sign(g,f)) - h)) / x
!     .......... next qr transformation ..........
     c = 1.0_rq
     s = 1.0_rq

     do i1 = l, k1
        i = i1 + 1
        g = rv1(i)
        y = w(i)
        h = s * g
        g = c * g
        z = sqrt(f*f+h*h)
        rv1(i1) = z
        c = f / z
        s = h / z
        f = x * c + g * s
        g = -x * s + g * c
        h = y * s
        y = y * c
        if (.not. matv) go to 575

        do j = 1, n
           x = v(j,i1)
           z = v(j,i)
           v(j,i1) = x * c + z * s
           v(j,i) = -x * s + z * c
        end do

575     z = sqrt(f*f+h*h)
        w(i1) = z
!     .......... rotation can be arbitrary if z is zero ..........
        if (z .eq. 0.0_rq) go to 580
        c = f / z
        s = h / z
580     f = c * g + s * y
        x = -s * g + c * y
        if (.not. matu) go to 600

        do j = 1, m
           y = u(j,i1)
           z = u(j,i)
           u(j,i1) = y * c + z * s
           u(j,i) = -y * s + z * c
        end do
600     continue
     end do

     rv1(l) = 0.0_rq
     rv1(k) = f
     w(k) = x
     go to 520
!     .......... convergence ..........
650  if (z .ge. 0.0_rq) go to 700
!     .......... w(k) is made non-negative ..........
     w(k) = -z
     if (.not. matv) go to 700

     do j = 1, n
        v(j,k) = -v(j,k)
     end do
700  continue
  end do

  go to 1001

!     .......... set error -- no convergence to a
!                singular value after 30 iterations ..........
1000 ierr = k

1001 return

end subroutine ssvd

!/hmb/boxcar_f --- boxcar average, ala IDL

subroutine boxcar_f(y,n,w,ys)

  use sep_math

  implicit real(rq) (a-h)
  implicit real(rq) (o-z)

  real(rq) :: y(*), ys(*)
  integer :: n, w
  integer :: hw, i, k, k1, k2

  hw = w / 2
  do i = 1,n
     ys(i) = 0.0_rq
     if (i .le. hw) then
        k1 = 1
        k2 = 2 * i - 1
     elseif (i .gt. n - hw) then
        k1 = 2 * i - n
        k2 = n
     else
        k1 = i - hw
        k2 = i + hw
     endif
     do k = k1,k2
        ys(i) = ys(i) + y(k)
     end do
     ys(i) = ys(i) / (k2 - k1 + 1)
  end do

  return

end subroutine boxcar_f

! $Id: source.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $
 MODULE source_mod
  USE diag_mod
  USE teqPol_mod, only : t_inv_p,t_inv_x
  IMPLICIT NONE
  REAL(rq), DIMENSION(:), ALLOCATABLE,TARGET :: t_wp,t_wpp,t_wppp,t_vp,t_vpp,&
       t_vppp,crjr,psish,crje,rmsh
  REAL(rq), DIMENSION(:), ALLOCATABLE, PRIVATE :: qelm,pelm,selm,rsrv,vptor,&
       gsrf,ea,eax,fff,ffm,x_s,u_s,v_s,w_s,p_c,p_x,p_pc,xx,xd,pcs,ppcs,xxm,&
       yy,pp,wk,ff,f_c,f_pc
  REAL(rq), DIMENSION(:,:), ALLOCATABLE, PRIVATE :: wsk,hh
  INTEGER, DIMENSION(:), ALLOCATABLE, PRIVATE :: k_p,ip,k_f,jnte,knte,ncgp,&
       jbl2,jbu2
  REAL(rq), DIMENSION(:), ALLOCATABLE, SAVE, PRIVATE :: s1,s2,s3,s4,s5
  REAL(rq), DIMENSION(:), ALLOCATABLE, SAVE, PRIVATE :: rsh,zsh,rlsh,zlsh,&
       rce,zce,cce,rcesh,zcesh,cedge,aaa,cs1,cs2,cs3,f_,w_,wp_,psb
  REAL(rq), PRIVATE :: dps,nsp,csph(4),plce,ppe(1),ffpe(1),f_f(1),a,c,s,f(1),&
       d(1,2)
  INTEGER, PRIVATE :: nefit,mlm,mlsh,n_s,lb
  INTEGER, PARAMETER, PRIVATE :: GAMMA=5._rq/3._rq

CONTAINS
 
  SUBROUTINE s_adiabat
    include "debug.i"

    INTEGER lmn,ier,nlagu,lelm_,l,ilag,ll,nlag,jp
    REAL(rq) :: pds(8),prsxo,zamma,yb,tanskew,qcelm_,pcelm_,scelm_,&
         pdp,pdm,fwallu,qdp,qdm,qpp,qp,dflat,dmn,qppp,denom,one,wn,&
         wp0,wnrm,test,qmn,dd,inv_x,xx(4),ddd
         
    SAVE prsxo,nlag,fwallu,inv_x,jp
    DATA prsxo/0/,nlag/20/,fwallu/0/,inv_x/0/
    IF(t_inv_p==0) THEN
       fwallu=ABS(t_fwall)
    ELSEIF(fwallu==0) THEN ! fwall after convergence is always ro*btor and
                           ! and fwallu retains the value of frsrf(msrf) that
                           ! is needed for inv_p=1,-1
       fwallu=ABS(t_fwall)
    END IF
    IF(t_msrf/=SIZE(t_vp)) THEN
       IF(ALLOCATED(t_vp)) DEALLOCATE(t_vp,t_vpp,t_vppp,t_wp,t_wpp,t_wppp)
       ALLOCATE(t_vp(t_msrf),t_vpp(t_msrf),t_vppp(t_msrf),t_wp(t_msrf),&
            t_wpp(t_msrf),t_wppp(t_msrf))
    END IF
    IF(t_msrf/=SIZE(qelm)) THEN
       IF(ALLOCATED(qelm)) DEALLOCATE(qelm,pelm,selm,rsrv,vptor,gsrf,cs1,&
            cs2,cs3,f_,w_,wp_)
       ALLOCATE(qelm(t_msrf),pelm(t_msrf),selm(t_msrf),rsrv(t_msrf),&
            vptor(t_msrf),gsrf(t_msrf),cs1(t_msrf),cs2(t_msrf),cs3(t_msrf),&
            f_(t_msrf),w_(t_msrf),wp_(t_msrf))
    END IF

    IF(jp==0) jp=0.9*t_msrf
    IF(t_inv_x/=0 .AND. t_inv_x/=inv_x) THEN
       inv_x=t_inv_x
       DO jp=t_msrf-1,2,-1
          IF(t_psibar(jp)<=inv_x) EXIT
       END DO
       IF(ALLOCATED(aaa)) DEALLOCATE(aaa,psb)
       ALLOCATE(aaa(t_msrf-jp),psb(jp))
       psb=t_psibar(:jp)
    END IF
    IF(prsxo==0) prsxo=t_prsx
    prsxo=t_prsx ! FIX LDP
    t_ipp=999 ! Fix for new source logic LDP
    nlagu=nlag
    qelm=t_qsave
    selm=t_ssave
    pelm=t_psave
    IF(t_scl==0) t_scl=1.0
    ! This logic models an ELM
    IF(t_lelm/=0) THEN
       IF(t_lelm>0) THEN
          qcelm_=t_qcelm/(1-t_psibar(t_lelm))**3
          pcelm_=t_pcelm/(1-t_psibar(t_lelm))**3
          scelm_=t_scelm/(1-t_psibar(t_lelm))**3
          lelm_=t_lelm
          cs3(t_lelm:)=(t_psibar(t_lelm:)-t_psibar(t_lelm))**3
          cs2(t_lelm:)=cs3(t_lelm:)
       ELSEIF(t_lelm<0) THEN
          lelm_=-t_lelm
          qcelm_=t_qcelm/(1-t_psibar(lelm_))**4
          pcelm_=t_pcelm/(1-t_psibar(lelm_))**3
          scelm_=t_scelm/(1-t_psibar(lelm_))**3
          cs2(lelm_:)=(t_psibar(lelm_:)-t_psibar(lelm_))**3
          cs3(lelm_:)=cs2(lelm_:)*(1-t_psibar(lelm_:))
       END IF
       IF(t_pcelm>0) THEN
          pelm(lelm_:)=t_psave(lelm_:)*(1+pcelm_*cs2(lelm_:))
       ELSEIF(t_pcelm<0) THEN
          pelm(lelm_:)=t_psave(lelm_:)/(1-pcelm_*cs2(lelm_:))
       END IF
       IF(t_scelm>0) THEN
          selm(lelm_:)=t_ssave(lelm_:)*(1+scelm_*cs2(lelm_:))
       ELSEIF(t_scelm<0) THEN
          selm(lelm_:)=t_ssave(lelm_:)/(1-scelm_*cs2(lelm_:))
       END IF
       IF(t_qcelm>0) THEN
          qelm(lelm_:)=t_qsave(lelm_:)*(1+qcelm_*cs3(lelm_:))
       ELSEIF(t_qcelm<0) THEN
          qelm(lelm_:)=t_qsave(lelm_:)/(1-qcelm_*cs3(lelm_:))
       END IF
    END IF
    ! This logic models the current flattening following a disruption
    IF(t_lflat>0) THEN
       DO l=1,t_msrf
          t_lflat=l
          IF(t_qsave(l)>t_qflat) EXIT
       END DO
       pdp=t_psibar(t_lflat+1)-t_psibar(t_lflat)
       pdm=t_psibar(t_lflat-1)-t_psibar(t_lflat)
       qdp=(t_qsave(t_lflat+1)-t_qsave(t_lflat))/pdp
       qdm=(t_qsave(t_lflat-1)-t_qsave(t_lflat))/pdm
       qpp=(qdp-qdm)/(pdp-pdm)
       qp=(qdp*pdm-qdm*pdp)/(pdm-pdp)
       dflat=2*(t_qflat-t_qsave(t_lflat))/qp/(1+sqrt(1+2*&
            (t_qflat-t_qsave(t_lflat))*qpp/qp**2))
       qp=qp+qpp*dflat
       dflat=dflat+t_psibar(t_lflat)
       dmn=-3_rq*t_qrat*(t_qflat-t_qsave(1))/qp
       qpp=-2_rq*qp/dmn
       qppp=-qpp/dmn
       qmn=t_qflat+dmn*(qp+0.5_rq*dmn*(qpp+dmn*qppp/3.0))
      dmn=dmn+dflat
       DO l=1,t_msrf
          lmn=l
          IF(t_psibar(l)>dmn) EXIT
       END DO
       DO l=1,lmn-1
          qelm(l)=qmn
       END DO
       DO l=lmn,t_lflat-1
          dmn=t_psibar(l)-dflat
          qelm(l)=t_qflat+dmn*(qp+0.5_rq*dmn*(qpp+dmn*qppp/3.0))
       END DO
    END IF
    IF(t_lflat/=0) THEN
       IF(t_entropy_flag==0) THEN
          pelm=t_scflat*t_psave
       ELSE
          selm=t_scflat*t_ssave
       END IF
    END IF
    ! END of disruption model
    CALL allocate_separatrix(t_jm,t_km,t_mls,t_nsym,t_n4)
    CALL surfaces_separatrix(t_psibar,t_rlsd,t_zlsd)
    mlm=t_mls/2+1
    t_asrf=0.5_rq*(t_rlsd(t_mls,:,1)-t_rlsd(mlm,:,1))
    t_rsrf=0.5_rq*(t_rlsd(t_mls,:,1)+t_rlsd(mlm,:,1))
    call get_surfint
    f_=TWOPI*qelm/t_rsqbp ! new F
    ier=0
    call boxd_interp (t_raxis,t_zaxis,pds,ier,s_n4)
    IF(t_nsym==2) THEN ! should get same answer as above.
       s_skew=0.5_rq*atan(2*pds(5)/(pds(4)-pds(6)))
       tanskew=tan(s_skew)**2
    END IF

    IF(t_mdpsi.eq.0) THEN
       ll=15
    ELSE
       ll=t_mdpsi
    END IF
  
    denom=prsxo*t_betaj
    ! w_ needs fwallu
    rsrv=t_frsrf*t_fpsrf/FOURPI
    IF(t_ifluxcord==0) THEN
       vptor=t_vpsrf/t_qsrf
    ELSE
       vptor=t_vpsrf
    END IF
    IF(t_entropy_flag==0) THEN
       t_v=pelm/denom/(t_psil-t_psix)
    ELSEIF(t_entropy_flag>0) THEN
       pelm=selm/vptor**GAMMA ! new P
       t_psave=pelm
       t_v=pelm/denom/(t_psil-t_psix)
    ELSEIF(t_entropy_flag<0 .AND. t_nitt==0) THEN
       pelm=selm/vptor**GAMMA ! new P
       t_psave=pelm
       t_v=pelm/denom/(t_psil-t_psix)
    END IF
    w_=(t_w-t_w(ll))/t_scl ! even this subtract. necessitates 2*errt
    yb=t_splbdry
    IF(t_filter_p>2) THEN
       t_v=zero_der_interp(t_psibar,t_v,t_filter_p)
    ELSEIF(t_filter_p>0) THEN
       CALL polyfit_interp(t_v,t_vp,t_psibar,t_dpoly,t_spoly,t_mpoly,-2)
       ! derivative=zero on edge
       yb=777
    ELSEIF(t_filter_p<0) THEN
       CALL polyfit_interp(t_v,t_vp,t_psibar,t_dpoly,t_spoly,t_mpoly,-2)
       yb=777
    END IF
    CALL spline_interp(t_psibar,t_v,yb,yb,t_vp,t_vpp,t_vppp,noint)
    one=1
    DO ilag=1,1
       IF(t_ipj==3) THEN ! jpar and psave profile
          IF(ilag==1) THEN
             call spline_interp(t_psibar,t_v,t_splbdry,t_splbdry,t_vp,t_vpp,&
                  t_vppp,noint)
          END IF
          t_qsrf=t_rsqbp*t_frsrf/TWOPI
          cs1=TWOPI*t_qsrf+t_cusrf/t_frsrf
          t_wp=(t_jparsave*.4_rq*PI-2*denom*t_vp*t_vpsrf/cs1)
          CALL fdInt(t_wp,t_psrf,t_msrf,t_w)
          wn=fwallu-t_w(t_msrf)
          t_w=t_w+wn
          t_w=t_w**2/(2*FOURPI*t_dpsi0)
          call spline_interp(t_psibar,t_w,t_splbdry,t_splbdry,t_wp,t_wpp,&
               t_wppp,noint)
       ELSE  ! q-profile from diff equation, P from p/s save
          IF(ilag==1) THEN
             t_w=t_cusrf/f_
             call spline_interp(t_psrf,t_w,t_splbdry,t_splbdry,wp_,t_wpp,&
                  t_wppp,noint)
          END IF
          cs1=t_frsrf/f_
          cs1=(cs1*(1+cs1)**2*2/((1+cs1)**3+cs1-1))**t_one_pow
          ! --- inverse average of used and wanted
          cs2=t_cusrf/f_+TWOPI*qelm
          cs3=2*denom*t_vp*t_vpsrf/f_+wp_
          t_wp=-cs1*f_**2*cs3/FOURPI/cs2
       END IF ! t_ipj
       yb=t_splbdry
       IF(t_ipj==3) THEN
          ! --- do nothing
       ELSEIF(t_inv_x/=0) THEN
          CALL spline_interp(psb,t_wp,t_splbdry,t_splbdry,gsrf,t_wpp,&
               t_wppp,t_w)
          CALL spline_interp(psb,t_w,yb,yb,t_wp,t_wpp,t_wppp,noint)
          ddd=inv_x-psb(jp)
          xx(1)=t_w(jp)+ddd*(t_wp(jp)+0.5_rq*ddd*(t_wpp(jp)+ddd*t_wppp(jp)/3))
          xx(2)=t_wp(jp)+ddd*(t_wpp(jp)+0.5*ddd*t_wppp(jp))
          xx(3)=t_wpp(jp)+ddd*t_wppp(jp)
          ddd=1-inv_x
          xx(4)=-2*(xx(2)+xx(3)*ddd)/ddd**2
          aaa=t_psibar(jp+1:)-inv_x
          t_w(jp+1:)=xx(1)+aaa*(xx(2)+0.5_rq*aaa*(xx(3)+aaa*xx(4)/3))
          t_wp(jp+1:)=xx(2)+aaa*(xx(3)+0.5_rq*aaa*xx(4))
          t_wpp(jp+1:)=xx(3)+aaa*xx(4)
          t_wppp(jp+1:)=xx(4)
       ELSEIF(t_filter_wp==999) THEN
          wp0=0
          call splider_interp(t_psibar,t_wp,t_w,t_wpp,t_wppp,ndbg10,wp0,jp,&
               ldbg8)
       ELSEIF(t_filter_wp==-999) THEN
          wp0=t_wp(t_msrf)
          call splider_interp(t_psibar,t_wp,t_w,t_wpp,t_wppp,ndbg10,wp0,jp,&
               ldbg8)
       ELSE
          CALL fdInt(t_wp,t_psibar,t_msrf,t_w)
          IF(t_filter_wp>2) THEN
             t_w=zero_der_interp(t_psibar,t_w,t_filter_wp,10,"edge")
          ELSEIF(t_filter_wp>0) THEN
             CALL polyfit_interp(t_w,t_wp,t_psibar,t_dpoly,t_spoly,t_mpoly,-2)
             ! zeroes derivative at edge
             yb=777
          ELSEIF(t_filter_wp<0) THEN
             CALL polyfit_interp(t_w,t_wp,t_psibar,t_dpoly,t_spoly,t_mpoly,1)
             yb=777
          END IF
          call spline_interp(t_psibar,t_w,yb,yb,t_wp,t_wpp,t_wppp,noint)
       END IF
       wn=t_w(t_msrf)
       t_w=t_w-wn
       test=SUM(abs(w_-t_w))/SUM(abs(w_)+abs(t_w))
       cs3=(fwallu**2+2.*FOURPI*t_w*(t_psil-t_psix))
       w_=t_w
       DO l=1,t_msrf
          IF(cs3(l)<=0) call errdetec("fsq<0 in adiabat",1)
       END DO
       t_frsrf=sqrt(cs3)
       IF(test<=2*errt_rq) EXIT
    END DO

    t_fpsrf=FOURPI*t_wp/t_frsrf
    t_pdsrf=denom*t_vp
    t_prsrf=denom*(t_psil-t_psix)*t_v
    t_srsrf=t_prsrf*vptor**GAMMA
    t_w=t_w/prsxo
    t_wp=t_wp/prsxo
    t_wpp=t_wpp/prsxo
    t_wppp=t_wppp/prsxo
    prsxo=t_prsx
    t_jtsrf = 10.*(t_pdsrf+t_bsqrf*t_fpsrf/t_frsrf/FOURPI)/t_rsqirf
    call spline_interp(t_psibar,t_qsrf,t_splbdry,t_splbdry,cs1,cs2,cs3,t_qh)
    t_phibar=t_qh/t_qh(t_msrf)
    IF(t_ifluxcord==2) t_jtsrf=t_qsrf*t_jtsrf
    IF(t_inv_p==-1) THEN
       dd=t_dpsi00/t_dpsi0
       fwallu=fwallu*(t_deltad*dd+1-t_deltad)
       t_fwall=fwallu ! Note at convergence fwall set back to ro*btor
    ELSEIF(t_inv_p==1) THEN
       dd=t_plcm*1.0e+05_rq/t_plc
       fwallu=fwallu*(t_deltad*dd+1-t_deltad)
       t_fwall=fwallu ! Note at convergence fwall set back to ro*btor
    END IF
    IF(ndbg21==1) call debugger
  END SUBROUTINE s_adiabat

!========================================================================
!    calculates total current(plc) and adds relaxation to cjr
!========================================================================
  SUBROUTINE s_current
    REAL(rq) :: suml,sumu,sumc,f1,f2,plco,plcinv,gg,aa,rlsmin,rlsmax,&
         zlsmin,zlsmax
    INTEGER k,jl,ju,j,kl,ku,nnl,nnu,mlsl,mlsu,n,n1
    SAVE plco
    DATA plco / 0.0 /
    n1=0
    IF(ALLOCATED(crjr)) THEN
       n1=SIZE(crjr)
    END IF
    IF(n1/=t_jmkm) THEN
       IF(ALLOCATED(crjr)) DEALLOCATE(crjr)
       ALLOCATE(crjr(t_jmkm))
       crjr=0
    END IF

    IF(t_ipj==11) THEN
       t_plc=-s_pin*t_cusrf(t_msrf)/FOURPI
       return
    END IF
    plcinv=t_plc
    IF((t_kedge==0 .or. t_kedge==10) .AND. t_ipf>=0) THEN
       gg=t_frsrf(t_msrf)*t_fpsrf(t_msrf)
       aa=t_pdsrf(t_msrf)
       t_plc=0
       suml=0
       kl=0
       DO k=1,t_km
          jl=s_jbl(k)
          ju=s_jbu(k)
          IF(jl/=t_jm+1 .AND. ju/=0 .AND. s_jcr(k,1)/=0 .AND. s_jcr(k,2)/=0)&
               THEN
             !   endpoints
             IF(kl==0) kl=k
             IF(t_kedge/=10) THEN
                nnl=jl+t_jm*(k-1)
                nnu=ju+t_jm*(k-1)
                f1=-FOURPI*s_rcr(k,1)*aa-gg/s_rcr(k,1)
                f2=-FOURPI*s_rcr(k,2)*aa-gg/s_rcr(k,2)
                t_plc=t_plc-.5_rq*(t_crj(nnl)/i_r(jl)+f2)*(i_r(jl)-&
                     s_rcr(k,2))/t_dr+.5_rq*t_crj(nnl)/i_r(jl)
                t_plc=t_plc+.5_rq*(t_crj(nnu)/i_r(ju)+f1)*(i_r(ju)-&
                     s_rcr(k,1))/t_dr+.5_rq*t_crj(nnu)/i_r(ju)
             END IF
             sumc=0
             DO j=jl,ju
                sumc=sumc+t_crj(j+t_jm*(k-1))/i_r(j)
             END DO
             t_plc=t_plc-sumc
             IF(suml==0)suml=sumc
             ku=k
          END IF
       END DO
       sumu=sumc
       !---     top and bottom
       call xminmax(s_zlse,1,s_mlse,1,zlsmin,zlsmax,mlsl,mlsu)
       rlsmin=s_rlse(mlsl)
       rlsmax=s_rlse(mlsu)
       f1=-FOURPI*rlsmin*aa-gg/rlsmin
       f2=-FOURPI*rlsmax*aa-gg/rlsmax
       t_plc=t_plc-0.5_rq*((zlsmax-i_z(ku))*(s_rcr(ku,1)-s_rcr(ku,2))*f2-&
            (zlsmin-i_z(kl))*(s_rcr(kl,1)-s_rcr(kl,2))*f1)/t_dr/t_dz+0.5_rq*&
            (sumu+suml)
       !---     END for top and bottom
       t_plc=t_plc*t_dr*t_dz/FOURPI
    ELSEIF(t_kedge>0 .AND. t_ipf>0) THEN
       t_plc=0
       do k=1,t_km
          nnl=jbl2(k)+t_jm*(k-1)
          nnu=jbu2(k)+t_jm*(k-1)
          do n=nnl,nnu
             t_plc=t_plc+t_crj(n)/t_rm(n)
          END do
       END do
       t_plc=-t_plc*t_dr*t_dz/FOURPI
    ELSE
       t_plc=-sum(t_crj/t_rm)*t_dr*t_dz/FOURPI
    END IF
    IF(t_plc==0) CALL errdetec("t_plc=0 in current",0)
    IF(t_ipj>9) THEN
       t_crj=t_crj*plcinv/t_plc
       t_plc=plcinv
    END IF
    t_plc=t_alpha*plco+(1.-t_alpha)*t_plc
    t_crj=t_alpha*crjr+(1.-t_alpha)*t_crj
    plco=t_plc
    IF(t_ipj>=3) t_plc=-s_pin*t_cusrf(t_msrf)/FOURPI
    RETURN
  END SUBROUTINE s_current

  SUBROUTINE s_sourceGS(psin,rsin,crj,pvec)
    !========================================================
    !
    !  sourceGS - calls source for the complete grid
    !  returns crj, the rhs of G-S eq and pvec, F
    !  overwrites psin BEWARE
    !
    !========================================================
    REAL(rq), DIMENSION(:), INTENT(INOUT) :: psin
    REAL(rq), DIMENSION(:), INTENT(IN)    :: rsin
    REAL(rq), DIMENSION(:), INTENT(OUT)   :: crj,pvec
    REAL(rq) ,DIMENSION(SIZE(crj)) :: bt

    INTEGER :: nkl,n,nn,i,n1
    include "debug.i"
    n1=0
    IF(ALLOCATED(p_x)) THEN
       n1=SIZE(p_x)
    END IF
    IF(n1/=s_mxpt) THEN
       IF(ALLOCATED(p_x)) DEALLOCATE(p_x,p_c,p_pc,k_p,f_c,f_pc,k_f)
       ALLOCATE(p_x(s_mxpt),p_c(s_mxpt),p_pc(s_mxpt),k_p(s_mxpt),f_c(s_mxpt),&
            f_pc(s_mxpt),k_f(s_mxpt))
       p_x=0;p_c=0;p_pc=0;k_p=0;f_c=0;f_pc=0;k_f=0
    END IF
    nn=0
    crj=0
    pvec=0
    p_x=0;p_c=0;p_pc=0
    bt=0
    DO n=1,t_jmkm
       IF(s_lxpt(n)==0) THEN
          nn=nn+1
          k_p(nn)=n
          p_x(nn)=(psin(n)-t_psix)/(t_psil-t_psix)
       END IF
    END DO
    call s_source(p_x,p_c,p_pc,0) ! Pressure
    IF(t_ircwt==9) CALL parsestr("relax_s")
    call s_source(p_x,f_c,f_pc,1) ! F
    DO n=1,s_mxpt
       i=k_p(n)
       crj(i)=-FOURPI*rsin(i)**2*p_pc(n)-f_pc(n)*f_c(n)
       pvec(i)=p_c(n)
       bt(i)=f_c(n)
    END DO

    IF(s_nxpt/=0) THEN ! outside region is force free
       IF(SIZE(p_x)/=s_nxpt) THEN
          IF(ALLOCATED(p_x)) DEALLOCATE(p_x,f_c,f_pc,k_f)
          ALLOCATE(p_x(s_nxpt),f_c(s_nxpt),f_pc(s_nxpt),k_f(s_nxpt))
          p_x=0;f_c=0;f_pc=0;k_f=0
       END IF
       nn=0
       DO n=1,t_jmkm
          IF(s_lxpt(n)==-1) THEN
             nn=nn+1
             k_f(nn)=n
             p_x(nn)=(psin(n)-t_psix)/(t_psil-t_psix)
          END IF
       END DO
       call s_source(p_x,f_c,f_pc,2) ! F
       DO n=1,s_nxpt
          i=k_f(n)
          crj(i)=-f_pc(n)*f_c(n)
          bt(i)=f_c(n)
       END DO
    END IF
    psin=bt
    WHERE(s_lxpt==1) psin=t_fwall

    IF(t_ipp==-999) RETURN

    IF(t_kedge<0) THEN  !  just sets up current on grid
       call s_current
       return
    ELSEIF(t_kedge==0 .or. t_kedge==10) THEN
       call s_current
    ELSEIF(t_kedge==1) THEN
       call s_edgecur1
       call s_current
    ELSE
       call s_edgecur2
       call s_current
    END IF

  END SUBROUTINE s_sourceGS

  SUBROUTINE s_source(x,pc,ppc,jip)
    !
    !*********************************************************************
    !                                                                    *
    !  SOURCE CALCULATES PRESSURE,ETC AND/OR F AS A FUNCTION OF FLUX     *
    !  RETURNS P,P'IF JIP=0 or F,F' IF JIP/=0 IN PC,PPC                  *
    !  RETURNS OHMIC PROFILE in PC IF JIP=-1                             *
    !  N IS THE DIMENSION of X (DIMENSIONLESS FLUX),P, AND PPC           *
    !  IPP IPF -- (INPUT) OPTION FLAG FOR FUNCTIONAL FORM IN X           *
    !  PROFILE                                                           *
    !  IPP=1   P' STRICKLER'S FORM, exp(-ALFA(1)*x)                      *
    !  IPP=2   P' exp-(ALFA(1)*x)-AAP*(-ALFA(1)*BETP(1)*x      )         *
    !  IPP=3   P = (1-X**BETP(1))**ALFA(1)                               *
    !  IPP=4   P FLAT TO AAP THEN (1-((X-AAP)/(1-AAP))**BETP(1))**ALFA(1)*
    !  IPP=5   P=(1-XX)**ALFA                                            *
    !          XX=X**BETA; BETA<2 ELSE  XX=((X+2-BETA)/(3-BETA))**2      *
    !          AND BECOMES HOLLOW                                        *
    !  IPP=6   P=(1-XA)**AA; IF ALFA>1 XA=XX AND AA=ALFA                 *
    !          ELSE AA=1 AND XA=XX/(1-ALFA*(1-XX)/XX*ALOG(1-XX))         *
    !          XX=X**BETA; BETA<2 ELSE  XX=((X+2-BETA)/(3-BETA))**2      *
    !          AND BECOMES HOLLOW                                        *
    !  IPP=7   EFIT FORMS USES PEFIT/FEFIT/ AS COEFFS. FOR P'            *
    !  IPP=|999| SPLINE; USES V,VP,VPP,VPPP                              *
    !  *******************************************************************
    !  IPJ=0   FF'-PROFILE SPECIFIED WITH IPF SEE IPP ABOVE              *
    !  IPF<=0  SPHEROMAK(RFP) LAMBDA=1+SUM(ASPH(I)*X**I  (INSIDE)        *
    !  IPF<0   SPHEROMAK OUTSIDE WITH BSPH F=FWALL AT PSI=0              *
    !          RFP WITH BTOR <0                                          *
    !  IPJ=2   OHMIC PROFILE FIXED USES IPF FORMS: NOTE USES PC          *
    !  IPJ=3   FF' FROM JPARSAVE AND PSAVE, P FROM PSAVE                 *
    !  IPJ=5   FF' FROM QSAVE and P FROM PSAVE                           *
    !  EPP     ADDS A BUMP TO P ~EPP*X**|NPP|*(1-X)**2;                  *
    !          (1-X)**2 PART IF NPP<0; NORMALIZED TO EPP                 *
    !  EPF     ADDS A BUMP TO FF' USING NPF, SEE EPP. WILL ALSO ADD      *
    !          BUMP TO OHMIC PROFILE IF JIP=-1                           *
    !  IPF=|999| SPLINE; USES W,WP,WPP,WPPP IF IPJ>=2 USES SAME          *
    !          COEFFICIENTS FOR FF'                                      *
    !                                                                    *
    !*********************************************************************
    INTEGER, INTENT(IN) :: jip
    REAL(rq), DIMENSION(:), INTENT(IN)  :: x
    REAL(rq), DIMENSION(:), INTENT(OUT) :: pc,ppc
    INTEGER  :: mbsp,i,j,k,l,n,ispc,jjp,nn,ier,no
    REAL(rq) :: t0,temx,tempx,ss(2,2),tt(2),bdc(t_jm)
    REAL(rq) :: pds(8),nasp1,nbsp1,zpsph,zcsph(4),zpemp,zpump,z0(4)
    REAL(rq) :: coef,fwallsq,zbf,zprbet,pemp,pump,fp,fp_pri,sqzbf,d_s
    REAL(rq) :: fdf,zfp,xp,xpp,dx,suma,sumf,z00,alfe,zz,bbp,pfn,fpf,ppn,fpp
    REAL(rq) :: rll,ruu,zzz
    include "debug.i"
    
    n_s=SIZE(x)
    IF(ALLOCATED(ea)) THEN
       IF(n_s/=SIZE(ea)) &
          DEALLOCATE(ea,eax,fff,ffm,x_s,u_s,v_s,w_s,xx,xd,pcs,&
            ppcs,xxm,yy,ip,wsk)
    ENDIF
    IF (.NOT.ALLOCATED(ea)) THEN
       ALLOCATE(ea(n_s),eax(n_s),fff(n_s),ffm(n_s),x_s(n_s),u_s(n_s),v_s(n_s),&
            w_s(n_s),xx(n_s),xd(n_s),pcs(n_s),ppcs(n_s),xxm(n_s),yy(n_s),&
            ip(n_s),wsk(n_s,0:4))
       ea=0;eax=0;ffm=0;x_s=0;u_s=0;v_s=0;w_s=0;xx=0;xd=0;ppcs=0;pcs=0;xxm=0
       yy=0;ip=0;wsk=0
    END IF

    IF(ALLOCATED(t_vp)) THEN
       IF(t_msrf/=SIZE(t_vp)) &
          DEALLOCATE(t_vp,t_vpp,t_vppp,t_wp,t_wpp,t_wppp)
    ENDIF
    IF(.NOT.ALLOCATED(t_vp)) THEN
       ALLOCATE(t_vp(t_msrf),t_vpp(t_msrf),t_vppp(t_msrf),t_wp(t_msrf),&
            t_wpp(t_msrf),t_wppp(t_msrf))
       IF(IABS(t_ipf)==999)&
            CALL spline_interp(t_psibar,t_w,t_splbdry,t_splbdry,t_wp,t_wpp,&
            t_wppp,noint)
       IF(IABS(t_ipp)==999)&
            CALL spline_interp(t_psibar,t_v,t_splbdry,t_splbdry,t_vp,t_vpp,&
            t_vppp,noint)
    END IF
    nefit=5
    coef=-5.0e-09*t_dr*t_dz
    IF(t_ircwt==9) THEN
       wsk(:,0:4)=0
    END IF

    dps=t_psil-t_psix
    fwallsq=t_frsrf(t_msrf)**2
    IF(t_inv_eq==0) fwallsq=t_fwall**2 ! LDP 97/08/014
    zbf=FOURPI*(1.-t_betaj)*t_ro**2
    zprbet=t_prsx*t_betaj

    !
    ! Spheromak logic
    !
    zpsph=0
    zcsph=0
    nasp1=t_nasp+1
    nbsp1=t_nbsp+1
    pemp=0
    pump=0
    fp=1+sum(t_asph)
    fp_pri=fp
    IF(t_ipf==0 .OR. t_ipf==-1) sqzbf=sqrt(zbf*t_prsx)
    IF(t_ipf==-1) THEN ! Spheromak with gun
       zpsph=0
       IF(t_psph/=0) zpsph=(t_psph-t_psix)/(t_psil-t_psix)
       z0(1)=-t_psix/dps
       z0(2)=z0(1)**2
       z0(3)=z0(1)**3
       z0(4)=z0(1)**t_nbsp
       csph=t_bsph/z0
       IF(t_gsph/=0 .AND. t_xsph/=0) THEN
          temx=t_xsph**t_gsph
          IF(t_gsph==-1) THEN
             tempx=log(t_xsph)
          ELSE
             tempx=(t_xsph**(t_gsph+1)-1)/(t_gsph+1)
          END IF
       END IF
       zcsph=0
       IF(t_bsph_flag/=0) THEN
          IF(t_psph==0) THEN ! continuous derivative for lambda
             fdf=(t_asph(1)+2*t_asph(2)+3*t_asph(3)+t_nasp*t_asph(4))/(1+&
                  sum(t_asph))
             call sph(csph,t_bsph,z0,fdf,t_bsph_flag,t_nbsp)
          ELSE
             IF(t_bsph(1)/=0) THEN
                zcsph(1)=-t_bsph(1)/zpsph
             ELSEIF(t_bsph(2)/=0) THEN
                zcsph(2)=-t_bsph(2)/zpsph**2
             ELSEIF(t_bsph(3)/=0) THEN
                zcsph(3)=-t_bsph(3)/zpsph**3
             ELSEIF(t_bsph(4)/=0) THEN
                zcsph(4)=-t_bsph(4)/zpsph**t_nbsp
             ELSE
                zcsph(4)=-1/zpsph**t_nbsp
             END IF
          END IF
       END IF
       fp=(1+sum(t_asph))/(1+sum(csph))
       zfp=(1+sum(t_asph))/(1+sum(zcsph))
       ! lamda on plasma edge or at gun IF (rgun,zgun) set
       fwallsq=t_fwall**2
       zpemp=zfp*((1-z0(1))+zcsph(1)*(1-z0(2))/2+zcsph(2)*(1-z0(3))/3+&
            zcsph(3)*(1-z0(3)*z0(1))/4+zcsph(4)*(1-z0(4)*z0(1))/nbsp1)
       zpump=zpemp/(1+sum(t_asph))
       pemp=fp*((1-z0(1))+csph(1)*(1-z0(2))/2+csph(2)*(1-z0(3))/3+&
            csph(3)*(1-z0(3)*z0(1))/4+csph(4)*(1-z0(4)*z0(1))/nbsp1)
       pump=pemp/(1+sum(t_asph))
       IF(t_rgun/=0) THEN 
          call boxd_interp(t_rgun,t_zgun,pds,ier,s_n4)
          z00=(pds(1)-t_psix)/t_dpsi0
       ELSE ! "rgun" at extremum in flux
          rll=t_rwl(t_km-1);zzz=i_z(t_km-1);ruu=t_rwu(t_km-1)
          
          DO j=1,t_jm
             bdc(j)=(t_psi(j+t_jm*(t_km-2))-t_psix)/dps
          END DO
          t0=xminaf(bdc,t_jwl(t_km-1),t_jwu(t_km-1),1,j)
          ier=1
          IF(j<t_jwl(t_km-1)) THEN
             call boxd_interp(rll,zzz,pds,ier,s_n4)
             t0=(pds(1)-t_psix)/dps
          ELSEIF(j>t_jwu(t_km-1)) THEN
             call boxd_interp(ruu,zzz,pds,ier,s_n4)
             t0=(pds(1)-t_psix)/dps
          ELSEIF(j/=t_jwl(t_km-1) .AND. j/=t_jwu(t_km-1)) THEN
             xp=0.5_rq*(bdc(j+1)-bdc(j-1))
             xpp=bdc(j+1)+bdc(j-1)-2*bdc(j)
             dx=-xp/xpp
             t0=t0+dx*(xp+0.5_rq*dx*xpp)
          END IF
          t_fgun= -(fp*((t0-1)+csph(1)*(t0**2-1)/2+csph(2)*(t0**3-1)/3+&
               csph(3)*(t0**4-1)/4+csph(4)*(t0**nbsp1-1)/nbsp1)+pemp)*&
               sqzbf+t_fwall
          t_lamdagun=-sqzbf*fp*(1+csph(1)*t0+csph(2)*t0**2+csph(3)*t0**3+&
               csph(4)*t0**t_nbsp)/t_dpsi0
       END IF
       suma=sqzbf**2*(1+sum(t_asph))
       ! outside delta F/(psil-psix)
    ELSEIF(t_ipf==-8) THEN
       sumf=zbf*(1+sum(t_asph))
       pemp=-sumf*t_psil/dps/zbf
       t_lamdagun=-sqrt(-t_prsx*sumf*dps/t_psil)/dps
    END IF
    !
    ! END Spheromak logic
    !

    IF(t_ipj==0 .AND. (t_ipf==0 .or. t_ipf==1)) THEN 
       pc=t_fwall ! spheromak
    ELSE
       pc=fwallsq
    END IF

    IF(jip==0) THEN
       ispc=1
    ELSE
       ispc=0
    END IF
    jjp=iabs(jip)

    !     Profiles for either FF' or P' or <J.B>

    IF(t_ipp==iabs(999) .AND. jip==0) THEN ! splines for P'
       !        zprbet=betaj
       DO nn=1,n_s
          DO l=2,t_msrf
             IF(t_psibar(l)>=x(nn)) EXIT
          END DO
          ip(nn)=l-1
       END DO
       DO nn=1,n_s
          i=ip(nn)
          zz=x(nn)-t_psibar(i)
          pc(nn)=(t_v(i)+zz*(t_vp(i)+0.5_rq*zz*(t_vpp(i)+zz*t_vppp(i)/3)))*dps
          ppc(nn)=(t_vp(i)+zz*(t_vpp(i)+0.5_rq*zz*t_vppp(i)))
       END DO
       !
    ELSEIF((t_ipf==iabs(999) .or. t_ipj/=0) .AND. jip==1) THEN
       ! splines for FF'
       zbf=FOURPI
       DO nn=1,n_s
          DO l=2,t_msrf
             IF(t_psibar(l)>=x(nn)) EXIT
          END DO
          ip(nn)=l-1
       END DO
       DO nn=1,n_s
          i=ip(nn)
          zz=x(nn)-t_psibar(i)
          pc(nn)=(t_w(i)+zz*(t_wp(i)+0.5_rq*zz*(t_wpp(i)+zz*t_wppp(i)/3)))*dps
          ppc(nn)=(t_wp(i)+zz*(t_wpp(i)+0.5_rq*zz*t_wppp(i)))
       END DO
       !
    ELSEIF((jip==0 .AND. t_ipp==1) .or. (jjp==1 .AND. t_ipf==1)) THEN
       CALL Expalf(t_alfa(ispc),x,pc,ppc)  ! Strickler's form
       ! 
    ELSEIF((jip==0 .AND. t_ipp==2) .or. (jjp==1 .AND. t_ipf==2)) THEN
       !  Diff of Strickler's
       CALL Expalf(t_alfa(ispc),x,pcs,ppcs)
       alfe=t_alfa(ispc)*t_betp(ispc)
       CALL Expalf(alfe,x,pc,ppc)
       pc =(pc-t_aap*pcs)
       ppc=(ppc-t_aap*ppcs)
       ! 
    ELSEIF((jip==0 .AND. t_ipp==3) .or. (jjp==1 .AND. t_ipf==3)) THEN
       ! ppc=(1.-x**t_betp)**t_alfa;
       CALL Parab(t_alfa(ispc),t_betp(ispc),x,pc,ppc)
       ! 
    ELSEIF((jip==0 .AND. t_ipp==4) .or. (jjp==1 .AND. t_ipf==4)) THEN
       ! flat out to x=aap
       IF(t_aap/=0) THEN
          x_s=x
          WHERE (x<=t_aap)
             x_s=0
          ELSEWHERE
             x_s=(x-t_aap)/(1-t_aap)
          END WHERE
          CALL Parab(t_alfa(ispc),t_betp(ispc),x_s,pc,ppc)
          ppc=ppc/(1-t_aap)
          WHERE(x<=t_aap)
             ppc=0
          END WHERE
       ELSE
        CALL Parab(t_alfa(ispc),t_betp(ispc),x,pc,ppc)         
       END IF
       ! 
    ELSEIF((jip==0 .AND. t_ipp==5) .or. (jjp==1 .AND. t_ipf==5)) THEN
       !   hollow current
       IF(t_betp(ispc)<=2) THEN
          xx=x**(t_betp(ispc)-1)
          xd=t_betp(ispc)*xx
          xx=xx*x
       ELSE
          xd=2*(x+2-t_betp(ispc))/(3-t_betp(ispc))**2
          xx=0.5_rq*xd*(x+2-t_betp(ispc))
       END IF
       pc=abs(1-xx)**(t_alfa(ispc)-1)
       ppc=-t_alfa(ispc)*pc*xd/dps
       pc=pc*(1-xx)
       ! 
    ELSEIF((jip==0 .AND. t_ipp==6) .or. (jjp==1 .AND. t_ipf==6)) THEN
       IF(t_betp(ispc)<=2) THEN
          xx=x**(t_betp(ispc)-1)
          xd=t_betp(ispc)*xx
          xx=xx*x
       ELSE
          xd=2*(x+2.-t_betp(ispc))/(3.-t_betp(ispc))**2
          xx=0.5_rq*xd*(x+2.-t_betp(ispc))
       END IF
       xxm=abs(1.-xx)
       IF(t_alfa(ispc)>=1) THEN
          pcs=xxm**(t_alfa(ispc)-1)
          ppc=t_alfa(ispc)*pcs/dps*xd
          pc=pcs*xxm
       ELSEIF(t_alfa(ispc)<1) THEN
          pcs=xxm*(log(abs(xxm-errb_rq))-errt_rq)/(xx+&
               errt_rq)
          ppcs=(t_alfa(ispc)-1)*pcs+1
          pc=(1.-pcs/ppcs)
       END IF
    ELSEIF(t_ipp==7 .AND. jip==0) THEN  !  Efit form for P'
       IF(t_nbsp>4) nefit=nbsp1
       CALL Efit(x,pc,ppc,t_pefit(1),t_pefit(2),t_pefit(3),t_pefit(4),&
            t_pefit(5))
       !
    ELSEIF(t_ipf==7 .AND. jjp==1) THEN  !  Efit form for FF'
       CALL Efit(x,pc,ppc,t_fefit(1),t_fefit(2),t_fefit(3),t_fefit(4),&
            t_fefit(5))
       !
    ELSEIF((jip==0 .AND. t_ipp==8) .or. (jjp==1 .AND. t_ipf==8)) THEN
       ! sum of two pieces
       xxm=abs(1.-x)+errb_rq
       pcs=(1.-t_betp(ispc))*xxm**(t_ipp-6)
       ppcs=(t_ipp-6)*pcs
       pcs=pcs*xxm
       IF(t_alfa(ispc)>=1) THEN
          yy=t_betp(ispc)*xxm**(t_alfa(ispc)-1)
          pc=(pcs+yy*xxm)
          ppc=-(ppcs+t_alfa(ispc)*yy)/dps
       ELSEIF(t_alfa(ispc)<1) THEN
          yy=(t_alfa(ispc)-1)*xxm*log(abs(xxm))/x+1
          pc=(pcs+t_betp(1)*(1.-x/yy))
          ppc=pcs   !   not complete must fix
       END IF
    END IF
    !
    IF(t_epf/=0 .AND. iabs(t_ipf)/=999 .AND. jip==-1) THEN
       ! Add a bump to the ohmic current
       bbp=0
       pcs=0
       IF(t_ipp==4) THEN ! correction for x>aap
          bbp=t_aap
          xx=(x-bbp)/(1-bbp)
       ELSE
          xx=x
       END IF
       IF(t_npf<0) THEN
          pfn=-t_npf
          fpf=-t_npf
          fpf=(1.+fpf)**(1+pfn)/fpf**pfn
          WHERE(x>bbp) 
             pcs=t_epf*fpf*xx**pfn*(1-xx)
          END WHERE
       ELSE
          WHERE(x>bbp) 
             pcs=t_epf*xx**t_npf
          END WHERE
       END IF
       pc=pc+pcs
    END IF

    IF(jip==-1) THEN ! Only for Ohmic profile
       pc=t_prsx*pc*t_ro**2
       return
    END IF
    ! 
    ! END profiles for either FF' or P' or <J.B>
    !
    IF(jip==0) THEN
       IF(t_epp/=0 .AND. iabs(t_ipp)/=999) THEN ! Add a bump to the pressure 
          bbp=0
          IF(t_ipp==4) THEN ! correction for x>aap
             bbp=t_aap
             xx=(x-bbp)/(1-bbp)
          ELSE
             xx=x
          END IF
          pcs=0
          ppcs=0
          IF(t_npp<0) THEN
             ppn=-t_npp
             fpp=t_epp*(ppn/2+1)**2*(1+2/ppn)**ppn
             WHERE(x>bbp)
                pcs=fpp*xx**ppn*(1-xx)**2
             ELSEWHERE
                pcs=fpp*xx**(ppn-1)*(1-xx)*(ppn-(ppn+2)*&
                xx)/(dps*(1-bbp))
             END WHERE
          ELSE
             fpp=t_epp*(t_npp+1)*(1+1/t_npp)**t_npp
             WHERE(xx>bbp)
                pcs=fpp*(t_npp-(t_npp+1)*xx)*xx**(t_npp-1)/&
                     (dps*(1-bbp))
             ELSEWHERE
                ppcs=fpp*(1.-xx)*xx**t_npp
             END WHERE
          END IF
          pc=pc+pcs
          ppc=ppc+ppcs
       END IF
       !
       pc =zprbet*pc
       ppc=zprbet*ppc
       return
    END IF
    !
    ! Spheromak
    IF(t_ipf==8 .or. t_ipf==-8) THEN  !  Spheromak, but FF'
       IF(jip==1) THEN ! inside separatrix
          IF(t_nasp>4) nefit=nasp1
          CALL Efit(x,pcs,ppc,1.0_rq,t_asph(1),t_asph(2),t_asph(3),t_asph(4))
          pc=(pemp+2*pcs)
          IF(t_ircwt==9) THEN
             d_s=-1_rq/dps
             IF(t_lsph/=0) wsk(:,0)=d_s
             IF(t_nsph>=1) wsk(:,1)=d_s*x
             IF(t_nsph>=2) wsk(:,2)=d_s*x_s
             IF(t_nsph>=3) wsk(:,3)=d_s*u_s
             IF(t_nsph==4) wsk(:,4)=d_s*v_s
          END IF
       ELSEIF(jip==2) THEN ! outside plasma
          ppc=pemp*(t_psix+x*dps)/t_psil**2
          pc=pemp*((t_psix+x*dps)/t_psil)**2
          IF(t_ircwt==9) THEN
             IF(t_lsph/=0) wsk(:,0)=ppc/sumf
             IF(t_nsph>=1) wsk(:,1)=ppc/sumf
             IF(t_nsph>=2) wsk(:,2)=ppc/sumf
             IF(t_nsph>=3) wsk(:,3)=ppc/sumf
             IF(t_nsph==4) wsk(:,4)=ppc/sumf
          END IF
       END IF
       ! 
       ELSEIF(t_ipf==0 .or. t_ipf==-1) THEN ! Spheromak
       IF(jip==1) THEN ! inside separatrix
          nsp=t_nasp
          CALL Sphero(x,eax,ea,t_asph(1),t_asph(2),t_asph(3),t_asph(4))
          ppc=-ea
          pc=-(eax+pemp)
          IF(t_ircwt==9) THEN
             IF(t_lsph/=0) wsk(:,0)=(eax+pemp)/dps+ea*(x-1+pump)
             IF(t_nsph>=1) wsk(:,1)=(eax+pemp)*x/dps+&
                  ea*((u_s-1)/2+pump)
             IF(t_nsph>=2) wsk(:,2)=(eax+pemp)*u_s/dps+&
                  ea*((v_s-1)/3+pump)
             IF(t_nsph>=3) wsk(:,3)=(eax+pemp)*v_s/dps+&
                  ea*((w_s-1)/4+pump)
             IF(t_nsph==4) wsk(:,4)=(eax+pemp)*x_s/dps+&
                  ea*((x_s-1)/(nsp+1)+pump)
          END IF
       ELSEIF(jip==2) THEN ! outside region od spheromak
          nsp=t_nbsp
          CALL Sphero(x,xd,xx,csph(1),csph(2),csph(3),csph(4))
          ppc=-xx*fp
          pc=-(xd*fp+pemp)
          IF(t_gsph==-1) THEN
             WHERE(x>=t_xsph .AND. x<1)
                xx=1/x/dps
                xd=log(x)
                ppc=-xx*fp_pri
                pc=-(xd*fp_pri+pemp)
             END WHERE

             WHERE(x<t_xsph)
                xx=temx/dps
                xd=tempx+(x-t_xsph)*temx
                ppc=-xx*fp_pri
                pc=-(xd*fp_pri+pemp)
             END WHERE
          ELSEIF(t_gsph/=0) THEN
             WHERE(x>=t_xsph .AND. x<1)
                xx=x**t_gsph/dps
                xd=(x**(t_gsph+1)-1)/(t_gsph+1)
                ppc=-xx*fp_pri
                pc=-(xd*fp_pri+pemp)
             END WHERE

             WHERE(x<t_xsph)
                xx=temx/dps
                xd=tempx+(x-t_xsph)*temx
                ppc=-xx*fp_pri
                pc=-(xd*fp_pri+pemp)
             END WHERE
          END IF
          IF(zpsph/=0) THEN
             CALL Sphero(x,xd,xx,zcsph(1),zcsph(2),zcsph(3),zcsph(4))
             WHERE(x<1 .AND. x>zpsph)
                ppc=-xx*zfp
                pc=-(xd*zfp+zpemp)
             END WHERE
          END IF
          IF(t_ircwt==9) THEN ! Speheromak reconstruction (needs work
             IF(t_lsph/=0) wsk(:,0)=2*pc*ppc/suma
             IF(t_nsph>=1) wsk(:,1)=2*pc*ppc/suma
             IF(t_nsph>=2) wsk(:,2)=2*pc*ppc/suma
             IF(t_nsph>=3) wsk(:,3)=2*pc*ppc/suma
             IF(t_nsph==4) wsk(:,4)=2*pc*ppc/suma
          END IF
       END IF
    END IF
    !
    IF(t_ipf==0 .or. t_ipf==-1) THEN
       pc=sqzbf*pc+t_fwall ! spheromak
       ppc=sqzbf*ppc
    ELSE
       IF(t_epf/=0 .AND. t_ipj==0 .AND. iabs(t_ipf)/=999)THEN
          ! Add a bump to FF'
          IF(t_ipf==4) THEN
             bbp=t_aap
             xx=(x-t_aap)/(1-t_aap)
          ELSE
             xx=x
             bbp=0
          END IF
          IF(t_npf<0) THEN
             pfn=-t_npf
             fpf=t_epf*(pfn/2+1)**2*(1+2/pfn)**pfn
             xx=(x-bbp)/(1-bbp)
             WHERE(x>bbp)
                pc=pc+fpf*xx**pfn*(1-xx)**2
                ppc=ppc+fpf*xx**(pfn-1)*(1-xx)* (pfn-(pfn+2)*&
                     xx)/(dps*(1-bbp))
             END WHERE
          ELSE   
             fpf=t_epf*(t_npf+1)*(1+1/t_npf)**t_npf
             WHERE(x>bbp)
                pc=pc+fpf*(1.-xx)*xx**t_npf
                ppc=ppc+fpf*(t_npf-(t_npf+1)*xx)*xx**(t_npf-1)/&
                     (dps*(1-bbp))
             END WHERE
          END IF
       END IF
       ! 
       pc=2*zbf*t_prsx*pc+fwallsq
       ppc=zbf*t_prsx*ppc
       DO i=1,n_s
          IF(pc(i)<0) THEN
             call remark('warning("fsq<0 use absolute value and continue")')
             EXIT
          END IF
       END DO
       pc=sqrt(abs(pc))
       ppc=ppc/pc
       
    END IF
    ! 
    IF(t_ircwt==9) THEN ! spheromak
       call reconstruct(wsk,SIZE(ea),jip)
       IF(t_lsph==1 .AND. jip==0) THEN
          DO j=1-iabs(t_lsph),t_nsph
             t_splw(t_nloop0p+1,j)=1.e-6*t_fgun/FP
          END DO
       ELSE
          t_gplc=-1e-5*zbf*t_prsx*t_gplc/FOURPI
          t_gcw=coef*zbf*t_prsx*t_gcw*t_gcw
          t_gplw=zbf*t_prsx*t_gplw
       END IF
    END IF

  END SUBROUTINE S_SOURCE

  SUBROUTINE sph(csph,t_bsph,z0,del,bsph_flag,t_nbsp)

    REAL(rq) :: csph(4),t_bsph(4),z0(4),ss(2,2),tt(2),del,uu,t_nbsp,n1,n2
    INTEGER bsph_flag,l1,l2

    uu=csph(1)*(1-del)+csph(2)*(2-del)+csph(3)*(3-del)+csph(4)*(t_nbsp-del)&
         -del
    IF(bsph_flag<5) THEN
       l1=bsph_flag
       n1=l1
       IF(l1==4) n1=t_nbsp
       csph(l1)=(uu-csph(l1)*(n1-del))/(del-n1)
       t_bsph(l1)=z0(l1)*csph(l1)
    ELSE
       l1=bsph_flag/10
       l2=bsph_flag-10*l1
       n1=l1
       n2=l2
       IF(l1==4) THEN
          n1=t_nbsp
       ELSEIF(l2==4) THEN
          n2=t_nbsp
       END IF
       ss(1,1)=n1*z0(l1)
       ss(1,2)=n2*z0(l2)
       ss(2,1)=(n1-del)
       ss(2,2)=(n2-del)
       call rmInvert(ss,2,2)
       tt(2)=uu-csph(l1)*(n1-del)-csph(l2)*(n2-del)
       uu=csph(1)*z0(1)+2*csph(2)*z0(2)+3*csph(3)*z0(3)+t_nbsp*csph(4)*z0(4)
       tt(1)=uu-n1*csph(l1)*z0(l1)-n2*csph(l2)*z0(l2)
       csph(l1)=-ss(1,1)*tt(1)-ss(1,2)*tt(2)
       csph(l2)=-ss(2,1)*tt(1)-ss(2,2)*tt(2)
       t_bsph(l1)=z0(l1)*csph(l1)
       t_bsph(l2)=z0(l2)*csph(l2)
    END IF

    RETURN
  END SUBROUTINE sph

  SUBROUTINE reconstruct(wsk,n,jin)
    INTEGER, INTENT(IN) :: jin,n
    REAL(rq), INTENT(IN) :: wsk(n,0:t_nsph)
    INTEGER :: jix(n_s),i,j,nn
    REAL(rq) :: rr(n_s)

    IF(jin==0) THEN
       t_gcw=0
       t_gplc=0
       t_gplw=0
       DO i=1,t_jmkm
          IF(s_lxpt(i)==0) THEN ! inside separatrix
             nn=nn+1
             jix(nn)=i
             rr(nn)=t_rm(i)
          END IF
       END DO
    ELSE
       DO i=1,t_jmkm
          IF(s_lxpt(i)==-1) THEN ! outside separatrix
             nn=nn+1
             jix(nn)=i
             rr(nn)=t_rm(i)
          END IF
       END DO
    END IF

    DO j=1,1-iabs(t_lsph),t_nsph
       DO nn=1,n_s
          i=jix(nn)
          t_gcw(:,j)=t_gcw(:,j)+t_gc(i,1,:)*wsk(nn,j)/rr(nn)
          t_gplw(:,j,:)=t_gplw(:,j,:)+t_gpl(i,:,:)/rr(nn)
       END DO
       t_gplc(j)=t_gplc(j)+sum(wsk(:,j)/rr)
    END DO
    RETURN

  END SUBROUTINE reconstruct

  SUBROUTINE s_xohmic(nret,iter)
    USE teqGS_mod, only : t_prsx01
    include "debug.i"
    !
    ! compute t_w,wp,wpp,wppp for subroutine source
    ! t_frsrf is leftover-on CALL to xohmic from equila, an initial cond.
    !
    REAL(rq) :: pds(8),wp0,dps,fwallu,test
    REAL(rq), DIMENSION(t_msrf) :: cs1,cs2,cs3
    INTEGER nret,iter,ier,l,n1
    n1=0
    IF(ALLOCATED(t_wp)) THEN
       n1=SIZE(t_wp)
    END IF
    IF(n1/=t_msrf) THEN
       IF(ALLOCATED(t_vp)) DEALLOCATE(t_wp,t_wpp,t_wppp,t_vp,t_vpp,t_vppp)
       ALLOCATE(t_wp(t_msrf),t_wpp(t_msrf),t_wppp(t_msrf),t_vp(t_msrf),&
            t_vpp(t_msrf),t_vppp(t_msrf))
    END IF
    n1=0
    IF(ALLOCATED(s1)) THEN
       n1=SIZE(s1)
    END IF
    IF(n1/=t_msrf) THEN
       IF(ALLOCATED(s1)) DEALLOCATE(s1,s2,s3,s4)
       ALLOCATE(s1(t_msrf),s2(t_msrf),s3(t_msrf),s4(t_msrf))
    END IF
    
    iter=1
    CALL surfaces_separatrix(t_psibar,t_rlsd,t_zlsd)
    CALL get_surfint
    cs1=t_bsqrf-t_frsrf**2*t_rsqirf
    t_rls=t_rlsd(:,t_msrf,1)
    t_zls=t_zlsd(:,t_msrf,1)
    ier=0
    CALL boxd_interp(t_raxis,t_zaxis,pds,ier,s_n4)
    IF(ier/=0) CALL errdetec("xohmic: boxd_interp error",1)
    ! IF sigma not=0 & ixpt=1, THEN psil ne psilim but plasma is still limited
    dps=t_psil-t_psix
    IF(t_ipj==1) THEN
       IF(t_prsx01==0) t_prsx01=t_prsx
       t_jtsrf=t_jtsave/t_prsx01/10
       t_prsrf=t_psave/t_prsx01
       CALL fdDeriv(t_prsrf,t_psibar,t_msrf,t_pdsrf);t_pdsrf=t_pdsrf/dps
       t_ipp=999;t_ipf=999 ! This option only uses cubic splines in source
    ELSEIF(t_ipj<0) THEN
       call remark("trouble: disconnected")
    ELSE
       IF(t_nitt==0) THEN
          CALL s_source(t_psibar,s1,s2,-1) ! Ohmic profile
          CALL s_source(t_psibar,s3,s4,0)
          s1=s1/t_prsx
          s3=s3/t_prsx
          s4=s4*dps/t_prsx
       END IF
       t_jtsrf=-s1/dps
       t_prsrf=s3
       t_pdsrf=s4/dps
    END IF
    cs3=t_w
    cs2=t_frsrf**2
    fwallu=t_fwall
    DO iter=1,nret
       t_bsqrf=cs1+cs2*t_rsqirf
       t_wp=cs2*(t_jtsrf*t_rsqirf-t_pdsrf)/t_bsqrf
       wp0=0
       CALL splider_interp(t_psibar,t_wp,t_w,t_wpp,t_wppp,ndbg10,wp0,0,ldbg8)
       cs2=fwallu**2+2.*FOURPI*t_prsx*dps*t_w
       test=sum(abs(t_w-cs3))/sum(abs(t_w)+abs(cs3))
       cs3=t_w
       if(ndbg28==9 .and. t_ipj==1) call debugger
       IF(test<=errt_rq) EXIT
    END DO

    DO l=1,t_msrf
       IF(cs2(l)<0) CALL errdetec("fsq lt.0 in xohmic",1)
    END DO
    t_v=t_prsrf/dps/t_betaj
    t_frsrf=sqrt(fwallu**2+2.*FOURPI*t_prsx*dps*t_w)
    t_fpsrf=FOURPI*t_prsx*t_wp/t_frsrf
    t_pdsrf=t_prsx*t_pdsrf
    t_prsrf=t_prsx*t_prsrf
    IF(t_ifluxcord==0) THEN
       cs1=t_vpsrf/t_qsrf
    ELSE
       cs1=t_vpsrf
    END IF
    t_srsrf=t_prsrf*cs1**GAMMA
    CALL spline_interp(t_psibar,t_qsrf,t_splbdry,t_splbdry,cs1,cs2,cs3,t_qh)
    t_phibar=t_qh/t_qh(t_msrf)
    CALL spline_interp(t_psibar,t_v,t_splbdry,t_splbdry,t_vp,t_vpp,t_vppp,&
         noint)
    t_jtsrf=10.*(t_pdsrf+t_bsqrf*t_fpsrf/t_frsrf/FOURPI)/t_rsqirf
    RETURN

  END SUBROUTINE s_xohmic

  SUBROUTINE Expalf(e1,e2,e3,e4)
    REAL(rq), INTENT(IN)  :: e1
    REAL(rq), DIMENSION(:), INTENT(IN)  :: e2
    REAL(rq), DIMENSION(:), INTENT(OUT) :: e3,e4
    !
    !     calculates exponential profile
    !
    ea=exp(-e1)
    eax=exp(-e1*e2)
    e3=(ea*(1+(1.-e2)*e1)-eax)/e1/(ea-1)
    e4=(eax-ea)/dps/(ea-1)

  END SUBROUTINE Expalf

  SUBROUTINE Parab(e1,e2,e3,e4,e5)
    REAL(rq), INTENT(IN) :: e1,e2
    REAL(rq), DIMENSION(:), INTENT(IN)  :: e3
    REAL(rq), DIMENSION(:), INTENT(OUT) :: e4,e5
    !
    !     calculates polynomial form
    !
    u_s=abs(e3)+errb_rq
    fff=u_s**(e2-1)
    ffm=abs(1-fff*u_s)+errb_rq
    e4=ffm**(e1-1)
    e5=-e1*e2*e4*fff/dps
    e4=e4*ffm
  END SUBROUTINE Parab

  SUBROUTINE Efit(e1,e2,e3,e4,e5,e6,e7,e8)
    REAL(rq), INTENT(IN) :: e4,e5,e6,e7,e8
    REAL(rq), DIMENSION(:), INTENT(IN)  :: e1
    REAL(rq), DIMENSION(:), INTENT(OUT) :: e2,e3
    x_s=e1**2
    u_s=x_s*e1
    v_s=u_s*e1**(nefit-4)
    e3=-(e4+e1*e5+x_s*e6+u_s*e7+v_s*e8)/dps
    e2=e4*(1-e1)+e5/2*(1-x_s)+e6/3*(1-u_s)+e7/4*&
         (1-u_s*e1)+e8/nefit*(1-v_s*e1)
  END SUBROUTINE Efit

  SUBROUTINE Sphero(e1,e2,e3,e4,e5,e6,e7)
    REAL(rq), INTENT(IN) :: e4,e5,e6,e7
    REAL(rq), DIMENSION(:), INTENT(IN)  :: e1
    REAL(rq), DIMENSION(:), INTENT(OUT) :: e2,e3
    u_s=e1**2
    v_s=u_s*e1
    w_s=v_s*e1
    if(e7/=0) x_s=e1**nsp
    e2=e1-1+e4*(u_s-1)/2+e5*(v_s-1)/3+e6*(w_s-&
         1)/4+e7*(e1*x_s-1)/(nsp+1)
    e3=(1+e4*e1+e5*u_s+e6*v_s+e7*x_s)/dps
  END SUBROUTINE Sphero

  SUBROUTINE s_get_flux(rr,tt,lxp,jmk,ps)
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    !-- Computes pol_flux, ps on the fixed grid from inverse coordinates
    !-- rr(t_jmkm) is rho**2 and tt(t_jmkm) is the angle for the grid points
    !-- This works for an arbitrary r,z grid
    !-- Tests to see IF jmk=t_jmkm to calculate cps's etc
    !-- Note uses iabs(jmk) and number
    !cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
    INTEGER, INTENT(IN) :: jmk
    REAL(rq), DIMENSION(jmk), INTENT(IN)  :: rr,tt
    REAL(rq), DIMENSION(jmk), INTENT(INOUT) :: ps
    INTEGER,  DIMENSION(jmk), INTENT(IN)  :: lxp

    REAL(rq) :: rmax,zmax
    INTEGER ier,jm_km,lmx,n,l,ll,iii,ls
    INTEGER, DIMENSION(t_lmax) :: iwk_
    REAL(rq), DIMENSION(t_lmax) :: p_,r_,z_,uu_,ww_
    !
    !
    jm_km=iabs(jmk)
    lmx=0
    ier=6
    DO n=1,jm_km
       IF(lxp(n)==0) THEN
          lmx=lmx+1
          iwk_(lmx)=n
          uu_(lmx)=rr(n)
          ww_(lmx)=tt(n)
       END IF
       IF(lmx==t_lmax .or. (n==jm_km .AND. lmx/=0)) THEN ! vectors t_lmax long
          rmax=uu_(lmx)
          zmax=ww_(lmx)
          IF(lmx<t_lmax) THEN
             DO l=lmx+1,t_lmax ! fill up array
                uu_(l)=rmax
                ww_(l)=zmax
             END DO
          END IF
          CALL boxi_interp(uu_,ww_,t_pdls,t_dpsi0,t_psix,t_wvert,ier,t_n6)
          DO ll=1,lmx
             ps(iwk_(ll))=t_pdls(ll,1)
          END DO
          IF(jmk==t_jmkm) THEN
             DO ll=1,lmx
                iii=iwk_(ll)
                i_cps(iii,1,1)=t_pdls(ll,1)
                i_cps(iii,2,1)=t_pdls(ll,2)
                i_cps(iii,1,2)=t_pdls(ll,3)
                i_cps(iii,2,2)=t_pdls(ll,5)
             END DO
             p_=t_pdls(:,1)
             CALL interp_interp(t_psrf,t_frsrf,t_splbdry,t_splbdry,p_,r_,z_)
             DO ll=1,lmx
                iii=iwk_(ll)
                t_bt(iii)= r_(ll)/t_rm(iii)
                t_br(iii)=-i_cps(iii,1,2)/t_rm(iii)
                t_bz(iii)= i_cps(iii,2,1)/t_rm(iii)
                t_bp(iii)= sqrt(t_br(iii)**2+t_bz(iii)**2)
                t_bmod(iii)=sqrt(t_bt(iii)**2+t_bp(iii)**2)
             END DO
          END IF
          lmx=0
       END IF
    END DO
    t_rls=t_rlsd(:,t_msrf,1) ! reset
    t_zls=t_zlsd(:,t_msrf,1)
  END SUBROUTINE s_get_flux

  SUBROUTINE s_source_inv
    !--- Finds cps from inverse equilibrium
    include "debug.i"
    REAL(rq), DIMENSION(t_msrf) :: w_,v_,u_
    REAL(rq), DIMENSION(t_jm) :: rpl,zpl,spl,tpl
    REAL(rq), DIMENSION(t_jmkm) :: ps1,ps2,ps3
    REAL(rq), DIMENSION(t_mls) :: cq
    INTEGER,  DIMENSION(t_jmkm) :: lxp
    REAL(rq) :: y1,yn
    INTEGER j,k,m,lmin,n1

    n1=0
    if(ALLOCATED(crjr)) then
       n1=SIZE(crjr)
    end if
    if(n1/=t_jmkm) then
       IF(ALLOCATED(crjr))  DEALLOCATE(crjr)
       ALLOCATE(crjr(t_jmkm))
       crjr=0
    end if

    ps1=atan2((t_zm-t_zaxis)/t_wvert,t_rm-t_raxis)
    where(ps1<0) ps1=ps1+TWOPI
    cq=t_rhosq(t_msrf,:t_mls,1)
    !     Find out whether grid point is inside(lxp=0) or outside plasma
    y1=-666
    yn=-666
    CALL interp_interp(t_tswpts,cq,y1,yn,ps1,ps2,ps3)
    ps3=(t_rm-t_raxis)**2+((t_zm-t_zaxis)/t_wvert)**2
    lxp=0
    where(ps3>ps2) lxp=1

    if(t_use_halo .AND. t_lhalo<t_msrf) then  ! zero current outside first wall
       zpl=xmaxaf(t_zplate,1,t_nplates,1,lmin)
       rpl=i_r
       tpl=atan2((zpl-t_zaxis)/t_wvert,rpl-t_raxis)
       WHERE(tpl<0)tpl=tpl+TWOPI
       spl=sqrt((rpl-t_raxis)**2+((zpl-t_zaxis)/t_wvert)**2)
       CALL interp_interp(tpl,spl,t_splbdry,t_splbdry,ps1,ps2,ps3)
       ps3=(t_rm-t_raxis)**2+((t_zm-t_zaxis)/t_wvert)**2
    end if

    DO k=1,t_km
       DO j=1,t_jm
          if(lxp(j+t_jm*(k-1))==0) EXIT
       END DO
       s_jbl(k)=j
       DO j=t_jm,1,-1
          if(lxp(j+t_jm*(k-1))==0) EXIT
       END DO
       s_jbu(k)=j
    END DO

    !     Find flux on fixed grid inside plasma; uses lxp
    CALL s_get_flux(ps3,ps1,lxp,t_jmkm,t_psi)
    w_=-t_fpsrf*t_frsrf
    v_=-FOURPI*t_pdsrf
    if(t_filter_wp/=0) then
       DO m=t_msrf-1,1,-1
          if(t_asrf(t_msrf)-t_asrf(m)>2*t_dr) EXIT
       END DO
       u_=1
       u_(m:)=(1-(t_psibar(m:)-t_psibar(m))**10/(1-t_psibar(m))**10)
       w_=w_*u_
       v_=v_*u_
    end if
    CALL interp_interp(t_psrf,w_,t_splbdry,t_splbdry,t_psi,t_crj,ps3)
    CALL interp_interp(t_psrf,v_,t_splbdry,t_splbdry,t_psi,ps2,ps3)
    t_crj=t_crj+ps2*t_rm**2
    where(lxp==1) t_crj=0
    if(t_ipf<0) then ! get current on open field lines
       CALL s_setcrjX
!       CALL parsestr("setcrjX")
       if(t_fix_bound) where(lxp==1) t_crj=crjr
    end if
    t_crj=t_alpha*crjr+(1-t_alpha)*t_crj
    IF(t_fix_bound) RETURN
    t_plc=-sum(t_crj/t_rm)*t_dr*t_dz/FOURPI

  END SUBROUTINE s_source_inv

  FUNCTION cspX(x,x_1,x_2,x_3,x_4,x_n1) RESULT(rr)
    REAL(rq), DIMENSION(:), INTENT(IN) ::  x
    REAL(rq), INTENT(IN) :: x_1,x_2,x_3,x_4,x_n1
    REAL(rq), DIMENSION(SIZE(x)) :: xx_1,xx_2,xx_3,xx_4,xx_n
    REAL(rq), DIMENSION(SIZE(x),2) :: rr
    REAL(rq) :: n1
    
    n1=1+t_nbsp
    xx_1=x
    xx_2=xx_1*xx_1
    xx_3=xx_2*xx_1
    xx_4=xx_3*xx_1
    xx_n=xx_1
    IF(t_bsph(4)/=0) THEN
       xx_n=xx_1**t_nbsp
    END IF
    rr(:,1)=1+xx_1*csph(1)+xx_2*csph(2)+xx_3*csph(3)+xx_n*csph(4)
    rr(:,2)=(xx_2-x_2)*csph(1)/2+(xx_3-x_3)*csph(2)/3+(xx_4-x_4)*&
         csph(3)/4+(xx_n*x-x_n1)*csph(4)/n1+xx_1-x_1
  END FUNCTION cspX
 
  SUBROUTINE s_setcrjX
    USE teqPol_mod, only : t_inv_k
    INTEGER i,k, n0, n1, n2, n3, n4
    REAL(rq) :: x_1,x_2,x_3,x_4,x_n1,e(1,2),f(1),esph(4),fsph(4),fw_
    REAL(rq), SAVE :: fw
    INTEGER, SAVE :: iw
    DATA fw /0.0/, iw /1/
    
    IF(t_fix_bound) THEN
       t_fwall=t_fpsrf(t_msrf)*t_psil
       t_btor=t_fwall/t_ro
       RETURN
    END IF

    IF(fw==0) fw=t_fwall
    f=1.0_rq
    lb=0
    a=t_frsrf(t_msrf)/(t_fpsrf(t_msrf)*t_psil)

    ! Force t_crj to be continuous across separatrix
    x_1=-t_psix/t_dpsi0
    x_2=x_1*x_1
    x_3=x_2*x_1
    x_4=x_3*x_1
    x_n1=x_1**t_nbsp
    fsph(1)=x_1;fsph(2)=x_2;fsph(3)=x_3;fsph(4)=x_n1
    csph=t_bsph/fsph
    IF(t_bsph_flag/=0) THEN
       s=extrp(t_fpsrf,t_psibar,t_msrf,1,1)/t_fpsrf(t_msrf)
       call sph(csph,t_bsph,fsph,s,t_bsph_flag,t_nbsp)
    END IF
    x_n1=x_n1*x_1
    s=1+SUM(csph)
    d=cspX(f,x_1,x_2,x_3,x_4,x_n1)*t_dpsi0/t_psil/s
    IF(s/=1) lb=1  ! t_bsph's--->csph's
    IF(t_crj_flag) THEN
       DO i=1,4
          IF(t_bsph(i)==0) EXIT
       END DO
       esph=t_bsph;esph(i)=1
       csph=esph/fsph
       e=cspX(f,x_1,x_2,x_3,x_4,x_n1)*t_dpsi0/t_psil
       esph(i)=(a-d(1,2))*s/(e(1,2)-a*(SUM(esph)-s))
       csph=esph/fsph
       c=0
       lb=1 ! csph's
    ELSE
       lb=0 ! old way
       a=a/d(1,2)
       c=t_psil*(1-a)
    END IF
    ! End force of continuity of t_crj across separatrix

    DO k = 1,t_km
       IF (t_jwl(k) /= (t_jm+1) .AND. t_jwl(k) /= t_jwu(k)) THEN
          ! inside flux conserver
          n0 = t_jm * (k - 1)
          n3 = 0
          n4 = -1
          IF (s_jbl(k) == (t_jm + 1)) THEN ! No confinement region
             n1 = n0 + t_jwl(k)
             n2 = n0 + t_jwu(k)
             n4=-2
          ELSE
               !  Inside of confinement region...
             n1 = n0 + t_jwl(k)
             n2 = n0 + s_jbl(k) - 1
               ! Outside of confinement region...
             n3 = n0 + s_jbu(k) + 1
             n4 = n0 + t_jwu(k) 
          END IF
          IF(n2>=n1) THEN
             ALLOCATE(pp(n2+1-n1),ff(n2+1-n1),hh(n2+1-n1,2),wk(n2+1-n1))
             pp=(t_psi(n1:n2)-t_psix)/t_dpsi0
             IF(lb==0) THEN
                wk=t_fpsrf(t_msrf)*(t_psi(n1:n2)-c)
                t_crj(n1:n2)=-t_fpsrf(t_msrf)*wk
             ELSE
                hh=cspX(pp,x_1,x_2,x_3,x_4,x_n1)/s
                wk=t_fpsrf(t_msrf)*(t_dpsi0*hh(:,2)-c)
                t_crj(n1:n2)=-t_fpsrf(t_msrf)*hh(:,1)*wk
             END IF
             IF(n4==-2 .AND. t_gsph/=0) THEN
                IF(t_gsph==-1) THEN
                   ff=1/pp
                   a=t_fpsrf(t_msrf)*t_dpsi0
                   WHERE(pp<1)
                      wk=t_frsrf(t_msrf)+a*log(pp)
                   END WHERE
                ELSE
                   a=t_fpsrf(t_msrf)/t_dpsi0/(1+t_gsph)
                   WHERE(pp<1)
                      ff=pp**t_gsph
                      wk=t_frsrf(t_msrf)+a*(pp*ff-1)
                   END WHERE
                END IF
                hh(:,1)=t_crj(n1:n2)
                WHERE(pp<1)
                   hh(:,1)=-wk*t_fpsrf(t_msrf)*ff
                END WHERE
                t_crj(n1:n2)=hh(:,1)
             END IF
             t_bt(n1:n2)=wk/t_rm(n1:n2)
             DEALLOCATE(hh,pp,wk,ff)
          END IF
          IF(n4>n3) THEN
             ALLOCATE(pp(n4+1-n3),wk(n4+1-n3),hh(n4+1-n3,2))
             pp=(t_psi(n3:n4)-t_psix)/t_dpsi0
             IF(lb==0) THEN
                wk=t_fpsrf(t_msrf)*(t_psi(n3:n4)-c)

             ELSE
                hh=cspX(pp,x_1,x_2,x_3,x_4,x_n1)/s
                wk=t_fpsrf(t_msrf)*(t_dpsi0*hh(:,2)-c)
             END IF
             t_crj(n3:n4)=-t_fpsrf(t_msrf)*wk
             t_bt(n3:n4)=wk/t_rm(n3:n4)
             DEALLOCATE(hh,pp,wk)
          END IF
       END IF
    END DO
    t_fgun=t_frsrf(t_msrf)
    IF(t_nitt==1 .OR. t_nitt==iw) THEN
       fw=t_fwall
       iw=t_nitt+t_nl
    END IF
!    t_fwall=fw*d(1,2)
!    CALL parsestr("fwall=pin*jparTor(mtor)*psiEdge/5")
    IF(t_inv_k==3) t_fwall=t_jparsave(t_msrf)*TWOPI*t_psil/5
    t_fwall=t_fwall*d(1,2)
    t_btor=t_fwall/t_ro
    t_bt=t_bt+1.e-20_rq

  END SUBROUTINE s_setcrjX

  SUBROUTINE shift
!
!---   Calculates shifted mesh for 2nd order current and recaculates mesh
!      if the inverse equilibrium is being used
!    Determine plasma-boundary crossing-points on shifted grid if t_kedge>1
!
      REAL(rq) :: pdbs(t_jm,1),bdd(t_jm)
      INTEGER :: j,k,n,ier,isw,lbdry
      IF(SIZE(psish)/=t_jmkm) THEN
         IF(ALLOCATED(rsh)) DEALLOCATE(rsh,zsh,psish,rmsh)
         ALLOCATE(rsh(t_jm),zsh(t_km),psish(t_jmkm),rmsh(t_jmkm))
      END IF
      IF(SIZE(crje)/=t_jmkm) THEN
         IF(ALLOCATED(crje)) DEALLOCATE(crje,jbl2,jbu2)
         ALLOCATE(crje(t_jmkm),jbl2(t_km),jbu2(t_km))
         crje=0
         jbl2=0
         jbu2=0
      END IF
      rsh=t_r-0.5_rq*t_dr ! set up shifted grid
      zsh=t_z-0.5_rq
      rmsh=t_rm-0.5_rq*t_dr
      isw=0
      DO k=1,t_km                ! compute flux on shifted grid 
         bdd=zsh(k)
         ier=1
         call boxm_interp(rsh,bdd,pdbs,t_r,t_z,i_cps,isw,ier,t_n4)
         DO j=1,t_jm
            n=(k-1)*t_jm+j
            psish(n)=pdbs(j,1)
         END DO
      END DO
      lbdry=2
      call psisrf_separatrix(t_psil,lbdry,rsh,zsh,psish)
      IF(SIZE(rlsh)/=s_mlse) THEN
         IF(ALLOCATED(rlsh)) DEALLOCATE(rlsh,zlsh)
         ALLOCATE(rlsh(s_mlse),zlsh(s_mlse))
      END IF
      t_psi=i_cps(:,1,1)
      mlsh=s_mlse
      rlsh=s_rlse     ! crossing-points on shifted grid
      zlsh=s_zlse
    END SUBROUTINE shift

    SUBROUTINE s_edgecur1

      ! calculate correction-current per box around plasma edge
      REAL(rq) :: f0,f1,f2,f01,f02, r10,z10,r20,z20,dre,dze,on_(1),cc_1,&
           cc_2,cc_3,cc_4,cor,dr1,dr2,dz1,dz2
      INTEGER :: mend,m,j,k,n,isign,kstart,klower,nlower
      IF(SIZE(rce)/=t_jqm) THEN
         IF(ALLOCATED(rce)) DEALLOCATE(rce,zce,cce,jnte,knte,ncgp,rcesh,zcesh,&
              cedge)
         ALLOCATE(rce(t_jqm),zce(t_jqm),cce(t_jqm),jnte(t_jqm),knte(t_jqm),&
              ncgp(t_jqm),rcesh(t_jqm),zcesh(t_jqm),cedge(t_jqm))
      END IF
      IF(SIZE(crje)/=t_jmkm) THEN
         IF(ALLOCATED(crje)) DEALLOCATE(crje,jbl2,jbu2)
         ALLOCATE(crje(t_jmkm),jbl2(t_km),jbu2(t_km))
         crje=0
         jbl2=0
         jbu2=0
      END IF
      on_=1
      call s_source(on_,f_f,ppe,0)
      call s_source(on_,f_f,ffpe,1)
      ffpe=ffpe*f_f
      f2= (-FOURPI*s_rlse(1)**2*ppe(1)-ffpe(1) )/s_rlse(1) !   f2=fedge
      mend=s_mlse-1; ! if(t_nsym=1) mend= from s_mlse, & FIX PLCE & test depos
      DO m=1,mend
         dre=s_rlse(m+1)-s_rlse(m)
         dze=s_zlse(m+1)-s_zlse(m)
         ! j,k,n are indices of lower left corner of each box.
         ! reference corner (rce,zce and f0) chosen so t_crj always nonzero.

         IF(dze>0) THEN
            IF(dre<0) THEN
               !ur
               j=1+(s_rlse(m+1)-t_r(1))*(1+errt_rq)/t_dr
               k=1+(s_zlse(m)-t_z(1))*(1+errt_rq)/t_dz
               rce(m)=t_r(j)
               zce(m)=t_z(k)
               n=(k-1)*t_jm+j
               isign=1
               f0=t_crj(n)/t_r(j)
               f01=t_crj(n+1)/t_r(j+1)
               f02=t_crj(n+t_jm)/t_r(j)
               cc_3=t_crj(n)/t_r(j)
               cc_4=t_crj(n-1-t_jm)/t_r(j-1)
               cc_1=t_crj(n-1)/t_r(j-1)
               cc_2=t_crj(n-t_jm)/t_r(j)
            ELSE
               !lr
               j=1+(s_rlse(m)-t_r(1))*(1+errt_rq)/t_dr
               k=1+(s_zlse(m)-t_z(1))*(1+errt_rq)/t_dz
               rce(m)=t_r(j)
               zce(m)=t_z(k+1)
               n=(k-1)*t_jm+j
               isign=-1
               f0=t_crj(n+t_jm)/t_r(j)
               f01=t_crj(n)/t_r(j)
               f02=t_crj(n+1+t_jm)/t_r(j+1)
               cc_3=t_crj(n+t_jm)/t_r(j)
               cc_4=t_crj(n+2*t_jm-1)/t_r(j-1)
               cc_1=t_crj(n+2*t_jm)/t_r(j)
               cc_2=t_crj(n+t_jm-1)/t_r(j-1)
            END IF

         ELSE
            IF(dre<0) THEN
               !ul
               j=1+(s_rlse(m+1)-t_r(1))*(1+errt_rq)/t_dr
               k=1+(s_zlse(m+1)-t_z(1))*(1+errt_rq)/t_dz
               rce(m)=t_r(j+1)
               zce(m)=t_z(k)
               n=(k-1)*t_jm+j
               isign=-1
               f0=t_crj(n+1)/t_r(j+1)
               f01=t_crj(n+1+t_jm)/t_r(j+1)
               f02=t_crj(n)/t_r(j)
               cc_3=t_crj(n+1)/t_r(j+1)
               cc_4=t_crj(n-t_jm+2)/t_r(j+2)         
               cc_1=t_crj(n+2)/t_r(j+2)
               cc_2=t_crj(n-t_jm+1)/t_r(j+1)
            ELSE
               !ll
               j=1+(s_rlse(m)-t_r(1))*(1+errt_rq)/t_dr
               k=1+(s_zlse(m+1)-t_z(1))*(1+errt_rq)/t_dz
               rce(m)=t_r(j+1)
               zce(m)=t_z(k+1)
               n=(k-1)*t_jm+j
               isign=1
               f0=t_crj(n+1+t_jm)/t_r(j+1)
               f01=t_crj(n+t_jm)/t_r(j)
               f02=t_crj(n+1)/t_r(j+1)
               cc_3=t_crj(n+t_jm+1)/t_r(j+1)
               cc_4=t_crj(n+2*t_jm+2)/t_r(j+2)
               cc_1=t_crj(n+t_jm+2)/t_r(j+2)
               cc_2=t_crj(n+2*t_jm+1)/t_r(j+1)
            END IF
         END IF
         jnte(m)=j
         knte(m)=k 
         f1=f2
         f2= (-FOURPI*s_rlse(m+1)**2*ppe(1)-ffpe(1))/s_rlse(m+1)
         r10=s_rlse(m)-rce(m)
         r20=s_rlse(m+1)-rce(m)
         z10=s_zlse(m)-zce(m)
         z20=s_zlse(m+1)-zce(m)
         cce(m)=( (r10*z20 - r20*z10)*(f0+f1+f2) +&
              isign*( r10*z10*(f0+f1+f01) + r20*z20*(f0+f2+f02) ) )/6
         cce(m)=cce(m)-.25*t_dr*t_dz*(f0+f01+f02) ! already included in pdesol
         cor=t_dr*t_dz*((cc_1+cc_2+cc_3+cc_4)/4-(cc_1+cc_2)/6-(cc_3+cc_4)/3)
         IF(t_kedge==-1) cce(m)=cce(m)-cor*(1-(ABS(r20)+ABS(z20))/(t_dr+t_dz))

      END DO
      plce=0
      DO m=1,mend  ! change t_r,zce from reference pt to wire pt
         rce(m)=.5_rq*(rce(m)+.5_rq*(s_rlse(m)+s_rlse(m+1)))
         zce(m)=.5_rq*(zce(m)+.5_rq*(s_zlse(m)+s_zlse(m+1)))
         cce(m)=-cce(m)/FOURPI
         plce=plce+cce(m)
      END DO
      cce(s_mlse)=cce(1)
      rce(s_mlse)=rce(1)
      zce(s_mlse)=zce(1)

      ! deposit edge-current on grid
      ! crje(t_jmkm) ! -4*pi*R*J/c
      ! cce is input wire current in esu/sec
      crje=0
      DO m=1,mend
         j=jnte(m)
         k=knte(m)
         n=(k-1)*t_jm+j
         dr1 = rce(m) - t_r(j)
         dr2 = t_r(j+1) - rce(m)
         dz1 = zce(m) - t_z(k)
         dz2 = t_z(k+1) - zce(m)
         crje(n)      = crje(n) + cce(m)*t_r(j)*dr2*dz2
         crje(n+1)    = crje(n+1) + cce(m)*t_r(j+1)*dr1*dz2
         crje(n+t_jm)   = crje(n+t_jm) + cce(m)*t_r(j)*dr2*dz1
         crje(n+t_jm+1) = crje(n+t_jm+1) + cce(m)*t_r(j+1)*dr1*dz1
      END DO
      DO n=1,t_jmkm
         crje(n)=-crje(n)*4*Pi/(t_dr*t_dz)**2
      END DO
      ! symmetrize assumes upper is done
      IF(t_nsym==10) THEN  ! ???? check prob not here
         kstart = t_km/2 + 2
         DO k=kstart,t_km
            DO j=1,t_jm
               klower = t_km - k + 1
               nlower = (klower - 1)*t_jm + j
               n = (k - 1)*t_jm + j
               crje(nlower) = crje(n)
            END DO
         END DO
      END IF

      ! correct t_crj
      t_crj=t_crj+crje
      jbl2=s_jbl
      jbu2=s_jbu

      ! adjust jbu,jbl  ! WARNING: modified jbl,jbu should have different names
      ! within EDGECUR1 to avoid conflict with values computed
      ! in PSILMS
      ! bugs IF bean shaped
      DO k=1,s_kx-1
         IF(jbl2(k+1)/=t_jm+1) jbl2(k)=jbl2(k+1)-1
         IF(jbu2(k+1)/=0) jbu2(k)=jbu2(k+1)+1
      END DO
      DO k=t_km,s_kx+1,-1
         IF(jbl2(k-1)/=t_jm+1) jbl2(k)=jbl2(k-1)-1
         IF(jbu2(k-1)/=0) jbu2(k)=jbu2(k-1)+1
      END DO
      jbl2(s_kx)=jbl2(s_kx)-1
      jbu2(s_kx)=jbu2(s_kx)+1

      ! compute plas. current. pdesol knows nothing about boundary.
      ! t_crj covers a cell.
      ! seems to me psiscl should be scaling to this plc.
    END SUBROUTINE s_edgecur1

    SUBROUTINE s_edgecur2
      ! Compute 2nd-order-accurate current and Grad-Shafranov source in edge
      !  cells, Should work for bean-shaped as well as convex boundaries

      REAL(rq) :: f0(3),f1,f2,f00,f01,f02,r10,z10,r20,z20,wt,w01,w02,on_(1)
      REAL(rq) :: dre,dze,dse,ca,sa,dy,da,dy1,dy2,re0,ze0,psid(6),aay,bby,&
           ccy,ddy,cc_1,cc_2,cc_3,cc_4,cor
      INTEGER :: kl,ku,j,k,m,n,jn,jref,kref,isign,ier
      REAL(rq) :: psiv(t_jm,t_km)
      include "debug.i"

      IF(SIZE(rce)/=t_jqm) THEN
         IF(ALLOCATED(rce)) DEALLOCATE(rce,zce,cce,jnte,knte,ncgp,rcesh,zcesh,&
              cedge)
         ALLOCATE(rce(t_jqm),zce(t_jqm),cce(t_jqm),jnte(t_jqm),knte(t_jqm),&
              ncgp(t_jqm),rcesh(t_jqm),zcesh(t_jqm),cedge(t_jqm))
      END IF

      psiv=RESHAPE(t_crj,(/t_jm,t_km/))
      on_=1
      call s_source(on_,f_f,ppe,0)
      call s_source(on_,f_f,ffpe,1)
      ffpe=ffpe*f_f
      f2=(-FOURPI*rlsh(1)**2*ppe(1)-ffpe(1))/rlsh(1) ! -(4*pi/!)*J_tor at edge,
                                                     ! at t_r=rlsh(1)
      kl=t_km+1
      ku=0
      DO m=1,mlsh-1
         dre=rlsh(m+1)-rlsh(m)
         dze=zlsh(m+1)-zlsh(m)
         ! j,k,ncgp are indices of lower left corner of each cell on shifted
         ! grid, and of point at which current is corrected on original grid.
         ! reference corner (rcesh, zcesh, f00) chosen so crjsh always nonzero.
         ! indices of reference corner on shifted grid = (jref,kref).
         IF(dze>0) THEN
            IF(dre<0) THEN
               !ur
               j=1+(rlsh(m+1)-rsh(1))*(1+errt_rq)/t_dr
               k=1+(zlsh(m)-zsh(1))*(1+errt_rq)/t_dz
               rcesh(m)=rsh(j)
               zcesh(m)=zsh(k)
               isign=1
               jref=j
               kref=k
               f00=psiv(jref,kref)/rsh(jref)
               f01=psiv(jref+1,kref)/rsh(jref+1)
               f02=psiv(jref,kref+1)/rsh(jref)
               cc_3=psiv(j,k)/rsh(j)
               cc_4=psiv(j-1,k-1)/rsh(j-1)
               cc_1=psiv(j-1,k)/rsh(j-1)
               cc_2=psiv(j,k-1)/rsh(j) 
            ELSE
               !lr
               j=1+(rlsh(m)-rsh(1))*(1+errt_rq)/t_dr
               k=1+(zlsh(m)-zsh(1))*(1+errt_rq)/t_dz
               rcesh(m)=rsh(j)
               zcesh(m)=zsh(k+1)
               isign=-1
               jref=j
               kref=k+1
               f00=psiv(jref,kref)/rsh(jref)
               f01=psiv(jref,kref-1)/rsh(jref)
               f02=psiv(jref+1,kref)/rsh(jref+1)
               cc_3=psiv(j,k+1)/rsh(j)
               cc_4=psiv(j-1,k+2)/rsh(j-1)
               cc_1=psiv(j,k+2)/rsh(j)
               cc_2=psiv(j-1,k+1)/rsh(j-1)
            END IF
         ELSE
            IF(dre<0) THEN
               !ul
               j=1+(rlsh(m+1)-rsh(1))*(1+errt_rq)/t_dr
               k=1+(zlsh(m+1)-zsh(1))*(1+errt_rq)/t_dz
               rcesh(m)=rsh(j+1)
               zcesh(m)=zsh(k)
               isign=-1
               jref=j+1
               kref=k
               f00=psiv(jref,kref)/rsh(jref)
               f01=psiv(jref,kref+1)/rsh(jref)
               f02=psiv(jref-1,kref)/rsh(jref-1)
               cc_3=psiv(j+1,k)/rsh(j+1)
               cc_4=psiv(j+2,k-1)/rsh(j+2)
               cc_1=psiv(j+2,k)/rsh(j+2)
               cc_2=psiv(j+1,k-1)/rsh(j+1)
            ELSE
               !ll
               j=1+(rlsh(m)-rsh(1))*(1+errt_rq)/t_dr
               k=1+(zlsh(m+1)-zsh(1))*(1+errt_rq)/t_dz
               rcesh(m)=rsh(j+1)
               zcesh(m)=zsh(k+1)
               isign=1
               jref=j+1
               kref=k+1
               f00=psiv(jref,kref)/rsh(jref)
               f01=psiv(jref-1,kref)/rsh(jref-1)
               f02=psiv(jref,kref-1)/rsh(jref)
               cc_3=psiv(j+1,k+1)/rsh(j+1)
               cc_4=psiv(j+2,k+2)/rsh(j+2)
               cc_1=psiv(j+2,k+1)/rsh(j+2)
               cc_2=psiv(j+1,k+2)/rsh(j+1)
            END IF
         END IF
         kl=min0(kl,k)
         ku=max0(ku,k)
         ncgp(m)=(k-1)*t_jm+j 
         f1=f2  ! f1=(-4*pi/!)*J_tor at edge, t_r=rlsh(m)
         f2= (-FOURPI*rlsh(m+1)**2*ppe(1)-ffpe(1))/rlsh(m+1) ! at t_r=rlsh(m+1)
         r10=rlsh(m)-rcesh(m)
         r20=rlsh(m+1)-rcesh(m)
         z10=zlsh(m)-zcesh(m)
         z20=zlsh(m+1)-zcesh(m)
         !        J_tor/! integrated over grid-point-centered cell r(j), z(k):
         IF(t_kedge /= 3)THEN
            cedge(m)=-(1./6./FOURPI)*((r10*z20 - r20*z10)*(f00+f1+f2) +&
                 isign*(r10*z10*(f00+f1+f01)+r20*z20*(f00+f2+f02)))
         END IF
         IF(t_kedge.eq.3)THEN  ! correct discontinuity proportional to f_rz
            w01=0.
            w02=0.
            IF(r10*z10 /= 0.)w01=1.
            IF(r20*z20 /= 0.)w02=1.
            wt=.5_rq/(2+w01+w02)/FOURPI    
            cedge(m)=-wt*(f00+w01*f01+w02*f02+.5_rq*(f1+f2))*&
                 (r10*z20-r20*z10+isign*(r10*z10+r20*z20))
         END IF
         cor=t_dr*t_dz*((cc_1+cc_2+cc_3+cc_4)/4-(cc_1+cc_2)/6-(cc3+cc_4)/3)
         cedge(m)=cedge(m)+cor*(1-(abs(r20)+abs(z20))/(t_dr+t_dz))
         !        correct for curvature of plasma edge:
         IF(ndbg26<0) THEN
            dse=sqrt(dre**2+dze**2)
            sa=dze/dse
            ca=-dre/dse
            re0=.5_rq*(rlsh(m)+rlsh(m+1))
            ze0=.5_rq*(zlsh(m)+zlsh(m+1))
            ier=0
            call boxd_interp(re0,ze0,psid,ier,t_n4)
            aay=psid(4)*sa*sa+2.*psid(6)*ca*sa+psid(5)*ca*ca
            bby=psid(2)*sa+psid(3)*ca
            ccy=t_psil-psid(1)
            ddy=bby+sign(1._rq,bby)*sqrt(bby*bby+2*aay*ccy)
            dy1=1.e20
            dy2=1.e20         
            IF(aay /= 0.)dy1=-ddy/aay
            IF(ddy /= 0.)dy2=ccy/ddy
            dy=min(abs(dy1),abs(dy2))  ! distance from chord to boundary
            da=2.*dse*dy/3.  ! area between chord & boundary
            cedge(m)=cedge(m)-.5_rq*(f1+f2)*da/FOURPI
         END IF
      END DO
      cedge(mlsh)=cedge(1)
      rcesh(mlsh)=rcesh(1)
      zcesh(mlsh)=zcesh(1)
      ncgp(mlsh)=ncgp(1)

! correct t_crj in edge-cells:

      DO m=1,mlsh
         t_crj(ncgp(m))=-t_rm(ncgp(m))*cedge(m)*FOURPI/t_dr/t_dz
      END DO

      ! determine jbl2,jbu2, the indices in the r-array of the inner and outer 
      ! boundaries of the region where the 2nd-order crj /= 0. they DO not
      ! necessarily = jbl(k)
      jbl2=t_jm+1
      jbu2=0
      DO k=kl,ku
        DO j=1,t_jm
          n=(k-1)*t_jm+j
          IF(t_crj(n)/=0) EXIT
       END DO
       jbl2(k)=j
       DO j=t_jm,1,-1
          n=(k-1)*t_jm+j
          IF(t_crj(n)/=0) EXIT
       END DO
       jbu2(k)=j
      END DO
    END SUBROUTINE s_edgecur2

    SUBROUTINE s_fix_edge(ps)
      REAL(rq), INTENT(IN) :: ps
      REAL(rq) ::  yb,dummy,wpn,c0(t_msrf),c1(t_msrf)
      INTEGER mx,l
      mx=t_msrf
      IF(ps<1) THEN
        c1=(ps-t_psibar)**2
        dummy=xminaf(c1,1,t_msrf,1,mx)
        c0(:mx)=1
        yb=(1-t_psibar(mx))**10
        c0(mx+1:)=(1-((t_psibar(mx+1:)-t_psibar(mx)))**10/yb)
        t_vp=t_pdsrf*c0
        t_wp=2*t_fpsrf*t_frsrf*c0
     ELSE
        t_vp=t_pdsrf*c0
        t_wp=2*t_fpsrf*t_frsrf*c0
     END IF
     yb=t_splbdry
     CALL spline_interp(t_psibar,t_vp,yb,yb,t_vpp,t_vppp,c1,t_v)
     CALL spline_interp(t_psibar,t_wp,yb,yb,t_wpp,t_wppp,c1,t_w)
     wpn=t_frsrf(t_msrf)**2/t_dpsi0
     DO l=1,t_msrf
        t_v(l)=t_v(l)-t_v(t_msrf)
        t_w(l)=(t_w(l)-t_w(t_msrf))+wpn
     END DO
     IF(t_filter_p>2) THEN
        t_v=zero_der_interp(t_psibar,t_v,t_filter_p)
     ELSEIF(t_filter_p/=0) THEN
        CALL polyfit_interp(t_v,t_vp,t_psibar,t_dpoly,t_spoly,t_mpoly,-2)
        ! zeroes derivative at edge
        yb=777
     END IF
     CALL spline_interp(t_psibar,t_v,yb,yb,t_vp,t_vpp,t_vppp,noint)
     yb=t_splbdry
     IF(t_filter_wp>2) THEN
        t_w=zero_der_interp(t_psibar,t_w,t_filter_wp)
     ELSEIF(t_filter_wp/=0) THEN
        CALL polyfit_interp(t_w,t_wp,t_psibar,t_dpoly,t_spoly,t_mpoly,-2)
        ! zeroes derivative at edge
        yb=777
     END IF
     CALL spline_interp(t_psibar,t_w,yb,yb,t_wp,t_wpp,t_wppp,noint)
     t_prsrf=t_v*t_dpsi0
     t_pdsrf=t_vp
     t_frsrf=SQRT(t_w*t_dpsi0)
     t_fpsrf=0.5*t_wp/t_frsrf
     t_v=t_v/t_betaj
     t_vp=t_vp/t_betaj
     t_vp=t_vp/t_betaj
     t_vpp=t_vpp/t_betaj
     t_w=t_w/(8*PI)
     t_wp=t_wp/(8*PI)
     t_wpp=t_wpp/(8*PI)
     t_wppp=t_wppp/(8*PI)
     t_prsx=1.0000000001
     t_ipscl=-1
     t_ipp=999
     t_ipf=999
   END SUBROUTINE s_fix_edge

END MODULE source_mod

! $Id: ioTeq.f90,v 1.2 2007/07/23 16:00:58 meyer Exp $ 

MODULE ioTeq_mod

  USE runTeq_mod
  USE teqSubs_mod, only : t_stretch

  IMPLICIT NONE

  REAL(rq), DIMENSION(:,:), ALLOCATABLE :: bri,bzi,psiv
  REAL(rq), DIMENSION(:), ALLOCATABLE :: psg,prg,pdg,ffpg,fg,fpg,rpx
  INTEGER, PARAMETER :: OK=0, ERR=-1

  EXTERNAL giveupus,basclose,kaboom,freeus,teq_interface

CONTAINS

  SUBROUTINE wreqdskf(type,filename,suffix,tunits)

    ! Subroutine wreqdskf writes EQDSK files in the EFIT a- and g-file formats
    ! formats (http://web.gat.com/efit/) and three TEQ-specific formats. This
    ! routine takes up to four optional arguments, all character strings.
    ! Optional values are given in square brackets, below.
    !
    ! Calling sequence:
    !
    !   CALL wreqdskf(type,filename,suffix,tunits)
    !
    ! where the arguments are:
    !
    !   type     : file format character code (see below) ["g"]
    !   filename : EQDSK file name [default constructed from shot info]
    !   suffix   : EQDSK file suffix ["_teq"]
    !   tunits   : Time units, one of "s", "ms", "µs" (or "us") ["ms"]
    !
    ! The follwing EQDSK file types are available:
    !
    !   Type  Equilibrium      Description
    !     a   direct or inv.   auxiliary EQDSK file (EFIT a-file)
    !     d   direct           for input to Glasser's DCON
    !     g   direct or inv.   primay EQDSK file (EFIT g-file)
    !     i   inverse          for input to Glasser's DCON
    !     t   inverse          for input to Turnbull's GATO
    !
    ! If argument filename is not specified, a name will be constructed from
    ! the file type-code, user-variables shotName and shotTime and the suffix
    ! argument in the following format:
    !
    !             <type>shotName.<time_string><suffix>
    !
    ! If shotName is blank, the string "eqdsk" will be used. The value of
    ! time_string is a five character integer representation of the time
    ! in the specified units.


    CHARACTER(len=*), OPTIONAL, INTENT(IN) :: type,filename,suffix,tunits
    CHARACTER(len=1) :: eqdsk_type
    CHARACTER(len=8) :: eqdsk_suffix
    CHARACTER(len=256) :: eqdsk_file
    CHARACTER(len=2) :: eqdsk_tunits
    CHARACTER(len=5) :: tstr

    INTEGER, PARAMETER :: UNKNOWN=0,MCO2R=1,MCO2V=3,NSILOP=41,NFCOIL=18,&
         NESUM=6,MAGPRI=73,ERR=-1
        CHARACTER(len=3) :: limloc, qmflag, fit_type
    CHARACTER(len=42) :: header
    REAL(rq), PARAMETER :: pt01=.01_rq,pt1=.1_rq,pow7=1.e7_rq,&
         pow_4=1.e-4_rq,pow_6=1.e-6_rq,pow_8=1.e-8_rq
    REAL(rq) :: rseps(2), zseps(2)

    !     These quantites are unknown, but some applications need entries
    !     in a-files so they are written as vectors of zeros
    REAL(rq) :: rco2v(MCO2V), dco2v(MCO2V), rco2r(MCO2R), dco2r(MCO2R)
    REAL(rq) ::  csilop(NSILOP), cmpr2(MAGPRI), ccbrsp(NFCOIL), eccurt(NESUM)
    INTEGER :: i,j,idum,nbbs,limitr,kvtor,m,k,ktime1,nmass,nbbbs,jflag,&
         lflag,jmp,kmp
    REAL(rq) :: tsaisq,rcencm,bcentr,pasmat,cpasma,rout,zout,aout,axpt,&
         eout,doutu,doutl,vout,rcurrt,zcurrt,qsta,betatx,betapx,ali,oleft,&
         oright,otop,obott,qpsib,vertn,shearb,bpolav,s1,s2,s3,qout,olefs,&
         orighs,otops,sibdry,areao,wplasm,terror,elongm,qqmagx,cdflux,&
         alpha_,rttt,psiref,xndnt,sepexp,obots,btaxp,btaxv,alim,taudia,&
         aaq1,aaq2,aaq3,seplim,rmagx,zmagx,simagx,taumhd,betapd,betatd,&
         wplasmd,fluxx,vloopt,taurci,tavem,timex,delrmax2,qmerci,pbinj,&
         rvsin,zvsin,wpdot,rvsout,zvsout,vsurfa,wbdot,slantu,slantl,pp95,&
         zuperts,chipre,cjor95,ssep,yyy2,xnnx,xprof,oring,cjor0,fexpan,&
         qqmin,chigamt,cjor99,cj1ave,rmidin,rmidout,psurfa,xdum,dpsi,xnnc,&
         cprof,ssi01,fexpvs,sepnose,ssi95,rqqmin,xdim,zdim,rzero,rgrid1,&
         zmid,rmaxis,zmaxis,ssimag,ssibry,dnnorm,rvtor
    INTEGER :: jinc,kinc ! Must connect data base
    DATA jinc /1/, kinc /1/
    DATA delrmax2 /40/
    ALLOCATE(bri(t_mls,t_msrf),bzi(t_mls,t_msrf),psiv(t_jm,t_km))
    ALLOCATE(psg(t_jm),prg(t_jm),pdg(t_jm),ffpg(t_jm),fg(t_jm),fpg(t_jm),&
         rpx(t_jm))

    ! Non-blank shotName mandatory
    IF (t_shotName == "") t_shotName="eqdsk"

    ! EQDSK file type code
    IF (PRESENT(type)) THEN
       eqdsk_type=type
    ELSE
       eqdsk_type="g"
    END IF

    ! EQDSK filename suffix
    IF (PRESENT(suffix)) THEN
       eqdsk_suffix=suffix
    ELSE
       eqdsk_suffix="_teq"
    END IF

    ! EQDSK (a,g) file time units
    IF (PRESENT(tunits)) THEN
       eqdsk_tunits=tunits
    ELSE
       eqdsk_tunits="ms"
    END IF

    ! Construct time string
    IF (eqdsk_tunits == "s") THEN
       WRITE(tstr,'(I5.5)') INT(t_shotTime+0.5)
    ELSE IF (eqdsk_tunits == "µs" .OR. eqdsk_tunits == "us") THEN
       WRITE(tstr,'(I5.5)') INT(1000000*t_shotTime+0.5)
    ELSE
       WRITE(tstr,'(I5.5)') INT(1000*t_shotTime+0.5)
    END IF

    ! EQDSK file name
    IF (PRESENT(filename)) THEN
       eqdsk_file=filename
    ELSE
       eqdsk_file=eqdsk_type//TRIM(t_shotName)//"."//tstr//TRIM(eqdsk_suffix)
    END IF
    IF (LEN_TRIM(t_shotName) > 6) THEN ! Use C-Mod convention (uppercase)
       DO i=1,LEN_TRIM(eqdsk_file)
          IF (LGE(eqdsk_file(i:i),'a') .AND. LLE(eqdsk_file(i:i),'z')) THEN
             eqdsk_file(i:i)=ACHAR(IACHAR(eqdsk_file(i:i))-32)
          END IF
       END DO
    END IF

    ! Set the EQDSK a- & g-file headers
    CALL set_headers(eqdsk_tunits)

    CALL teq_interface ! Too avoid HP character pointer disassociate bug.
    IF (eqdsk_type == "d" .OR. eqdsk_type == "i") THEN ! binary file
       IF (iopen(ioun7,eqdsk_file) == ERR) THEN
          CALL giveupus(ioun7)
          CALL basclose(ioun7)
          RETURN
       END IF
    ELSE
       IF (icreate(ioun7,eqdsk_file) == ERR) THEN ! text file
          CALL giveupus(ioun7)
          CALL basclose(ioun7)
          RETURN
       END IF
    END IF

    IF (jinc <= 0) jinc = 1
    IF (kinc <= 0) kinc = 1
    jmp = (t_jm - 1)/jinc + 1
    kmp = (t_km - 1)/jinc + 1

    !     PART I: PREPARE DATA...
    IF (eqdsk_type == "a") THEN ! Map to EFIT variable names
       !         uday.. ~ aheader
       !         ishot  ~ shotName
       IF (eqdsk_tunits == "s") THEN
          timex  = t_shotTime
       ELSE IF (eqdsk_tunits == "µs" .OR. eqdsk_tunits == "us") THEN
          timex  = t_shotTime*1.0e+06_rq
       ELSE
          timex  = t_shotTime*1.0e+03_rq
       END IF
       ktime1 = 1
       jflag  = 1
       lflag  = 0
       limloc = "UNK"
       IF (s_limiterd /= 0) THEN
          alim = atan2((t_zlim(0) - t_zaxis),(t_rlim(0) - t_raxis))
          IF (alim < 0) alim = alim + TWOPI
          IF (alim >= 7*Pi/4 .OR. alim < Pi/4) THEN
             limloc = "OUT"
          ELSEIF (alim >= Pi/4 .AND. alim < 3*Pi/4) THEN
             limloc = "TOP"
          ELSEIF (alim >= 3*Pi/4 .AND. alim < 5*Pi/4) THEN
             limloc = "IN"
          ELSE
             limloc = "BOT"
          END IF
       ELSE
          IF (abs((s_pxpu - s_pxpl) / t_dpsi0) < t_dn_criterion) THEN
             limloc = "DN"
          ELSE
             axpt = atan2((t_zxpt - t_zaxis),(t_rxpt - t_raxis))
             IF (axpt < 0) axpt = axpt + TWOPI
             IF (axpt >= 7*Pi/4 .OR. axpt < Pi/4) THEN
                limloc = "SNO"
             ELSEIF (axpt >= Pi/4 .AND. axpt < 3*Pi/4) THEN
                limloc = "SNT"
             ELSEIF (axpt >= 3*Pi/4 .AND. axpt < 5*Pi/4) THEN
                limloc = "SNI"
             ELSE
                limloc = "SNB"
             END IF
          END IF
       END IF
       qmflag   = "CLC"
       tsaisq   = UNKNOWN
       rcencm   = t_ro
       bcentr   = t_btor*1.0e-04_rq
       pasmat   = UNKNOWN
       cpasma   = t_placur
       rout     = s_rcntr
       zout     = UNKNOWN
       aout     = s_rbore
       eout     = t_elongn
       doutu    = t_trianu
       doutl    = t_trianl
       vout     = t_volume
       rcurrt   = UNKNOWN
       zcurrt   = UNKNOWN
       qsta     = t_qstar
       betatx   = t_betae*1.0e+02_rq
       betapx   = t_betap(1)
       ali      = t_li(1)
       oleft    = UNKNOWN
       oright   = UNKNOWN
       otop     = UNKNOWN
       obott    = UNKNOWN
       qpsib    = t_q95
       vertn    = UNKNOWN
       rco2v    = UNKNOWN
       dco2v    = UNKNOWN
       rco2r    = UNKNOWN
       dco2r    = UNKNOWN
       shearb   = UNKNOWN
       bpolav   = UNKNOWN
       s1       = UNKNOWN
       s2       = UNKNOWN
       s3       = UNKNOWN
       qout     = t_qsrf(t_msrf)
       olefs    = UNKNOWN
       orighs   = UNKNOWN
       otops    = UNKNOWN
       sibdry   = t_psil*1.0e-08_rq
       areao    = t_surf
       wplasm   = UNKNOWN
       terror   = UNKNOWN
       elongm   = t_esrf(1)
       qqmagx   = t_qsrf(1)
       cdflux   = UNKNOWN
       alpha_   = UNKNOWN
       rttt     = UNKNOWN
       psiref   = UNKNOWN
       xndnt    = UNKNOWN
       IF (s_limiterd /= 0) THEN
          rseps=-999
          zseps=-999
       ELSE
          rseps(1) = s_rxpl
          zseps(1) = s_zxpl
          rseps(2) = s_rxpu
          zseps(2) = s_zxpu
       END IF
       sepexp   = UNKNOWN
       obots    = UNKNOWN
       btaxp    = UNKNOWN
       btaxv    = (t_fwall/t_raxis)*1.0e-04_rq
       aaq1     = UNKNOWN
       aaq2     = UNKNOWN
       aaq3     = UNKNOWN
       seplim   = UNKNOWN
       rmagx    = t_raxis
       zmagx    = t_zaxis
       simagx   = t_psix*1.0e-08_rq
       taumhd   = UNKNOWN
       betapd   = UNKNOWN
       betatd   = UNKNOWN
       wplasmd  = UNKNOWN
       fluxx    = UNKNOWN
       vloopt   = UNKNOWN
       taudia   = UNKNOWN
       qmerci   = UNKNOWN
       tavem    = UNKNOWN
       csilop   = UNKNOWN
       cmpr2    = UNKNOWN
       ccbrsp   = UNKNOWN
       eccurt   = UNKNOWN
       pbinj    = UNKNOWN
       IF (t_nspt < 2) THEN
          rvsin  = 0.0
          zvsin  = 0.0
       wpdot    = UNKNOWN
          rvsout = 0.0
          zvsout = 0.0
       ELSEIF (t_nspt < 4) THEN
          rvsin   = t_rspt(1)
          zvsin   = t_zspt(1)
          rvsout  = t_rspt(2)
          zvsout  = t_zspt(2)
       ELSE
          rvsin   = t_rspt(3)
          zvsin   = t_zspt(3)
          rvsout  = t_rspt(4)
          zvsout  = t_zspt(4)
       END IF
       vsurfa   = UNKNOWN
       wpdot    = UNKNOWN
       wbdot    = UNKNOWN
       slantu   = UNKNOWN
       slantl   = UNKNOWN
       zuperts  = UNKNOWN
       chipre   = UNKNOWN
       cjor95   = UNKNOWN
       pp95     = UNKNOWN
       ssep     = 0.0
       IF (limloc == "SNB") THEN
          IF (s_dsep /= 0) THEN
             ssep = -s_dsep
          ELSE
             ssep = -delrmax2
          END IF
       ELSEIF (limloc == "SNT") THEN
          IF (s_dsep /= 0) THEN
             ssep = s_dsep
          ELSE
             ssep = delrmax2
          END IF
       END IF
       yyy2     = UNKNOWN
       xnnc     = UNKNOWN
       cprof    = UNKNOWN
       oring    = UNKNOWN
       cjor0    = UNKNOWN
       fexpan   = UNKNOWN
       qqmin    = t_qmin
       chigamt  = UNKNOWN
       ssi01    = UNKNOWN
       fexpvs   = UNKNOWN
       sepnose  = UNKNOWN
       ssi95    = UNKNOWN
       rqqmin   = t_rhomin
       cjor99   = UNKNOWN
       cj1ave   = UNKNOWN
       rmidin   = UNKNOWN
       rmidout  = UNKNOWN
       psurfa   = UNKNOWN
       xdum     = 0.0
       fit_type = "TEQ"
       header   = " "

    ELSEIF (eqdsk_type == "g") THEN ! Map to EFIT variable names
       psiv = RESHAPE(t_psi,(/t_jm,t_km/))*1.0e-8_rq
       dpsi = (t_psil - t_psix)/(t_jm - 1)
       psg=(/(j,j=0,t_jm-1)/)*dpsi+t_psix
       CALL interp_interp(t_psrf,t_qsrf ,t_splbdry,t_splbdry,psg,rpx, fg)
       CALL interp_interp(t_psrf,t_frsrf,t_splbdry,t_splbdry,psg,fg ,fpg)
       CALL interp_interp(t_psrf,t_prsrf,t_splbdry,t_splbdry,psg,prg,pdg)
       rpx(t_jm) = t_qsrf(t_msrf)
       prg  = prg*1.0e-01_rq
       pdg  = pdg*1.0e+07_rq
       WHERE(prg<9.e-99_rq)
          prg=0
       END WHERE
       WHERE(ABS(pdg)<9.e-99_rq)
          pdg=0
       END WHERE
       ffpg = fg*fpg*1.0e-04_rq
       fg   = fg*1.0e-06_rq
       psg  = psg*1.0e-08_rq
       fpg = ffpg/(fg + errt_rq)

       !         Map to EFIT variable names
       !         case   ~ gheader (set by user)
       idum   = 3
       xdim   = (t_r(t_jm) - t_r(1))*1.0e-02_rq
       zdim   = (t_z(t_km) - t_z(1))*1.0e-02_rq
       rzero  = (t_r(1) + t_r(t_jm))*5.0e-03_rq
       rgrid1 = t_r(1)*1.0e-02_rq
       zmid   = 0.5*(t_z(1) + t_z(t_km))*1.0e-02_rq
       rmaxis = t_raxis*1.0e-02_rq
       zmaxis = t_zaxis*1.0e-02_rq
       ssimag = t_psix*1.0e-08_rq
       ssibry = t_psil*1.0e-8_rq
       bcentr = t_btor*1.0e-04_rq
       cpasma = t_placur
       xdum   = 0.0
       !         fpol   = fg
       !         pres   = prg
       !         ffprim = ffpg
       !         pprime = pdg
       !         psirz  = psiv
       !         qpsi   = rpx
       nbbbs  = s_mlse
       limitr = t_nplates + 1
       !         rbbbs  = 0.01*rlse
       !         zbbbs  = 0.01*zlse
       !         xlim   ~ 0.01*rplate [assumes r,zplate form plasma-enclosing contour]
       !         ylim   ~ 0.01*zplate
       kvtor  = UNKNOWN
       rvtor  = UNKNOWN
       nmass  = UNKNOWN

       !         Sign convention for g-files
       IF (cpasma > 0) THEN
          ssimag = -ssimag
          ssibry = -ssibry
          ffpg=-ffpg
          pdg=-pdg
          psiv = -RESHAPE(t_psi,(/t_jm,t_km/))*1.0e-8_rq
       END IF
       IF (bcentr < 0 .AND. fg(t_jm) > 0) fg=-fg

    ELSEIF (eqdsk_type == "t") THEN ! Evaluate Bpoloidal on inverse mesh
       bri(:,1)=0
       bzi(:,1)=0
       bri(:,2:) = -s_pin*t_rlsd(:,2:,2)/t_zlsd(:,2:,4)
       bzi(:,2:) = -s_pin*t_zlsd(:,2:,2)/t_zlsd(:,2:,4)

    END IF ! PART I

    !     PART II: WRITE DATA...
    IF (eqdsk_type == "a") THEN ! write a-file
       write(ioun7,1055) t_aheader
       write(ioun7,1053) t_shotName, ktime1
       write(ioun7,1040) timex
       write(ioun7,1060) timex, jflag, lflag, limloc, MCO2V, MCO2R, qmflag
       write(ioun7,1040) tsaisq, rcencm, bcentr, pasmat
       write(ioun7,1040) cpasma, rout, zout, aout
       write(ioun7,1040) eout, doutu, doutl, vout
       write(ioun7,1040) rcurrt, zcurrt, qsta, betatx
       write(ioun7,1040) betapx, ali, oleft, oright
       write(ioun7,1040) otop, obott, qpsib, vertn
       IF (mco2v > 0) THEN
          write(ioun7,1040) (rco2v(k), k=1,mco2v)
          write(ioun7,1040) (dco2v(k), k=1,mco2v)
       END IF
       IF (mco2r > 0) THEN
          write(ioun7,1040) (rco2r(k), k=1,mco2r)
          write(ioun7,1040) (dco2r(k), k=1,mco2r)
       END IF
       write(ioun7,1040) shearb, bpolav, s1, s2
       write(ioun7,1040) s3, qout, olefs, orighs
       write(ioun7,1040) otops, sibdry, areao, wplasm
       write(ioun7,1040) terror, elongm, qqmagx, cdflux
       write(ioun7,1040) alpha_, rttt, psiref, xndnt
       write(ioun7,1040) rseps(1), zseps(1), rseps(2), zseps(2)
       write(ioun7,1040) sepexp, obots, btaxp, btaxv
       write(ioun7,1040) aaq1, aaq2, aaq3, seplim
       write(ioun7,1040) rmagx, zmagx, simagx, taumhd
       write(ioun7,1040) betapd, betatd, wplasmd, fluxx
       write(ioun7,1040) vloopt, taudia, qmerci, tavem
       write(ioun7,1041) nsilop, magpri, nfcoil, nesum
       IF (nsilop*magpri > 0) THEN
          write(ioun7,1040) (csilop(k), k=1,nsilop), (cmpr2(k), k=1,magpri)
       END IF
       IF (nfcoil > 0) THEN
          write(ioun7,1040) (ccbrsp(k), k=1,nfcoil)
       END IF
       IF (nesum > 0) THEN
          write(ioun7,1040) (eccurt(k), k=1,nesum)
       END IF
       write(ioun7,1040) pbinj, rvsin, zvsin, rvsout
       write(ioun7,1040) zvsout, vsurfa, wpdot, wbdot
       write(ioun7,1040) slantu, slantl, zuperts, chipre
       write(ioun7,1040) cjor95, pp95, ssep, yyy2
       write(ioun7,1040) xnnc, cprof, oring, cjor0
       write(ioun7,1040) fexpan, qqmin, chigamt, ssi01
       write(ioun7,1040) fexpvs, sepnose, ssi95, rqqmin
       write(ioun7,1040) cjor99, cj1ave, rmidin, rmidout
       write(ioun7,1040) psurfa, xdum, xdum, xdum
       write(ioun7,1042) header, fit_type
    ELSEIF (eqdsk_type == "d") THEN ! write d-file (---> DCON)
       psiv = t_psil - RESHAPE(t_psi,(/t_jm,t_km/))*pow_8
       write(ioun7) jmp, kmp, t_msrf
       write(ioun7) pt01*t_r(1), pt01*t_r(t_jm), pt01*t_z(1), pt01*t_z (t_km)

       write(ioun7) ((psiv(j,k), j=1,t_jm,jinc), k=1,t_km,kinc)
       write(ioun7) ((t_psrf(m) - t_psil), m=1,t_msrf)
       write(ioun7) (t_frsrf(m)*pow_6, m=1,t_msrf)
       write(ioun7) (t_prsrf(m)*pt1, m=1,t_msrf)
       write(ioun7) (t_qsrf(m), m=1,t_msrf)
       write(ioun7) (t_pdsrf(m)*pow7, m=1,t_msrf)

    ELSEIF (eqdsk_type == "g") THEN ! write g-file
       write(ioun7,2000) t_gheader, idum, jmp, kmp
       write(ioun7,2020) xdim, zdim, rzero, rgrid1, zmid
       write(ioun7,2020) rmaxis, zmaxis, ssimag, ssibry, bcentr
       write(ioun7,2020) cpasma, ssimag, xdum, rmaxis, xdum
       write(ioun7,2020) zmaxis, xdum, ssibry, xdum, xdum
       write(ioun7,2020) (fg(j), j=1,t_jm,jinc)
       write(ioun7,2020) (prg(j), j=1,t_jm,jinc)	
       write(ioun7,2020) (ffpg(j), j=1,t_jm,jinc)	
       write(ioun7,2020) (pdg(j), j=1,t_jm,jinc)	
       write(ioun7,2020) ((psiv(j,k), j=1,t_jm,jinc), k=1,t_km,kinc)
       write(ioun7,2020) (rpx(j), j=1,t_jm,jinc)
       IF (t_inv_eq == 1) THEN
          write(ioun7,2022) t_mls, t_nplates+1
          write(ioun7,2020) (pt01*t_rls(i), pt01*t_zls(i), i=1,t_mls)
       ELSE
          write(ioun7,2022) s_mlse, t_nplates+1
          write(ioun7,2020) (pt01*s_rlse(i), pt01*s_zlse(i), i=1,s_mlse)
       END IF
       IF(t_nplates/=0) THEN
          write(ioun7,2020) (pt01*t_rplate(i,1), pt01*t_zplate(i,1),&
               i=1,t_nplates),pt01*t_rplate(t_nplates,2), pt01*t_zplate(t_nplates,2)
       END IF
       write(ioun7,2024) kvtor, rvtor, nmass
    ELSEIF (eqdsk_type == "i") then ! write i-file (inv --> Glasser's DCON)
       write(ioun7) t_msrf, t_mls
       write(ioun7) ((t_psrf(m) - t_psil)*pow_8, m=1,t_msrf)
       write(ioun7) (t_frsrf(m)*pow_6, m=1,t_msrf)
       write(ioun7) (t_prsrf(m)*pt1, m=1,t_msrf)
       write(ioun7) (t_qsrf(m), m=1,t_msrf)
       write(ioun7) ((pt01*t_rlsd(i,m,1), i=1,t_mls), m=1,t_msrf)
       write(ioun7) ((pt01*t_zlsd(i,m,1), i=1,t_mls), m=1,t_msrf)
    ELSEIF (eqdsk_type == "t") then ! write t-file (inv --> Turnbull's GATO)
       dnnorm = 1
       write(ioun7,3000) t_rundate
       write(ioun7,3001) t_theader
       write(ioun7,3002) t_msrf, t_lmax, (2-t_nsym)
       write(ioun7,3003) pt01*t_ro, pt01*t_raxis, pt01*t_zaxis, t_btor*pow_4
       write(ioun7,3003) t_placur, t_esrf(1), dnnorm
       write(ioun7,3003) ( t_psrf(m)*pow_8, m=1,t_msrf)
       write(ioun7,3003) (t_frsrf(m)*pow_6, m=1,t_msrf)
       write(ioun7,3003) (t_frsrf(m)*t_fpsrf(m)*pow_4, m=1,t_msrf)
       write(ioun7,3003) (t_prsrf(m)*pt1, m=1,t_msrf)
       write(ioun7,3003) (t_pdsrf(m)*pow7, m=1,t_msrf)
       write(ioun7,3003) ( t_qsrf(m), m=1,t_msrf)
       write(ioun7,3003) (t_vpsrf(m), m=1,t_msrf)
       write(ioun7,3003) (t_pdls(i,2)*0.0, i=1,t_lmax)
       write(ioun7,3003) (t_pdls(i,3)*0.0, i=1,t_lmax)
       write(ioun7,3003) ((t_rlsd(i,m,1)*pt01, m=1,t_msrf), i=1,t_lmax)
       write(ioun7,3003) ((t_zlsd(i,m,1)*pt01, m=1,t_msrf), i=1,t_lmax)
       write(ioun7,3003) ((bri(i,m)*pow_4, m=1,t_msrf), i=1,t_lmax)
       write(ioun7,3003) ((bzi(i,m)*pow_4, m=1,t_msrf), i=1,t_lmax)

    END IF ! PART II

    CALL giveupus(ioun7)
    CALL basclose(ioun7)
    ! Restore shotName
    IF (t_shotName == "eqdsk") t_shotName=""


    DEALLOCATE(psg,prg,pdg,ffpg,fg,fpg,rpx,bri,bzi,psiv)

1040 format(1x,4e16.9)
1041 format(1x,4i5)
1042 format(1x,a42,1x,a3)
1053 format(1x,a16,1x,i5)
1055 format(1x,a)
1060 format(1h*,f7.2,10x,i5,11x,i5,1x,a3,1x,i3,1x,i3,1x,a3,1x,2i5)

2000 format(a48,3i4)
2020 format(5e16.9)
2022 format(2i5)
2024 format(i5,e16.9,i5)

3000 format(a8)
3001 format(a)
3002 format(3i5)
3003 format(4(1PE19.12))

  END SUBROUTINE wreqdskf
  SUBROUTINE set_headers(tunits)
    
    ! Set header strings for EQDSK a- and g-files.

    CHARACTER(len=*) :: tunits
    CHARACTER(len=8) :: date
    CHARACTER(len=10) :: time
    CHARACTER(len=5) :: zone
    CHARACTER(len=7) :: time_str
    CHARACTER(len=3), DIMENSION(12) :: mn= &
         (/'Jan','Feb','Mar','Apr','May','Jun', &
           'Jul','Aug','Sep','Oct','Nov','Dec'/)
    INTEGER, DIMENSION(8) :: values

    ! Construct time string
    IF (tunits == "s") THEN
       WRITE(time_str,'(I5,"s ")') INT(t_shotTime+0.5)
    ELSE IF (tunits == "µs" .OR. tunits == "us") THEN
       WRITE(time_str,'(I5,"µs")') INT(1000000*t_shotTime+0.5)
    ELSE ! Assume ms
       WRITE(time_str,'(I5,"ms")') INT(1000*t_shotTime+0.5)
    ENDIF
   
    ! Construct header for a-file
    CALL DATE_AND_TIME(date,time,zone,values)
    t_aheader=date(7:8)//"-"//mn(values(2))//"-"//date(3:4)//" "//t_codedate

    ! Construct header for g-file
    IF (LEN_TRIM(t_shotName) <= 6) THEN ! Standard header
       t_gheader="  TEQ g    "//date(5:6)//"/"//date(7:8)//"/"//date(1:4)
       t_gheader=TRIM(t_gheader)//"    #"//t_shotName(1:6)//" "//time_str
    ELSE ! C-Mod style header
       t_gheader="  TEQ G      "//date(5:6)//"/"//date(7:8)//"  /"//date(1:4)
       t_gheader=TRIM(t_gheader)//"     "//t_shotName(1:10)//" "//time_str
    END IF

  END SUBROUTINE set_headers

  SUBROUTINE fopen_c(ioun,ioname)
    INTEGER, INTENT(INOUT) :: ioun
    CHARACTER*(*),INTENT(IN) ::  ioname
    CHARACTER(len=3) :: fmt
    INTEGER len
    DATA fmt/'old'/,len/0/
    CALL freeus(ioun)
    IF(ioun>0) THEN
       OPEN(unit=ioun,file=ioname,status=fmt,err=99999)
       RETURN
    ELSE
       WRITE(STDOUT,10001) 
       WRITE(t_logunit,10001) 
       CALL kaboom(0)
    END IF
99999 CONTINUE
       WRITE(STDOUT,10002) ioname 
       WRITE(t_logunit,10002) ioname
       CALL kaboom(0)
10001 format("ceq: No free io units available for ioun")
10002 format("Error opening disk file ",a)
  END SUBROUTINE fopen_c

  FUNCTION iopen(ioun,ioname) RESULT(iiopen)
    INTEGER, INTENT(INOUT) :: ioun
    INTEGER ::  iiopen
    CHARACTER*(*),INTENT(IN) ::  ioname
    CHARACTER(len=11) :: fmt
    INTEGER len
    DATA fmt/'unformatted'/,len/0/
    CALL freeus(ioun)
    IF(ioun>0) THEN
       OPEN(unit=ioun,file=ioname,form=fmt,err=99999)
       iiopen = OK
       RETURN
    ELSE
       WRITE(STDOUT,10001) 
       WRITE(t_logunit,10001) 
    END IF
99999 cONTINUE
    WRITE(STDOUT,10002) ioname 
    WRITE(t_logunit,10002) ioname
    iiopen = ERR
10001 format("ceq: No free io units available for ioun")
10002 format("Error opening disk file ",a)
  END FUNCTION iopen

  FUNCTION icreate(ioun,ioname) RESULT(iicreate)
    INTEGER, INTENT(INOUT) :: ioun
    INTEGER :: iicreate
    CHARACTER*(*),INTENT(IN) ::  ioname
    CHARACTER(len=9) :: fmt
    DATA fmt/'formatted'/
    CALL freeus(ioun)
    IF(ioun>0) THEN
       OPEN(unit=ioun,file=ioname,form=fmt,err=99999)
       iicreate = OK
       RETURN
    ELSE
       WRITE(STDOUT,10001) 
       WRITE(t_logunit,10001) 
    END IF
99999 CONTINUE
    WRITE(STDOUT,10002) ioname 
    WRITE(t_logunit,10002) ioname
    iicreate = ERR
10001 format("ceq: No free io units available for ioun")
10002 format("Error creating disk file ",a)
  END FUNCTION icreate

  SUBROUTINE io_close
    IF(ioun12 > 0 .AND. ioun12 /= STDOUT) THEN
       REWIND(ioun12)
       CALL giveupus(ioun12)
       CALL basclose(ioun12)
    END IF
  END SUBROUTINE io_close

  SUBROUTINE read_ext(geqdsk)
    CHARACTER*(*), INTENT(IN) :: geqdsk
    CALL fopen_c(ioun12,geqdsk)
    READ(ioun12,'(52x,2i4)')t_jm,t_km
    t_inv_eq=0
    t_msrf=t_jm
    IF(t_map==0) t_map=64
    t_jmkm=t_jm*t_km
    CALL genTeq
    CALL cont_read_ext
  END SUBROUTINE read_ext

  SUBROUTINE cont_read_ext
    REAL(rq) ::  xdim,zdi,rzero,rgrid,zmid,rmaxis,zmaxis,ssimag1,ssibry1,&
         bcentr,ssimag2,ssibry2,xdum,zdim
    integer i,ios,k,n
    read(ioun12,'(5e16.9)')xdim,zdim,rzero,rgrid,zmid
    read(ioun12,'(5e16.9)')rmaxis,zmaxis,ssimag1,ssibry1,bcentr
    read(ioun12,'(5e16.9)')t_plcm,ssimag2,xdum,rmaxis,xdum
    read(ioun12,'(5e16.9)')zmaxis,xdum,ssibry2,xdum,xdum
    read(ioun12,'(5e16.9)')(t_vpsrf(i),i=1,t_msrf)
    read(ioun12,'(5e16.9)')(t_jtsrf(i),i=1,t_msrf)
    read(ioun12,'(5e16.9)')(t_jparsrf(i),i=1,t_msrf)
    read(ioun12,'(5e16.9)')(t_jparsrf(i),i=1,t_msrf)
    read(ioun12,'(5e16.9)')(t_psi(i),i=1,t_jmkm)
    read(ioun12,'(5e16.9)',iostat=ios)(t_jparsrf(i),i=1,t_msrf)
    CALL io_close
    t_psi=t_psi*1.0e+08
    t_dr=xdim/(t_jm-1)
    t_dz=zdim/(t_km-1)
    t_psix=ssimag1*1.0e+08_rq
    t_psil=ssibry1*1.0e+08_rq
    t_plcm=t_plcm*1.0e-06_rq
    t_dpsi0=t_psil-t_psix
    s_psilim=t_psil
    s_pin=sign(1.0_rq,t_dpsi0)
    t_phibar=(/(i,i=0,t_msrf-1)/)/(t_msrf-1.0_rq)
    t_vpsrf=ABS(t_vpsrf)*1.0e+06_rq
    t_jtsrf=ABS(t_jtsrf)*10
    t_rn=xdim*100
    t_rx=t_rn+rgrid*100
    t_zx=zdim*50
    t_ro=0.5_rq*(t_rx+t_rn)
    CALL setgeo(t_rm,t_zm)
    i_cps(:,1,1)=t_psi
    CALL t_stretch(t_lsrf,t_psil,t_psix)
    CALL interp_interp(t_phibar,t_vpsrf,t_splbdry,t_splbdry,t_psibar,t_frsrf,&
         t_fpsrf)
    CALL interp_interp(t_phibar,t_jtsrf,t_splbdry,t_splbdry,t_psibar,t_prsrf,&
         t_pdsrf)
    CALL interp_interp(t_phibar,t_jparsrf,t_splbdry,t_splbdry,t_psibar,t_qsrf,&
         t_vpsrf)
    t_fpsrf=t_fpsrf/t_dpsi0
    t_pdsrf=t_pdsrf/t_dpsi0
    t_qsave=t_qsrf
    t_fsave=t_frsrf
    t_fwall=t_frsrf(t_msrf)
    t_btor=t_fwall/t_ro
  END SUBROUTINE cont_read_ext

  SUBROUTINE geqdsk__flux(geqdsk)
    !     FLUX COORDINATES etc. FROM geqdsk FILE
    CHARACTER*(*) geqdsk
    !     Needs rlimm and zlimm the limiter; may need need rxpr and zxpr
    CALL read_ext(geqdsk)
    CALL flux_geom
  END SUBROUTINE geqdsk__flux

  SUBROUTINE flux_geom
    !  ROUTINE WHICH COMPUTES FLUX GEOMETRY
    REAL(rq) ::  rho(t_mls),psil_
    integer imth,l
    data imth /11/

    IF(ALLOCATED(i_rhosq)) DEALLOCATE(i_rhosq)
    IF(t_n6==6) THEN
       ALLOCATE(i_rhosq(t_msrf*t_mls,2,3))
       i_rhosq=0
    ELSE
       ALLOCATE(i_rhosq(t_msrf*t_mls,4,4))
       i_rhosq=0
    END IF
    CALL i_t(i_rhosq)

    t_ixp=2
    psil_=s_psilim
    t_theta=(t_pxpt-psil_)/(t_pxpt-t_psix)
    IF(t_theta<0) t_theta=0
    IF(t_thetac/=0) t_theta=t_thetac
    CALL gs_separatrix
    t_dpsi0=t_psil-t_psix
    t_dpsi00=t_dpsi0
    t_brwpts=cos(t_tswpts)
    t_bzwpts=sin(t_tswpts)
    CALL surfaces_separatrix(t_psibar,t_rlsd,t_zlsd)
    t_rhosq(:,:,1)=transpose((t_rlsd(:,:,1)-t_raxis)**2+&
         ((t_zlsd(:,:,1)+t_zaxis)/t_wvert)**2)
    CALL get_rhosq
    DO l=1,t_msrf
       rho=sqrt(t_rhosq(l,:,1))+errt_rq
       t_rlsd(:,l,2)=(0.5*t_rhosq(l,:,3)/rho*t_brwpts-rho*t_bzwpts)
       t_zlsd(:,l,2)=(0.5*t_rhosq(l,:,3)/rho*t_bzwpts+rho*t_brwpts)*t_wvert
       t_rlsd(:,l,3)=0.5*t_rhosq(l,:,2)/rho*t_brwpts/t_dpsi0
       t_zlsd(:,l,3)=0.5*t_rhosq(l,:,2)/rho*t_bzwpts*t_wvert/t_dpsi0
       t_zlsd(:,l,4)=0.5*t_wvert*t_rhosq(l,:,2)*t_rlsd(:,l,1)/t_dpsi0
       ! Jacobian
       t_rlsd(:,l,4)=sqrt(t_rlsd(:,l,2)**2+t_zlsd(:,l,2)**2)&
            /abs(t_zlsd(:,l,4))
       ! Bpol
    END DO
    t_rlsd(:,1,4)=errt_rq ! To avoid zero divides
    CALL get_surfint
  END SUBROUTINE flux_geom

END MODULE ioTeq_mod
